//
unit UFInfo;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls,GLVectorFileObjects,
  ActnList, ToolWin,GLMeshOptimizer;

type
  TFInfo = class(TForm)
    tv: TTreeView;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ActionList1: TActionList;
    actFullExpand: TAction;
    ToolButton2: TToolButton;
    actFullCollapse: TAction;
    ToolButton3: TToolButton;
    actOptimize: TAction;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure actFullExpandExecute(Sender: TObject);
    procedure actFullCollapseExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Filltree;
  end;

var
  FInfo: TFInfo;

implementation

uses dtmPOFvar, dtmGLSViewerFrm;

{$R *.dfm}

{ TForm1 }
procedure TFInfo.FormCreate(Sender: TObject);
begin
  top := FInfoY;{0;}
  left := FInfoX;{488;}
end;
procedure TFInfo.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FInfoX := FInfo.left;
  FInfoY := FInfo.top;
  DoSaver;
     Action := caFree;
end;

procedure TFInfo.Filltree;
var
   t,u,fgc: integer;
   N,M : TTreeNode;
   stMode : string;
   FF : TGLFreeForm;
begin
     FF := dtmGLSViewerForm.FreeForm;
     tv.Items.Clear;

     // Get Total FaceGroups count
     fgc := 0;
     for t := 0 to FF.MeshObjects.Count-1 do
     begin
          inc(fgc,FF.MeshObjects[t].FaceGroups.Count);
     end;
     N := tv.Items.Add(nil,'Total (MeshObjects: '+inttostr(FF.MeshObjects.Count)+') (FaceGroups: '+inttostr(fgc)+') (Triangles: '+inttostr(FF.MeshObjects.TriangleCount)+')');

     for t := 0 to FF.MeshObjects.Count-1 do
     begin
          case FF.MeshObjects[t].Mode of
             momTriangles     : stMode := 'momTriangles';
             momTriangleStrip : stMode := 'momTriangleStrip';
             momFaceGroups    : stMode := 'momFaceGroups';
          end;

          M := tv.Items.AddChild(N,'Mo.'+inttostr(t)+' (Mode: '+stMode+')  (FaceGroups: '+inttostr(FF.MeshObjects[t].FaceGroups.Count)+')  (Triangles: '+inttostr(FF.MeshObjects[t].TriangleCount)+')');

          for u := 0 to FF.MeshObjects[t].FaceGroups.Count-1 do
          begin
               tv.Items.AddChild(M,'Fg.'+Inttostr(u)+'  (MatName."'+FF.MeshObjects[t].FaceGroups[u].MaterialName+'")  (LightMap.Idx: '+inttostr(FF.MeshObjects[t].FaceGroups[u].LightMapIndex)+')  (Triangles: '+inttostr(FF.MeshObjects[t].FaceGroups[u].TriangleCount)+')');
          end;

     end;

end;



procedure TFInfo.actFullExpandExecute(Sender: TObject);
begin
     tv.FullExpand;
end;

procedure TFInfo.actFullCollapseExecute(Sender: TObject);
begin
     tv.FullCollapse;
end;


end.
