{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmDTPFrm;
{by Ivan Lee Herring, 2004}
interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, ComCtrls, ExtDlgs,
  GLUtils,//StrtoFloatDef
  GR32, {GR32_Layers,}GR32_Polygons, GR32_Image;

type
  TAreaRecord = record
    Shape, Filename: Integer;
  end;
  TPointRecord = record
    Shape, Filename   : Integer;
  end;
  TLinearRecord = record
    Shape, Filename   : Integer;
  end;
  TdtmDTPForm = class(TForm)
    ColorDialog1: TColorDialog;
    OpenDialog: TOpenDialog;
    SaveDialog1: TSaveDialog;
    OpenPictureDialog1: TOpenPictureDialog;
    DtpPageControl: TPageControl;
    DtpShpTS: TTabSheet;
    DtpDtmTS: TTabSheet;
    Panel1: TPanel;
    Label9: TLabel;
    ShapeTypeLabel: TLabel;
    ViewChangesBtn: TSpeedButton;
    ShpHelpBtn: TSpeedButton;
    DtpExitBtn: TSpeedButton;
    LegendLayerCB: TComboBox;
    PageControl1: TPageControl;
    TabSheet3: TTabSheet;
    Label3: TLabel;
    Label4: TLabel;
    OutlineThicknessLabel: TLabel;
    Label6: TLabel;
    LineOpacityLabel: TLabel;
    FillOpacityLabel: TLabel;
    Label8: TLabel;
    PointSizeLabel: TLabel;
    Label10: TLabel;
    StippleSizeLabel: TLabel;
    StippleStepperLabel: TLabel;
    StippleCountBtn: TSpeedButton;
    StippleCountLabel: TLabel;
    CanvasLineSizeLabel: TLabel;
    Bevel1: TBevel;
    Antialiase: TCheckBox;
    LineAlpha: TScrollBar;
    FillAlpha: TScrollBar;
    LineThickness: TScrollBar;
    ThickOutline: TCheckBox;
    OutlineColorPanel: TPanel;
    LegendColorsPanel: TPanel;
    GroupBox2: TGroupBox;
    ProjectSetotsFileBtn: TSpeedButton;
    ProjectRobotRldFileBtn: TSpeedButton;
    LayerPlatoEdit: TEdit;
    ProjectActorEdit: TEdit;
    PointSizeScrollBar: TScrollBar;
    LineScrollBar: TScrollBar;
    LineStippledCB: TCheckBox;
    Image32: TImage32;
    StippleColorPanel: TPanel;
    StippleStepper: TUpDown;
    PointTypeRG: TRadioGroup;
    CanvasLineUpDown: TUpDown;
    PolyFilledCB: TCheckBox;
    TabSheet4: TTabSheet;
    PageControl3: TPageControl;
    TabSheet11: TTabSheet;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    EcotypeOpenBtn: TSpeedButton;
    Label78: TLabel;
    Label79: TLabel;
    EcotypeUpDown: TUpDown;
    EcotypeAttributeCB: TComboBox;
    EcotypeEdit: TEdit;
    EcotypeIDEdit: TEdit;
    PageControl5: TPageControl;
    TabSheet16: TTabSheet;
    TabSheet18: TTabSheet;
    Panel2: TPanel;
    SlopeDirectionRG: TRadioGroup;
    UseFlippedHTFCB: TCheckBox;
    UseSavedTexturesCB: TCheckBox;
    CreateTexturesOnDemandCB: TCheckBox;
    SaveCreatedTexturesCB: TCheckBox;
    PixelEnlargementRG: TRadioGroup;
    TilesperTextureRG: TRadioGroup;
    TextureFileTypeRG: TRadioGroup;
    UseConglomerationCB: TCheckBox;
    UseImageMapCB: TCheckBox;
    UseEcoTypesCB: TCheckBox;
    Label51: TLabel;
    GroupBox5: TGroupBox;
    Label47: TLabel;
    DemCIEdit: TEdit;
    DemCIE: TLabel;
    DemCIEEdit: TEdit;
    SetCIBtn: TSpeedButton;
    ContourColorsCB: TCheckBox;
    DtmLoadBtn: TSpeedButton;
    DtmLoadEdit: TEdit;
    TabSheet17: TTabSheet;
    DtmHtfLoadEdit: TEdit;
    DtmHtfLoadBtn: TSpeedButton;
    DtmSaveBtn: TSpeedButton;
    SlopeCellSizeEdit: TEdit;
    Label54: TLabel;
    Label84: TLabel;
    PolyFillTypeRG: TRadioGroup;
    PolyFillFileBtn: TSpeedButton;
    PolyFillFileEdit: TEdit;
    TabSheet13: TTabSheet;
    GroupBox1: TGroupBox;
    XUpBtn: TSpeedButton;
    XDownBtn: TSpeedButton;
    YUpBtn: TSpeedButton;
    YDownBtn: TSpeedButton;
    SetBtn: TSpeedButton;
    ReSetBtn: TSpeedButton;
    XLonEdit: TEdit;
    YLatEdit: TEdit;
    GroupBox3: TGroupBox;
    SetHTFBtn: TSpeedButton;
    HTFYLabel: TLabel;
    HTFXLabel: TLabel;
    XLabel: TLabel;
    X2Label: TLabel;
    HTFXEdit: TEdit;
    HTFYEdit: TEdit;
    InDatumCB: TComboBox;
    DoDatumBtn: TSpeedButton;
    EcotypeLayerAttributeCB: TComboBox;
    Label102: TLabel;
    UseBumpMapCB: TCheckBox;
    TBRange: TTrackBar;
    RangeLabel: TLabel;
    CloseBtn: TBitBtn;
    AbortBtn: TBitBtn;
    DtmHelpBtn: TSpeedButton;
    DtpHelpBtn: TSpeedButton;
    TabSheet34: TTabSheet;
    UseQualityDCB: TCheckBox;
    UseClodPCB: TCheckBox;
    UseDOVCB: TCheckBox;
    UseSeaLevelCB: TCheckBox;
    SeaLevelUsedEdit: TEdit;
    ZScaleUsedEdit: TEdit;
    UseZScaleCB: TCheckBox;
    UseXScaleCB: TCheckBox;
    XScaleUsedEdit: TEdit;
    UseCloudsCB: TCheckBox;
    UseWavesCB: TCheckBox;
    QualityDUsedEdit: TEdit;
    ClodPUsedEdit: TEdit;
    DOVUsedEdit: TEdit;
    CloudChangeAmountEdit: TEdit;
    CloudAnimeEdit: TEdit;
    CloudSharpUsedEdit: TEdit;
    CloudSharpRangeUsedEdit: TEdit;
    CloudMinUsedEdit: TEdit;
    CloudMinRangeUsedEdit: TEdit;
    CloudRandomSeedUsedEdit: TEdit;
    CloudImageSizeUsedEdit: TEdit;
    UseCloudFileCB: TCheckBox;
    CloudFileOpenBtn: TSpeedButton;
    CloudFileUsedEdit: TEdit;
    MakeAndSaveCloudNoiseFile: TSpeedButton;
    WavesRangeUsedEdit: TEdit;
    WavesRateUsedEdit: TEdit;
    UseCloudsRangeCB: TCheckBox;
    UseCloudsSRangeCB: TCheckBox;
    TabSheet45: TTabSheet;
    UseStormCloudsCB: TCheckBox;
    StormCloudsRateUsedEdit: TEdit;
    StormCloudsRangeUsedEdit: TEdit;
    DisplayFPSCB: TCheckBox;
    LoadDTPOnStartCB: TCheckBox;
    MaximumShapeLayersEdit: TEdit;
    MaximumShapeObjectsEdit: TEdit;
    RunDTSCB: TCheckBox;
    SunMovingUsedEdit: TEdit;
    UseSunMovingCB: TCheckBox;
    UseCloudsSettingCB: TCheckBox;
    StormCloudsRangeXUsedEdit: TEdit;
    StormCloudsRangeYUsedEdit: TEdit;
    StormCloudsRangeZUsedEdit: TEdit;
    UseStormLinearCB: TCheckBox;
    StormCloudsNumberUsedEdit: TEdit;
    StormCloudsNumRangeUsedEdit: TEdit;
    StormCloudsNumRangeVarUsedEdit: TEdit;
    UseStormMovingCB: TCheckBox;
    UseStormMovingDirSCB: TCheckBox;
    StormCloudsDirectionUsedEdit: TEdit;
    StormCloudsSpeedUsedEdit: TEdit;
    UseStormMovingPathCB: TCheckBox;
    Label94: TLabel;
    StormCloudsPosXUsedEdit: TEdit;
    StormCloudsPosYUsedEdit: TEdit;
    StormCloudsPosZUsedEdit: TEdit;
    StormWindDirectionVarUsedEdit: TEdit;
    StormWindSpeedVariationUsedEdit: TEdit;
    StormWindSpeedUsedEdit: TEdit;
    StormWindDirectionUsedEdit: TEdit;
    UseStormWindCB: TCheckBox;
    TornadoeFrequencyUsedEdit: TEdit;
    TornadoeForceUsedEdit: TEdit;
    UseStormTornadoesCB: TCheckBox;
    LightningFrequencyUsedEdit: TEdit;
    LightningForceUsedEdit: TEdit;
    UseStormLightningCB: TCheckBox;
    RainDensityUsedEdit: TEdit;
    RainDensityVarUsedEdit: TEdit;
    UseStormRainCB: TCheckBox;
    StormMovingFileUsedEdit: TEdit;
    StormMovingPathBtn: TSpeedButton;
    TabSheet48: TTabSheet;
    PatternPldEdit: TEdit;
    Label45: TLabel;
    PatternPldOpenBtn: TSpeedButton;
    PatternPldSaveBtn: TSpeedButton;
    Label101: TLabel;
    PatternLayerAttCB: TComboBox;
    Label46: TLabel;
    PatternAttCB: TComboBox;
    PatternAttLabel: TLabel;
    Label53: TLabel;
    Label48: TLabel;
    PatternAttObjectLabel: TLabel;
    PatternAttValueLabel: TLabel;
    Label52: TLabel;
    PatternAttUpDown: TUpDown;
    PatternAttBaseRG: TRadioGroup;
    PatternAttImage: TImage;
    PatternAttSetEdit: TEdit;
    PatternAttSetBtn: TSpeedButton;
    Label49: TLabel;
    PatternAttDisplayCB: TCheckBox;
    PatternAttBaseCB: TCheckBox;
    TabSheet26: TTabSheet;
    TabSheet27: TTabSheet;
    PageControl8: TPageControl;
    TabSheet28: TTabSheet;
    TabSheet29: TTabSheet;
    TabSheet30: TTabSheet;
    TabSheet31: TTabSheet;
    TabSheet32: TTabSheet;
    PageControl10: TPageControl;
    TabSheet36: TTabSheet;
    PointOpenPldBtn: TSpeedButton;
    Label68: TLabel;
    PSTLabel: TLabel;
    Label66: TLabel;
    CurrentPSTLabel: TLabel;
    Label65: TLabel;
    CurrentPdlLabel: TLabel;
    Label34: TLabel;
    PointPldSaveBtn: TSpeedButton;
    PointSetBtn: TSpeedButton;
    PointEdit: TEdit;
    PointShapeAttCB: TComboBox;
    PointCurrentPdlUpDown: TUpDown;
    PointCurrentPdlEdit: TEdit;
    PointShapeAttSelectUpDown: TUpDown;
    PldSupportRG: TRadioGroup;
    PldDisplayRG: TRadioGroup;
    PointShapeAttSelectCB: TComboBox;
    TabSheet37: TTabSheet;
    PointOpenPdlBtn: TSpeedButton;
    PaointSavePdlBtn: TSpeedButton;
    Label119: TLabel;
    PointAddPtdBtn: TSpeedButton;
    Label33: TLabel;
    pdlRichEdit: TRichEdit;
    PointFilenameEdit: TEdit;
    TabSheet38: TTabSheet;
    PointOpenPtdBtn: TSpeedButton;
    Label118: TLabel;
    PointSavePtdBtn: TSpeedButton;
    Label122: TLabel;
    Label123: TLabel;
    Label124: TLabel;
    Label125: TLabel;
    Label126: TLabel;
    Point3dsTextureBtn: TSpeedButton;
    Point3dsBtn: TSpeedButton;
    PointControlBtn: TSpeedButton;
    PtdFilenameEdit: TEdit;
    PtdSupportWidthEdit: TEdit;
    PtdSupportDepthEdit: TEdit;
    PtdHeightEdit: TEdit;
    PtdLengthEdit: TEdit;
    PtdWidthEdit: TEdit;
    PtdTextureFileEdit: TEdit;
    Ptd3dsFileEdit: TEdit;
    PointDtcEdit: TEdit;
    PageControl6: TPageControl;
    TabSheet19: TTabSheet;
    Label95: TLabel;
    CurrentLtdLabel: TLabel;
    CurrentLldLabel: TLabel;
    Label96: TLabel;
    Label91: TLabel;
    LSTLabel: TLabel;
    Label89: TLabel;
    LinearLldOpenBtn: TSpeedButton;
    LinearLldSaveBtn: TSpeedButton;
    LinearSetBtn: TSpeedButton;
    LinearLdlUpDown: TUpDown;
    LinearShapeAttCB: TComboBox;
    LinearEdit: TEdit;
    LinearShapeAttSelectUpDown: TUpDown;
    CurrentLdlEdit: TEdit;
    LinearDisplayRG: TRadioGroup;
    LinearSupportRG: TRadioGroup;
    LinearShapeAttSelectCB: TComboBox;
    TabSheet35: TTabSheet;
    LinearLdlOpenBtn: TSpeedButton;
    LinearLdlSaveBtn: TSpeedButton;
    Label120: TLabel;
    LinearAddltdBtn: TSpeedButton;
    Label97: TLabel;
    LdlRichEdit: TRichEdit;
    LinearLdlFilenameEdit: TEdit;
    TabSheet20: TTabSheet;
    LinearLtdSaveBtn: TSpeedButton;
    LinearLtdOpenBtn: TSpeedButton;
    Label104: TLabel;
    Linear3dsBtn: TSpeedButton;
    Label106: TLabel;
    Label107: TLabel;
    Label108: TLabel;
    Label109: TLabel;
    Linear3dsTextureBtn: TSpeedButton;
    Label121: TLabel;
    LinearControlBtn: TSpeedButton;
    LinearLtdFilenameEdit: TEdit;
    Linear3dsFileEdit: TEdit;
    LtdSupportDepthEdit: TEdit;
    LtdSupportWidthEdit: TEdit;
    LtdWidthEdit: TEdit;
    LtdHeightEdit: TEdit;
    LinearTextureFileEdit: TEdit;
    LtdLengthEdit: TEdit;
    LinearDtcEdit: TEdit;
    PageControl2: TPageControl;
    TabSheet6: TTabSheet;
    CurrentablLabel: TLabel;
    aldOpenBtn: TSpeedButton;
    Label42: TLabel;
    aldTotalLabel: TLabel;
    CurrentaldTotalLabel: TLabel;
    Label58: TLabel;
    Label86: TLabel;
    aldSaveBtn: TSpeedButton;
    SetaldShapeBtn: TSpeedButton;
    Label38: TLabel;
    aldAdlUpDown: TUpDown;
    AreaEdit: TEdit;
    aldShapeAttCB: TComboBox;
    CurrentAdlEdit: TEdit;
    aldShapeASUpDown: TUpDown;
    AreaDisplayRG: TRadioGroup;
    aldShapeAttSelectCB: TComboBox;
    TabSheet44: TTabSheet;
    Label35: TLabel;
    adlSaveAblBtn: TSpeedButton;
    adlOpenAblAddBtn: TSpeedButton;
    adlOpenAblBtn: TSpeedButton;
    Label40: TLabel;
    adlRichEdit: TRichEdit;
    adlFilenameEdit: TEdit;
    TabSheet7: TTabSheet;
    ablOpenBtn: TSpeedButton;
    ablSaveBtn: TSpeedButton;
    ablAslAddBtn: TSpeedButton;
    Label19: TLabel;
    ablEdit: TEdit;
    ablRichEdit: TRichEdit;
    TabSheet8: TTabSheet;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label44: TLabel;
    aslOpenBtn: TSpeedButton;
    aslTexOpenBtn: TSpeedButton;
    asl3dsOpenBtn: TSpeedButton;
    aslSaveBtn: TSpeedButton;
    aslControlBtn: TSpeedButton;
    Label26: TLabel;
    Label27: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    aslEdit: TEdit;
    asl3dTexEdit: TEdit;
    aslSidEdit: TEdit;
    aslUidEdit: TEdit;
    aslCnEdit: TEdit;
    aslSnEdit: TEdit;
    aslWidthEdit: TEdit;
    aslHeightEdit: TEdit;
    aslSrEdit: TEdit;
    aslSdEdit: TEdit;
    asl3dFileEdit: TEdit;
    aslControlEdit: TEdit;
    aslObjTypeRG: TRadioGroup;
    aslGroupEdit: TEdit;
    aslPlantsEdit: TEdit;
    aslDensityEdit: TEdit;
    aslDepthEdit: TEdit;
    PageControl11: TPageControl;
    TabSheet22: TTabSheet;
    GroupBox4: TGroupBox;
    oldOpenTextureBtn: TSpeedButton;
    oldOpenActorBtn: TSpeedButton;
    oldOpenSetBtn: TSpeedButton;
    oldSaveSetBtn: TSpeedButton;
    Label11: TLabel;
    OldNameEdit: TEdit;
    oldObjectFileNameEdit: TEdit;
    oldTextureFileNameEdit: TEdit;
    oldTextureOnlyCB: TCheckBox;
    OldSizeEdit: TEdit;
    oldObjectCB: TCheckBox;
    oldSSObjectCB: TCheckBox;
    TabSheet1: TTabSheet;
    rldTextureEdit: TEdit;
    rldTextureBtn: TSpeedButton;
    Label116: TLabel;
    rldSizeEdit: TEdit;
    rldRobotFileNameEdit: TEdit;
    rldRobotBtn: TSpeedButton;
    rldOpenBtn: TSpeedButton;
    rldNameEdit: TEdit;
    rldSaveBtn: TSpeedButton;
    RobotHelpBtn: TSpeedButton;
    PLATOHelpBtn: TSpeedButton;
    rldRobotRG: TRadioGroup;
    aldRG: TRadioGroup;
    LinearlldRG: TRadioGroup;
    pldRG: TRadioGroup;
    oldCTRG: TRadioGroup;
    LoadDTCOnStartCB: TCheckBox;
    TabSheet40: TTabSheet;
    Panel3: TPanel;
    obeOpenSetBtn: TSpeedButton;
    obeSaveBtn: TSpeedButton;
    Label111: TLabel;
    ObeNameEdit: TEdit;
    PageControl4: TPageControl;
    TabSheet14: TTabSheet;
    ObeRG: TRadioGroup;
    TabSheet15: TTabSheet;
    PageControl7: TPageControl;
    TabSheetB: TTabSheet;
    Label28: TLabel;
    Label39: TLabel;
    Label92: TLabel;
    Label103: TLabel;
    Label29: TLabel;
    Label133: TLabel;
    ObePathBtn: TSpeedButton;
    Label67: TLabel;
    Label130: TLabel;
    ObePathRichEdit: TRichEdit;
    TabSheet21: TTabSheet;
    Label161: TLabel;
    Label160: TLabel;
    Label158: TLabel;
    Label146: TLabel;
    Label145: TLabel;
    Label144: TLabel;
    Label140: TLabel;
    ObeActionBtn: TSpeedButton;
    ObeActionRichEdit: TRichEdit;
    TabSheet23: TTabSheet;
    ObeEvolveBtn: TSpeedButton;
    Label165: TLabel;
    Label175: TLabel;
    Label178: TLabel;
    Label179: TLabel;
    ObeEvolveRichEdit: TRichEdit;
    TabSheet49: TTabSheet;
    PageControl16: TPageControl;
    TabSheet126: TTabSheet;
    Label215: TLabel;
    TabSheet127: TTabSheet;
    Label216: TLabel;
    TabSheet128: TTabSheet;
    Label217: TLabel;
    TabSheet129: TTabSheet;
    Label218: TLabel;
    TabSheet130: TTabSheet;
    Label219: TLabel;
    TabSheet131: TTabSheet;
    Label220: TLabel;
    TabSheet132: TTabSheet;
    Label221: TLabel;
    TabSheet133: TTabSheet;
    Label222: TLabel;
    TabSheet134: TTabSheet;
    Label223: TLabel;
    TabSheet135: TTabSheet;
    Label224: TLabel;
    TabSheet136: TTabSheet;
    Label225: TLabel;
    TabSheet137: TTabSheet;
    Label226: TLabel;
    TabSheet138: TTabSheet;
    Label227: TLabel;
    TabSheet139: TTabSheet;
    Label228: TLabel;
    TabSheet140: TTabSheet;
    Label229: TLabel;
    TabSheet141: TTabSheet;
    Label230: TLabel;
    TabSheet142: TTabSheet;
    Label231: TLabel;
    TabSheet143: TTabSheet;
    Label232: TLabel;
    TabSheet144: TTabSheet;
    Label233: TLabel;
    TabSheet145: TTabSheet;
    Label234: TLabel;
    TabSheet146: TTabSheet;
    Label235: TLabel;
    TabSheet147: TTabSheet;
    Label236: TLabel;
    TabSheet148: TTabSheet;
    Label237: TLabel;
    TabSheet149: TTabSheet;
    Label238: TLabel;
    TabSheet150: TTabSheet;
    Label239: TLabel;
    TabSheet151: TTabSheet;
    Label240: TLabel;
    TabSheet46: TTabSheet;
    PageControl12: TPageControl;
    TabSheet41: TTabSheet;
    Label1: TLabel;
    Label59: TLabel;
    Label62: TLabel;
    Label12: TLabel;
    Label7: TLabel;
    Label2: TLabel;
    Label63: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label64: TLabel;
    TabSheet42: TTabSheet;
    Label90: TLabel;
    Label99: TLabel;
    Label87: TLabel;
    Label100: TLabel;
    Label43: TLabel;
    TabSheet43: TTabSheet;
    Label83: TLabel;
    Label82: TLabel;
    Label13: TLabel;
    Label80: TLabel;
    Label14: TLabel;
    Label81: TLabel;
    Label60: TLabel;
    Label85: TLabel;
    Label37: TLabel;
    TabSheet12: TTabSheet;
    Label61: TLabel;
    Label32: TLabel;
    TabSheet39: TTabSheet;
    Label98: TLabel;
    Label77: TLabel;
    TabSheet24: TTabSheet;
    PageControl13: TPageControl;
    TabSheet33: TTabSheet;
    Label129: TLabel;
    TabSheet47: TTabSheet;
    Label132: TLabel;
    TabSheet50: TTabSheet;
    Label134: TLabel;
    TabSheet51: TTabSheet;
    Label135: TLabel;
    DtmDtcLoadBtn: TSpeedButton;
    DtmDtcLoadEdit: TEdit;
    Label128: TLabel;
    TabSheet25: TTabSheet;
    Label131: TLabel;
    ToolsCurrentConversionLabel: TLabel;
    ToolsDoPathBtn: TSpeedButton;
    Label93: TLabel;
    TabSheet9: TTabSheet;
    Panel4: TPanel;
    DtcOpenSetBtn: TSpeedButton;
    DtcSaveBtn: TSpeedButton;
    Label112: TLabel;
    DtcFileEdit: TEdit;
    PageControl9: TPageControl;
    TabSheet5: TTabSheet;
    Label20: TLabel;
    Label162: TLabel;
    DtcAActorBtn: TSpeedButton;
    DtcAPathBtn: TSpeedButton;
    DtcAEvolveBtn: TSpeedButton;
    Label25: TLabel;
    DtcA1RichEdit: TRichEdit;
    DtcA2RichEdit: TRichEdit;
    TabSheet52: TTabSheet;
    Label207: TLabel;
    TabSheet10: TTabSheet;
    Label50: TLabel;
    DtcFCamBtn: TSpeedButton;
    DtcFTarBtn: TSpeedButton;
    DtcFCamEdit: TEdit;
    DtcFTarEdit: TEdit;
    TabSheet2: TTabSheet;
    oldSetodlBtn: TSpeedButton;
    odlRichEdit: TRichEdit;
    Label136: TLabel;
    OdlFilenameEdit: TEdit;
    oldSaveodlBtn: TSpeedButton;
    Label137: TLabel;
    oldAddodlBtn: TSpeedButton;
    DtcFileTypeRG: TRadioGroup;
    DtcHelpBtn: TSpeedButton;
    Label138: TLabel;
    Label36: TLabel;
    LayerShapeCountLabel: TLabel;
    Label41: TLabel;
    Label88: TLabel;
    GeneralSortListBox: TListBox;
    PointShapeAttBtn: TSpeedButton;
    LinearShapeAttBtn: TSpeedButton;
    aldShapeAttBtn: TSpeedButton;
    Label5: TLabel;
    DtcLLayerBtn: TSpeedButton;
    DtcLActionBtn: TSpeedButton;
    DtcLERobotRichEdit: TRichEdit;
    DtcLERobotBtn: TSpeedButton;
    DtcLActionRichEdit: TRichEdit;
    DtcAActionBtn: TSpeedButton;
    Label18: TLabel;
    rldUpEdit: TEdit;
    rldPositionZEdit: TEdit;
    Label105: TLabel;
    OldUpDirEdit: TEdit;
    OldUpSizeEdit: TEdit;
    Label110: TLabel;
    aslUpDirEdit: TEdit;
    aslUpSizeEdit: TEdit;
    Label127: TLabel;
    PointUpDirEdit: TEdit;
    PointUpSizeEdit: TEdit;
    Label139: TLabel;
    LinearUpDirEdit: TEdit;
    LinearUpSizeEdit: TEdit;
    Label141: TLabel;
    PointScaleEdit: TEdit;
    Label142: TLabel;
    aslScaleEdit: TEdit;
    Label143: TLabel;
    Edit5: TEdit;
    Label147: TLabel;
    OldWidthEdit: TEdit;
    Label148: TLabel;
    OldLengthEdit: TEdit;
    Label149: TLabel;
    OldHeightEdit: TEdit;
    TabSheet53: TTabSheet;
    Label150: TLabel;
    Label151: TLabel;
    TabSheet54: TTabSheet;
    rldPositionXEdit: TEdit;
    rldPositionYEdit: TEdit;
    Label117: TLabel;
    DtcIFilesBtn: TSpeedButton;
    DtcIRichEdit: TRichEdit;
    DtcLLayerRichEdit: TRichEdit;
    DtcLPathBtn: TSpeedButton;
    DtcLEvolveBtn: TSpeedButton;
    Label152: TLabel;
    Label153: TLabel;
    Edit1: TEdit;
    Label154: TLabel;
    Edit2: TEdit;
    SpeedButton1: TSpeedButton;
    Label155: TLabel;
    DtmHtfDisplayRG: TRadioGroup;
    DtmPalLoadBtn: TSpeedButton;
    Label69: TLabel;
    DtmPalLoadEdit: TEdit;
    PageControl14: TPageControl;
    TabSheet55: TTabSheet;
    Label156: TLabel;
    Label157: TLabel;
    Label159: TLabel;
    Label163: TLabel;
    Label164: TLabel;
    Label166: TLabel;
    Label167: TLabel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    Label168: TLabel;
    SpeedButton5: TSpeedButton;
    UpDown1: TUpDown;
    ComboBox1: TComboBox;
    Edit3: TEdit;
    UpDown2: TUpDown;
    Edit4: TEdit;
    ComboBox2: TComboBox;
    TabSheet56: TTabSheet;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    Label169: TLabel;
    SpeedButton8: TSpeedButton;
    Label170: TLabel;
    RichEdit1: TRichEdit;
    Edit6: TEdit;
    TabSheet57: TTabSheet;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    Label171: TLabel;
    Label174: TLabel;
    Label176: TLabel;
    Label177: TLabel;
    Label180: TLabel;
    Label181: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    Edit11: TEdit;
    Edit12: TEdit;
    Edit14: TEdit;
    Edit16: TEdit;
    Edit17: TEdit;
    Edit18: TEdit;
    Label113: TLabel;
    Label114: TLabel;
    Label115: TLabel;
    tldOpenBtn: TSpeedButton;
    RadioGroup1: TRadioGroup;
    LayerVisibleCB: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure DtpExitBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ShpHelpBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure LegendColorsPanelClick(Sender: TObject);
    procedure LegendLayerCBClick(Sender: TObject);
    procedure XUpBtnClick(Sender: TObject);

    procedure SetBtnClick(Sender: TObject);
    procedure XDownBtnClick(Sender: TObject);
    procedure ReSetBtnClick(Sender: TObject);
    procedure YUpBtnClick(Sender: TObject);
    procedure YDownBtnClick(Sender: TObject);
    procedure DoDatumBtnClick(Sender: TObject);
    procedure SetHTFBtnClick(Sender: TObject);
    procedure oldOpenSetBtnClick(Sender: TObject);
    procedure oldSaveSetBtnClick(Sender: TObject);
    procedure oldOpenActorBtnClick(Sender: TObject);
    procedure oldOpenTextureBtnClick(Sender: TObject);
    procedure OutlineColorPanelClick(Sender: TObject);
    procedure LineAlphaChange(Sender: TObject);
    procedure AntialiaseClick(Sender: TObject);
    procedure FillAlphaChange(Sender: TObject);
    procedure LineThicknessChange(Sender: TObject);
    procedure PointSizeScrollBarChange(Sender: TObject);
    procedure ProjectSetotsFileBtnClick(Sender: TObject);
    procedure ViewChangesBtnClick(Sender: TObject);
    procedure LineScrollBarChange(Sender: TObject);
    procedure StippleColorPanelClick(Sender: TObject);
    procedure StippleStepperClick(Sender: TObject; Button: TUDBtnType);
    procedure StippleCountBtnClick(Sender: TObject);
    procedure ProjectRobotRldFileBtnClick(Sender: TObject);
    procedure PointTypeRGClick(Sender: TObject);
    procedure CanvasLineUpDownClick(Sender: TObject; Button: TUDBtnType);

procedure PaintMyPoints;

    procedure PolyFilledCBClick(Sender: TObject);
procedure PaintMyPoly;
    procedure PatternAttSetBtnClick(Sender: TObject);
    procedure PatternAttBaseRGClick(Sender: TObject);
    procedure PatternAttBaseCBClick(Sender: TObject);
    procedure PatternPldOpenBtnClick(Sender: TObject);

    procedure DtmLoadBtnClick(Sender: TObject);
procedure SetDtmData;    
    procedure DtmHtfLoadBtnClick(Sender: TObject);
    procedure DtmHtfDisplayRGClick(Sender: TObject);
procedure GetData;
    procedure SlopeDirectionRGClick(Sender: TObject);
    procedure DtmSaveBtnClick(Sender: TObject);
    procedure DtmPalLoadBtnClick(Sender: TObject);
    procedure SlopeCellSizeEditChange(Sender: TObject);
    procedure PolyFillFileBtnClick(Sender: TObject);
    procedure PolyFillTypeRGClick(Sender: TObject);
    procedure PatternPldSaveBtnClick(Sender: TObject);
    procedure PatternLayerAttCBClick(Sender: TObject);
    procedure PatternAttCBClick(Sender: TObject);
    procedure EcotypeOpenBtnClick(Sender: TObject);
    procedure EcotypeLayerAttributeCBChange(Sender: TObject);
    procedure EcotypeAttributeCBChange(Sender: TObject);
    procedure EcotypeUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure PatternAttUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure aldOpenBtnClick(Sender: TObject);
    procedure aldAdlUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure ablOpenBtnClick(Sender: TObject);
    procedure aslOpenBtnClick(Sender: TObject);
    procedure asl3dsOpenBtnClick(Sender: TObject);
    procedure aslTexOpenBtnClick(Sender: TObject);
    procedure PointOpenPldBtnClick(Sender: TObject);
    procedure PointCurrentPdlUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure LinearLldOpenBtnClick(Sender: TObject);
    procedure LinearLdlUpDownClick(Sender: TObject; Button: TUDBtnType);


    procedure TBRangeChange(Sender: TObject);
    procedure LinearLldSaveBtnClick(Sender: TObject);
    procedure LinearLtdOpenBtnClick(Sender: TObject);
    procedure LinearLtdSaveBtnClick(Sender: TObject);
    procedure Linear3dsBtnClick(Sender: TObject);
    procedure Linear3dsTextureBtnClick(Sender: TObject);
    procedure PointPldSaveBtnClick(Sender: TObject);
    procedure ablSaveBtnClick(Sender: TObject);
    procedure aslSaveBtnClick(Sender: TObject);
    procedure aldSaveBtnClick(Sender: TObject);
    procedure CloseBtnClick(Sender: TObject);
    procedure AbortBtnClick(Sender: TObject);
    procedure DtmHelpBtnClick(Sender: TObject);
    procedure LinearLdlOpenBtnClick(Sender: TObject);
    procedure LinearLdlSaveBtnClick(Sender: TObject);
    procedure PointOpenPdlBtnClick(Sender: TObject);
    procedure PaointSavePdlBtnClick(Sender: TObject);
    procedure PointOpenPtdBtnClick(Sender: TObject);
    procedure PointSavePtdBtnClick(Sender: TObject);
    procedure PointAddPtdBtnClick(Sender: TObject);
    procedure PointShapeAttSelectUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure Point3dsBtnClick(Sender: TObject);
    procedure Point3dsTextureBtnClick(Sender: TObject);
    procedure LinearSetBtnClick(Sender: TObject);
    procedure LinearShapeAttSelectUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure PointSetBtnClick(Sender: TObject);
    procedure MakeAndSaveCloudNoiseFileClick(Sender: TObject);
    procedure CloudFileOpenBtnClick(Sender: TObject);
    procedure adlOpenAblBtnClick(Sender: TObject);
    procedure adlSaveAblBtnClick(Sender: TObject);
    procedure adlOpenAblAddBtnClick(Sender: TObject);
    procedure aldShapeASUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure SetaldShapeBtnClick(Sender: TObject);

    procedure ablAslAddBtnClick(Sender: TObject);
    procedure aslControlBtnClick(Sender: TObject);
    procedure LinearControlBtnClick(Sender: TObject);
    procedure PointControlBtnClick(Sender: TObject);
    procedure LinearAddltdBtnClick(Sender: TObject);
    procedure StormMovingPathBtnClick(Sender: TObject);

    procedure ToolsDoPathBtnClick(Sender: TObject);
    procedure rldRobotBtnClick(Sender: TObject);
    procedure rldTextureBtnClick(Sender: TObject);
    procedure rldOpenBtnClick(Sender: TObject);
    procedure rldSaveBtnClick(Sender: TObject);
    procedure RobotHelpBtnClick(Sender: TObject);
    procedure PLATOHelpBtnClick(Sender: TObject);
    procedure DtcOpenSetBtnClick(Sender: TObject);
    procedure DtcSaveBtnClick(Sender: TObject);
    procedure oldAddodlBtnClick(Sender: TObject);
    procedure DtcFCamBtnClick(Sender: TObject);
    procedure DtcFTarBtnClick(Sender: TObject);
    procedure DtcAActorBtnClick(Sender: TObject);
    procedure DtcAPathBtnClick(Sender: TObject);
    procedure DtcAEvolveBtnClick(Sender: TObject);
    procedure DtcHelpBtnClick(Sender: TObject);
    procedure oldSaveodlBtnClick(Sender: TObject);
    procedure oldSetodlBtnClick(Sender: TObject);
    procedure PointShapeAttBtnClick(Sender: TObject);
    procedure LinearShapeAttBtnClick(Sender: TObject);
    procedure aldShapeAttBtnClick(Sender: TObject);
    procedure DtmDtcLoadBtnClick(Sender: TObject);
    procedure DtcAActionBtnClick(Sender: TObject);
    procedure DtcLLayerBtnClick(Sender: TObject);
    procedure DtcLERobotBtnClick(Sender: TObject);
    procedure DtcLActionBtnClick(Sender: TObject);
    procedure DtcIFilesBtnClick(Sender: TObject);
    procedure DtcLPathBtnClick(Sender: TObject);
    procedure DtcLEvolveBtnClick(Sender: TObject);
    procedure LayerVisibleCBClick(Sender: TObject);

  private
    { Private declarations }
    AreaArray:Array of TAreaRecord;
    PointArray:Array of TPointRecord;
    LinearArray:Array of TLinearRecord;
  public
    { Public declarations }
  end;

var
  dtmDTPForm: TdtmDTPForm;

implementation

{$R *.DFM}

uses
  dtmfrm,
  dtmGlobals, dtmPOFvar,
  {dtmEcotypeColorsFrm,}
  dtmDtpLayerReader,
  dtmDtpdtmreader,
  AllShapeLoaderFrm;

procedure TdtmDTPForm.FormDestroy(Sender: TObject);
begin
  SetLength(AreaArray,0);
  SetLength(PointArray,0);
  SetLength(LinearArray,0);
end;
procedure TdtmDTPForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  dtmDTPFormY := dtmDTPForm.top;
  dtmDTPFormX := dtmDTPForm.left;
end;
procedure TdtmDTPForm.DtpExitBtnClick(Sender: TObject);
begin
  GetData;
  Close;
end;
procedure TdtmDTPForm.CloseBtnClick(Sender: TObject);
begin
  GetData;
  Close;
end;
procedure TdtmDTPForm.AbortBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TdtmDTPForm.DtmHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(6001);  Application.HelpContext(6000);
end;
procedure TdtmDTPForm.ShpHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(6002);
end;
procedure TdtmDTPForm.PLATOHelpBtnClick(Sender: TObject);
begin
//PLATO: 6101
//P 6160   L 6120 A 6130   T 6140   O 6100
  Application.HelpContext(6101);
end;
procedure TdtmDTPForm.RobotHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(6200);
end;
procedure TdtmDTPForm.DtcHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(6220);
end;
procedure TdtmDTPForm.FormCreate(Sender: TObject);
var
 i, LayerDo,Startat:Integer;
begin
  top := dtmDTPFormY;
  left := dtmDTPFormX;
  {Fill Items with layers}
    For Startat:=0 to LayersLoaded-1 do
    Begin
      LayerDo:=LayersControlArray[Startat];
      LegendLayerCB.Items.Add( LayA[LayerDo].Filename);
    end;
  Image32.SetupBitmap;
  LegendLayerCB.ItemIndex:=(CurrentLayer-1);
  CurrentLayer:= LegendLayerCB.ItemIndex+1;
  LayerVisibleCB.Checked:=  LayA[CurrentLayer].Visible;
  LegendColorsPanel.Color := LayA[CurrentLayer].LayerColor;
  OutlineColorPanel.Color:= LayA[CurrentLayer].OutLineColor;
   Antialiase.Checked:=  LayA[CurrentLayer].PolygonAntialiased;
   PolyFilledCB.Checked:= LayA[CurrentLayer].PolyFilled;
   ThickOutline.Checked:= LayA[CurrentLayer].UseOutlinePoly;
   LineAlpha.Position:=  LayA[CurrentLayer].LineAlphaPosition;
   LineOpacityLabel.Caption := Format('(%d)', [LayA[CurrentLayer].LineAlphaPosition]);
   FillAlpha.Position:=  LayA[CurrentLayer].FillAlphaPosition;
   FillOpacityLabel.Caption := Format('(%d)', [LayA[CurrentLayer].FillAlphaPosition]);
   LineThickness.Position:=  Round(LayA[CurrentLayer].LineSize*10);
   OutlineThicknessLabel.Caption := Format('(%.1f)', [LayA[CurrentLayer].LineSize]);
   PointSizeScrollBar.Position:=  ((LayA[CurrentLayer].PointSize));
   PointSizeLabel.Caption := Format('(%d)', [((LayA[CurrentLayer].PointSize*2)+1)]);
   PointTypeRG.ItemIndex:=LayA[CurrentLayer].CurrentPointType;{CurrentPointType}

   LineScrollBar.Position:=  Round(LayA[CurrentLayer].StippleStep*100);
   StippleSizeLabel.Caption := Format('(%.1f)', [LayA[CurrentLayer].StippleStep]);
   StippleStepper.Position:=LayA[CurrentLayer].StippleColorCount-1;
   StippleColorPanel.Color :=  LayA[CurrentLayer].StippleColorArray[StippleStepper.Position];
   StippleStepperLabel.Caption :=Format('(%d)', [StippleStepper.Position]);
   StippleCountLabel.Caption :=Format('(%d)', [((LayA[CurrentLayer].StippleColorCount))]);
   StippleStepper.Max:=LayA[CurrentLayer].StippleColorCount-1;

  CanvasLineUpDown.Position:=LayA[CurrentLayer].CanvasLineSize;
  CanvasLineSizeLabel.Caption:=Format('(%d)', [CanvasLineUpDown.Position]);

  i:= LayA[CurrentLayer].ShpType;
  Case i of
 0: ShapeTypeLabel.Caption:='Null Shape';
 1: ShapeTypeLabel.Caption:='Point';
 3: ShapeTypeLabel.Caption:='PolyLine';
 5: ShapeTypeLabel.Caption:='Polygon';
 8: ShapeTypeLabel.Caption:='MultiPoint';
11: ShapeTypeLabel.Caption:='PointZ';
13: ShapeTypeLabel.Caption:='PolyLineZ';
15: ShapeTypeLabel.Caption:='PolygonZ';
18: ShapeTypeLabel.Caption:='MultiPointZ';
21: ShapeTypeLabel.Caption:='PointM';
23: ShapeTypeLabel.Caption:='PolyLineM';
25: ShapeTypeLabel.Caption:='PolygonM';
28: ShapeTypeLabel.Caption:='MultiPointM';
31: ShapeTypeLabel.Caption:='MultiPatch';      {Fan or Strip     }
end;{case}

  {ots}
  LayerPlatoEdit.Text:=LayA[CurrentLayer].LayerPlatoEditText;
  ProjectActorEdit.Text:=ProjectRobotRldFilename;
  MaximumShapeObjectsEdit.Text :=Inttostr(MaximumShapeObjects);
  {HTFix}
  XLabel.Caption:=FLoattostr(LayA[CurrentLayer].OffsetX);
  X2Label.Caption:=FLoattostr(LayA[CurrentLayer].XMin);

  DShiftOffsetX:=DataScalerX;
  XLonEdit.Text:=FloattoStr(DataScalerX);
  DShiftOffsetY:=DataScalerY;
  YLatEdit.Text:=FloattoStr(DataScalerY);

HTFXLabel.Caption:=FloattoStr(DataScalerX*DataSizeMaxOffX);
HTFYLabel.Caption:=FloattoStr(DataScalerY*DataSizeMaxOffY);
HTFXEdit.Text:=FloattoStr(DataScalerX*DataSizeMaxOffX);
HTFYEdit.Text:=FloattoStr(DataScalerY*DataSizeMaxOffY);

  If FileExists(ChangeFileExt(
  LayA[CurrentLayer].Path+
  LayA[CurrentLayer].Filename,'.vrp'))then
  begin
    DoDatumBtn.Enabled:=True;
    {Read ProjectionRecord}
  end else
  begin
    DoDatumBtn.Enabled:=False;
    InDatumCB.ItemIndex:=24;{UnknownWGS84=23}
  end;
  {  LineScrollBar(Sender);}
  //OdlRG.ItemIndex:=P2LayerPaleCommand;
  //Phase2Edit.Text:=Phase2DTSEditText;
  SetDtmData;
end;
{procedure THtfForm.ReadAnyVersionProj(ReadFileName:String);
procedure THtfForm.ReadVersionProj(ReadFileName:String);
procedure THtfForm.ReadVer1Proj(ReadFileName:String);}

procedure TdtmDTPForm.LegendLayerCBClick(Sender: TObject);
var i:Integer;
begin
  CurrentLayer:= LegendLayerCB.ItemIndex+1;
  i:= LayA[CurrentLayer].ShpType;
  Case i of
 0: ShapeTypeLabel.Caption:='Null Shape';
 1: ShapeTypeLabel.Caption:='Point';
 3: ShapeTypeLabel.Caption:='Line';
 5: ShapeTypeLabel.Caption:='Area Polygon';
 8: ShapeTypeLabel.Caption:='MultiPoint';
11: ShapeTypeLabel.Caption:='PointZ';
13: ShapeTypeLabel.Caption:='PolyLineZ';
15: ShapeTypeLabel.Caption:='PolygonZ';
18: ShapeTypeLabel.Caption:='MultiPointZ';
21: ShapeTypeLabel.Caption:='PointM';
23: ShapeTypeLabel.Caption:='PolyLineM';
25: ShapeTypeLabel.Caption:='PolygonM';
28: ShapeTypeLabel.Caption:='MultiPointM';
31: ShapeTypeLabel.Caption:='MultiPatch';      {Fan or Strip     }
end;{case}
  LayerVisibleCB.Checked:=  LayA[CurrentLayer].Visible;
  LegendColorsPanel.Color := LayA[CurrentLayer].LayerColor;
  OutlineColorPanel.Color:= LayA[CurrentLayer].OutLineColor;
   Antialiase.Checked:=  LayA[CurrentLayer].PolygonAntialiased;
   PolyFilledCB.Checked:= LayA[CurrentLayer].PolyFilled;
   PolyFillTypeRG.ItemIndex:= LayA[CurrentLayer].PolyFillType;
   PolyFillFileEdit.Text:=LayA[CurrentLayer].PolyFillFile;

   ThickOutline.Checked:= LayA[CurrentLayer].UseOutlinePoly;
   LineAlpha.Position:=  LayA[CurrentLayer].LineAlphaPosition;
   LineOpacityLabel.Caption := Format('(%d)', [LayA[CurrentLayer].LineAlphaPosition]);
   FillAlpha.Position:=  LayA[CurrentLayer].FillAlphaPosition;
   FillOpacityLabel.Caption := Format('(%d)', [LayA[CurrentLayer].FillAlphaPosition]);
   LineThickness.Position:=  Round(LayA[CurrentLayer].LineSize*10);
   OutlineThicknessLabel.Caption := Format('(%.1f)', [LayA[CurrentLayer].LineSize]);
   PointTypeRG.ItemIndex:=LayA[CurrentLayer].CurrentPointType;{CurrentPointType}
   PointSizeScrollBar.Position:=  ((LayA[CurrentLayer].PointSize));
   PointSizeLabel.Caption := Format('(%d)', [((LayA[CurrentLayer].PointSize*2)+1)]);
   LineScrollBar.Position:=  Round(LayA[CurrentLayer].StippleStep*100);
   StippleSizeLabel.Caption := Format('(%.1f)', [LayA[CurrentLayer].StippleStep]);
   StippleStepper.Position:=LayA[CurrentLayer].StippleColorCount-1;
   StippleColorPanel.Color :=  LayA[CurrentLayer].StippleColorArray[StippleStepper.Position];
   StippleStepperLabel.Caption :=Format('(%d)', [StippleStepper.Position]);
   StippleCountLabel.Caption :=Format('(%d)', [((LayA[CurrentLayer].StippleColorCount))]);
   StippleStepper.Max:=LayA[CurrentLayer].StippleColorCount-1;

  CanvasLineUpDown.Position:=LayA[CurrentLayer].CanvasLineSize;
  CanvasLineSizeLabel.Caption:=Format('(%d)', [CanvasLineUpDown.Position]);

   LineScrollBarChange(Sender);
  {ots}
  LayerPlatoEdit.Text:=LayA[CurrentLayer].LayerPlatoEditText;
  //OtsNameEdit.Text:=LayA[CurrentLayer].OtsNameEditText;
  //LayerDTSUpDown.Position:= LayA[CurrentLayer].LayerPlatoCommand;
  {Get Shape Layer Attributes to fill ComboBoxes}
  EcotypeLayerAttributeCB.Clear;
  PatternLayerAttCB.Clear;
  aldShapeAttCB.Clear;
  PointShapeAttCB.Clear;
  LinearShapeAttCB.Clear;
  For i:= 0 to LayA[CurrentLayer].AttributesN-1 do
  begin
    EcotypeLayerAttributeCB.Items.Add(
     LayA[CurrentLayer].AttType[i].Displayname);
    PatternLayerAttCB.Items.Add(
     LayA[CurrentLayer].AttType[i].Displayname);
    aldShapeAttCB.Items.Add(
     LayA[CurrentLayer].AttType[i].Displayname);
    PointShapeAttCB.Items.Add(
     LayA[CurrentLayer].AttType[i].Displayname);
    LinearShapeAttCB.Items.Add(
     LayA[CurrentLayer].AttType[i].Displayname);
  end;
  EcotypeLayerAttributeCB.ItemIndex:=0;
  PatternLayerAttCB.ItemIndex:=0;
  aldShapeAttCB.ItemIndex:=0;
  PointShapeAttCB.ItemIndex:=0;
  LinearShapeAttCB.ItemIndex:=0;

  LayerShapeCountLabel.Caption:= inttostr(LayA[CurrentLayer].ShapeN);
  {HTFix}
  XLabel.Caption:=FLoattostr(LayA[CurrentLayer].OffsetX);
  X2Label.Caption:=FLoattostr(LayA[CurrentLayer].XMin);

  If FileExists(ChangeFileExt(
  LayA[CurrentLayer].Path+
  LayA[CurrentLayer].Filename,'.vrp'))then
  begin
    DoDatumBtn.Enabled:=True;
    {Read ProjectionRecord}
  end else
  begin
    DoDatumBtn.Enabled:=False;
    InDatumCB.ItemIndex:=24;{UnknownWGS84=23}
  end;
end;

procedure TdtmDTPForm.DoDatumBtnClick(Sender: TObject);
begin
{InDatumCB.ItemIndex  WGS84=23

buzDatum, buzGlobal

Procedure ConvertDatums(
                    LongXCoord, LatYCoord:Double;
                    var XCoord, YCoord:Double);}
end;
(*****************************************************)
(*****************************************************)



(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.XUpBtnClick(Sender: TObject);
begin
    DShiftOffsetX:=DShiftOffsetX+DataScalerX;
    XLonEdit.Text:=FloattoStr(DShiftOffsetX);
end;

procedure TdtmDTPForm.XDownBtnClick(Sender: TObject);
begin
    DShiftOffsetX:=DShiftOffsetX-DataScalerX;
    XLonEdit.Text:=FloattoStr(DShiftOffsetX);
end;

procedure TdtmDTPForm.YUpBtnClick(Sender: TObject);
begin
    DShiftOffsetY:=DShiftOffsetY+DataScalerY;
    YLatEdit.Text:=FloattoStr(DShiftOffsetY);
end;

procedure TdtmDTPForm.YDownBtnClick(Sender: TObject);
begin
    DShiftOffsetY:=DShiftOffsetY-DataScalerY;
    YLatEdit.Text:=FloattoStr(DShiftOffsetY);
end;

procedure TdtmDTPForm.ReSetBtnClick(Sender: TObject);
begin
    DShiftOffsetX:=DataScalerX;
    XLonEdit.Text:=FloattoStr(DShiftOffsetX);
    DShiftOffsetY:=DataScalerY;
    YLatEdit.Text:=FloattoStr(DShiftOffsetY);
    DTMform.PrepareBitmap;
end;

procedure TdtmDTPForm.SetBtnClick(Sender: TObject);
begin
  DTMform.PrepareBitmap;
{XLonEdit.Text}
{YLatEdit.Text}
end;

(*
    TMaxOffsetX:=( (360 /htf.SizeX));
    TMaxOffsetY:=( (180 /htf.SizeY));
    TMaxOffX:= htf.SizeX;
    TMaxOffY:= htf.SizeY;

        TMinOffX:= curX;
        TMinOffY:= curY;
        DVDORedraw;


    If CurrentLayer =1 then
    Begin
      MinOffX:=LayA[CurrentLayer].XMin;
      MinOffY:=LayA[CurrentLayer].YMin;
      MaxOffX:=LayA[CurrentLayer].XMax;
      MaxOffY:=LayA[CurrentLayer].YMax;
    End;


      {Offset is +- to center data to 0,0}
      TMinOffX:= TMinOffX*TMaxOffsetX;
      TMinOffY:= TMinOffY*TMaxOffsetY;
      ScreenScale :=   TMaxOffsetX;

              dXTemp:=LayA[LayerDo].LyrShp[ShapeToDo].XMax;
              dYTemp:=LayA[LayerDo].LyrShp[ShapeToDo].YMax;
              DXdtemp:=MaxOffsetX +dXTemp- TMinOffX ;
              DYdtemp:=MaxOffsetY +dYTemp+ TMinOffY;
              DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
              DYI:=Trunc(TMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
              Image321.Bitmap.FillRect(DXI-2,DYI-2,DXI+2,DYI+2,PointColor);


              dXTemp:=LayA[LayerDo].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Xd;
              dYTemp:=LayA[LayerDo].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Yd;
              DXdtemp:=MaxOffsetX +dXTemp- TMinOffX ;
              DYdtemp:=MaxOffsetY +dYTemp+ TMinOffY;
              DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
              DYI:=Trunc(TMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
              Editarray[INumPoints-1].X:= DXI;
              Editarray[INumPoints-1].Y:= DYI;
*)

procedure TdtmDTPForm.SetHTFBtnClick(Sender: TObject);
begin
  {isHTFLoaded}
  DataScalerX:=( (strtofloatdef(HTFXEdit.Text) /DataSizeMaxOffX));
  DataScalerY:=( (strtofloatdef(HTFYEdit.Text) /DataSizeMaxOffY));
  HTFXLabel.Caption:=FloattoStr(DataScalerX*DataSizeMaxOffX);
  HTFYLabel.Caption:=FloattoStr(DataScalerY*DataSizeMaxOffY);
  {HTFXEdit.Text:=FloattoStr(TMaxOffsetX*TMaxOffX);
   HTFYEdit.Text:=FloattoStr(TMaxOffsetY*TMaxOffX); }
end;
(*****************************************************)
(*****************************************************)





(*****************************************************)
   {ProjectPath: .dtp .. and its files vld, ots, ...
   MapsPath :.dtm
   TigerPath md2 smd qc .
   DXFPath dxf 3ds
3D Formats: 3DS, OBJ, SMD, MD2, TIN, PLY, STL
2D Formats: JPG, BMP, TGA, CEL etc.
   }
(*****************************************************)
procedure TdtmDTPForm.oldOpenSetBtnClick(Sender: TObject);
var
 ActorFileName,TextureFileName,
 OdlFilename,
 S : string;
 F: TextFile;
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Object List Defined (*.old)|*.old';
  If (OldNameEdit.Text=NoName) then
     OpenDialog.Filename:= '*.old' else
  If (OldNameEdit.Text <> '') then
  OpenDialog.Filename:= '*.old' else
  OpenDialog.Filename:= OldNameEdit.Text;
  if OpenDialog.Execute then
  if UpperCase(ExtractFileExt(OpenDialog.Filename)) = '.OLD' then
  begin
    If (not FileExists(OpenDialog.Filename)) then Exit;
    Application.ProcessMessages;
    AssignFile(F, OpenDialog.FileName);
    Reset(F);
    Readln(F, S);
    If (S=GoatVersion) then
    begin
    ProjectPath:=ExtractFilePath(OpenDialog.Filename);
    OldNameEdit.Text:=OpenDialog.FileName;
    Readln(F, S);
    If S='True' then oldObjectCB.Checked:=True
                else oldObjectCB.Checked:=False;{Boolean}
    Readln(F, S);
    If S='True'  then oldTextureOnlyCB.Checked:=True
                 else oldTextureOnlyCB.Checked:=False;
    Readln(F, S);
    If S='True'  then oldSSObjectCB.Checked:=True
                 else oldSSObjectCB.Checked:=False;

      Readln(F, ActorFileName);
      oldObjectFileNameEdit.Text:=ActorFileName;
      Readln(F, TextureFileName);
      oldTextureFileNameEdit.Text:=TextureFileName;
      Readln(F, S);
      OldSizeEdit.Text:=S;
      Readln(F, S);
      oldCTRG.ItemIndex:=strtoint(S);
      Readln(F, OdlFilename);
      Readln(F, S);
      OldLengthEdit.Text:=S;
      Readln(F, S);
      OldWidthEdit.Text:=S;
      Readln(F, S);
      OldUpDirEdit.Text:=S;
      Readln(F, S);
      OldHeightEdit.Text:=S;
      Readln(F, S);
      OldUpSizeEdit.Text:=S;
      OdlFilenameEdit.Text:=OdlFilename;
      odlRichEdit.Lines.LoadFromFile(OdlFilename);
    end else {Error Message Wrong File type Version};
    CloseFile(F);
  end;
end;

procedure TdtmDTPForm.oldSaveSetBtnClick(Sender: TObject);
var
 WhatsMyLine : string;
 F: TextFile;
begin  { for Actor and Texture}
  If ((FileExists(oldObjectFileNameEdit.Text))) then
  begin
    SaveDialog1.InitialDir:=ProjectPath;
    OpenDialog.Filter:= 'Object List Defined (*.old)|*.old';
    SaveDialog1.Filename:= OldNameEdit.Text;
    if SaveDialog1.Execute then
    if UpperCase(ExtractFileExt(SaveDialog1.Filename)) = '.OLD' then
    begin
      ProjectPath:=ExtractFilePath(SaveDialog1.Filename);
      AssignFile(F, SaveDialog1.FileName);
      Rewrite(F);
      writeln(F, GoatVersion);
      If oldObjectCB.Checked  then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
      Writeln(F, WhatsMyLine);{}
      If oldTextureOnlyCB.Checked  then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
      Writeln(F, WhatsMyLine);{}
      If oldSSObjectCB.Checked  then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
      Writeln(F, WhatsMyLine);{}

      If (not FileExists(oldObjectFileNameEdit.Text)) then
      oldObjectFileNameEdit.Text:= NoName;
      writeln(F, oldObjectFileNameEdit.Text);
      If (not FileExists(oldTextureFileNameEdit.Text)) then
      oldTextureFileNameEdit.Text:= NoName;
      writeln(F, oldTextureFileNameEdit.Text);
      //If no size entered then Make It So
      If length(OldSizeEdit.Text)<1 then
      OldSizeEdit.Text:= '1';
      {Check Validity of Input Size: is it a number?}
      writeln(F, OldSizeEdit.Text);
      writeln(F, inttostr(oldCTRG.ItemIndex));
      writeln(F, OldLengthEdit.Text);
      writeln(F, OldWidthEdit.Text);
      writeln(F, OldUpDirEdit.Text);
      writeln(F, OldHeightEdit.Text);
      writeln(F, OldUpSizeEdit.Text); 
      If (not FileExists(OdlFilenameEdit.Text)) then
      OdlFilenameEdit.Text:= NoName;
      writeln(F, OdlFilenameEdit.Text);
      If ( FileExists(OdlFilenameEdit.Text)) then
          odlRichEdit.Lines.SaveToFile(OdlFilenameEdit.Text);
      CloseFile(F);
    end;
  end;
end;
   {TigerPath md2 smd qc ??? qc IS a kind of ots !!!
    SMD, MD2|*. SMD;*. MD2
    DXFPath dxf 3ds
    3DS, OBJ, TIN, PLY, STL|*.3DS;*. OBJ;*.TIN; *.PLY; *.STL
   }
procedure TdtmDTPForm.oldOpenActorBtnClick(Sender: TObject);
begin
  If (oldObjectCB.Checked or oldSSObjectCB.Checked) then
  begin
    OpenDialog.InitialDir:=DXFPath;
    {If oldSSObjectCB.Checked then //NO MD2 in ShapeShifter?
    OpenDialog.Filter:= 'Object (*.3ds)|*.3DS;*. OBJ;*.TIN;*.PLY;*.STL'
    else }
    //    //MDC MD3 GL2 MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GTS LWO GLSM
    OpenDialog.Filter:= 'Object (*.3ds)|*.MD2;*.3DS;*.OBJ;*.TIN;*.PLY;*.STL;*.OCT;*.NMF;*.GTS;*.LWO;*.MS3D;*.GLSM';
    OpenDialog.Filename:= '*.3ds';
    if OpenDialog.Execute then
    begin
      oldObjectFileNameEdit.Text:=OpenDialog.Filename;
      DXFPath:=ExtractFilePath(OpenDialog.Filename);
    end;
  end
  {else If oldTextureOnlyCB.Checked then
  begin
    OpenDialog.InitialDir:=DXFPath;
    OpenDialog.Filter:= 'Texture Billboard (*.png)|*.png;*.jpg;*.tga;*.bmp';
    OpenDialog.Filename:= '*.png';
    if OpenDialog.Execute then
    begin
      oldObjectFileNameEdit.Text:=OpenDialog.Filename;
      DXFPath:=ExtractFilePath(OpenDialog.Filename);
    end;
  end};
end;

procedure TdtmDTPForm.oldOpenTextureBtnClick(Sender: TObject);
begin
  OpenPictureDialog1.Filter:= 'Texture (*.png)|*.png;*.jpg;*.tga;*.bmp';
  if OpenPictureDialog1.Execute then
  oldTextureFileNameEdit.Text:=OpenPictureDialog1.Filename;
end;

procedure TdtmDTPForm.oldAddodlBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (pth,evl,act)|*.pth;*.evl;*.act';
  OpenDialog.FileName:= '*.*';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    OdlRichEdit.Lines.Add(OpenDialog.Filename);
  end;
end;

procedure TdtmDTPForm.oldSaveodlBtnClick(Sender: TObject);
begin
  SaveDialog1.InitialDir:=ProjectPath;
    OpenDialog.Filter:= 'Object List Defined (*.old)|*.old';
  SaveDialog1.Filename:= OdlFilenameEdit.Text;
  if SaveDialog1.Execute then
  begin
    OdlFilenameEdit.Text:=SaveDialog1.Filename;
    odlRichEdit.Lines.SaveToFile(SaveDialog1.Filename);
  end;
end;

procedure TdtmDTPForm.oldSetodlBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
    OpenDialog.Filter:= 'Object List Defined (*.old)|*.old';
  If (OdlFilenameEdit.Text='') then
     OpenDialog.Filename:= '*.old' else
  OpenDialog.Filename:= OdlFilenameEdit.Text;
  if OpenDialog.Execute then
  begin
    OdlFilenameEdit.Text:=OpenDialog.Filename;
    odlRichEdit.Lines.LoadFromFile(OpenDialog.Filename);
  end;
end;
(*****************************************************)

(*****************************************************)
procedure TdtmDTPForm.ToolsDoPathBtnClick(Sender: TObject);
var   //DTMform.DVDORedraw; line 3405
  NameString:String;
   INumparts,  INumPoints,NumParts, NumPoints,
  TotalShapePaths,TotalNodes,ShapeToDo:Integer;
   DXdtemp,DYdtemp:Double;
  F: TextFile;
begin
  if Assigned(htf) then
  begin
    //Select a filename and save data
    SaveDialog1.Filter := 'Path files (*.pth)|*.pth';
    SaveDialog1.InitialDir:=ProjectPath;
    if SaveDialog1.Execute then          { Display Open dialog box }
    begin
      GeneralSortListBox.Clear;
      //Make a Copy of the name as BASE File Name..
      //Get Count of Shapes
      TotalShapePaths:=(LayA[CurrentLayer].ShapeN);
      For ShapeToDo:= 1 to TotalShapePaths Do
      Begin
        ToolsCurrentConversionLabel.Caption:=inttostr(ShapeToDo)+
                                              ' of '+
                                             inttostr(TotalShapePaths);
        //Cycle Through the Layer and COUNT the Number of Nodes in the Line
        //Then do it again to get the X,Y,Z locations
        TotalNodes:=0;
        Numparts:=LayA[CurrentLayer].LyrShp[ShapeToDo].PartsN;{Numparts}
        for INumparts := 1 to Numparts do
        begin {Always at least 1 0...}
            NumPoints:=LayA[CurrentLayer].LyrShp[ShapeToDo].PPA[INumparts];
            TotalNodes:=TotalNodes+NumPoints;
        end;

        NameString:=Copy(SaveDialog1.FileName,0,length(SaveDialog1.FileName)-4);
        NameString:=NameString+Inttostr(ShapeToDo)+'.pth';
        GeneralSortListBox.Items.Add(NameString);
        AssignFile(F, NameString);
        Rewrite(F);
        //Write Header stuff
        Writeln(F, PathVersion);
        Writeln(F, Inttostr(FileSizeX));  //XYZ Max Min to make Grids
        Writeln(F, Inttostr(0)); //: [Default 10x10x10]
        Writeln(F, Inttostr(FileSizeY));
        Writeln(F, Inttostr(0));
        Writeln(F, Inttostr(MaximumElevation));
        Writeln(F, Inttostr(MinimumElevation));
        //function InputBox(const ACaption, APrompt, ADefault: string): string
        //OffsetString:= InputBox('Path Limits','X Offset','0');
        Writeln(F,Inttostr(0));
        //OffsetString:= InputBox('Path Limits','Y Offset','0');
        Writeln(F,Inttostr(0));
        //OffsetString:= InputBox('Path Limits','Z Offset','0');
        Writeln(F,Inttostr(0));
        Writeln(F, Inttostr(0));
        Writeln(F, Inttostr(0));
        Writeln(F, Inttostr(0));
        Writeln(F, Floattostr(0.5));
        Writeln(F, Floattostr(0.5));
        Writeln(F, Floattostr(0.5));
        Writeln(F, Floattostr(1.0));
        Writeln(F, Floattostr(1.0));
        Writeln(F, Floattostr(1.0));
        {    XMax,  XMin, YMax, YMin, ZMax, ZMin
             XOffset,YOffset, ZOffset,
               XOrigin, YOrigin, ZOrigin,
               //Areal Extents of the Grid :Integer;
           XStep,YStep,ZStep,
           XScale, YScale, ZScale  : Single; }
        Writeln(F,'1'); //Number of Active Paths..  Paths [1]
                      //I dunno HOW so just 1.. it is # 0
        Writeln(F,'1'); //SplineMode
        Writeln(F, Inttostr(TotalNodes));
        Writeln(F,'0');//LoopCount
        Writeln(F,'False');
        Writeln(F,'False');
        Writeln(F,'False');
        Writeln(F,'False');

        Numparts:=LayA[CurrentLayer].LyrShp[ShapeToDo].PartsN;{Numparts}
        for INumparts := 1 to Numparts do
        begin {Always at least 1 0...}
          NumPoints:=LayA[CurrentLayer].LyrShp[ShapeToDo].PPA[INumparts];
          for INumPoints := 1{2} to NumPoints do
          begin {2 points internally}
            dXTemp:=LayA[CurrentLayer].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Xd;
            dYTemp:=LayA[CurrentLayer].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Yd;
            DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
            DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
            Writeln(F,Floattostr(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))));
            Writeln(F,Floattostr( ((DXdtemp   ) / ScreenScale) ));
            Writeln(F,0);//z
            Writeln(F,0);
            Writeln(F,0);
            Writeln(F,0);
            Writeln(F,1);
            Writeln(F,1);
            Writeln(F,1);
            Writeln(F,1);
            Writeln(F,1);  //Node Number #
          end;
        end;
        CloseFile(F);
      end;
      NameString:=ChangeFileExt(SaveDialog1.FileName ,'.ldl');
      AssignFile(F, NameString);
      Rewrite(F);
      for INumPoints := 0 to GeneralSortListBox.Items.Count-1 do
      Writeln(F, GeneralSortListBox.Items.Strings[INumPoints]);
      CloseFile(F);        
      GeneralSortListBox.Clear;
    end;
  end;
end;
(*****************************************************)



(*****************************************************)
procedure TdtmDTPForm.LayerVisibleCBClick(Sender: TObject);
begin
  LayA[CurrentLayer].Visible:=(not LayA[CurrentLayer].Visible);
end;
(*****************************************************)
procedure TdtmDTPForm.LegendColorsPanelClick(Sender: TObject);
begin
  ColorDialog1.Color :=
  LayA[CurrentLayer].LayerColor;
  {LegendColorsPanel.Color;}
  if ColorDialog1.execute then
  begin
    LegendColorsPanel.Color := ColorDialog1.Color;
    {MapGridsColor := LegendColorsPanel.Color;}
    LayA[CurrentLayer].LayerColor:=LegendColorsPanel.Color;
  end;
end;

procedure TdtmDTPForm.OutlineColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color :=
  LayA[CurrentLayer].OutLineColor;
  {LegendColorsPanel.Color;}
  if ColorDialog1.execute then
  begin
    OutlineColorPanel.Color := ColorDialog1.Color;
    {MapGridsColor := LegendColorsPanel.Color;}
    LayA[CurrentLayer].OutLineColor:=OutlineColorPanel.Color;
  end;
end;
(*****************************************************)
(*****************************************************)

procedure TdtmDTPForm.ViewChangesBtnClick(Sender: TObject);
begin
  DTMform.PrepareBitmap;
end;

(*****************************************************)
procedure TdtmDTPForm.PolyFillFileBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Fill (*.pld eld)|*.eld;*.pld';
  If (PolyFillFileEdit.Text='') then
     OpenDialog.Filename:= '*.pld' else
  OpenDialog.Filename:= PolyFillFileEdit.Text;
  if OpenDialog.Execute then
  if ( (UpperCase(ExtractFileExt(OpenDialog.Filename)) = '.PLD')
     or(UpperCase(ExtractFileExt(OpenDialog.Filename)) = '.ELD')) then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.Filename);
    PolyFillFileEdit.Text:=(OpenDialog.Filename);
    LayA[CurrentLayer].PolyFillFile:=OpenDialog.Filename;
    //PaintMyPoly;
  end;
end;
(*****************************************************)
procedure TdtmDTPForm.AntialiaseClick(Sender: TObject);
begin      {False}
  LayA[CurrentLayer].PolygonAntialiased:=Antialiase.Checked;
  PaintMyPoly;
end;

procedure TdtmDTPForm.PolyFilledCBClick(Sender: TObject);
begin{}
  LayA[CurrentLayer].PolyFilled:=PolyFilledCB.Checked;
  PaintMyPoly;
end;
procedure TdtmDTPForm.PolyFillTypeRGClick(Sender: TObject);
begin
  LayA[CurrentLayer].PolyFillType:= PolyFillTypeRG.ItemIndex;
  PaintMyPoly;
end;

procedure TdtmDTPForm.LineAlphaChange(Sender: TObject);
begin   {255}
  LayA[CurrentLayer].LineAlphaPosition:=LineAlpha.Position;
  LineOpacityLabel.Caption := Format('(%d)', [LayA[CurrentLayer].LineAlphaPosition]);
  PaintMyPoly;
end;

procedure TdtmDTPForm.FillAlphaChange(Sender: TObject);
begin     {127}
  LayA[CurrentLayer].FillAlphaPosition:=FillAlpha.Position;
  FillOpacityLabel.Caption := Format('(%d)', [LayA[CurrentLayer].FillAlphaPosition]);
  PaintMyPoly;
end;

procedure TdtmDTPForm.LineThicknessChange(Sender: TObject);
begin    {10 of 200}
  LayA[CurrentLayer].UseOutlinePoly := ThickOutline.Checked;
  LayA[CurrentLayer].LineSize := LineThickness.Position / 10;
  OutlineThicknessLabel.Caption := Format('(%.1f)', [LayA[CurrentLayer].LineSize]);
  PaintMyPoly;
end;

procedure TdtmDTPForm.PaintMyPoly;
var
  UseOutlinePoly:Boolean;
  FillAlphaPosition, LineAlphaPosition : integer;
  LineSize:Single;
  PolyColor, OutLineColor:TColor32;
    Polygon: TPolygon32;
    Outline: TPolygon32;
    TmpPoly: TPolygon32;
Begin
  {Draw a line to SEE Transparency against}
  Image32.Bitmap.MoveTo(60, 4);
  Image32.Bitmap.PenColor := Color32(MapGridColor);
  Image32.Bitmap.LineToS(60, 26);
  {Do Poly stuff}
  Polygon := TPolygon32.Create;
  Outline := TPolygon32.Create;
  Polygon.Antialiased := LayA[CurrentLayer].PolygonAntialiased;
  UseOutlinePoly:= LayA[CurrentLayer].UseOutlinePoly;
  Polygon.FillMode := pfWinding;  {pfAlternate}
  OutLineColor:= Color32(LayA[CurrentLayer].OutLineColor);
  PolyColor:= Color32(LayA[CurrentLayer].LayerColor);
  FillAlphaPosition:= LayA[CurrentLayer].FillAlphaPosition;
  LineAlphaPosition:= LayA[CurrentLayer].LineAlphaPosition;
  LineSize:= LayA[CurrentLayer].LineSize;
  Polygon.NewLine;
  Polygon.Add(FixedPoint(10, 10));
  Polygon.Add(FixedPoint(110, 10));
  Polygon.Add(FixedPoint(110, 20));
  Polygon.Add(FixedPoint(10, 20));
  Polygon.Add(FixedPoint(10, 10));
  Polygon.DrawFill(Image32.Bitmap,
               SetAlpha(PolyColor, FillAlphaPosition));
  if UseOutlinePoly then
  begin
    TmpPoly := Polygon.Outline;
    Outline := TmpPoly.Grow(Fixed(LineSize / 2), 0.5);
    Outline.FillMode := pfWinding;
    TmpPoly.Free;
  end;
  if UseOutlinePoly then
     Outline.Antialiased := LayA[CurrentLayer].PolygonAntialiased;
  if UseOutlinePoly then
     Outline.DrawFill(Image32.Bitmap,
                    SetAlpha(OutLineColor, LineAlphaPosition))
     else Polygon.DrawEdge(Image32.Bitmap,
                    SetAlpha(OutLineColor, LineAlphaPosition));
  Outline.Free;
  {Outline := nil;  }
  Polygon.Free;
End;
(*****************************************************)
{Lines}
(*****************************************************)

procedure TdtmDTPForm.StippleCountBtnClick(Sender: TObject);
begin
  Inc(LayA[CurrentLayer].StippleColorCount);
  StippleStepper.Max:=LayA[CurrentLayer].StippleColorCount-1;
  StippleStepper.Position:=LayA[CurrentLayer].StippleColorCount-1;
  StippleColorPanel.Color := clBlack;
  SetLength(LayA[CurrentLayer].StippleColorArray,LayA[CurrentLayer].StippleColorCount);
  LayA[CurrentLayer].StippleColorArray[StippleStepper.Position]:=
  StippleColorPanel.Color;
  StippleCountLabel.Caption:=InttoStr(LayA[CurrentLayer].StippleColorCount);
end;

procedure TdtmDTPForm.StippleStepperClick(Sender: TObject;
  Button: TUDBtnType);
begin
  StippleColorPanel.Color :=
    LayA[CurrentLayer].StippleColorArray[StippleStepper.Position];
  {LayA[CurrentLayer].StippleStepper:=StippleStepper.Position;}
  StippleStepperLabel.Caption:=Format('(%d)', [StippleStepper.Position]);
end;

procedure TdtmDTPForm.LineScrollBarChange(Sender: TObject);
var
I:Integer;
NewStipple: array of TColor32;
begin
  Image32.Bitmap.Clear(clWhite32);
  LayA[CurrentLayer].UseStippleStep := LineStippledCB.Checked;
  LayA[CurrentLayer].StippleStep := LineScrollBar.Position / 100;
  StippleSizeLabel.Caption := Format('(%.1f)', [LayA[CurrentLayer].StippleStep]);
    {SetStipple([clWhite32, clRed32, clGreen32, 0, 0, 0]);
     SetStipple([clGreen32, clGreen32, clGreen32, 0, 0, clWhite32, 0, 0]);
    SetStipple([clWhite32, $00FFFFFF]);
    SetStipple([clWhite32, clWhite32, clWhite32, clWhite32, 0, 0, 0, 0]);
}
  SetLength(NewStipple,LayA[CurrentLayer].StippleColorCount);
    For I:=0 to LayA[CurrentLayer].StippleColorCount-1 do
    NewStipple[I]:=Color32(LayA[CurrentLayer].StippleColorArray[I]);
  Image32.Bitmap.SetStipple(NewStipple);
  Image32.Bitmap.StippleStep := LayA[CurrentLayer].StippleStep;

  Image32.Bitmap.MoveTo(10, 10);
  If LayA[CurrentLayer].UseStippleStep then
   Image32.Bitmap.LineToFSP(110, 10) else
  begin
    Image32.Bitmap.PenColor :=
            Color32(LayA[CurrentLayer].LayerColor);
    Image32.Bitmap.LineToS(110, 10);
  end;
end;

procedure TdtmDTPForm.StippleColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color :=
  LayA[CurrentLayer].StippleColorArray[StippleStepper.Position];
  {LegendColorsPanel.Color;}
  if ColorDialog1.execute then
  begin
    StippleColorPanel.Color := ColorDialog1.Color;
    LayA[CurrentLayer].StippleColorArray[StippleStepper.Position]:= ColorDialog1.Color;
  end;
end;
(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.ProjectSetotsFileBtnClick(Sender: TObject);
begin             //TigerPath
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= '? List Defined (*.?ld)|*.?ld';
  If (LayerPlatoEdit.Text='Nada.?ld') then
     OpenDialog.Filename:= '*.?ld' else
  If (LayerPlatoEdit.Text <> '') then
  OpenDialog.Filename:= '*.?ld' else
  OpenDialog.Filename:= LayerPlatoEdit.Text;
  if OpenDialog.Execute then                            //?ld
  //if UpperCase(ExtractFileExt(OpenDialog.Filename)) = '.OTS' then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.Filename);
    LayerPlatoEdit.Text:=(OpenDialog.Filename);
    LayA[CurrentLayer].LayerPlatoEditText:=OpenDialog.Filename;

  end;
end;


(*****************************************************)
procedure TdtmDTPForm.ProjectRobotRldFileBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Object + Texture Set (*.rld)|*.rld';
  If (ProjectActorEdit.Text='Nada.rld') then
     OpenDialog.Filename:= '*.rld' else
  If (ProjectActorEdit.Text <> '') then
  OpenDialog.Filename:= '*.rld' else
  OpenDialog.Filename:= ProjectActorEdit.Text;
  if OpenDialog.Execute then
  if UpperCase(ExtractFileExt(OpenDialog.Filename)) = '.RLD' then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.Filename);
    ProjectActorEdit.Text:=(OpenDialog.Filename);
    ProjectRobotRldFilename:=OpenDialog.Filename;
  end;
end;
(*****************************************************)
(*****************************************************)


(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.PointSizeScrollBarChange(Sender: TObject);
begin
  LayA[CurrentLayer].PointSize:=PointSizeScrollBar.Position;
  PointSizeLabel.Caption := Format('(%d)', [((LayA[CurrentLayer].PointSize*2)+1)]);
  PaintMyPoints;
end;

procedure TdtmDTPForm.PointTypeRGClick(Sender: TObject);
var PointCaption:String;
begin
  {Points: 0:Dot 1:Circle 2:DotInCircle 3:FilledCircle
        4:PlusSign 5:X 6:Box 7:XInBox 8:FilledBox}
  PointCaption:='Point Type: ';
  Case PointTypeRG.ItemIndex of {Points:}
    0:PointTypeRG.Caption:=PointCaption+'Dot';
    1:PointTypeRG.Caption:=PointCaption+'Circle';
    2:PointTypeRG.Caption:=PointCaption+'DotInCircle';
    3:PointTypeRG.Caption:=PointCaption+'FilledCircle';
    4:PointTypeRG.Caption:=PointCaption+'PlusSign';
    5:PointTypeRG.Caption:=PointCaption+'X';
    6:PointTypeRG.Caption:=PointCaption+'Box';
    7:PointTypeRG.Caption:=PointCaption+'XInBox';
    8:PointTypeRG.Caption:=PointCaption+'FilledBox';
  End;{Case}
  LayA[CurrentLayer].CurrentPointType:=PointTypeRG.ItemIndex;
  PaintMyPoints;
end;

procedure TdtmDTPForm.CanvasLineUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
  LayA[CurrentLayer].CanvasLineSize:=CanvasLineUpDown.Position;
  CanvasLineSizeLabel.Caption:=Format('(%d)', [CanvasLineUpDown.Position]);
  PaintMyPoints;
end;

procedure TdtmDTPForm.PaintMyPoints;
var
   DXI, DYI,
   PointSize, CurrentPointType:Integer;
   Canvas: TCanvas;
{  I:Integer;
   PointColor:TColor32;
   NewStipple: array of TColor32;}
Begin
  Image32.Bitmap.Clear(clWhite32);
  Canvas := TCanvas.Create; // create a new independent TCanvas object
  Canvas.Handle := Image32.Bitmap.Handle;
           { Color32(LayA[CurrentLayer].LayerColor)}
  Canvas.Pen.Color :=LayA[CurrentLayer].LayerColor;
  Canvas.Pen.Style := psSolid;
  Canvas.Pen.Width := LayA[CurrentLayer].CanvasLineSize;
  Canvas.Brush.Color := LayA[CurrentLayer].LayerColor;{OutLineColor;}
  Canvas.Brush.Style := bsSolid; {bsClear}

  CurrentPointType:=  LayA[CurrentLayer].CurrentPointType;
  PointSize:=  LayA[CurrentLayer].PointSize;
  DXI:=10; DYI:=10;
{  SetLength(NewStipple,LayA[CurrentLayer].StippleColorCount);
    For I:=0 to LayA[CurrentLayer].StippleColorCount-1 do
    NewStipple[I]:=Color32(LayA[CurrentLayer].StippleColorArray[I]);
  Image32.Bitmap.SetStipple(NewStipple);
  Image32.Bitmap.StippleStep := LayA[CurrentLayer].StippleStep;
  PointColor := Color32(LayA[CurrentLayer].LayerColor);}
{  Image32.Bitmap.MoveToF(10, 10);
  If CanvasLineSize=0 then
   Image32.Bitmap.LineToFSP(110, 10) else
  begin
    Image32.Bitmap.PenColor :=
            Color32(LayA[CurrentLayer].LayerColor);
    Image32.Bitmap.LineToS(110, 10);
  end;}
          case CurrentPointType of
            0: {Pnt Dot} Canvas.Pixels[DXI, DYI] :=
                LayA[CurrentLayer].LayerColor;
            1: {Pnt Circle}
              begin {    Canvas.Ellipse}
                {The ellipse is outlined using the value of Pen,
                 and filled using the value of Brush.}
                Canvas.Brush.Style :=bsClear;
                Canvas.Ellipse(DXI - PointSize, DYI - PointSize,
                DXI + PointSize, DYI +PointSize);
                Canvas.Brush.Style := bsSolid; {bsClear}
              end;
            2: {Pnt DotInCircle  }
              begin
                Canvas.Ellipse(DXI - PointSize,
                DYI - PointSize, DXI + PointSize, DYI +PointSize);
                Canvas.Pixels[DXI, DYI] :=
                  LayA[CurrentLayer].OutLineColor;
              end;
              {FilledCircle}
            3:
            begin
            Canvas.Pen.Color :=LayA[CurrentLayer].OutLineColor;
            Canvas.Ellipse(DXI - PointSize,
            DYI - PointSize, DXI + PointSize, DYI +PointSize);
            end;
            4: {Pnt PlusSign  +}
              begin
                Canvas.moveto(DXI - PointSize, DYI);
                Canvas.lineto(DXI + PointSize, DYI);
                Canvas.moveto(DXI, DYI + PointSize);
                Canvas.lineto(DXI, DYI - PointSize);
              end;
            5: {PntX   X}
              begin
                Canvas.moveto(DXI - PointSize, DYI - PointSize);
                Canvas.lineto(DXI + PointSize, DYI + PointSize);
                Canvas.moveto(DXI - PointSize, DYI + PointSize);
                Canvas.lineto(DXI + PointSize, DYI - PointSize);
              end;

            6: {Pnt Box X1, Y1, X2, Y2}
{To fill a rectangular region
without drawing the boundary in the current pen,
use FillRect.
To outline a rectangular region without filling it,
use FrameRect or Polygon.
To draw a rectangle with rounded corners, use RoundRect.}
              begin
                Canvas.Brush.Style :=bsClear;
                Canvas.Rectangle(DXI - PointSize,
                DYI - PointSize, DXI + PointSize, DYI +PointSize);
                Canvas.Brush.Style := bsSolid; {bsClear}
              end;
            7: {Pnt XInBox}
              begin
                Canvas.Brush.Style :=bsClear;
                Canvas.Rectangle(DXI - PointSize,
                DYI - PointSize, DXI + PointSize, DYI +PointSize);
                Canvas.Brush.Style := bsSolid; {bsClear}
                Canvas.moveto(DXI - PointSize, DYI - PointSize);
                Canvas.lineto(DXI + PointSize, DYI + PointSize);
                Canvas.moveto(DXI - PointSize, DYI + PointSize);
                Canvas.lineto(DXI + PointSize, DYI - PointSize);
              end;
             8: {FilledBox}
          Canvas.FillRect(Rect(DXI-PointSize,DYI+PointSize,
          DXI+PointSize,DYI-PointSize){,PointColor});
          end; {Case}
Canvas.Free;
End;
(*****************************************************)
(*****************************************************)
  {Points: 0:Dot 1:Circle 2:DotInCircle 3:FilledCircle
        4:PlusSign 5:X 6:Box 7:XInBox 8:FilledBox}
{Points: 9 Types Variable Size, Variable-Thick lines, Color
 Lines: Stippled Color or Variable Width-Solid Color
 Antialiased:  Lines? and Polygon-Outline
 Polygon: Line and Fill Opacity, Line and Fill Color, Outline Thickness}
{Overlaid Stippled on Solid-Wide-lines
 Points from GR32 Polygons
 Bitmap Image- Point/Lines/Polygons
 Jans Symbol maker}
(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.PatternPldOpenBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir:=ProjectPath;
    OpenDialog.Filter:= 'PatternAtt (*.pld)|*.pld';
    OpenDialog.FileName:= '*.pld';
  if OpenDialog.Execute then
  Begin
    LoadDtpLayerPldFile(OpenDialog.Filename);
  end;
end;
procedure TdtmDTPForm.PatternPldSaveBtnClick(Sender: TObject);
begin
    {}
end;

procedure TdtmDTPForm.PatternLayerAttCBClick(Sender: TObject);
begin
    {}
end;

procedure TdtmDTPForm.PatternAttCBClick(Sender: TObject);
begin
    {}
end;
procedure TdtmDTPForm.PatternAttSetBtnClick(Sender: TObject);
var
  Bitmap: TBitmap;
begin
    OpenDialog.InitialDir:=ProjectPath;
    OpenDialog.Filter:= 'PatternAtt (*.bmp)|*.bmp';
    OpenDialog.FileName:= '*.bmp';
  if OpenDialog.Execute then
  Begin
  PatternAttSetEdit.Text:=OpenDialog.Filename;
  Bitmap := TBitmap.Create;
  try
  {Specifies an external bitmap image that defines a pattern for the brush.}
    Bitmap.LoadFromFile(OpenDialog.Filename);
    PatternAttImage.Canvas.Brush.Bitmap := Bitmap;
    PatternAttImage.Canvas.FillRect(Rect(0,0,128,128));
  finally
    PatternAttImage.Canvas.Brush.Bitmap := nil;
    Bitmap.Free;
  end;
  end;
end;

procedure TdtmDTPForm.PatternAttBaseRGClick(Sender: TObject);
begin
{bsSolid, bsClear, bsHorizontal, bsVertical,
bsFDiagonal, bsBDiagonal, bsCross, bsDiagCross}
end;

procedure TdtmDTPForm.PatternAttBaseCBClick(Sender: TObject);
begin
  PatternAttBaseCB.Checked:= (not PatternAttBaseCB.Checked);
  PatternAttBaseRG.Visible:= PatternAttBaseCB.Checked;
end;

procedure TdtmDTPForm.PatternAttUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
    {}
end;
(*****************************************************)
(*****************************************************)


(*****************************************************)
(*****************************************************)

procedure TdtmDTPForm.EcotypeOpenBtnClick(Sender: TObject);
begin
    {}
end;

procedure TdtmDTPForm.EcotypeLayerAttributeCBChange(Sender: TObject);
begin
    {}
end;

procedure TdtmDTPForm.EcotypeAttributeCBChange(Sender: TObject);
begin
    {}
end;

procedure TdtmDTPForm.EcotypeUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
      {}
end;


(*****************************************************)
(*****************************************************)


(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.DtmLoadBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'DTM File (*.dtm)|*.dtm';
  OpenDialog.FileName:= '*.dtm';
  OpenDialog.InitialDir:=MapsPath;
  if OpenDialog.Execute then
  begin
    MapsPath:=ExtractFilePath(OpenDialog.FileName);
    MapName:=ExtractFileName(OpenDialog.FileName);
    DtmLoadEdit.Text:=OpenDialog.Filename;
    Application.ProcessMessages;
    DodtmMapLoad(OpenDialog.Filename);
    SetDtmData;
  end;
end;

(*****************************************************)
procedure TdtmDTPForm.SetDtmData;
Begin
  DtmLoadEdit.Text:=MapsPath+MapName;
  DtmHtfLoadEdit.Text:=HTFPath+HTFName;
  If (HTFPaletteName ='') then
  DtmPalLoadEdit.Text:= ProgramPath+ 'Blue-Green-Red.pal'
  else   DtmPalLoadEdit.Text:=HTFPaletteName;
  Application.ProcessMessages;
  HTFPaletteName:= DtmPalLoadEdit.Text;

  DtmHtfDisplayRG.ItemIndex:=DtmHtfDisplay;
  SlopeDirectionRG.ItemIndex:=SlopeDirection;

  DemCIEdit.Text:= Inttostr(TotalContours);
  DemCIEEdit.Text:=Inttostr(ContourInterval);
  ContourColorsCB.Checked:=UseContourColors;
  SlopeDirectionRG.ItemIndex:=SlopeDirection;
  SlopeCellSizeEdit.Text:=Inttostr(SlopeCellSize);

  LoadDTPOnStartCB.Checked:=LoadDTPOnStart;
  MaximumShapeObjectsEdit.Text :=Inttostr(MaximumShapeObjects);
  MaximumShapeLayersEdit.Text :=Inttostr(MaximumShapeLevels);

  TextureFileTypeRG.ItemIndex:=TextureFileType;

  UseFlippedHTFCB.Checked:= UseFlippedHTF;
  CreateTexturesOnDemandCB.Checked:= CreateTexturesOnDemand;
  SaveCreatedTexturesCB.Checked:= SaveCreatedTextures;
  UseSavedTexturesCB.Checked:=UseSavedTextures;
  UseEcoTypesCB.Checked:=UseEcoTypes;
  UseImageMapCB.Checked:=UseImageMap;
  UseConglomerationCB.Checked:=UseConglomeration;
  UseBumpMapCB.Checked:= UseBumpMap;
  TBRange.Position:=BumpRanger;
    RangeLabel.Caption:=Inttostr(TBRange.Position);
  UseCloudsCB.Checked:=UseClouds;
  UseWavesCB.Checked:=UseWaves;
  UseStormCloudsCB.Checked:=UseStormClouds;
  RunDTSCB.Checked:=RunDTS;
  DtmDtcLoadEdit.Text:=DtmDtcLoad;
  LoadDTCOnStartCB.Checked:=LoadDTCOnStart;
  UseDOVCB.Checked:=UseDOV;
  UseClodPCB.Checked:=UseClodP;
  UseQualityDCB.Checked:=UseQualityD;
  DOVUsedEdit.Text := floattostr(DOVUsed);
  ClodPUsedEdit.Text := floattostr(ClodPUsed);
  QualityDUsedEdit.Text := floattostr(QualityDUsed);
  UseCloudsRangeCB.Checked:=UseCloudsRange;
  StormCloudsRateUsedEdit.Text := floattostr(StormCloudsRateUsed);
  StormCloudsRangeUsedEdit.Text := floattostr(StormCloudsRangeUsed);
  WavesRateUsedEdit.Text := floattostr(WavesRateUsed);
  WavesRangeUsedEdit.Text := floattostr(WavesRangeUsed);
 CloudFileUsedEdit.Text:=CloudFileUsed;
 UseCloudFileCB.Checked:=UseCloudFile;
 UseSunMovingCB.Checked:=UseSunMoving;
  DisplayFPSCB.Checked:=DisplayFPS;

  SunMovingUsedEdit.Text:=Inttostr(SunMovingUsed);
  UseCloudsSRangeCB.Checked:= UseCloudsSRange;
  CloudAnimeEdit.Text :=floattostr(CloudAnime);
  CloudChangeAmountEdit.Text := floattostr(CloudChangeAmount);
  CloudSharpUsedEdit.Text := floattostr(CloudSharpUsed);
  CloudSharpRangeUsedEdit.Text := floattostr(CloudSharpRangeUsed);
  CloudRandomSeedUsedEdit.Text:=Inttostr(CloudRandomSeedUsed );
  CloudImageSizeUsedEdit.Text :=Inttostr(CloudImageSizeUsed);
  CloudMinUsedEdit.Text :=Inttostr(CloudMinUsed);
  CloudMinRangeUsedEdit.Text :=Inttostr(CloudMinRangeUsed);
//
  StormMovingFileUsedEdit.Text:=StormMovingFileUsed;
  StormWindDirectionUsedEdit.Text:=Inttostr(StormWindDirectionUsed);
  StormWindSpeedUsedEdit.Text:=Inttostr(StormWindSpeedUsed);
  StormWindDirectionVarUsedEdit.Text:=Inttostr(StormWindDirectionVarUsed);
  StormWindSpeedVariationUsedEdit.Text:=Inttostr(StormWindSpeedVariationUsed);
  StormCloudsDirectionUsedEdit.Text:=Inttostr(StormCloudsDirectionUsed);
  StormCloudsSpeedUsedEdit.Text:=Inttostr(StormCloudsSpeedUsed);
  StormCloudsNumberUsedEdit.Text:=Inttostr(StormCloudsNumberUsed);

  RainDensityUsedEdit.Text:=floattostr(RainDensityUsed);
  RainDensityVarUsedEdit.Text:=floattostr(RainDensityVarUsed);
  LightningFrequencyUsedEdit.Text:=floattostr(LightningFrequencyUsed);
  LightningForceUsedEdit.Text:=floattostr(LightningForceUsed);
  TornadoeFrequencyUsedEdit.Text:=floattostr(TornadoeFrequencyUsed);
  TornadoeForceUsedEdit.Text:=floattostr(TornadoeForceUsed);
  StormCloudsPosXUsedEdit.Text:=floattostr(StormCloudsPosXUsed);
  StormCloudsPosYUsedEdit.Text:=floattostr(StormCloudsPosYUsed);
  StormCloudsPosZUsedEdit.Text:=floattostr(StormCloudsPosZUsed);
  StormCloudsNumRangeUsedEdit.Text:=floattostr(StormCloudsNumRangeUsed);
  StormCloudsNumRangeVarUsedEdit.Text:=floattostr(StormCloudsNumRangeVarUsed);
  StormCloudsRangeXUsedEdit.Text:=floattostr(StormCloudsRangeXUsed);
  StormCloudsRangeYUsedEdit.Text:=floattostr(StormCloudsRangeYUsed);
  StormCloudsRangeZUsedEdit.Text:=floattostr(StormCloudsRangeZUsed);

  UseCloudsSettingCB.Checked:=UseCloudsSetting;
  UseStormLinearCB.Checked:=UseStormLinear;
  UseStormMovingCB.Checked:=UseStormMoving;
  UseStormMovingDirSCB.Checked:=UseStormMovingDirS;
  UseStormMovingPathCB.Checked:=UseStormMovingPath;
  UseStormRainCB.Checked:=UseStormRain;
  UseStormLightningCB.Checked:=UseStormLightning;
  UseStormTornadoesCB.Checked:=UseStormTornadoes;
  UseStormWindCB.Checked:=UseStormWind;
//
  Case PixelEnlargement of
  2:PixelEnlargementRG.ItemIndex:=0;
  4:PixelEnlargementRG.ItemIndex:=1;
  8:PixelEnlargementRG.ItemIndex:=2;
  16:PixelEnlargementRG.ItemIndex:=3;
  end;
  Case TilesperTexture of
  1:TilesperTextureRG.ItemIndex:=0;
  2:TilesperTextureRG.ItemIndex:=1;
  4:TilesperTextureRG.ItemIndex:=2;
  8:TilesperTextureRG.ItemIndex:=3;
  end;

  //str(XScaleUsed, ShowString);
  XScaleUsedEdit.Text := floattostr(XScaleUsed);
  //XScaleUsedEdit.Text := Format('%12.4f', [XScaleUsed]);//ShowString;

  //str(ZScaleUsed, ShowString);
  ZScaleUsedEdit.Text := floattostr(ZScaleUsed);
  //ZScaleUsedEdit.Text := Format('%12.4f', [ZScaleUsed]);//ShowString;

  //str(SeaLevelUsed, ShowString);
  SeaLevelUsedEdit.Text := inttostr(SeaLevelUsed);
  UseXScaleCB.Checked:= UseXScale;
  UseZScaleCB.Checked:= UseZScale;
  UseSeaLevelCB.Checked:= UseSeaLevel;
End;
{If WhatsMyLine='True' then bDemLoaded:=True
                          else bDemLoaded:=False;                          }
   // HTFPath:=ExtractFilePath(OpenDialog.FileName);
(*****************************************************)
procedure TdtmDTPForm.TBRangeChange(Sender: TObject);
begin
  BumpRanger:=TBRange.Position;
  RangeLabel.Caption:=Inttostr(TBRange.Position);
end;

procedure TdtmDTPForm.DtmHtfLoadBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'HTF File (*.htf)|*.htf;.dtm';
  {HTF File (*.htf)|*.htf|All Files (*.*)|*.*|dtp Files (*.dtp)|*.dtp}
  OpenDialog.FileName:= '*.htf';
  OpenDialog.InitialDir:=HTFPath;
  if OpenDialog.Execute then
  If (Lowercase(ExtractFileExt(OpenDialog.FileName))= '.htf') then
  begin
   // HTFPath:=ExtractFilePath(OpenDialog.FileName);
     DtmHtfLoadEdit.Text:=OpenDialog.Filename;
  end
end;

procedure TdtmDTPForm.DtmHtfDisplayRGClick(Sender: TObject);
begin
  DtmHtfDisplay:=DtmHtfDisplayRG.ItemIndex;
end;

procedure TdtmDTPForm.GetData;
var code: Integer;
begin
        MapsPath:=ExtractFilePath(DtmLoadEdit.Text);
        MapName:=ExtractFileName(DtmLoadEdit.Text);
        HTFPath:=ExtractFilePath(DtmHtfLoadEdit.text);
        HTFName:=ExtractFileName(DtmHtfLoadEdit.text);
  DtmHtfDisplay:=DtmHtfDisplayRG.ItemIndex;
  If (DtmPalLoadEdit.Text  ='') then
  DtmPalLoadEdit.Text:= ProgramPath+ 'Blue-Green-Red.pal';
  Application.ProcessMessages;
  HTFPaletteName:= DtmPalLoadEdit.Text;

  UseFlippedHTF:= UseFlippedHTFCB.Checked;
  UseSavedTextures:=UseSavedTexturesCB.Checked;
  CreateTexturesOnDemand:= CreateTexturesOnDemandCB.Checked;
  SaveCreatedTextures:= SaveCreatedTexturesCB.Checked;

  UseXScale := UseXScaleCB.Checked;
  UseZScale:= UseZScaleCB.Checked;
  UseSeaLevel:= UseSeaLevelCB.Checked;
  val(XScaleUsedEdit.Text, XScaleUsed, Code);
  val(ZScaleUsedEdit.Text, ZScaleUsed, Code);
  val(SeaLevelUsedEdit.Text, SeaLevelUsed, Code);
  BumpRanger:=TBRange.Position;
  UseBumpMap:= UseBumpMapCB.Checked;
  UseEcoTypes:= UseEcoTypesCB.Checked;
  UseImageMap:= UseImageMapCB.Checked;
  UseConglomeration:= UseConglomerationCB.Checked;
  LoadDTPOnStart :=  LoadDTPOnStartCB.Checked;
  MaximumShapeObjects:= strtoint(MaximumShapeObjectsEdit.Text);
  MaximumShapeLevels:= strtoint(MaximumShapeLayersEdit.Text);
  UseClouds:= UseCloudsCB.Checked;
  UseCloudsRange:= UseCloudsRangeCB.Checked;

  UseWaves:= UseWavesCB.Checked;
  UseStormClouds:= UseStormCloudsCB.Checked;
  UseSunMoving:= UseSunMovingCB.Checked;
  DisplayFPS:= DisplayFPSCB.Checked;

  SunMovingUsed:=Strtoint(SunMovingUsedEdit.Text);
  UseCloudsSRange:=UseCloudsSRangeCB.Checked;
  RunDTS:= RunDTSCB.Checked;
  DtmDtcLoad:=DtmDtcLoadEdit.Text;
  LoadDTCOnStart:=LoadDTCOnStartCB.Checked;
  UseDOV:= UseDOVCB.Checked;
  UseClodP:= UseClodPCB.Checked;
  UseQualityD:= UseQualityDCB.Checked;
  val(DOVUsedEdit.Text, DOVUsed, Code);
  val(ClodPUsedEdit.Text, ClodPUsed, Code);
  val(QualityDUsedEdit.Text, QualityDUsed, Code);
  val(StormCloudsRateUsedEdit.Text, StormCloudsRateUsed, Code);
  val(StormCloudsRangeUsedEdit.Text, StormCloudsRangeUsed, Code);
  val(WavesRateUsedEdit.Text, WavesRateUsed, Code);
  WavesRangeUsed:=Strtoint(WavesRangeUsedEdit.Text);
 CloudFileUsed:=CloudFileUsedEdit.Text;
 UseCloudFile:= UseCloudFileCB.Checked;
   CloudAnime:=Strtoint(CloudAnimeEdit.Text);
  val(CloudChangeAmountEdit.Text, CloudChangeAmount, Code);
  val(CloudSharpUsedEdit.Text, CloudSharpUsed, Code);
  val(CloudSharpRangeUsedEdit.Text, CloudSharpRangeUsed, Code);

  CloudRandomSeedUsed:=Strtoint(CloudRandomSeedUsedEdit.Text);
  CloudImageSizeUsed:=Strtoint(CloudImageSizeUsedEdit.Text);
  CloudMinUsed:=Strtoint(CloudMinUsedEdit.Text);
  CloudMinRangeUsed:=Strtoint(CloudMinRangeUsedEdit.Text);
//
  StormMovingFileUsed:=StormMovingFileUsedEdit.Text;
  StormWindDirectionUsed:=Strtoint(StormWindDirectionUsedEdit.Text);
  StormWindSpeedUsed:=Strtoint(StormWindSpeedUsedEdit.Text);
  StormWindDirectionVarUsed:=Strtoint(StormWindDirectionVarUsedEdit.Text);
  StormWindSpeedVariationUsed:=Strtoint(StormWindSpeedVariationUsedEdit.Text);
  StormCloudsDirectionUsed:=Strtoint(StormCloudsDirectionUsedEdit.Text);
  StormCloudsSpeedUsed:=Strtoint(StormCloudsSpeedUsedEdit.Text);
  StormCloudsNumberUsed:=Strtoint(StormCloudsNumberUsedEdit.Text);

  RainDensityUsed:=StrtoFloatDef(RainDensityUsedEdit.Text);
  RainDensityVarUsed:=StrtoFloatDef(RainDensityVarUsedEdit.Text);
  LightningFrequencyUsed:=StrtoFloatDef(LightningFrequencyUsedEdit.Text);
  LightningForceUsed:=StrtoFloatDef(LightningForceUsedEdit.Text);
  TornadoeFrequencyUsed:=StrtoFloatDef(TornadoeFrequencyUsedEdit.Text);
  TornadoeForceUsed:=StrtoFloatDef(TornadoeForceUsedEdit.Text);
  StormCloudsPosXUsed:=StrtoFloatDef(StormCloudsPosXUsedEdit.Text);
  StormCloudsPosYUsed:=StrtoFloatDef(StormCloudsPosYUsedEdit.Text);
  StormCloudsPosZUsed:=StrtoFloatDef(StormCloudsPosZUsedEdit.Text);
  StormCloudsNumRangeUsed:=StrtoFloatDef(StormCloudsNumRangeUsedEdit.Text);
  StormCloudsNumRangeVarUsed:=StrtoFloatDef(StormCloudsNumRangeVarUsedEdit.Text);
  StormCloudsRangeXUsed:=StrtoFloatDef(StormCloudsRangeXUsedEdit.Text);
  StormCloudsRangeYUsed:=StrtoFloatDef(StormCloudsRangeYUsedEdit.Text);
  StormCloudsRangeZUsed:=StrtoFloatDef(StormCloudsRangeZUsedEdit.Text);

  UseCloudsSetting:=UseCloudsSettingCB.Checked;
  UseStormLinear:=UseStormLinearCB.Checked;
  UseStormMoving:=UseStormMovingCB.Checked;
  UseStormMovingDirS:=UseStormMovingDirSCB.Checked;
  UseStormMovingPath:=UseStormMovingPathCB.Checked;
  UseStormRain:=UseStormRainCB.Checked;
  UseStormLightning:=UseStormLightningCB.Checked;
  UseStormTornadoes:=UseStormTornadoesCB.Checked;
  UseStormWind:=UseStormWindCB.Checked;
//
  Case PixelEnlargementRG.ItemIndex of
  0:PixelEnlargement:=2;
  1:PixelEnlargement:=4;
  2:PixelEnlargement:=8;
  3:PixelEnlargement:=16;
  end;
  Case TilesperTextureRG.ItemIndex of
  0:TilesperTexture:=1;
  1:TilesperTexture:=2;
  2:TilesperTexture:=4;
  3:TilesperTexture:=8;
  end;
  TextureFileType:=TextureFileTypeRG.ItemIndex;

  SlopeDirection:=SlopeDirectionRG.ItemIndex;
  SlopeCellSize:=Strtoint(  SlopeCellSizeEdit.Text);
  TotalContours:=Strtoint(DemCIEdit.Text);
  ContourInterval:=Strtoint(DemCIEEdit.Text);
  UseContourColors := ContourColorsCB.Checked;
end;

procedure TdtmDTPForm.SlopeDirectionRGClick(Sender: TObject);
begin
  SlopeDirection:=SlopeDirectionRG.ItemIndex;
end;

procedure TdtmDTPForm.DtmSaveBtnClick(Sender: TObject);
begin
    SaveDialog1.InitialDir:=MapsPath;
    SaveDialog1.Filter:= 'Dtm Maps set (*.dtm)|*.dtm';
    If DtmLoadEdit.Text<>'' then
    SaveDialog1.Filename:= DtmLoadEdit.Text else
    SaveDialog1.Filename:='*.dtm';
    if SaveDialog1.Execute then
    begin
      //Verify input and Set into Global variables
      If FileExists(DtmHtfLoadEdit.text) then
      begin
        DtmLoadEdit.Text:=SaveDialog1.Filename;
        Application.ProcessMessages;
        GetData;
        //bDemLoaded:=True;
        DodtmMapSave(SaveDialog1.Filename,False);
      end else showmessage(DtmHtfLoadEdit.text+'does not exist');
    end;
end;

procedure TdtmDTPForm.DtmPalLoadBtnClick(Sender: TObject);
begin
     OpenDialog.InitialDir:= ProgramPath;
     OpenDialog.Filter:= 'HTF Palette (*.pal)|*.pal';
     OpenDialog.FileName:= '*.pal';
     if OpenDialog.Execute then
     begin
       if UpperCase(ExtractFileExt(OpenDialog.FileName)) = '.PAL' then
       begin
        HTFPaletteName:=OpenDialog.FileName;
        DtmPalLoadEdit.Text:=OpenDialog.FileName;
       end;
     end;
end;

procedure TdtmDTPForm.DtmDtcLoadBtnClick(Sender: TObject);
begin
  OpenDialog.Filter := 'DTC (*.dtc)|*.dtc';
  OpenDialog.InitialDir := ProjectPath;
  OpenDialog.Filename:='*.dtc';
  if OpenDialog.execute then
  begin
    DtmDtcLoadEdit.Text := OpenDialog.Filename;
  end;
end;

procedure TdtmDTPForm.MakeAndSaveCloudNoiseFileClick(Sender: TObject);
var
  aPERM: array [0..255] of Byte;
  outfile:Textfile;
  i:Integer;
Procedure RandomPerm;
var Idiot,Count,More, Less,again:Integer;
begin
  MakeAndSaveCloudNoiseFile.Caption:=inttostr(0);
  Application.ProcessMessages;
  aPERM[0]:=Random(256);
  Count:=0;
  repeat
    again:=0;
    Less:= Random(256);
    For Idiot := 0 to Count do
    begin
      more:= aPERM[Idiot];
      If (Less = more) then  inc(again);
    end;
      Label61.Caption:= inttostr(again); //these can be removed.. just for debugging
      Application.ProcessMessages;
      If (again = 0) then
      begin
        aPERM[Count+1]:=Less;
        inc(Count);
        MakeAndSaveCloudNoiseFile.Caption:=
        inttostr(Less)+','+inttostr(Count);
        Application.ProcessMessages;
      end;
  until Count = 255
end;
begin
  SaveDialog1.Filter := 'Cloud base (*.clb)|*.clb';
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.DefaultExt:='rnd';
  SaveDialog1.Filename:=ChangeFileExt(ProjectName,'.clb' );
  if (SaveDialog1.Execute) then
  begin
    if UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.CLB' then
    begin
      Application.ProcessMessages;
      Randomize;
      RandomPerm;
      Try
        AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
        Rewrite(outfile);
        Writeln(outfile, 'Cloud Base V1.0');
        For I := 0 to 255 do
          Writeln(outfile, inttostr(aPERM[I]));
      Finally
        CloseFile(outfile);
      End;
      Label61.Caption:='Done';
      MakeAndSaveCloudNoiseFile.Caption:='';
    end;
  end;
end;

procedure TdtmDTPForm.CloudFileOpenBtnClick(Sender: TObject);
begin
  OpenDialog.Filter := 'Cloud base (*.clb)|*.clb';
  OpenDialog.InitialDir := ProjectPath;
  OpenDialog.Filename:=ChangeFileExt(ProjectName,'.clb' );
  if OpenDialog.execute then
  begin
    CloudFileUsedEdit.Text := OpenDialog.Filename;
  end;
end;

procedure TdtmDTPForm.StormMovingPathBtnClick(Sender: TObject);
begin
  OpenDialog.Filter := 'Storm Path (*.pth)|*.pth';
  OpenDialog.InitialDir := ProjectPath;
  OpenDialog.Filename:=ChangeFileExt(ProjectName,'.pth' );
  if OpenDialog.execute then
  begin
    StormMovingFileUsedEdit.Text := OpenDialog.Filename;
  end;
end;


procedure TdtmDTPForm.SlopeCellSizeEditChange(Sender: TObject);
begin
  SlopeCellSize:=Strtoint(  SlopeCellSizeEdit.Text);
end;
(*****************************************************)
(*****************************************************)


(*****************************************************)
(*****************************************************)





(*****************************************************)
(*****************************************************)


(*****************************************************)
(*****************************************************)
//Load and Save can be done Easy here...
procedure TdtmDTPForm.aldOpenBtnClick(Sender: TObject);
var
  outfile:Textfile;
  ControlFileNamesCount, AttributeCount, i:Integer;
  S:String;
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Area List (*.ald)|*.ald';
  If (AreaEdit.Text='') then
     OpenDialog.Filename:= '*.ald' else
     OpenDialog.Filename:= AreaEdit.Text;
  if OpenDialog.Execute then
  begin
    AreaEdit.Text:= OpenDialog.Filename;
    Try     { File selected in dialog box }
      AssignFile(outfile, OpenDialog.FileName);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S);  aldRG.ItemIndex:=strtoint(S);
      Readln(outfile,S);  AreaDisplayRG.ItemIndex:=strtoint(S);
      //The Attribute to Display
      Readln(outfile,S);  aldShapeAttCB.ItemIndex:=strtoint(S);

      //Number of Shape Attribute Values
      Readln(outfile,S);
      AttributeCount:=strtoint(S);
      aldTotalLabel.Caption:=inttostr(AttributeCount);
      aldShapeAttSelectCB.Items.BeginUpdate;
      aldShapeAttSelectCB.Clear;
      For I:=0 to AttributeCount-1 do
      begin
        Readln(outfile, S);
        aldShapeAttSelectCB.Items.add(S);
      end;
      aldShapeAttSelectCB.Items.EndUpdate;
      aldShapeAttSelectCB.ItemIndex:=0;
      aldShapeASUpDown.Position:=0;
      CurrentaldTotalLabel.Caption:=inttostr(aldShapeAttSelectCB.ItemIndex);
      //Array..List of Shape Attribute = ptd Filenames in pdl
      //1=17 2=4 3=11 4=1 5=1
      SetLength(AreaArray,AttributeCount);
      For i:= 0 to AttributeCount-1 do
      begin
        Readln(outfile, S); AreaArray[i].Shape:=strtoint(S);
        Readln(outfile, S); AreaArray[i].FileName:=strtoint(S);
      end;
      Application.ProcessMessages;
      //Filename of  Other Defined List (.odl)
      Readln(outfile,S);
      adlFilenameEdit.Text:= S;
      //Number of ControlFileNames
      Readln(outfile,S);
      ControlFileNamesCount:=strtoint(S);
      adlRichEdit.Clear;
      For I:=0 to ControlFileNamesCount-1 do
      begin
        Readln(outfile, S);
        adlRichEdit.Lines.add(S);
      end;
      //This should set the caption too
      aldAdlUpDown.Position:=0;
      CurrentablLabel.Caption:=inttostr(aldAdlUpDown.Position);
      CurrentAdlEdit.Text:=
        adlRichEdit.Lines[aldAdlUpDown.Position];
    Finally
      CloseFile(outfile);
    End;
  end;
end;
procedure TdtmDTPForm.aldSaveBtnClick(Sender: TObject);
var
  outfile:Textfile;
  i:Integer;
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Area List (*.ald)|*.ald';
  SaveDialog1.Filename:= AreaEdit.Text;
  if SaveDialog1.Execute then
  begin
    AreaEdit.Text:=SaveDialog1.Filename;
    Try
      AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
      Rewrite(outfile);
      Writeln(outfile, GoatVersion); //Open File and Set Data
      Writeln(outfile,inttostr(aldRG.ItemIndex));
      Writeln(outfile,inttostr(AreaDisplayRG.ItemIndex));

      Writeln(outfile,inttostr(aldShapeAttCB.ItemIndex));
      //Number of Shape Attribute Values
      Writeln(outfile,inttostr(aldShapeAttSelectCB.Items.Count));
      For I:= 0 to aldShapeAttSelectCB.Items.Count-1 do
        Writeln(outfile, aldShapeAttSelectCB.Items[i]);
      //Array..List of Shape Attribute = Otd Filenames
      //1=17 2=4 3=11 4=1 5=1
      //If this .ald file Exists it MUST be able to Open and Load pdl ?
      For I:= 0 to aldShapeAttSelectCB.Items.Count-1 do
      begin
        Writeln(outfile, Inttostr(AreaArray[i].Shape));
        Writeln(outfile, Inttostr(AreaArray[i].FileName));
      end;
      //Filename of  Other Defined List (.odl)
      Writeln(outfile, adlFilenameEdit.Text);
      //adlRichEdit.Lines.SavetoFile(adlFilenameEdit.Text);
      For I:= 0 to adlRichEdit.Lines.Count-1 do
        Writeln(outfile, adlRichEdit.Lines[i]);
      Finally
        CloseFile(outfile);
      End;
  end;
end;
procedure TdtmDTPForm.aldShapeAttBtnClick(Sender: TObject);
var
  TooMany,i:Integer;
  DataString:String;
begin
    //Count the number of Attributes the SAME..IF > 100 then STOP
    //PointShapeAttCB.ItemIndex
    TooMany:=0;
    GeneralSortListBox.Items.BeginUpdate;
    GeneralSortListBox.Clear;
    aldShapeAttSelectCB.Items.BeginUpdate;
    aldShapeAttSelectCB.Clear;

    For I:= 0 to LayA[CurrentLayer].ShapeN-1 do
      GeneralSortListBox.Items.Add(LayA[CurrentLayer].LyrShp[I+1].AAttributes[aldShapeAttCB.ItemIndex]);
    GeneralSortListBox.Sorted := True;
    DataString := GeneralSortListBox.Items.Strings[0];
    aldShapeAttSelectCB.Items.Add(GeneralSortListBox.Items.Strings[0]);
    for i := 1 to (GeneralSortListBox.Items.Count - 1) do
    begin
      {Fill list2 with items  That are NOT Duplicates..from a Sorted List}
      if (DataString <> GeneralSortListBox.Items.Strings[i]) then
      begin
      inc(TooMany);
        DataString := GeneralSortListBox.Items.Strings[i];
        aldShapeAttSelectCB.Items.Add(GeneralSortListBox.Items.Strings[i]);
      end; {IF}
    end; {for}
    GeneralSortListBox.Items.Clear; {Done so empty it}
    GeneralSortListBox.Items.EndUpdate;
    aldShapeAttSelectCB.Items.EndUpdate;

    If TooMany> 100 then Showmessage('last one is '+Inttostr(TooMany));
    aldTotalLabel.Caption:=Inttostr(TooMany);
    If TooMany> 100 then aldTotalLabel.Color:=ClRed
       else aldTotalLabel.Color:=clBtnFace;
    SetLength(AreaArray,TooMany);
    For i:= 0 to TooMany-1 do
    begin
      AreaArray[i].Shape:=i; AreaArray[i].FileName:=0;
    end;
end;

procedure TdtmDTPForm.aldShapeASUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  aldShapeAttSelectCB.ItemIndex:=aldShapeASUpDown.Position;
  CurrentaldTotalLabel.Caption:= inttostr(aldShapeASUpDown.Position);
end;
procedure TdtmDTPForm.SetaldShapeBtnClick(Sender: TObject);
begin
  AreaArray[aldShapeASUpDown.Position].Shape:=aldShapeASUpDown.Position;
  AreaArray[aldShapeASUpDown.Position].FileName:=aldAdlUpDown.Position;
end;
procedure TdtmDTPForm.aldAdlUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  CurrentAdlEdit.Text:=adlRichEdit.Lines[aldAdlUpDown.Position];
  CurrentablLabel.Caption:= inttostr(aldAdlUpDown.Position);
end;
///////////////////////////////////////////////////////
procedure TdtmDTPForm.adlOpenAblBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Bioregions List (*.adl)|*.adl';
  If (adlFilenameEdit.Text='') then
     OpenDialog.Filename:= '*.adl' else
  OpenDialog.Filename:= adlFilenameEdit.Text;
  if OpenDialog.Execute then
  begin
    adlFilenameEdit.Text:=OpenDialog.Filename;
    adlRichEdit.Lines.LoadFromFile(OpenDialog.Filename);
    aldAdlUpDown.Position:=0;
  end;
end;

procedure TdtmDTPForm.adlSaveAblBtnClick(Sender: TObject);
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Bioregions List (*.adl)|*.adl';
  SaveDialog1.Filename:= adlFilenameEdit.Text;
  if SaveDialog1.Execute then
  begin
    adlFilenameEdit.Text:=SaveDialog1.Filename;
    adlRichEdit.Lines.SaveToFile(SaveDialog1.Filename);
  end;
end;

procedure TdtmDTPForm.adlOpenAblAddBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Bioregion (*.abl)|*.abl';
  //If there is one in lower level use it
  If (ablEdit.Text='') then
     OpenDialog.Filename:= '*.abl' else
  OpenDialog.Filename:= ablEdit.Text;
  if OpenDialog.Execute then
  begin
    adlRichEdit.Lines.Add(OpenDialog.Filename);
  end;
end;
//////////////////////////////////////////////////////////

procedure TdtmDTPForm.ablOpenBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Species List (*.abl)|*.abl';
  If (ablEdit.Text='') then
     OpenDialog.Filename:= '*.abl' else
  OpenDialog.Filename:= ablEdit.Text;
  if OpenDialog.Execute then
  begin
    ablEdit.Text:=OpenDialog.Filename;
    ablRichEdit.Lines.LoadFromFile(OpenDialog.Filename);
  end;
end;
procedure TdtmDTPForm.ablSaveBtnClick(Sender: TObject);
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Species List (*.abl)|*.abl';
  SaveDialog1.Filename:= ablEdit.Text;
  if SaveDialog1.Execute then
  begin
    ablEdit.Text:=SaveDialog1.Filename;
    ablRichEdit.Lines.SaveToFile(SaveDialog1.Filename);
  end;
end;

procedure TdtmDTPForm.ablAslAddBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Species Defined *.asl)|*.asl';
  If (aslEdit.Text='') then
     OpenDialog.Filename:= '*.asl' else
  OpenDialog.Filename:= aslEdit.Text;
  if OpenDialog.Execute then
  begin
    ablRichEdit.Lines.Add(OpenDialog.Filename);
  end;
end;


procedure TdtmDTPForm.aslOpenBtnClick(Sender: TObject);
var
  outfile:Textfile;
  S:String;
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Species Defined *.asl)|*.asl';
  If (aslEdit.Text='') then
     OpenDialog.Filename:= '*.asl' else
  OpenDialog.Filename:= aslEdit.Text;
  if OpenDialog.Execute then
  begin
    aslEdit.Text:=OpenDialog.Filename;
    
    LinearLtdFilenameEdit.Text:=OpenDialog.Filename;
    Try     { File selected in dialog box }
      AssignFile(outfile, OpenDialog.FileName);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S);  aslSidEdit.Text:=S;
      Readln(outfile,S);  aslUidEdit.Text:=S;
      Readln(outfile,S);  aslCnEdit.Text:=S;
      Readln(outfile,S);  aslSnEdit.Text:=S;
      Readln(outfile,S);  aslGroupEdit.Text:=S;
      Readln(outfile,S);  aslPlantsEdit.Text:=S;
      Readln(outfile,S);  aslDensityEdit.Text:=S;
      Readln(outfile,S);  aslObjTypeRG.ItemIndex:=strtoint(S);
      Readln(outfile,S);  asl3dFileEdit.Text:=S;
      Readln(outfile,S);  asl3dTexEdit.Text:=S;
      Readln(outfile,S);  aslWidthEdit.Text:=S;
      Readln(outfile,S);  aslHeightEdit.Text:=S;
      Readln(outfile,S);  aslDepthEdit.Text:=S;
      Readln(outfile,S);  aslSrEdit.Text:=S;
      Readln(outfile,S);  aslSdEdit.Text:=S;
      Readln(outfile,S);  aslScaleEdit.Text:=S;
      Readln(outfile,S);  aslUpDirEdit.Text:=S;
      Readln(outfile,S);  aslUpSizeEdit.Text:=S;
      Readln(outfile,S);  aslControlEdit.Text:=S;
      Finally
        CloseFile(outfile);
      End;
  end;
end;
procedure TdtmDTPForm.aslSaveBtnClick(Sender: TObject);
var  outfile:Textfile;
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Species Defined *.asl)|*.asl';
  SaveDialog1.Filename:= aslEdit.Text;
  if SaveDialog1.Execute then
  begin
    aslEdit.Text:=SaveDialog1.Filename;
    Try
      AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
      Rewrite(outfile);
      Writeln(outfile, GoatVersion);
      Writeln(outfile, aslSidEdit.Text);
      Writeln(outfile, aslUidEdit.Text);
      Writeln(outfile, aslCnEdit.Text);
      Writeln(outfile, aslSnEdit.Text);
      Writeln(outfile, aslGroupEdit.Text);
      Writeln(outfile, aslPlantsEdit.Text);
      Writeln(outfile, aslDensityEdit.Text);
      Writeln(outfile, inttostr(aslObjTypeRG.ItemIndex));

      Writeln(outfile, asl3dFileEdit.Text);
      Writeln(outfile, asl3dTexEdit.Text);
      Writeln(outfile, aslWidthEdit.Text);
      Writeln(outfile, aslHeightEdit.Text);
      Writeln(outfile, aslDepthEdit.Text);
      Writeln(outfile, aslSrEdit.Text);
      Writeln(outfile, aslSdEdit.Text);
      Writeln(outfile, aslScaleEdit.Text);
      Writeln(outfile, aslUpDirEdit.Text);
      Writeln(outfile, aslUpSizeEdit.Text);
      Writeln(outfile, aslControlEdit.Text);
      Finally
        CloseFile(outfile);
      End;
  end;
end;
procedure TdtmDTPForm.asl3dsOpenBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir:=DXFPath;
    //OpenDialog.Filter:= 'Object (*.3ds)|*.3DS;*. OBJ;*.TIN;*.PLY;*.STL';
    //    //MDC MD3 GL2 MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GTS LWO GLSM
    OpenDialog.Filter:= 'Object (*.3ds)|*.MD2;*.3DS;*.OBJ;*.TIN;*.PLY;*.STL;*.OCT;*.NMF;*.GTS;*.LWO;*.MS3D;*.GLSM';
    OpenDialog.Filename:= '*.3ds';
    if OpenDialog.Execute then
    begin
      asl3dFileEdit.Text:=OpenDialog.Filename;
      DXFPath:=ExtractFilePath(OpenDialog.Filename);
    end;
end;

procedure TdtmDTPForm.aslTexOpenBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir:=DXFPath;
    OpenDialog.Filter:= 'Texture (*.png)|*.png;*.jpg;*.tga;*.bmp';
    OpenDialog.Filename:= '*.png';
    if OpenDialog.Execute then
    begin
      asl3dTexEdit.Text:=OpenDialog.Filename;
      DXFPath:=ExtractFilePath(OpenDialog.Filename);
    end;
end;

procedure TdtmDTPForm.aslControlBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (pth,evl,act)|*.pth;*.evl;*.act';
  OpenDialog.FileName:= '*.evl';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    aslControlEdit.Text:=OpenDialog.FileName;
  end;
end;
(*****************************************************)
(*****************************************************)
//Domain connect each Shape to dbl using a ddl list [of dbl files]
//dbl percent/density of dvl   using a dsl list [of dvl files]

(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.PointOpenPldBtnClick(Sender: TObject);
var
  outfile:Textfile;
  ControlFileNamesCount, AttributeCount,i:Integer;
  S:String;
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Point List (*.pld)|*.pld';
  If (PointEdit.Text='') then
     OpenDialog.Filename:= '*.pld' else
     OpenDialog.Filename:= PointEdit.Text;
  if OpenDialog.Execute then
  begin
    PointEdit.Text:= OpenDialog.Filename;
    Try     { File selected in dialog box }
      AssignFile(outfile, OpenDialog.FileName);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S);  pldRG.ItemIndex:=strtoint(S);
      Readln(outfile,S);  PldDisplayRG.ItemIndex:=strtoint(S);
      Readln(outfile,S);  PldSupportRG.ItemIndex:=strtoint(S);
      //The Attribute to Display
      Readln(outfile,S);  PointShapeAttCB.ItemIndex:=strtoint(S);

      //Number of Shape Attribute Values
      Readln(outfile,S);
      AttributeCount:=strtoint(S);
      PSTLabel.Caption:=inttostr(AttributeCount);
      PointShapeAttSelectCB.Items.BeginUpdate;
      PointShapeAttSelectCB.Clear;
      For I:=0 to AttributeCount-1 do
      begin
        Readln(outfile, S);
        PointShapeAttSelectCB.Items.add(S);
      end;
      PointShapeAttSelectCB.Items.EndUpdate;
      PointShapeAttSelectCB.ItemIndex:=0;
      PointShapeAttSelectUpDown.Position:=0;
      CurrentPSTLabel.Caption:=inttostr(PointShapeAttSelectCB.ItemIndex);
      //Array..List of Shape Attribute = ptd Filenames in pdl
      //1=7 2=4 3=6 4=1 5=1  6=4
      SetLength(PointArray,AttributeCount);
      For i:= 0 to AttributeCount-1 do
      begin
        Readln(outfile, S); PointArray[i].Shape:=strtoint(S);
        Readln(outfile, S); PointArray[i].FileName:=strtoint(S);
      end;
      Application.ProcessMessages;
      //Filename of  Other Defined List (.odl)
      Readln(outfile,S);
      PointFilenameEdit.Text:= S;
      //Number of ControlFileNames
      Readln(outfile,S);
      ControlFileNamesCount:=strtoint(S);
      pdlRichEdit.Clear;
      For I:=0 to ControlFileNamesCount-1 do
      begin
        Readln(outfile, S);
        pdlRichEdit.Lines.add(S);
      end;
      //This should set the caption too
      PointCurrentPdlUpDown.Position:=0;
      CurrentPdlLabel.Caption:=inttostr(PointCurrentPdlUpDown.Position);
      PointCurrentPdlEdit.Text:=
        pdlRichEdit.Lines[PointCurrentPdlUpDown.Position];
    Finally
      CloseFile(outfile);
    End;
  end;
end;
procedure TdtmDTPForm.PointPldSaveBtnClick(Sender: TObject);
var
  outfile:Textfile;
  i:Integer;
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Point List (*.pld)|*.pld';
  SaveDialog1.Filename:= PointEdit.Text;
  if SaveDialog1.Execute then
  begin
    PointEdit.Text:=SaveDialog1.Filename;
    Try
      AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
      Rewrite(outfile);
      Writeln(outfile, GoatVersion); //Open File and Set Data
      Writeln(outfile,inttostr(pldRG.ItemIndex));
      Writeln(outfile,inttostr(PldDisplayRG.ItemIndex));
      Writeln(outfile,inttostr(PldSupportRG.ItemIndex));
      Writeln(outfile,inttostr(PointShapeAttCB.ItemIndex));

      //Number of Shape Attribute Values
      Writeln(outfile,inttostr(PointShapeAttSelectCB.Items.Count));
      For I:=0 to PointShapeAttSelectCB.Items.Count-1 do
        Writeln(outfile, PointShapeAttSelectCB.Items[i]);
      //Array..List of Shape Attribute = Otd Filenames
      //1=17 2=4 3=11 4=1 5=1
      //If this .pld file Exists it MUST be able to Open and Load pdl ?
      For I:=0 to PointShapeAttSelectCB.Items.Count-1 do
      begin
        Writeln(outfile, inttostr(PointArray[i].Shape));
        Writeln(outfile, inttostr(PointArray[i].FileName));
      end;
      //Filename of  Other Defined List (.odl)
      Writeln(outfile, PointFilenameEdit.Text);
      Writeln(outfile, inttostr(pdlRichEdit.Lines.Count));
      For I:=0 to pdlRichEdit.Lines.Count-1 do
        Writeln(outfile, pdlRichEdit.Lines[i]);
      //pdlRichEdit.Lines.SavetoFile(PointFilenameEdit.Text);
      Finally
        CloseFile(outfile);
      End;
  end;
end;

//When the Layer selection is changed
//The Different attributes are loaded into PointShapeAttCB
//When Selected the Number of Different Values are counted
// If > 100 different values then STOP
procedure TdtmDTPForm.PointShapeAttBtnClick(Sender: TObject);
var
  TooMany,i:Integer;
  DataString:String;
begin
    //Count the number of Attributes the SAME..IF > 100 then STOP
    //PointShapeAttCB.ItemIndex
    TooMany:=0;
    GeneralSortListBox.Items.BeginUpdate;
    GeneralSortListBox.Clear;
    PointShapeAttSelectCB.Items.BeginUpdate;
    PointShapeAttSelectCB.Clear;

    For I:= 0 to LayA[CurrentLayer].ShapeN-1 do
      GeneralSortListBox.Items.Add(LayA[CurrentLayer].LyrShp[I+1].AAttributes[PointShapeAttCB.ItemIndex]);
    GeneralSortListBox.Sorted := True;
    DataString := GeneralSortListBox.Items.Strings[0];
    PointShapeAttSelectCB.Items.Add(GeneralSortListBox.Items.Strings[0]);
    for i := 1 to (GeneralSortListBox.Items.Count - 1) do
    begin
      {Fill list2 with items  That are NOT Duplicates..from a Sorted List}
      if (DataString <> GeneralSortListBox.Items.Strings[i]) then
      begin
      inc(TooMany);
        DataString := GeneralSortListBox.Items.Strings[i];
        PointShapeAttSelectCB.Items.Add(GeneralSortListBox.Items.Strings[i]);
      end; {IF}
    end; {for}
    GeneralSortListBox.Items.Clear; {Done so empty it}
    GeneralSortListBox.Items.EndUpdate;
    PointShapeAttSelectCB.Items.EndUpdate;

    If TooMany> 100 then Showmessage('last one is '+Inttostr(TooMany));
    PSTLabel.Caption:=Inttostr(TooMany);
    If TooMany> 100 then PSTLabel.Color:=ClRed
       else PSTLabel.Color:=clBtnFace;
    SetLength(PointArray,TooMany);
    For i:= 0 to TooMany-1 do
    begin
      PointArray[i].Shape:=i;
      PointArray[i].FileName:=0;
    end;
end;
procedure TdtmDTPForm.PointShapeAttSelectUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  PointShapeAttSelectCB.ItemIndex:=
    PointShapeAttSelectUpDown.Position;
  CurrentPSTLabel.Caption:=
    inttostr(PointShapeAttSelectUpDown.Position);
end;
procedure TdtmDTPForm.PointSetBtnClick(Sender: TObject);
begin
  PointArray[PointShapeAttSelectUpDown.Position].Shape:=
    PointShapeAttSelectUpDown.Position;
  PointArray[PointShapeAttSelectUpDown.Position].FileName:=
    PointCurrentPdlUpDown.Position;
    //pdlRichEdit.Lines[PointCurrentPdlUpDown.Position];
end;
procedure TdtmDTPForm.PointCurrentPdlUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  PointCurrentPdlEdit.Text:=
    pdlRichEdit.Lines[PointCurrentPdlUpDown.Position];
  CurrentPdlLabel.Caption:=
    inttostr(PointCurrentPdlUpDown.Position);
end;


procedure TdtmDTPForm.PointOpenPdlBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Point Defined List (*.pdl)|*.pdl';
  If (PointFilenameEdit.Text='') then
     OpenDialog.Filename:= '*.pdl' else
  OpenDialog.Filename:= PointFilenameEdit.Text;
  if OpenDialog.Execute then
  begin
    PointFilenameEdit.Text:=OpenDialog.Filename;
    pdlRichEdit.Lines.LoadFromFile(OpenDialog.Filename);
    PointCurrentPdlUpDown.Position:=0;
  end;
end;
procedure TdtmDTPForm.PointAddPtdBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Point Defined (*.ptd)|*.ptd';
  If (PtdFilenameEdit.Text='') then
     OpenDialog.Filename:= '*.ptd' else
  OpenDialog.Filename:= PtdFilenameEdit.Text;
  if OpenDialog.Execute then
  begin
    pdlRichEdit.Lines.Add(OpenDialog.Filename);
  end;
end;
procedure TdtmDTPForm.PaointSavePdlBtnClick(Sender: TObject);
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Point Defined List (*.pdl)|*.pdl';
  SaveDialog1.Filename:= PointFilenameEdit.Text;
  if SaveDialog1.Execute then
  begin
    PointFilenameEdit.Text:=SaveDialog1.Filename;
    pdlRichEdit.Lines.SaveToFile(SaveDialog1.Filename);
  end;
end;


procedure TdtmDTPForm.PointOpenPtdBtnClick(Sender: TObject);
var
  outfile:Textfile;
  S:String;
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Point Defined *.ptd)|*.ptd';
  If (PtdFilenameEdit.Text='') then
     OpenDialog.Filename:= '*.ptd' else
  OpenDialog.Filename:= PtdFilenameEdit.Text;
  if OpenDialog.Execute then
  begin
    PtdFilenameEdit.Text:=OpenDialog.Filename;
    Try     { File selected in dialog box }
      AssignFile(outfile, OpenDialog.FileName);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S);  Ptd3dsFileEdit.Text:=S;
      Readln(outfile,S);  PtdTextureFileEdit.Text:=S;
      Readln(outfile,S);  PtdWidthEdit.Text:=S;
      Readln(outfile,S);  PtdLengthEdit.Text:=S;
      Readln(outfile,S);  PtdHeightEdit.Text:=S;
      Readln(outfile,S);  PtdSupportWidthEdit.Text:=S;
      Readln(outfile,S);  PtdSupportDepthEdit.Text:=S;
      Readln(outfile,S);  PointDtcEdit.Text:=S;
      Readln(outfile,S);  PointScaleEdit.Text:=S;

      Readln(outfile,S);  PointUpDirEdit.Text:=S;
      Readln(outfile,S);  PointUpSizeEdit.Text:=S;
      Finally
        CloseFile(outfile);
      End;
  end;
end;

procedure TdtmDTPForm.PointSavePtdBtnClick(Sender: TObject);
var  outfile:Textfile;
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Point Defined *.ptd)|*.ptd';
  SaveDialog1.Filename:= PtdFilenameEdit.Text;
  if SaveDialog1.Execute then
  begin
    PtdFilenameEdit.Text:=SaveDialog1.Filename;
    Try
      AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
      Rewrite(outfile);
      Writeln(outfile, GoatVersion);
      Writeln(outfile, Ptd3dsFileEdit.Text);
      Writeln(outfile, PtdTextureFileEdit.Text);
      Writeln(outfile, PtdWidthEdit.Text);
      Writeln(outfile, PtdLengthEdit.Text);
      Writeln(outfile, PtdHeightEdit.Text);
      Writeln(outfile, PtdSupportWidthEdit.Text);
      Writeln(outfile, PtdSupportDepthEdit.Text);
      Writeln(outfile, PointDtcEdit.Text);
      Writeln(outfile, PointUpDirEdit.Text);
      Writeln(outfile, PointUpSizeEdit.Text);
      Finally
        CloseFile(outfile);
      End;
  end;
end;

procedure TdtmDTPForm.Point3dsBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir:=DXFPath;
//    OpenDialog.Filter:= 'Object (*.3ds)|*.3DS;*. OBJ;*.TIN;*.PLY;*.STL';
    //    //MDC MD3 GL2 MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GTS LWO GLSM
    OpenDialog.Filter:= 'Object (*.3ds)|*.MD2;*.3DS;*.OBJ;*.TIN;*.PLY;*.STL;*.OCT;*.NMF;*.GTS;*.LWO;*.MS3D;*.GLSM';
    OpenDialog.Filename:= '*.3ds';
    if OpenDialog.Execute then
    begin
      Ptd3dsFileEdit.Text:=OpenDialog.Filename;
      DXFPath:=ExtractFilePath(OpenDialog.Filename);
    end;
end;
procedure TdtmDTPForm.Point3dsTextureBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir:=DXFPath;
    OpenDialog.Filter:= 'Texture (*.png)|*.png;*.jpg;*.tga;*.bmp';
    OpenDialog.Filename:= '*.png';
    if OpenDialog.Execute then
    begin
      PtdTextureFileEdit.Text:=OpenDialog.Filename;
      DXFPath:=ExtractFilePath(OpenDialog.Filename);
    end;
end;

procedure TdtmDTPForm.PointControlBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (pth,evl,act)|*.pth;*.evl;*.act';
  OpenDialog.FileName:= '*.act';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    PointDtcEdit.Text:=OpenDialog.FileName;
  end;
end;
(*****************************************************)
(*****************************************************)


(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.LinearLldOpenBtnClick(Sender: TObject);
var
  outfile:Textfile;
  ControlFileNamesCount, AttributeCount, i:Integer;
  S:String;
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Linear List (*.lld)|*.lld';
  If (LinearEdit.Text='') then
     OpenDialog.Filename:= '*.lld' else
     OpenDialog.Filename:= LinearEdit.Text;
  if OpenDialog.Execute then
  begin
    LinearEdit.Text:= OpenDialog.Filename;
    Try     { File selected in dialog box }
      AssignFile(outfile, OpenDialog.FileName);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S);  LinearlldRG.ItemIndex:=strtoint(S);
      Readln(outfile,S);  LinearDisplayRG.ItemIndex:=strtoint(S);
      Readln(outfile,S);  LinearSupportRG.ItemIndex:=strtoint(S);
      //The Attribute to Display
      Readln(outfile,S);  LinearShapeAttCB.ItemIndex:=strtoint(S);

      //Number of Shape Attribute Values
      Readln(outfile,S);
      AttributeCount:=strtoint(S);
      LSTLabel.Caption:=inttostr(AttributeCount);
      LinearShapeAttSelectCB.Items.BeginUpdate;
      LinearShapeAttSelectCB.Clear;
      For I:=0 to AttributeCount-1 do
      begin
        Readln(outfile, S);
        LinearShapeAttSelectCB.Items.add(S);
      end;
      LinearShapeAttSelectCB.Items.EndUpdate;
      LinearShapeAttSelectCB.ItemIndex:=0;
      LinearShapeAttSelectUpDown.Position:=0;
      CurrentLldLabel.Caption:=inttostr(LinearShapeAttSelectCB.ItemIndex);
      //Array..List of Shape Attribute = ptd Filenames in pdl
      //1=17 2=4 3=11 4=1 5=1
      SetLength(LinearArray,AttributeCount);
      For i:= 0 to AttributeCount-1 do
      begin
        Readln(outfile, S); LinearArray[i].Shape:=strtoint(S);
        Readln(outfile, S); LinearArray[i].FileName:=strtoint(S);
      end;
      Application.ProcessMessages;
      //Filename of  Other Defined List (.odl)
      Readln(outfile,S);
      LinearLdlFilenameEdit.Text:= S;
      //Number of ControlFileNames
      Readln(outfile,S);
      ControlFileNamesCount:=strtoint(S);
      ldlRichEdit.Clear;
      For I:=0 to ControlFileNamesCount-1 do
      begin
        Readln(outfile, S);
        ldlRichEdit.Lines.add(S);
      end;
      //This should set the caption too
      LinearLdlUpDown.Position:=0;
      CurrentLtdLabel.Caption:=inttostr(LinearLdlUpDown.Position);
      CurrentLdlEdit.Text:=
        ldlRichEdit.Lines[LinearLdlUpDown.Position];
    Finally
      CloseFile(outfile);
    End;
  end;
end;
procedure TdtmDTPForm.LinearLldSaveBtnClick(Sender: TObject);
var
  outfile:Textfile;
  i:Integer;
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Linear List (*.lld)|*.lld';
  SaveDialog1.Filename:= LinearEdit.Text;
  if SaveDialog1.Execute then
  begin  { File selected in dialog box }
    LinearEdit.Text:= SaveDialog1.Filename;
    Try
      AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
      Rewrite(outfile);
      Writeln(outfile, GoatVersion); //Open File and Set Data
      Writeln(outfile,inttostr(LinearlldRG.ItemIndex));
      Writeln(outfile,inttostr(LinearDisplayRG.ItemIndex));
      Writeln(outfile,inttostr(LinearSupportRG.ItemIndex));

      Writeln(outfile,inttostr(LinearShapeAttCB.ItemIndex));
      //Number of Shape Attribute Values
      Writeln(outfile,inttostr(LinearShapeAttSelectCB.Items.Count));
      For I:=0 to LinearShapeAttSelectCB.Items.Count-1 do
      Writeln(outfile, LinearShapeAttSelectCB.Items[i]);
      //Array..List of Shape Attribute = Otd Filenames
      //1=17 2=4 3=11 4=1 5=1
      //If this .pld file Exists it MUST be able to Open and Load pdl ?
      For I:= 0 to LinearShapeAttSelectCB.Items.Count-1 do
      begin
        Writeln(outfile, Inttostr(LinearArray[i].Shape));
        Writeln(outfile, Inttostr(LinearArray[i].FileName));
      end;
      //Filename of  Other Defined List (.odl)
      Writeln(outfile, LinearLdlFilenameEdit.Text);
      //ldlRichEdit.Lines.SavetoFile(LinearLdlFilenameEdit.Text);
      Writeln(outfile, Inttostr(ldlRichEdit.Lines.Count));
      For I:=0 to ldlRichEdit.Lines.Count-1 do
      Writeln(outfile, ldlRichEdit.Lines[i]);   
      Finally
        CloseFile(outfile);
      End;
  end;
end;

procedure TdtmDTPForm.LinearShapeAttBtnClick(Sender: TObject);
var
  TooMany,i:Integer;
  DataString:String;
begin
    //Count the number of Attributes the SAME..IF > 100 then STOP
    //PointShapeAttCB.ItemIndex
    TooMany:=0;
    GeneralSortListBox.Items.BeginUpdate;
    GeneralSortListBox.Clear;
    LinearShapeAttSelectCB.Items.BeginUpdate;
    LinearShapeAttSelectCB.Clear;

    For I:= 0 to LayA[CurrentLayer].ShapeN-1 do
      GeneralSortListBox.Items.Add(LayA[CurrentLayer].LyrShp[I+1].AAttributes[LinearShapeAttCB.ItemIndex]);
    GeneralSortListBox.Sorted := True;
    DataString := GeneralSortListBox.Items.Strings[0];
    LinearShapeAttSelectCB.Items.Add(GeneralSortListBox.Items.Strings[0]);
    for i := 1 to (GeneralSortListBox.Items.Count - 1) do
    begin
      {Fill list2 with items  That are NOT Duplicates..from a Sorted List}
      if (DataString <> GeneralSortListBox.Items.Strings[i]) then
      begin
      inc(TooMany);
        DataString := GeneralSortListBox.Items.Strings[i];
        LinearShapeAttSelectCB.Items.Add(GeneralSortListBox.Items.Strings[i]);
      end; {IF}
    end; {for}
    GeneralSortListBox.Items.Clear; {Done so empty it}
    GeneralSortListBox.Items.EndUpdate;
    LinearShapeAttSelectCB.Items.EndUpdate;

    If TooMany> 100 then Showmessage('last one is '+Inttostr(TooMany));
    LSTLabel.Caption:=Inttostr(TooMany);
    If TooMany> 100 then LSTLabel.Color:=ClRed
       else LSTLabel.Color:=clBtnFace;
    SetLength(LinearArray,TooMany);
    For i:= 0 to TooMany-1 do
    begin
      LinearArray[i].Shape:=i; LinearArray[i].FileName:=0;
    end;
end;

procedure TdtmDTPForm.LinearShapeAttSelectUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  LinearShapeAttSelectCB.ItemIndex:=LinearShapeAttSelectUpDown.Position;
  CurrentLldLabel.Caption:= inttostr(LinearShapeAttSelectUpDown.Position);
end;
procedure TdtmDTPForm.LinearSetBtnClick(Sender: TObject);
begin
  LinearArray[LinearShapeAttSelectUpDown.Position].Shape:=LinearShapeAttSelectUpDown.Position;
  LinearArray[LinearShapeAttSelectUpDown.Position].FileName:=LinearLdlUpDown.Position;
end;
procedure TdtmDTPForm.LinearLdlUpDownClick(Sender: TObject;
  Button: TUDBtnType);
begin
  CurrentLdlEdit.Text:=LdlRichEdit.Lines[LinearLdlUpDown.Position];
  CurrentLtdLabel.Caption:= inttostr(LinearLdlUpDown.Position);
end;

procedure TdtmDTPForm.LinearLdlOpenBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Linear Defined List  (*.ldl)|*.ldl';
  If (LinearLdlFilenameEdit.Text='') then
     OpenDialog.Filename:= '*.ldl' else
  OpenDialog.Filename:= LinearLdlFilenameEdit.Text;
  if OpenDialog.Execute then
  begin
    LinearLdlFilenameEdit.Text:= OpenDialog.Filename;
    LdlRichEdit.Lines.LoadFromFile(OpenDialog.Filename);
    LinearLdlUpDown.Position:=0;
  end;
end;
procedure TdtmDTPForm.LinearLdlSaveBtnClick(Sender: TObject);
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Linear Defined List (*.ldl)|*.ldl';
  SaveDialog1.Filename:= LinearLdlFilenameEdit.Text;
  if SaveDialog1.Execute then
  begin
    LinearLdlFilenameEdit.Text:=SaveDialog1.Filename;
    LdlRichEdit.Lines.SaveToFile(SaveDialog1.Filename);
  end;
end;
procedure TdtmDTPForm.LinearAddltdBtnClick(Sender: TObject);
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Linear Defined (*.ltd)|*.ltd';
  If (LinearLtdFilenameEdit.Text='') then
     OpenDialog.Filename:= '*.ltd' else
  OpenDialog.Filename:= LinearLtdFilenameEdit.Text;
  if OpenDialog.Execute then
  begin
    LdlRichEdit.Lines.Add(OpenDialog.Filename);
  end;
end;
(*****************************************************)
procedure TdtmDTPForm.LinearLtdOpenBtnClick(Sender: TObject);
var
  outfile:Textfile;
  S:String;
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Linear Defined *.ltd)|*.ltd';
  If (LinearLtdFilenameEdit.Text='') then
     OpenDialog.Filename:= '*.ltd' else
  OpenDialog.Filename:= LinearLtdFilenameEdit.Text;
  if OpenDialog.Execute then
  begin
    LinearLtdFilenameEdit.Text:=OpenDialog.Filename;
    Try     { File selected in dialog box }
      AssignFile(outfile, OpenDialog.FileName);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S);  Linear3dsFileEdit.Text:=S;
      Readln(outfile,S);  LinearTextureFileEdit.Text:=S;
      Readln(outfile,S);  LtdWidthEdit.Text:=S;
      Readln(outfile,S);  LtdLengthEdit.Text:=S;
      Readln(outfile,S);  LtdHeightEdit.Text:=S;
      Readln(outfile,S);  LtdSupportWidthEdit.Text:=S;
      Readln(outfile,S);  LtdSupportDepthEdit.Text:=S;
      Readln(outfile,S);  LinearDtcEdit.Text:=S;
      Readln(outfile,S);  LinearUpDirEdit.Text:=S;
      Readln(outfile,S);  LinearUpSizeEdit.Text:=S;
      Finally
        CloseFile(outfile);
      End;
  end;
end;

procedure TdtmDTPForm.LinearLtdSaveBtnClick(Sender: TObject);
var  outfile:Textfile;
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'Linear Defined *.ltd)|*.ltd';
  SaveDialog1.Filename:= LinearLtdFilenameEdit.Text;
  if SaveDialog1.Execute then
  begin
    LinearLtdFilenameEdit.Text:=SaveDialog1.Filename;
    Try
      AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
      Rewrite(outfile);
      Writeln(outfile, GoatVersion);
      Writeln(outfile, Linear3dsFileEdit.Text);
      Writeln(outfile, LinearTextureFileEdit.Text);
      Writeln(outfile, LtdWidthEdit.Text);
      Writeln(outfile, LtdLengthEdit.Text);
      Writeln(outfile, LtdHeightEdit.Text);
      Writeln(outfile, LtdSupportWidthEdit.Text);
      Writeln(outfile, LtdSupportDepthEdit.Text);
      Writeln(outfile, LinearDtcEdit.Text);
      Writeln(outfile, LinearUpDirEdit.Text);
      Writeln(outfile, LinearUpSizeEdit.Text);
      Finally
        CloseFile(outfile);
      End;
  end;
end;

procedure TdtmDTPForm.Linear3dsBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir:=DXFPath;
//    OpenDialog.Filter:= 'Object (*.3ds)|*.3DS;*. OBJ;*.TIN;*.PLY;*.STL';
    //    //MDC MD3 GL2 MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GTS LWO GLSM
    OpenDialog.Filter:= 'Object (*.3ds)|*.MD2;*.3DS;*.OBJ;*.TIN;*.PLY;*.STL;*.OCT;*.NMF;*.GTS;*.LWO;*.MS3D;*.GLSM';
    OpenDialog.Filename:= '*.3ds';
    if OpenDialog.Execute then
    begin
      Linear3dsFileEdit.Text:=OpenDialog.Filename;
      DXFPath:=ExtractFilePath(OpenDialog.Filename);
    end;
end;

procedure TdtmDTPForm.Linear3dsTextureBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir:=DXFPath;
    OpenDialog.Filter:= 'Texture (*.png)|*.png;*.jpg;*.tga;*.bmp';
    OpenDialog.Filename:= '*.png';
    if OpenDialog.Execute then
    begin
      LinearTextureFileEdit.Text:=OpenDialog.Filename;
      DXFPath:=ExtractFilePath(OpenDialog.Filename);
    end;
end;

procedure TdtmDTPForm.LinearControlBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (pth,evl,act)|*.pth;*.evl;*.act';
  OpenDialog.FileName:= '*.pth';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    LinearDtcEdit.Text:=OpenDialog.FileName;
  end;
end;
(*****************************************************)

(*****************************************************)
(*****************************************************)


(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.DtcOpenSetBtnClick(Sender: TObject);
var
 S : string;
 I,ActorCount,CommandCount:Integer;
 F: TextFile;
begin
{Phase2EditText}
  OpenDialog.Filter:= 'DTC File (*.dtc)|*.dtc';
  OpenDialog.FileName:= '*.dtc';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcFileEdit.Text:=OpenDialog.FileName;
    Application.ProcessMessages;
    AssignFile(F, OpenDialog.FileName);
    Reset(F);
    Readln(F, S);
    DtcFileTypeRG.ItemIndex:=strtoint(S);
    Case DtcFileTypeRG.ItemIndex of
    0: //Layers
    Begin
      Readln(F, S); ActorCount:=strtoint(S);
      For I:=0 to ActorCount-1 do begin
      Readln(F, S); DtcLLayerRichEdit.Lines.add(S);end;
      Readln(F, S); ActorCount:=strtoint(S);
      For I:=0 to ActorCount-1 do begin
      Readln(F, S); DtcLERobotRichEdit.Lines.add(S);end;
      Readln(F, S); CommandCount:=strtoint(S);
      If (ActorCount <> CommandCount) then
      showmessage('Actors <> Commands'+#13#10+
      inttostr(ActorCount)+ ' <> '+ inttostr(CommandCount));
      For I:=0 to CommandCount-1 do begin
      Readln(F, S); DtcLActionRichEdit.Lines.add(S);end;
    end;
    1:  //Objects
    begin
      Readln(F, S); ActorCount:=strtoint(S);
      For I:=0 to ActorCount-1 do
      begin
        Readln(F, S); DtcIRichEdit.Lines.add(S);
      end;
    end;
    2:  //Actors
    Begin
      Readln(F, S); ActorCount:=strtoint(S);
      For I:=0 to ActorCount-1 do begin
      Readln(F, S); DtcA1RichEdit.Lines.add(S);end;
      Readln(F, S); CommandCount:=strtoint(S);
      If (ActorCount <> CommandCount) then
      showmessage('Actors <> Commands'+#13#10+
      inttostr(ActorCount)+ ' <> '+ inttostr(CommandCount));
      For I:=0 to CommandCount-1 do begin
      Readln(F, S); DtcA2RichEdit.Lines.add(S);end;
    end;
    3: //Flyby
    Begin
      Readln(F, S); DtcFCamEdit.Text:=S;
      Readln(F, S); DtcFTarEdit.Text:=S;
    end;
    End;//Case
    CloseFile(F);
  end;
end;
procedure TdtmDTPForm.DtcSaveBtnClick(Sender: TObject);
var
 S : string; I,ActorCount,CommandCount:Integer;
 F: TextFile;
begin
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.Filter:= 'DTC File (*.dtc)|*.dtc';
  If DtcFileEdit.Text<>'' then
  SaveDialog1.Filename:= DtcFileEdit.Text else
  SaveDialog1.Filename:='*.dtc';
  if SaveDialog1.Execute then
  begin
    ProjectPath:=ExtractFilePath(SaveDialog1.FileName);
    DtcFileEdit.Text:=SaveDialog1.Filename;
    Application.ProcessMessages;
    AssignFile(F, OpenDialog.FileName);
    Rewrite(F);
    S:=inttostr(DtcFileTypeRG.ItemIndex);
    Writeln(F, S);
    Case DtcFileTypeRG.ItemIndex of
    0: //Layers
    begin
      ActorCount:=DtcLLayerRichEdit.Lines.Count;
      S:=inttostr(ActorCount); Writeln(F, S);
      For I:=0 to ActorCount-1 do begin
      S:= DtcLLayerRichEdit.Lines[i];Writeln(F, S);end;
      ActorCount:=DtcLERobotRichEdit.Lines.Count;
      S:=inttostr(ActorCount); Writeln(F, S);
      For I:=0 to ActorCount-1 do begin
      S:= DtcLERobotRichEdit.Lines[i];Writeln(F, S);end;
      CommandCount:=DtcA2RichEdit.Lines.Count;
      S:=inttostr(CommandCount); Writeln(F, S);
      For I:=0 to CommandCount-1 do begin
      S:= DtcLActionRichEdit.Lines[i];
      Writeln(F, S);
      If (ExtractFileExt(S) <> ExtractFileExt(DtcLActionRichEdit.Lines[0])) then
      ShowMessage('Paths or Evolve .. NO Mixing allowed');
      end;
      If (ActorCount <> CommandCount) then
      showmessage('Actors <> Commands'+#13#10+
      inttostr(ActorCount)+ ' <> '+ inttostr(CommandCount));
    end;

    1://Objects
    begin
      ActorCount:=DtcA1RichEdit.Lines.Count;
      S:=inttostr(ActorCount); Writeln(F, S);
      For I:=0 to ActorCount-1 do begin
      S:= DtcIRichEdit.Lines[i];Writeln(F, S);end;
    end;

    2: //Actors
    Begin
      ActorCount:=DtcA1RichEdit.Lines.Count;
      S:=inttostr(ActorCount); Writeln(F, S);
      For I:=0 to ActorCount-1 do begin
      S:= DtcA1RichEdit.Lines[i];Writeln(F, S);end;
      CommandCount:=DtcA2RichEdit.Lines.Count;
      S:=inttostr(CommandCount); Writeln(F, S);
      For I:=0 to CommandCount-1 do begin
      S:= DtcA2RichEdit.Lines[i];
      Writeln(F, S);
      If (ExtractFileExt(S) <> ExtractFileExt(DtcA2RichEdit.Lines[0])) then
      ShowMessage('Paths or Evolve .. NO Mixing allowed');
      end;
      If (ActorCount <> CommandCount) then
      showmessage('Actors <> Commands'+#13#10+
      inttostr(ActorCount)+ ' <> '+ inttostr(CommandCount));
    end;
    3://Flyby
    Begin
      S:=DtcFCamEdit.Text;Writeln(F, S);
      S:=DtcFTarEdit.Text;Writeln(F, S);
    end;
    End;//Case
    CloseFile(F);
    end;
end;


procedure TdtmDTPForm.DtcFCamBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (pth)|*.pth';
  OpenDialog.FileName:= '*.pth';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcFCamEdit.Text:=OpenDialog.FileName;
  end;
end;

procedure TdtmDTPForm.DtcFTarBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (pth)|*.pth';
  OpenDialog.FileName:= '*.pth';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcFTarEdit.Text:=OpenDialog.FileName;
  end;
end;


procedure TdtmDTPForm.DtcAActorBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Robot (*.rld)|*.rld';
  OpenDialog.FileName:= '*.rld';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcA1RichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;

procedure TdtmDTPForm.DtcAPathBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (pth)|*.pth';
  OpenDialog.FileName:= '*.pth';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcA2RichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;
procedure TdtmDTPForm.DtcAActionBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (act)|*.act';
  OpenDialog.FileName:= '*.act';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcA2RichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;
procedure TdtmDTPForm.DtcAEvolveBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (evl)|*.evl';
  OpenDialog.FileName:= '*.evl';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcA2RichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;



procedure TdtmDTPForm.DtcIFilesBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Robot (*.rld)|*.rld';
  OpenDialog.FileName:= '*.rld';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcIRichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;


procedure TdtmDTPForm.DtcLLayerBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Robot (*.rld)|*.rld';
  OpenDialog.FileName:= '*.rld';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcLLayerRichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;

procedure TdtmDTPForm.DtcLERobotBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Robot (*.rld)|*.rld';
  OpenDialog.FileName:= '*.rld';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcLERobotRichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;

procedure TdtmDTPForm.DtcLActionBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (act)|*.act';
  OpenDialog.FileName:= '*.act';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcLActionRichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;
procedure TdtmDTPForm.DtcLEvolveBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (evl)|*.evl';
  OpenDialog.FileName:= '*.evl';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcLActionRichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;
procedure TdtmDTPForm.DtcLPathBtnClick(Sender: TObject);
begin
  OpenDialog.Filter:= 'Control (pth)|*.pth';
  OpenDialog.FileName:= '*.pth';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    DtcLActionRichEdit.Lines.Add(OpenDialog.FileName);
  end;
end;

(*****************************************************)
(*****************************************************)


(*****************************************************)
(*****************************************************)
procedure TdtmDTPForm.rldOpenBtnClick(Sender: TObject);
var
 ActorFileName,TextureFileName,
 S : string;
 F: TextFile;
begin
  OpenDialog.InitialDir:=ProjectPath;
  OpenDialog.Filter:= 'Robot (*.rld)|*.rld';
  If (rldNameEdit.Text=NoName) then
     OpenDialog.Filename:= '*.rld' else
  If (rldNameEdit.Text = '') then
  OpenDialog.Filename:= '*.rld' else
  OpenDialog.Filename:= rldNameEdit.Text;
  if OpenDialog.Execute then
  if UpperCase(ExtractFileExt(OpenDialog.Filename)) = '.RLD' then
  begin
    If (not FileExists(OpenDialog.Filename)) then Exit;
    ProjectPath:=ExtractFilePath(OpenDialog.Filename);
    AssignFile(F, OpenDialog.FileName);
    Reset(F);
    Readln(F, S);
    If (S=GoatVersion) then
    begin
      rldNameEdit.Text:= OpenDialog.FileName;
      Readln(F, ActorFileName);
      rldRobotFileNameEdit.Text:=ActorFileName;
      Readln(F, TextureFileName);
      rldTextureEdit.Text:=TextureFileName;
      Readln(F, S);
      rldRobotRG.ItemIndex:=strtoint(S);
      Readln(F, S);
      rldSizeEdit.Text:=S;
      Readln(F, S);
      rldPositionXEdit.Text:=S;
      Readln(F, S);
      rldPositionYEdit.Text:=S;
      Readln(F, S);
      rldUpEdit.Text:=S;
      Readln(F, S);
      rldPositionZEdit.Text:=S;
    end else {Error Message Wrong File type Version};
    CloseFile(F);
  end;
end;

procedure TdtmDTPForm.rldSaveBtnClick(Sender: TObject);
var F: TextFile;
begin  { for Actor and Texture}
  If ((FileExists(rldRobotFileNameEdit.Text))) then
  begin  //MUST have an Actor file selected
    SaveDialog1.InitialDir:=ProjectPath;
    SaveDialog1.Filter:= 'Robot (*.rld)|*.rld';
    SaveDialog1.Filename:= rldNameEdit.Text;
    if SaveDialog1.Execute then
    if UpperCase(ExtractFileExt(SaveDialog1.Filename)) = '.RLD' then
    begin
      ProjectPath:=ExtractFilePath(SaveDialog1.Filename);
      rldNameEdit.Text:= SaveDialog1.FileName;
      AssignFile(F, SaveDialog1.FileName);
      Rewrite(F);
      writeln(F, GoatVersion);
      writeln(F, rldRobotFileNameEdit.Text);
      If (not FileExists(rldTextureEdit.Text)) then
      rldTextureEdit.Text:= NoName;
      writeln(F, rldTextureEdit.Text);
      writeln(F,inttostr(rldRobotRG.ItemIndex));
      //If no size entered then Make It So
      If length(rldSizeEdit.Text)<1 then
      rldSizeEdit.Text:= '1';
       {Check Validity of Input Size: is it a number?}
      writeln(F, rldSizeEdit.Text);
      writeln(F, rldPositionXEdit.Text);
      writeln(F, rldPositionYEdit.Text);
      writeln(F, rldUpEdit.Text);
      writeln(F, rldPositionZEdit.Text);
      CloseFile(F);
    end;
  end;
end;

procedure TdtmDTPForm.rldRobotBtnClick(Sender: TObject);
begin
    OpenDialog.InitialDir:=TigerPath;
    //MDC MD3 GL2 MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GTS LWO GLSM
    OpenDialog.Filter:= 'Robot  (*.qc,*.smd,*.md2,*.md3,*.mdc,*.gl2,*.GLSM,*.MS3D,*.3ds)|*.qc;*.smd;*.md2;*.md3;*.mdc;*.gl2;*.GLSM;*.ms3d;*.3ds';
    OpenDialog.Filename:= '*.qc';
    OpenPictureDialog1.InitialDir:=TigerPath;
    if OpenDialog.Execute then
    begin
      rldRobotFileNameEdit.Text:=OpenDialog.Filename;
      TigerPath:=ExtractFilePath(OpenDialog.Filename);
    end;
end;

procedure TdtmDTPForm.rldTextureBtnClick(Sender: TObject);
begin
  OpenPictureDialog1.Filter:= 'Texture (*.png)|*.png;*.jpg;*.tga;*.bmp';
  if OpenPictureDialog1.Execute then
  rldTextureEdit.Text:=OpenPictureDialog1.Filename;
end;
(*****************************************************)
(*****************************************************)

(*****************************************************)
(*****************************************************)

(*
procedure TdtmHdsForm.LoadPointobject(Filename:String;ILoad:Integer);
var
  NewProxy : TGLProxyObject;
 // ControlType,SupportStructureType,
 DisplayType, PointShapeAttType,
  ShapeType, ShapeToDo, DXI,DYI, NumShape: integer;
  DXdtemp,DYdtemp:Double;
  ControlFileNamesCount, AttributeCount,i:Integer;
  S:String;
  outfile:Textfile;
  ControlStringList,
  PointShapeAttStringList:TStringList;
 ActorFileName,ActorTextureFileName,
 P2FileName: string;
 ActorUp : string;
  Dirs:String; Dir:Integer;
//  oldCTRG:Integer;
//  ActorLength, ActorWidth,  ActorHeight,
 ActorUpSize, ActorScale:Double;
 terrainHeight:Single;
 AttrCount:Integer;
 ControlFileName,AttrString: string;
begin
  ControlStringList:= TStringList.Create;
  PointShapeAttStringList := TStringList.Create;
  Try
    //ActorScale:=1; ActorUpSize:=1;
    ActorUp:='Y';
    //  ActorLength:=1;ActorWidth:=1;ActorHeight:=1;oldCTRG:=1;
    Try     { File selected in dialog box }
      AssignFile(outfile, Filename);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S); // ControlType:=strtoint(S);
      Readln(outfile,S);  DisplayType:=strtoint(S);
      Readln(outfile,S); // SupportStructureType:=strtoint(S);
      //The Attribute to Display
      Readln(outfile,S);  PointShapeAttType:=strtoint(S);

      //Number of Shape Attribute Values
      Readln(outfile,S);
      AttributeCount:=strtoint(S);
      //PointShapeAttSelectCB.Clear;
      For I:=0 to AttributeCount-1 do
      begin
        Readln(outfile, S);
        PointShapeAttStringList.add(S);
      end;
      //Array..List of Shape Attribute = ptd Filenames in pdl
      //1=17 2=4 3=11 4=1 5=1
      SetLength(PointArray,AttributeCount);
      For i:= 0 to AttributeCount-1 do
      begin
        Readln(outfile, S); PointArray[i].Shape:=strtoint(S);
        Readln(outfile, S); PointArray[i].FileName:=strtoint(S);
      end;
      Application.ProcessMessages;
      //Filename of  Other Defined List (.odl)
      Readln(outfile,S);
      //PointFilenameEdit.Text:= S;
      //Number of ControlFileNames
      Readln(outfile,S);
      ControlFileNamesCount:=strtoint(S);
      For I:=0 to ControlFileNamesCount-1 do
      begin
        Readln(outfile, S);
        ControlStringList.add(S);
      end;
    Finally
      CloseFile(outfile);
    End;

    //  LayA[ILoad].OtsNameEditText
    ShapeType:= LayA[ILoad].ShpType;
    NumShape:= LayA[ILoad].ShapeN;
    If ((ShapeType=1) or(ShapeType=11) or(ShapeType=21)) then
    begin   //ONLY POINT OBJECTS HERE
      For ShapeToDo:=1 to NumShape do
      Begin
        dXTemp:=LayA[ILoad].LyrShp[ShapeToDo].XMax;
        dYTemp:=LayA[ILoad].LyrShp[ShapeToDo].YMax;
        DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
        DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
        DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
        DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
        AttrString:=LayA[ILoad].LyrShp[ShapeToDo].AAttributes[PointShapeAttType];
        AttrCount:=-1;
        For I:=0 to AttributeCount-1 do
        begin
          If AttrString =
          PointShapeAttStringList.Strings[i] then
          AttrCount:=i;
        end;
        For i:= 0 to AttributeCount-1 do
        begin
          if PointArray[i].Shape=AttrCount then
          ControlFileName:=ControlStringList.Strings[ PointArray[i].FileName];
        end;
           // Filename,TextureFileName
        //Get the Attribute and Connect the Link
        // ControlStringList[1]
        { Find will only work on sorted lists! }
        {    MyList.Sort;  ControlStringList  PointShapeAttStringList
            if MyList.Find('Flowers', Index) then
            begin}

        Try     { File selected in dialog box }
          AssignFile(outfile,ControlFileName);
          Reset(outfile);   //Open File and Set Data
          Readln(outfile,S); If S= GoatVersion then;
          Readln(outfile,ActorFileName);
          Readln(outfile,ActorTextureFileName);
          Readln(outfile,S); // ActorWidth:=strtoint(S);
          Readln(outfile,S); // ActorLength:=strtoint(S);
          Readln(outfile,S); // ActorHeight:=strtoint(S);

          Readln(outfile,S); // LtdSupportWidthEdit.Text:=S;
          Readln(outfile,S); // LtdSupportDepthEdit.Text:=S;
          Readln(outfile,P2FileName);
          Readln(outfile,S); ActorScale:=strtofloat(S);
          Readln(outfile,ActorUp);
          Readln(outfile,S); ActorUpSize:=strtofloat(S);

        Finally
          CloseFile(outfile);
        End;
        //Only Proxies Supported so far...
        If DisplayType = 0 then
        begin
          NewProxy := TGLProxyObject(MMProxyDC.AddNewChild(TGLProxyObject));
          NewProxy.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
          //BillBoards only
          //NewProxy.Width :=ActorWidth;
          //NewProxy.Height :=ActorHeight;
          NewProxy.Position.X:=DXI;
          NewProxy.Position.Z:=DYI;
          with NewProxy.Position do
          begin       //ShapeDC.DeleteChildren;
            terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
            Y:=terrainHeight+ActorUpSize{- (min[2]*ActorScale)}; //0.04
            NewProxy.Position.Y:=Y;
          end;
          If Length(ActorUp)=2 then
          begin
            Dirs:= ActorUp[1];
            If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
            ActorUp := ActorUp[2];
          end else Dir:=1;
          If lowercase(ActorUp)='y' then
          begin
            NewProxy.Up.y:=Dir;
            NewProxy.Up.z:= 0;
            NewProxy.Up.x:=0;
          end else
          If lowercase(ActorUp)='z' then
          begin
            NewProxy.Up.y:=Dir;
            NewProxy.Up.z:=0;
            NewProxy.Up.x:=0;
          end else
          If lowercase(ActorUp)='x' then
          begin
            NewProxy.Up.x:=Dir;
            NewProxy.Up.y:=0;
            NewProxy.Up.z:=0;
          end;

          // Need a master object for this new proxy ?
          // Just use the manager :
          NewProxy.MasterObject := Manager.LoadModel(ActorFilename,ActorTextureFileName);
        end;
      end;
    end;
  finally
    ControlStringList.Free;
    PointShapeAttStringList.Free;
  end;
end;
*)























end.


