unit dtmDvFrm;
//Somebody ELSE wrote this....  Delaunay
//Credits go to : _______

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  dtmDvUnit, ExtCtrls, StdCtrls, Buttons;

type
  TDVForm = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    LoadBtn: TSpeedButton;
    SaveBtn: TSpeedButton;
    ClearBtn: TSpeedButton;
    OpenDialog: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Edit1: TEdit;
    start: TButton;

    procedure FormCreate(Sender: TObject);
    procedure startClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DrawEdge(Edge:TDEdge);
    procedure DrawTriangle(Triangle:TDTriangle);
    procedure DrawPoints;
    procedure DrawDelaunay;
    procedure DrawConvexHull;
    procedure DrawVoronoi;
    procedure DrawAll;
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ClearBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure LoadBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Delaunay:TDelaunay;
  end;

var
  DVForm: TDVForm;

implementation

{$R *.DFM}

uses dtmErrMsg, dtmGlobals, dtmPOFvar;

procedure TDVForm.FormCreate(Sender: TObject);
//var i:integer;    //Create some Points ?
begin
  randomize;
  delaunay:=tdelaunay.Create(DVForm);
end;
procedure TDVForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Delaunay.Clear(True);
  Delaunay.Destroy;
end;
procedure TDVForm.DrawEdge(Edge:TDEdge);
begin
  canvas.MoveTo(edge.leftp.X,edge.leftp.Y);
  canvas.LineTo(edge.rightp.X,edge.rightp.Y);
end;

procedure TDVForm.DrawTriangle(Triangle:TDTriangle);
begin
  DrawEdge(Triangle.E);
  DrawEdge(Triangle.E.NextE);
  DrawEdge(Triangle.E.NextE.NextE);
end;

procedure TDVForm.DrawPoints;
var i:integer;
begin
  for i:=0 to Delaunay.Count-1 do
  Canvas.Ellipse(Delaunay.Point[i].X-2,Delaunay.Point[i].Y-2,
               Delaunay.Point[i].X+2,Delaunay.Point[i].Y+2);
end;

procedure TDVForm.DrawDelaunay;
var Triangle:TDTriangle;
begin
  Triangle:=Delaunay.FirstT;
  repeat
  DrawTriangle(Triangle);
  Triangle:=Triangle.NextT;
  until Triangle=nil;
end;

Procedure TDVForm.DrawConvexHull;
var Edge:TDEdge;
begin
Edge:=Delaunay.HullStart;
repeat
 DrawEdge(edge);
 Edge:=Edge.NextH;
until Edge=Delaunay.HullStart;
end;

Procedure TDVForm.DrawVoronoi;
var Edge:TDEdge;
    Triangle:TDTriangle;

     procedure Voronoi_Step(Edge:TDEdge);
     var x1,y1,x2,y2:double;
     begin
     Edge.GetVoronoi(x1,y1,x2,y2);
     canvas.MoveTo(trunc(x1),trunc(y1));
     canvas.LineTo(trunc(x2),trunc(y2));
     Edge.NextE.GetVoronoi(x1,y1,x2,y2);
     canvas.MoveTo(trunc(x1),trunc(y1));
     canvas.LineTo(trunc(x2),trunc(y2));
     Edge.NextE.NextE.GetVoronoi(x1,y1,x2,y2);
     canvas.MoveTo(trunc(x1),trunc(y1));
     canvas.LineTo(trunc(x2),trunc(y2));
     end;

begin
Triangle:=Delaunay.FirstT;
repeat
Edge:=Triangle.e;
Voronoi_Step(Edge);
Triangle:=Triangle.NextT;
until triangle=nil;
end;

procedure TDVForm.DrawAll;
begin
PatBlt(Canvas.Handle,0,0,DVForm.ClientWidth,DVForm.ClientHeight,BLACKNESS);
if checkbox1.Checked then
begin  //Delaunay
  Canvas.Pen.Color:=rgb(255,0,0);
  DrawDelaunay;
end;
if checkbox2.Checked then
begin
  Canvas.Pen.Color:=rgb(0,255,0);
  DrawConvexHull;
end;
if checkbox3.Checked then
begin
  Canvas.Pen.Color:=rgb(0,0,255);
  DrawVoronoi;
end;
if checkbox4.Checked then
begin
  Canvas.Pen.Color:=rgb(255,255,255);
  DrawPoints;
end;
end;


procedure TDVForm.startClick(Sender: TObject);
var     i, count_of_points:integer;
        //edge:tdedge;
        //triangle:tdtriangle;
begin
  count_of_points:=strtoint(edit1.Text);
  //---------INSERT POINTS (=DELAUNAY CALCULATION)
  for i:=0 to count_of_points do
    Delaunay.Insert(random(DVForm.Width-200)+50, random(DVForm.Height-100)+30);
  DrawAll;
end;

procedure TDVForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
//var Rect:TRect;
begin
  Delaunay.Insert(x,y);
  if Delaunay.Count>=3 then
  DrawAll;
end;

procedure TDVForm.CheckBox1Click(Sender: TObject);
begin
  DrawAll;
end;

procedure TDVForm.CheckBox2Click(Sender: TObject);
begin
  DrawAll;
end;

procedure TDVForm.CheckBox3Click(Sender: TObject);
begin
  DrawAll;
end;

procedure TDVForm.CheckBox4Click(Sender: TObject);
begin
  DrawAll;
end;



procedure TDVForm.ClearBtnClick(Sender: TObject);
begin
  Delaunay.Clear(True);
  PatBlt(Canvas.Handle,0,0,DVForm.ClientWidth,DVForm.ClientHeight,BLACKNESS);
end;

procedure TDVForm.SaveBtnClick(Sender: TObject);
var
  i:Integer;
  outfile:Textfile;
begin
  //SaveDialog1.Filter := 'HTFViewer Palette (*.pal)|*.pal';
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.FileName:='*.dvf';
  if (SaveDialog1.Execute) then
  begin
    if Lowercase(ExtractFileExt(SaveDialog1.FileName)) = '.dvf' then
    begin
    AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
    Rewrite(outfile);
      Writeln(outfile, inttostr(Delaunay.Count));
    For I:= 0 to Delaunay.Count-1 do
    Begin
      Writeln(outfile, inttostr(Delaunay.Point[i].X));
      Writeln(outfile, inttostr(Delaunay.Point[i].Y));
    end;
    CloseFile(outfile);
    end;
  end;
end;

procedure TDVForm.LoadBtnClick(Sender: TObject);
var
  I,ii,x,y: integer;
  F: TextFile;
  FirstLine: string;
Begin
  OpenDialog.Filter:= 'HTF File (*.htf)|*.htf;.dtm';
  {HTF File (*.htf)|*.htf|All Files (*.*)|*.*|dtp Files (*.dtp)|*.dtp}
  OpenDialog.FileName:= '*.dvf';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  If (Lowercase(ExtractFileExt(OpenDialog.FileName))= '.dvf') then
  begin
    Delaunay.Clear(True);
    PatBlt(Canvas.Handle,0,0,DVForm.ClientWidth,DVForm.ClientHeight,BLACKNESS);

    Application.ProcessMessages;
    // ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    //  DtmHtfLoadEdit.Text:=OpenDialog.Filename;
    AssignFile(F, OpenDialog.FileName);
    try
      Reset(F);
      Readln(F, FirstLine);
      I:=Strtoint(FirstLine);
      For II:= 1 to i do
      begin
        Readln(F, FirstLine);x:=Strtoint(FirstLine);
        Readln(F, FirstLine);y:=Strtoint(FirstLine);
        Delaunay.Insert(x,y);
      end;
      if Delaunay.Count>=3 then DrawAll;
      CloseFile(F);
    except
      on EInOutError do
        MessageDlg('File I/O error.', mtError, [mbOk], 0);
    end;
  end;
end;


end.


