{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmGLSTrealFrm;
{Tree types:
even: Maple branch on opposite sides: SPLIT..Clones
alternate branching Left..Right ..stronger trees...}

{ComputeTreeRealCoords
      TreePolygonVertices: array of array of array of real;
      TreePolyImageVertices: array of array of array of Integer;
      TreePolygonVerticesNumber: array of integer;
                     barfly
B (Black Base Extents)    clBlack
A  (Aqua  1st Stem)       clAqua
R  (Red   2nd Stem )      clRed
F  (Fuchsia 3rdStem)      clFuchsia  (Purple)
L  (Lime 4th Stem)        clLime
Y  (Yellow 5th Stem)      clYellow        }

{PruneShapeDisplayBtnClick}

(*
  GlsTreeFrm in 'GlsTreeFrm.pas' {aGlsTreeForm},
  TreeCode in 'TreeCode.pas',
  GlsPluginMenuFrm in 'GlsPluginMenuFrm.pas' {GlsPluginMenuForm},
  GlsProgressFormUnit in 'GlsProgressFormUnit.pas' {GlsProgressForm},
  TreeAboutFrm in 'TreeAboutFrm.pas' {TreeAboutForm},
  GlsTreeViewerFrm in 'GlsTreeViewerFrm.pas' {GlsViewerForm},
  GlsTreeViewBitmapFrm in 'GlsTreeViewBitmapFrm.pas' {ViewBitmapForm},
  GlsTreeAboutFrm in 'GlsTreeAboutFrm.pas' {GlsTreeAboutForm},
  glstreedemofrm in 'glstreedemofrm.pas' {ATreeDemoForm},
  GlsTreeDemoLoader in 'GlsTreeDemoLoader.pas',  
  GlsTreeDemoFractal in 'GlsTreeDemoFractal.pas',
  GlsLSystemFrm in 'GlsLSystemFrm.pas' {LSystemForm},
  GlsLsysTurtlep in 'GlsLsysTurtlep.pas',
  GlsMathings in 'GlsMathings.pas' {MathingsForm},
  GlsMathRandom in 'GlsMathRandom.pas',
  GlsMathPopulation in 'GlsMathPopulation.pas',
  GlsMathAttractors in 'GlsMathAttractors.pas';

  TreeConstants,
  TreeCode,
  TreeModelParameters,
  TreeFrame, TreeONB, TreeMatrix, TreeVector,
  TreeTransformationList;
*)
interface
  
uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  //GlsPluginMenuFrm,
  TreeModelParameters,
  TreeVector,
  TreeCode,
  TreeConstants,
  TGA, {jpg,} jpeg, pngimage, ShellApi,
  Math,
  StdCtrls, ExtCtrls, ComCtrls, Menus, ExtDlgs, Buttons;

type
  TDrawingTool =
    (dtEllipse, dtCSEllipse, dtPolygon,
    dtVTriangle, dtTriangle, dtTSTriangle,
    dtVPRectangle, dtVERectangle, dtVSRectangle,
    dtVDRectangle, dtVTRectangle, dtVFRectangle, dtVNRectangle,
    dtVMRectangle, dtVARectangle, dtVWRectangle, dtVCRectangle,
    dtVBRectangle, dtVRectangle, dtRectangle, dtRoundRect,
    dtLine, dtMLine,dtPBrush);

type
  TdtmGlsTrealForm = class(TForm)
    ScrollBox1: TScrollBox;
    TracerImage: TImage;
    Panel1: TPanel;
    PageControl1: TPageControl;
    Splitter1: TSplitter;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    TabSheet5: TTabSheet;
    TreeDefLabel: TLabel;
    TreeDefFileNameEdit: TEdit;
    OpenTreeDefFileBtn: TSpeedButton;
    SaveTreeDefFileBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    HelpBtn: TSpeedButton;
    GroupBox2: TGroupBox;
    Label2: TLabel;
    Label4: TLabel;
    ScaleFloatEdit: TEdit;
    ScaleVFloatEdit: TEdit;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    RatioFloatEdit: TEdit;
    RatioPowerFloatEdit: TEdit;
    GroupBox4: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    LobeDepthFloatEdit: TEdit;
    LobesNumberEdit: TEdit;
    pager: TPageControl;
    StemLevel0TabSheet: TTabSheet;
    ScalingParameters0GroupBox: TGroupBox;
    Label26: TLabel;
    Taper0FloatEdit: TEdit;
    CurvatureParameters0GroupBox: TGroupBox;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Curve0FloatEdit: TEdit;
    CurveBack0FloatEdit: TEdit;
    CurveV0FloatEdit: TEdit;
    CurveRes0NumberEdit: TEdit;
    StemSplittingParameters0GroupBox: TGroupBox;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    SplitAngle0FloatEdit: TEdit;
    SplitAngleV0FloatEdit: TEdit;
    SegSplits0FloatEdit: TEdit;
    Level1TS: TTabSheet;
    Level2TS: TTabSheet;
    LeafColorDialog: TColorDialog;
    OpenShapeDialog: TOpenDialog;
    SaveShapeDialog: TSaveDialog;
    Level3TS: TTabSheet;
    Level4TS: TTabSheet;
    WindStrengthTB: TTrackBar;
    Label37: TLabel;
    WindFromTB: TTrackBar;
    SunHeightTB: TTrackBar;
    SunFromTB: TTrackBar;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    GroupBox5: TGroupBox;
    Label51: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    SplitAngle1FloatEdit: TEdit;
    SplitAngleV1FloatEdit: TEdit;
    SegSplits1FloatEdit: TEdit;
    GroupBox6: TGroupBox;
    Label49: TLabel;
    Label50: TLabel;
    Label54: TLabel;
    Length1FloatEdit: TEdit;
    LengthV1FloatEdit: TEdit;
    Taper1FloatEdit: TEdit;
    GroupBox7: TGroupBox;
    Label55: TLabel;
    Vertices1NumberEdit: TEdit;
    GroupBox8: TGroupBox;
    Label47: TLabel;
    Label48: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Curve1FloatEdit: TEdit;
    CurveBack1FloatEdit: TEdit;
    CurveV1FloatEdit: TEdit;
    CurveRes1NumberEdit: TEdit;
    Label58: TLabel;
    Branches1NumberEdit: TEdit;
    GroupBox9: TGroupBox;
    Rotate1FloatEdit: TEdit;
    DownAngleV1FloatEdit: TEdit;
    RotateV1FloatEdit: TEdit;
    DownAngle1FloatEdit: TEdit;
    Label59: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    PrintTreeDefFileBtn: TSpeedButton;
    StatusBar: TStatusBar;
    GroupBox10: TGroupBox;
    Label64: TLabel;
    Label65: TLabel;
    Label66: TLabel;
    Length2FloatEdit: TEdit;
    LengthV2FloatEdit: TEdit;
    Taper2FloatEdit: TEdit;
    GroupBox11: TGroupBox;
    Label67: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    SplitAngle2FloatEdit: TEdit;
    SplitAngleV2FloatEdit: TEdit;
    SegSplits2FloatEdit: TEdit;
    GroupBox12: TGroupBox;
    Label70: TLabel;
    Label71: TLabel;
    Vertices2NumberEdit: TEdit;
    Branches2NumberEdit: TEdit;
    GroupBox13: TGroupBox;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Rotate2FloatEdit: TEdit;
    DownAngleV2FloatEdit: TEdit;
    RotateV2FloatEdit: TEdit;
    DownAngle2FloatEdit: TEdit;
    GroupBox14: TGroupBox;
    Label76: TLabel;
    Label77: TLabel;
    Label78: TLabel;
    Label79: TLabel;
    Curve2FloatEdit: TEdit;
    CurveBack2FloatEdit: TEdit;
    CurveV2FloatEdit: TEdit;
    CurveRes2NumberEdit: TEdit;
    GroupBox15: TGroupBox;
    Label80: TLabel;
    Label81: TLabel;
    Label82: TLabel;
    Length3FloatEdit: TEdit;
    LengthV3FloatEdit: TEdit;
    Taper3FloatEdit: TEdit;
    GroupBox16: TGroupBox;
    Label83: TLabel;
    Label84: TLabel;
    Label85: TLabel;
    SplitAngle3FloatEdit: TEdit;
    SplitAngleV3FloatEdit: TEdit;
    SegSplits3FloatEdit: TEdit;
    GroupBox17: TGroupBox;
    Label86: TLabel;
    Label87: TLabel;
    Vertices3NumberEdit: TEdit;
    Branches3NumberEdit: TEdit;
    GroupBox18: TGroupBox;
    Label88: TLabel;
    Label89: TLabel;
    Label90: TLabel;
    Label91: TLabel;
    Rotate3FloatEdit: TEdit;
    DownAngleV3FloatEdit: TEdit;
    RotateV3FloatEdit: TEdit;
    DownAngle3FloatEdit: TEdit;
    GroupBox19: TGroupBox;
    Label92: TLabel;
    Label93: TLabel;
    Label94: TLabel;
    Label95: TLabel;
    Curve3FloatEdit: TEdit;
    CurveBack3FloatEdit: TEdit;
    CurveV3FloatEdit: TEdit;
    CurveRes3NumberEdit: TEdit;
    GroupBox20: TGroupBox;
    Label96: TLabel;
    Label97: TLabel;
    Label98: TLabel;
    Length4FloatEdit: TEdit;
    LengthV4FloatEdit: TEdit;
    Taper4FloatEdit: TEdit;
    GroupBox21: TGroupBox;
    Label99: TLabel;
    Label100: TLabel;
    Label101: TLabel;
    SplitAngle4FloatEdit: TEdit;
    SplitAngleV4FloatEdit: TEdit;
    SegSplits4FloatEdit: TEdit;
    GroupBox22: TGroupBox;
    Label102: TLabel;
    Label103: TLabel;
    Vertices4NumberEdit: TEdit;
    Branches4NumberEdit: TEdit;
    GroupBox23: TGroupBox;
    Label104: TLabel;
    Label105: TLabel;
    Label106: TLabel;
    Label107: TLabel;
    Rotate4FloatEdit: TEdit;
    DownAngleV4FloatEdit: TEdit;
    RotateV4FloatEdit: TEdit;
    DownAngle4FloatEdit: TEdit;
    GroupBox24: TGroupBox;
    Label108: TLabel;
    Label109: TLabel;
    Label110: TLabel;
    Label111: TLabel;
    Curve4FloatEdit: TEdit;
    CurveBack4FloatEdit: TEdit;
    CurveV4FloatEdit: TEdit;
    CurveRes4NumberEdit: TEdit;
    Level5TS: TTabSheet;
    GroupBox25: TGroupBox;
    Label112: TLabel;
    Label113: TLabel;
    Label114: TLabel;
    Length5FloatEdit: TEdit;
    LengthV5FloatEdit: TEdit;
    Taper5FloatEdit: TEdit;
    GroupBox26: TGroupBox;
    Label115: TLabel;
    Label116: TLabel;
    Label117: TLabel;
    SplitAngle5FloatEdit: TEdit;
    SplitAngleV5FloatEdit: TEdit;
    SegSplits5FloatEdit: TEdit;
    GroupBox27: TGroupBox;
    Label118: TLabel;
    Label119: TLabel;
    Vertices5NumberEdit: TEdit;
    Branches5NumberEdit: TEdit;
    GroupBox28: TGroupBox;
    Label120: TLabel;
    Label121: TLabel;
    Label122: TLabel;
    Label123: TLabel;
    Rotate5FloatEdit: TEdit;
    DownAngleV5FloatEdit: TEdit;
    RotateV5FloatEdit: TEdit;
    DownAngle5FloatEdit: TEdit;
    GroupBox29: TGroupBox;
    Label124: TLabel;
    Label125: TLabel;
    Label126: TLabel;
    Label127: TLabel;
    Curve5FloatEdit: TEdit;
    CurveBack5FloatEdit: TEdit;
    CurveV5FloatEdit: TEdit;
    CurveRes5NumberEdit: TEdit;
    GroupBox30: TGroupBox;
    LeafColorVariationCheckBox: TCheckBox;
    PickLeafColorBtn: TSpeedButton;
    LeafColorShape: TShape;
    Label41: TLabel;
    LeafAttractionUpFloatEdit: TEdit;
    Label16: TLabel;
    Label15: TLabel;
    LeafScaleXFloatEdit: TEdit;
    LeafScaleFloatEdit: TEdit;
    Label14: TLabel;
    LeavesNumberEdit: TEdit;
    Label12: TLabel;
    Label131: TLabel;
    Label132: TLabel;
    DistanceTrackBar: TTrackBar;
    Label133: TLabel;
    WindGustTB: TTrackBar;
    Label136: TLabel;
    Label137: TLabel;
    SunStrengthTB: TTrackBar;
    PruneImage: TImage;
    PruneShapeDisplayBtn: TSpeedButton;
    LeafTextureBtn: TSpeedButton;
    Label128: TLabel;
    LeafShapeBtn: TSpeedButton;
    Label130: TLabel;
    Label139: TLabel;
    GroupBox31: TGroupBox;
    FruitImageBtn: TSpeedButton;
    Label140: TLabel;
    FruitImageEdit: TEdit;
    Label135: TLabel;
    FruitShapeFileBtn: TSpeedButton;
    Label129: TLabel;
    FruitTextureBtn: TSpeedButton;
    LeafImageBtn: TSpeedButton;
    LeafImageEdit: TEdit;
    LeafShapeSaverBtn: TSpeedButton;
    FruitShapeSaverBtn: TSpeedButton;
    SaveTdfDialog: TSaveDialog;
    OpenTdfDialog: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Render1: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    OnHelp1: TMenuItem;
    Me1: TMenuItem;
    About1: TMenuItem;
    Tree1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    Leaf1: TMenuItem;
    Fruit1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Print1: TMenuItem;
    Trace1: TMenuItem;
    N2: TMenuItem;
    ImageLoad1: TMenuItem;
    N3: TMenuItem;
    ShapeLoad1: TMenuItem;
    ShapeSave1: TMenuItem;
    N4: TMenuItem;
    BarkLoad1: TMenuItem;
    DistanceLabel: TLabel;
    WindStrengthLabel: TLabel;
    WindFromLabel: TLabel;
    WindGustLabel: TLabel;
    SunStrengthLabel: TLabel;
    SunHeightLabel: TLabel;
    SunFromLabel: TLabel;
    Label151: TLabel;
    FruitColorShape: TShape;
    PickFruitColorBtn: TSpeedButton;
    FruitColorVariationCheckBox: TCheckBox;
    Image2: TMenuItem;
    ShapeLoad2: TMenuItem;
    ShapeSave2: TMenuItem;
    TextureLoad1: TMenuItem;
    Image3: TMenuItem;
    ShapeLoad3: TMenuItem;
    ShapeSave3: TMenuItem;
    TextureLoad2: TMenuItem;
    FruitNumberEdit: TEdit;
    FruitPerEdit: TEdit;
    Label143: TLabel;
    Label144: TLabel;
    LeafLocationRG: TRadioGroup;
    Label145: TLabel;
    LeafsPerEdit: TEdit;
    LeafGroupingCB: TComboBox;
    DefinitionSaveAs1: TMenuItem;
    ShapeSaveAs1: TMenuItem;
    ShapeSaveAs2: TMenuItem;
    GLSViewer1: TMenuItem;
    TabSheet6: TTabSheet;
    RichEdit1: TRichEdit;
    Label146: TLabel;
    ManOpenLeafShapeFileBtn: TSpeedButton;
    ManSaveLeafShapeFileBtn: TSpeedButton;
    Label147: TLabel;
    ManOpenFruitShapeFileBtn: TSpeedButton;
    ManSaveFruitShapeFileBtn: TSpeedButton;
    ManualShapeInputFilenameEdit: TEdit;
    Label148: TLabel;
    Label149: TLabel;
    TreeInputname1: TMenuItem;
    BaseExtents: TMenuItem;
    FirstLimbLevel: TMenuItem;
    SecondLimbLevel: TMenuItem;
    ThirdLimbLevel: TMenuItem;
    FourthLimbLevel: TMenuItem;
    ManDisplayLeafBtn: TSpeedButton;
    CClear1: TMenuItem;
    DDraw1: TMenuItem;
    ADrawAll1: TMenuItem;
    TreeParameter1: TMenuItem;
    TraceInput1: TMenuItem;
    TICNone: TMenuItem;
    PrinterSetupDialog: TPrinterSetupDialog;
    SetupPrinterBtn: TSpeedButton;
    Label152: TLabel;
    FTracerFinished1: TMenuItem;
    SaveImage1: TMenuItem;
    SaveScreenImageDialog: TSaveDialog;
    ManDisplayFruitBtn: TSpeedButton;
    ShapeSaveAs: TMenuItem;
    SaveAnnoDefinitionBtn: TSpeedButton;
    FifthLimbLevel: TMenuItem;
    Label154: TLabel;
    Label155: TLabel;
    Label156: TLabel;
    Label157: TLabel;
    Label158: TLabel;
    DisplayTreeBtn: TSpeedButton;
    Label160: TLabel;
    LeafBackColorVariationCheckBox: TCheckBox;
    LeafBackColorShape: TShape;
    PickLeafBackColorBtn: TSpeedButton;
    N6: TMenuItem;
    HighLevelTracing1: TMenuItem;
    Leaf2: TMenuItem;
    Stem1: TMenuItem;
    General1: TMenuItem;
    Overview1: TMenuItem;
    Menu1: TMenuItem;
    N7: TMenuItem;
    Prune1: TMenuItem;
    Level6TS: TTabSheet;
    GroupBox33: TGroupBox;
    Label142: TLabel;
    Label162: TLabel;
    Label163: TLabel;
    Length6FloatEdit: TEdit;
    LengthV6FloatEdit: TEdit;
    Taper6FloatEdit: TEdit;
    GroupBox34: TGroupBox;
    Label164: TLabel;
    Label165: TLabel;
    Label166: TLabel;
    SplitAngle6FloatEdit: TEdit;
    SplitAngleV6FloatEdit: TEdit;
    SegSplits6FloatEdit: TEdit;
    Label167: TLabel;
    GroupBox35: TGroupBox;
    Label168: TLabel;
    Label169: TLabel;
    Vertices6NumberEdit: TEdit;
    Branches6NumberEdit: TEdit;
    GroupBox36: TGroupBox;
    Label170: TLabel;
    Label171: TLabel;
    Label172: TLabel;
    Label173: TLabel;
    Rotate6FloatEdit: TEdit;
    DownAngleV6FloatEdit: TEdit;
    RotateV6FloatEdit: TEdit;
    DownAngle6FloatEdit: TEdit;
    GroupBox37: TGroupBox;
    Label174: TLabel;
    Label175: TLabel;
    Label176: TLabel;
    Label177: TLabel;
    Curve6FloatEdit: TEdit;
    CurveBack6FloatEdit: TEdit;
    CurveV6FloatEdit: TEdit;
    CurveRes6NumberEdit: TEdit;
    FruitTypeRG: TComboBox;
    Label179: TLabel;
    FruitScaleFloatEdit: TEdit;
    Label180: TLabel;
    FruitScaleXFloatEdit: TEdit;
    Label181: TLabel;
    GroupBox1: TGroupBox;
    ShapeLabel: TLabel;
    Label6: TLabel;
    Label178: TLabel;
    ShapeComboBox: TComboBox;
    LevelsNumberEdit: TEdit;
    SeasonComboBox: TComboBox;
    Label36: TLabel;
    Label42: TLabel;
    RandomTreeSeedNumberEdit: TEdit;
    Label38: TLabel;
    Label39: TLabel;
    HealthTrackBar: TTrackBar;
    HealthLabel: TLabel;
    Label40: TLabel;
    Label46: TLabel;
    LoadTreeImageBtn: TSpeedButton;
    Label134: TLabel;
    LoadTreeShapeBtn: TSpeedButton;
    SaveTreeShapeBtn: TSpeedButton;
    TreeImageEdit: TEdit;
    TreeShapeEdit: TEdit;
    GroupBox32: TGroupBox;
    TreeShapeRG: TRadioGroup;
    TICRG: TRadioGroup;
    GroupBox39: TGroupBox;
    Label21: TLabel;
    Label20: TLabel;
    Label19: TLabel;
    Label18: TLabel;
    Label17: TLabel;
    PrunePowerHighFloatEdit: TEdit;
    PrunePowerLowFloatEdit: TEdit;
    PruneWidthPeakFloatEdit: TEdit;
    PruneWidthFloatEdit: TEdit;
    PruneRatioFloatEdit: TEdit;
    GroupBox40: TGroupBox;
    Label141: TLabel;
    LoadTreeBarkBtn: TSpeedButton;
    TreeBarkEdit: TEdit;
    Label153: TLabel;
    PickTreeColorBtn: TSpeedButton;
    TreeColorShape: TShape;
    TreeColorVariationCheckBox: TCheckBox;
    GroupBox38: TGroupBox;
    Label27: TLabel;
    Label1: TLabel;
    Label63: TLabel;
    FlareFloatEdit: TEdit;
    GroupBox41: TGroupBox;
    Vertices0Label: TLabel;
    Vertices0NumberEdit: TEdit;
    Label138: TLabel;
    Leaves1NumberEdit: TEdit;
    Label150: TLabel;
    Leaves0NumberEdit: TEdit;
    Label161: TLabel;
    Leaves2NumberEdit: TEdit;
    Label182: TLabel;
    Leaves3NumberEdit: TEdit;
    Label183: TLabel;
    Leaves4NumberEdit: TEdit;
    Label184: TLabel;
    Leaves5NumberEdit: TEdit;
    Label185: TLabel;
    Leaves6NumberEdit: TEdit;
    WindActiveCB: TCheckBox;
    Label35: TLabel;
    Label186: TLabel;
    GroupBox42: TGroupBox;
    Label188: TLabel;
    LoadTreeSpriteBtn: TSpeedButton;
    TreeSpriteEdit: TEdit;
    Scale0FloatEdit: TEdit;
    Label22: TLabel;
    Label23: TLabel;
    ScaleV0FloatEdit: TEdit;
    LeafOffsetEdit: TEdit;
    Label189: TLabel;
    GroupBox43: TGroupBox;
    Label159: TLabel;
    Label3: TLabel;
    ZScaleFloatEdit: TEdit;
    Label5: TLabel;
    ZScaleVFloatEdit: TEdit;
    N8: TMenuItem;
    DefinitionAnnoSave1: TMenuItem;
    N9: TMenuItem;
    SpriteImageLoad1: TMenuItem;
    BoleSplits0NumberEdit: TEdit;
    BaseSplits0NumberEdit: TEdit;
    InchMeterEdit: TEdit;
    InchMeterBtn: TSpeedButton;
    LengthV0FloatEdit: TEdit;
    Label25: TLabel;
    Length0FloatEdit: TEdit;
    Label24: TLabel;
    Label11: TLabel;
    LeafTextureCB: TComboBox;
    ClearAllTextures1: TMenuItem;
    FruitShapeRG: TRadioGroup;
    FruitLocationRG: TRadioGroup;
    DeathTollRG: TRadioGroup;
    LeafShapeRG: TRadioGroup;
    Label13: TLabel;
    BoleSizeFloatEdit: TEdit;
    BaseSizeFloatEdit: TEdit;
    Label190: TLabel;
    FlareVFloatEdit: TEdit;
    LobeScaleFloatEdit: TEdit;
    Label192: TLabel;
    LobeScaleVFloatEdit: TEdit;
    Label193: TLabel;
    DownAngle0FloatEdit: TEdit;
    Label194: TLabel;
    DownAngleV0FloatEdit: TEdit;
    Label195: TLabel;
    Rotate0FloatEdit: TEdit;
    Label196: TLabel;
    RotateV0FloatEdit: TEdit;
    Label187: TLabel;
    AttractionUpFloatEdit: TEdit;
    Label191: TLabel;
    LeafShapeCB: TComboBox;
    FruitTextureCB: TComboBox;
    FruitShapeCB: TComboBox;
    Label197: TLabel;
    ClearAllTextures2: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    ClearAllShapes1: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    ClearAllShapes2: TMenuItem;

    procedure FormCreate(Sender: TObject);
procedure DisplayHint(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ExitBtnClick(Sender: TObject);

    procedure Contents1Click(Sender: TObject);
    procedure OnHelp1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure GLSViewer1Click(Sender: TObject);
    procedure DisplayTreeBtnClick(Sender: TObject);
    procedure SaveImage1Click(Sender: TObject);

procedure ClearFileData;    

{procedure ModelInputComponentChange(Sender: TObject); }
    procedure RandomTreeSeedNumberEditChange(Sender: TObject);
    procedure LevelsNumberEditExit(Sender: TObject);

    procedure SetupPrinterBtnClick(Sender: TObject);
    procedure PrintTreeDefFileBtnClick(Sender: TObject);
    procedure SaveAnnoDefinitionBtnClick(Sender: TObject);
procedure SaveOrPrint(Switch:Integer);

    procedure SaveTreeDefFileBtnClick(Sender: TObject);
    procedure OpenTreeDefFileBtnClick(Sender: TObject);
    procedure LoadTreeImageBtnClick(Sender: TObject);
    procedure LoadTreeShapeBtnClick(Sender: TObject);
    procedure SaveTreeShapeBtnClick(Sender: TObject);
procedure SaveTreeShape(Filename:String);
    procedure LoadTreeBarkBtnClick(Sender: TObject);
    procedure PickTreeColorBtnClick(Sender: TObject);

    procedure LoadTreeSpriteBtnClick(Sender: TObject);

    procedure InchMeterBtnClick(Sender: TObject);
    procedure LeafImageBtnClick(Sender: TObject);
    procedure LeafShapeBtnClick(Sender: TObject);
    procedure LeafShapeSaverBtnClick(Sender: TObject);
Function LeafShapeChecker(LeafShape:Integer):Boolean;

procedure LoadLeafShape(FileName: string);
procedure SaveLeafShape(FileName: string);
    procedure LeafTextureBtnClick(Sender: TObject);
    procedure PickLeafColorBtnClick(Sender: TObject);

    procedure PickLeafBackColorBtnClick(Sender: TObject);

    procedure Leaf2Click(Sender: TObject);
    procedure ManOpenLeafShapeFileBtnClick(Sender: TObject);
    procedure ManSaveLeafShapeFileBtnClick(Sender: TObject);
    procedure ManOpenFruitShapeFileBtnClick(Sender: TObject);
    procedure ManSaveFruitShapeFileBtnClick(Sender: TObject);
    procedure ManDisplayLeafBtnClick(Sender: TObject);
    procedure ManDisplayFruitBtnClick(Sender: TObject);
procedure BlankCanvas;

    procedure FruitImageBtnClick(Sender: TObject);
    procedure FruitTextureBtnClick(Sender: TObject);
    procedure FruitShapeFileBtnClick(Sender: TObject);
    procedure FruitShapeSaverBtnClick(Sender: TObject);
procedure LoadFruitShape(FileName: string);
procedure SaveFruitShape(FileName: string);
    procedure PickFruitColorBtnClick(Sender: TObject);

    procedure CClear1Click(Sender: TObject);
    procedure TraceInput1Click(Sender: TObject);
    procedure FTracerFinished1Click(Sender: TObject);
    procedure DDraw1Click(Sender: TObject);
    procedure ADrawAll1Click(Sender: TObject);
    procedure TICRGClick(Sender: TObject);

    procedure TICNoneClick(Sender: TObject);


    procedure BaseExtentsClick(Sender: TObject);
    procedure FirstLimbLevelClick(Sender: TObject);
    procedure SecondLimbLevelClick(Sender: TObject);
    procedure ThirdLimbLevelClick(Sender: TObject);
    procedure FourthLimbLevelClick(Sender: TObject);
    procedure FifthLimbLevelClick(Sender: TObject);

    procedure TreeShapeRGClick(Sender: TObject);


    procedure TracerImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TracerImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TracerImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

procedure ComputeTreeRealCoords;
procedure ComputeLeafImageCoords;
procedure ComputeLeafRealCoords;
procedure ComputeFruitImageCoords(InX,InY:Integer);
procedure ComputeFruitRealCoords;

function ShapeRat(const Shape: integer; const Ratio: Double): Double;
    procedure PruneShapeDisplayBtnClick(Sender: TObject);

    procedure HealthTrackBarChange(Sender: TObject);
    procedure DistanceTrackBarChange(Sender: TObject);
    procedure WindStrengthTBChange(Sender: TObject);
    procedure WindGustTBChange(Sender: TObject);
    procedure WindFromTBChange(Sender: TObject);
    procedure SunHeightTBChange(Sender: TObject);
    procedure SunStrengthTBChange(Sender: TObject);
    procedure SunFromTBChange(Sender: TObject);
    procedure ClearAllTextures1Click(Sender: TObject);
    procedure LeafShapeCBChange(Sender: TObject);
    procedure ClearAllTextures2Click(Sender: TObject);
    procedure ClearAllShapes1Click(Sender: TObject);
    procedure ClearAllShapes2Click(Sender: TObject);

  private
    { Private declarations }

     DrawingToolPBrushWidth:integer;
     TreeImageLoaded,LeafImageLoaded, FruitImageLoaded,
     ImageLoaded,FruityLeafStarted,
     Drawing:Boolean;
     DIYX3Y3,DIYX4Y4,Origin, MovePt:TPoint;
     {FruitList, LeafList, TreeList:TList; }
     DrawingTool: TDrawingTool;
     Function  LoadImage(var InName:String):Boolean;
     procedure DrawShape
  (TopLeft, BottomRight, Tri, Quad: TPoint; AMode: TPenMode);
     procedure DrawTracedShape(Which:Integer);
  public
    { Public declarations }
    GrabberImageBitmap:TBitmap;
    procedure InitModelParameters(ModelParameters: TModelParameters);
    { Pre: True
      Post: All model parameters inputted by the user have been assigned to
            the corresponding properties of the class FModelParameters. }
    procedure SaveTreeDefinition(FileName: string);
    { Pre: True
      Post: The current model parameters have been saved to FileName. }
    procedure LoadTreeDefinition(FileName: string);
    { Pre: FileName should point to an existing file.
      Post: The current model parameters have been set to the model parameters
            loaded from the tree definition file FileName. }
  end;

var
  dtmGlsTrealForm: TdtmGlsTrealForm;


implementation

uses
  dtmGlsTrealViewerFrm,
  dtmGlsTrealAboutFrm;


{$R *.DFM}

procedure TdtmGlsTrealForm.FormCreate(Sender: TObject);
var
 InString:String;
 f:TextFile;
 MS: TMemoryStatus;
begin
  {Get Memory available to use in Testing for Tree Crashing}
  GlobalMemoryStatus(MS);
  MemoryCapacity:= (MS.dwAvailPhys{/1024});
{  PhysMem.Caption := FormatFloat('#,###" KB"', MS.dwTotalPhys/1024);
  FreeRes.Caption := Format('%d %%', [MS.dwMemoryLoad]);
  {LeavesGrownTotal:=0; }
 { GlsViewerCancelled:=True;
  GlsDemoCancelled:=True;
  GlsUserCancelled:=True;
  DisplayWithLeaves:=False;
  DemoTreePlanted:=False;
  TreePlanted:=False; }
  DisplayWithLeaves:=True;
  BoleMade:=False;
  AnimationActive:=False;
  DistanceActive:=False;
  WindAnimationActive:=False;
 { Anime360Counter:=0;
  WindSign:=0;
  Bolebusted:=0; }
  aGlsTreeFormX:=123;
  aGlsTreeFormY:=123;
  GlsTrealViewerFormX:=0;
  GlsTrealViewerFormY:=0;
  ATreeDemoFormX:=0;
  ATreeDemoFormY:=0;
  MathingsFormX:=0;MathingsFormY:=0;
  LSystemFormX:=0;LSystemFormY:=0;


  RandomTreeSeedNumber:=11;
  RandomTreeSeedNumberEdit.Text:='11';
  HealthTrackBar.Position:=100;
  SeasonComboBox.ItemIndex:=2;{W S Summer F}
  GlobalLevelsNumber:=7; {CANNOT be <1}
  LevelsNumberEdit.Text:=Inttostr(GlobalLevelsNumber);
  FruityLeafStarted:=False;
  Drawing:=False;
  TreeImageLoaded:=False;
  LeafImageLoaded:=False;
  FruitImageLoaded:=False;
  ImageLoaded:=False;
  GrabberImageBitmap := TBitMap.Create;
  DrawingTool := dtRectangle;
  DrawingToolPBrushWidth:=3;
  TracerImage.Canvas.Brush.Color := clWhite;
  TracerImage.Canvas.FillRect(Rect(0,0,256,256));
  TracerImage.Canvas.Brush.Style := bsClear;
  GlsPath:=ExtractFilePath(Application.Exename);
  GlsTdfPath:=Extractfilepath(Application.exename)+'tree definitions\';
  GlsDataPath:=Extractfilepath(Application.exename)+'tree data\';
  {GlsHelpPath:=Extractfilepath(Application.exename)+'help\';}
  {Goofy, used to be different}
  FruitShapeCurrent:=-1;
  FruitPolygonVerticesNumber[FruitShapeCurrent]:=-1;
  FruitTypeRG.ItemIndex:=0;
  LeafGroupingCB.ItemIndex:=0;
  {LeafShapeEdit.Text:='apple_leaf.lsf'; }
  LeafShapeCurrent:=-1;
{  LeafShapeCB.Items.Add('anon_leaf.lsf');}
  If FileExists(GlsDataPath+'anon_leaf.lsf'{LeafShapeCB.Items[0]}) then
  begin
{    LoadLeafShape(GlsDataPath+LeafShapeCB.Items[0]);
    LeafTextureCB.Items.Clear;
    LeafTextureCB.Items.Add('anon_leaf.jpg');}
  end else
  begin
    Showmessage(GlsDataPath+'anon_leaf.lsf NOT found');
    Application.Terminate;
  end;

  { Update the main form caption }
  dtmGlsTrealForm.Caption := 'GLS TReal v' + TREAL_VERSION;

  { Use the english decimal and thousands seperator characters }
  DecimalSeparator := '.';
  ThousandSeparator := ',';
  DoubleBuffered := True;

{Load info from GlsTreal.ini}
  if FileExists(ExtractFilePath(Application.Exename) + 'glstreal.ini') then
  begin   { Read the settings from the Treal.ini }
    try
      AssignFile(f, ExtractFilePath(Application.Exename) + 'glstreal.ini');
      try
        Reset(f);
        Readln(f,InString);
        TreeDefFileNameEdit.Text:=InString;
        {Readln(f,GlsTdfPath);
        Readln(f,GlsDataPath);
        Readln(f,GlsHelpPath);}
        Readln(f,InString);
        HealthTrackBar.Position:=StrtoInt(InString);{100;}
        Readln(f,InString);
        SeasonComboBox.ItemIndex:=StrtoInt(InString);{2;}
        Readln(f,InString);
        RandomTreeSeedNumberEdit.Text:=InString;{'0';}
        RandomTreeSeedNumber:=Strtoint(RandomTreeSeedNumberEdit.Text);
        Readln(f,InString);  aGlsTreeFormX:=StrtoInt(InString);
        Readln(f,InString);  aGlsTreeFormY:=StrtoInt(InString);
        Readln(f,InString);  GlsTrealViewerFormX:=StrtoInt(InString);
        Readln(f,InString);  GlsTrealViewerFormY:=StrtoInt(InString);
        Readln(f,InString);  ATreeDemoFormX:=StrtoInt(InString);
        Readln(f,InString);  ATreeDemoFormY:=StrtoInt(InString);
        Readln(f,InString);  MathingsFormX:=StrtoInt(InString);
        Readln(f,InString);  MathingsFormY:=StrtoInt(InString);
        Readln(f,InString);  LSystemFormX:=StrtoInt(InString);
        Readln(f,InString);  LSystemFormY:=StrtoInt(InString);
      except
        on EInOutError do
        begin
          MessageDlg('glstreal.ini corrupt!', mtError, [mbOK], 0);
        end;
      end;
    finally
      CloseFile(f);
    end;
  end else
  begin
    try
      AssignFile(f, ExtractFilePath(Application.Exename) + 'glstreal.ini');
      try
        Rewrite(f);
       InString:=TreeDefFileNameEdit.Text;
        Writeln(f,InString);
        {Writeln(f,GlsTdfPath);
        Writeln(f,GlsDataPath);
        Writeln(f,GlsHelpPath);}
        InString:=Inttostr(HealthTrackBar.Position);
        Writeln(f,InString);
        InString:=Inttostr(SeasonComboBox.ItemIndex);
        Writeln(f,InString);
        InString:=RandomTreeSeedNumberEdit.Text;
        Writeln(f,InString);
        InString:=Inttostr(aGlsTreeFormX);
        Writeln(f,InString);
        InString:=Inttostr(aGlsTreeFormY);
        Writeln(f,InString);
        InString:=Inttostr(GlsTrealViewerFormX);
        Writeln(f,InString);
        InString:=Inttostr(GlsTrealViewerFormY);
        Writeln(f,InString);
        InString:=Inttostr(ATreeDemoFormX);
        Writeln(f,InString);
        InString:=Inttostr(ATreeDemoFormY);
        Writeln(f,InString);
        InString:=Inttostr(MathingsFormX);
        Writeln(f,InString);
        InString:=Inttostr(MathingsFormY);
        Writeln(f,InString);
        InString:=Inttostr(LSystemFormX);
        Writeln(f,InString);
        InString:=Inttostr(LSystemFormY);
        Writeln(f,InString);
      except
        on EInOutError do
        begin
          MessageDlg('glstreal.ini corrupted!', mtError, [mbOK], 0);
        end;
      end;
    finally
      CloseFile(f);
    end;
  end;
  Left:=aGlsTreeFormX;
  Top:=aGlsTreeFormY;
{HealthTrackBar.Position
SeasonComboBox.ItemIndex
RandomSeedNumberEdit.SetValue(
TreeDefinitionFileName}

   if FileExists(GlsTdfPath+TreeDefFileNameEdit.Text) then
      LoadTreeDefinition(GlsTdfPath+TreeDefFileNameEdit.Text);
  { Load tree definition file if one was specified using the command line }
  if ParamCount > 0 then
    If (ExtractFileExt(ParamStr(1))='.tdf') then
    if FileExists(ParamStr(1)) then
    LoadTreeDefinition(GlsTdfPath+ParamStr(1));
end;

procedure TdtmGlsTrealForm.DisplayHint(Sender: TObject);
begin
  Statusbar.Panels[0].Text  := Application.Hint;
end;
procedure TdtmGlsTrealForm.FormActivate(Sender: TObject);
begin
  Application.OnHint := DisplayHint;{App}
end;

procedure TdtmGlsTrealForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
 InString:String;
 f:TextFile;
begin
  aGlsTreeFormX:=dtmGlsTrealForm.Left;
  aGlsTreeFormY:=dtmGlsTrealForm.Top;
  {Save info as GlsTreal.ini}
    try
      AssignFile(f, ExtractFilePath(Application.Exename) + 'glstreal.ini');
      try
        Rewrite(f);
        InString:=TreeDefFileNameEdit.Text;
        Writeln(f,InString);
        {Writeln(f,GlsTdfPath);
        Writeln(f,GlsDataPath);
        Writeln(f,GlsHelpPath);}
        InString:=Inttostr(HealthTrackBar.Position);
        Writeln(f,InString);
        InString:=Inttostr(SeasonComboBox.ItemIndex);
        Writeln(f,InString);
        InString:=RandomTreeSeedNumberEdit.Text;
        Writeln(f,InString);
        InString:=Inttostr(aGlsTreeFormX);
        Writeln(f,InString);
        InString:=Inttostr(aGlsTreeFormY);
        Writeln(f,InString);
        InString:=Inttostr(GlsTrealViewerFormX);
        Writeln(f,InString);
        InString:=Inttostr(GlsTrealViewerFormY);
        Writeln(f,InString);
        InString:=Inttostr(ATreeDemoFormX);
        Writeln(f,InString);
        InString:=Inttostr(ATreeDemoFormY);
        Writeln(f,InString);
        InString:=Inttostr(MathingsFormX);
        Writeln(f,InString);
        InString:=Inttostr(MathingsFormY);
        Writeln(f,InString);
        InString:=Inttostr(LSystemFormX);
        Writeln(f,InString);
        InString:=Inttostr(LSystemFormY);
        Writeln(f,InString);        
      except
        on EInOutError do
        begin
          MessageDlg('glstreal.ini corrupt!', mtError, [mbOK], 0);
        end;
      end;
    finally
      CloseFile(f);
    end;
  GrabberImageBitmap.Free;    
end;

procedure TdtmGlsTrealForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;


procedure TdtmGlsTrealForm.SaveImage1Click(Sender: TObject);
begin  {SaveImageDialog}
  SaveScreenImageDialog.Initialdir:=GlsPath;
  SaveScreenImageDialog.FileName:=ChangeFileExt(TreeDefFileNameEdit.Text,'.bmp');
  if SaveScreenImageDialog.Execute then
  begin
    Application.ProcessMessages;
    TracerImage.Picture.Savetofile(SaveScreenImageDialog.FileName);
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.Contents1Click(Sender: TObject);
begin
ShellExecute(
Application.Handle, // handle to parent window
'open',             // pointer to string that specifies operation to perform
PChar(ExtractFilePath(Application.Exename)+'tree help\glstreal_2treal.htm'),// pointer to filename or folder name string
'',// pointer to string that specifies executable-file parameters
 PChar(ExtractFilePath(Application.Exename)+'tree help'),// pointer to string that specifies default directory
SW_SHOWNORMAL);
end;

procedure TdtmGlsTrealForm.OnHelp1Click(Sender: TObject);
begin{MS Help}
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;
                         {Help}
procedure TdtmGlsTrealForm.Leaf2Click(Sender: TObject);
var
  s:String;
  Item: TMenuItem;
begin
  s:=ExtractFilePath(Application.Exename)+'tree help\';
  Item := Sender as TMenuItem;
    Case Item.tag of
      2:s:=s+'glstree_menu.htm';  {glstree_menu.htm}
      3:s:=s+'glstree_tree.htm'; {Tree }
      4:s:=s+'glstree_trace.htm'; {Tracing1 }
      5:s:=s+'glstree_stem.htm'; {branches}
      6:s:=s+'glstree_leaf.htm'; { Leaf2}
      7:s:=s+'glstree_prune.htm'; {glstree_prune.htm}
      else s:=s+'glstreal_2treal.htm'; {1 Overview.. catch all too}
    end;
  ShellExecute(
  Application.Handle, // handle to parent window
  'open',             // pointer to string that specifies operation to perform
  PChar(s),// pointer to filename or folder name string
  '',// pointer to string that specifies executable-file parameters
  PChar(ExtractFilePath(Application.Exename)+'tree help'),// pointer to string that specifies default directory
  SW_SHOWNORMAL);
end;
procedure TdtmGlsTrealForm.About1Click(Sender: TObject);
begin
  dtmGlsTrealAboutForm:=TdtmGlsTrealAboutForm.Create(Application);
  try
    dtmGlsTrealAboutForm.ShowModal;
  finally
    dtmGlsTrealAboutForm.Release;
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------

procedure TdtmGlsTrealForm.GLSViewer1Click(Sender: TObject);
begin
  DisplayWithLeaves:=True;
  WindAnimationActive:=WindActiveCB.Checked;
  AnimationDistance:=DistanceTrackBar.Position;
  dtmGlsTrealViewerForm:=TdtmGlsTrealViewerForm.Create(Application);
  try
    dtmGlsTrealViewerForm.ShowModal;
  finally
    dtmGlsTrealViewerForm.Release;
  end;
end;

procedure TdtmGlsTrealForm.DisplayTreeBtnClick(Sender: TObject);
begin
  DisplayWithLeaves:=False;
  WindAnimationActive:=WindActiveCB.Checked;
  dtmGlsTrealViewerForm:=TdtmGlsTrealViewerForm.Create(Application);
  try
    dtmGlsTrealViewerForm.ShowModal;
  finally
    dtmGlsTrealViewerForm.Release;
  end;
end;

//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.ClearFileData;
Begin         
 SetLength(LeafPolygonVertices,0);
 SetLength(LeafPolyImageVertices,0);
 SetLength(LeafPolygonVerticesNumber,0);
 SetLength(LeafShapeType,0);
 SetLength(FruitPolygonVertices,0);
 SetLength(FruitPolyImageVertices,0);
 SetLength(FruitPolygonVerticesNumber,0);
 SetLength(FruitShapeType,0);
 SetLength(TreePolygonVertices,0);
 SetLength(TreePolyImageVertices,0);
 SetLength(TreePolygonVerticesNumber,0);
 LeafShapeCurrent:=-1;
 FruitShapeCurrent:=-1;
End;

//-----------------------------------------------------
//-----------------------------------------------------
   {SURE Would make more sense to Rewrite code so
    Levels IS the NUMBER of Branches,
    and Leaves are always done too}
procedure TdtmGlsTrealForm.LevelsNumberEditExit(Sender: TObject);
begin
  GlobalLevelsNumber:= strtoint(LevelsNumberEdit.Text);
  If GlobalLevelsNumber > 7 then
  begin                        {1..6 +1 =7}
    showmessage('Sorry! Limited to 7 Levels.');
    exit;
  end;
  if GlobalLevelsNumber <= 0 then
  begin
    MessageDlg('Levels should be a value greater than zero!',
     mtError, [mbOK], 0);
    {LevelsNumberEdit.SetFocus;
    LevelsNumberEdit.SelectAll; }
  end
  else  { LevelsNumberEdit.GetValue > 0 }
{  If strtoint(LevelsNumberEdit.Text) <> CurrentLevelsNumber then}
  begin {Make some newbies }
    Level1TS.TabVisible:=False;
    Level2TS.TabVisible:=False;
    Level3TS.TabVisible:=False;
    Level4TS.TabVisible:=False;
    Level5TS.TabVisible:=False;
    Level6TS.TabVisible:=False;
      { hide redundant tab sheets }
    If GlobalLevelsNumber >1then
    {Level1TS.Font.Color:=clWindowText;}  Level1TS.TabVisible:=True;
    If GlobalLevelsNumber >2then
    {Level2TS.Font.Color:=clWindowText;}  Level2TS.TabVisible:=True;
    If GlobalLevelsNumber >3then
    {Level3TS.Font.Color:=clWindowText;}  Level3TS.TabVisible:=True;
    If GlobalLevelsNumber >4then
    {Level4TS.Font.Color:=clWindowText;}  Level4TS.TabVisible:=True;
    If GlobalLevelsNumber >5then
    {Level5TS.Font.Color:=clWindowText;}  Level5TS.TabVisible:=True;
    If GlobalLevelsNumber >6then
    {Level6TS.Font.Color:=clWindowText;}  Level6TS.TabVisible:=True;
  end;
end;


procedure TdtmGlsTrealForm.InitModelParameters(ModelParameters:TModelParameters);
{ Pre: ModelParameters <> nil
  Post: All model parameters inputted by the user have been assigned to
        the corresponding properties of the class FModelParameters. }
var i: integer;
begin
  { Initialize the model parameters class }
  with ModelParameters do
  begin
      Shape := ShapeComboBox.ItemIndex;
      {Level inherent}
      {Levels determined upon Create
       Levelers             := Strtoint(LevelsNumberEdit.Text);}
      Season:=  SeasonComboBox.ItemIndex;
      TreeSeed:= strtoint(RandomTreeSeedNumberEdit.Text);
      Health:=HealthTrackBar.Position;
      AttractionUp := strtofloat(AttractionUpFloatEdit.Text);
      DeathToll:= DeathTollRG.ItemIndex;

      Distance:= DistanceTrackBar.Position;
      WindStrength:=WindStrengthTB.Position;
      WindGust:=WindGustTB.Position;
      WindFrom:=WindFromTB.Position;
      SunHeight:=SunHeightTB.Position;
      SunStrength:=SunStrengthTB.Position;
      SunFrom:=SunFromTB.Position;

      TreeImageFile:= TreeImageEdit.Text;
      TreeShapeFile:= TreeShapeEdit.Text;
      TreeSpriteFile:= TreeSpriteEdit.Text;
    Scale              := strtofloat(ScaleFloatEdit.Text);
    ScaleV             := strtofloat(ScaleVFloatEdit.Text);
    nLength[0]         := strtofloat(Length0FloatEdit.Text);
    nLengthV[0]        := strtofloat(LengthV0FloatEdit.Text);

    Ratio              := strtofloat(RatioFloatEdit.Text);
    RatioPower         := strtofloat(RatioPowerFloatEdit.Text);
    Scale0             := strtofloat(Scale0FloatEdit.Text);
    ScaleV0            := strtofloat(ScaleV0FloatEdit.Text);

    Lobes              := strtoint(LobesNumberEdit.Text);
    LobeDepth          := strtofloat(LobeDepthFloatEdit.Text);
    LobeScale              := strtofloat(LobeScaleFloatEdit.Text);
    LobeScaleV             := strtofloat(LobeScaleVFloatEdit.Text);

      TreeBarkFile:= TreeBarkEdit.Text;
      TreeColor          := TreeColorShape.Brush.Color;
      TreeColorVariation := TreeColorVariationCheckBox.Checked;

    BaseSplits         := strtoint(BaseSplits0NumberEdit.Text);
    BaseSize           := strtofloat(BaseSizeFloatEdit.Text);
    ZScale             := strtofloat(ZScaleFloatEdit.Text);
    ZScaleV            := strtofloat(ZScaleVFloatEdit.Text);

    BoleSplits         := strtoint(BoleSplits0NumberEdit.Text);
    BoleSize           := strtofloat(BoleSizeFloatEdit.Text);
    Flare              := strtofloat(FlareFloatEdit.Text);
    FlareV              := strtofloat(FlareVFloatEdit.Text);

    nVertices[0]       := strtoint(Vertices0NumberEdit.Text);
    nBranches[0]    := 0;
    nLeaves[0]       := strtoint(Leaves0NumberEdit.Text);
    nTaper[0]          := strtofloat(Taper0FloatEdit.Text);

        nDownAngle[0]   := strtofloat(DownAngle0FloatEdit.Text);
        nDownAngleV[0]  := strtofloat(DownAngleV0FloatEdit.Text);
        nRotate[0]      := strtofloat(Rotate0FloatEdit.Text);
        nRotateV[0]     := strtofloat(RotateV0FloatEdit.Text);

    nCurveRes[0]       := strtoint(CurveRes0NumberEdit.Text);
    nCurveV[0]         := strtofloat(CurveV0FloatEdit.Text);
    nCurve[0]          := strtofloat(Curve0FloatEdit.Text);
    nCurveBack[0]      := strtofloat(CurveBack0FloatEdit.Text);

    nSegSplits[0]      := strtofloat(SegSplits0FloatEdit.Text);
    nSplitAngle[0]     := strtofloat(SplitAngle0FloatEdit.Text);
    nSplitAngleV[0]    := strtofloat(SplitAngleV0FloatEdit.Text);


    { The first is the Trunk
      The last level is reserved for the leaves, and thus doesn't include stem
      parameters (that's why the '- 1' term after Levels. }

    for i := 1 to Levelers - 1 do
    begin

      { Initialize the stem parameters for each recursion level
        using FindComponent to locate the float edit component
        corresponding with the stem parameter }

      nLength[i]      := strtofloat(TEdit(FindComponent('Length'
                           + IntToStr(i) + 'FloatEdit')).Text);
     nLengthV[i]     := strtofloat(TEdit(FindComponent('LengthV'
                         + IntToStr(i) + 'FloatEdit')).Text);
      nTaper[i]       := strtofloat(TEdit(FindComponent('Taper'
                          + IntToStr(i) + 'FloatEdit')).Text);
      nSegSplits[i]   := strtofloat(TEdit(FindComponent('SegSplits'
                           + IntToStr(i) + 'FloatEdit')).Text);
      nSplitAngle[i]  := strtofloat(TEdit(FindComponent('SplitAngle'
                             + IntToStr(i) + 'FloatEdit')).Text);
      nSplitAngleV[i] := strtofloat(TEdit(FindComponent('SplitAngleV'
                            + IntToStr(i) + 'FloatEdit')).Text);
      nCurveRes[i]    := strtoint(TEdit(FindComponent('CurveRes'
                            + IntToStr(i) + 'NumberEdit')).Text);
      nCurveBack[i]   := strtofloat(TEdit(FindComponent('CurveBack'
                           + IntToStr(i) + 'FloatEdit')).Text);
      nCurve[i]       := strtofloat(TEdit(FindComponent('Curve'
                           + IntToStr(i) + 'FloatEdit')).Text);
      nCurveV[i]      := strtofloat(TEdit(FindComponent('CurveV'
                           + IntToStr(i) + 'FloatEdit')).Text);
      nRotate[i]      := strtofloat(TEdit(FindComponent('Rotate'
                          + IntToStr(i) + 'FloatEdit')).Text);
      nRotateV[i]     := strtofloat(TEdit(FindComponent('RotateV'
                         + IntToStr(i) + 'FloatEdit')).Text);
      nBranches[i]    := strtoint(TEdit(FindComponent('Branches'
                         + IntToStr(i) + 'NumberEdit')).Text);
      nDownAngle[i]   := strtofloat(TEdit(FindComponent('DownAngle'
                           + IntToStr(i) + 'FloatEdit')).Text);
      nDownAngleV[i]  := strtofloat(TEdit(FindComponent('DownAngleV'
                          + IntToStr(i) + 'FloatEdit')).Text);
      nVertices[i]    := strtoint(TEdit(FindComponent('Vertices'
                             + IntToStr(i) + 'NumberEdit')).Text);
      nLeaves[i]       := strtoint(TEdit(FindComponent('Leaves'
                             + IntToStr(i) + 'NumberEdit')).Text);
    end;

    Leaves             := strtoint(LeavesNumberEdit.Text);
    LeafScale          := strtofloat(LeafScaleFloatEdit.Text);
    LeafScaleX         := strtofloat(LeafScaleXFloatEdit.Text);
    LeafAttractionUp       := strtofloat(LeafAttractionUpFloatEdit.Text);
      LeafOffset:=strtofloat(LeafOffsetEdit.Text);
      LeafGrouping:=LeafGroupingCB.ItemIndex;
      FLeafsPer:=strtoint( LeafsPerEdit.Text);
      LeafImageFile:= LeafImageEdit.Text;

      LeafTextureCount:=LeafTextureCB.Items.Count;
      For i:=0 to LeafTextureCount-1 do
      begin
        LeafTextureFile[i]:=LeafTextureCB.Items[i];
        If (not FileExists(GlsDataPath+LeafTextureFile[i]) ) then
        LeafTextureFile[i]:= 'anon_leaf.jpg';
      end;

      LeafShapeCount:=LeafShapeCB.Items.Count;
      For i:=0 to LeafShapeCount-1 do
      begin
        LeafShapeFile[i]:=LeafShapeCB.Items[i];
        LeafShape[i]:= LeafShapeRG.ItemIndex;
        {LeafShapeFile:= LeafShapeEdit.Text;}
        If (not FileExists(GlsDataPath+LeafShapeFile[i])) then
        begin
            LoadLeafShape(GlsDataPath+'anon_leaf.lsf');
            LeafShape[i]:= 0;
        end;
        {Decide Which type of file it really is}
        LeafShape[i] :=0;
      end;


      LeafColor          := LeafColorShape.Brush.Color;
      LeafColorVariation := LeafColorVariationCheckBox.Checked;
      LeafBackColor          := LeafBackColorShape.Brush.Color;
      LeafBackColorVariation := LeafBackColorVariationCheckBox.Checked;
      LeafLocation:=LeafLocationRG.ItemIndex;

      FruitLocation:=FruitLocationRG.ItemIndex;
      Fruits:= strtoint(FruitNumberEdit.Text);
      FruitScale:=strtofloat(FruitScaleFloatEdit.Text);
      FruitScaleX:=strtofloat(FruitScaleXFloatEdit.Text);
      FruitPer := strtoint(FruitPerEdit.Text);
      FruitPattern:=FruitTypeRG.ItemIndex;
      FruitImageFile:= FruitImageEdit.Text;

      FruitTextureCount:=FruitTextureCB.Items.Count;
      For i:=0 to FruitTextureCount-1 do
      begin
        FruitTextureFile[i]:= FruitTextureCB.Items[i];
        If (not FileExists(GlsDataPath+FruitTextureFile[i]) ) then
        FruitTextureFile[i]:= 'anon_fruit.tga';
      end;

      FruitShapeCount:=FruitShapeCB.Items.Count;
      For i:=0 to FruitShapeCount-1 do
      begin
      FruitShapeFile[i]:= FruitShapeCB.Items[i];
      FruitShape[i]:=FruitShapeRG.ItemIndex;
      If (not FileExists(GlsDataPath+FruitShapeFile[i])) then
      begin
        FruitShapeFile[i]:= 'anon_fruit.fsf';
        FruitShape[i]:=0;
        {FruitShapeFile:= '';
        FruitShapeFileEdit.Text:= '';
        FruitTextureFile:= '';
        FruitTextureEdit.Text:= ''; }
      end;
        {Select shape type from file extension}
        FruitShape[i]:=0;
      end;

{Showmessage(inttostr(LeafTextureCount)+' : '+LeafTextureFile[0]+
inttostr(LeafShapeCount)+' : '+LeafShapeFile[0]+ #13#10+
inttostr(FruitTextureCount)+' : '+FruitTextureFile[0]+
inttostr(FruitShapeCount)+FruitShapeFile[0]);}

      FruitColor:=FruitColorShape.Brush.Color;
      FruitColorVariation:= FruitColorVariationCheckBox.Checked;

    PruneRatio         := strtofloat(PruneRatioFloatEdit.Text);
    PruneWidth         := strtofloat(PruneWidthFloatEdit.Text);
    PruneWidthPeak     := strtofloat(PruneWidthPeakFloatEdit.Text);
    PrunePowerLow      := strtofloat(PrunePowerLowFloatEdit.Text);
    PrunePowerHigh     := strtofloat(PrunePowerHighFloatEdit.Text);

    { Adjust the current low level parameters according to
    the high level parameters }
    case SeasonComboBox.ItemIndex of
      0: { Winter }
         begin
         Leaves := 0;
         Fruits:=0;
         end;
      1: { Spring }
         begin
           LeafScale := LeafScale / 2;
           LeafScaleX := LeafScaleX / 2;
           FruitScale :=FruitScale/2;
           FruitScaleX:= FruitScaleX/2;
         end;
    { 2: Summer (no adjustment needed) }
      3: { Autumn ..turn em brown  POV drops them to ground}
         begin
           LeafColor := $2A8AE4;
           LeafColorVariation := True;
           LeafBackColor:= $2A8AE4;
           LeafBackColorVariation := True;
           FruitColorVariation:= True;
           FruitColor:= $2A8AE4;
         end;
    end;
    {This should reduce the number of Leaves iaw Health
    Done in GlsTree now...}
{    Leaves := Leaves - (Leaves * (1 - (101 div (HealthTrackBar.Position + 1))));}
    {Leaves := (Round(Leaves *(HealthTrackBar.Position/100)));
    If (Leaves < 0) then Leaves := 0;}

  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------


//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.SaveTreeDefFileBtnClick(Sender: TObject);
begin
  { Update the amount of stem levels }
  LevelsNumberEditExit(Sender);
  { This procedure is used for all save actions. If the Save As menu item
    was clicked, a standard save dialog will be opened. If either the save
    speedbutton or the Save menu item was clicked the file will be saved
    immediately, unless the TreeDefFileNameEdit doesn't contain a filename. }

  if TMenuItem(Sender).Name = 'DefinitionSaveAs1' then
  begin
    SaveTdfDialog.InitialDir:= GlsTdfPath;
    SaveTdfDialog.FileName:=TreeDefFileNameEdit.Text;
    if SaveTdfDialog.Execute then
    begin
      Application.ProcessMessages;
      SaveTreeDefinition(SaveTdfDialog.FileName);
      TreeDefFileNameEdit.Text := ExtractFileName(SaveTdfDialog.FileName);
    end;
  end
  else
  begin
    if TreeDefFileNameEdit.Text = '' then
    begin
      SaveTdfDialog.InitialDir:= GlsTdfPath;
      if SaveTdfDialog.Execute then
      begin
        Application.ProcessMessages;
        SaveTreeDefinition(SaveTdfDialog.FileName);
        TreeDefFileNameEdit.Text := ExtractFileName(SaveTdfDialog.FileName);
      end;
    end
    else
    begin     {Cannot overwrite .trd always saves as Version 0.2}
      SaveTreeDefinition(GlsTdfPath+ChangeFileExt(TreeDefFileNameEdit.Text,'.tdf'));
    end;
  end;
end;



procedure TdtmGlsTrealForm.SaveTreeDefinition(FileName: string);
{ Pre: True
  Post: The current model parameters have been saved to FileName. }
var f: TextFile;
i:integer;
begin
  LevelsNumberEditExit(nil);
  try
    AssignFile(f, FileName);
    Rewrite(f);
    try
      { Write the header }
      Writeln(f, 'Tree Definition File V '+TREAL_VERSION+', generated on '
      + DateToStr(Date) + ' by GLS TReal');
      Writeln(f, TREAL_VERSION);
      Writeln(f, IntToStr(LeafTextureCB.Items.Count));
      Writeln(f, IntToStr(LeafShapeCB.Items.Count)); {LeafShapeCount}
      Writeln(f, IntToStr(FruitTextureCB.Items.Count)); {FruitTextureCount}
      Writeln(f, IntToStr(FruitShapeCB.Items.Count)); {FruitShapeCount}
      Writeln(f, IntToStr(ShapeComboBox.ItemIndex));
      Writeln(f, LevelsNumberEdit.Text);
        Writeln(f, IntToStr(SeasonComboBox.ItemIndex));
        Writeln(f, RandomTreeSeedNumberEdit.Text);
        Writeln(f, IntToStr(HealthTrackBar.Position));
        Writeln(f, AttractionUpFloatEdit.Text);
        Writeln(f, IntToStr(DeathTollRG.ItemIndex));

        Writeln(f, IntToStr(DistanceTrackBar.Position));
        Writeln(f, IntToStr(WindStrengthTB.Position));
        Writeln(f, IntToStr(WindGustTB.Position));
        Writeln(f, IntToStr(WindFromTB.Position));
        Writeln(f, IntToStr(SunHeightTB.Position));
        Writeln(f, IntToStr(SunStrengthTB.Position));
        Writeln(f, IntToStr(SunFromTB.Position));

        Writeln(f, TreeImageEdit.Text);
        Writeln(f, TreeShapeEdit.Text);
        Writeln(f, TreeSpriteEdit.Text);
        Writeln(f, ScaleFloatEdit.Text);
        Writeln(f, ScaleVFloatEdit.Text);
        Writeln(f, Length0FloatEdit.Text);
        Writeln(f, LengthV0FloatEdit.Text);

        Writeln(f, RatioFloatEdit.Text);
        Writeln(f, RatioPowerFloatEdit.Text);
        Writeln(f, Scale0FloatEdit.Text);
        Writeln(f, ScaleV0FloatEdit.Text);

        Writeln(f, LobesNumberEdit.Text);
        Writeln(f, LobeDepthFloatEdit.Text);
        Writeln(f, LobeScaleFloatEdit.Text);
        Writeln(f, LobeScaleVFloatEdit.Text);

        Writeln(f, TreeBarkEdit.Text);
        Writeln(f, IntToStr(TreeColorShape.Brush.Color));
        if TreeColorVariationCheckBox.Checked then Writeln(f, 'true')
           else Writeln(f, 'false');

        Writeln(f, BaseSplits0NumberEdit.Text);
        Writeln(f, BaseSizeFloatEdit.Text);
        Writeln(f, ZScaleFloatEdit.Text);
        Writeln(f, ZScaleVFloatEdit.Text);
        
        Writeln(f, BoleSplits0NumberEdit.Text);
        Writeln(f, BoleSizeFloatEdit.Text);
        Writeln(f, FlareFloatEdit.Text);
        Writeln(f, FlareVFloatEdit.Text);

        Writeln(f, Vertices0NumberEdit.Text);
        Writeln(f, 0);
        Writeln(f, Leaves0NumberEdit.Text);
        Writeln(f, Taper0FloatEdit.Text);

        Writeln(f, DownAngle0FloatEdit.Text);
        Writeln(f, DownAngleV0FloatEdit.Text);
        Writeln(f, Rotate0FloatEdit.Text);
        Writeln(f, RotateV0FloatEdit.Text);

        Writeln(f, CurveRes0NumberEdit.Text);
        Writeln(f, CurveV0FloatEdit.Text);
        Writeln(f, Curve0FloatEdit.Text);
        Writeln(f, CurveBack0FloatEdit.Text);

        Writeln(f, SegSplits0FloatEdit.Text);
        Writeln(f, SplitAngle0FloatEdit.Text);
        Writeln(f, SplitAngleV0FloatEdit.Text);

      { LevelsNumberEdit.GetValue - 2 is used in the following loop, since the
        last recursion level is the leaf level. So we have in fact
        LevelsNumberEdit.GetValue - 1 stem parameter tabs. }
        {Trunk0 1,2,3,4,5... Leaf 6 = 7 levels}
        If GlobalLevelsNumber > 1 then
        begin  {Trunk0 1,... Leaf x = 3 levels}
        Writeln(f, Branches1NumberEdit.Text);
        Writeln(f, Vertices1NumberEdit.Text);
        Writeln(f, CurveRes1NumberEdit.Text);
        end;
        If GlobalLevelsNumber > 2 then
        begin  {Trunk0 1,2... Leaf x = 4 levels}
        Writeln(f, Branches2NumberEdit.Text);
        Writeln(f, Vertices2NumberEdit.Text);
        Writeln(f, CurveRes2NumberEdit.Text);
        end;
        If GlobalLevelsNumber > 3 then
        begin   {Trunk0 1,2,3... Leaf x = 5 levels}
        Writeln(f, Branches3NumberEdit.Text);
        Writeln(f, Vertices3NumberEdit.Text);
        Writeln(f, CurveRes3NumberEdit.Text);
        end;
        If GlobalLevelsNumber > 4 then
        begin   {Trunk0 1,2,3,4... Leaf x = 6 levels}
        Writeln(f, Branches4NumberEdit.Text);
        Writeln(f, Vertices4NumberEdit.Text);
        Writeln(f, CurveRes4NumberEdit.Text);
        end;
        If GlobalLevelsNumber > 5 then
        begin   {Trunk0 1,2,3,4,5... Leaf x = 7 levels}
        Writeln(f, Branches5NumberEdit.Text);
        Writeln(f, Vertices5NumberEdit.Text);
        Writeln(f, CurveRes5NumberEdit.Text);
        end;
        If GlobalLevelsNumber > 6 then
        begin   {Trunk0 1,2,3,4,5... Leaf x = 7 levels}
        Writeln(f, Branches6NumberEdit.Text);
        Writeln(f, Vertices6NumberEdit.Text);
        Writeln(f, CurveRes6NumberEdit.Text);
        end;
      { Save the values belonging to all float edit input components
        belonging to the stem parameters }

      { LevelsNumberEdit.GetValue - 2 is used in the following loop, since the
        last recursion level is the leaf level. So we have in fact
        LevelsNumberEdit.GetValue - 1 stem parameter tabs. }
        If GlobalLevelsNumber > 1 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Writeln(f, Length1FloatEdit.Text);
        Writeln(f, LengthV1FloatEdit.Text);
        Writeln(f, Taper1FloatEdit.Text);
        Writeln(f, DownAngle1FloatEdit.Text);
        Writeln(f, DownAngleV1FloatEdit.Text);
        Writeln(f, Rotate1FloatEdit.Text);
        Writeln(f, RotateV1FloatEdit.Text);
        Writeln(f, CurveBack1FloatEdit.Text);
        Writeln(f, Curve1FloatEdit.Text);
        Writeln(f, CurveV1FloatEdit.Text);
        Writeln(f, SplitAngle1FloatEdit.Text);
        Writeln(f, SplitAngleV1FloatEdit.Text);
        Writeln(f, SegSplits1FloatEdit.Text);{Yes out of order}
        Writeln(f, Leaves1NumberEdit.Text);
        End;
        If GlobalLevelsNumber > 2 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Writeln(f, Length2FloatEdit.Text);
        Writeln(f, LengthV2FloatEdit.Text);
        Writeln(f, Taper2FloatEdit.Text);
        Writeln(f, DownAngle2FloatEdit.Text);
        Writeln(f, DownAngleV2FloatEdit.Text);
        Writeln(f, Rotate2FloatEdit.Text);
        Writeln(f, RotateV2FloatEdit.Text);
        Writeln(f, CurveBack2FloatEdit.Text);
        Writeln(f, Curve2FloatEdit.Text);
        Writeln(f, CurveV2FloatEdit.Text);
        Writeln(f, SplitAngle2FloatEdit.Text);
        Writeln(f, SplitAngleV2FloatEdit.Text);
        Writeln(f, SegSplits2FloatEdit.Text);{Yes out of order}
        Writeln(f, Leaves2NumberEdit.Text);
        End;
        If GlobalLevelsNumber > 3 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Writeln(f, Length3FloatEdit.Text);
        Writeln(f, LengthV3FloatEdit.Text);
        Writeln(f, Taper3FloatEdit.Text);
        Writeln(f, DownAngle3FloatEdit.Text);
        Writeln(f, DownAngleV3FloatEdit.Text);
        Writeln(f, Rotate3FloatEdit.Text);
        Writeln(f, RotateV3FloatEdit.Text);
        Writeln(f, CurveBack3FloatEdit.Text);
        Writeln(f, Curve3FloatEdit.Text);
        Writeln(f, CurveV3FloatEdit.Text);
        Writeln(f, SplitAngle3FloatEdit.Text);
        Writeln(f, SplitAngleV3FloatEdit.Text);
        Writeln(f, SegSplits3FloatEdit.Text);{Yes out of order}
        Writeln(f, Leaves3NumberEdit.Text);
        End;
        If GlobalLevelsNumber > 4 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Writeln(f, Length4FloatEdit.Text);
        Writeln(f, LengthV4FloatEdit.Text);
        Writeln(f, Taper4FloatEdit.Text);
        Writeln(f, DownAngle4FloatEdit.Text);
        Writeln(f, DownAngleV4FloatEdit.Text);
        Writeln(f, Rotate4FloatEdit.Text);
        Writeln(f, RotateV4FloatEdit.Text);
        Writeln(f, CurveBack4FloatEdit.Text);
        Writeln(f, Curve4FloatEdit.Text);
        Writeln(f, CurveV4FloatEdit.Text);
        Writeln(f, SplitAngle4FloatEdit.Text);
        Writeln(f, SplitAngleV4FloatEdit.Text);
        Writeln(f, SegSplits4FloatEdit.Text);{Yes out of order}
        Writeln(f, Leaves4NumberEdit.Text);
        End;
        If GlobalLevelsNumber > 5 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Writeln(f, Length5FloatEdit.Text);
        Writeln(f, LengthV5FloatEdit.Text);
        Writeln(f, Taper5FloatEdit.Text);
        Writeln(f, DownAngle5FloatEdit.Text);
        Writeln(f, DownAngleV5FloatEdit.Text);
        Writeln(f, Rotate5FloatEdit.Text);
        Writeln(f, RotateV5FloatEdit.Text);
        Writeln(f, CurveBack5FloatEdit.Text);
        Writeln(f, Curve5FloatEdit.Text);
        Writeln(f, CurveV5FloatEdit.Text);
        Writeln(f, SplitAngle5FloatEdit.Text);
        Writeln(f, SplitAngleV5FloatEdit.Text);
        Writeln(f, SegSplits5FloatEdit.Text);{Yes out of order}
        Writeln(f, Leaves5NumberEdit.Text);
        End;
        If GlobalLevelsNumber > 6 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Writeln(f, Length6FloatEdit.Text);
        Writeln(f, LengthV6FloatEdit.Text);
        Writeln(f, Taper6FloatEdit.Text);
        Writeln(f, DownAngle6FloatEdit.Text);
        Writeln(f, DownAngleV6FloatEdit.Text);
        Writeln(f, Rotate6FloatEdit.Text);
        Writeln(f, RotateV6FloatEdit.Text);
        Writeln(f, CurveBack6FloatEdit.Text);
        Writeln(f, Curve6FloatEdit.Text);
        Writeln(f, CurveV6FloatEdit.Text);
        Writeln(f, SplitAngle6FloatEdit.Text);
        Writeln(f, SplitAngleV6FloatEdit.Text);
        Writeln(f, SegSplits6FloatEdit.Text);{Yes out of order}
        Writeln(f, Leaves6NumberEdit.Text);
        End;

        Writeln(f, LeavesNumberEdit.Text);
        Writeln(f, LeafScaleFloatEdit.Text);
        Writeln(f, LeafScaleXFloatEdit.Text);
        Writeln(f, LeafAttractionUpFloatEdit.Text);
        Writeln(f, LeafOffsetEdit.Text);
        Writeln(f, IntToStr(LeafGroupingCB.ItemIndex));
        Writeln(f, LeafsPerEdit.Text);
        Writeln(f, LeafImageEdit.Text);
        For i:=  0 to LeafShapeCB.Items.Count-1 do
        begin
          Writeln(f, LeafShapeCB.Items[i]);
          {Writeln(f, LeafShapeEdit.Text);}
          Writeln(f, IntToStr(LeafShapeRG.ItemIndex));
        end;
        For i:=  0 to LeafTextureCB.Items.Count-1 do
            Writeln(f, LeafTextureCB.Items[i]);
        Writeln(f, IntToStr(LeafColorShape.Brush.Color));
        if LeafColorVariationCheckBox.Checked then Writeln(f, 'true')
           else Writeln(f, 'false');
        Writeln(f, IntToStr(LeafBackColorShape.Brush.Color));
        if LeafBackColorVariationCheckBox.Checked then Writeln(f, 'true')
           else Writeln(f, 'false');
        Writeln(f, IntToStr(LeafLocationRG.ItemIndex));


        Writeln(f, IntToStr(FruitLocationRG.ItemIndex));
        Writeln(f, FruitNumberEdit.Text);
        Writeln(f, FruitScaleFloatEdit.Text);
        Writeln(f, FruitScaleXFloatEdit.Text);
        Writeln(f, FruitPerEdit.Text);
        Writeln(f, IntToStr(FruitTypeRG.ItemIndex));
        Writeln(f, FruitImageEdit.Text);
        For i:=  0 to FruitShapeCB.Items.Count-1 do
        begin
          Writeln(f, FruitShapeCB.Items[i]);
          {Writeln(f, FruitShapeFileEdit.Text);}
          Writeln(f, IntToStr(FruitShapeRG.ItemIndex));
        end;
        For i:=  0 to FruitTextureCB.Items.Count-1 do
            Writeln(f, FruitTextureCB.Items[i]);
        {Writeln(f, FruitTextureEdit.Text); }
        Writeln(f, IntToStr(FruitColorShape.Brush.Color));
        if FruitColorVariationCheckBox.Checked then Writeln(f, 'true')
           else Writeln(f, 'false');


        Writeln(f, PruneRatioFloatEdit.Text);
        Writeln(f, PruneWidthFloatEdit.Text);
        Writeln(f, PruneWidthPeakFloatEdit.Text);
        Writeln(f, PrunePowerLowFloatEdit.Text);
        Writeln(f, PrunePowerHighFloatEdit.Text);
    except
      { On known exceptions show an error message. }
      on EConvertError do MessageDlg(FileName +
       ' is not a valid tree definition file!', mtError, [mbOK], 0);
      on EInOutError do MessageDlg('Error while writing ' + FileName + '!',
      mtError, [mbOK], 0);

    else
      { Show a general error message }
      MessageDlg('Unknow error while writing ' + FileName + '!',
       mtError, [mbOK], 0);
     end;
  finally
    CloseFile(f);
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------

//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.LoadTreeSpriteBtnClick(Sender: TObject);
begin
  OpenPictureDialog1.Initialdir:=GlsDataPath;
  if OpenPictureDialog1.Execute then
  begin
    TreeSpriteEdit.Text:= Extractfilename(OpenPictureDialog1.FileName);
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.OpenTreeDefFileBtnClick(Sender: TObject);
begin      {tree definitions}
  OpenTdfDialog.Initialdir:=GlsTdfPath;
   if OpenTdfDialog.Execute then
  begin
  Application.ProcessMessages;
  ClearFileData;
  TreeDefFileNameEdit.Text := ExtractFileName(OpenTdfDialog.FileName);
  LoadTreeDefinition(OpenTdfDialog.FileName);
  end;
end;

procedure TdtmGlsTrealForm.LoadTreeDefinition(FileName: string);
{ Pre: FileName should point to an existing file.
  Post: The current model parameters have been set to the model parameters
        loaded from the tree definition file FileName. }
var f: TextFile;
    Version,
    LeafTextureCounter, LeafShapeCounter,
    FruitTextureCounter, FruitShapeCounter,
    i: integer;
    s:String;
  function GetNextValue: string;
  { Pre: f is assigned to a valid tree definition file.
    Ret: The next model parameter value read from f. }
  var Dummy: string;
  begin
    Readln(f, Dummy);
    Result := Dummy;
  end;
begin
  try
    AssignFile(f, FileName);
    Reset(f);
    Readln(f,s);   {Header}
    { Check the header, 2nd line of text is version for changes}
    If Pos('GLS TReal',s)=0 then
    begin
      Showmessage('Not a GLS TReal tdf file');
      Exit;
    end;
    {Header Version... later can be used for changes at end of file...}
    Version:=Round(strtofloat(GetNextValue)*100);
    If (Version<21) then
    begin
      showmessage('Not a current tdf file');
      Exit;
    end;
    try
      { Update the tree definition filename edit box }
      TreeDefFileNameEdit.Text := ExtractFileName(FileName);
{    LeafTextureCounter, LeafShapeCounter,
    FruitTextureCounter, FruitShapeCounter,}
{#3}  LeafTextureCounter:= Strtoint(GetNextValue);
      LeafShapeCounter:= Strtoint(GetNextValue);
      FruitTextureCounter:= Strtoint(GetNextValue);
      FruitShapeCounter:= Strtoint(GetNextValue);
      ShapeComboBox.ItemIndex:=StrToInt(GetNextValue);
        {LeafKeeper:=StrToInt(GetNextValue);
        LeafShapeComboBox.ItemIndex:=LeafKeeper;}
        { Load the values belonging to all number edit input components }
      LevelsNumberEdit.Text:= GetNextValue;
      GlobalLevelsNumber:=strtoint(LevelsNumberEdit.Text);
        {Levels := CurrentLevelsNumber;}
      LevelsNumberEditExit(nil);

      SeasonComboBox.ItemIndex:=Strtoint(GetNextValue);
      RandomTreeSeedNumberEdit.Text:= GetNextValue;
      HealthTrackBar.Position:=Strtoint(GetNextValue);
      AttractionUpFloatEdit.Text:= GetNextValue;
      DeathTollRG.ItemIndex:=Strtoint(GetNextValue);

      DistanceTrackBar.Position:=Strtoint(GetNextValue);
      WindStrengthTB.Position:=Strtoint(GetNextValue);
      WindGustTB.Position:=Strtoint(GetNextValue);
      WindFromTB.Position:=Strtoint(GetNextValue);
      SunHeightTB.Position:=Strtoint(GetNextValue);
      SunStrengthTB.Position:=Strtoint(GetNextValue);
      SunFromTB.Position:=Strtoint(GetNextValue);

      TreeImageEdit.Text:= GetNextValue;
      TreeShapeEdit.Text:= GetNextValue;
      TreeSpriteEdit.Text:= GetNextValue;
        ScaleFloatEdit.Text:= GetNextValue;
        ScaleVFloatEdit.Text:= GetNextValue;
        Length0FloatEdit.Text:= GetNextValue;
        LengthV0FloatEdit.Text:= GetNextValue;

        RatioFloatEdit.Text:= GetNextValue;
        RatioPowerFloatEdit.Text:= GetNextValue;
        Scale0FloatEdit.Text:= GetNextValue;
        ScaleV0FloatEdit.Text:= GetNextValue;

        LobesNumberEdit.Text:= GetNextValue;
        LobeDepthFloatEdit.Text:= GetNextValue;
        LobeScaleFloatEdit.Text:= GetNextValue;
        LobeScaleVFloatEdit.Text:= GetNextValue;

      TreeBarkEdit.Text:= GetNextValue;
       TreeColorShape.Brush.Color:=Strtoint(GetNextValue);
        if  'true'= GetNextValue then
        TreeColorVariationCheckBox.Checked:=True else
        TreeColorVariationCheckBox.Checked:=False;

        BaseSplits0NumberEdit.Text:= GetNextValue;
        BaseSizeFloatEdit.Text:= GetNextValue;
        ZScaleFloatEdit.Text:= GetNextValue;
        ZScaleVFloatEdit.Text:= GetNextValue;

        BoleSplits0NumberEdit.Text:= GetNextValue;
        BoleSizeFloatEdit.Text:= GetNextValue;
        FlareFloatEdit.Text:= GetNextValue;
        FlareVFloatEdit.Text:= GetNextValue;

        Vertices0NumberEdit.Text:= GetNextValue;
        Readln(f,s);{}
        Leaves0NumberEdit.Text:= GetNextValue;
        Taper0FloatEdit.Text:= GetNextValue;

        DownAngle0FloatEdit.Text:= GetNextValue;
        DownAngleV0FloatEdit.Text:= GetNextValue;
        Rotate0FloatEdit.Text:= GetNextValue;
        RotateV0FloatEdit.Text:= GetNextValue;

        CurveRes0NumberEdit.Text:= GetNextValue;
        CurveV0FloatEdit.Text:= GetNextValue;
        Curve0FloatEdit.Text:= GetNextValue;
        CurveBack0FloatEdit.Text:= GetNextValue;

        SegSplits0FloatEdit.Text:= GetNextValue;
        SplitAngle0FloatEdit.Text:= GetNextValue;
        SplitAngleV0FloatEdit.Text:= GetNextValue;

      { Save the values belonging to all number edit input components
        belonging to the stem parameters }
        LevelsNumberEditExit(nil);
      { LevelsNumberEdit.GetValue - 2 is used in the following loop, since the
        last recursion level is the leaf level. So we have in fact
        LevelsNumberEdit.GetValue - 1 stem parameter tabs. }
        {Trunk0 1,2,3,4,5... Leaf 6 = 7 levels}
        If GlobalLevelsNumber > 1 then
        begin  {Trunk0 1,... Leaf x = 3 levels}
        Branches1NumberEdit.Text:= GetNextValue;
        Vertices1NumberEdit.Text:= GetNextValue;
        CurveRes1NumberEdit.Text:= GetNextValue;
        end;
        If GlobalLevelsNumber > 2 then
        begin  {Trunk0 1,2... Leaf x = 4 levels}
        Branches2NumberEdit.Text:= GetNextValue;
        Vertices2NumberEdit.Text:= GetNextValue;
         CurveRes2NumberEdit.Text:= GetNextValue;
        end;
        If GlobalLevelsNumber > 3 then
        begin   {Trunk0 1,2,3... Leaf x = 5 levels}
        Branches3NumberEdit.Text:= GetNextValue;
        Vertices3NumberEdit.Text:= GetNextValue;
        CurveRes3NumberEdit.Text:= GetNextValue;
        end;
        If GlobalLevelsNumber > 4 then
        begin   {Trunk0 1,2,3,4... Leaf x = 6 levels}
        Branches4NumberEdit.Text:= GetNextValue;
        Vertices4NumberEdit.Text:= GetNextValue;
        CurveRes4NumberEdit.Text:= GetNextValue;
        end;
        If GlobalLevelsNumber > 5 then
        begin   {Trunk0 1,2,3,4,5... Leaf x = 7 levels}
        Branches5NumberEdit.Text:= GetNextValue;
        Vertices5NumberEdit.Text:= GetNextValue;
        CurveRes5NumberEdit.Text:= GetNextValue;
        end;
        If GlobalLevelsNumber > 6 then
        begin   {Trunk0 1,2,3,4,5... Leaf x = 7 levels}
        Branches6NumberEdit.Text:= GetNextValue;
        Vertices6NumberEdit.Text:= GetNextValue;
        CurveRes6NumberEdit.Text:= GetNextValue;
        end;
      { Save the values belonging to all float edit input components
        belonging to the stem parameters }

      { LevelsNumberEdit.GetValue - 2 is used in the following loop, since the
        last recursion level is the leaf level. So we have in fact
        LevelsNumberEdit.GetValue - 1 stem parameter tabs. }
        If GlobalLevelsNumber > 1 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Length1FloatEdit.Text:= GetNextValue;
        LengthV1FloatEdit.Text:= GetNextValue;
        Taper1FloatEdit.Text:= GetNextValue;
        DownAngle1FloatEdit.Text:= GetNextValue;
        DownAngleV1FloatEdit.Text:= GetNextValue;
        Rotate1FloatEdit.Text:= GetNextValue;
        RotateV1FloatEdit.Text:= GetNextValue;
        CurveBack1FloatEdit.Text:= GetNextValue;
        Curve1FloatEdit.Text:= GetNextValue;
        CurveV1FloatEdit.Text:= GetNextValue;
        SplitAngle1FloatEdit.Text:= GetNextValue;
        SplitAngleV1FloatEdit.Text:= GetNextValue;
        SegSplits1FloatEdit.Text:= GetNextValue;{Yes out of order}
        Leaves1NumberEdit.Text:= GetNextValue;
        End;
        If GlobalLevelsNumber > 2 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Length2FloatEdit.Text:= GetNextValue;
        LengthV2FloatEdit.Text:= GetNextValue;
        Taper2FloatEdit.Text:= GetNextValue;
        DownAngle2FloatEdit.Text:= GetNextValue;
        DownAngleV2FloatEdit.Text:= GetNextValue;
        Rotate2FloatEdit.Text:= GetNextValue;
        RotateV2FloatEdit.Text:= GetNextValue;
        CurveBack2FloatEdit.Text:= GetNextValue;
        Curve2FloatEdit.Text:= GetNextValue;
        CurveV2FloatEdit.Text:= GetNextValue;
        SplitAngle2FloatEdit.Text:= GetNextValue;
        SplitAngleV2FloatEdit.Text:= GetNextValue;
        SegSplits2FloatEdit.Text:= GetNextValue;{Yes out of order}
        Leaves2NumberEdit.Text:= GetNextValue;
        End;
        If GlobalLevelsNumber > 3 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Length3FloatEdit.Text:= GetNextValue;
        LengthV3FloatEdit.Text:= GetNextValue;
        Taper3FloatEdit.Text:= GetNextValue;
        DownAngle3FloatEdit.Text:= GetNextValue;
        DownAngleV3FloatEdit.Text:= GetNextValue;
        Rotate3FloatEdit.Text:= GetNextValue;
        RotateV3FloatEdit.Text:= GetNextValue;
        CurveBack3FloatEdit.Text:= GetNextValue;
        Curve3FloatEdit.Text:= GetNextValue;
        CurveV3FloatEdit.Text:= GetNextValue;
        SplitAngle3FloatEdit.Text:= GetNextValue;
        SplitAngleV3FloatEdit.Text:= GetNextValue;
        SegSplits3FloatEdit.Text:= GetNextValue;{Yes out of order}
        Leaves3NumberEdit.Text:= GetNextValue;
        End;
        If GlobalLevelsNumber > 4 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Length4FloatEdit.Text:= GetNextValue;
        LengthV4FloatEdit.Text:= GetNextValue;
        Taper4FloatEdit.Text:= GetNextValue;
        DownAngle4FloatEdit.Text:= GetNextValue;
        DownAngleV4FloatEdit.Text:= GetNextValue;
        Rotate4FloatEdit.Text:= GetNextValue;
        RotateV4FloatEdit.Text:= GetNextValue;
        CurveBack4FloatEdit.Text:= GetNextValue;
        Curve4FloatEdit.Text:= GetNextValue;
        CurveV4FloatEdit.Text:= GetNextValue;
        SplitAngle4FloatEdit.Text:= GetNextValue;
         SplitAngleV4FloatEdit.Text:= GetNextValue;
        SegSplits4FloatEdit.Text:= GetNextValue;{Yes out of order}
        Leaves4NumberEdit.Text:= GetNextValue;
        End;
        If GlobalLevelsNumber > 5 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Length5FloatEdit.Text:= GetNextValue;
        LengthV5FloatEdit.Text:= GetNextValue;
        Taper5FloatEdit.Text:= GetNextValue;
        DownAngle5FloatEdit.Text:= GetNextValue;
        DownAngleV5FloatEdit.Text:= GetNextValue;
         Rotate5FloatEdit.Text:= GetNextValue;
        RotateV5FloatEdit.Text:= GetNextValue;
        CurveBack5FloatEdit.Text:= GetNextValue;
        Curve5FloatEdit.Text:= GetNextValue;
        CurveV5FloatEdit.Text:= GetNextValue;
        SplitAngle5FloatEdit.Text:= GetNextValue;
        SplitAngleV5FloatEdit.Text:= GetNextValue;
        SegSplits5FloatEdit.Text:= GetNextValue;{Yes out of order}
        Leaves5NumberEdit.Text:= GetNextValue;
        End;
        If GlobalLevelsNumber > 6 then
        begin  {Trunk0 1,... Leaf x = 3 levels  7}
        Length6FloatEdit.Text:= GetNextValue;
        LengthV6FloatEdit.Text:= GetNextValue;
        Taper6FloatEdit.Text:= GetNextValue;
        DownAngle6FloatEdit.Text:= GetNextValue;
        DownAngleV6FloatEdit.Text:= GetNextValue;
         Rotate6FloatEdit.Text:= GetNextValue;
        RotateV6FloatEdit.Text:= GetNextValue;
        CurveBack6FloatEdit.Text:= GetNextValue;
        Curve6FloatEdit.Text:= GetNextValue;
        CurveV6FloatEdit.Text:= GetNextValue;
        SplitAngle6FloatEdit.Text:= GetNextValue;
        SplitAngleV6FloatEdit.Text:= GetNextValue;
        SegSplits6FloatEdit.Text:= GetNextValue;{Yes out of order}
        Leaves6NumberEdit.Text:= GetNextValue;
        End;

        LeavesNumberEdit.Text:= GetNextValue;
        LeafScaleFloatEdit.Text:= GetNextValue;
        LeafScaleXFloatEdit.Text:= GetNextValue;
        LeafAttractionUpFloatEdit.Text:= GetNextValue;
        LeafOffsetEdit.Text:= GetNextValue;
      LeafGroupingCB.ItemIndex:=Strtoint(GetNextValue);
      LeafsPerEdit.Text:= GetNextValue;
      LeafImageEdit.Text:= GetNextValue;
{    LeafTextureCounter, LeafShapeCounter,
    FruitTextureCounter, FruitShapeCounter,}

      LeafShapeCB.Items.Clear;
      {SetLength(LeafShapeType,LeafShapeCounter+1); }
      For i:=0 to LeafShapeCounter -1 do
      begin
        LeafShapeCB.Items.add( GetNextValue);
        {LeafShapeEdit.Text:= GetNextValue;}
        {LeafShapeType[i]:= Strtoint(GetNextValue);}{File Type}
        LeafShapeRG.ItemIndex:= Strtoint(GetNextValue);{ LeafShapeType[i];}
      If FileExists(GlsDataPath+LeafShapeCB.Items[i]) then
      begin
        LoadLeafShape(GlsDataPath+LeafShapeCB.Items[i]);
        {Redone here to REINSTATE the data values}
        {LeafShapeComboBox.ItemIndex:=LeafKeeper;}
      end
      else
      begin
        If FileExists(GlsDataPath+'anon_leaf.lsf') then
        begin
        LoadLeafShape(GlsDataPath+'anon_leaf.lsf');
        LeafShapeCB.Items[i]:='anon_leaf.lsf';
        end
        else
        begin
          Showmessage(GlsDataPath+'anon_leaf.lsf NOT found');
          Application.Terminate;
        end;
      end;
      end;
      LeafShapeCB.ItemIndex:= 0;

        LeafTextureCB.Items.Clear;
      For i:=0 to LeafTextureCounter -1 do
      begin
            LeafTextureCB.Items.add( GetNextValue);
        If (not FileExists(GlsDataPath+LeafTextureCB.Items[i]))then
        LeafTextureCB.Items[i]:= 'anon_leaf.jpg';
      end;
      LeafTextureCB.ItemIndex:= 0;

       LeafColorShape.Brush.Color:=Strtoint(GetNextValue);
        if  'true'= GetNextValue then
        LeafColorVariationCheckBox.Checked:=True else
        LeafColorVariationCheckBox.Checked:=False;

       LeafBackColorShape.Brush.Color:=Strtoint(GetNextValue);
        if  'true'= GetNextValue then
        LeafBackColorVariationCheckBox.Checked:=True else
        LeafBackColorVariationCheckBox.Checked:=False;
      LeafLocationRG.ItemIndex:=Strtoint(GetNextValue);


      FruitLocationRG.ItemIndex:=Strtoint(GetNextValue);
      FruitNumberEdit.Text:= GetNextValue;
      FruitScaleFloatEdit.Text:= GetNextValue;
      FruitScaleXFloatEdit.Text:= GetNextValue;
      FruitPerEdit.Text:= GetNextValue;
      FruitTypeRG.ItemIndex:=Strtoint(GetNextValue);
      FruitImageEdit.Text:= GetNextValue;

      FruitShapeCB.Items.Clear;
      {SetLength(FruitShapeType,FruitShapeCounter+1);}
      For i:=0 to FruitShapeCounter -1 do
      begin
        FruitShapeCB.Items.add( GetNextValue);
      {FruitShapeFileEdit.Text:= GetNextValue;
      FruitShapeRG.ItemIndex:=Strtoint(GetNextValue); }
        {FruitShapeType[i]:= Strtoint(GetNextValue);}{File Type}
        FruitShapeRG.ItemIndex:=Strtoint(GetNextValue);{ FruitShapeType[i];}
      If FileExists(GlsDataPath+FruitShapeCB.Items[i]) then
      LoadFruitShape(GlsDataPath+FruitShapeCB.Items[i]) else
      begin
        If FileExists(GlsDataPath+'anon_fruit.fsf') then
        begin
          FruitShapeCB.Items[i]:= 'anon_fruit.fsf';
        end
        else
        begin
          Showmessage(GlsDataPath+'anon_fruit.fsf NOT found');
          Application.Terminate;
        end;
      {FruitShapeFile[i]:= 'anon_fruit.fsf';}
      {FruitShapeFileEdit.Text:='';
      FruitTextureEdit.Text:='';}
      end;
       end;
      FruitShapeCB.ItemIndex:= 0;
      {FruitTextureEdit.Text:= GetNextValue;}
        FruitTextureCB.Items.Clear;
      For i:=0 to FruitTextureCounter -1 do
      begin
            FruitTextureCB.Items.add( GetNextValue);
        If (not FileExists(GlsDataPath+FruitTextureCB.Items[i]))then
        FruitTextureCB.Items[i]:= 'anon_fruit.tga';
      end;
      FruitTextureCB.ItemIndex:= 0;

      FruitColorShape.Brush.Color:=Strtoint(GetNextValue);
      if  'true'= GetNextValue then
        FruitColorVariationCheckBox.Checked:=True else
        FruitColorVariationCheckBox.Checked:=False;

        PruneRatioFloatEdit.Text:= GetNextValue;
        PruneWidthFloatEdit.Text:= GetNextValue;
        PruneWidthPeakFloatEdit.Text:= GetNextValue;
        PrunePowerLowFloatEdit.Text:= GetNextValue;
        PrunePowerHighFloatEdit.Text:= GetNextValue;
    except
      { On known exceptions show an error message. }
      on EConvertError do MessageDlg(FileName +
      ' is not a valid tree definition file!', mtError, [mbOK], 0);
      on EInOutError do MessageDlg('Error while reading ' + FileName + '!',
       mtError, [mbOK], 0);
    else
      { Show a general error message }
      MessageDlg('Unknown error while reading ' + FileName + '!',
       mtError, [mbOK], 0);
    end;
  finally
    CloseFile(f);
  end;
end;

//-----------------------------------------------------
procedure TdtmGlsTrealForm.LeafShapeCBChange(Sender: TObject);
begin
  LeafShapeRG.ItemIndex:= LeafShapeType[LeafShapeCB.ItemIndex];
end;
//-----------------------------------------------------

procedure TdtmGlsTrealForm.SetupPrinterBtnClick(Sender: TObject);
begin
  PrinterSetupDialog.Execute;
end;
procedure TdtmGlsTrealForm.SaveAnnoDefinitionBtnClick(Sender: TObject);
begin
  SaveOrPrint(0);
end;
procedure TdtmGlsTrealForm.PrintTreeDefFileBtnClick(Sender: TObject);
begin
  SaveOrPrint(1);
end;
procedure TdtmGlsTrealForm.SaveOrPrint(Switch:Integer);
var
  s:String;
    LeafTextureCounter, LeafShapeCounter,
    FruitTextureCounter, FruitShapeCounter,
  i,RunningCount:Integer;
begin
  If FileExists(GlsTdfPath+TreeDefFileNameEdit.Text) then
  begin
    If Switch=0 then  RichEdit1.PlainText := True;
    Application.ProcessMessages;
    RichEdit1.Clear;
    {Load info to hidden RichEdit and print IT}
    RichEdit1.Lines.LoadfromFile(GlsTdfPath+TreeDefFileNameEdit.Text);
    RichEdit1.Lines.Insert(0,'');{Add Title}
    RichEdit1.Lines.Insert(0,TreeDefFileNameEdit.Text);
    {Put 3 blank lines at TOP to move down}
    RichEdit1.Lines.Insert(0,'');
    RichEdit1.Lines.Insert(0,'');
    RichEdit1.Lines.Insert(0,'');
    RunningCount:=5; {5 and 6 are header}
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'GLS TREAL VERSION: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      LeafTextureCounter:=Strtoint(s);{Store for later}
      RichEdit1.Lines[RunningCount] := 'LeafTextureCount: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      LeafShapeCounter:=Strtoint(s);{Store for later}
      RichEdit1.Lines[RunningCount] := 'LeafShapeCount: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      FruitTextureCounter:=Strtoint(s);{Store for later}
      RichEdit1.Lines[RunningCount] := 'FruitTextureCount: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      FruitShapeCounter:=Strtoint(s);{Store for later}
      RichEdit1.Lines[RunningCount] := 'FruitShapeCount: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Shape: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Levels: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Season: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'TreeSeed: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Health: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Attraction Up: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Death Toll: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Distance: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'WindStrength: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'WindGust: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'WindFrom: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'SunHeight: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'SunStrength: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'SunFrom: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'TreeImageFile: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'TreeShapeFile: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
       RichEdit1.Lines[RunningCount] := 'Tree Sprite File: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Scale: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'ScaleV: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Length0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LengthV0: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Ratio: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Ratio Power: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Scale0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'ScaleV0: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Lobes: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Lobe Depth: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Lobe Scale: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Lobe ScaleV: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'TreeBarkFile: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'TreeColor: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'TreeColorVariation: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Base Splits 0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Base Size: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'ZScale: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'ZScale V: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Bole Splits: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Bole Size: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Flare: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Flare V: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Vertices 0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Branches 0=0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Leaves 0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Taper 0: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'nDownAngle 0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'nDownAngleV 0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'nRotate 0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'nRotateV 0: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'CurveRes 0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'CurveV0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Curve0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'CurveBack0: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'SegSplits0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'SplitAngle0: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'SplitAngleV0: '+s;


    For i:= 1 to  GlobalLevelsNumber-1 do
    begin  {Trunk0 1,... Leaf x = 3 levels}
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'Branches'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'Vertices'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'CurveRes'+inttostr(i)+': '+s;
    end;
        {Trunk0 1,... Leaf x = 3 levels  7}
    For i:= 1 to  GlobalLevelsNumber-1 do
    begin
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'Length'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'LengthV'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'Taper'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'DownAngle'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'DownAngleV'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'Rotate'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'RotateV'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'CurveBack'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'Curve'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'CurveV'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'SplitAngle'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'SplitAngleV'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'SegSplits'+inttostr(i)+': '+s;
      inc(RunningCount);
        s:=RichEdit1.Lines[RunningCount];
        RichEdit1.Lines[RunningCount] := 'Leaves@ '+inttostr(i)+': '+s;
    End;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Leaves: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafScale: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafScale X: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Leaf Attraction Up: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Leaf Offset: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafGrouping: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'FLeafsPer: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafImageFile: '+s;
{  LeafCutter, LeafShape,FruitCutter, FruitShape,}
    For i:= 0 to LeafShapeCounter-1  do
    begin
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafShapeFile: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Leaf Shape: '+s;
    end;
   { LeafTextureCounter, LeafShapeCounter,
    FruitTextureCounter, FruitShapeCounter,}
    For i:= 0 to LeafTextureCounter-1  do
    begin
      inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafTextureFile: '+s;
    end;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafColor: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafColorVariation: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafBackColor: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafBackColorVariation: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'LeafLocation: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'FruitLocation: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Fruit #: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Fruit Scale: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Fruit Scale X: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'FruitPer: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Fruit Pattern: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'FruitImageFile: '+s;
    For i:= 0 to FruitShapeCounter-1  do
    begin
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'FruitShapeFile: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Fruit Shape: '+s;
    end;
    {FruitTextureCounter, FruitShapeCounter,}
    For i:= 0 to FruitTextureCounter-1  do
    begin
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'FruitTextureFile: '+s;
    end;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'FruitColor: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'FruitColorVariation: '+s;

    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Prune Ratio: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Prune Width: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Prune Width Peak: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'Prune Power Low: '+s;
    inc(RunningCount);
      s:=RichEdit1.Lines[RunningCount];
      RichEdit1.Lines[RunningCount] := 'PrunePowerHigh: '+s;

    If Switch=0 then
      RichEdit1.Lines.SaveToFile(GlsTdfPath+TreeDefFileNameEdit.Text+'.txt')
      {RichEdit1.Lines.SaveToFile(ChangeFileExt(TreeDefFileNameEdit.Text,'.txt'))}
    else If Switch=1 then
      RichEdit1.Print(TreeDefFileNameEdit.Text);
    Application.ProcessMessages;
    RichEdit1.Clear;
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------


//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.LoadTreeImageBtnClick(Sender: TObject);
var s:String;
Begin
  s:=TreeImageEdit.Text;
  If LoadImage(s) then
  begin
   TreeImageEdit.Text:=s;
   TreeImageLoaded:=True;   LeafImageLoaded:=False;
   FruitImageLoaded:=False;  ImageLoaded:=True;
  end else TreeImageEdit.Text:='';
End;


Function  TdtmGlsTrealForm.LoadImage(var InName:String):Boolean;
var
 BitmapLoaded:Boolean;
 BitMap : TBitMap;
 jp: TJpegImage;
 PNG: TPNGObject;
 tga : TTGAImage;
 s:String;
begin
  BitmapLoaded:=False;
  OpenPictureDialog1.Filename:=InName;
  OpenPictureDialog1.Initialdir:=GlsDataPath;
  if OpenPictureDialog1.Execute then
  begin
    TreeImageLoaded:=False;{Set these false so ONLY 1 can be edited}
    LeafImageLoaded:=False;
    FruitImageLoaded:=False;
    ImageLoaded:=False;
    BitmapLoaded:=True;
    InName:=Extractfilename(OpenPictureDialog1.FileName);
    s:= lowercase(ExtractFileExt(OpenPictureDialog1.FileName));
    BitMap := TBitMap.Create; {all get assigned to it}
    try
      If s='.bmp' then
        BitMap.Loadfromfile(OpenPictureDialog1.FileName)
      else If s='.png' then
      begin
        PNG := TPNGObject.Create;
        try
          PNG.LoadFromFile(OpenPictureDialog1.FileName);
          Bitmap.Assign(PNG);    //Convert data into bitmap
        finally
          PNG.Free;
        end;
      end
      else If s='.tga' then
      begin
         tga:=TTGAImage.Create;
         try
            tga.LoadFromFile(OpenPictureDialog1.FileName);
            BitMap.Width := tga.Width;
            BitMap.Height := tga.Height;
            BitMap.Canvas.Draw(0,0,tga);
            {tga.Assign(pic.Bitmap);
            tga.SaveToFile(fName) }
         finally
            tga.Free;
         end;
      end
      else If s='.jpg' then
      begin
        jp := TJpegImage.Create;
        try
          with jp do
          begin
            jp.LoadFromFile(OpenPictureDialog1.FileName);
            BitMap.Width := jp.Width;
            BitMap.Height := jp.Height;
            BitMap.Canvas.Draw(0,0,jp);
          end;
        finally
          jp.Free;
        end;
      end else
      begin
        BitmapLoaded:=False;
        showmessage('bmp, png, jpg else:'+#13#10+
                    'File format not supported');
      end;
      If BitmapLoaded=True then
      begin
        TracerImage.Width := BitMap.Width;
        TracerImage.Height := BitMap.Height;
        TracerImage.Picture.Assign(BitMap);
        GrabberImageBitmap.Width := BitMap.Width;
        GrabberImageBitmap.Height := BitMap.Height;
        GrabberImageBitmap.Assign(BitMap);
      end;
    finally
      BitMap.Free;
    end;
  end;
  Result:=BitmapLoaded;
end;

procedure TdtmGlsTrealForm.LoadTreeShapeBtnClick(Sender: TObject);
var f: TextFile;
Incrementer,i:Integer;
ss,s:string;
begin  {GlsShapePath}
 {Shape file (tsf, lsf, fsf)}
  OpenShapeDialog.Initialdir:= GlsDataPath;
   if OpenShapeDialog.Execute then
  begin
  TreeShapeEdit.Text := OpenShapeDialog.FileName;
  try
    AssignFile(f, OpenShapeDialog.FileName);
    Reset(f);
    try
      For Incrementer:= 0 to 4 do
      Begin
      Readln(f, s);
      TreePolygonVerticesNumber[Incrementer]:=Strtoint(s);
      SetLength(TreePolygonVertices[Incrementer], TreePolygonVerticesNumber[Incrementer]+1,3);
      SetLength(TreePolyImageVertices[Incrementer], TreePolygonVerticesNumber[Incrementer]+1,2);
      For i:= 0 to TreePolygonVerticesNumber[Incrementer] do
      begin  {FruitPolyImageVertices}
      Readln(f, s);
      ss:=Copy(s,0,Pos(',', S)-1);
      TreePolyImageVertices[Incrementer,i,0]:= Strtoint(ss);
      ss:='';ss:=Copy(s,Pos(',', S)+1,Length(s));s:=ss;ss:='';
      ss:=Copy(s,0,Pos(',', S)-1);
      TreePolyImageVertices[Incrementer,i,1]:= Strtoint(ss);
      ss:='';ss:=Copy(s,Pos(',', S)+1,Length(s));s:=ss;ss:='';
      ss:=Copy(s,0,Pos(',', S)-1);  
      TreePolygonVertices[Incrementer,i,0]:= StrtoFloat(ss);
      ss:='';ss:=Copy(s,Pos(',', S)+1,Length(s));s:=ss;ss:='';
      ss:=Copy(s,0,Pos(',', S)-1);
      TreePolygonVertices[Incrementer,i,1]:= StrtoFloat(ss);
      ss:='';ss:=Copy(s,Pos(',', S)+1,Length(s));s:=ss;
      TreePolygonVertices[Incrementer,i,2]:= StrtoFloat(s);
      end;
      End;
    except
      { On known exceptions show an error message. }
      on EConvertError do MessageDlg(OpenShapeDialog.FileName +
       ' is not a valid tree shape file!', mtError, [mbOK], 0);
      on EInOutError do MessageDlg('Error while writing '
                                  + OpenShapeDialog.FileName + '!',
      mtError, [mbOK], 0);
    else
      { Show a general error message }
      MessageDlg('Unknown error while reading '
                 + OpenShapeDialog.FileName + '!',
       mtError, [mbOK], 0);
     end;
  finally
    CloseFile(f);
  end;
  end;
end;

procedure TdtmGlsTrealForm.SaveTreeShapeBtnClick(Sender: TObject);
begin {GlsShapePath}
  if TMenuItem(Sender).Name = 'ShapeSaveAs' then
  begin
    SaveShapeDialog.InitialDir:= GlsDataPath;
    SaveShapeDialog.FileName:=TreeShapeEdit.Text;
    if SaveShapeDialog.Execute then
    begin
      SaveTreeShape(SaveShapeDialog.FileName);
      TreeShapeEdit.Text := ExtractFileName(SaveShapeDialog.FileName);
    end;
  end
  else
  begin
    if TreeShapeEdit.Text = '' then
    begin
      SaveShapeDialog.InitialDir:= GlsDataPath;
      if SaveShapeDialog.Execute then
      begin
        SaveTreeShape(SaveShapeDialog.FileName);
        TreeShapeEdit.Text := ExtractFileName(SaveShapeDialog.FileName);
      end;
    end
    else
    begin
      SaveTreeShape(GlsDataPath+TreeShapeEdit.Text);
    end;
  end;
end;

procedure TdtmGlsTrealForm.SaveTreeShape(Filename:String);
var f: TextFile;
Incrementer,
i:Integer;
begin
  try
    AssignFile(f, FileName);
    Rewrite(f);
    try
      For Incrementer:= 0 to 4 do
      Begin
      Writeln(f, IntToStr(TreePolygonVerticesNumber[Incrementer]));
      For i:= 0 to TreePolygonVerticesNumber[Incrementer] do
      begin
      Writeln(f,
      IntToStr(TreePolyImageVertices[Incrementer,i,0])+','+
      IntToStr(TreePolyImageVertices[Incrementer,i,1])+','+
      FloatToStr(TreePolygonVertices[Incrementer,i,0])+','+
      FloatToStr(TreePolygonVertices[Incrementer,i,1])+','+
      FloatToStr(TreePolygonVertices[Incrementer,i,2])   );
      end;
      End;
    except
      { On known exceptions show an error message. }
      on EConvertError do MessageDlg(FileName +
       ' is not a valid tree definition file!', mtError, [mbOK], 0);
      on EInOutError do MessageDlg('Error while writing ' + FileName + '!',
      mtError, [mbOK], 0);

    else
      { Show a general error message }
      MessageDlg('Unknown error while writing ' + FileName + '!',
       mtError, [mbOK], 0);
     end;
  finally
    CloseFile(f);
  end;
end;

procedure TdtmGlsTrealForm.LoadTreeBarkBtnClick(Sender: TObject);
begin
  OpenPictureDialog1.Initialdir:=GlsDataPath;
  if OpenPictureDialog1.Execute then
  begin
    TreeBarkEdit.Text:= Extractfilename(OpenPictureDialog1.FileName);
  end;
end;

procedure TdtmGlsTrealForm.PickTreeColorBtnClick(Sender: TObject);
begin
  LeafColorDialog.Color:=TreeColorShape.Brush.Color;
  if LeafColorDialog.Execute then
  begin
    TreeColorShape.Brush.Color := LeafColorDialog.Color;
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------



//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.InchMeterBtnClick(Sender: TObject);
begin
  LeafScaleFloatEdit.Text:=
    FloattostrF((StrtoFloat(InchMeterEdit.Text)/39.37),ffFixed,7,2);
end;
//-----------------------------------------------------
Function TdtmGlsTrealForm.LeafShapeChecker(LeafShape:Integer):Boolean;
{var TempShapePath:String;}
Begin(*
  TempShapePath:=GlsDataPath+'apple_leaf.lsf';
  Case LeafShape of
  0:
    Begin
      If FileExists(TempShapePath)  then
      begin
        LeafShapeEdit.Text:=ExtractFileName(TempShapePath);
        LoadLeafShape(TempShapePath);
        Result:=True;
      end else
      Begin
        ShowMessage( TempShapePath+' Not found'+#10#13+
                     'Do NOT do Textures');
        Result:=False;
      end;
    end;
  1:  {User Defined}
    Begin
      If FileExists(GlsDataPath+LeafShapeEdit.Text)  then
      begin
        LoadLeafShape(GlsDataPath+LeafShapeEdit.Text);
        Result:=True;
      end else Result:=False;
    end;
  else  Result:=False;
  End;
  If (Result=False) then LeafShapeEdit.Text:='';{TempShapePath;}
  *)Result:=False;
End;
//-----------------------------------------------------

procedure TdtmGlsTrealForm.LeafImageBtnClick(Sender: TObject);
var s:String;
Begin
  s:=LeafImageEdit.Text;
  If LoadImage(s) then
  begin
   LeafImageEdit.Text:=s;
   TreeImageLoaded:=False;   LeafImageLoaded:=True;
   FruitImageLoaded:=False;  ImageLoaded:=True;
  end else LeafImageEdit.Text:='';
End;



procedure TdtmGlsTrealForm.LeafShapeBtnClick(Sender: TObject);
begin  {Shape file (tsf, lsf, fsf)}
  OpenShapeDialog.Initialdir:= GlsDataPath;
  OpenShapeDialog.Filter:=
  'Shape file (.lsf;.3ds;.ms3d)|*.3ds;*.lsf;*.ms3d';
   if OpenShapeDialog.Execute then
  begin
  {LeafShapeEdit.Text}
  LeafShapeCB.Items.add(ExtractFileName(OpenShapeDialog.FileName));
  LoadLeafShape(OpenShapeDialog.FileName);
  LeafShapeCB.ItemIndex:=LeafShapeCB.Items.Count-1;
  end;
  OpenShapeDialog.Filter:=
  'Shape file (tsf, lsf, fsf)|*.tsf;*.lsf;*.fsf';
end;

procedure TdtmGlsTrealForm.LeafShapeSaverBtnClick(Sender: TObject);
begin {GlsShapePath}
  if TMenuItem(Sender).Name = 'ShapeSaveAs1' then
  begin
    SaveShapeDialog.InitialDir:= GlsDataPath;
    SaveShapeDialog.FileName:=LeafShapeCB.Items[0];{ LeafShapeEdit.Text;}
    if SaveShapeDialog.Execute then
    begin
      SaveLeafShape(SaveShapeDialog.FileName);
      {LeafShapeEdit.Text}
      LeafShapeCB.Items[0]:= ExtractFileName(SaveShapeDialog.FileName);
    end;
  end
  else
  begin
    if LeafShapeCB.Items[0] = '' then
    begin
      SaveShapeDialog.InitialDir:= GlsDataPath;
      if SaveShapeDialog.Execute then
      begin
        SaveLeafShape(SaveShapeDialog.FileName);
        {LeafShapeEdit.Text}
        LeafShapeCB.Items[0]:= ExtractFileName(SaveShapeDialog.FileName);
      end;
    end
    else
    begin
      SaveLeafShape(GlsDataPath+LeafShapeCB.Items[0]{LeafShapeEdit.Text});
    end;
  end;
end;

{GlsShapePath FruitShape If loaded then use ELSE a SPhere!}
procedure TdtmGlsTrealForm.LoadLeafShape(FileName: string);
var f: TextFile;
ImageToo:Boolean;
i:Integer;
ss,s:string;
begin
  try
    AssignFile(f, FileName);
    Reset(f);
    try
      Readln(f, s);        {showmessage('0: '+s);}
      inc(LeafShapeCurrent);{0...}
      SetLength(LeafPolygonVerticesNumber,LeafShapeCurrent+1);
      LeafPolygonVerticesNumber[LeafShapeCurrent]:=Strtoint(s);
      Readln(f, s);If strtoint(s)=1 then ImageToo:=True else ImageToo:=False;
      SetLength(LeafPolygonVertices, LeafShapeCurrent+1, LeafPolygonVerticesNumber[LeafShapeCurrent]+1);
      SetLength(LeafPolyImageVertices, LeafShapeCurrent+1, LeafPolygonVerticesNumber[LeafShapeCurrent]+1);
      For i:= 0 to LeafPolygonVerticesNumber[LeafShapeCurrent] do
      begin
      Readln(f, s);  { Copy(S; Index, Count: Integer): string;}
      ss:=Copy(s,0,Pos(',', S)-1);
      LeafPolyImageVertices[LeafShapeCurrent,i,0]:= Strtoint(ss);  {showmessage('1: '+ss);}
      ss:=Copy(s,Pos(',', S)+1,Length(s));
      s:=ss;                              { showmessage('2a: '+ss);}
      ss:=Copy(s,0,Pos(',', S)-1);               { showmessage('2b: '+ss);}
      LeafPolyImageVertices[LeafShapeCurrent,i,1]:= Strtoint(ss);
      ss:=Copy(s,Pos(',', S)+1,Length(s));
      s:=ss;
      ss:=Copy(s,0,Pos(',', S)-1);               { showmessage('x: '+ss);}
      LeafPolygonVertices[LeafShapeCurrent,i,0]:= StrtoFloat(ss);
      ss:=Copy(s,Pos(',', S)+1,Length(s));
      s:=ss;
      ss:=Copy(s,0,Pos(',', S)-1);
      LeafPolygonVertices[LeafShapeCurrent,i,1]:= StrtoFloat(ss);{ showmessage('y: '+ss);}
      ss:=Copy(s,Pos(',', S)+1,Length(s));
      s:=ss;     {showmessage('z: '+ss); }
      {ss:=Copy(s,0,Pos(',', S));}
      LeafPolygonVertices[LeafShapeCurrent,i,2]:= StrtoFloat(s);
      end;
      If (not ImageToo) then ComputeLeafImageCoords;
    except
      { On known exceptions show an error message. }
      on EConvertError do MessageDlg(FileName +
       ' is not a valid tree definition file!', mtError, [mbOK], 0);
      on EInOutError do MessageDlg('Error while writing ' + FileName + '!',
      mtError, [mbOK], 0);
    else
      { Show a general error message }
      MessageDlg('Unknown error while reading ' + FileName + '!',
       mtError, [mbOK], 0);
     end;
  finally
    CloseFile(f);
  end;
end;

procedure TdtmGlsTrealForm.SaveLeafShape(FileName: string);
var f: TextFile;
i:Integer;
begin
  try
    AssignFile(f, FileName);
    Rewrite(f);
    try
      Writeln(f, IntToStr(LeafPolygonVerticesNumber[0]));
      Writeln(f, 1);{Image too}
      For i:= 0 to LeafPolygonVerticesNumber[0] do
      begin
      Writeln(f, IntToStr(LeafPolyImageVertices[0,i,0])+','+
      IntToStr(LeafPolyImageVertices[0,i,1])+','+
      FloatToStr(LeafPolygonVertices[0,i,0])+','+
      FloatToStr(LeafPolygonVertices[0,i,1])+','+
      FloatToStr(LeafPolygonVertices[0,i,2])   );
      end;
    except
      { On known exceptions show an error message. }
      on EConvertError do MessageDlg(FileName +
       ' is not a valid tree definition file!', mtError, [mbOK], 0);
      on EInOutError do MessageDlg('Error while writing ' + FileName + '!',
      mtError, [mbOK], 0);

    else
      { Show a general error message }
      MessageDlg('Unknown error while writing ' + FileName + '!',
       mtError, [mbOK], 0);
     end;
  finally
    CloseFile(f);
  end;
end;


procedure TdtmGlsTrealForm.ClearAllShapes1Click(Sender: TObject);
begin
  LeafShapeCurrent:=0;
  LeafShapeCB.Items.Clear;
end;

procedure TdtmGlsTrealForm.LeafTextureBtnClick(Sender: TObject);
begin{just loads the File name - no display}
  OpenPictureDialog1.Initialdir:=GlsDataPath;
  if OpenPictureDialog1.Execute then
  begin
    LeafTextureCB.Items.Add( ExtractfileName(OpenPictureDialog1.FileName));
    LeafTextureCB.ItemIndex:=LeafTextureCB.Items.Count-1;
  end;
end;
procedure TdtmGlsTrealForm.ClearAllTextures1Click(Sender: TObject);
begin
  LeafTextureCB.Items.Clear;
end;

procedure TdtmGlsTrealForm.PickLeafColorBtnClick(Sender: TObject);
begin  {LeafColorDialog}
  LeafColorDialog.Color:=LeafColorShape.Brush.Color;
  if LeafColorDialog.Execute then
  begin
    LeafColorShape.Brush.Color := LeafColorDialog.Color;
  end;
end;

procedure TdtmGlsTrealForm.PickLeafBackColorBtnClick(Sender: TObject);
begin
  LeafColorDialog.Color:=LeafBackColorShape.Brush.Color;
  if LeafColorDialog.Execute then
  begin
    LeafBackColorShape.Brush.Color := LeafColorDialog.Color;
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------

procedure TdtmGlsTrealForm.ManOpenLeafShapeFileBtnClick(Sender: TObject);
begin  {Shape file (tsf, lsf, fsf)}
  OpenShapeDialog.Initialdir:= GlsDataPath;
   if OpenShapeDialog.Execute then
  begin
  ManualShapeInputFilenameEdit.Text := ExtractFileName(OpenShapeDialog.FileName);
  LoadLeafShape(OpenShapeDialog.FileName);
  RichEdit1.Lines.LoadFromFile(OpenShapeDialog.FileName);
  end;
end;

procedure TdtmGlsTrealForm.ManSaveLeafShapeFileBtnClick(Sender: TObject);
begin
    SaveShapeDialog.InitialDir:= GlsDataPath;
    SaveShapeDialog.FileName:=ManualShapeInputFilenameEdit.Text;
    if SaveShapeDialog.Execute then
    begin
      RichEdit1.Lines.SavetoFile(SaveShapeDialog.FileName);
      ManualShapeInputFilenameEdit.Text := ExtractFileName(SaveShapeDialog.FileName);
    end;
end;

procedure TdtmGlsTrealForm.ManOpenFruitShapeFileBtnClick(Sender: TObject);
begin {Shape file (tsf, lsf, fsf)}
  OpenShapeDialog.Initialdir:= GlsDataPath;
   if OpenShapeDialog.Execute then
  begin
    ManualShapeInputFilenameEdit.Text := ExtractFileName(OpenShapeDialog.FileName);
    LoadFruitShape(OpenShapeDialog.FileName);
    RichEdit1.Lines.LoadFromFile(OpenShapeDialog.FileName);
  end;
end;

procedure TdtmGlsTrealForm.ManSaveFruitShapeFileBtnClick(Sender: TObject);
begin
    SaveShapeDialog.InitialDir:= GlsDataPath;
    SaveShapeDialog.FileName:=ManualShapeInputFilenameEdit.Text;
    if SaveShapeDialog.Execute then
    begin
      RichEdit1.Lines.SavetoFile(SaveShapeDialog.FileName);
      ManualShapeInputFilenameEdit.Text := ExtractFileName(SaveShapeDialog.FileName);
    end;
end;

procedure TdtmGlsTrealForm.ManDisplayLeafBtnClick(Sender: TObject);
begin
  {ManualShapeInputFilenameEdit
   RichEdit1
   TracerImage  Sized to fit X -0.5..0.5  Y 0..1}
  ManSaveLeafShapeFileBtnClick(Self);
  LoadLeafShape(SaveShapeDialog.FileName);
  ComputeLeafImageCoords;
  BlankCanvas;
  DrawTracedShape(2);
end;
procedure TdtmGlsTrealForm.ManDisplayFruitBtnClick(Sender: TObject);
begin
  ManSaveFruitShapeFileBtnClick(Self);
  LoadFruitShape(SaveShapeDialog.FileName);
  {moved INTO Loader  ComputeFruitImageCoords;}
                     {BlankCanvas;}
  DrawTracedShape(1);
  {Replace the Non image with an Image Coordinate version}
  SaveFruitShape(SaveShapeDialog.FileName);
end;

procedure TdtmGlsTrealForm.BlankCanvas;
begin
  TreeImageLoaded:=False;{Set these false so ONLY 1 can be edited}
  LeafImageLoaded:=False;
  FruitImageLoaded:=False;
  ImageLoaded:=False;
  TICNoneClick(Self);
  GrabberImageBitmap.Width := 256;
  GrabberImageBitmap.Height := 256;
  GrabberImageBitmap.Canvas.Brush.Color := clWhite;
  GrabberImageBitmap.Canvas.FillRect(Rect(0,0,256,256));
  TracerImage.Width := GrabberImageBitmap.Width;
  TracerImage.Height := GrabberImageBitmap.Height;
  TracerImage.Picture.Assign(GrabberImageBitmap);
end;
//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.PickFruitColorBtnClick(Sender: TObject);
begin
  LeafColorDialog.Color:=FruitColorShape.Brush.Color;
  if LeafColorDialog.Execute then
  begin
    FruitColorShape.Brush.Color := LeafColorDialog.Color;
  end;
end;

procedure TdtmGlsTrealForm.FruitTextureBtnClick(Sender: TObject);
begin  {just loads the File name - no display}
  OpenPictureDialog1.Initialdir:=GlsDataPath;
  if OpenPictureDialog1.Execute then
  begin
    {GlsTexturePath:=Extractfilepath(OpenPictureDialog1.FileName);}
    {FruitTextureEdit.Text:=}
    FruitTextureCB.Items.Add(ExtractfileName(OpenPictureDialog1.FileName));
    FruitTextureCB.ItemIndex:=FruitTextureCB.Items.Count-1;
  end;
end;

procedure TdtmGlsTrealForm.ClearAllTextures2Click(Sender: TObject);
begin
  FruitTextureCB.Items.Clear;
end;

procedure TdtmGlsTrealForm.FruitImageBtnClick(Sender: TObject);
var s:String;
Begin
    s:=FruitImageEdit.Text;
    If LoadImage(s) then
    begin
      FruitImageEdit.Text:=s;
      TreeImageLoaded:=False;
      LeafImageLoaded:=False;
      FruitImageLoaded:=True;
      ImageLoaded:=True;
    end else FruitImageEdit.Text:='';
End;


procedure TdtmGlsTrealForm.FruitShapeFileBtnClick(Sender: TObject);
begin
{Shape file (tsf, lsf, fsf)}
  OpenShapeDialog.Filter:=
  'Shape file (.fsf;.3ds;.ms3d;.sph)|*.3ds;*.fsf;*.ms3d;*.sph';
  OpenShapeDialog.Initialdir:= GlsDataPath;
   if OpenShapeDialog.Execute then
  begin
  {FruitShapeFileEdit.Text :=}
  FruitShapeCB.Items.Add(ExtractFileName(OpenShapeDialog.FileName));
  {GlsShapePath:=ExtractFilePath(FruitShapeFileEdit.Text);}
  LoadFruitShape(OpenShapeDialog.FileName);
  FruitShapeCB.ItemIndex:=FruitShapeCB.Items.Count-1;
  end;
  OpenShapeDialog.Filter:=
  'Shape file (tsf, lsf, fsf)|*.tsf;*.lsf;*.fsf';
end;

procedure TdtmGlsTrealForm.FruitShapeSaverBtnClick(Sender: TObject);
begin {GlsShapePath}
  if TMenuItem(Sender).Name = 'ShapeSaveAs2' then
  begin
    {GlsShapePath:=ExtractFilePath(FruitShapeFileEdit.Text);}
    SaveShapeDialog.InitialDir:= GlsDataPath;
    SaveShapeDialog.FileName:=FruitShapeCB.Items[0];{FruitShapeFileEdit.Text;}
    if SaveShapeDialog.Execute then
    begin
      SaveFruitShape(SaveShapeDialog.FileName);
      {FruitShapeFileEdit.Text}
      FruitShapeCB.Items[0]:= ExtractFileName(SaveShapeDialog.FileName);
      {GlsShapePath:=ExtractFilePath(FruitShapeFileEdit.Text);}
    end;
  end
  else
  begin
    if FruitShapeCB.Items[0]{FruitShapeFileEdit.Text} = '' then
    begin
      SaveShapeDialog.InitialDir:= GlsDataPath;
      if SaveShapeDialog.Execute then
      begin
        SaveFruitShape(SaveShapeDialog.FileName);
        {FruitShapeFileEdit.Text }
        FruitShapeCB.Items[0]:= ExtractFileName(SaveShapeDialog.FileName);
        {GlsShapePath:=ExtractFilePath(FruitShapeFileEdit.Text);}
      end;
    end
    else
    begin
      SaveFruitShape(GlsDataPath+FruitShapeCB.Items[0]{FruitShapeFileEdit.Text});
      {GlsShapePath:=ExtractFilePath(FruitShapeFileEdit.Text);}
    end;
  end;
end;

{GlsShapePath FruitShape If loaded then use ELSE a SPhere!}
procedure TdtmGlsTrealForm.LoadFruitShape(FileName: string);
var f: TextFile;
ImageToo:Boolean;
x,y,i:Integer;
ss,s:string;
begin
  try
    AssignFile(f, FileName);
    Reset(f);
    try
      Readln(f, s);
      inc(FruitShapeCurrent);
      SetLength( FruitPolygonVerticesNumber, FruitShapeCurrent+1);
      FruitPolygonVerticesNumber[FruitShapeCurrent]:=Strtoint(s);
      Readln(f, s);If strtoint(s)=1 then ImageToo:=True else ImageToo:=False;
      Readln(f, s);x:=strtoint(s);
      Readln(f, s);y:=strtoint(s);
      SetLength( FruitPolyImageVertices,FruitShapeCurrent+1,FruitPolygonVerticesNumber[FruitShapeCurrent]+1);
      SetLength(FruitPolygonVertices,FruitShapeCurrent+1, FruitPolygonVerticesNumber[FruitShapeCurrent]+1);
      For i:= 0 to FruitPolygonVerticesNumber[FruitShapeCurrent] do
      begin  {FruitPolyImageVertices}
      Readln(f, s);
      ss:=Copy(s,0,Pos(',', S)-1);
      FruitPolyImageVertices[FruitShapeCurrent,i,0]:= Strtoint(ss);
      ss:=Copy(s,Pos(',', S)+1,Length(s));s:=ss;
      ss:=Copy(s,0,Pos(',', S)-1);
      FruitPolyImageVertices[FruitShapeCurrent,i,1]:= Strtoint(ss);
      ss:=Copy(s,Pos(',', S)+1,Length(s));s:=ss;
      ss:=Copy(s,0,Pos(',', S)-1);
      FruitPolygonVertices[FruitShapeCurrent,i,0]:= StrtoFloat(ss);
      ss:=Copy(s,Pos(',', S)+1,Length(s));s:=ss;
      ss:=Copy(s,0,Pos(',', S)-1);
      FruitPolygonVertices[FruitShapeCurrent,i,1]:= StrtoFloat(ss);
      ss:=Copy(s,Pos(',', S)+1,Length(s));s:=ss;
      {ss:=Copy(s,0,Pos(',', S)); }
      FruitPolygonVertices[FruitShapeCurrent,i,2]:= StrtoFloat(s);
      end;
      If (not ImageToo) then ComputeFruitImageCoords(x,y);

    except
      { On known exceptions show an error message. }
      on EConvertError do MessageDlg(FileName +
       ' is not a valid tree definition file!', mtError, [mbOK], 0);
      on EInOutError do MessageDlg('Error while writing ' + FileName + '!',
      mtError, [mbOK], 0);
    else
      { Show a general error message }
      MessageDlg('Unknown error while reading ' + FileName + '!',
       mtError, [mbOK], 0);
     end;
  finally
    CloseFile(f);
  end;
end;


procedure TdtmGlsTrealForm.SaveFruitShape(FileName: string);
var f: TextFile;
i:Integer;
begin
  try
    AssignFile(f, FileName);
    Rewrite(f);
    try
      Writeln(f, IntToStr(FruitPolygonVerticesNumber[0]));
      Writeln(f, 1);{Image too}
      Writeln(f, IntToStr(TracerImage.Width));
      Writeln(f, IntToStr(TracerImage.Height));
      For i:= 0 to FruitPolygonVerticesNumber[0] do
      begin
      Writeln(f, IntToStr(FruitPolyImageVertices[0,i,0])+','+
      IntToStr(FruitPolyImageVertices[0,i,1])+','+
      FloatToStr(FruitPolygonVertices[0,i,0])+','+
      FloatToStr(FruitPolygonVertices[0,i,1])+','+
      FloatToStr(FruitPolygonVertices[0,i,2])   );
      end;
    except
      { On known exceptions show an error message. }
      on EConvertError do MessageDlg(FileName +
       ' is not a valid tree definition file!', mtError, [mbOK], 0);
      on EInOutError do MessageDlg('Error while writing ' + FileName + '!',
      mtError, [mbOK], 0);

    else
      { Show a general error message }
      MessageDlg('Unknown error while writing ' + FileName + '!',
       mtError, [mbOK], 0);
     end;
  finally
    CloseFile(f);
  end;
end;

procedure TdtmGlsTrealForm.ClearAllShapes2Click(Sender: TObject);
begin
  FruitShapeCurrent:=0;
  FruitShapeCB.Items.Clear;
end;

//-----------------------------------------------------
//-----------------------------------------------------

//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.BaseExtentsClick(Sender: TObject);
begin
TreeShapeRG.ItemIndex:=0;
end;
procedure TdtmGlsTrealForm.FirstLimbLevelClick(Sender: TObject);
begin
TreeShapeRG.ItemIndex:=1;
end;
procedure TdtmGlsTrealForm.SecondLimbLevelClick(Sender: TObject);
begin
TreeShapeRG.ItemIndex:=2;
end;
procedure TdtmGlsTrealForm.ThirdLimbLevelClick(Sender: TObject);
begin
TreeShapeRG.ItemIndex:=3;
end;
procedure TdtmGlsTrealForm.FourthLimbLevelClick(Sender: TObject);
begin
TreeShapeRG.ItemIndex:=4;
end;
procedure TdtmGlsTrealForm.FifthLimbLevelClick(Sender: TObject);
begin
TreeShapeRG.ItemIndex:=5;
end;
procedure TdtmGlsTrealForm.TreeShapeRGClick(Sender: TObject);
begin
  FruityLeafStarted:=False;
  Case TreeShapeRG.ItemIndex of
  0:  BaseExtents.Checked:=True;
  1:  FirstLimbLevel.Checked:=True;
  2:  SecondLimbLevel.Checked:=True;
  3:  FourthLimbLevel.Checked:=True;
  4:  FifthLimbLevel.Checked:=True;
  End;
end;
//-----------------------------------------------------
//-----------------------------------------------------

procedure TdtmGlsTrealForm.TICNoneClick(Sender: TObject);
begin
TICRG.ItemIndex:=0;
end;
procedure TdtmGlsTrealForm.TraceInput1Click(Sender: TObject);
begin
TICRG.ItemIndex:=1;
end;
procedure TdtmGlsTrealForm.FTracerFinished1Click(Sender: TObject);
begin
TICRG.ItemIndex:=2;
end;
procedure TdtmGlsTrealForm.CClear1Click(Sender: TObject);
begin
TICRG.ItemIndex:=3;
end;
procedure TdtmGlsTrealForm.DDraw1Click(Sender: TObject);
begin
TICRG.ItemIndex:=4;
end;
procedure TdtmGlsTrealForm.ADrawAll1Click(Sender: TObject);
begin
TICRG.ItemIndex:=5;
end;

procedure TdtmGlsTrealForm.TICRGClick(Sender: TObject);
var i:Integer;
begin
  Case TICRG.ItemIndex of
  0:  begin
        Drawing := False;
        Screen.Cursor := crDefault;
        TICNone.Checked:=True;
        StatusBar.Panels[1].Text:='Active Tracer: None';
      end;
  1: If (ImageLoaded) then
    begin
      TICRG.ItemIndex:=3;
      TICRGClick(Sender);{CLEAR whatever else ADDS points}
      Application.ProcessMessages;
      Drawing := True;
      Screen.Cursor := crCross;
      TraceInput1.Checked:=True;
      If TreeImageLoaded then
         StatusBar.Panels[1].Text:='Active Tracer: Tree'
      else If LeafImageLoaded then
         StatusBar.Panels[1].Text:='Active Tracer: Leaf'
      else If FruitImageLoaded then
         StatusBar.Panels[1].Text:='Active Tracer: Fruit'
    end else TICRG.ItemIndex:=0;
  2:  If (ImageLoaded) then
    begin
      Drawing := False; Screen.Cursor := crDefault;
      {Finish: Compute the DATA into ARRAY Coordinates}
      If TreeImageLoaded then ComputeTreeRealCoords
      else If LeafImageLoaded then ComputeLeafRealCoords
      else If FruitImageLoaded then ComputeFruitRealCoords;
      {Finished SO Reset to doing Nothing}
      TICNone.Checked:=True;
      StatusBar.Panels[1].Text:='Active Tracer: None';
    end else TICRG.ItemIndex:=0;
  3:  If (ImageLoaded) then
    begin
      Drawing := False;Screen.Cursor := crDefault;
      CClear1.Checked:=True;
      TracerImage.Picture.Assign(GrabberImageBitmap);
      If FruitImageLoaded then
      begin
        FruitPolygonVerticesNumber[0]:=-1;
        SetLength( FruitPolyImageVertices,0);
        SetLength(FruitPolygonVertices, 0);
      end;
      If LeafImageLoaded then
      begin
        LeafPolygonVerticesNumber[0]:=-1;
        SetLength( LeafPolygonVertices,0);
        SetLength(LeafPolyImageVertices, 0);
      end;
      If TreeImageLoaded then
      begin
        for i:=0 to 5 do TreePolygonVerticesNumber[i]:=-1;
        SetLength( TreePolyImageVertices,0);
        SetLength( TreePolyImageVertices,6);
        SetLength(TreePolygonVertices, 0);
        SetLength(TreePolygonVertices, 6);
      end;
    end else TICRG.ItemIndex:=0;
  4:  If (ImageLoaded) then
     begin
       Drawing := False;Screen.Cursor := crDefault;
       DDraw1.Checked:=True;
       TracerImage.Picture.Assign(GrabberImageBitmap);
       If FruitImageLoaded then DrawTracedShape(1);
       If LeafImageLoaded then DrawTracedShape(2);
       If TreeImageLoaded then DrawTracedShape(3);
     end else TICRG.ItemIndex:=0;
  5: If (ImageLoaded and TreeImageLoaded) then
    begin
      Drawing := False;
      Screen.Cursor := crDefault;
      ADrawAll1.Checked:=True;
       TracerImage.Picture.Assign(GrabberImageBitmap);
       DrawTracedShape(4);
    end else TICRG.ItemIndex:=0;
  End;
end;
//-----------------------------------------------------
{TreeImageLoaded  DrawTracedShape;} {LeafImageLoaded}
{FruitImageLoaded}
//-----------------------------------------------------
procedure TdtmGlsTrealForm.TracerImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If (Drawing and ImageLoaded) then
  begin
    TracerImage.Canvas.Pen.Width := 2;
    TracerImage.Canvas.Pen.Color := clAqua;
    If (TreeImageLoaded) then
    Case TreeShapeRG.ItemIndex of
    0:TracerImage.Canvas.Pen.Color := clBlack;
    1:TracerImage.Canvas.Pen.Color := clAqua;
    2:TracerImage.Canvas.Pen.Color := clRed;
    3:TracerImage.Canvas.Pen.Color := clFuchsia;
    4:TracerImage.Canvas.Pen.Color := clLime;
    5:TracerImage.Canvas.Pen.Color := clYellow;
    end;
    TracerImage.Canvas.MoveTo(X, Y);
    If (not FruityLeafStarted ) then
    begin
      Origin := Point(X, Y);
      FruityLeafStarted:=True;
    end;
    MovePt := Point(X, Y);
    DrawingTool :=dtLine;
    Screen.Cursor := crCross;
  end;
end;

procedure TdtmGlsTrealForm.TracerImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
  var Xs,Ys:String;
begin
  If (Drawing and ImageLoaded) then
  begin
    DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
    MovePt := Point(X, Y);
    DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmNotXor);
  end;
  str(X, Xs); str(Y, Ys);
  Statusbar.Panels[0].Text := '   X: ' + Xs + ', Y: ' + Ys;
end;

procedure TdtmGlsTrealForm.TracerImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  If (Drawing and ImageLoaded) then
  begin
    {DrawingTool := dtRectangle;}
{    Drawing := False;}
{    DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmCopy);}
    TracerImage.Canvas.Rectangle(X+2, Y+2,X-2, Y-2);

{    Screen.Cursor := crDefault;}
    If FruitImageLoaded then
    begin
      inc(FruitPolygonVerticesNumber[0]);
      Statusbar.Panels[1].Text  := inttostr(FruitPolygonVerticesNumber[0]);
      SetLength(FruitPolyImageVertices,1,FruitPolygonVerticesNumber[0]+1);
      SetLength(FruitPolygonVertices,1, FruitPolygonVerticesNumber[0]+1);
      FruitPolyImageVertices[0,FruitPolygonVerticesNumber[0],0]:= x;
      FruitPolyImageVertices[0,FruitPolygonVerticesNumber[0],1]:= y;
      FruitPolygonVertices[0,FruitPolygonVerticesNumber[0],0]:= x;
      FruitPolygonVertices[0,FruitPolygonVerticesNumber[0],1]:= y;
      FruitPolygonVertices[0,FruitPolygonVerticesNumber[0],2]:= 0;
    end;
    If (LeafImageLoaded )then
    begin
      inc(LeafPolygonVerticesNumber[0]);
      Statusbar.Panels[1].Text  := inttostr(LeafPolygonVerticesNumber[0]);
      SetLength(LeafPolyImageVertices,1,LeafPolygonVerticesNumber[0]+1);
      SetLength(LeafPolygonVertices,1, LeafPolygonVerticesNumber[0]+1);
      LeafPolyImageVertices[0,LeafPolygonVerticesNumber[0],0]:= x;
      LeafPolyImageVertices[0,LeafPolygonVerticesNumber[0],1]:= y;
      LeafPolygonVertices[0,LeafPolygonVerticesNumber[0],0]:= x;
      LeafPolygonVertices[0,LeafPolygonVerticesNumber[0],1]:= y;
      LeafPolygonVertices[0,LeafPolygonVerticesNumber[0],2]:= 0;
    end;
    If TreeImageLoaded then
    begin
      inc(TreePolygonVerticesNumber[TreeShapeRG.ItemIndex]);
      Statusbar.Panels[1].Text  := inttostr(TreePolygonVerticesNumber[TreeShapeRG.ItemIndex]);
      SetLength(TreePolyImageVertices[TreeShapeRG.ItemIndex],
        (TreePolygonVerticesNumber[TreeShapeRG.ItemIndex]+1),2);
      SetLength(TreePolygonVertices[TreeShapeRG.ItemIndex],
        TreePolygonVerticesNumber[TreeShapeRG.ItemIndex]+1,3);
      TreePolyImageVertices[TreeShapeRG.ItemIndex,TreePolygonVerticesNumber[TreeShapeRG.ItemIndex],0]:= x;
      TreePolyImageVertices[TreeShapeRG.ItemIndex,TreePolygonVerticesNumber[TreeShapeRG.ItemIndex],1]:= y;
      TreePolygonVertices[TreeShapeRG.ItemIndex,TreePolygonVerticesNumber[TreeShapeRG.ItemIndex],0]:= x;
      TreePolygonVertices[TreeShapeRG.ItemIndex,TreePolygonVerticesNumber[TreeShapeRG.ItemIndex],1]:= y;
      TreePolygonVertices[TreeShapeRG.ItemIndex,TreePolygonVerticesNumber[TreeShapeRG.ItemIndex],2]:= 0;
    end;
  end;
end;

//-----------------------------------------------------
procedure TdtmGlsTrealForm.DrawShape
  (TopLeft, BottomRight, Tri, Quad: TPoint; AMode: TPenMode);
var
TheRect: TRect;
begin
  with TracerImage.Canvas do
  begin
    Pen.Mode := AMode;
    case DrawingTool of
      dtLine:
        begin
          TracerImage.Canvas.MoveTo(TopLeft.X, TopLeft.Y);
          TracerImage.Canvas.LineTo(BottomRight.X, BottomRight.Y);
        end; {DrawingTool := dtVRectangle;}
      dtVDRectangle, dtVTRectangle, dtVFRectangle, dtVNRectangle,
        dtVMRectangle, dtVARectangle, dtVWRectangle, dtVCRectangle,
        dtVSRectangle, dtVBRectangle, dtVRectangle:
        begin
          TheRect.TopLeft:=TopLeft;
          TheRect.BottomRight:=BottomRight;
          {(TopLeft.X, TopLeft.Y, BottomRight.X, BottomRight.Y);}
          TracerImage.Canvas.FrameRect(TheRect);
        end;
      dtRectangle:  {using MovePt only}
        TracerImage.Canvas.Rectangle
          (BottomRight.X+2, BottomRight.Y+2,BottomRight.X-2, BottomRight.Y-2);
      dtCSEllipse, dtEllipse:
        TracerImage.Canvas.Ellipse
          (Topleft.X, TopLeft.Y, BottomRight.X, BottomRight.Y);
      dtPBrush:
        TracerImage.Canvas.Ellipse
          (Topleft.X, TopLeft.Y,
          (Topleft.X + DrawingToolPBrushWidth),
          (TopLeft.Y + DrawingToolPBrushWidth));
      dtRoundRect: TracerImage.Canvas.RoundRect
        (TopLeft.X, TopLeft.Y, BottomRight.X,
          BottomRight.Y, (TopLeft.X - BottomRight.X) div 2,
          (TopLeft.Y - BottomRight.Y) div 2);
    end;
    Pen.Mode := pmCopy;
  end;
end;
//-----------------------------------------------------
//-----------------------------------------------------
{TreeImageLoaded  DrawTracedShape;} {LeafImageLoaded}
{FruitImageLoaded}
procedure TdtmGlsTrealForm.DrawTracedShape(Which:Integer);
var RecursiveI,Xi,Yi,i:Integer;
Begin
  {Refresh}
        {TracerImage.Width := GrabberImageBitmap.Width;
        TracerImage.Height := GrabberImageBitmap.Height;
        TracerImage.Picture.Assign(GrabberImageBitmap);}
  TracerImage.Canvas.Pen.Color := clAqua;
  Case Which of
  1:{(FruitImageLoaded )}
    Begin
      DrawingTool := dtRectangle;
      Drawing := False;
      For i:= 0 to FruitPolygonVerticesNumber[0] do
      begin
      Xi:=FruitPolyImageVertices[0,i,0];
      Yi:=FruitPolyImageVertices[0,i,1];
      {MovePt := Point(Xi, Yi);}
      TracerImage.Canvas.Rectangle(Xi+2, Yi+2,Xi-2, Yi-2);
      {DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmCopy);}
      end;
    end;
  2:{(LeafImageLoaded )}
    Begin
      DrawingTool := dtRectangle;
      Drawing := False;
      For i:= 0 to LeafPolygonVerticesNumber[0] do
      begin
      Xi:=LeafPolyImageVertices[0,i,0];
      Yi:=LeafPolyImageVertices[0,i,1];
      TracerImage.Canvas.Rectangle(Xi+2, Yi+2,Xi-2, Yi-2);
      {MovePt := Point(Xi, Yi);
      DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmCopy);}
      end;
    end;
  3:{(TreeImageLoaded )}
    Begin
      Case TreeShapeRG.ItemIndex of
    0:TracerImage.Canvas.Pen.Color := clBlack;
    1:TracerImage.Canvas.Pen.Color := clAqua;
    2:TracerImage.Canvas.Pen.Color := clRed;
    3:TracerImage.Canvas.Pen.Color := clFuchsia;
    4:TracerImage.Canvas.Pen.Color := clLime;
    5:TracerImage.Canvas.Pen.Color := clYellow;
      end;
      DrawingTool := dtRectangle;
      Drawing := False;
      For i:= 0 to TreePolygonVerticesNumber[TreeShapeRG.ItemIndex] do
      begin
        Xi:=TreePolyImageVertices[TreeShapeRG.ItemIndex, i,0];
        Yi:=TreePolyImageVertices[TreeShapeRG.ItemIndex, i,1];
        TracerImage.Canvas.Rectangle(Xi+2, Yi+2,Xi-2, Yi-2);
        {MovePt := Point(Xi, Yi);
        DrawShape(Origin, MovePt, DIYX3Y3, DIYX4Y4, pmCopy); }
      end;
    end;
  4:{TreeImageLoaded  ALL}
    Begin
      For RecursiveI := 0 to 5 do
      begin
        TreeShapeRG.ItemIndex:=RecursiveI;
        DrawTracedShape(3);
      end;
    end;
  End;{Case}
End;
//-----------------------------------------------------
//-----------------------------------------------------
{Finish: Compute the DATA into IMAGE ARRAY Coordinates
procedure TaGlsTreeForm.ComputeTreeImageCoords;}

{Finish: Compute the DATA into REAL ARRAY Coordinates
 Actually this is to Compute Parameters...
 THERE is NO NEED for REAL coords?...
 as you cannot input manually and compute Image Coords}
procedure TdtmGlsTrealForm.ComputeTreeRealCoords;
var
  TempWorkerBee,Temp1,Temp2,Temp3,
  TreeHeight: Double;
  LevelCount,
  TreePart,i,MinX,MaxX,MinY,MaxY,XWidth,YHeight:Integer;
  NadaIString,NadaFString,NadaF1String:String;
Begin
  NadaFString:='0.0';NadaIString:='0';
  {Given x,y image coords Compute the REAL coords}
  MinX :=123456;MaxX :=-123456;
  MinY :=123456;MaxY :=-123456;
  LevelCount:=0;
  For TreePart := 0 to 5 do
  begin
    If  TreePolygonVerticesNumber[TreePart]>0 then
    begin
      LevelCount:= TreePart;
      For i:=0 to TreePolygonVerticesNumber[TreePart] do
      begin
        If MinX > TreePolyImageVertices[TreePart,i,0] then
           MinX := TreePolyImageVertices[TreePart,i,0];
        If MaxX < TreePolyImageVertices[TreePart,i,0] then
           MaxX := TreePolyImageVertices[TreePart,i,0];
        If MinY > TreePolyImageVertices[TreePart,i,1] then
           MinY := TreePolyImageVertices[TreePart,i,1];
        If MaxY < TreePolyImageVertices[TreePart,i,1] then
           MaxY := TreePolyImageVertices[TreePart,i,1];
      end;
    end;
  end;
  XWidth:= MaxX -MinX;
  YHeight:= MaxY -MinY;
  For TreePart := 0 to 5 do
  For i:=0 to TreePolygonVerticesNumber[TreePart] do
  begin
      TreePolygonVertices[TreePart,i,0]:=
      ((TreePolyImageVertices[TreePart,i,0]-MinX)/ (XWidth /10)) ;
      TreePolygonVertices[TreePart,i,1]:=
      ((TreePolyImageVertices[TreePart,i,1]-MinY)/ (YHeight /10)) ;
  end;
  {NOW do the HARD part... Compute the Tree Parameters
  ShapeLabel}
  LevelsNumberEdit.Text:=Inttostr(LevelCount);
  {BASE GENERAL}
  {ScaleFloatEdit.Text:=inttostr(Round(StrtoFloat(TreeHeightEdit.Text)));}
  TreeHeight:=Strtofloat(ScaleVFloatEdit.Text);
  ZScaleFloatEdit.Text:=NadaFString;
  ZScaleVFloatEdit.Text:=NadaFString;
  {Get the Tree Height to Compute Percentage of Height the Base is}
  Temp1:=(TreePolyImageVertices[0,4,1]-TreePolyImageVertices[0,0,1]);
  TempWorkerBee:=(TreePolyImageVertices[0,4,1]-TreePolyImageVertices[0,0,1]);
  BaseSizeFloatEdit.Text:= Floattostr((TreeHeight/Temp1)*(TreeHeight/TempWorkerBee));
  RatioFloatEdit.Text:=NadaFString;
  RatioPowerFloatEdit.Text:=NadaFString;
  LobesNumberEdit.Text:=NadaIString;
  LobeDepthFloatEdit.Text:=NadaFString;
  FlareFloatEdit.Text:=
    Inttostr(TreePolyImageVertices[0,4,1]-TreePolyImageVertices[0,0,1]);
  Temp3:=Temp1;
  Temp2:=Temp3; If Temp2 < Temp1 then ;

{BASE TRUNK}
  Scale0FloatEdit.Text:=NadaF1String;
  {
   ScaleV0FloatEdit.Text:=NadaFString;
   Length0FloatEdit.Text:=
     Inttostr(TreePolyImageVertices[0,4,1]-TreePolyImageVertices[0,0,1]);
   LengthV0FloatEdit.Text:=NadaFString;
   Taper0FloatEdit
   Vertices0NumberEdit
   BaseSplits0NumberEdit.Text:=NadaFString;
   SegSplits0FloatEdit
   SplitAngle0FloatEdit
   SplitAngleV0FloatEdit.Text:=NadaFString;
   CurveRes0NumberEdit
   CurveBack0FloatEdit.Text:=NadaFString;
   Curve0FloatEdit.Text:=NadaFString;
   CurveV0FloatEdit.Text:=NadaFString;  }

{FOR EACH LEVEL  }
{ For TreePart := 1 to LevelCount do
  Begin
   Length1FloatEdit
   LengthV1FloatEdit.Text:=NadaFString;
   Taper1FloatEdit.Text:=NadaFString;
   SplitAngle1FloatEdit
   SplitAngleV1FloatEdit.Text:=NadaFString;
   SegSplits1FloatEdit
   Vertices1NumberEdit
   Branches1NumberEdit
   DownAngle1FloatEdit
   DownAngleV1FloatEdit.Text:=NadaFString;
   Rotate1FloatEdit
   RotateV1FloatEdit.Text:=NadaFString;
   CurveRes1NumberEdit
   CurveBack1FloatEdit
   Curve1FloatEdit
   CurveV1FloatEdit.Text:=NadaFString;
  End;}
End;


{An image should be Power of 2 : 256x256 and Square
 THUS use for the actual Texture
 The Leaf Coordinates are Also the Texture Coords :
  SO THe Moused Coords need to be converted to
 X: -0.5..0.5: 0..1  Y: 0..1
    FROM the image X,Y 0.255, 0..255 Coordinaters}
procedure TdtmGlsTrealForm.ComputeLeafImageCoords;
var i:Integer;
Begin
  For i:=0 to LeafPolygonVerticesNumber[0] do
  begin
     LeafPolyImageVertices[0,i,0]:=
      Round((LeafPolygonVertices[0,i,0]+0.5)*255);
     LeafPolyImageVertices[0,i,1]:=
      Round((LeafPolygonVertices[0,i,1]*255*-1)+255);
  end;
End;

procedure TdtmGlsTrealForm.ComputeFruitImageCoords(InX,InY:Integer);
var i:Integer;
Begin
  For i:=0 to FruitPolygonVerticesNumber[0] do
  begin
     FruitPolyImageVertices[0,i,0]:=
      Round((FruitPolygonVertices[0,i,0]+0.5)*(InX-1));
     FruitPolyImageVertices[0,i,1]:=
      Round((FruitPolygonVertices[0,i,1]*(InY-1)*-1)+(InY-1));
  end;
  TreeImageLoaded:=False;{Set these false so ONLY 1 can be edited}
  LeafImageLoaded:=False;
  FruitImageLoaded:=False;
  ImageLoaded:=False;
  TICNoneClick(Self);
  GrabberImageBitmap.Width := InX;
  GrabberImageBitmap.Height := InY;
  GrabberImageBitmap.Canvas.Brush.Color := clWhite;
  GrabberImageBitmap.Canvas.FillRect(Rect(0,0,InX,InY));
  TracerImage.Width := GrabberImageBitmap.Width;
  TracerImage.Height := GrabberImageBitmap.Height;
  TracerImage.Picture.Assign(GrabberImageBitmap);
  {Save the file AS one having Image Coords}
End;


{Given x,y image coords Compute the REAL coords.. Image ALWAYS 256x256}
procedure TdtmGlsTrealForm.ComputeLeafRealCoords;
var   i:Integer;
Begin
  For i:=0 to LeafPolygonVerticesNumber[0] do
  begin
      LeafPolygonVertices[0,i,0]:=
      (LeafPolyImageVertices[0,i,0] /255)-0.5 ;
      LeafPolygonVertices[0,i,1]:=
      ((255-LeafPolyImageVertices[0,i,1]) /255) ;
  end;
End;


procedure TdtmGlsTrealForm.ComputeFruitRealCoords;
var
  i:Integer;
Begin
  {Given x,y image coords Compute the REAL coords
  Fruit can by any size SO must USE the Image Size}
  For i:=0 to FruitPolygonVerticesNumber[0] do
  begin
      FruitPolygonVertices[0,i,0]:=
      (FruitPolyImageVertices[0,i,0]/(TracerImage.Width-1))-0.5 ;
      FruitPolygonVertices[0,i,1]:=
      (((TracerImage.Height-1)-FruitPolyImageVertices[0,i,1])/(TracerImage.Height-1)) ;
  end;
End;


//-----------------------------------------------------
//-----------------------------------------------------
procedure TdtmGlsTrealForm.RandomTreeSeedNumberEditChange(Sender: TObject);
begin
  RandomTreeSeedNumber:=Strtoint(RandomTreeSeedNumberEdit.Text);
end;
procedure TdtmGlsTrealForm.HealthTrackBarChange(Sender: TObject);
begin
  HealthLabel.Caption:=Inttostr(HealthTrackBar.Position);
end;
procedure TdtmGlsTrealForm.DistanceTrackBarChange(Sender: TObject);
begin
  DistanceLabel.Caption:=Inttostr(DistanceTrackBar.Position);
end;
procedure TdtmGlsTrealForm.WindStrengthTBChange(Sender: TObject);
begin
  WindStrengthLabel.Caption:=Inttostr(WindStrengthTB.Position);
end;
procedure TdtmGlsTrealForm.WindGustTBChange(Sender: TObject);
begin
  WindGustLabel.Caption:=Inttostr(WindGustTB.Position);
end;
procedure TdtmGlsTrealForm.WindFromTBChange(Sender: TObject);
begin
  WindFromLabel.Caption:=Inttostr(WindFromTB.Position);
end;
procedure TdtmGlsTrealForm.SunHeightTBChange(Sender: TObject);
begin
  SunHeightLabel.Caption:=Inttostr(SunHeightTB.Position);
end;
procedure TdtmGlsTrealForm.SunStrengthTBChange(Sender: TObject);
begin
  SunStrengthLabel.Caption:=Inttostr(SunStrengthTB.Position);
end;
procedure TdtmGlsTrealForm.SunFromTBChange(Sender: TObject);
begin
  SunFromLabel.Caption:=Inttostr(SunFromTB.Position);
end;
//-----------------------------------------------------
//-----------------------------------------------------

function GetRandomValue(const UpperBound: Double): Double;
{ Pre: True
  Ret: A random value i, with i: -UpperBound <= i <= UpperBound }
var Sign: integer;
begin
  if UpperBound = 0 then Result := 0
  else
  begin
    { Determine 'nondeterministically' the sign of the result 0 or 1}
    if Random(2) = 0 then Sign := -1 else Sign := 1;
    { Calculate the result using Random that returns a Double value i,
      i: 0 <= i < 1 }
    {Multiply by < 1 is dividing so result is -UpperBound.. UpperBound}
    Result := UpperBound * Random * Sign;
  end;
end;
{where ShapeRatio( 8, ratio ) is defined as
[ ratio / ( 1 - PruneWidthPeak ) ]PrunePowerHigh
when ratio < 1 - PruneWidthPeak, or
[ ( 1 - ratio ) / ( 1 - PruneWidthPeak ) ]PrunePowerLow }
function TdtmGlsTrealForm.ShapeRat(const Shape: integer; const Ratio: Double): Double;
    begin
         if ratio < (1 - StrtoFloat(PruneWidthPeakFloatEdit.Text)) then
         Result := Power(( ratio / ( 1 - StrtoFloat(PruneWidthPeakFloatEdit.Text) ) )
                    ,StrtoFloat(PrunePowerHighFloatEdit.Text))
         else Result := Power( (( 1 - ratio )
                          / ( 1 - StrtoFloat(PruneWidthPeakFloatEdit.Text) ) )
                          ,StrtoFloat(PrunePowerLowFloatEdit.Text));
    end;
//-----------------------------------------------------
 //  wide : 320, high : 320
      // Clear to white, Per pixel If fits then black
      // Could use Bezier? or Algo-math... dunno how
      // this is similar to what the code wants to do...
//-----------------------------------------------------
procedure TdtmGlsTrealForm.PruneShapeDisplayBtnClick(Sender: TObject);
var
  insidex,insidey:Boolean;
  xWidth,yHeight : Integer;
  scalesize,TrunkLength,scaletree, r, ratiox,ratioy:Double;
begin
  PruneImage.Canvas.Brush.Color := clBlue;
  PruneImage.Canvas.Brush.Style := bsSolid;
  PruneImage.Canvas.FillRect(Rect(0,0,320,320));
  {Draw a semi circle at base and a thinny circle at top}
  for yHeight := 0 to 319 do
  begin
    Application.ProcessMessages;
    for xWidth :=0 to 319 do
    begin
      {StrtoFloat(PruneRatioFloatEdit.Text)  0=no use..1.0 :TOTAL USE }
      scaletree:=StrtoFloat(ScaleFloatEdit.Text)
           + GetRandomValue(StrtoFloat(ScaleVFloatEdit.Text));
      scalesize:= (320/(scaletree));
      r := sqrt((((160-xWidth)/scalesize)*((160-xWidth)/scalesize))
              +(((160-yHeight)/scalesize)*((160-yHeight)/scalesize)) {x2 + y2 + z2} );
      TrunkLength := (StrtoFloat(Length0FloatEdit.Text)
        + GetRandomValue(StrtoFloat(LengthV0FloatEdit.Text))) {* ScaleTree};

      ratioy := (   ((scaletree - ((yHeight)/scalesize) )/scalesize)
                  / (scaletree * (1-(TrunkLength+0.0001))) );
      ratiox := (   ((scaletree - ((xWidth)/scalesize)  )/scalesize)
                 /  (scaletree * (1-(TrunkLength+0.0001))) );
      If ((r / scaletree) < (StrtoFloat(PruneWidthFloatEdit.Text)
                             *ShapeRat( 8 , ratioy )) )
         then insidey :=true else insidey :=false;
      If   ((r / scaletree) < (StrtoFloat(PruneWidthFloatEdit.Text)
                             *ShapeRat( 8 , ratiox )) )
         then insidex :=true else insidex :=false;
      If ( ( insidex) and ( insidey)) then
        PruneImage.Canvas.Pixels[xWidth, yHeight] := clRed else
      If ( ( insidex)) then
        PruneImage.Canvas.Pixels[xWidth, yHeight] := clGreen else
      If ( ( insidey)) then
        PruneImage.Canvas.Pixels[xWidth, yHeight] := clYellow;
{            SubStemLength := FTree.TrunkLength * FLengthChildMax *
                        ShapeRatio(Shape, (FTree.TrunkLength - OffsetSubStem)
                                         / (FTree.TrunkLength - FBaseLength));}
    end;
  end;
  PruneImage.Canvas.Brush.Color := clBlue;
  PruneImage.Canvas.Polygon([Point(10, 10), Point(70, 10),
                             Point(70, 60), Point(10, 60),
                             Point(10, 10)]);
  PruneImage.Canvas.Pen.Color := clRed;
  PruneImage.Canvas.Brush.Color := clRed;
  PruneImage.Canvas.Pen.Style:=psSolid;
  PruneImage.Canvas.Pen.Width := Random(7);
  PruneImage.Canvas.Polyline([Point(40, 10), Point(20, 60),
  Point(70, 30), Point(10, 30), Point(60, 60), Point(40, 10)]);
end;
//-----------------------------------------------------
(*
r := sqrt ( x2 + y2 + z2 )
ratio := ( scaletree - z ) / ( scaletree *(1-BaseSize ) )
inside := [ r / scaletree < PruneWidth *
ShapeRatio( 8 {(envelope)}, ratio ) ]
where ShapeRatio( 8, ratio ) is defined as
[ ratio / ( 1 - PruneWidthPeak ) ]PrunePowerHigh
when ratio < 1 - PruneWidthPeak, or
[ ( 1 - ratio ) / ( 1 - PruneWidthPeak ) ]PrunePowerLow
*)
//-----------------------------------------------------
//-----------------------------------------------------











end.
