{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmGlsTrealAboutFrm;

interface

uses Windows, SysUtils, Classes, Registry,
  Graphics, Forms, Controls, StdCtrls,
  ShellAPI, Dialogs, Buttons, ExtCtrls, Consts, pngimage;

type
  TdtmGlsTrealAboutForm = class(TForm)
    Panel1: TPanel;
    Version: TLabel;
    Copyright: TLabel;
    Label1: TLabel;
    Label3: TLabel;
    BuildInfo: TLabel;
    Label12: TLabel;
    PhysMem: TLabel;
    Label13: TLabel;
    FreeRes: TLabel;
    Label10: TLabel;
    Label16: TLabel;
    WindowsVersion: TLabel;
    Label4: TLabel;
    Label2: TLabel;
    Label5: TLabel;
    SystemInformationBtn: TSpeedButton;
    DelphiButton: TSpeedButton;
    HelpBtn: TSpeedButton;
    oglImage: TImage;
    glsImage: TImage;
    BitBtn1: TBitBtn;
    Label6: TLabel;
    procedure BitBtn1Click(Sender: TObject);

    procedure oglImageClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure LoadEdits;
    procedure GetBuildInfo(var v1, v2, v3, v4: Word);
    function GetBuildInfoString: string;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Label2Click(Sender: TObject);
    procedure Label5Click(Sender: TObject);
    procedure SystemInformationBtnClick(Sender: TObject);
    procedure DelphiButtonClick(Sender: TObject);
    procedure glsImageClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dtmGlsTrealAboutForm: TdtmGlsTrealAboutForm;

implementation

{$R *.DFM}

procedure TdtmGlsTrealAboutForm.FormClose(Sender: TObject; var Action:
  TCloseAction);
begin {}
  {AboutX := AboutDTM.left;
  AboutY := AboutDTM.top;
  DoSaver; }
  ModalResult := mrOK;
end;

procedure TdtmGlsTrealAboutForm.FormCreate(Sender: TObject);
var
  MS: TMemoryStatus;
begin
  {left := AboutX;
  top := AboutY;  }
  GlobalMemoryStatus(MS);
  PhysMem.Caption := FormatFloat('#,###" KB"', MS.dwTotalPhys /
    1024);
  FreeRes.Caption := Format('%d %%', [MS.dwMemoryLoad]);
  {RNEdit.Text := StartedNameNumber; }
  LoadEdits;
end;


procedure TdtmGlsTrealAboutForm.BitBtn1Click(Sender: TObject);
begin
Close;
end;
                   


                  
procedure TdtmGlsTrealAboutForm.LoadEdits;
const
  Win95RegInfo = 'SOFTWARE\Microsoft\Windows\CurrentVersion\';
var
  OsVersionInfo: TOsVersionInfo;
begin

  OsVersionInfo.dwOSVersionInfoSize := sizeof(OsVersionInfo);
  GetVersionEx(OsVersionInfo);
  with OsVersionInfo do
  begin
    WindowsVersion.Caption := (IntToStr(dwMajorVersion) + '.'
      + IntToStr(dwMinorVersion));
{WORD HIWORD(DWORD dwValue ); // value from which high-order word is retrieved
LOWORD...}
  end;
  BuildInfo.Caption := GetBuildInfoString
end; {Of Getting ... Load}




procedure TdtmGlsTrealAboutForm.GetBuildInfo(var v1, v2, v3, v4: Word);
var
  VerInfoSize: DWord;
  VerInfo: Pointer;
  VerValueSize: DWord;
  VerValue: PVSFixedFileInfo;
  Dummy: DWord;
begin
  VerInfoSize := GetFileVersionInfoSize(PChar(Application.ExeName),
    dummy);
  GetMem(VerInfo, VerInfoSize);
  GetFileVersionInfo(PChar(Application.ExeName), 0, VerInfoSize,
    VerInfo);
  VerQueryValue(VerInfo, '\', Pointer(VerValue), VerValueSize);
  with VerValue^ do
  begin
    v1 := dwFileVersionMS shr 16;
    v2 := dwFileVersionMS and $FFFF;
    v3 := dwFileVersionLS shr 16;
    v4 := dwFileVersionLS and $FFFF;
  end;
  FreeMem(VerInfo, VerInfoSize);
end;

function TdtmGlsTrealAboutForm.GetBuildInfoString: string;
var
  v1, v2, v3, v4: Word;
begin
  GetBuildInfo(v1, v2, v3, v4);
  Result := Format('%d.%d.%d  (Build %d)', [v1, v2, v3, v4]);
end;


procedure TdtmGlsTrealAboutForm.Label2Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'mailto:ilh2o@ezl.com', '', '',  SW_SHOW);
end;

procedure TdtmGlsTrealAboutForm.Label5Click(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'http://www.ezl.com/~ilh2o/', '', '', SW_SHOW);
end;

procedure TdtmGlsTrealAboutForm.SystemInformationBtnClick(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'MSINFO32.EXE', '', '', SW_SHOW);
end;

procedure TdtmGlsTrealAboutForm.DelphiButtonClick(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'http://www.borland.com/delphi/', '', '', SW_SHOW);
end;



procedure TdtmGlsTrealAboutForm.oglImageClick(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'http://www.opengl.org/', '', '', SW_SHOW);
end;

procedure TdtmGlsTrealAboutForm.glsImageClick(Sender: TObject);
begin
  ShellExecute(0, 'open',
    'http://www.glscene.org/', '', '', SW_SHOW);
end;



procedure TdtmGlsTrealAboutForm.HelpBtnClick(Sender: TObject);
begin
ShellExecute(
Application.Handle, // handle to parent window
'open',             // pointer to string that specifies operation to perform
PChar(ExtractFilePath(Application.Exename)+'tree help\glstreal2.htm'),{PChar(POVRayExecutable),}// pointer to filename or folder name string
''{PChar(POVRayCommandLine)},// pointer to string that specifies executable-file parameters
 PChar(ExtractFilePath(Application.Exename)+'tree help'),// pointer to string that specifies default directory
SW_SHOWNORMAL);
end;

end.
