{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmHTFDEMListMakerFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ComCtrls;

type
  TdtmHTFDEMListMakerForm = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    RichEdit1: TRichEdit;
    ClearBtn: TSpeedButton;
    SelectFilesBtn: TSpeedButton;
    SaveListBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    SelectDirectoryFilesBtn: TSpeedButton;
    procedure ClearBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SaveListBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure SelectFilesBtnClick(Sender: TObject);
    procedure SelectDirectoryFilesBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dtmHTFDEMListMakerForm: TdtmHTFDEMListMakerForm;

implementation

{$R *.DFM}

uses   dtmGlobals, dtmPOFvar, dtmErrMsg;

procedure TdtmHTFDEMListMakerForm.FormCreate(Sender: TObject);
begin
{}
end;

procedure TdtmHTFDEMListMakerForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
{}
end;
procedure TdtmHTFDEMListMakerForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;


procedure TdtmHTFDEMListMakerForm.ClearBtnClick(Sender: TObject);
begin
  RichEdit1.clear;
end;


procedure TdtmHTFDEMListMakerForm.SaveListBtnClick(Sender: TObject);
begin
  SaveDialog1.InitialDir:=DemPath;
  SaveDialog1.FileName:='DemList.txt';
  If SaveDialog1.execute then
   RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
end;



procedure TdtmHTFDEMListMakerForm.SelectFilesBtnClick(Sender: TObject);
var  I: integer;
begin
  OpenDialog1.InitialDir:=DemPath;
  OpenDialog1.Options := [ofAllowMultiSelect, ofFileMustExist];
  OpenDialog1.Filter := 'DEM file(s) (*.*)|*.*';
  if OpenDialog1.Execute then
    with OpenDialog1.Files do
      for I := 0 to Count - 1 do
      begin
        RichEdit1.Lines.Append(Strings[I]);
      end;
end;


procedure TdtmHTFDEMListMakerForm.SelectDirectoryFilesBtnClick(Sender: TObject);
var
   i : Integer;
   sr : TSearchRec;
   sl : TStringList;
   OpenDialog1DemExt, OpenDialog1DemPath:String;
begin
  OpenDialog1.InitialDir:=DemPath;
  OpenDialog1.Filter:= 'DEM files (*.*)|*.*';
  if OpenDialog1.Execute then
  begin
    OpenDialog1DemPath:= ExtractFilePath(OpenDialog1.FileName);
    OpenDialog1DemExt:= ExtractFileExt(OpenDialog1.FileName);
    i:=FindFirst(OpenDialog1DemPath+'*'+OpenDialog1DemExt, faAnyFile, sr);
    sl:=TStringList.Create;
  try
    while i=0 do
    begin
      sl.Add(sr.Name);
      i:=FindNext(sr);
    end;
    sl.Sort;
    for i:=0 to sl.Count-1 do
    begin
    RichEdit1.Lines.Append(sl[i]);
    end;
  finally
    sl.Free;
    FindClose(sr);
  end;
  end;
end;





end.
