{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmHtfDem24kFrm;

{Converted from Demtools C into DTM Delphi by Ivan Lee Herring, October 2003}

interface
{ http://www.arq.net/~kasten/demtools/dist/demtools_src_current.tar.gz
  http://www.arq.net/~kasten/
  Demtools/libdem/demheader.h
  Demtools/libdem/demdefs.h
  Demtools/libdem/dem.h      ????
  Demtools/demtools/demheader.c    ????
 Demtools/dem3dmap/readfile.c     The Main Reader
      float and int readers
 Demtools/libdem/dembuildheader.c  used in Main reader
 Demtools/libdem/dempositionb.c    Inside the main reader
 Demtools/dem3dmap/ordercoords.c  used in Main reader
 Demtools/dem3dmap/readdemfile.c   Read data
 Demtools/libdem/demresfactor.c   used in dem reader
 Copyright (C) 1998 Eric Kasten
 probably a lot more..i got lazy..ILH,
   stripped out the reading.. none of the display }

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TdtmHtfDem24kForm = class(TForm)
    ProgressBar1: TProgressBar;
    Button1: TButton;
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    RichMemo: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    Decimeter, CloseUpShop:Boolean;
    FromF: file;
    NumRead: Integer;
    NewFileName, SaveFileName:String;
    DEMValverts:Array of Double;{Integer;}{Smallint;}
    Procedure ReadDemHeader;
    Procedure BuildDemHeader;
    Function demfgetint:Integer;
    Function demfgetfloat:double;
    Function demfindmaxrow:Integer;
    Function demresfactor:double;
    Function calcplotdiv:Double;
    Function calcoffset(coord:Double):Integer;
    Procedure ordercoords;
    Procedure readdemfile;
  public
    { Public declarations }
    {Called from dtmHtfFrm : Converts a DEM into ManMatrix array}
    Function DoDEM24ktoBin(var InfileName:String):Boolean;
  end;

var
  dtmHtfDem24kForm: TdtmHtfDem24kForm;

implementation

{$R *.DFM}

uses   dtmGlobals, dtmPOFvar, dtmErrMsg, dtmHtfFrm;

{  TDTEDHeader = Record     DTEDHeader.CellSizeX
     UHL:array[1..3] of char;
     CellSizeX:array[1..4] of char;
     CellSizeY:array[1..4] of char;
     DSI:array[1..3] of char;
     BottomLeftY:array[1..7] of char;
     BottomLeftX:array[1..8] of char;
     TopLeftY:array[1..7] of char;
     TopLeftX:array[1..8] of char;
     TopRightY:array[1..7] of char;
     TopRightX:array[1..8] of char;
     BottomRightY:array[1..7] of char;
     BottomRightX:array[1..8] of char;
     maxcolsX:array[1..4] of char;
     maxrowsY:array[1..5] of char;
     ACC:array[1..3] of char;
   end;      }
type { Demtools/libdem/demheader.h }
  TDemHeaderTMPL = Record
   filename:array[1..40] of char;
   freetext:array[1..40] of char;
   fill01:array[1..55] of char;
   process:Char;
   fill02:Char;
   sectind:array[1..3] of char;
   origin:array[1..4] of char;
   level:array[1..6] of char;
   pattern:array[1..6] of char;
   refcode:array[1..6] of char;
   zone:array[1..6] of char;
   mapprojparams:array[1..360] of char;
   groundunits:array[1..6] of char;
   elevationunits:array[1..6] of char;
   sides:array[1..6] of char;
   coords:array[1..192] of char;
   elevs:array[1..48] of char;
   angle:array[1..24] of char;
   accuracycode:array[1..6] of char;
   spatialresx:array[1..12] of char;
   spatialresy:array[1..12] of char;
   spatialresz:array[1..12] of char;
   rows:array[1..6] of char;
   cols:array[1..6] of char;
   maxcontour:array[1..5] of char;
   maxcontourunits:Char;
   mincontour:array[1..5] of char;
   mincontourunits:Char;
   sourcedate:array[1..4] of char;
   inspectiondate:array[1..4] of char;
   revflag:Char;
   valflag:Char;
   suspectflag:array[1..2] of char;
   vertdatum:array[1..2] of char;
   horzdatum:array[1..2] of char;
   dataedition:array[1..4] of char;
   percentvoid:array[1..4] of char;
   fill03:array[1..124] of char;
  End;

  TDemHeader = Record
     quadtext:array[1..136] of char;
     process:Char;
     sectind:array[1..4] of char;
     origin:array[1..5] of char;
     level:Integer;
     pattern:Integer;
     refcode:Integer;
     zone:Integer;
     mapprojparams:array[0..14] of Double;
     groundunits:Integer;
     elevationunits:Integer;
     sides:Integer;
     coords:array[0..3,0..1] of Double;
     maxelevation:Double;
     minelevation:Double;
     angle:Double;
     accuracycode:Integer;
     spatialresolution:array[0..2] of Double;
     rowsi:Integer;
     colsi:Integer;
     maxcontour:Integer;
     maxcontourunits:Integer;
     mincontour:Integer;
     mincontourunits:Integer;
     sourcedate:Integer;
     inspectiondate:Integer;
     revflag:Char;
     valflag:Integer;
     suspectflag:Integer;
     vertdatum:Integer;
     horzdatum:Integer;
     dataedition:Integer;
     percentvoid:Integer;
  End;
  Tdemvals = Record
    maxcols, maxrows:Integer;
    CellSize:Integer;    {:Double;}
    {actually redone: spatialresolution would work, ? integer}
  End;
var
    DemHeader: TDemHeader;
    DemHeaderTMPL: TDemHeaderTMPL;
    Demval:Tdemvals;
CONST  INVAL : Double = -9999.0;

procedure TdtmHtfDem24kForm.FormCreate(Sender: TObject);
begin
  top := dtmHtfDem24kFormY;
  left := dtmHtfDem24kFormX;
end;

procedure TdtmHtfDem24kForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  dtmHtfDem24kFormY := dtmHtfDem24kForm.top;
  dtmHtfDem24kFormX := dtmHtfDem24kForm.left;
  DoSaver;
end;

procedure TdtmHtfDem24kForm.Button1Click(Sender: TObject);
begin
  CloseUpShop:=True;
end;

{ Demtools/dem3dmap/readfile.c
Demtools/demtools/demheader.c
Demtools/dem3dmap/readdemfile.c}
Function TdtmHtfDem24kForm.DoDEM24ktoBin(var InfileName:String):Boolean;
var i,j,k:Integer;
Begin
  CloseUpShop:=False;
  SaveFileName:=InfileName;
  {Label1.Caption:=InfileName;}
  Label1.Caption:=ExtractFileName(InfileName);
  Label2.Caption:=DemPath;
  ProgressBar1.Position:=0;
  Application.ProcessMessages;
  AssignFile(FromF, InfileName);
  Reset(FromF, 1);	{ Record size = 1 }
  ProgressBar1.Position:=25;
  Application.ProcessMessages;
  Memo1.Clear;
  Memo1.Lines.Add('FileName '+ InfileName);
  ReadDemHeader;
  ProgressBar1.Position:=50;
  Application.ProcessMessages;
  BuildDemHeader;
  Label1.Caption:='Prereading: '+ExtractFileName(InfileName);
  Label2.Caption:=DemPath;
  ProgressBar1.Position:=1;
  Application.ProcessMessages;
  Demval.maxcols := DemHeader.colsi;
  Demval.maxrows := demfindmaxrow; {Height Y data varies}
  {FileSizeX  Real #  cols=across=X}
  Memo1.Lines.Add('Demval.maxcols (X) '+Inttostr(Demval.maxcols));
  Memo1.Lines.Add('Demval.maxrows (Y) '+Inttostr(Demval.maxrows));
  Application.ProcessMessages;
  ordercoords;
  Memo1.Lines.Add('CellSize '+Floattostr(calcplotdiv));
  Demval.CellSize := Round(calcplotdiv); {CellSize }
  Memo1.Lines.Add('CellSize '+Floattostr(Demval.CellSize)); {10: CellSize}

  Label1.Caption:='Processing: '+ExtractFileName(InfileName)+' to '+NewFileName;
  Label2.Caption:=DemPath;
  ProgressBar1.Position:=1;
  Application.ProcessMessages;
  try
    Setlength(DEMValverts,(Demval.maxcols*Demval.maxrows));
  except
    on EOutOfMemory do
    begin
      Setlength(DEMValverts,0);
      Application.Terminate;
    end;
  end;
  readdemfile;
  CloseFile(FromF);

  {Convert from DEMValverts ? double? to ManMatrix Smallint data}
  try
    SetLength(ManMatrix,Demval.maxcols {FileSizeX+1},Demval.maxrows{FileSizeY+1});
  except
    on EOutOfMemory do
    begin
      Setlength(ManMatrix,0);
      Application.Terminate;
    end;
  end;
  {Transfer the data from DEMValverts to  ManMatrix}
  Label1.Caption:='Transfer: '+NewFileName;
  Label2.Caption:=DemPath;
  ProgressBar1.Position:=1;
  Application.ProcessMessages;
  k:=0;
  For I := 0 to Demval.maxcols-1 do
  begin
    ProgressBar1.Position:=Round( (i /Demval.maxcols )*100);
    Application.ProcessMessages;
    For J := Demval.maxrows-1 downto 0 do
    begin
      ManMatrix[i,j]:= Round(DEMValverts[k]);
      inc(k);
    end;
  end;
  dtmHtfForm.NullValueEdit.Text :=Inttostr(Round(INVAL));{'DefaultZ='+NullValueEdit.Text;}
  dtmHtfForm.MissingValueEdit.Text :=Inttostr(Round(INVAL));
                               {Converted to smallint}
  dtmHtfForm.IntegerorFloatCB.Checked:={False;}True; {bit 32 (single) bit 16 (Intel)}
  FileSizeX:=Demval.maxcols;
  FileSizeY:=Demval.maxrows;
  dtmHtfForm.EDSizeX.Text:=IntToStr(FileSizeX);
  dtmHtfForm.EDSizeY.Text:=IntToStr(FileSizeY); {tpcfg}
  dtmHtfForm.XWidthEdit.Text:=IntToStr(FileSizeX);
  dtmHtfForm.YHeightEdit.Text:=IntToStr(FileSizeY);    {width}
  dtmHtfForm.PixelXSizeEdit.Text:=IntToStr( Round(Demval.CellSize));  {physical size}
  dtmHtfForm.PixelYSizeEdit.Text:=IntToStr( Round(Demval.CellSize));
  {dtmHtfForm.SEXEWEdit.Text:=FloatToStr(pick a Coord);
  dtmHtfForm.SEYNSEdit.Text:=FloatToStr(pick a Coord);}
  dtmHtfForm.PixelCoordinateCB.Itemindex:=0; {i guess}
  {dtmHtfForm.PixelsPerDegreeEdit.Text:=FloatToStr(Compute it);
  dtmHtfForm.KiloPerPixelEdit.Text:=FloatToStr(Compute it);}
  dtmHtfForm.MapZUnitsCB.Itemindex:= dtmHtfForm.InUnitCB.Itemindex;{Converted ? by now}
  {dtmHtfForm.ZSizeEdit.Text:= Inttostr((DEMVal.zsize));}
  Setlength(DEMValverts,0);
  ProgressBar1.Position:=0;
  Label1.Caption:='DONE HERE';
  Label2.Caption:='';
  Application.ProcessMessages;
  If CloseUpShop then
  begin
    RichMemo.Text:=Memo1.Text;
    RichMemo.Lines.SaveToFile(ChangeFileExt(SaveFileName,'.doc'));
  end;
  Result:=True;
  InfileName:=DemPath+NewFileName;
End;


Procedure TdtmHtfDem24kForm.ReadDemHeader;
Procedure DumDeDum(Error,Count:Integer);
Begin
    {So it Stops the Show}
    ShowMessage('Datum Error at: '+Inttostr(Error)+' of '+ Inttostr(Count));
End;
Begin
  {BlockRead(var F: File; var Buf; Count: Integer [; var AmtTransferred: Integer]);}
  BlockRead(FromF, DemHeaderTMPL.filename, SizeOf(DemHeaderTMPL.filename), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.filename)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.freetext, SizeOf(DemHeaderTMPL.freetext), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.freetext)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.fill01, SizeOf(DemHeaderTMPL.fill01), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.fill01)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.process, SizeOf(DemHeaderTMPL.process), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.process)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.fill02, SizeOf(DemHeaderTMPL.fill02), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.fill02)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.sectind, SizeOf(DemHeaderTMPL.sectind), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.sectind)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.origin, SizeOf(DemHeaderTMPL.origin), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.origin)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.level, SizeOf(DemHeaderTMPL.level), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.level)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.pattern, SizeOf(DemHeaderTMPL.pattern), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.pattern)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.refcode, SizeOf(DemHeaderTMPL.refcode), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.refcode)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.zone, SizeOf(DemHeaderTMPL.zone), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.zone)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.mapprojparams, SizeOf(DemHeaderTMPL.mapprojparams), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.mapprojparams)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.groundunits, SizeOf(DemHeaderTMPL.groundunits), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.groundunits)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.elevationunits, SizeOf(DemHeaderTMPL.elevationunits), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.elevationunits)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.sides, SizeOf(DemHeaderTMPL.sides), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.sides)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.coords, SizeOf(DemHeaderTMPL.coords), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.coords)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.elevs, SizeOf(DemHeaderTMPL.elevs), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.elevs)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.angle, SizeOf(DemHeaderTMPL.angle), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.angle)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.accuracycode, SizeOf(DemHeaderTMPL.accuracycode), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.accuracycode)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.spatialresx, SizeOf(DemHeaderTMPL.spatialresx), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.spatialresx)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.spatialresy, SizeOf(DemHeaderTMPL.spatialresy), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.spatialresy)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.spatialresz, SizeOf(DemHeaderTMPL.spatialresz), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.spatialresz)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.rows, SizeOf(DemHeaderTMPL.rows), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.rows)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.cols, SizeOf(DemHeaderTMPL.cols), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.cols)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.maxcontour, SizeOf(DemHeaderTMPL.maxcontour), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.maxcontour)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.maxcontourunits, SizeOf(DemHeaderTMPL.maxcontourunits), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.maxcontourunits)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.mincontour, SizeOf(DemHeaderTMPL.mincontour), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.mincontour)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.mincontourunits, SizeOf(DemHeaderTMPL.mincontourunits), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.mincontourunits)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.sourcedate, SizeOf(DemHeaderTMPL.sourcedate), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.sourcedate)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.inspectiondate, SizeOf(DemHeaderTMPL.inspectiondate), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.inspectiondate)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.revflag, SizeOf(DemHeaderTMPL.revflag), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.revflag)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.valflag, SizeOf(DemHeaderTMPL.valflag), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.valflag)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.suspectflag, SizeOf(DemHeaderTMPL.suspectflag), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.suspectflag)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.vertdatum, SizeOf(DemHeaderTMPL.vertdatum), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.vertdatum)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.horzdatum, SizeOf(DemHeaderTMPL.horzdatum), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.horzdatum)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.dataedition, SizeOf(DemHeaderTMPL.dataedition), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.dataedition)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.percentvoid, SizeOf(DemHeaderTMPL.percentvoid), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.percentvoid)then DumDeDum(1,NumRead);
  BlockRead(FromF, DemHeaderTMPL.fill03, SizeOf(DemHeaderTMPL.fill03), NumRead);
  If NumRead <> SizeOf(DemHeaderTMPL.fill03)then DumDeDum(1,NumRead);
End;


//*======================================================================*/
//* dembuildheader        Demtools/libdem/dembuildheader.c          */
//*                                                                      */
//* Build the DEM header struct from the DEM header template.            */
//*                                                                      */
Procedure TdtmHtfDem24kForm.BuildDemHeader;
var
  i,k:Integer;
  TempString:String;
Begin
  For i:= 1 to 40 do DemHeader.quadtext[i]:=DemHeaderTMPL.filename[i];
  {dem->quadtext[40] = '\0';
  strncat(dem->quadtext,demtmpl->freetext,40);
  strncat(dem->quadtext,demtmpl->fill01,55);}

  Memo1.Lines.Add('Header '+DemHeader.quadtext);
  {Make Filename State_Name_ID.dem}
  TempString:=Trim(Copy(DemHeader.quadtext,pos(',',DemHeader.quadtext)+2,2));
  NewFileName:=TempString+'_'
               +Trim(Copy(DemHeader.quadtext,0,pos(',',DemHeader.quadtext)-1));
  NewFileName:=Trim(Lowercase(NewFileName));
  NewFileName:=NewFileName+'_'+Lowercase(ExtractFileName(SaveFileName));
  For i:= 0 to length(NewFileName) do
    If ((NewFileName[i]=' ') )then NewFileName[i]:='_';
  Memo1.Lines.Add('New File Name '+NewFileName);
  Memo1.Lines.Add('notes '+DemHeaderTMPL.freetext);
  Memo1.Lines.Add('fill01 '+DemHeaderTMPL.fill01);
  DemHeader.process := DemHeaderTMPL.process;
  Memo1.Lines.Add('process '+DemHeader.process);

  {strncpy(dem->sectind,demtmpl->sectind,3);
  dem->sectind[3] = '\0';}
  For i:= 1 to 3 do DemHeader.sectind[i]:=DemHeaderTMPL.sectind[i];
  Memo1.Lines.Add('sectind '+DemHeader.sectind);
  {strncpy(dem->origin,demtmpl->origin,4);
  dem->origin[4] = '\0';}
  For i:= 1 to 4 do DemHeader.origin[i]:=DemHeaderTMPL.origin[i];
  Memo1.Lines.Add('origin '+DemHeader.origin);
  {dem->level = demgetint(demtmpl->level,6);}
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.level[i];
   TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.level:=Strtoint(TempString);
    Memo1.Lines.Add('level '+TempString);
  {dem->pattern = demgetint(demtmpl->pattern,6);}
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.pattern[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.pattern:=Strtoint(TempString);
    Memo1.Lines.Add('pattern '+TempString);
  {dem->refcode = demgetint(demtmpl->refcode,6);}
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.refcode[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.refcode:=Strtoint(TempString);
    Memo1.Lines.Add('refcode '+TempString);
    dtmHtfForm.ProjectionCB.ItemIndex:=DemHeader.refcode;
  {dem->zone = demgetint(demtmpl->zone,6);}
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.zone[i];
    TempString:=Trim(TempString);If Length(TempString) >0 then
    DemHeader.zone:=Strtoint(TempString);
    Memo1.Lines.Add('zone '+TempString);
    Case DemHeader.refcode of
    0: dtmHtfForm.InUtmZoneCB.ItemIndex:=61;
    1: dtmHtfForm.InUtmZoneCB.ItemIndex:=DemHeader.zone;
    2: dtmHtfForm.StatePlaneZoneEdit.Text:=TempString;
    end;
  {dem->minelevation = demgetfloat(&(demtmpl->elevs[0]),24);}
     Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 1 to 24 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end; TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[0]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[0] '+TempString);
    dtmHtfForm.DLGPA1.Text:=Floattostr(DemHeader.mapprojparams[0]);
  {dem->maxelevation = demgetfloat(&(demtmpl->elevs[24]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  25 to 48 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[1]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[1] '+TempString);
    dtmHtfForm.DLGPA2.Text:=Floattostr(DemHeader.mapprojparams[1]);

       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  49 to 72 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[2]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[2] '+TempString);
    dtmHtfForm.DLGPA3.Text:=Floattostr(DemHeader.mapprojparams[2]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 73 to 96  do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[3]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[3] '+TempString);
    dtmHtfForm.DLGPB1.Text:=Floattostr(DemHeader.mapprojparams[3]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  97 to 120 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[4]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[4] '+TempString);
    dtmHtfForm.DLGPB2.Text:=Floattostr(DemHeader.mapprojparams[4]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 121 to 144 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[5]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[5] '+TempString);
    dtmHtfForm.DLGPB3.Text:=Floattostr(DemHeader.mapprojparams[5]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  145 to 168 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[6]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[6] '+TempString);
    dtmHtfForm.DLGPC1.Text:=Floattostr(DemHeader.mapprojparams[6]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 169 to 192 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[7]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[7] '+TempString);
    dtmHtfForm.DLGPC2.Text:=Floattostr(DemHeader.mapprojparams[7]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  193 to 216 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[8]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[8] '+TempString);
    dtmHtfForm.DLGPC3.Text:=Floattostr(DemHeader.mapprojparams[8]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  217 to 240 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[9]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[9] '+TempString);
    dtmHtfForm.DLGPD1.Text:=Floattostr(DemHeader.mapprojparams[9]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  241 to 264 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end; TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[10]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[10] '+TempString);
    dtmHtfForm.DLGPD2.Text:=Floattostr(DemHeader.mapprojparams[10]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  265 to 288 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[11]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[11] '+TempString);
    dtmHtfForm.DLGPD3.Text:=Floattostr(DemHeader.mapprojparams[11]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  290 to 312 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[12]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[12] '+TempString);
    dtmHtfForm.DLGPE1.Text:=Floattostr(DemHeader.mapprojparams[12]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  313 to 336 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[13]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[13] '+TempString);
    dtmHtfForm.DLGPE2.Text:=Floattostr(DemHeader.mapprojparams[13]);
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  337 to 360 do
  begin
    TempString[k]:=DemHeaderTMPL.mapprojparams[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.mapprojparams[14]:=Strtofloat(TempString);
    Memo1.Lines.Add('mapprojparams[14] '+TempString);
    dtmHtfForm.DLGPE3.Text:=Floattostr(DemHeader.mapprojparams[14]);

  {dem->groundunits = demgetint(demtmpl->groundunits,6); }
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.groundunits[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.groundunits:=Strtoint(TempString);
    Memo1.Lines.Add('groundunits '+TempString);
    dtmHtfForm.InUnitCB.ItemIndex:=(DemHeader.groundunits);
  {dem->elevationunits = demgetint(demtmpl->elevationunits,6);}
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.elevationunits[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.elevationunits:=Strtoint(TempString);
    Memo1.Lines.Add('elevationunits '+TempString);
    dtmHtfForm.MapZUnitsCB.ItemIndex:=StrToInt(TempString);
    {NO, All dem are floats, this transforms them to Integer...
    If (DemHeader.elevationunits=? ) then HtfForm.bZisInteger :=False;}
  {dem->sides = demgetint(demtmpl->sides,6);}
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.sides[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.sides:=Strtoint(TempString);
    Memo1.Lines.Add('sides '+TempString);
  {dem->coords[0][0] = demgetfloat(&(demtmpl->coords[0]),24); }
   Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=   1 to 24  do
  begin
    TempString[k]:=DemHeaderTMPL.coords[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.coords[0,0]:=Strtofloat(TempString);
    Memo1.Lines.Add('Coords[0,0] '+TempString);
  {dem->coords[0][1] = demgetfloat(&(demtmpl->coords[24]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=   25 to 48  do
  begin
    TempString[k]:=DemHeaderTMPL.coords[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.coords[0,1]:=Strtofloat(TempString);
    Memo1.Lines.Add('Coords[0,1] '+TempString);

       dtmHtfForm.BottomLeftXEdit.Text:= FloattostrF(DemHeader.coords[0,0],ffFixed,15,15);
       dtmHtfForm.BottomLeftYEdit.Text:= FloattostrF(DemHeader.coords[0,1],ffFixed,15,15);
  {dem->coords[1][0] = demgetfloat(&(demtmpl->coords[48]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  49 to 72  do
  begin
    TempString[k]:=DemHeaderTMPL.coords[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.coords[1,0]:=Strtofloat(TempString);
    Memo1.Lines.Add('Coords[1,0] '+TempString);
  {dem->coords[1][1] = demgetfloat(&(demtmpl->coords[72]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 73 to 96  do
  begin
    TempString[k]:=DemHeaderTMPL.coords[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.coords[1,1]:=Strtofloat(TempString);
    Memo1.Lines.Add('Coords[1,1] '+TempString);

       dtmHtfForm.TopLeftXEdit.Text:= FloattostrF(DemHeader.coords[1,0],ffFixed,15,15);
       dtmHtfForm.TopLeftYEdit.Text:= FloattostrF(DemHeader.coords[1,1],ffFixed,15,15);
  {dem->coords[2][0] = demgetfloat(&(demtmpl->coords[96]),24); }
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 97 to 120 do
  begin
    TempString[k]:=DemHeaderTMPL.coords[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.coords[2,0]:=Strtofloat(TempString);
    Memo1.Lines.Add('Coords[2,0] '+TempString);
  {dem->coords[2][1] = demgetfloat(&(demtmpl->coords[120]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 121 to 144 do
  begin
    TempString[k]:=DemHeaderTMPL.coords[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end; TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.coords[2,1]:=Strtofloat(TempString);
    Memo1.Lines.Add('Coords[2,1] '+TempString);
       dtmHtfForm.TopRightXEdit.Text:= FloattostrF(DemHeader.coords[2,0],ffFixed,15,15);
       dtmHtfForm.TopRightYEdit.Text:= FloattostrF(DemHeader.coords[2,1],ffFixed,15,15);
  {dem->coords[3][0] = demgetfloat(&(demtmpl->coords[144]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 145 to 168 do
  begin
    TempString[k]:=DemHeaderTMPL.coords[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.coords[3,0]:=Strtofloat(TempString);
    Memo1.Lines.Add('Coords[3,0] '+TempString);
  {dem->coords[3][1] = demgetfloat(&(demtmpl->coords[168]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  169 to 192 do
  begin
    TempString[k]:=DemHeaderTMPL.coords[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.coords[3,1]:=Strtofloat(TempString);
    Memo1.Lines.Add('Coords[3,1] '+TempString);
       dtmHtfForm.BottomRightXEdit.Text:= FloattostrF(DemHeader.coords[3,0],ffFixed,15,15);
       dtmHtfForm.BottomRightYEdit.Text:= FloattostrF(DemHeader.coords[3,1],ffFixed,15,15);

  {dem->minelevation = demgetfloat(&(demtmpl->elevs[0]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  1 to 24 do
  begin
    TempString[k]:=DemHeaderTMPL.elevs[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.minelevation:=Strtofloat(TempString);
    Memo1.Lines.Add('minelevation '+TempString);
    MinimumElevation := Round(DemHeader.minelevation);
  {dem->maxelevation = demgetfloat(&(demtmpl->elevs[24]),24);}
       Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:=  25 to 48 do
  begin
    TempString[k]:=DemHeaderTMPL.elevs[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.maxelevation:=Strtofloat(TempString);
    Memo1.Lines.Add('maxelevation '+TempString);
    MaximumElevation := Round(DemHeader.maxelevation);
  {dem->angle = demgetfloat(demtmpl->angle,24);}
     Setlength(TempString,24);  For i:= 1 to 24 do TempString[i]:=' ';
  k:=1;
  For i:= 1 to 24 do
  begin
    TempString[k]:=DemHeaderTMPL.angle[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.angle:=Strtofloat(TempString);
    Memo1.Lines.Add('angle '+TempString);

  {dem->accuracycode = demgetint(demtmpl->accuracycode,6);}
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.accuracycode[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.accuracycode:=Strtoint(TempString);
    Memo1.Lines.Add('accuracycode '+TempString);
  {dem->spatialresolution[0] = demgetfloat(demtmpl->spatialresx,12);}
     Setlength(TempString,12);  For i:= 1 to 12 do TempString[i]:=' ';
  k:=1;
  For i:=  1 to 12 do
  begin
    TempString[k]:=DemHeaderTMPL.spatialresx[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.spatialresolution[0]:=Strtofloat(TempString);
    Memo1.Lines.Add('spatialresolution[0] '+TempString);
    dtmHtfForm.PixelXSizeEdit.Text:=FloattostrF(DemHeader.spatialresolution[0],ffFixed,15,15);
    Case Round(DemHeader.spatialresolution[0]) of
    10:dtmHtfForm.SourceCB.ItemIndex:=1; { 1: 10M dem  2: 30M dem }
    30:dtmHtfForm.SourceCB.ItemIndex:=2;
    else dtmHtfForm.SourceCB.ItemIndex:=0;{NA}
    end;

  {dem->spatialresolution[1] = demgetfloat(demtmpl->spatialresy,12);}
     Setlength(TempString,12);  For i:= 1 to 12 do TempString[i]:=' ';
  k:=1;
  For i:=  1 to 12 do
  begin
    TempString[k]:=DemHeaderTMPL.spatialresy[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.spatialresolution[1]:=Strtofloat(TempString);
    Memo1.Lines.Add('spatialresolution[1] '+TempString);
    dtmHtfForm.PixelYSizeEdit.Text:=FloattostrF(DemHeader.spatialresolution[1],ffFixed,15,15);
  {dem->spatialresolution[2] = demgetfloat(demtmpl->spatialresz,12);}
   {Check for them being equal...}
     Setlength(TempString,12);  For i:= 1 to 12 do TempString[i]:=' ';
  k:=1;
  For i:=  1 to 12 do
  begin
    TempString[k]:=DemHeaderTMPL.spatialresz[i];
    If (TempString[k] ='D') then TempString[k]:='E';
    inc(k);
  end;  TempString:=Trim(TempString); TempString:='0'+TempString;
    DemHeader.spatialresolution[2]:=Strtofloat(TempString);
    Memo1.Lines.Add('spatialresolution[2] '+TempString);
    dtmHtfForm.ZSizeEdit.Text:= FloattostrF(DemHeader.spatialresolution[2],ffFixed,15,15);

    If (DemHeader.spatialresolution[2] < 1) then
       Decimeter:=True else Decimeter:=False;

  {dem->rows = demgetint(demtmpl->rows,6); }
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.rows[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.rowsi:=Strtoint(TempString);
    Memo1.Lines.Add('rows '+TempString);
  {dem->cols = demgetint(demtmpl->cols,6);}
   Setlength(TempString,6);  For i:= 1 to 6 do TempString[i]:=' ';
  For i:= 1 to 6 do TempString[i]:=DemHeaderTMPL.cols[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.colsi:=Strtoint(TempString);
    Memo1.Lines.Add('cols '+TempString);
  {dem->maxcontour = demgetint(demtmpl->maxcontour,5);}
   Setlength(TempString,5);  For i:= 1 to 5 do TempString[i]:=' ';
  For i:= 1 to 5 do TempString[i]:=DemHeaderTMPL.maxcontour[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.maxcontour:=Strtoint(TempString);
    Memo1.Lines.Add('maxcontour '+TempString);
  {dem->maxcontourunits = demgetint(&(demtmpl->maxcontourunits),1);}
   TempString:=DemHeaderTMPL.maxcontourunits;
    Trim(TempString); If Length(TempString) >0 then
    DemHeader.maxcontourunits:=Strtoint(TempString);
    Memo1.Lines.Add('maxcontourunits '+TempString);
  {dem->mincontour = demgetint(demtmpl->mincontour,5); }
     Setlength(TempString,5);  For i:= 1 to 5 do TempString[i]:=' ';
  For i:= 1 to 5 do TempString[i]:=DemHeaderTMPL.mincontour[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.mincontour:=Strtoint(TempString);
    Memo1.Lines.Add('mincontour '+TempString);
  {dem->mincontourunits = demgetint(&(demtmpl->mincontourunits),1);}
  TempString:=DemHeaderTMPL.mincontourunits;
    TempString:=Trim(TempString);If Length(TempString) >0 then
    DemHeader.mincontourunits:=Strtoint(TempString);
    Memo1.Lines.Add('mincontourunits '+TempString);
  {dem->sourcedate = demgetint(demtmpl->sourcedate,4);  }
     Setlength(TempString,4);  For i:= 1 to 4 do TempString[i]:=' ';
  For i:= 1 to 4 do TempString[i]:=DemHeaderTMPL.sourcedate[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.sourcedate:=Strtoint(TempString);
    Memo1.Lines.Add('sourcedate '+TempString);
  {dem->inspectiondate = demgetint(demtmpl->inspectiondate,4); }
   Setlength(TempString,4);  For i:= 1 to 4 do TempString[i]:=' ';
  For i:= 1 to 4 do TempString[i]:=DemHeaderTMPL.inspectiondate[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.inspectiondate:=Strtoint(TempString);
    Memo1.Lines.Add('inspectiondate '+TempString);
  {dem->revflag = demtmpl->revflag; }
  DemHeader.revflag:=DemHeaderTMPL.revflag;
    Memo1.Lines.Add('revflag '+DemHeader.revflag);
  {dem->valflag = demgetint(&(demtmpl->valflag),1); }
  TempString:=DemHeaderTMPL.valflag;
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.valflag:=Strtoint(TempString);
    Memo1.Lines.Add('valflag '+TempString);
  {dem->suspectflag = demgetint(demtmpl->suspectflag,2); }
     Setlength(TempString,2);  For i:= 1 to 2 do TempString[i]:=' ';
  For i:= 1 to 2 do TempString[i]:=DemHeaderTMPL.suspectflag[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.suspectflag:=Strtoint(TempString);
    Memo1.Lines.Add('suspectflag '+TempString);
  {dem->vertdatum = demgetint(demtmpl->vertdatum,2); }
     Setlength(TempString,2);  For i:= 1 to 2 do TempString[i]:=' ';
  For i:= 1 to 2 do TempString[i]:=DemHeaderTMPL.vertdatum[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.vertdatum:=Strtoint(TempString);
    Memo1.Lines.Add('vertdatum '+TempString);
  {dem->horzdatum = demgetint(demtmpl->horzdatum,2); }
     Setlength(TempString,2);  For i:= 1 to 2 do TempString[i]:=' ';
  For i:= 1 to 2 do TempString[i]:=DemHeaderTMPL.horzdatum[i];
    TempString:=Trim(TempString);If Length(TempString) >0 then
    DemHeader.horzdatum:=Strtoint(TempString);
    Memo1.Lines.Add('horzdatum '+TempString);

      If Length(TempString)>1 then
      begin
      I:=StrToInt(TempString);
      If I>0 then
      begin  {InDatumCB  IS NOT 0!}
      case I of
      1: dtmHtfForm.InDatumCB.ItemIndex:=13 {Nad27};
      2: dtmHtfForm.InDatumCB.ItemIndex:=22 {WGS72};
      3: dtmHtfForm.InDatumCB.ItemIndex:=23 {WGS 84};
      4: dtmHtfForm.InDatumCB.ItemIndex:=14 {NAD83};
      5: dtmHtfForm.InDatumCB.ItemIndex:=15 {Old Hawaii};
      6: dtmHtfForm.InDatumCB.ItemIndex:=18 {Puerto Rico};
      else dtmHtfForm.InDatumCB.ItemIndex:=13;
      end;{Case}
      end else dtmHtfForm.InDatumCB.ItemIndex:=13;
      end else dtmHtfForm.InDatumCB.ItemIndex:=13; {DEM 1* = Nad27}

  {dem->dataedition = demgetint(demtmpl->dataedition,4);}
     Setlength(TempString,4);  For i:= 1 to 4 do TempString[i]:=' ';
  For i:= 1 to 4 do TempString[i]:=DemHeaderTMPL.dataedition[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.dataedition:=Strtoint(TempString);
    Memo1.Lines.Add('dataedition '+TempString);
  {dem->percentvoid = demgetint(demtmpl->percentvoid,4);}
     Setlength(TempString,4);  For i:= 1 to 4 do TempString[i]:=' ';
  For i:= 1 to 4 do TempString[i]:=DemHeaderTMPL.percentvoid[i];
    TempString:=Trim(TempString); If Length(TempString) >0 then
    DemHeader.percentvoid:=Strtoint(TempString);
    Memo1.Lines.Add('percentvoid '+TempString);
End;


//*======================================================================*/
//* demfgetint                                                           */
//*                                                                      */
//* Read a DEM int from the specified file.                              */
//*                                                                      */
Function TdtmHtfDem24kForm.demfgetint:Integer;
var
   intch:char;
   i:Integer;
   in64:String;{char in[64];}
Begin
  Setlength(in64,0);
  Setlength(in64,64); For i:= 1 to 64 do in64[i]:=' ';
{  in64[1] :=' ';}
  BlockRead(FromF,intch,1); in64[1] := intch;
  while(intch = ' ')do begin BlockRead(FromF,intch,1);end;
  i:=2;
  in64[2] := intch;
  BlockRead(FromF,intch,1);
  while (not(intch = ' ')) do
  begin
    inc(i);
    in64[i] := intch;
    BlockRead(FromF,intch,1);
  end;
  in64:=Trim(in64);
  {showmessage(':'+in64); }
  Result:=strtoint(in64);
  Setlength(in64,0);
End;
//*======================================================================*/
//* demfgetfloat                                                         */
//*                                                                      */
//* Read a DEM float value from the specified file.                      */
//*                                                                      */
Function TdtmHtfDem24kForm.demfgetfloat:double;
var
   ch:char;
   i,j:Integer;
   in64:String;{char in[64];}
Begin
  Setlength(in64,0);
  Setlength(in64,64);  For i:= 1 to 64 do in64[i]:=' ';
  in64[1] :='0';
  BlockRead(FromF,ch,1);
  while(ch = ' ')do BlockRead(FromF,ch,1);
  i:=2;
  in64[i] := ch;
  while (not(ch = ' ')) do
  begin
    BlockRead(FromF,ch,1);
    if(ch = 'D') then ch := 'E';
    inc(i);
    in64[i] := ch;
    if (ch = 'E') then begin
      for j := 0 to 2 do begin
        BlockRead(FromF,ch,1);
        inc(i);
        in64[i] :=ch;
      end;
    end;
  end;
  in64:=Trim(in64);  in64:='0'+in64;
  Result:=strtofloat(in64);
  Setlength(in64,0);
End;



//*======================================================================*/
//* demresfactor    Demtools/libdem/demresfactor.c
//*                                                                      */
//* Calculate the elevation multiplier to put the elevation values       */
//* into the same units as the ground coordinates.                       */
//*                                                                      */
Function TdtmHtfDem24kForm.demresfactor:double;
//* Crude estimate of the number of meters in an arc-second */
CONST
ARCSEC2METER :Double = 26.8333333;
METERS2FEET  :Double = 3.28083333;
DEM_UNIT_RADIANS :Integer=         0;
DEM_UNIT_FEET :Integer=            1;
DEM_UNIT_METERS :Integer=          2;
DEM_UNIT_ARCSECS :Integer=         3;
var   zfactor:double;
Begin  { (DemHeader:tdemheader)}
   zfactor := 1.0;
  if (DemHeader.groundunits = DemHeader.elevationunits) then
  begin
    Result:=(DemHeader.spatialresolution[2]/DemHeader.spatialresolution[0]);
    exit;
  end;

  if (DemHeader.groundunits = DEM_UNIT_FEET)then
  begin
    if (DemHeader.elevationunits = DEM_UNIT_METERS) then zfactor := METERS2FEET
  end
  else if (DemHeader.groundunits = DEM_UNIT_METERS) then
  begin
    if (DemHeader.elevationunits = DEM_UNIT_FEET) then zfactor := 1.0/METERS2FEET
  end
  else if (DemHeader.groundunits = DEM_UNIT_ARCSECS) then
  begin
    if (DemHeader.elevationunits = DEM_UNIT_METERS) then zfactor := 1.0/ARCSEC2METER
    else
    if (DemHeader.elevationunits = DEM_UNIT_FEET)then
      zfactor := (1.0/METERS2FEET)/ARCSEC2METER
    else zfactor := 1.0;
  end;
  Result:=((DemHeader.spatialresolution[2]*zfactor)/DemHeader.spatialresolution[0]);
End;




//======================================================================
// demfindmaxrow
// A Whole lot of Compiler Shut Ups... Just to Count the Rows
// Search the DEM elevation for the profile with the maximum number
// of values.
{int demfindmaxrow(FILE *demfile,int maxcols)}
Function TdtmHtfDem24kForm.demfindmaxrow:Integer;
var
  i,i2,cur_c,cur_r,rows,maxrow:Integer;
  DoDa:Double;
Begin    {(demfp,DemHeader.cols)}
  //dempositionB(demfile); //No need already there...
  cur_c := demfgetint;
  cur_r := demfgetint;  If cur_r<0 then ;
  rows := demfgetint;
  i:=demfgetint; If i<0 then ; //* max col info -- usually 1 */
  maxrow := rows;
  while(cur_c < Demval.maxcols) do
  begin
    ProgressBar1.Position:=Round((cur_c / Demval.maxcols)*100);
    Application.ProcessMessages;
    DoDa:=demfgetfloat; If DoDa<0 then ;
    DoDa:=demfgetfloat; If DoDa<0 then ;
    DoDa:=demfgetfloat; If DoDa<0 then ;
    DoDa:=demfgetfloat;If DoDa<0 then ;
    DoDa:=demfgetfloat; If DoDa<0 then ;
    i2:=0;
    for i := 1 to rows{-1 ?} do i2:=demfgetint;
       If i2<0 then ;
    cur_r := demfgetint;  If cur_r<0 then ;
    cur_c := demfgetint;
    rows := demfgetint;
    i2:=demfgetint; If i2<0 then ; //* max col info -- usually 1 */
    if (rows > maxrow)then maxrow := rows;
  end;
  Result:=maxrow;
End;


//======================================================================
// calcplotdiv
//
// Calculate the number of map coordinate points that should be
// combined to make up a single pixel.
//   float calcplotdiv(demheader *demh,int maxrow)
Function TdtmHtfDem24kForm.calcplotdiv:Double;
var midx1,midx2:Double;
Begin  {(DemHeader,demvals.maxrow);}
  midx1 := abs(DemHeader.coords[0][1] - DemHeader.coords[2][1]);
  midx2 := abs(DemHeader.coords[1][1] - DemHeader.coords[3][1]);
  if (midx1 > midx2) then Result:=(midx1/Demval.maxrows)
  else Result:=(midx2/Demval.maxrows);
End;


//*======================================================================*/
//* calcoffset                                                          */
//*                                                                     */
//* Calculate the DEM data offset.  That is, how many quads does the    */
//* data extend to either end of the profiles.  This happens because    */
//* the quads are not necessarily perfectly square.                     */
//*                                  ,plotsize                    */
Function TdtmHtfDem24kForm.calcoffset(coord:Double):Integer;
var
  minx:Double;
  ppos:Integer;
Begin
  if (DemHeader.coords[0,0] < DemHeader.coords[2,0]) then
    minx := DemHeader.coords[0][0]
    else minx := DemHeader.coords[2][0];
  ppos := trunc((coord  - minx) / Demval.Cellsize);
  if (ppos < 0) then ppos := 0;
  Result:=(ppos);
End;



//*=====================================================================*/
//* ordercoords       Demtools/dem3dmap/ordercoords.c       */
//*                                                                     */
//* Order the coordinates in a top to bottom, left to right ordering    */
//* Note that this convenient for further calculations by other routines*/
//* in this program, but changes the order of coords stored in the      */
//* DEM header.                                                         */
//*                                                                     */
Procedure TdtmHtfDem24kForm.ordercoords;
var      { (DemHeader: tdemheader)}
   i,idx1,idx2:Integer;
   ym1,ym2:Double;
  wrkcoords:Array[0..3,0..1] of Double;
  wrk:Integer;
  ordmatrix:array[0..3] of Integer; {0,1,2,3}
Begin
  idx1 := 0;
  idx2 := 1;
  ordmatrix[0] := 0;ordmatrix[1] := 1;ordmatrix[2] := 2;ordmatrix[3] := 3;
  ym1 := DemHeader.coords[0,1];
  ym2 := DemHeader.coords[1,1];

  //* find the upper two coordinates */
  for i := 2 to 3 do begin
    if (ym1 < DemHeader.coords[i][1]) then
    begin
      if (ym1 > ym2) then
      begin
        idx2 := idx1;
        ym2 := ym1;
      end;

      idx1 := i;
      ym1 := DemHeader.coords[i][1];
    end else if (ym2 < DemHeader.coords[i][1]) then
    begin
      idx2 := i;
      ym2 := DemHeader.coords[i][1];
    end;
  end;

  if (DemHeader.coords[idx2][0] < DemHeader.coords[idx1][0]) then
  begin
    wrk := idx1;
    idx1 := idx2;
    idx2 := wrk;
  end;

  wrk := ordmatrix[0];
  ordmatrix[0] := idx1;
  ordmatrix[idx1] := wrk;
  wrk := ordmatrix[1];
  ordmatrix[1] := idx2;
  ordmatrix[idx2] := wrk;

  idx1 := ordmatrix[2];
  idx2 := ordmatrix[3];

  if (DemHeader.coords[idx2,0] < DemHeader.coords[idx1,0]) then
  begin
    wrk := idx1;
    idx1 := idx2;
    idx2 := wrk;
  end;

  ordmatrix[2] := idx1;
  ordmatrix[3] := idx2;

  for i := 0 to 3 do begin
    wrkcoords[i,0] := DemHeader.coords[ordmatrix[i],0];
    wrkcoords[i,1] := DemHeader.coords[ordmatrix[i],1];
  end;

  for i := 0 to 3 do begin
    DemHeader.coords[i,0] := wrkcoords[i,0];
    DemHeader.coords[i,1] := wrkcoords[i,1];
  end;

End;


//*======================================================================*/
//* readdemfile   Demtools/dem3dmap/readdemfile.c
//*                                                                     */
//* Read the DEM elevations into an array of vertices.                  */
//*
{(FILE *demfile,demheader *demh,float cscale,
int maxrows,int maxcols,float psize,GLfloat verts[])     psize:Integer
                             (maxrows, maxcols :Integer)}
Procedure TdtmHtfDem24kForm.readdemfile;

var
TempChar:Char;
{val,j,} pos,cnt,offset,I,cur_c,cur_r,rows:Integer;
j,FeFiFo,demrfact, coord,localelev:Double;
Begin
  cnt := 0;  If cnt>0 then ;
  pos := 0;  If pos>0 then ;
  {dempositionB(demfile);  Reset File}
  Reset(FromF, 1);
  For i:= 1 to 1024 do BlockRead(FromF, TempChar, 1);

  cur_c := demfgetint;{(demfile)}
  cur_r := demfgetint;    If cur_r<0 then ;
  rows := demfgetint;
  i:=demfgetint;  If i<0 then ;//* max col info -- usually 1 */

  while cur_c <= Demval.maxcols do
  begin
    ProgressBar1.Position:=Round((cur_c / Demval.maxcols)*100);
    Application.ProcessMessages;
    coord := demfgetfloat;
    FeFiFo:=demfgetfloat; If FeFiFo<0 then ;
    localelev := demfgetfloat;
    FeFiFo:=demfgetfloat; If FeFiFo<0 then ;
    FeFiFo:=demfgetfloat; If FeFiFo<0 then ;
    pos := 0;

    offset := calcoffset({demh,}coord{,Demval.plotsize});
    {ERROR ? where}
    {Is the Null area on the Far side? }
     {Left side Kludge Only good for USA?}
    If ((cur_c <25)and(rows < Demval.maxrows)) then offset :=0 else
     {Right side Kludge Only good for USA? There is a blip}
    If ((cur_c > (Demval.maxcols-30)){and(rows < Demval.maxrows)
    and (offset>(Demval.maxrows div 2))}) then offset :=Demval.maxrows - rows else
    {His fix mover... should be ok for the right side ?..?}
    if ((rows+offset) > Demval.maxrows) then offset := Demval.maxrows - rows;
    {Fill Near side: Bottom.. done on the Right side}
    for i := 1 to offset do
    begin
      DEMValverts[pos+((cur_c - 1)*Demval.maxrows)] := INVAL;
      inc(pos);
    end;
    {Actually GET the data}
    for i := 1 to rows do
    begin                   {This part is bogus? should be + ?}
      j := ((demfgetint + localelev) - DemHeader.minelevation);
      DEMValverts[pos+((cur_c - 1)*Demval.maxrows)] := j;
      {if (DEMValverts[pos+((cur_c - 1)*maxrows)] > DEMVal.zsize) then
      begin
        DEMVal.zsize := DEMValverts[pos+((cur_c - 1)*maxrows)];
      end;}
{      If (j > DEMVal.zsize) then DEMVal.zsize :=round(j);}
      inc(pos);
    end;
    {Fill the Far side: Top: done on the Left side}
    for i := rows+offset to Demval.maxrows-1 do begin
      DEMValverts[pos+((cur_c - 1) * Demval.maxrows)] := INVAL;
      inc(pos);
    end;
    {Get ready to do next loop}
    if (cur_c < Demval.maxcols) then
    begin
      cur_r := demfgetint;   If cur_r<0 then ;
      cur_c := demfgetint;
      rows := demfgetint;
      i:=demfgetint; If i<0 then ; //* max col info -- usually 1 */
    end else
    begin
      inc(cur_c);
    end;
  End;
  {Correct A Mundo}
  demrfact:= demresfactor;
  If Decimeter then demrfact:= demresfactor*10;
  for i := 0 to (Demval.maxrows * Demval.maxcols) do
  begin
    if (DEMValverts[i] = INVAL)then DEMValverts[i] := INVAL
    else DEMValverts[i] := (DEMValverts[i] * demrfact);
  end;

{dont do display here...
  Demval.zsize := Round(DEMVal.zsize * demrfact);
  DEMVal.divsiz := DEMVal.zsize;
  if (DEMVal.divsiz < DEMVal.ysize)then DEMVal.divsiz := DEMVal.ysize;
  if (DEMVal.divsiz < DEMVal.xsize)then DEMVal.divsiz := DEMVal.xsize;}

End;






end.
