{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmIMFrm;
{by Ivan Lee Herring, 2004}
{Image or Bin from HTF/BMP:
Make a Manmatrix then
   save as bin with a .tpcfg  (Open needs to get htf location)
OR convert and save as bmp     (change file name)}
interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  GR32, {Texture}
  pngimage,
  jpeg,//Requires the "jpeg" unit
  FileCtrl,{Directory Creation}
  VectorGeometry,
  HeightTileFile,  {HTF file access}
{  GLContext,OpenGL1x,  Texture_3D_Unit,}
  ComCtrls, StdCtrls, Buttons, ExtCtrls;


type
  TImageMakerForm = class(TForm)
    SaveDialog1: TSaveDialog;
    IMRG: TRadioGroup;
    XSizeEdit: TEdit;
    YSizeEdit: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    XSize: TLabel;
    YSize: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SizerTrackBar: TTrackBar;
    HelpBtn: TSpeedButton;
    ExitBtn: TSpeedButton;
    ProgressBar1: TProgressBar;
    OpenDialog1: TOpenDialog;
    GroupBox1: TGroupBox;
    ImageDoRG: TRadioGroup;
    ImageBinBtn: TSpeedButton;
    GroupBox2: TGroupBox;
    ImagetoRGBHistogramBtn: TSpeedButton;
    GroupBox3: TGroupBox;
    DivideImageBtn: TSpeedButton;
    DivideImageTileBtn: TSpeedButton;
    GroupBox4: TGroupBox;
    ResizeImageBtn: TSpeedButton;
    ResizeImageTileBtn: TSpeedButton;
    DivideImageEdit: TEdit;
    ResizeImageEdit: TEdit;
    RatioSizeLabel: TLabel;
    GroupBox5: TGroupBox;
    GenerateTexturesBtn: TSpeedButton;
    GroupBox6: TGroupBox;
    Label5: TLabel;
    LaunchGLViewerCB: TCheckBox;
    SaveBmpBtn: TSpeedButton;
    SaveBinBtn: TSpeedButton;
    SaveBothBtn: TSpeedButton;
    ImagetoRGBTX3Btn: TSpeedButton;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    SaveFlippedBinBtn: TSpeedButton;
    PixelEnlargementRG: TRadioGroup;
    FlippedCB: TCheckBox;
    ConglomerationBtn: TSpeedButton;
    procedure SizerTrackBarChange(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SaveBmpBtnClick(Sender: TObject);
    procedure SaveBinBtnClick(Sender: TObject);
    procedure ImageBinBtnClick(Sender: TObject);
procedure MakeMatrix(var MinimumElevation,MaximumElevation:Integer);
procedure MatrixBmp(InFile:String;Min,Max:Integer);
procedure MatrixBin(InFile:String;Min,Max:Integer);
    procedure SaveBothBtnClick(Sender: TObject);
    procedure ImagetoRGBHistogramBtnClick(Sender: TObject);
    procedure DivideImageBtnClick(Sender: TObject);
    procedure DivideImageTileBtnClick(Sender: TObject);
    procedure ResizeImageBtnClick(Sender: TObject);
    procedure ResizeImageTileBtnClick(Sender: TObject);
    procedure GenerateTexturesBtnClick(Sender: TObject);
procedure MatrixTiledBmp(Min,Max:Integer);
    procedure SaveFlippedBinBtnClick(Sender: TObject);
procedure MatrixFlippedBin(InFile:String;Min,Max:Integer);
    procedure ConglomerationBtnClick(Sender: TObject);

(*    procedure ImagetoRGBTX3BtnClick(Sender: TObject);*)

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ImageMakerForm: TImageMakerForm;
  iXSize,iYSize:Integer;

implementation

{$R *.DFM}

uses dtmfrm, dtmGlobals, dtmPOFvar, dtmPOFrm,
     dtmEcotypeColorsFrm, dtmEcoReader,
DtmGlfrm;

procedure TImageMakerForm.FormCreate(Sender: TObject);
begin
  top := ImageMakerFormY;
  left := ImageMakerFormX;
  iXSize:=htf.SizeX;
  XSize.Caption:=Inttostr(iXSize);
  XSizeEdit.Text:=Inttostr(iXSize);
  iYSize:=htf.SizeY;
  YSize.Caption:=Inttostr(iYSize);
  YSizeEdit.Text:=Inttostr(iYSize);
  Case PixelEnlargement of
  2:PixelEnlargementRG.ItemIndex:=0;
  4:PixelEnlargementRG.ItemIndex:=1;
  8:PixelEnlargementRG.ItemIndex:=2;
  16:PixelEnlargementRG.ItemIndex:=3;
  end;  
end;

procedure TImageMakerForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ImageMakerFormX := ImageMakerForm.left;
  ImageMakerFormY := ImageMakerForm.top;
  modalresult:=mrOk;
end;

procedure TImageMakerForm.ExitBtnClick(Sender: TObject);
begin
  Close;
end;

procedure TImageMakerForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(5678);
end;

procedure TImageMakerForm.SizerTrackBarChange(Sender: TObject);
var
  iXSizeOut,iYSizeOut,Ratiosize:Integer;
begin
  Ratiosize:=SizerTrackBar.Position;
  iXSizeOut:=  iXSize div Ratiosize;
  iYSizeOut:=  iYSize div Ratiosize;
  RatioSizeLabel.Caption:=Inttostr(Ratiosize);
  XSizeEdit.Text:=Inttostr(iXSizeOut);
  YSizeEdit.Text:=Inttostr(iYSizeOut);
  Application.ProcessMessages;
end;


procedure TImageMakerForm.SaveBmpBtnClick(Sender: TObject);
var MinimumElevation,MaximumElevation:Integer;
begin
  if not Assigned(htf) then Exit;
  SaveDialog1.Filter:= 'BMP Image  (*.bmp)|*.bmp';
  SaveDialog1.InitialDir:=ImagePath;
  SaveDialog1.Filename:='newname.bmp';
  if SaveDialog1.Execute then
  begin
    ImagePath:=ExtractFilePath(SaveDialog1.FileName);
    MaximumElevation := -2147483647;
    MinimumElevation := 2147483646;
    MakeMatrix(MinimumElevation,MaximumElevation);
    MatrixBmp(SaveDialog1.FileName,MinimumElevation,MaximumElevation);
    ProgressBar1.Position :=0;
    Application.ProcessMessages;
    If (not LaunchGLViewerCB.Checked ) then SetLength(ManMatrix,0,0);
    SaveBmpBtn.Caption:='DONE!';
  end;
End;


procedure TImageMakerForm.SaveBinBtnClick(Sender: TObject);
var MinimumElevation,MaximumElevation:Integer;
begin
  if not Assigned(htf) then Exit;
  SaveDialog1.Filter:= 'DEM bin  (*.bin)|*.bin';
  SaveDialog1.InitialDir:=DemPath;
  SaveDialog1.Filename:='newname.bin';
  if SaveDialog1.Execute then
  begin
    DemPath:=ExtractFilePath(SaveDialog1.FileName);
    MaximumElevation := -2147483647;
    MinimumElevation := 2147483646;
    MakeMatrix(MinimumElevation,MaximumElevation);
    MatrixBin(SaveDialog1.FileName,MinimumElevation,MaximumElevation);
    ProgressBar1.Position :=0;
    Application.ProcessMessages;
   If ((LaunchGLViewerCB.Checked)and NoGLRunning) then
   begin
     NoGLRunning:=False;
     dtmGlForm.show;
     dtmGlForm.EnableHeightCB.Checked:=False;
     dtmGlForm.FormShowDown(FileSizeX,FileSizeY);
   end else  SetLength(ManMatrix,0,0);
    SaveBinBtn.Caption:='DONE!';
  end;
End;

procedure TImageMakerForm.SaveBothBtnClick(Sender: TObject);
var
  MinimumElevation,MaximumElevation:Integer;
  BmpName:String;
begin
  if not Assigned(htf) then Exit;
  SaveDialog1.Filter:= 'BMP Image  (*.bmp)|*.bmp';
  SaveDialog1.InitialDir:=ImagePath;
  SaveDialog1.Filename:='newname.bmp';
  if SaveDialog1.Execute then
  begin
    ImagePath:=ExtractFilePath(SaveDialog1.FileName);
    BmpName:= SaveDialog1.FileName;
  SaveDialog1.Filter:= 'DEM bin  (*.bin)|*.bin';
  SaveDialog1.InitialDir:=DemPath;
  SaveDialog1.Filename:='newname.bin';
  if SaveDialog1.Execute then
  begin
    DemPath:=ExtractFilePath(SaveDialog1.FileName);
    MaximumElevation := -2147483647;
    MinimumElevation := 2147483646;
    MakeMatrix(MinimumElevation,MaximumElevation);
    MatrixBmp(BmpName,MinimumElevation,MaximumElevation);
    MatrixBin(SaveDialog1.FileName,MinimumElevation,MaximumElevation);
    ProgressBar1.Position :=0;
    Application.ProcessMessages;
   If ((LaunchGLViewerCB.Checked)and NoGLRunning) then
   begin
     NoGLRunning:=False;
     dtmGlForm.show;
     dtmGlForm.EnableHeightCB.Checked:=False;
     dtmGlForm.FormShowDown(FileSizeX,  FileSizeY);
   end else  SetLength(ManMatrix,0,0);
    SaveBothBtn.Caption:='DONE!';
  end;
  end;
end;
(******************************************************************)
{Convert 24 bit image into a heightfield
Save as Bin/tpcfg   and/or  grayscale bmp}
procedure TImageMakerForm.ImageBinBtnClick(Sender: TObject);
var
  FractalFilename, MyFilesExtension: string;
{  F_File: file of Smallint;}
  Red,Green,Blue:Byte;
  Tempman,Pixelxs,
{  maxcolx, maxrowy,  XCount, YCount,}
  y,Pixelx,height:Integer;
  BitMap : TBitMap;
  PixelLine : PByteArray;
begin
            OpenDialog1.Filter := 'dem bmp|*.bmp';
            OpenDialog1.Filename := '*.bmp';
            OpenDialog1.InitialDir:=ImagePath;
if OpenDialog1.Execute then
begin
  MyFilesExtension :=
      Uppercase(ExtractFileExt(OpenDialog1.FileName));
  if MyFilesExtension = '.BMP' then
  begin
    FractalFilename := OpenDialog1.FileName;
    BitMap := TBitMap.create;
    try
    BitMap.LoadFromFile(FractalFilename);
    {  PixelScanSize := 3;   pf24bit  PixelScanSize := 4;   pf32bit  }
    BitMap.PixelFormat := pf24bit;
    FileSizeX:=Bitmap.Width;
    FileSizeY:=Bitmap.Height;
    // Dynamically allocate the ManMatrix array
    SetLength(ManMatrix, FileSizeX, FileSizeY);
    MaximumElevation := -2147483647;
    MinimumElevation := 2147483646;
    for y := 0 to BitMap.height -1 do
    begin
            ProgressBar1.Position :=
            Round((y / FileSizeY) * 100);
            Application.ProcessMessages;
      PixelLine := BitMap.ScanLine[y];
      for Pixelx := 0 to BitMap.width -1 do
      begin
        Pixelxs := (Pixelx * 3);
        Red:=GetRValue(PixelLine[Pixelxs]);
        Green:=GetGValue(PixelLine[(Pixelxs + 1)]);
        Blue:=GetBValue(PixelLine[(Pixelxs + 2)]);
        // Set the height to a percentage of the maximum
        // value (255+255+255 = 765) this sets the height in a range
        // of 0.0 (0+0+0 = black pixel) to 1.0 (255+255+255 = white pixel)
        height := Round(((Red + Green + Blue) / 765)*1000);
        // Set the Z value of the current point in the mesh to the
        // value calculated above
        ManMatrix[Pixelx, y] := height;
              TempMan:=height;
              if (MaximumElevation <= TempMan) then
                MaximumElevation := TempMan;
              if (MinimumElevation >= TempMan) then
                MinimumElevation := TempMan;
      end;
    end;
    ProgressBar1.Position :=0;
    Application.ProcessMessages;
    finally
    BitMap.free;
    end;

    If ((ImageDoRG.ItemIndex=0)or(ImageDoRG.ItemIndex=2)) then
     MatrixBmp(FractalFilename,MinimumElevation,MaximumElevation);
    If ((ImageDoRG.ItemIndex=1)or(ImageDoRG.ItemIndex=2)) then
     MatrixBin(FractalFilename,MinimumElevation,MaximumElevation);
    Application.ProcessMessages;
   If ((LaunchGLViewerCB.Checked)and NoGLRunning) then
   begin
     NoGLRunning:=False;
     dtmGlForm.show;
     dtmGlForm.EnableHeightCB.Checked:=False;
     dtmGlForm.FormShowDown(FileSizeX,FileSizeY);
   end else  SetLength(ManMatrix,0,0);
    end;
  end;
end;

procedure TImageMakerForm.MakeMatrix(var MinimumElevation,MaximumElevation:Integer);
var
   ThinnerSQ,Thinner, Y1size,X1size, ElevationCounted,
   Xcount, Ycount,  ElevationTotal, Xcount2, Ycount2,
   Ratiosize, OutX{,OutY}:Integer;
  ElevationCount: Smallint;
Begin
  Case IMRG.Itemindex of
    0:begin
        OutX:=iXSize;
      end;
    else
      begin
        OutX:=StrtoInt(XSizeEdit.Text);
      end;
  end;{case}
  Ratiosize:=  iXSize div OutX ;
  Thinner:=Ratiosize;
  ThinnerSQ:= (Thinner*Thinner);
  X1size := (iXSize div Thinner);
  Y1size := (iYSize div Thinner);
  FileSizeX:=X1size;
  FileSizeY:=Y1size;
  XSizeEdit.Text:=Inttostr(FileSizeX);
  YSizeEdit.Text:=Inttostr(FileSizeY);
  SetLength(ManMatrix, X1size, Y1size);
  ProgressBar1.Position:=0;
  Application.ProcessMessages;
  for Ycount := 0 to Y1size - 1 do
  begin
    ProgressBar1.Position :=
               Round((Ycount / (Y1size- 1)) * 100);
    Application.ProcessMessages;
    for Xcount := 0 to X1size - 1 do
    begin
          {Add the thinned data and divide by
          thinner * Thinner}
      ElevationTotal:=0;
      for Ycount2 := 0 to Thinner - 1 do
      begin
        for Xcount2 := 0 to Thinner - 1 do
        begin
          ElevationTotal:=
              ElevationTotal+
              htf.XYHeight(
                        ((Xcount*Thinner)+Xcount2),
                        ((Ycount*Thinner)+Ycount2));
        end;
      end;
      ElevationCount:=
                round(ElevationTotal / ThinnerSQ );
      ManMatrix[Xcount,Ycount]:=ElevationCount;
      ElevationCounted:=ElevationCount;
      if (MaximumElevation <= ElevationCounted) then
         MaximumElevation := ElevationCounted;
      if (MinimumElevation >= ElevationCounted) then
          MinimumElevation := ElevationCounted;
    end;
  end;
  ProgressBar1.Position := 0;
End;

procedure TImageMakerForm.MatrixBmp(InFile:String;Min,Max:Integer);
type
  TLogPal = record
     lpal : TLogPalette;
     pe : Array[0..255] of TPaletteEntry;
  end;
var
   Ratio, x, y : Integer;
   bmp : TBitmap;
   scanLine : {PChar; }PByteArray;
   logpal : TLogPal;
   BackupName:String;
begin
      bmp:=  TBitMap.Create;
      bmp.PixelFormat:=pf8bit;
      bmp.Width:=FileSizeX;
      bmp.Height:=FileSizeY;
      Ratio:=Round((Max - Min)/255);
      for x:=0 to 255 do with logPal.lpal.palPalEntry[x] do
      begin
         peRed:=x;
         peGreen:=x;
         peBlue:=x;
         peFlags:=0;
      end;
      with logpal.lpal do
      begin
         palVersion:=$300;
         palNumEntries:=256;
      end;
      bmp.Palette:=CreatePalette(logPal.lpal);
          for y := FileSizeY- 1 downto 0 do
          begin
            ProgressBar1.Position :=
            Round((y / FileSizeY) * 100);
            Application.ProcessMessages;
            scanLine:=bmp.ScanLine[y];
            for x := 0 to FileSizeX- 1 do
            begin
              scanLine[x]:=(ManMatrix[x, y] div Ratio);
            end;
          end;
    if FileExists(InFile) then
    begin
      BackupName := ExtractFileName(InFile);
      BackupName := ChangeFileExt(BackupName, '.BAK');
      if not RenameFile(InFile, BackupName) then
        raise Exception.Create('Unable to create backup file.');
    end;
   bmp.SaveToFile(InFile);
   If ((LaunchGLViewerCB.Checked)and NoGLRunning) then
   begin
     NoGLRunning:=False;
     dtmGlForm.Image1.Picture.Assign(bmp);
     dtmGlForm.show;
     dtmGlForm.EnableHeightCB.Checked:=True;
     dtmGlForm.FormShowDown(FileSizeX,FileSizeY);
     bmp.Free;
   end else bmp.Free;
end;

procedure TImageMakerForm.MatrixBin(InFile:String;Min,Max:Integer);
var
  MyFilesS, FileMatrix:String;
  F_File: file of Smallint;
  tpcfgfile:textfile;
  XCount, YCount :Integer;
Begin
        FileMatrix := ChangeFileExt(InFile, '.bin');
        AssignFile(F_File, FileMatrix);
        ReWrite(F_File);
        if IoResult = 0 then
        begin
          for Ycount := 0 to FileSizeY- 1 do
          begin
            ProgressBar1.Position :=
            Round((Ycount / FileSizeY) * 100);
            Application.ProcessMessages;
            for Xcount := 0 to FileSizeX- 1 do
            begin
              Write(F_File, ManMatrix[Xcount, Ycount]);
            end;
          end;
          CloseFile(F_File);
       end;
begin
      AssignFile(tpcfgfile, ProgramPath+ChangeFileExt(ExtractFileName(InFile),'.tpcfg'));
      Rewrite(tpcfgfile);
      {HTFName=F:\HTF\etopo2.htf}
      MyFilesS:='HTFName='+HTFPath{+'\'}+ChangeFileExt(ExtractFileName(InFile),'.htf');
      Writeln(tpcfgfile,MyFilesS);
      {WorldSizeX=10800}
      MyFilesS:='WorldSizeX='+IntToStr(FileSizeX);
      Writeln(tpcfgfile,MyFilesS);
      {WorldSizeY=6336}
      MyFilesS:='WorldSizeY='+IntToStr(FileSizeY);
      Writeln(tpcfgfile,MyFilesS);
      {TileSize=128}
      MyFilesS:='TileSize='+IntToStr(128);
      Writeln(tpcfgfile,MyFilesS);
      {DefaultZ=0}
      MyFilesS:='DefaultZ='+IntToStr(Min);{-32767 NullDatumValue}
      Writeln(tpcfgfile,MyFilesS);
      {DEMPath=F:\DEM}
      MyFilesS:='DEMPath='+DEMPath;
      Writeln(tpcfgfile,MyFilesS);
        MyFilesS:='DEMs="'
                +ExtractFileName(ChangeFileExt(InFile,'.bin'))
                +',""0,0"",'+
                IntToStr(FileSizeX)+'x'+
                IntToStr(FileSizeY)+',""16 bits (Intel)"""';
      Writeln(tpcfgfile,MyFilesS);
      CloseFile(tpcfgfile);
end;
End;
(***********************************************)
(***********************************************)


(***********************************************)
(***********************************************)
(*
procedure TImageMakerForm.ImagetoRGBTX3BtnClick(Sender: TObject);
Type
  P_Byte = ^Byte;
  P_Longword = ^Longword;
var
  FractalFilename, MyFilesExtension: string;
  Red,Green,Blue:Byte;
    Index : Integer;
  Pixelxs, y,Pixelx:Integer;
  RX, GY, BZ, Value: Byte;
  BitMap : TBitMap;
  PixelLine : PByteArray;
  HisMatrix: array of array of array of Byte;
    M_3D_Texture : TGLTextureHandle;
    M_Input_Texture_3D : TTexture_3D;
begin
  OpenDialog1.Filter := 'image bmp|*.bmp';
  OpenDialog1.Filename := '*.bmp';
  OpenDialog1.InitialDir:=ImagePath;
  if OpenDialog1.Execute then
  begin
    MyFilesExtension :=
      Uppercase(ExtractFileExt(OpenDialog1.FileName));
    Application.ProcessMessages;
    if MyFilesExtension = '.BMP' then
    begin
      FractalFilename := OpenDialog1.FileName;
      BitMap := TBitMap.create;
      M_3D_Texture := TGLTextureHandle.Create;
      M_Input_Texture_3D := TTexture_3D.Create;
      M_Input_Texture_3D.Data_Type := GL_RGBA;
      M_Input_Texture_3D.X_Size := 255;
      M_Input_Texture_3D.Y_Size := 255;
      M_Input_Texture_3D.Z_Size := 255;
{showmessage('0');}
      try
        BitMap.LoadFromFile(FractalFilename);
        BitMap.PixelFormat := pf24bit;
        SetLength(HisMatrix, 256, 256, 256);
        {Fillchar(HisMatrix ,(256* 256* 256),0);}
        for BZ := 0 to 255 do  begin
          for GY := 0 to 255 do begin
            for RX := 0 to 255 do begin
              HisMatrix[RX, GY, BZ]:=1;end;end;end;

        MaximumElevation := -2147483647;
        MinimumElevation := 2147483646;
{showmessage('1');}
        for y := 0 to BitMap.height -1 do
        begin
          ProgressBar1.Position :=
            Round((y / BitMap.height) * 100);
            Application.ProcessMessages;
          PixelLine := BitMap.ScanLine[y];
          for Pixelx := 0 to BitMap.width -1 do
          begin
            Pixelxs := (Pixelx * 3);
            Red:=GetRValue(PixelLine[Pixelxs]);
            Green:=GetGValue(PixelLine[(Pixelxs + 1)]);
            Blue:=GetBValue(PixelLine[(Pixelxs + 2)]);
            Value:=HisMatrix[Red, Green, Blue];
            If HisMatrix[Red, Green, Blue] > 254 then
            begin
            ImagetoRGBHistogramBtn.Caption:='OverFlow occurred RGB: '+
            Inttostr(Red)+ ', '+Inttostr(Green)  +' , '+Inttostr(Blue);
            {HisMatrix[Red, Green, Blue]:= 255;}
            end else HisMatrix[Red, Green, Blue]:=Value+1;
          end;
        end;
showmessage('2');
        FractalFilename:=ChangeFileExt(FractalFilename,'.tx3');
        {ProgressBar1.Visible:=True;}
        for BZ := 0 to 255 do
        begin
          ProgressBar1.Position:= Round(100 * (BZ / 255));
          Application.ProcessMessages;
          for GY := 0 to 255 do
          begin {Row}
            for RX := 0 to 255 do
            begin {Col}
              Value :=HisMatrix[RX, GY, BZ];
              Index := (BZ * M_Input_Texture_3D.Y_Size * M_Input_Texture_3D.X_Size) + (GY * M_Input_Texture_3D.X_Size) + RX;
{              P_Byte ( (PChar (M_Input_Texture_3D.Data)) + (Index ) )^ := Value}
              P_Byte (Integer (PChar (M_Input_Texture_3D.Data)) + (Index* 3 ) )^ := Value

              {P_Byte (Integer (PChar (M_Input_Texture_3D.Data)) + (Index * 3) + 3)^ := Value}

            end;
          end;
        end;
{M_3D_Texture}
showmessage('3a');
        M_Input_Texture_3D.Save_To_File (FractalFilename);
showmessage('3b');
        ProgressBar1.Position:=(0);
        Application.ProcessMessages;
      Except
        SetLength(HisMatrix, 0, 0, 0);
        ProgressBar1.Position:=(0);
        BitMap.Free;
        M_3D_Texture.Free;
        M_Input_Texture_3D.Free;
      end;
      SetLength(HisMatrix, 0, 0, 0);
      BitMap.Free;
{      M_Input_Texture_3D.Free;
      M_3D_Texture.Free; }
    end;
  end;
showmessage('done');
  {ImagetoRGBTX3Btn.Caption:='ok';}
end;
*)

procedure TImageMakerForm.ImagetoRGBHistogramBtnClick(Sender: TObject);
{type
  Count3D = array[0..255] of Byte;}
var
{  Count3DArray: Count3D; }
  RX, GY, BZ, Value: Byte;
  fLoad: file of Byte;//Count3D;
var
  FractalFilename, MyFilesExtension: string;
  Red,Green,Blue:Byte;
  Pixelxs, y,Pixelx:Integer;
  BitMap : TBitMap;
  PixelLine : PByteArray;
  HisMatrix: array of array of array of Byte;
begin
            OpenDialog1.Filter := 'dem bmp|*.bmp';
            OpenDialog1.Filename := '*.bmp';
            OpenDialog1.InitialDir:=ImagePath;
if OpenDialog1.Execute then
begin
  MyFilesExtension :=
      Uppercase(ExtractFileExt(OpenDialog1.FileName));
  if MyFilesExtension = '.BMP' then
  begin
    FractalFilename := OpenDialog1.FileName;
    BitMap := TBitMap.create;
    try
    BitMap.LoadFromFile(FractalFilename);
    {  PixelScanSize := 3;   pf24bit  PixelScanSize := 4;   pf32bit  }
    BitMap.PixelFormat := pf24bit;
{    FileSizeX:=Bitmap.Width;
    FileSizeY:=Bitmap.Height;
    SetLength(ManMatrix, FileSizeX, FileSizeY);}
    SetLength(HisMatrix, 256, 256, 256);
    {Fillchar(HisMatrix ,(256* 256* 256),0);}
            for BZ := 0 to 255 do  begin
          for GY := 0 to 255 do begin
            for RX := 0 to 255 do begin
              HisMatrix[RX, GY, BZ]:=0;end;end;end;
{    MaximumElevation := -2147483647;
    MinimumElevation := 2147483646;}
    for y := 0 to BitMap.height -1 do
    begin
            ProgressBar1.Position :=
            Round((y / BitMap.height) * 100);
            Application.ProcessMessages;
      PixelLine := BitMap.ScanLine[y];
      for Pixelx := 0 to BitMap.width -1 do
      begin
        Pixelxs := (Pixelx * 3);
        Red:=GetRValue(PixelLine[Pixelxs]);
        Green:=GetGValue(PixelLine[(Pixelxs + 1)]);
        Blue:=GetBValue(PixelLine[(Pixelxs + 2)]);
        Value:=HisMatrix[Red, Green, Blue];
        If HisMatrix[Red, Green, Blue] > 254 then
        ImagetoRGBHistogramBtn.Caption:='OverFlow occurred RGB: '+
        Inttostr(Red)+ ', '+Inttostr(Green)  +' , '+Inttostr(Blue)
        else
        HisMatrix[Red, Green, Blue]:=Value+1;
     end;
   end;


  {Read em in}
  {$I-}
  FractalFilename:=ChangeFileExt(FractalFilename,'.rs3');
  AssignFile(fLoad, FractalFilename);
  Rewrite(fLoad);
  ProgressBar1.Visible:=True;
  for BZ := 0 to 255 do
  begin
    ProgressBar1.Position:= Round(100 * (BZ / 255));
    for GY := 0 to 255 do
    begin {Row}
      for RX := 0 to 255 do
      begin {Col}
        Value :=HisMatrix[RX, GY, BZ];
        write(fLoad, Value);
       { Count3DArray[RX] := Value;}
      end;
    end;
  end;
    CloseFile(fLoad);
  {$I+}
  ProgressBar1.Position:=(0);
  Except
    SetLength(HisMatrix, 0, 0, 0);
    ProgressBar1.Position:=(0);
    BitMap.Free;
    CloseFile(fLoad);
  end;
    SetLength(HisMatrix, 0, 0, 0);
    BitMap.Free;
  end;
end;
end;
(***********************************************)
(***********************************************)


(***********************************************)
(***********************************************)
procedure TImageMakerForm.DivideImageBtnClick(Sender: TObject);
var
  FractalFilename, MyFilesExtension: string;
  BitMap : TBitMap;
begin
  OpenDialog1.Filter := 'dem bmp|*.bmp';
  OpenDialog1.Filename := '*.bmp';
  OpenDialog1.InitialDir:=ImagePath;
  if OpenDialog1.Execute then
  begin
    Application.ProcessMessages;
    MyFilesExtension :=
      Uppercase(ExtractFileExt(OpenDialog1.FileName));
    if MyFilesExtension = '.BMP' then
    begin
      FractalFilename := OpenDialog1.FileName;
      BitMap := TBitMap.create;
      try
        BitMap.LoadFromFile(FractalFilename);
        {  PixelScanSize := 3;   pf24bit  PixelScanSize := 4;   pf32bit  }
        BitMap.PixelFormat := pf24bit;
        FileSizeX:=Bitmap.Width;
        FileSizeY:=Bitmap.Height;
        XSize.Caption:=Inttostr(FileSizeX);
        XSizeEdit.Text:=Inttostr(FileSizeX);
        YSize.Caption:=Inttostr(FileSizeY);
        YSizeEdit.Text:=Inttostr(FileSizeY);
        DivideImageEdit.Text:= OpenDialog1.FileName;
        ImagePath:=ExtractFilePath(OpenDialog1.FileName);
      finally
        BitMap.Free;
      end;
    end;
  end;{open}
end;
//Make SQUARE images from whatever was loaded
procedure TImageMakerForm.DivideImageTileBtnClick(Sender: TObject);
var
  FlippedCBChecked:Boolean;
   BitMap, bmp : TBitmap;
   s, x, y : Integer;
  HTFExtension, //HTFName,
  HTFTexturePath, HTFTextureName, Texname:String;
//Flip H
{TYPE
  TRGBArray    = ARRAY[0..0] OF TRGBTriple;
  pRGBArray    = ^TRGBArray;
var i,j,w :  INTEGER;
    RowIn :  pRGBArray;
    RowOut:  pRGBArray;}
begin   {gleaned from FSplitterMain}
  Application.ProcessMessages;
  If DivideImageEdit.Text <> '' then
  begin //Name IAW HTF file
    FlippedCBChecked:=FlippedCB.Checked;
    //HTFName :=ExtractFileName(DivideImageEdit.Text);
    HTFTextureName:=  Copy(HTFName,0,Length(HTFName)-4);
    HTFTexturePath:=  HTFTextureName+'tei\';
    HTFExtension:='.bmp';
    if not DirectoryExists(HTFPath+HTFTexturePath) then
    if not CreateDir(HTFPath+HTFTexturePath) then
    raise Exception.Create('Cannot create '+HTFPath+HTFTexturePath);
    s:=strtoint(XSizeEdit.Text);
    BitMap := TBitMap.create;
    bmp:=TBitmap.Create;
    bmp.PixelFormat:=pf24bit;
    bmp.Width:=s;
    bmp.Height:=s;
    try
      BitMap.LoadFromFile(DivideImageEdit.Text);
      BitMap.PixelFormat := pf24bit;
      If FlippedCBChecked then
      begin
        {w := s*sizeof(TRGBTriple);
        Getmem(rowin,w);}
        y:=0; while y<Bitmap.Height do
        begin
          x:=0; while x<Bitmap.Width do
          begin
            bmp.Canvas.Draw(-x, -y, BitMap);   //x div s, y div s
            //Flip left to right
  {  for j := 0 to s-1 do begin
      move(bmp.Scanline[j]^,rowin^,w);
      rowout := bmp.Scanline[j];
      for i := 0 to s-1 do rowout[i] :=rowin[s-1-i];
    end; }
    bmp.Assign(bmp);
            Texname:=Format(HTFTextureName+'Tei%d_%d_%d'+HTFExtension,
                             [PixelEnlargement,
                             (y div s),
                              //(((Bitmap.Width div s )- 1)-
                                (x div s)
                             ]);
            bmp.SaveToFile(HTFPath+HTFTexturePath+Texname);
            ProgressBar1.StepBy(1);
            Inc(x, s);//Inc(y, s);
            Application.ProcessMessages;
          end;
          Inc(y, s);//Inc(x, s);
        end;
   // Freemem(rowin);
      end else
      begin
      x:=0; while x<Bitmap.Width do
      begin
        y:=0; while y<Bitmap.Height do
        begin
          bmp.Canvas.Draw(-x, -y, BitMap);   //x div s, y div s
          Texname:=Format(HTFTextureName+'Tei%d_%d_%d'+HTFExtension,
                             [PixelEnlargement,
                                (x div s),(y div s)]);
          bmp.SaveToFile(HTFPath+HTFTexturePath+Texname);
          ProgressBar1.StepBy(1);
          Inc(y, s);
          Application.ProcessMessages;
        end;
        Inc(x, s);
      end;
      end;{flipped}
    finally
      bmp.Free;
      Bitmap.Free;
    end;
    DivideImageTileBtn.Caption:='DONE!';
  end;
end;
(***********************************************)
procedure TImageMakerForm.ConglomerationBtnClick(Sender: TObject);
begin
    {}
end;
(***********************************************)


(***********************************************)
(***********************************************)
procedure TImageMakerForm.ResizeImageBtnClick(Sender: TObject);
var
  FractalFilename, MyFilesExtension: string;
  BitMap : TBitMap;
begin
  OpenDialog1.Filter := 'dem bmp|*.bmp';
  OpenDialog1.Filename := '*.bmp';
  OpenDialog1.InitialDir:=ImagePath;
  if OpenDialog1.Execute then
  begin
    MyFilesExtension :=
      Uppercase(ExtractFileExt(OpenDialog1.FileName));
    if MyFilesExtension = '.BMP' then
    begin
      FractalFilename := OpenDialog1.FileName;
      BitMap := TBitMap.create;
      try
        BitMap.LoadFromFile(FractalFilename);
        {  PixelScanSize := 3;   pf24bit  PixelScanSize := 4;   pf32bit  }
        BitMap.PixelFormat := pf24bit;
        FileSizeX:=Bitmap.Width;
        FileSizeY:=Bitmap.Height;
        XSize.Caption:=Inttostr(FileSizeX);
        XSizeEdit.Text:=Inttostr(FileSizeX);
        YSize.Caption:=Inttostr(FileSizeY);
        YSizeEdit.Text:=Inttostr(FileSizeY);
        ResizeImageEdit.Text:= OpenDialog1.FileName;
      finally
        BitMap.Free;
      end;
    end;
  end;{open}
end;

procedure TImageMakerForm.ResizeImageTileBtnClick(Sender: TObject);
var
  BitMap,BitMap2 : TBitMap;
  ARect: TRect;
begin
  If ResizeImageEdit.Text <> '' then
  begin
    {Resize the image... for use as a texture or Height data}
    BitMap := TBitMap.create;
    BitMap2:= TBitMap.create;
    try
      BitMap.LoadFromFile(ResizeImageEdit.Text);
        ARect.Left:=0;
        ARect.Top:=0;
        ARect.Right:=strtoint(XSizeEdit.Text);
        ARect.Bottom:=strtoint(YSizeEdit.Text);
        BitMap2.Canvas.StretchDraw(ARect,BitMap);

      BitMap2.SaveToFile(ResizeImageEdit.Text)
    Finally
      BitMap.Free;
    end;
    ResizeImageTileBtn.Caption:='DONE!';
  end;
end;
(***********************************************)
(***********************************************)


(***********************************************)
(***********************************************)
procedure TImageMakerForm.GenerateTexturesBtnClick(Sender: TObject);
var
   FinishTime,StartTime:TDateTime;
   Hour, Min, Sec, MSec: Word;
begin
  if not Assigned(htf) then Exit;
  StartTime:=Now;
  MatrixTiledBmp(AutoMinimumElevation,AutoMaximumElevation);
  FinishTime:=Now;
  DecodeTime(FinishTime-StartTime, Hour, Min, Sec, MSec);
  ShowMessage(  IntToStr(Hour)+' H, '
               + IntToStr(Min)+' M, '
               + IntToStr(Sec)+' S, '
               + IntToStr(MSec)+' MS'
               );
    ProgressBar1.Position :=0;
    GenerateTexturesBtn.Caption:='DONE!';
    Application.ProcessMessages;
end;

(***********************************************)
{Given the htf data, and its tile size
Convert the data into Elevation Tint images
CANNOT use MATRIX as these can be BIG..
MUST do 1 Scanline at a TIME
Save as a bmp per each tile
or bin... Save per LINE : BlockWrite!
Expanded per ImageTileSizeRG 0=2 1=4 2=8 3=16
into Individually named Files HTFPath+HTFName...
Interpolate the Heights to Make smooth Elevation tint changes
If ContoursCB.Checked then Make Contour Lines

  TextureHTFName:=  Copy(HTFName,0,Length(HTFName)-4);
    for i:=0 to TilesWideX-1 do for j:=0 to TilesTallY-1 do
    begin
      name:=Format(TextureHTFName+'Tex_%d_%d.bmp', [i, j]);

   bmp.SaveToFile(HTFPath+name); }
   (*
    {Set blank into bitmap corners}
    for ty:=0 to sey-1 do
    begin
      scanLine:=bmpTile.ScanLine[ty];
      If ((ty=0) or (ty=sey-1)) then
      begin
        for tx:=0 to sex-1 do
          scanLine[tx]:=Color32(MapBacksColor){heightColor[dataRow[tx]]}
      end else
      begin
        scanLine[0]:=Color32(MapBacksColor);{heightColor[dataRow[0]];}
        scanLine[sex-1]:=Color32(MapBacksColor);{heightColor[dataRow[tileInfo.width-1]];}
      end;
    end;
   *)
(***********************************************)
procedure TImageMakerForm.MatrixTiledBmp(Min,Max:Integer);
var
  TexturesSize,
  TilesWideX,TilesTallY,
  htfTileSize,
  i,j, x, y : Integer;
  HTFExtension,
  HTFTexturePath, TextureHTFName, Texname:String;
  ScaleRect:TRect;
  bmp, bmp2 : TBitmap32;
  Bitbmp:TBitmap;
  scanLine :PColor32Array;// PByteArray;
  PNG: TPNGObject;
  jp: TJpegImage;
var {Eco Color}
  StepLevel, StepLevelCount, Step, Stepcount: Integer;
  TotRez,Rez:Double;
  RezEly,RezRely,RezSlope,RezSlopeDir:Double;

  HiEl,LoEl,
  MinRezEly,MinRezRely,MinRezSlope,
  TotRezEly,TotRezRely,TotRezSlope,
  REX, RexSq,RelativeElevation, SlopeDir,
  Slope2,CX2,CY2, Slope,CX,CY:Double;
  WidthX,HeightY, tx, ty : Integer;
{  scanLine : PColor32Array;}
  EcoMatrix: array of array of array of Double;
begin
  Case TilesperTexture of
  //Based on Overlap of 1..
  //Only TilesperTexture of 1 is ever used
    1:  htfTileSize:=1*(htf.TileSize-1);
    2:  htfTileSize:=2*(htf.TileSize-1);
    4:  htfTileSize:=4*(htf.TileSize-1);
    8:  htfTileSize:=8*(htf.TileSize-1);
    else htfTileSize:=htf.TileSize-1;
  end;
  If ( ((htf.SizeX mod htfTileSize)>0 )
    or ((htf.SizeY mod htfTileSize)>0)) then
  begin
    showmessage('Improper Choice'+#13#10+
    Inttostr(htf.SizeX) + ': '+Inttostr(htfTileSize)    );
    exit;
  end;
  Case TextureFileType of
    0:HTFExtension:='.png';
    1:HTFExtension:='.bmp';
    2:HTFExtension:='.jpg';
  end;
  PNG := TPNGObject.Create;
  jp := TJpegImage.Create;
  TilesWideX:=(htf.SizeX div(htfTileSize));
  TilesTallY:=(htf.SizeY div(htfTileSize));
  TexturesSize:= ((htfTileSize)* PixelEnlargement);
  TextureHTFName:=  Copy(HTFName,0,Length(HTFName)-4);
    If UseEcoTypes then
  HTFTexturePath:=  '\'+TextureHTFName+'tee\'else
  HTFTexturePath:=  '\'+TextureHTFName+'tex\';
  If UseEcoTypes then
  begin
    {HeightY:=Yhin-2;
     WidthX:=Xwin-2;}
    MinRezEly:=0;MinRezRely:=0;MinRezSlope:=0;LoEl:=0;
    TotRezEly:=0;TotRezRely:=0;TotRezSlope:=0;HiEl:=0;
    {Precompute  Data into Matrix}
    Setlength(EcoMatrix,10 ,EcoLevelsProcessed+1, 4 );
    for Step:=0 to 9 do
    for StepLevel:=0 to EcoLevelsProcessed do
    begin
    //Someday use the Latitude Longitude  Avg Rain Avg Temp Veg Density + Height
      EcoMatrix[Step,StepLevel,0]:=(EcoRecord[Step,StepLevel].ElevMax-EcoRecord[Step,StepLevel].ElevMin);
      EcoMatrix[Step,StepLevel,1]:=(EcoRecord[Step,StepLevel].REMax-EcoRecord[Step,StepLevel].REMin);
      EcoMatrix[Step,StepLevel,2]:=(EcoRecord[Step,StepLevel].SlopeMax-EcoRecord[Step,StepLevel].SlopeMin);
      EcoMatrix[Step,StepLevel,3]:=(EcoRecord[Step,StepLevel].SlopeDirMax-EcoRecord[Step,StepLevel].SlopeDirMin)
    end;
  end;
  for j:=0 to TilesWideX-1 do
  for i:=0 to TilesTallY-1 do
  begin          {i=Top and j=Left   [i,j]) }
    ProgressBar1.Position :=
            Round((j / TilesWideX) * 100);
      Application.ProcessMessages;
    If UseEcoTypes then
    Texname:=Format(TextureHTFName+'Tee%d_%d_%d'+HTFExtension, [PixelEnlargement,i,((TilesWideX-1)-j)])
    else Texname:=Format(TextureHTFName+'Tex%d_%d_%d'+HTFExtension, [PixelEnlargement,i,((TilesWideX-1)-j)]);
    bmp:=TBitmap32.Create;
    bmp2:=TBitmap32.Create;
    bmp.setsize(htfTileSize,htfTileSize );
    bmp2.setsize(TexturesSize,TexturesSize );
  {TilesWideX:=(htf.SizeX div(htfTileSize));
  TilesTallY:=(htf.SizeY div(htfTileSize));
  TexturesSize:= ((htfTileSize)* PixelEnlargement);}
//Fill the ManMatrix and Interpolate the data..
//Then process from it instead of htf.XYHeight
      {ManMatrix[tx,ty]:= (htf.XYHeight(x,y)}
    {Prepare Elevation Tint or EcoType  BaseTextures
     LightMap Tex2  ? changed per Mouse 'SUN' position
     Contours Done ?}
    If UseEcoTypes then
    begin
      for ty := htfTileSize- 1 downto 0 do
      begin
        scanLine:=bmp.ScanLine[ty];
        for tx := 0 to htfTileSize- 1 do
        begin
          CY := (htf.XYHeight(tx+(htfTileSize*j),(ty+1)+(htfTileSize*i)) - htf.XYHeight(tx+(htfTileSize*j),(ty-1)+(htfTileSize*i)))/2;
          CX := (htf.XYHeight((tx+1)+(htfTileSize*j),ty+(htfTileSize*i)) - htf.XYHeight((tx-1)+(htfTileSize*j),ty+(htfTileSize*i)))/2;
          Slope :=  {Sqrt}(CX+ CY);
          Slope2:=Slope / sqrt((Slope*Slope)+1);
          CX2:=CX*CX;
          CX2:=CX / sqrt((CX2)+1);
          CY2:=CY*CY;
          CY2:=CY / sqrt((CY2)+1);
          SlopeDir:=CX2+CY2;
          REX:=htf.XYHeight(tx+(htfTileSize*j),ty+(htfTileSize*i))-
            ((htf.XYHeight((tx+1)+(htfTileSize*j),(ty-1)+(htfTileSize*i))+
              htf.XYHeight((tx+1)+(htfTileSize*j),(ty+1)+(htfTileSize*i))+
              htf.XYHeight((tx-1)+(htfTileSize*j),(ty+1)+(htfTileSize*i))+
              htf.XYHeight((tx-1)+(htfTileSize*j),(ty-1)+(htfTileSize*i)))  /4);
          RexSq:=REX / sqrt((REX*REX)+1);
          RelativeElevation:=  RexSq;

          TotRez:=0;
          Stepcount:=1;
          StepLevelCount:=0;
          for Step:=1 to 9 do
          for StepLevel:=0 to EcoLevelsProcessed do
          begin       {EcoRecord[ChangeColX,ChangeRowY]}
            RezEly:= abs((htf.XYHeight(tx+(htfTileSize*j),ty+(htfTileSize*i))-(EcoMatrix[Step,StepLevel,0]))
                    /EcoMatrix[Step,StepLevel,0]);
            RezEly:=  power( 0.5, RezEly);
            RezEly:=  power( RezEly,EcoRecord[Step,StepLevel].ElevSharpness);
             {  RezEly:=  power( 0.5, RezEly);}
             {  RezEly:= power( power( 0.5,EcoRecord[Step,StepLevel].ElevSharpness),RezEly);}

            RezRely:= ( (RelativeElevation-(EcoMatrix[Step,StepLevel,1]))
                    /EcoMatrix[Step,StepLevel,1]);
            RezRely:=  power( 0.5, RezRely);
            RezRely:=  power( RezRely,EcoRecord[Step,StepLevel].RESharpness);

            RezSlope:= ((Slope2-(EcoMatrix[Step,StepLevel,2]))
                         /EcoMatrix[Step,StepLevel,2]);
            RezSlope:=  power( 0.5, RezSlope);
            RezSlope:=  power( RezSlope,EcoRecord[Step,StepLevel].SlopeSharpness);

            RezSlopeDir:= ((SlopeDir-(EcoMatrix[Step,StepLevel,3]))
                            /EcoMatrix[Step,StepLevel,3]);
            RezSlopeDir:=  power( 0.5, RezSlopeDir);
            RezSlopeDir:=  power( RezSlopeDir,EcoRecord[Step,StepLevel].SlopeDirSharpness);

            Rez:= RezEly+ RezRely+ RezSlope+RezSlopeDir;
            {Sun Rises from East so What?} {then Valley UpDown else if}{Shady?}
            If Rez > TotRez then
            begin
              TotRez:=Rez;
              Stepcount:=Step ;
              StepLevelCount:=StepLevel;
            end;
          end;
          scanLine[(htfTileSize- 1)-tx]:=Color32(EcoRecord[Stepcount,StepLevelCount].Color);
          {scanLine[(htfTileSize- 1)-x]:=
              heightColor[
           htf.XYHeight((x )+(htfTileSize*j),
                      (y)+(htfTileSize*i))];}
        end;
      end;
    end else
    begin  //TexturesSize
      for y := htfTileSize- 1 downto 0 do
      begin
        scanLine:=bmp.ScanLine[y];
        for x := 0 to htfTileSize- 1 do
        begin
          scanLine[(htfTileSize- 1)-x]:=
              heightColor[
           htf.XYHeight((x )+(htfTileSize*j),
                      (y )+(htfTileSize*i))];
        end;
      end;
    End;
    BitBmp := TBitmap.Create;
    BitBmp.HandleType := bmDIB;
    BitBmp.PixelFormat := pf32Bit;
    BitBmp.Width := bmp2.Width;
    BitBmp.Height := bmp2.Height;
    ScaleRect.Left:=0;
    ScaleRect.Right:=TexturesSize;
    ScaleRect.Top:=0;
    ScaleRect.Bottom:=TexturesSize;
    bmp.StretchFilter:=sfSpline;
    bmp.DrawTo(Bmp2,ScaleRect);
    bmp2.DrawTo(BitBmp.Canvas.Handle, 0, 0);
    if not DirectoryExists(HTFPath+HTFTexturePath) then
    if not CreateDir(HTFPath+HTFTexturePath) then
    raise Exception.Create('Cannot create '+HTFPath+HTFTexturePath);
    Case TextureFileType of
      0:{png}
      begin
        PNG.Assign(BitBmp);    //Convert data into png
        PNG.SaveToFile(HTFPath+HTFTexturePath+Texname);
      end;
      1: {bmp}
      begin
        BitBmp.SaveToFile(HTFPath+HTFTexturePath+Texname);
      end;
      2:{jpg}
      begin
        with jp do
        begin
          Assign(BitBmp);
          SaveToFile(HTFPath+HTFTexturePath+Texname);
        end;
      end;
    end;{Case}
    BitBmp.Free;
    bmp.Free;
    bmp2.Free;
  end;
  png.Free;
  jp.Free;
  Setlength(EcoMatrix,0 ,0, 0 );
end;
(***********************************************)
(***********************************************)


(***********************************************)
(***********************************************)
procedure TImageMakerForm.SaveFlippedBinBtnClick(Sender: TObject);
var
   FinishTime,StartTime:TDateTime;
   Hour, Min, Sec, MSec: Word;
begin
  if not Assigned(htf) then Exit;
  SaveDialog1.Filter:= 'DEM bin  (*.bin)|*.bin';
  SaveDialog1.InitialDir:=DEMPath;
  SaveDialog1.Filename:=Copy(HTFName,0,Length(HTFName)-4)+'flip.bin';
  if SaveDialog1.Execute then
  begin
    DEMPath:=ExtractFilePath(SaveDialog1.FileName);
    StartTime:=Now;
    MatrixFlippedBin(SaveDialog1.FileName,AutoMinimumElevation,AutoMaximumElevation);
  FinishTime:=Now;
  DecodeTime(FinishTime-StartTime, Hour, Min, Sec, MSec);
  ShowMessage(  IntToStr(Hour)+' H, '
               + IntToStr(Min)+' M, '
               + IntToStr(Sec)+' S, '
               + IntToStr(MSec)+' MS'
               );
    ProgressBar1.Position :=0;
    SaveFlippedBinBtn.Caption:='DONE!';
    Application.ProcessMessages;
  end;
End;


procedure TImageMakerForm.MatrixFlippedBin(InFile:String;Min,Max:Integer);
var
  MyFilesS, FileMatrix:String;
  F_File: file;
  BinMatrix: Array of Smallint;
  tpcfgfile:textfile;
  XFlip, XCount, YCount :Integer;
Begin
  FileMatrix := ChangeFileExt(InFile, '.bin');
  AssignFile(F_File, FileMatrix);
  ReWrite(F_File,1);
  if IoResult = 0 then
  begin
    SetLength(BinMatrix, FileSizeX);
    for Ycount := 0 to FileSizeY- 1 do
    begin
      ProgressBar1.Position :=
            Round((Ycount / FileSizeY) * 100);
      Application.ProcessMessages;
      XFlip:= FileSizeX- 1;
      for Xcount := 0 to FileSizeX- 1 do
      begin
        BinMatrix[XFlip]:=
          htf.XYHeight(Xcount,Ycount);
        dec(XFlip);
      end;  {slow but it works}
      for Xcount := 0 to FileSizeX- 1 do
      BlockWrite(F_File, BinMatrix[Xcount],2{Sizeof(BinMatrix)});
    end;
    CloseFile(F_File);
  end;
  begin
      AssignFile(tpcfgfile, ProgramPath+ChangeFileExt(ExtractFileName(InFile),'.tpcfg'));
      Rewrite(tpcfgfile);
      {HTFName=F:\HTF\etopo2.htf}
      MyFilesS:='HTFName='+HTFPath{+'\'}+ChangeFileExt(ExtractFileName(InFile),'.htf');
      Writeln(tpcfgfile,MyFilesS);
      {WorldSizeX=10800}
      MyFilesS:='WorldSizeX='+IntToStr(FileSizeX);
      Writeln(tpcfgfile,MyFilesS);
      {WorldSizeY=6336}
      MyFilesS:='WorldSizeY='+IntToStr(FileSizeY);
      Writeln(tpcfgfile,MyFilesS);
      {TileSize=129}
      MyFilesS:='TileSize='+IntToStr(129);
      Writeln(tpcfgfile,MyFilesS);
      {TileOverlap=1}
      MyFilesS:='TileOverlap='+IntToStr(1);
      Writeln(tpcfgfile,MyFilesS);
      {DefaultZ=0}
      MyFilesS:='DefaultZ='+IntToStr(Min);{-32767 NullDatumValue}
      Writeln(tpcfgfile,MyFilesS);
      {FilterZ=}
      MyFilesS:='FilterZ='+IntToStr(Min);
      Writeln(tpcfgfile,MyFilesS);
      {DEMPath=F:\DEM}
      MyFilesS:='DEMPath='+DEMPath;
      Writeln(tpcfgfile,MyFilesS);
        MyFilesS:='DEMs="'
                +ExtractFileName(ChangeFileExt(InFile,'.bin'))
                +',""0,0"",'+
                IntToStr(FileSizeX)+'x'+
                IntToStr(FileSizeY)+',""16 bits (Intel)"""';
      Writeln(tpcfgfile,MyFilesS);
      CloseFile(tpcfgfile);
  end;
  SetLength(BinMatrix,0);
End;
(***********************************************)
(***********************************************)

(***********************************************)
(***********************************************)







end.
