{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
{         Displays and gathers Program Options          }
{1 Options Form, 1 Error Message File
 Each POF file}
{All Programs in 1 Directory,
   SubDirectories: Filters, Fractal files, Life files, media
     Admin? :Extensions, Palettes.pal, .tpcfg, Server?Info,
Image Databases, Thumbnails, Fractal Images, Pan Images, 
Projects, Maps, 3D DTM .ots Eco Files.eco, Patterns ,
Grip Colors..Eco Colors..Patterns

function SaveBmpToJpegFile (const bitmap: TBitmap;  const filename: string;
                    const quality: integer;  const comment: string): boolean;
}
//Tile Size:128 (129x129) Pixels:4x4 (4bytes per pixel)= 1Meg...
//65x65  x8x8   x4 =   1Meg
//32x32  x16x16  x4  =   1Meg
{*******************************************************}
unit dtmPOFrm;
{by Ivan Lee Herring, 2004}
interface

uses
  Windows, Dialogs, StdCtrls, Buttons, Controls,Graphics,
  Sysutils{Filestuff},
  FileCtrl{SelectDirectory},
  GLUtils,
  ExtCtrls, ComCtrls, Forms, Classes;

type
  TdtmPOFForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Bevel1: TBevel;
    Label1: TLabel;
    Label4: TLabel;
    MessageBtn: TSpeedButton;
    POHelpBtn: TSpeedButton;
    POM_ResetMenuBtn: TSpeedButton;
    InfoCB: TCheckBox;
    ConfirmationCB: TCheckBox;
    ErrorsCB: TCheckBox;
    WarningCB: TCheckBox;
    CompletionCB: TCheckBox;
    BeepOrWavCB: TCheckBox;
    MessageXEdit: TEdit;
    MessageYEdit: TEdit;
    CloseBitBtn: TBitBtn;
    RecordReader: TTabSheet;
    ProjectsBtn: TSpeedButton;
    ShapeBtn: TSpeedButton;
    BaseImagesBtn: TSpeedButton;
    DLGBtn: TSpeedButton;
    VectorDbBtn: TSpeedButton;
    DXFBtn: TSpeedButton;
    TigerBtn: TSpeedButton;
    HtfBtn: TSpeedButton;
    DemBtn: TSpeedButton;
    Label3: TLabel;
    Label2: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label25: TLabel;
    Label17: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Label49: TLabel;
    DemEdit: TEdit;
    HTFEdit: TEdit;
    ActorEdit: TEdit;
    DXFEdit: TEdit;
    VectorDbEdit: TEdit;
    PanEdit: TEdit;
    BaseImagesEdit: TEdit;
    ShapeEdit: TEdit;
    ProjectsEdit: TEdit;
    OpenDialog1: TOpenDialog;
    TabSheet2: TTabSheet;
    SOSMAPBtn: TSpeedButton;
    SOSMAPEdit: TEdit;
    VoiceEdit: TEdit;
    VoiceBtn: TSpeedButton;
    TracerBtn: TSpeedButton;
    TracerEdit: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    VRGISBtn: TSpeedButton;
    VRGISEdit: TEdit;
    ILHEdit: TEdit;
    LifeEdit: TEdit;
    Fractal3DEdit: TEdit;
    DTMEdit: TEdit;
    GripIceEdit: TEdit;
    GripIceBtn: TSpeedButton;
    DTMBtn: TSpeedButton;
    Fractal3DBtn: TSpeedButton;
    LifeBtn: TSpeedButton;
    ILHBtn: TSpeedButton;
    MapBtn: TSpeedButton;
    MapEdit: TEdit;
    MapLabel: TLabel;
    PrintBigCB: TCheckBox;
    ThumbnailsTS: TTabSheet;
    ThumbBtn: TSpeedButton;
    ThumbEdit: TEdit;
    Label15: TLabel;
    WidthEdit: TEdit;
    SizeUpDown: TUpDown;
    Label18: TLabel;
    Shape1: TShape;
    FillColorBtn: TSpeedButton;
    ColorDialog: TColorDialog;
    Label20: TLabel;
    Skip32BitNoticeCB: TCheckBox;
    TabSheet3: TTabSheet;
    ExtMemo: TMemo;
    ExtDefaults: TSpeedButton;
    ExtOpen: TSpeedButton;
    ExtSave: TSpeedButton;
    ExtensionSetRG: TRadioGroup;
    ClearExtBtn: TSpeedButton;
    TestSoundRG: TRadioGroup;
    UseThumbnailsCB: TCheckBox;
    SkipIntroScreenCB: TCheckBox;
    Label14: TLabel;
    NoNamePathBtn: TSpeedButton;
    NoNameEdit: TEdit;
    FilePreviewsCB: TCheckBox;
    TabSheet4: TTabSheet;
    DemMaxE: TLabel;
    ECI7Edit: TEdit;
    ECI8Edit: TEdit;
    ECI6Edit: TEdit;
    ECI5Edit: TEdit;
    ECI4Edit: TEdit;
    ECI1Edit: TEdit;
    ECI2Edit: TEdit;
    ECI3Edit: TEdit;
    DemMinE: TLabel;
    EColorsRG: TRadioGroup;
    DemCIE: TLabel;
    DemCIEEdit: TEdit;
    Label19: TLabel;
    NullValueEdit: TEdit;
    SavePaletteBtn: TSpeedButton;
    SaveDialog1: TSaveDialog;
    ColorDialog1: TColorDialog;
    colorcolorPanel: TPanel;
    ECI9Edit: TEdit;
    ContourIntervalsBtn: TSpeedButton;
    Is1CB: TCheckBox;
    Bevel3: TBevel;
    Bevel4: TBevel;
    ContourColorsCB: TCheckBox;
    DemCIEdit: TEdit;
    Label16: TLabel;
    CIColorsCB: TCheckBox;
    SetCIBtn: TSpeedButton;
    LoadSoundRG: TRadioGroup;
    Bevel5: TBevel;
    TabSheet5: TTabSheet;
    Label21: TLabel;
    Label24: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    TabSheet6: TTabSheet;
    CreateTexturesOnDemandCB: TCheckBox;
    SaveCreatedTexturesCB: TCheckBox;
    PixelEnlargementRG: TRadioGroup;
    UseSavedTexturesCB: TCheckBox;
    TilesperTextureRG: TRadioGroup;
    UseImageMapCB: TCheckBox;
    Label30: TLabel;
    UseEcoTypesCB: TCheckBox;
    UseConglomerationCB: TCheckBox;
    UseFlippedHTFCB: TCheckBox;
    TextureFileTypeRG: TRadioGroup;
    TabSheet7: TTabSheet;
    TabSheet8: TTabSheet;
    SlopeDirectionRG: TRadioGroup;
    Label31: TLabel;
    Label32: TLabel;
    Panel1: TPanel;
    Label34: TLabel;
    EditColorLabel: TLabel;
    Label35: TLabel;
    MapHighlightColorPanel: TPanel;
    MapBlankColorPanel: TPanel;
    MapEditColorPanel: TPanel;
    MapEditingColorPanel: TPanel;
    TabSheet9: TTabSheet;
    Performance: TComboBox;
    Memo1: TMemo;
    ColorSpace: TComboBox;
    PixelFormat: TComboBox;
    Scale: TComboBox;
    ProgressiveDisplay: TCheckBox;
    Label36: TLabel;
    Label37: TLabel;
    JpgQualityTrackBar: TTrackBar;
    IncrementalDisplay1: TCheckBox;
    Label38: TLabel;
    Label39: TLabel;
    SlopeEdit1: TEdit;
    SlopeEdit2: TEdit;
    SlopeEdit3: TEdit;
    SlopeEdit4: TEdit;
    SlopeEdit5: TEdit;
    SlopeEdit6: TEdit;
    SlopeEdit7: TEdit;
    SlopeEdit8: TEdit;
    SlopeEdit9: TEdit;
    SlopeNoneLabel: TLabel;
    SlopeMaxLabel: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    SlopeSavePalette: TSpeedButton;
    Label44: TLabel;
    Label45: TLabel;
    LOSAngleEdit: TEdit;
    LOSDirectionEdit: TEdit;
    LOSRangeEdit: TEdit;
    LOSHeightEdit: TEdit;
    MapDataColorPanel: TPanel;
    MapGridColorPanel: TPanel;
    MapBackgroundColorPanel: TPanel;
    MapContourColorPanel: TPanel;
    CurrentColorPanel: TPanel;
    Label29: TLabel;
    Label40: TLabel;
    MapMaroonedColorPanel: TPanel;
    Label33: TLabel;
    Label41: TLabel;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    LOSFanLimitsCB: TCheckBox;
    SlopeCellSizeEdit: TEdit;
    Label55: TLabel;
    Label56: TLabel;
    TerrainonlyBtn: TSpeedButton;
    TBRange: TTrackBar;
    UseBumpMapCB: TCheckBox;
    RangeLabel: TLabel;
    TabSheet10: TTabSheet;
    Label60: TLabel;
    UseClodPCB: TCheckBox;
    UseDOVCB: TCheckBox;
    UseQualityDCB: TCheckBox;
    QualityDUsedEdit: TEdit;
    ClodPUsedEdit: TEdit;
    DOVUsedEdit: TEdit;
    UseSeaLevelCB: TCheckBox;
    SeaLevelUsedEdit: TEdit;
    ZScaleUsedEdit: TEdit;
    UseZScaleCB: TCheckBox;
    UseXScaleCB: TCheckBox;
    XScaleUsedEdit: TEdit;
    UseWavesCB: TCheckBox;
    UseCloudsCB: TCheckBox;
    CloudSharpRangeUsedEdit: TEdit;
    CloudSharpUsedEdit: TEdit;
    CloudMinRangeUsedEdit: TEdit;
    CloudMinUsedEdit: TEdit;
    TabSheet11: TTabSheet;
    CloudChangeAmountEdit: TEdit;
    CloudAnimeEdit: TEdit;
    CloudImageSizeUsedEdit: TEdit;
    CloudRandomSeedUsedEdit: TEdit;
    CloudFileOpenBtn: TSpeedButton;
    CloudFileUsedEdit: TEdit;
    UseCloudFileCB: TCheckBox;
    MakeAndSaveCloudNoiseFile: TSpeedButton;
    Label61: TLabel;
    WavesRateUsedEdit: TEdit;
    WavesRangeUsedEdit: TEdit;
    UseCloudsRangeCB: TCheckBox;
    UseCloudsSRangeCB: TCheckBox;
    RegisterFileTypesCB: TCheckBox;
    UseStormCloudsCB: TCheckBox;
    StormCloudsRateUsedEdit: TEdit;
    StormCloudsRangeUsedEdit: TEdit;
    StormCloudsNumberUsedEdit: TEdit;
    StormCloudsNumRangeUsedEdit: TEdit;
    UseStormLinearCB: TCheckBox;
    StormCloudsPosXUsedEdit: TEdit;
    UseStormMovingCB: TCheckBox;
    StormCloudsPosYUsedEdit: TEdit;
    UseStormMovingPathCB: TCheckBox;
    UseStormRainCB: TCheckBox;
    UseStormTornadoesCB: TCheckBox;
    RainDensityUsedEdit: TEdit;
    RainDensityVarUsedEdit: TEdit;
    TornadoeFrequencyUsedEdit: TEdit;
    TornadoeForceUsedEdit: TEdit;
    StormMovingPathBtn: TSpeedButton;
    StormMovingFileUsedEdit: TEdit;
    LightningFrequencyUsedEdit: TEdit;
    UseStormLightningCB: TCheckBox;
    LightningForceUsedEdit: TEdit;
    StormCloudsDirectionUsedEdit: TEdit;
    StormCloudsSpeedUsedEdit: TEdit;
    LoadDTPOnStartCB: TCheckBox;
    MaximumShapeLayersEdit: TEdit;
    MaximumShapeObjectsEdit: TEdit;
    RunDTSCB: TCheckBox;
    DisplayFPSCB: TCheckBox;
    SunMovingUsedEdit: TEdit;
    UseSunMovingCB: TCheckBox;
    StormCloudsNumRangeVarUsedEdit: TEdit;
    StormCloudsPosZUsedEdit: TEdit;
    UseStormWindCB: TCheckBox;
    StormWindDirectionUsedEdit: TEdit;
    StormWindSpeedUsedEdit: TEdit;
    StormWindDirectionVarUsedEdit: TEdit;
    StormWindSpeedVariationUsedEdit: TEdit;
    StormCloudsRangeXUsedEdit: TEdit;
    StormCloudsRangeYUsedEdit: TEdit;
    StormCloudsRangeZUsedEdit: TEdit;
    UseStormMovingDirSCB: TCheckBox;
    Label59: TLabel;
    UseCloudsSettingCB: TCheckBox;
    TabSheet12: TTabSheet;
    GroupBox1: TGroupBox;
    Label57: TLabel;
    IntervalLabel: TLabel;
    Label58: TLabel;
    ThresholdLabel: TLabel;
    IntervalBar: TTrackBar;
    ThresholdBar: TTrackBar;
    JoyNullRangeTB: TTrackBar;
    NullRangeLabel: TLabel;
    Labelnull: TLabel;
    Label62: TLabel;
    Label63: TLabel;
    LoadDTCOnStartCB: TCheckBox;
    Label128: TLabel;
    DtmDtcLoadBtn: TSpeedButton;
    DtmDtcLoadEdit: TEdit;
    TabSheet13: TTabSheet;
    GroupBox2: TGroupBox;
    HtfRez2CB: TCheckBox;
    HtfRez3CB: TCheckBox;
    HtfRez4CB: TCheckBox;
    HtfRez5CB: TCheckBox;
    HtfRez6CB: TCheckBox;
    HtfRez7CB: TCheckBox;
    HtfRez8CB: TCheckBox;
    HtfRez11CB: TCheckBox;
    HtfRez2Btn: TSpeedButton;
    HtfRez2Edit: TEdit;
    HtfRez3Btn: TSpeedButton;
    HtfRez3Edit: TEdit;
    HtfRez4Btn: TSpeedButton;
    HtfRez4Edit: TEdit;
    HtfRez5Btn: TSpeedButton;
    HtfRez5Edit: TEdit;
    HtfRez6Btn: TSpeedButton;
    HtfRez6Edit: TEdit;
    HtfRez7Btn: TSpeedButton;
    HtfRez7Edit: TEdit;
    HtfRez8Btn: TSpeedButton;
    HtfRez8Edit: TEdit;
    HtfRez11Btn: TSpeedButton;
    HtfRez11Edit: TEdit;
    HtfRez1Btn: TSpeedButton;
    HtfRez1Edit: TEdit;
    HtfRez1CB: TCheckBox;
    HtfRez9Btn: TSpeedButton;
    HtfRez9Edit: TEdit;
    HtfRez9CB: TCheckBox;
    HtfRez10Btn: TSpeedButton;
    HtfRez10Edit: TEdit;
    HtfRez10CB: TCheckBox;
    procedure CloseBitBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
procedure GetOptions;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
procedure Showem;
    procedure MessageBtnClick(Sender: TObject);
    procedure POHelpBtnClick(Sender: TObject);
    procedure POM_ResetMenuBtnClick(Sender: TObject);

    procedure ProjectsBtnClick(Sender: TObject);
    procedure ShapeBtnClick(Sender: TObject);
    procedure BaseImagesBtnClick(Sender: TObject);
    procedure DLGBtnClick(Sender: TObject);
    procedure VectorDbBtnClick(Sender: TObject);
    procedure DXFBtnClick(Sender: TObject);
    procedure TigerBtnClick(Sender: TObject);
    procedure HtfBtnClick(Sender: TObject);
    procedure DemBtnClick(Sender: TObject);

    procedure BeepOrWavCBClick(Sender: TObject);
    procedure VRGISBtnClick(Sender: TObject);
    procedure ILHBtnClick(Sender: TObject);
    procedure LifeBtnClick(Sender: TObject);
    procedure Fractal3DBtnClick(Sender: TObject);
    procedure DTMBtnClick(Sender: TObject);
    procedure GripIceBtnClick(Sender: TObject);
    procedure TracerBtnClick(Sender: TObject);
    procedure VoiceBtnClick(Sender: TObject);
    procedure SOSMAPBtnClick(Sender: TObject);
    procedure FillColorBtnClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure ThumbBtnClick(Sender: TObject);
    procedure SizeUpDownClick(Sender: TObject; Button: TUDBtnType);
    procedure ExtOpenClick(Sender: TObject);
    procedure ExtSaveClick(Sender: TObject);
    procedure ExtDefaultsClick(Sender: TObject);
    procedure ClearExtBtnClick(Sender: TObject);
    procedure TestSoundRGClick(Sender: TObject);
    procedure MapBtnClick(Sender: TObject);
    procedure UseThumbnailsCBClick(Sender: TObject);
    procedure NoNamePathBtnClick(Sender: TObject);
    procedure SavePaletteBtnClick(Sender: TObject);
    procedure EColorsRGClick(Sender: TObject);
    procedure ECI1EditDblClick(Sender: TObject);
    procedure ECI2EditDblClick(Sender: TObject);
    procedure ECI3EditDblClick(Sender: TObject);
    procedure ECI4EditDblClick(Sender: TObject);
    procedure ECI5EditDblClick(Sender: TObject);
    procedure ECI6EditDblClick(Sender: TObject);
    procedure ECI7EditDblClick(Sender: TObject);
    procedure ECI8EditDblClick(Sender: TObject);
    procedure ContourIntervalsBtnClick(Sender: TObject);
    procedure MapContourColorPanelClick(Sender: TObject);
    procedure MapGridColorPanelClick(Sender: TObject);
    procedure MapDataColorPanelClick(Sender: TObject);
    procedure MapBackgroundColorPanelClick(Sender: TObject);
    procedure SlopeDirectionRGClick(Sender: TObject);
    procedure SetCIBtnClick(Sender: TObject);
    procedure LoadSoundRGClick(Sender: TObject);
    procedure CurrentColorPanelClick(Sender: TObject);
    procedure SlopeSavePaletteClick(Sender: TObject);
    procedure SlopeEdit1DblClick(Sender: TObject);
    procedure SlopeEdit2DblClick(Sender: TObject);
    procedure SlopeEdit3DblClick(Sender: TObject);
    procedure SlopeEdit4DblClick(Sender: TObject);
    procedure SlopeEdit5DblClick(Sender: TObject);
    procedure SlopeEdit6DblClick(Sender: TObject);
    procedure SlopeEdit7DblClick(Sender: TObject);
    procedure SlopeEdit8DblClick(Sender: TObject);
    procedure SlopeEdit9DblClick(Sender: TObject);
    procedure SlopeNoneLabelClick(Sender: TObject);
    procedure SlopeMaxLabelClick(Sender: TObject);
    procedure MapHighlightColorPanelClick(Sender: TObject);
    procedure MapEditColorPanelClick(Sender: TObject);
    procedure MapEditingColorPanelClick(Sender: TObject);
    procedure MapMaroonedColorPanelClick(Sender: TObject);
    procedure MapBlankColorPanelClick(Sender: TObject);
    procedure LOSAngleEditChange(Sender: TObject);
    procedure LOSHeightEditChange(Sender: TObject);
    procedure LOSRangeEditChange(Sender: TObject);
    procedure LOSDirectionEditChange(Sender: TObject);
    procedure LOSFanLimitsCBClick(Sender: TObject);
    procedure SlopeCellSizeEditChange(Sender: TObject);
    procedure IntervalBarChange(Sender: TObject);
    procedure ThresholdBarChange(Sender: TObject);
    procedure TerrainonlyBtnClick(Sender: TObject);
    procedure TBRangeChange(Sender: TObject);
    procedure MakeAndSaveCloudNoiseFileClick(Sender: TObject);
    procedure CloudFileOpenBtnClick(Sender: TObject);
    procedure StormMovingPathBtnClick(Sender: TObject);
    procedure JoyNullRangeTBChange(Sender: TObject);
    procedure DtmDtcLoadBtnClick(Sender: TObject);
    procedure HtfRez1BtnClick(Sender: TObject);
    procedure HtfRez2BtnClick(Sender: TObject);
    procedure HtfRez3BtnClick(Sender: TObject);
    procedure HtfRez4BtnClick(Sender: TObject);
    procedure HtfRez5BtnClick(Sender: TObject);
    procedure HtfRez6BtnClick(Sender: TObject);
    procedure HtfRez7BtnClick(Sender: TObject);
    procedure HtfRez8BtnClick(Sender: TObject);
    procedure HtfRez9BtnClick(Sender: TObject);
    procedure HtfRez10BtnClick(Sender: TObject);
    procedure HtfRez11BtnClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dtmPOFForm: TdtmPOFForm;

implementation

{$R *.DFM}

uses dtmErrMsg, dtmGlobals, dtmPOFvar;

procedure TdtmPOFForm.CloseBitBtnClick(Sender: TObject);
begin
  Close;
end;
procedure TdtmPOFForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  GetOptions;
end;
procedure TdtmPOFForm.GetOptions;
var code: Integer;
begin
  POFFormY := dtmPOFForm.top;
  POFFormX := dtmPOFForm.left;
  ErrorBeepOn := ErrorsCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
  Skip32BitNotice:=   Skip32BitNoticeCB.Checked;
  SkipIntroScreen:=   SkipIntroScreenCB.Checked;
  PrintBigChecked:=  PrintBigCB.Checked;

  Case PixelEnlargementRG.ItemIndex of
  0:PixelEnlargement:=2;
  1:PixelEnlargement:=4;
  2:PixelEnlargement:=8;
  3:PixelEnlargement:=16;
  end;
  Case TilesperTextureRG.ItemIndex of
  0:TilesperTexture:=1;
  1:TilesperTexture:=2;
  2:TilesperTexture:=4;
  3:TilesperTexture:=8;
  end;
  //Terrain HTF
  UseFlippedHTF:= UseFlippedHTFCB.Checked;
  CreateTexturesOnDemand:= CreateTexturesOnDemandCB.Checked;
  SaveCreatedTextures:= SaveCreatedTexturesCB.Checked;
  UseSavedTextures:=UseSavedTexturesCB.Checked;
  UseEcoTypes:= UseEcoTypesCB.Checked;
  UseImageMap:= UseImageMapCB.Checked;
  UseConglomeration:= UseConglomerationCB.Checked;
  UseBumpMap:= UseBumpMapCB.Checked;
  BumpRanger:=TBRange.Position;
  UseXScale := UseXScaleCB.Checked;
  UseZScale:= UseZScaleCB.Checked;
  UseSeaLevel:= UseSeaLevelCB.Checked;
  val(XScaleUsedEdit.Text, XScaleUsed, Code);
  val(ZScaleUsedEdit.Text, ZScaleUsed, Code);
  val(SeaLevelUsedEdit.Text, SeaLevelUsed, Code);
  UseClouds:= UseCloudsCB.Checked;
  UseWaves:= UseWavesCB.Checked;
  UseStormClouds:= UseStormCloudsCB.Checked;
  LoadDTPOnStart :=  LoadDTPOnStartCB.Checked;
  MaximumShapeObjects:= strtoint(MaximumShapeObjectsEdit.Text);
  MaximumShapeLevels:= strtoint(MaximumShapeLayersEdit.Text);
  TextureFileType:=TextureFileTypeRG.ItemIndex;
  RunDTS:= RunDTSCB.Checked;
  DtmDtcLoad:=DtmDtcLoadEdit.Text;
  LoadDTCOnStart:=LoadDTCOnStartCB.Checked;
  UseDOV:= UseDOVCB.Checked;
  UseClodP:= UseClodPCB.Checked;
  UseQualityD:= UseQualityDCB.Checked;
  val(DOVUsedEdit.Text, DOVUsed, Code);
  val(ClodPUsedEdit.Text, ClodPUsed, Code);
  val(QualityDUsedEdit.Text, QualityDUsed, Code);

  val(StormCloudsRateUsedEdit.Text, StormCloudsRateUsed, Code);
  val(StormCloudsRangeUsedEdit.Text, StormCloudsRangeUsed, Code);
  val(WavesRateUsedEdit.Text, WavesRateUsed, Code);
  val(WavesRangeUsedEdit.Text, WavesRangeUsed, Code);
  UseSunMoving:= UseSunMovingCB.Checked;
  DisplayFPS:= DisplayFPSCB.Checked;
  SunMovingUsed:=Strtoint(SunMovingUsedEdit.Text);
  UseCloudsSRange:=UseCloudsSRangeCB.Checked;
 CloudFileUsed:=CloudFileUsedEdit.Text;
 UseCloudFile:= UseCloudFileCB.Checked;
  UseCloudsRange:=UseCloudsRangeCB.Checked;
   CloudAnime:=Strtoint(CloudAnimeEdit.Text);
  val(CloudChangeAmountEdit.Text, CloudChangeAmount, Code);
  val(CloudSharpUsedEdit.Text, CloudSharpUsed, Code);
  val(CloudSharpRangeUsedEdit.Text, CloudSharpRangeUsed, Code);

  CloudRandomSeedUsed:=Strtoint(CloudRandomSeedUsedEdit.Text);
  CloudImageSizeUsed:=Strtoint(CloudImageSizeUsedEdit.Text);
  CloudMinUsed:=Strtoint(CloudMinUsedEdit.Text);
  CloudMinRangeUsed:=Strtoint(CloudMinRangeUsedEdit.Text);
//
  StormMovingFileUsed:=StormMovingFileUsedEdit.Text;
  StormWindDirectionUsed:=Strtoint(StormWindDirectionUsedEdit.Text);
  StormWindSpeedUsed:=Strtoint(StormWindSpeedUsedEdit.Text);
  StormWindDirectionVarUsed:=Strtoint(StormWindDirectionVarUsedEdit.Text);
  StormWindSpeedVariationUsed:=Strtoint(StormWindSpeedVariationUsedEdit.Text);
  StormCloudsDirectionUsed:=Strtoint(StormCloudsDirectionUsedEdit.Text);
  StormCloudsSpeedUsed:=Strtoint(StormCloudsSpeedUsedEdit.Text);
  StormCloudsNumberUsed:=Strtoint(StormCloudsNumberUsedEdit.Text);

  RainDensityUsed:=StrtoFloatDef(RainDensityUsedEdit.Text);
  RainDensityVarUsed:=StrtoFloatDef(RainDensityVarUsedEdit.Text);
  LightningFrequencyUsed:=StrtoFloatDef(LightningFrequencyUsedEdit.Text);
  LightningForceUsed:=StrtoFloatDef(LightningForceUsedEdit.Text);
  TornadoeFrequencyUsed:=StrtoFloatDef(TornadoeFrequencyUsedEdit.Text);
  TornadoeForceUsed:=StrtoFloatDef(TornadoeForceUsedEdit.Text);
  StormCloudsPosXUsed:=StrtoFloatDef(StormCloudsPosXUsedEdit.Text);
  StormCloudsPosYUsed:=StrtoFloatDef(StormCloudsPosYUsedEdit.Text);
  StormCloudsPosZUsed:=StrtoFloatDef(StormCloudsPosZUsedEdit.Text);
  StormCloudsNumRangeUsed:=StrtoFloatDef(StormCloudsNumRangeUsedEdit.Text);
  StormCloudsNumRangeVarUsed:=StrtoFloatDef(StormCloudsNumRangeVarUsedEdit.Text);
  StormCloudsRangeXUsed:=StrtoFloatDef(StormCloudsRangeXUsedEdit.Text);
  StormCloudsRangeYUsed:=StrtoFloatDef(StormCloudsRangeYUsedEdit.Text);
  StormCloudsRangeZUsed:=StrtoFloatDef(StormCloudsRangeZUsedEdit.Text);

  UseCloudsSetting:=UseCloudsSettingCB.Checked;
  UseStormLinear:=UseStormLinearCB.Checked;
  UseStormMoving:=UseStormMovingCB.Checked;
  UseStormMovingDirS:=UseStormMovingDirSCB.Checked;
  UseStormMovingPath:=UseStormMovingPathCB.Checked;
  UseStormRain:=UseStormRainCB.Checked;
  UseStormLightning:=UseStormLightningCB.Checked;
  UseStormTornadoes:=UseStormTornadoesCB.Checked;
  UseStormWind:=UseStormWindCB.Checked;
//

{Get the Thumbnail data}
  {ThumbPath}
  UseThumbnails:= UseThumbnailsCB.Checked;
  ThumbSize:=SizeUpDown.Position;   {ThumbWidth }
  {ThumbColor }
{Get the Message locations}
  val(MessageXEdit.Text, MessageX, Code);
  val(MessageYEdit.Text, MessageY, Code);

  JoyNullRange:=JoyNullRangeTB.Position;
  ThresholdBarPosition:=ThresholdBar.Position;
  IntervalBarPosition:=IntervalBar.Position;

  TotalContours:=Strtoint(DemCIEdit.Text);
  ContourInterval:=Strtoint(DemCIEEdit.Text);
  UseContourColors := ContourColorsCB.Checked;
  SlopeDirection:=SlopeDirectionRG.ItemIndex;
  SlopeCellSize:=Strtoint(  SlopeCellSizeEdit.Text);
  LOSFanLimits:=LOSFanLimitsCB.Checked;
  DoSaver;
end;




procedure TdtmPOFForm.FormCreate(Sender: TObject);
begin
  top := POFFormY;
  left := POFFormX;
  OpenDialog1.InitialDir := HTFPath;
            {-50000.. - 7001: }{black 0,0,0}
     ECI1Edit.Color:= RGB({-7000.. - 6001: Navy} 0,0,128);
     ECI2Edit.Color:= RGB({-6000.. - 2001:Blue} 0,0,255 );
     ECI3Edit.Color:= RGB({-2000..0: Aqua} 0,255,255 );
     ECI4Edit.Color:= RGB({1..400:   Green} 0,255,0);
     ECI5Edit.Color:= RGB({401..1000: Yellow} 255,255,0);
     ECI6Edit.Color:= RGB({1001..2000:  Red }255,0,0);
     ECI7Edit.Color:= RGB({2001..3000:  Purple} 255,0,255);
     ECI8Edit.Color:= RGB({3001..4001:  Smog} 128,128,128);
     ECI9Edit.Color:= RGB({4001..50000:  Snow} 255,255,255);
     colorcolorPanel.Caption:=
     Inttostr(GetRValue(colorcolorPanel.Color))+','+
     Inttostr(GetGValue(colorcolorPanel.Color))+','+
     Inttostr(GetBValue(colorcolorPanel.Color));
end;

procedure TdtmPOFForm.MessageBtnClick(Sender: TObject);
begin
  MessageX := StrtoInt(MessageXEdit.Text);
  MessageY := StrtoInt(MessageYEdit.Text);
  DoMessages(7499); {7499, "Resistance is futile
                      \015\012All Messages end here"}
end;

procedure TdtmPOFForm.POHelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(50);
end;

procedure TdtmPOFForm.POM_ResetMenuBtnClick(Sender: TObject);
begin
  ResetToDefaults;
  Showem;
End;
procedure TdtmPOFForm.TerrainonlyBtnClick(Sender: TObject);
begin
  ResetTerrainDefaults;
  Showem;
end;
procedure TdtmPOFForm.FormShow(Sender: TObject);
begin
  Showem;
end;

procedure TdtmPOFForm.Showem;
var ShowString: string;
begin
{Set all the boxes and edits}
  ErrorsCB.Checked:=ErrorBeepOn;
  WarningCB.Checked:=WarningBeepOn;
  InfoCB.Checked:=InfoBeepOn;
  ConfirmationCB.Checked:=ConfirmBeepOn;
  CompletionCB.Checked:=CompletedBeepOn;
  PrintBigCB.Checked:=PrintBigChecked;
  FilePreviewsCB.Checked:=FilePreviews;
  Skip32BitNoticeCB.Checked:=Skip32BitNotice;


  TextureFileTypeRG.ItemIndex:=TextureFileType;
  UseFlippedHTFCB.Checked:= UseFlippedHTF;
  CreateTexturesOnDemandCB.Checked:= CreateTexturesOnDemand;
  SaveCreatedTexturesCB.Checked:= SaveCreatedTextures;
  UseSavedTexturesCB.Checked:=UseSavedTextures;
  UseEcoTypesCB.Checked:=UseEcoTypes;
  UseImageMapCB.Checked:=UseImageMap;
  UseConglomerationCB.Checked:=UseConglomeration;
  UseBumpMapCB.Checked:=UseBumpMap;
    TBRange.Position:=BumpRanger;
    RangeLabel.Caption:=Inttostr(TBRange.Position);
  LoadDTPOnStartCB.Checked:=LoadDTPOnStart;
  MaximumShapeObjectsEdit.Text :=Inttostr(MaximumShapeObjects);
  MaximumShapeLayersEdit.Text :=Inttostr(MaximumShapeLevels);
  UseCloudsCB.Checked:=UseClouds;
  UseWavesCB.Checked:=UseWaves;
  UseStormCloudsCB.Checked:=UseStormClouds;
  SunMovingUsedEdit.Text:=Inttostr(SunMovingUsed);
  UseCloudsSRangeCB.Checked:= UseCloudsSRange;
  RunDTSCB.Checked:=RunDTS;
  DtmDtcLoadEdit.Text:=DtmDtcLoad;
  LoadDTCOnStartCB.Checked:=LoadDTCOnStart;
  UseDOVCB.Checked:=UseDOV;
  UseClodPCB.Checked:=UseClodP;
  UseQualityDCB.Checked:=UseQualityD;
  DOVUsedEdit.Text := floattostr(DOVUsed);
  ClodPUsedEdit.Text := floattostr(ClodPUsed);
  QualityDUsedEdit.Text := floattostr(QualityDUsed);

  StormCloudsRateUsedEdit.Text := floattostr(StormCloudsRateUsed);
  StormCloudsRangeUsedEdit.Text := floattostr(StormCloudsRangeUsed);
  WavesRateUsedEdit.Text := floattostr(WavesRateUsed);
  WavesRangeUsedEdit.Text := floattostr(WavesRangeUsed);
 CloudFileUsedEdit.Text:=CloudFileUsed;
 UseCloudsRangeCB.Checked:=UseCloudsRange;
 UseCloudFileCB.Checked:=UseCloudFile;
   UseSunMovingCB.Checked:=UseSunMoving;
   DisplayFPSCB.Checked:=DisplayFPS;
  CloudAnimeEdit.Text :=floattostr(CloudAnime);
  CloudChangeAmountEdit.Text := floattostr(CloudChangeAmount);
  CloudSharpUsedEdit.Text := floattostr(CloudSharpUsed);
  CloudSharpRangeUsedEdit.Text := floattostr(CloudSharpRangeUsed);
  CloudRandomSeedUsedEdit.Text:=Inttostr(CloudRandomSeedUsed );
  CloudImageSizeUsedEdit.Text :=Inttostr(CloudImageSizeUsed);
  CloudMinUsedEdit.Text :=Inttostr(CloudMinUsed);
  CloudMinRangeUsedEdit.Text :=Inttostr(CloudMinRangeUsed);
//
  StormMovingFileUsedEdit.Text:=StormMovingFileUsed;
  StormWindDirectionUsedEdit.Text:=Inttostr(StormWindDirectionUsed);
  StormWindSpeedUsedEdit.Text:=Inttostr(StormWindSpeedUsed);
  StormWindDirectionVarUsedEdit.Text:=Inttostr(StormWindDirectionVarUsed);
  StormWindSpeedVariationUsedEdit.Text:=Inttostr(StormWindSpeedVariationUsed);
  StormCloudsDirectionUsedEdit.Text:=Inttostr(StormCloudsDirectionUsed);
  StormCloudsSpeedUsedEdit.Text:=Inttostr(StormCloudsSpeedUsed);
  StormCloudsNumberUsedEdit.Text:=Inttostr(StormCloudsNumberUsed);

  RainDensityUsedEdit.Text:=floattostr(RainDensityUsed);
  RainDensityVarUsedEdit.Text:=floattostr(RainDensityVarUsed);
  LightningFrequencyUsedEdit.Text:=floattostr(LightningFrequencyUsed);
  LightningForceUsedEdit.Text:=floattostr(LightningForceUsed);
  TornadoeFrequencyUsedEdit.Text:=floattostr(TornadoeFrequencyUsed);
  TornadoeForceUsedEdit.Text:=floattostr(TornadoeForceUsed);
  StormCloudsPosXUsedEdit.Text:=floattostr(StormCloudsPosXUsed);
  StormCloudsPosYUsedEdit.Text:=floattostr(StormCloudsPosYUsed);
  StormCloudsPosZUsedEdit.Text:=floattostr(StormCloudsPosZUsed);
  StormCloudsNumRangeUsedEdit.Text:=floattostr(StormCloudsNumRangeUsed);
  StormCloudsNumRangeVarUsedEdit.Text:=floattostr(StormCloudsNumRangeVarUsed);
  StormCloudsRangeXUsedEdit.Text:=floattostr(StormCloudsRangeXUsed);
  StormCloudsRangeYUsedEdit.Text:=floattostr(StormCloudsRangeYUsed);
  StormCloudsRangeZUsedEdit.Text:=floattostr(StormCloudsRangeZUsed);

  UseCloudsSettingCB.Checked:=UseCloudsSetting;
  UseStormLinearCB.Checked:=UseStormLinear;
  UseStormMovingCB.Checked:=UseStormMoving;
  UseStormMovingDirSCB.Checked:=UseStormMovingDirS;
  UseStormMovingPathCB.Checked:=UseStormMovingPath;
  UseStormRainCB.Checked:=UseStormRain;
  UseStormLightningCB.Checked:=UseStormLightning;
  UseStormTornadoesCB.Checked:=UseStormTornadoes;
  UseStormWindCB.Checked:=UseStormWind;
//
  Case PixelEnlargement of
  2:PixelEnlargementRG.ItemIndex:=0;
  4:PixelEnlargementRG.ItemIndex:=1;
  8:PixelEnlargementRG.ItemIndex:=2;
  16:PixelEnlargementRG.ItemIndex:=3;
  end;
  Case TilesperTexture of
  1:TilesperTextureRG.ItemIndex:=0;
  2:TilesperTextureRG.ItemIndex:=1;
  4:TilesperTextureRG.ItemIndex:=2;
  8:TilesperTextureRG.ItemIndex:=3;
  end;

  //str(XScaleUsed,12,4, ShowString);
  XScaleUsedEdit.Text := Format('%12.4f', [XScaleUsed]);//ShowString;
  //str(ZScaleUsed, ShowString);
  ZScaleUsedEdit.Text := Format('%12.4f', [ZScaleUsed]);//ShowString;
  str(SeaLevelUsed, ShowString);
  SeaLevelUsedEdit.Text := ShowString;
  UseXScaleCB.Checked:= UseXScale;
  UseZScaleCB.Checked:= UseZScale;
  UseSeaLevelCB.Checked:= UseSeaLevel;



  UseThumbnailsCB.Checked:=UseThumbnails;
  str(MessageX, ShowString);
  MessageXEdit.Text := ShowString;
  str(MessageY, ShowString);
  MessageYEdit.Text := ShowString;
  Fractal3DEdit.Text:=Fractal3DPath;
  LifeEdit.Text:=LifePath;
  SOSMAPEdit.Text:=SOSMAPPath;
  TracerEdit.Text:=DigitizerPath;
  VRGISEdit.Text:=VRGISPath;
  DTMEdit.Text:=DTMPath;
  VoiceEdit.Text:=VoicePath;
  GripIceEdit.Text:=RasterPath;
  ILHEdit.Text:=ILHProgram;
  ProjectsEdit.Text := ProjectPath;
  MapEdit.Text:=MapsPath;
  NoNameEdit.Text := NoNamePath;
  ActorEdit.Text := TigerPath;
  DemEdit.Text := DemPath;
  HTFEdit.Text := HTFPath;
  PanEdit.Text := DLGPath;
  DXFEdit.Text := DXFPath;
  ShapeEdit.Text := ShapePath;
  VectorDbEdit.Text := VRMDatabase;
  BaseImagesEdit.Text := ImagePath;
  ThumbEdit.Text :=ThumbPath;
  SizeUpDown.Position:=ThumbSize;   {Thumb Width and Height}
  Shape1.Brush.Color:=ThumbColor ;
  DemCIEdit.Text:= Inttostr(TotalContours);
  DemCIEEdit.Text:=Inttostr(ContourInterval);
  ContourColorsCB.Checked:=UseContourColors;
  SlopeDirectionRG.ItemIndex:=SlopeDirection;
  SlopeCellSizeEdit.Text:=Inttostr(SlopeCellSize);

   LOSFanLimitsCB.Checked:=LOSFanLimits;
   LOSHeightEdit.Text:=Inttostr(LOSHeight);
   LOSRangeEdit.Text:=Inttostr(LOSRange);
   LOSDirectionEdit.Text:=Inttostr(LOSDirection);
   LOSAngleEdit.Text:=Inttostr(LOSAngle);

  CurrentColorPanel.Color := CurrentColor;
  MapDataColorPanel.Color:=MapDataColor;
  MapHighlightColorPanel.Color:= MapHighlightColor;
  MapEditColorPanel.Color:=MapEditColor;
  MapEditingColorPanel.Color:= MapEditingColor;
  MapGridColorPanel.Color:=MapGridColor;
  MapContourColorPanel.Color:= MapContourColor;
  MapBackgroundColorPanel.Color:=MapBackgroundColor;
  MapBlankColorPanel.Color:=  MapBlankColor;
  MapMaroonedColorPanel.Color:= MapMaroonedColor;

  JoyNullRangeTB.Position:=JoyNullRange;
  ThresholdBar.Position:=ThresholdBarPosition;
  IntervalBar.Position:=IntervalBarPosition;
  NullRangeLabel.Caption:=Inttostr(JoyNullRangeTB.Position);
  ThresholdLabel.Caption:=Inttostr(ThresholdBar.Position);
  IntervalLabel.Caption:=Inttostr(IntervalBar.Position);
end;




procedure TdtmPOFForm.ProjectsBtnClick(Sender: TObject);
begin
  TransSearchDir:= ProjectPath;
  if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    ProjectPath := TransSearchDir;
    ProjectsEdit.Text := ProjectPath;
  end {else DoMessages(1)};
end;

procedure TdtmPOFForm.MapBtnClick(Sender: TObject);
begin
  TransSearchDir:= MapsPath;
  if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    MapsPath := TransSearchDir;
    MapEdit.Text := MapsPath;
  end {else DoMessages(1)};
end;

procedure TdtmPOFForm.ShapeBtnClick(Sender: TObject);
begin
  TransSearchDir:= ShapePath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      ShapePath := TransSearchDir;
      ShapeEdit.Text := ShapePath;
    end {else DoMessages(8)};
end;

procedure TdtmPOFForm.BaseImagesBtnClick(Sender: TObject);
begin
  TransSearchDir:= ImagePath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      ImagePath := TransSearchDir;
        BaseImagesEdit.Text := ImagePath;
    end {else DoMessages(13)};
end;

procedure TdtmPOFForm.DLGBtnClick(Sender: TObject);
begin
  TransSearchDir:= DLGPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DLGPath := TransSearchDir;
      PanEdit.Text := DLGPath;
    end{ else DoMessages(10)};
end;

procedure TdtmPOFForm.VectorDbBtnClick(Sender: TObject);
begin
  TransSearchDir:= VRMDatabase;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      VRMDatabase := TransSearchDir;
      VectorDbEdit.Text := VRMDatabase;
    end {else DoMessages(12)};
end;

procedure TdtmPOFForm.DXFBtnClick(Sender: TObject);
begin
  TransSearchDir:= DXFPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DXFPath := TransSearchDir;
      DXFEdit.Text := DXFPath;
    end {else DoMessages(11)};
end;


procedure TdtmPOFForm.TigerBtnClick(Sender: TObject);
begin
  TransSearchDir:= TigerPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
    TigerPath := TransSearchDir;
    ActorEdit.Text := TigerPath;
  end; {else DoMessages(3);}
end;

procedure TdtmPOFForm.HtfBtnClick(Sender: TObject);
begin
  TransSearchDir:= HTFPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      HTFPath := TransSearchDir;
      HTFEdit.Text := HTFPath;
  end;{ else DoMessages(4);}
end;

procedure TdtmPOFForm.DemBtnClick(Sender: TObject);
begin
  TransSearchDir:= DemPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
        begin
      DemPath :=TransSearchDir;
      DemEdit.Text := DemPath;
  end;{ else DoMessages(9);}
end;

procedure TdtmPOFForm.VRGISBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'VRGIS Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := VRGISPath;
  OpenDialog1.Filename:='vrgis.exe';
  if OpenDialog1.execute then
  begin
    VRGISPath := (OpenDialog1.filename);
    VRGISEdit.Text := VRGISPath;
  end;
end;

procedure TdtmPOFForm.ILHBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'ILH Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := ILHProgram;
  OpenDialog1.Filename:='Image.exe';
  if OpenDialog1.execute then
  begin
    ILHProgram := (OpenDialog1.filename);
    ILHEdit.Text := ILHProgram;
  end;
end;

procedure TdtmPOFForm.LifeBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Life Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := LifePath;
  OpenDialog1.Filename:='Life.exe';
  if OpenDialog1.execute then
  begin
    LifePath := (OpenDialog1.filename);
    LifeEdit.Text := LifePath;
  end;
end;

procedure TdtmPOFForm.Fractal3DBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Fractal3D Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := Fractal3DPath;
  OpenDialog1.Filename:='Fractl3D.exe';
  if OpenDialog1.execute then
  begin
    Fractal3DPath := (OpenDialog1.filename);
    Fractal3DEdit.Text := Fractal3DPath;
  end;
end;

procedure TdtmPOFForm.DTMBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'DTM Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := DTMPath;
  OpenDialog1.Filename:='dtm.exe';
  if OpenDialog1.execute then
  begin
    DTMPath := (OpenDialog1.filename);
    DTMEdit.Text := DTMPath;
  end;
end;

procedure TdtmPOFForm.GripIceBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'GripIce Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := RasterPath;
  OpenDialog1.Filename:='grip.exe';
  if OpenDialog1.execute then
  begin
    RasterPath := (OpenDialog1.filename);
    GripIceEdit.Text := RasterPath;
  end;
end;


procedure TdtmPOFForm.TracerBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Tracer Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := DigitizerPath;
  OpenDialog1.Filename:='Tracer.exe';
  if OpenDialog1.execute then
  begin
    DigitizerPath := (OpenDialog1.filename);
    TracerEdit.Text := DigitizerPath;
  end;
end;

procedure TdtmPOFForm.VoiceBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Voice Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := VoicePath;
  OpenDialog1.Filename:='Voice.exe';
  if OpenDialog1.execute then
  begin
    VoicePath := (OpenDialog1.filename);
    VoiceEdit.Text := VoicePath;
  end;
end;

procedure TdtmPOFForm.SOSMAPBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'SOSMAP Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := SOSMAPPath;
  OpenDialog1.Filename:='sosmap.exe';
  if OpenDialog1.execute then
  begin
    SOSMAPPath := (OpenDialog1.filename);
    SOSMAPEdit.Text := SOSMAPPath;
  end;
end;
procedure TdtmPOFForm.NoNamePathBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'NoName Program (*.exe)|*.exe';
  OpenDialog1.InitialDir := NoNamePath;
  OpenDialog1.Filename:='*.exe';
  if OpenDialog1.execute then
  begin
    NoNamePath := (OpenDialog1.filename);
    NoNameEdit.Text := NoNamePath;
  end;
end;

(*
procedure TForm1.CreateButtonClick(Sender: TObject);
var
  i: Integer;
  InFileName, OutFileName: string;
  FilePath, FileName: string;
begin
  for i:=0 to FilesListBox.Items.Count-1 do
  begin
    InFileName:=FilesListBox.Items[i];
    FilePath:=ExtractFilePath(InFileName);
    FileName:=ExtractFileName(InFileName);
    if OutDirEdit.Text<>'' then
      FilePath:=IncludeTrailingBackSlash(OutDirEdit.Text);
                                        {ThumbPath}
    OutFileName:=Concat(FilePath,
    PrefixEdit.Text,                  {ThmPrefix  max 5}
    FileName);
    CreateThumbnail(InFileName,OutFileName,
    WidthUpDown.Position,             {ThumbWidth }
      HeightUpDown.Position,           {ThumbHeight }
      Shape1.Brush.Color);             {ThumbColor }
    Application.ProcessMessages;
    StatusBar1.SimpleText:=
    'Done '+IntToStr(i+1)+' of '+IntToStr(FilesListBox.Items.count);
  end;
end;
*)
{  UseThumbnailsCB.Checked:=UseThumbnails;}
procedure TdtmPOFForm.UseThumbnailsCBClick(Sender: TObject);
begin
  UseThumbnails:=(not UseThumbnails);
  UseThumbnailsCB.Checked:=UseThumbnails;
end;

procedure TdtmPOFForm.FillColorBtnClick(Sender: TObject);
begin
  ColorDialog.Color:=ThumbColor;
  if ColorDialog.Execute then
      ThumbColor:=ColorDialog.Color;
  Shape1.Brush.Color:=ThumbColor;
end;

procedure TdtmPOFForm.ThumbBtnClick(Sender: TObject);
begin
  TransSearchDir:= ThumbPath;
      if SelectDirectory(TransSearchDir,
        [sdAllowCreate, sdPerformCreate, sdPrompt],
        SELDIRHELP) then
  begin
    ThumbPath := TransSearchDir;
    ThumbEdit.Text := ThumbPath;
  end;
end;

procedure TdtmPOFForm.SizeUpDownClick(Sender: TObject; Button: TUDBtnType);
begin
If ((Button = btNext) and  (SizeUpDown.Position <287)) then
   begin
   Shape1.Width:=SizeUpDown.Position+1;
   Shape1.Height:=SizeUpDown.Position+1;
   end   else  {287w 190h}
If ((Button = btPrev) and  (SizeUpDown.Position >2)) then
   begin
   Shape1.Width:=SizeUpDown.Position-1;
   Shape1.Height:=SizeUpDown.Position-1;
   end;
end;
(*If ((Button = btNext) and  (HeightUpDown.Position <190)) then
   Shape1.Height:=HeightUpDown.Position+1
   else  {287w 190h}
If ((Button = btPrev) and  (HeightUpDown.Position >2)) then
   Shape1.Height:=HeightUpDown.Position-1;*)
{The Button parameter specifies how the value of Position
 is about to change.
 When Button is btNext, the Up or Right arrow was clicked,
 and the value of Position is about to increase by Increment.
  When Button is btPrev, the Down or Left arrow was clicked,
  and the value of Position is about to decrease by Increment.  }
procedure TdtmPOFForm.ExtOpenClick(Sender: TObject);
var
ExtFileName:String;
begin

Case ExtensionSetRG.ItemIndex of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
If FileExists(ProgramPath+ExtFileName) then
  ExtMemo.Lines.LoadFromFile(ProgramPath+ExtFileName)
  else
  begin
  Tempname:=ProgramPath+ExtFileName;
  DoMessages(30002);{30002, "Error opening file "}
  end;
end;

procedure TdtmPOFForm.ExtSaveClick(Sender: TObject);
var
ExtFileName:String;
begin
Case ExtensionSetRG.ItemIndex of
0:ExtFileName:='Grafext.et0';
1:ExtFileName:='Grafext.et1';
2:ExtFileName:='Grafext.et2';
3:ExtFileName:='Grafext.et3';
4:ExtFileName:='Grafext.et4';
5:ExtFileName:='Grafext.et5';
6:ExtFileName:='Grafext.et6';
end;{case}
  ExtMemo.Lines.SaveToFile(ProgramPath+ExtFileName)
end;

procedure TdtmPOFForm.ExtDefaultsClick(Sender: TObject);
begin
Case ExtensionSetRG.ItemIndex of
0:begin
{ExtMemo}
  ExtMemo.Lines.Add('*.shp');
  ExtMemo.Lines.Add('*.shx');
  ExtMemo.Lines.Add('*.sbx');
  ExtMemo.Lines.Add('*.sbx');
  ExtMemo.Lines.Add('*.dxf');
  ExtMemo.Lines.Add('*.dlg');
  ExtMemo.Lines.Add('*.vrm');
  ExtMemo.Lines.Add('*.3ds');
  {Actors .. other 3D Vector file types}  
end;
1:begin
  ExtMemo.Lines.Add('*.raw');
    {.$ifdef PortableNetworkGraphic}
  ExtMemo.Lines.Add('*.png');
    {.$endif}
    // internally register Delphi's "built in" formats,
    //these will not be unregistered on exit and
    // also not registered with TPicture
    //(because they are already or will soon be)
  ExtMemo.Lines.Add('*.bmp');
  ExtMemo.Lines.Add('*.ico');
  ExtMemo.Lines.Add('*.wmf');
  ExtMemo.Lines.Add('*.emf');
  ExtMemo.Lines.Add('*.jfif');
  ExtMemo.Lines.Add('*.jpg');
  ExtMemo.Lines.Add('*.jpe');
  ExtMemo.Lines.Add('*.jpeg');

    // register our own formats
  ExtMemo.Lines.Add('*.rle');
  ExtMemo.Lines.Add('*.dib');

    {.$ifdef TargaGraphic}
  ExtMemo.Lines.Add('*.win');
  ExtMemo.Lines.Add('*.vst');
  ExtMemo.Lines.Add('*.vda');
  ExtMemo.Lines.Add('*.tga');
  ExtMemo.Lines.Add('*.icb');
    {.$endif}

    {.$ifdef TIFFGraphic}
  ExtMemo.Lines.Add('*.tiff');
  ExtMemo.Lines.Add('*.tif');
  ExtMemo.Lines.Add('*.fax');
      {.$ifdef EPSGraphic}
  ExtMemo.Lines.Add('*.eps');
      {.$endif}
    {.$endif}

    {.$ifdef PCXGraphic}
  ExtMemo.Lines.Add('*.pcx');
  ExtMemo.Lines.Add('*.pcc');
  ExtMemo.Lines.Add('*.scr');
    {.$endif}

    {.$ifdef RLAGraphic}
  ExtMemo.Lines.Add('*.rpf');
  ExtMemo.Lines.Add('*.rla');
    {.$endif}

    {.$ifdef SGIGraphic}
  ExtMemo.Lines.Add('*.sgi');
  ExtMemo.Lines.Add('*.rgba');
  ExtMemo.Lines.Add('*.rgb');
  ExtMemo.Lines.Add('*.bw');
    {.$endif}

    {.$ifdef PhotoshopGraphic}
  ExtMemo.Lines.Add('*.psd');
  ExtMemo.Lines.Add('*.pdd');
    {.$endif}

    {.$ifdef PortableMapGraphic}
  ExtMemo.Lines.Add('*.ppm');
  ExtMemo.Lines.Add('*.pgm');
  ExtMemo.Lines.Add('*.pbm');
    {.$endif}

    {.$ifdef AutodeskGraphic}
  ExtMemo.Lines.Add('*.cel');
  ExtMemo.Lines.Add('*.pic');
    {.$endif}

    {.$ifdef PCDGraphic}
  ExtMemo.Lines.Add('*.pcd');
    {.$endif}

    {$ifdef GIFGraphic}
  ExtMemo.Lines.Add('*.gif');
    {$endif}

    {.$ifdef CUTGraphic}
  ExtMemo.Lines.Add('*.cut');
    {.$endif}

    {.$ifdef PaintshopProGraphic}
  ExtMemo.Lines.Add('*.psp');
    {.$endif}
end;
2:begin
  ExtMemo.Lines.Add( '*.bin');
  ExtMemo.Lines.Add( '*.bit');
  ExtMemo.Lines.Add( '*.bt');
  ExtMemo.Lines.Add( '*.ddf');
  ExtMemo.Lines.Add( '*.dem');
  ExtMemo.Lines.Add( '*.dt0');
  ExtMemo.Lines.Add( '*.dt1');
  ExtMemo.Lines.Add( '*.dt2');
  ExtMemo.Lines.Add( '*.dt3');
  ExtMemo.Lines.Add( '*.dt4');
  ExtMemo.Lines.Add( '*.dt5');
  ExtMemo.Lines.Add( '*.grd');
  ExtMemo.Lines.Add( '*.hgt');
  ExtMemo.Lines.Add( '*.xyz');

end;
3:begin   {Trash}
  ExtMemo.Lines.Add(      '*.tmp');
  ExtMemo.Lines.Add(      '~*.*');
  ExtMemo.Lines.Add(      '*.~*');
  ExtMemo.Lines.Add(      '*.?~?');
  ExtMemo.Lines.Add(      '*.aps');
  ExtMemo.Lines.Add(      '*.bak');
  ExtMemo.Lines.Add(      '*.bk?');
  ExtMemo.Lines.Add(      '*.bsc');
  ExtMemo.Lines.Add(      '*.dmp');
  ExtMemo.Lines.Add(      '*.dsm');
  ExtMemo.Lines.Add(      '*.ilk');
  ExtMemo.Lines.Add(      '*.pch');
  ExtMemo.Lines.Add(      '*.rws');
  ExtMemo.Lines.Add(      '*.sbr');
  ExtMemo.Lines.Add(      'backup*.wbk');
  ExtMemo.Lines.Add(      '*.fts');
  ExtMemo.Lines.Add(      '*.gid');
  ExtMemo.Lines.Add(      '*.$$$');
end;
4:begin  {Words}
  ExtMemo.Lines.Add(      '*.doc');
  ExtMemo.Lines.Add(      '*.txt');
  ExtMemo.Lines.Add(      '*.wpd');
  ExtMemo.Lines.Add(      '*.html');
  ExtMemo.Lines.Add(      '*.htm');
end;
5:begin  {Mine}
  ExtMemo.Lines.Add(      '*.db');
  ExtMemo.Lines.Add(      '*.dbf');
end;
6:begin {Other}
  ExtMemo.Lines.Add(      '*.zip');
end;
end;
end;

procedure TdtmPOFForm.ClearExtBtnClick(Sender: TObject);
begin
  ExtMemo.Clear;
end;

procedure TdtmPOFForm.TestSoundRGClick(Sender: TObject);
begin
   Case TestSoundRG.ItemIndex of
   0:DoMessages(7498{9998});  {info}
   1:DoMessages(14999);{ mtConfirmation}
   2:DoMessages(24999);{warn}
   3:DoMessages(29996);{error}
   4:DoMessages(31001);{done}
   end;{case}
end;

procedure TdtmPOFForm.LoadSoundRGClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Wav files (*.wav)|*.wav';
  OpenDialog1.InitialDir := ILHProgram;
  OpenDialog1.Filename:='*.wav';
  if OpenDialog1.execute then
  begin
   Case LoadSoundRG.ItemIndex of
   0:InfoString:= OpenDialog1.filename; {Info}
   1:ConfirmationString:= OpenDialog1.filename;{ Confirmation}
   2:WarnString:= OpenDialog1.filename;{Warn}
   3:ErrorString:= OpenDialog1.filename;{Error}
   4:DoneString:= OpenDialog1.filename;{Done}
   end;{case}
  end;
end;

procedure TdtmPOFForm.BeepOrWavCBClick(Sender: TObject);
begin
  InfoBeepOn := InfoCB.Checked;
  ConfirmBeepOn := ConfirmationCB.Checked;
  WarningBeepOn := WarningCB.Checked;
  ErrorBeepOn := ErrorsCB.Checked;
  CompletedBeepOn := CompletionCB.Checked;
  VoicesON:=BeepOrWavCB.Checked;
end;

procedure TdtmPOFForm.PageControl1Change(Sender: TObject);
begin
  if ((Sender as TPageControl).ActivePage = ThumbnailsTS)
  then
  begin
  {Use to store the Thumbnail Info}
  {ThumbPath}
  ThumbSize:=SizeUpDown.Position;   {ThumbSize }
  {ThumbColor }
  end;
end;

procedure TdtmPOFForm.ContourIntervalsBtnClick(Sender: TObject);
var
  {MyFilesS: string;}
  I,ContourI,i2,i3:Integer;
  outfile:Textfile;
begin
  SaveDialog1.Filter := 'HTFViewer Palette (*.pal)|*.pal';
  SaveDialog1.InitialDir:=ProgramPath;
  SaveDialog1.FileName:='Contours.pal';
  if (SaveDialog1.Execute) then
  begin
    if UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.PAL' then
    begin
      AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
      Rewrite(outfile);
      If EColorsRG.Itemindex=0 then
        Writeln(outfile,NullValueEdit.text+':0,0,0')
        else Writeln(outfile,NullValueEdit.text+':255,255,255');

      If CIColorsCB.Checked then
      begin
        ContourI:=  Strtoint(DemCIEdit.text);
        i2:=  Strtoint(NullValueEdit.text);
        If (i2 < -32766) then
          i3:= Round( (65534 )/ContourI )
          else
          i3:= Round( (32767 -abs(i2) )/ContourI );
        For I:= 1 to ContourI do
        begin
          If EColorsRG.Itemindex=0 then
            Writeln(outfile, Inttostr(i2+(I*i3))+':'+  {32767:255,255,255}
            Inttostr(0+(I*GetRValue(colorcolorPanel.Color)div ContourI))+','+
            Inttostr(0+(I*GetGValue(colorcolorPanel.Color)div ContourI))+','+
            Inttostr(0+(I*GetBValue(colorcolorPanel.Color)div ContourI)))
          else
            Writeln(outfile, Inttostr(i2+(I*i3))+':'+  {32767:255,255,255}
            Inttostr(255-(I*GetRValue(colorcolorPanel.Color)div ContourI))+','+
            Inttostr(255-(I*GetGValue(colorcolorPanel.Color)div ContourI))+','+
            Inttostr(255-(I*GetBValue(colorcolorPanel.Color)div ContourI)));
        end;
      end else
      begin
        ContourI:=  Strtoint(DemCIEdit.text);
        i2:=  Strtoint(NullValueEdit.text);
        If (i2 < -32766) then
          i3:= Round( (65534 )/ContourI )
          else
          i3:= Round( (32767 -abs(i2) )/ContourI );
          {-32768:0,0,0}
        Writeln(outfile, Inttostr(i2+i3)+':'+  {32767:255,255,255}
          Inttostr(GetRValue(colorcolorPanel.Color))+','+
          Inttostr(GetGValue(colorcolorPanel.Color))+','+
          Inttostr(GetBValue(colorcolorPanel.Color)));
      end;
      If EColorsRG.Itemindex=0 then
        Writeln(outfile,'32767:255,255,255')
        else Writeln(outfile,'32767:0,0,0');
      CloseFile(outfile);
    end;
  end;
end;

procedure TdtmPOFForm.SavePaletteBtnClick(Sender: TObject);
var
  {MyFilesS: string;}
  outfile:Textfile;
begin
  SaveDialog1.Filter := 'HTFViewer Palette (*.pal)|*.pal';
  SaveDialog1.InitialDir:=ProgramPath;
  SaveDialog1.FileName:='*.pal';
  if (SaveDialog1.Execute) then
  begin
    if UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.PAL' then
    begin
      AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
      Rewrite(outfile);
      Case EColorsRG.Itemindex of
      0:
      begin
        Writeln(outfile,NullValueEdit.text+  {32767:255,255,255}
        Inttostr(GetRValue(colorcolorPanel.Color))+','+
        Inttostr(GetGValue(colorcolorPanel.Color))+','+
        Inttostr(GetBValue(colorcolorPanel.Color)));
        Writeln(outfile,'32767:255,255,255');
      end;
      1:  //black
      begin
        Writeln(outfile,NullValueEdit.text+':0,0,0');
        {-32768:0,0,0}
        Writeln(outfile,'32767:'+  {32767:255,255,255}
       Inttostr(GetRValue(colorcolorPanel.Color))+','+
       Inttostr(GetGValue(colorcolorPanel.Color))+','+
       Inttostr(GetBValue(colorcolorPanel.Color)));
      end;
      2..3:
      begin
        If EColorsRG.Itemindex=2 then
        Writeln(outfile,NullValueEdit.text+':0,0,0')
        else Writeln(outfile,NullValueEdit.text+':255,255,255');
        Writeln(outfile, ECI1Edit.text+':'+
        Inttostr(GetRValue(ECI1Edit.Color))+','+
        Inttostr(GetGValue(ECI1Edit.Color))+','+
        Inttostr(GetBValue(ECI1Edit.Color)));
        Writeln(outfile, ECI2Edit.text+':'+
        Inttostr(GetRValue(ECI2Edit.Color))+','+
        Inttostr(GetGValue(ECI2Edit.Color))+','+
        Inttostr(GetBValue(ECI2Edit.Color)));
        Writeln(outfile, ECI3Edit.text+':'+
        Inttostr(GetRValue(ECI3Edit.Color))+','+
        Inttostr(GetGValue(ECI3Edit.Color))+','+
        Inttostr(GetBValue(ECI3Edit.Color)));
        If Is1CB.Checked then
        Writeln(outfile, '0'+':'+
         Inttostr(GetRValue(255-ECI4Edit.Color))+','+
         Inttostr(GetGValue(255-ECI4Edit.Color))+','+
         Inttostr(GetBValue(255-ECI4Edit.Color)));
        Writeln(outfile, ECI4Edit.text+':'+
         Inttostr(GetRValue(ECI4Edit.Color))+','+
         Inttostr(GetGValue(ECI4Edit.Color))+','+
         Inttostr(GetBValue(ECI4Edit.Color)));
        Writeln(outfile, ECI5Edit.text+':'+
         Inttostr(GetRValue(ECI5Edit.Color))+','+
         Inttostr(GetGValue(ECI5Edit.Color))+','+
         Inttostr(GetBValue(ECI5Edit.Color)));
        Writeln(outfile, ECI6Edit.text+':'+
         Inttostr(GetRValue(ECI6Edit.Color))+','+
         Inttostr(GetGValue(ECI6Edit.Color))+','+
         Inttostr(GetBValue(ECI6Edit.Color)));
        Writeln(outfile, ECI7Edit.text+':'+
         Inttostr(GetRValue(ECI7Edit.Color))+','+
         Inttostr(GetGValue(ECI7Edit.Color))+','+
         Inttostr(GetBValue(ECI7Edit.Color)));
        Writeln(outfile, ECI8Edit.text+':'+
         Inttostr(GetRValue(ECI8Edit.Color))+','+
         Inttostr(GetGValue(ECI8Edit.Color))+','+
         Inttostr(GetBValue(ECI8Edit.Color)));
        Writeln(outfile, ECI9Edit.text+':'+
         Inttostr(GetRValue(ECI9Edit.Color))+','+
         Inttostr(GetGValue(ECI9Edit.Color))+','+
         Inttostr(GetBValue(ECI9Edit.Color)));
        If EColorsRG.Itemindex=2 then
         Writeln(outfile,'32767:255,255,255')
         else Writeln(outfile,'32767:0,0,0');
      end;
      end;{Case}
    CloseFile(outfile);

(*
Blue-Green.pal
-32768:0,0,0
-9000:0,0,0
0:0,0,255
1:0,255,0
9000:0,0,0
32767:0,0,0
     ECI1Edit.Color:=
            -50000.. - 7001: {Smog 255,255,255}
            -7000.. - 6001: { Purple 255,0,255}
            -6000.. - 2001: {Blue 0,0,255 }
            -2000..0: {Aqua 0,255,255 }
            1..400: {  Green 0,255,0}
            401..1000: {Yellow 255,255,0}
            1001..2000: { Red 255,0,0}
            2001..3000: { Purple 255,0,255}
            3001..50000: { Smog 255,255,255}
{Blue 0,0,255 }
{Aqua 0,255,255 }
{Green 0,255,0}
{Yellow 255,255,0}
{Red 255,0,0}
{Purple 255,0,255}
{Smog 255,255,255}
*)
    end ;
  end;
end;


procedure TdtmPOFForm.EColorsRGClick(Sender: TObject);
begin
  If EColorsRG.Itemindex=0 then
  begin
     ColorDialog1.Color:=colorcolorPanel.Color;
   If ColorDialog1.Execute then
   begin
     colorcolorPanel.Color:=ColorDialog1.Color;
     colorcolorPanel.Caption:=
     Inttostr(GetRValue(ColorDialog1.Color))+','+
     Inttostr(GetGValue(ColorDialog1.Color))+','+
     Inttostr(GetBValue(ColorDialog1.Color));
     colorcolorPanel.Hint:= colorcolorPanel.Caption;
   end;
  end;     
end;


procedure TdtmPOFForm.ECI1EditDblClick(Sender: TObject);
begin
   ColorDialog1.Color:= ECI1Edit.Color;
   If ColorDialog1.Execute then
   begin
     ECI1Edit.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.ECI2EditDblClick(Sender: TObject);
begin
   ColorDialog1.Color:= ECI2Edit.Color;
   If ColorDialog1.Execute then
   begin
     ECI2Edit.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.ECI3EditDblClick(Sender: TObject);
begin
   ColorDialog1.Color:= ECI3Edit.Color;
   If ColorDialog1.Execute then
   begin
     ECI3Edit.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.ECI4EditDblClick(Sender: TObject);
begin
   ColorDialog1.Color:= ECI4Edit.Color;
   If ColorDialog1.Execute then
   begin
     ECI4Edit.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.ECI5EditDblClick(Sender: TObject);
begin
   ColorDialog1.Color:= ECI5Edit.Color;
   If ColorDialog1.Execute then
   begin
     ECI5Edit.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.ECI6EditDblClick(Sender: TObject);
begin
   ColorDialog1.Color:= ECI6Edit.Color;
   If ColorDialog1.Execute then
   begin
     ECI6Edit.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.ECI7EditDblClick(Sender: TObject);
begin
   ColorDialog1.Color:= ECI7Edit.Color;
   If ColorDialog1.Execute then
   begin
     ECI7Edit.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.ECI8EditDblClick(Sender: TObject);
begin
   ColorDialog1.Color:= ECI8Edit.Color;
   If ColorDialog1.Execute then
   begin
     ECI8Edit.Color:=ColorDialog1.Color;
   end;
end;
////////////////////////////////////////////////////

procedure TdtmPOFForm.CurrentColorPanelClick(Sender: TObject);
begin
  if ColorDialog1.Execute then
  begin
    CurrentColorPanel.Color := ColorDialog1.Color;
    CurrentColor := CurrentColorPanel.Color;
  end;
end;
procedure TdtmPOFForm.MapDataColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapDataColorPanel.Color;
  if ColorDialog1.execute then
    MapDataColorPanel.Color := ColorDialog1.Color;
  MapDataColor := MapDataColorPanel.Color;
end;
procedure TdtmPOFForm.MapHighlightColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapHighlightColorPanel.Color;
  if ColorDialog1.execute then
    MapHighlightColorPanel.Color := ColorDialog1.Color;
  MapHighlightColor := MapHighlightColorPanel.Color;
end;

procedure TdtmPOFForm.MapEditColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapEditColorPanel.Color;
  if ColorDialog1.execute then
    MapEditColorPanel.Color := ColorDialog1.Color;
  MapEditColor := MapEditColorPanel.Color;
end;

procedure TdtmPOFForm.MapEditingColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapEditingColorPanel.Color;
  if ColorDialog1.execute then
    MapEditingColorPanel.Color := ColorDialog1.Color;
  MapEditingColor := MapEditingColorPanel.Color;
end;

procedure TdtmPOFForm.MapGridColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapGridColorPanel.Color;
  if ColorDialog1.execute then
    MapGridColorPanel.Color := ColorDialog1.Color;
  MapGridColor := MapGridColorPanel.Color;
end;
procedure TdtmPOFForm.MapContourColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapContourColorPanel.Color;
  if ColorDialog1.execute then
    MapContourColorPanel.Color := ColorDialog1.Color;
  MapContourColor := MapContourColorPanel.Color;
end; 

procedure TdtmPOFForm.MapBackgroundColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapBackgroundColorPanel.Color;
  if ColorDialog1.execute then
    MapBackgroundColorPanel.Color := ColorDialog1.Color;
  MapBackgroundColor := MapBackgroundColorPanel.Color;
end;

procedure TdtmPOFForm.MapMaroonedColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapMaroonedColorPanel.Color;
  if ColorDialog1.execute then
    MapMaroonedColorPanel.Color := ColorDialog1.Color;
  MapMaroonedColor := MapMaroonedColorPanel.Color;
end;

procedure TdtmPOFForm.MapBlankColorPanelClick(Sender: TObject);
begin
  ColorDialog1.Color := MapBlankColorPanel.Color;
  if ColorDialog1.execute then
    MapBlankColorPanel.Color := ColorDialog1.Color;
  MapBlankColor := MapBlankColorPanel.Color;
end;


procedure TdtmPOFForm.SetCIBtnClick(Sender: TObject);
begin
  TotalContours:=Strtoint(DemCIEdit.Text);
  ContourInterval:=Strtoint(DemCIEEdit.Text);
  UseContourColors := ContourColorsCB.Checked;
end;





procedure TdtmPOFForm.TBRangeChange(Sender: TObject);
begin
    BumpRanger:=TBRange.Position;
    RangeLabel.Caption:=Inttostr(TBRange.Position);
end;
/////////////////////////////////////////////
procedure TdtmPOFForm.SlopeDirectionRGClick(Sender: TObject);
begin
  SlopeDirection:=SlopeDirectionRG.ItemIndex;
end;
/////////////////////////////////////////////
procedure TdtmPOFForm.SlopeSavePaletteClick(Sender: TObject);
var
  {MyFilesS: string;}
  outfile:Textfile;
begin
  SlopeCellSize:=Strtoint(SlopeCellSizeEdit.text);
  SaveDialog1.Filter := 'HTFViewer Palette (*.pal)|*.pal';
  SaveDialog1.InitialDir:=ProgramPath;
  SaveDialog1.FileName:='Slopes.pal';
  if (SaveDialog1.Execute) then
  begin
    if UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.PAL' then
    begin
    AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
    Rewrite(outfile);

Writeln(outfile, '0:'+
     Inttostr(GetRValue(SlopeNoneLabel.Color))+','+
     Inttostr(GetGValue(SlopeNoneLabel.Color))+','+
     Inttostr(GetBValue(SlopeNoneLabel.Color)));
{If EColorsRG.Itemindex=0 then
Writeln(outfile,NullValueEdit.text+':0,0,0')
else Writeln(outfile,NullValueEdit.text+':255,255,255');}
Writeln(outfile, SlopeEdit1.text+':'+
     Inttostr(GetRValue(SlopeEdit1.Color))+','+
     Inttostr(GetGValue(SlopeEdit1.Color))+','+
     Inttostr(GetBValue(SlopeEdit1.Color)));
Writeln(outfile, SlopeEdit2.text+':'+
     Inttostr(GetRValue(SlopeEdit2.Color))+','+
     Inttostr(GetGValue(SlopeEdit2.Color))+','+
     Inttostr(GetBValue(SlopeEdit2.Color)));
Writeln(outfile, SlopeEdit3.text+':'+
     Inttostr(GetRValue(SlopeEdit3.Color))+','+
     Inttostr(GetGValue(SlopeEdit3.Color))+','+
     Inttostr(GetBValue(SlopeEdit3.Color)));
{If Is1CB.Checked then
Writeln(outfile, '0'+':'+
     Inttostr(GetRValue(255-ECI4Edit.Color))+','+
     Inttostr(GetGValue(255-ECI4Edit.Color))+','+
     Inttostr(GetBValue(255-ECI4Edit.Color))); }
Writeln(outfile, SlopeEdit4.text+':'+
     Inttostr(GetRValue(SlopeEdit4.Color))+','+
     Inttostr(GetGValue(SlopeEdit4.Color))+','+
     Inttostr(GetBValue(SlopeEdit4.Color)));
Writeln(outfile, SlopeEdit5.text+':'+
     Inttostr(GetRValue(SlopeEdit5.Color))+','+
     Inttostr(GetGValue(SlopeEdit5.Color))+','+
     Inttostr(GetBValue(SlopeEdit5.Color)));
Writeln(outfile, SlopeEdit6.text+':'+
     Inttostr(GetRValue(SlopeEdit6.Color))+','+
     Inttostr(GetGValue(SlopeEdit6.Color))+','+
     Inttostr(GetBValue(SlopeEdit6.Color)));
Writeln(outfile, SlopeEdit7.text+':'+
     Inttostr(GetRValue(SlopeEdit7.Color))+','+
     Inttostr(GetGValue(SlopeEdit7.Color))+','+
     Inttostr(GetBValue(SlopeEdit7.Color)));
Writeln(outfile, SlopeEdit8.text+':'+
     Inttostr(GetRValue(SlopeEdit8.Color))+','+
     Inttostr(GetGValue(SlopeEdit8.Color))+','+
     Inttostr(GetBValue(SlopeEdit8.Color)));
Writeln(outfile, SlopeEdit9.text+':'+
     Inttostr(GetRValue(SlopeEdit9.Color))+','+
     Inttostr(GetGValue(SlopeEdit9.Color))+','+
     Inttostr(GetBValue(SlopeEdit9.Color)));


Writeln(outfile, '180:'+
     Inttostr(GetRValue(SlopeMaxLabel.Color))+','+
     Inttostr(GetGValue(SlopeMaxLabel.Color))+','+
     Inttostr(GetBValue(SlopeMaxLabel.Color)));
{If EColorsRG.Itemindex=0 then
   Writeln(outfile,'32767:255,255,255')
   else Writeln(outfile,'32767:0,0,0'); }

    CloseFile(outfile);
    end;
  end;
end;


procedure TdtmPOFForm.SlopeEdit1DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit1.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit1.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeEdit2DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit2.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit2.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeEdit3DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit3.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit3.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeEdit4DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit4.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit4.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeEdit5DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit5.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit5.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeEdit6DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit6.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit6.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeEdit7DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit7.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit7.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeEdit8DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit8.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit8.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeEdit9DblClick(Sender: TObject);
begin
   ColorDialog1.Color:= SlopeEdit9.Color;
   If ColorDialog1.Execute then
   begin
     SlopeEdit9.Color:=ColorDialog1.Color;
   end;
end;

procedure TdtmPOFForm.SlopeNoneLabelClick(Sender: TObject);
begin
 If SlopeNoneLabel.Color = ClWhite then
 begin
    SlopeNoneLabel.Color := ClBlack;
    SlopeNoneLabel.Font.Color := ClWhite;
 end else
 begin
    SlopeNoneLabel.Color := ClWhite;
    SlopeNoneLabel.Font.Color := ClBlack;
 end;
end;

procedure TdtmPOFForm.SlopeMaxLabelClick(Sender: TObject);
begin
 If SlopeMaxLabel.Color = ClWhite then
 begin
    SlopeMaxLabel.Color := ClBlack;
    SlopeMaxLabel.Font.Color := ClWhite;
 end else
 begin
    SlopeMaxLabel.Color := ClWhite;
    SlopeMaxLabel.Font.Color := ClBlack;
 end;
end;



///////////////////////////
// LOSHeight LOSRange  LOSDirection  LOSAngle
procedure TdtmPOFForm.LOSHeightEditChange(Sender: TObject);
begin
   LOSHeight:=Strtoint(LOSHeightEdit.Text);
end;

procedure TdtmPOFForm.LOSRangeEditChange(Sender: TObject);
begin
   LOSRange:=Strtoint(LOSRangeEdit.Text);
end;

procedure TdtmPOFForm.LOSDirectionEditChange(Sender: TObject);
begin
   LOSDirection:=Strtoint(LOSDirectionEdit.Text);
end;
procedure TdtmPOFForm.LOSAngleEditChange(Sender: TObject);
begin
   LOSAngle:=Strtoint(LOSAngleEdit.Text);
end;

procedure TdtmPOFForm.LOSFanLimitsCBClick(Sender: TObject);
begin
  LOSFanLimits:=LOSFanLimitsCB.Checked;
end;

procedure TdtmPOFForm.SlopeCellSizeEditChange(Sender: TObject);
begin
  SlopeCellSize:=Strtoint(  SlopeCellSizeEdit.Text);
end;

procedure TdtmPOFForm.IntervalBarChange(Sender: TObject);
begin
  //Joystick1.Interval:=IntervalBar.Position;
  IntervalLabel.Caption:=Inttostr(IntervalBar.Position);
end;

procedure TdtmPOFForm.ThresholdBarChange(Sender: TObject);
begin
  //Joystick1.Threshold:=ThresholdBar.Position;
  ThresholdLabel.Caption:=Inttostr(ThresholdBar.Position);
end;
procedure TdtmPOFForm.JoyNullRangeTBChange(Sender: TObject);
begin
  NullRangeLabel.Caption:=Inttostr(JoyNullRangeTB.Position);
end;

procedure TdtmPOFForm.DtmDtcLoadBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'DTC (*.dtc)|*.dtc';
  OpenDialog1.InitialDir := ProjectPath;
  OpenDialog1.Filename:='*.dtc';
  if OpenDialog1.execute then
  begin
    DtmDtcLoadEdit.Text := OpenDialog1.Filename;
  end;
end;

procedure TdtmPOFForm.CloudFileOpenBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Cloud base (*.clb)|*.clb';
  OpenDialog1.InitialDir := ProjectPath;
  OpenDialog1.Filename:=ChangeFileExt(ProjectName,'.clb' );
  if OpenDialog1.execute then
  begin
    CloudFileUsedEdit.Text := OpenDialog1.Filename;
  end;
end;


procedure TdtmPOFForm.MakeAndSaveCloudNoiseFileClick(Sender: TObject);
var
  aPERM: array [0..255] of Byte;
  outfile:Textfile;
  i:Integer;
Procedure RandomPerm;
var Idiot,Count,More, Less,again:Integer;
begin
  MakeAndSaveCloudNoiseFile.Caption:=inttostr(0);
  Application.ProcessMessages;
  aPERM[0]:=Random(256);
  Count:=0;
  repeat
    again:=0;
    Less:= Random(256);
    For Idiot := 0 to Count do
    begin
      more:= aPERM[Idiot];
      If (Less = more) then  inc(again);
    end;
      Label61.Caption:= inttostr(again); //these can be removed.. just for debugging
      Application.ProcessMessages;
      If (again = 0) then
      begin
        aPERM[Count+1]:=Less;
        inc(Count);
        MakeAndSaveCloudNoiseFile.Caption:=
        inttostr(Less)+','+inttostr(Count);
        Application.ProcessMessages;
      end;
  until Count = 255
end;
begin
  SaveDialog1.Filter := 'Cloud base (*.clb)|*.clb';
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.DefaultExt:='rnd';
  SaveDialog1.Filename:=ChangeFileExt(ProjectName,'.clb' );
  if (SaveDialog1.Execute) then
  begin
    if UpperCase(ExtractFileExt(SaveDialog1.FileName)) = '.CLB' then
    begin
      Application.ProcessMessages;
      Randomize;
      RandomPerm;
      Try
        AssignFile(outfile, SaveDialog1.FileName);   { File selected in dialog box }
        Rewrite(outfile);
        Writeln(outfile, 'Cloud Base V1.0');
        For I := 0 to 255 do
          Writeln(outfile, inttostr(aPERM[I]));
      Finally
        CloseFile(outfile);
      End;
      Label61.Caption:='Done';
      MakeAndSaveCloudNoiseFile.Caption:='';
    end;
  end;
end;





procedure TdtmPOFForm.StormMovingPathBtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Storm Path (*.pth)|*.pth';
  OpenDialog1.InitialDir := ProjectPath;
  OpenDialog1.Filename:=ChangeFileExt(ProjectName,'.pth' );
  if OpenDialog1.execute then
  begin
    StormMovingFileUsedEdit.Text := OpenDialog1.Filename;
  end;
end;
(*****************************************************)
(*****************************************************)



(*****************************************************)
(*****************************************************)
//3AS :    1.86624^11  = 186,624,000,000
//1 AS : 1.679616^12     = 1,679,616,000,000
//1/3 AS :  1.5116544^13   = 15,116,544,000,000
 //1/9AS : 1.36048896^14  =136,048,896,000,000
//  ResetToDefaults;   dtmPOFvar
//  Showem;
procedure TdtmPOFForm.HtfRez1BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := '1 Degree (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez1Edit.Text := OpenDialog1.filename;
    HtfRez1CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez2BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Etopo 5Min (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez2Edit.Text := OpenDialog1.filename;
    HtfRez2CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez3BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Etopo 2Min (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez3Edit.Text := OpenDialog1.filename;
    HtfRez3CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez4BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'Stopo (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez4Edit.Text := OpenDialog1.filename;
    HtfRez4CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez5BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'SRTM 3AS (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez5Edit.Text := OpenDialog1.filename;
    HtfRez5CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez6BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := 'SRTM 1AS (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez6Edit.Text := OpenDialog1.filename;
    HtfRez6CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez7BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := '1/3 AS [10 Meter]  (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez7Edit.Text := OpenDialog1.filename;
    HtfRez7CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez8BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := '1/9 AS [1 Meter]  (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez8Edit.Text := OpenDialog1.filename;
    HtfRez8CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez9BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := '1/27 AS [1/3 Meter]  (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez9Edit.Text := OpenDialog1.filename;
    HtfRez9CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez10BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := '1/81 AS [0.1 Meter]  (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez10Edit.Text := OpenDialog1.filename;
    HtfRez10CB.Checked:=True;
  end;
end;

procedure TdtmPOFForm.HtfRez11BtnClick(Sender: TObject);
begin
  OpenDialog1.Filter := '1/243 AS [1 cm] (*.htf)|*.htf';
  OpenDialog1.InitialDir := HTFPath;
  OpenDialog1.Filename:='*.htf';
  if OpenDialog1.execute then
  begin
    HTFPath := extractfilepath(OpenDialog1.filename);
    HtfRez11Edit.Text := OpenDialog1.filename;
    HtfRez11CB.Checked:=True;
  end;
end;

end.
