{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
{ Global Variables that are Stored : Program Options    }
{*******************************************************}
{Alt  Save bitmap image}
{Ctrl+Shift 4 Terrain Renderer Full Size}
{Shift 3  Full Size}
{Ctrl 2  Tile Size}
{1 is data areal display movement
{0 is Mouse movement .. display data values at mouse cursor}
{  Starttime,endtime:TDateTime;
  Hour, Min, Sec, MSec: Word;
      DecodeTime(endtime-Starttime, Hour, Min, Sec, MSec);
      AllCanadaBtn.Caption :=
                 IntToStr(Hour)+' H '
               + IntToStr(Min)+' M '
               + IntToStr(Sec)+' S '
               + IntToStr(MSec)+' MS';}

unit dtmPOFvar;

interface

uses   Sysutils{Filestuff},  Graphics;

type
  TColorMatrix = array[0..2, 0..15] of Byte; {RGB Color sets}
  ColorSet= array[0..2] of Byte;
              {ColorSet3:= GetColor(FMcolor);
                PixelLine[Pixelx] := ColorSet3[0];
                PixelLine[(Pixelx + 1)] := ColorSet3[1];
                PixelLine[(Pixelx + 2)] := ColorSet3[2]; }
  PrefRecord = record
  {This is my secret string ? as text?}
  PHiddenString: string[255]; {array [1..256] of Char;}
  PColor256Name, PTempName, PProLoaded,
  PProgramPath,    PVRMProgramPath,
  PILHProgram,     PVRGISPath,
  PRasterPath,     PDTMPath,    PThumbPath,
  PFractal3DPath,  PLifePath,   PSOSMAPPath,
  PDigitizerPath,  PVoicePath,
  POldFileName4,
  POldFileName3,
  POldFileName2,
  POldFileName1,
  POldFileName0,
    PProgramPort,
  PInfoString, PConfirmationString, PWarnString,
  PErrorString, PDoneString,   PZipPath,
  PProjectPath, PProjectName, PMapName,  PMapsPath,
  PDemPath,     PHTFPath,     PTigerPath, PDxfPath,
  PVRMDatabase, PDLGPath,     PImagePath, PShapePath,
  PNoNamePath: string[255];

    PCurrentColor,  PMapDataColor,
    PMapHighlightColor,  PMapEditColor,  PMapEditingColor,
    PMapGridColor, PMapContourColor,
    PMapBackgroundColor, PMapBlankColor, PMapMaroonedColor,
    PThumbColor: TColor;
    PLOSFanLimits:Boolean;
    PLOSHeight, PLOSRange,  PLOSDirection,  PLOSAngle,
    PJoyNullRange,
    PThresholdBarPosition{500}, PIntervalBarPosition{100},
    PJoyCentroidX,  PJoyCentroidY,
    PTotalContours, PContourInterval, PSlopeCellSize,
    PThumbSize: Integer;
    PSlopeDirection,
    PCropXWide,PCropYTall,
    PColorreg: Integer;
    PStarted: TDateTime;
    PStartedNameNumber: string[25];
 PDOVUsed, PClodPUsed, PQualityDUsed,
 PXScaleUsed,PZScaleUsed:Double;
 PTilesperTexture:Cardinal;
 PCloudFileUsed:String[255];
   PSunMovingUsed : Integer;
  PUseCloudsSRange,
 PUseCloudsRange,PUseCloudFile:Boolean;
     PStormCloudsRateUsed,PStormCloudsRangeUsed,
    PWavesRateUsed,
  PCloudAnime, PCloudChangeAmount,
  PCloudSharpUsed, PCloudSharpRangeUsed:Double;
  PCloudRandomSeedUsed:Longint;
 PCloudMinUsed, PCloudMinRangeUsed,
 PWavesRangeUsed,
 PCloudImageSizeUsed: Integer;
//
  PStormMovingFileUsed :String[255];
  PStormWindDirectionUsed, PStormWindSpeedUsed,
  PStormWindDirectionVarUsed, PStormWindSpeedVariationUsed,
  PStormCloudsDirectionUsed, PStormCloudsSpeedUsed,
  PStormCloudsNumberUsed : Integer;

  PRainDensityUsed,PRainDensityVarUsed,
  PLightningFrequencyUsed,PLightningForceUsed,
  PTornadoeFrequencyUsed,PTornadoeForceUsed,
  PStormCloudsPosXUsed,PStormCloudsPosYUsed,PStormCloudsPosZUsed,
  PStormCloudsNumRangeUsed,PStormCloudsNumRangeVarUsed,
  PStormCloudsRangeXUsed,PStormCloudsRangeYUsed,PStormCloudsRangeZUsed:Double;

  PUseCloudsSetting, PUseStormLinear,
  PUseStormMoving, PUseStormMovingDirS, PUseStormMovingPath,
  PUseStormRain, PUseStormLightning, PUseStormTornadoes, PUseStormWind:Boolean;
//
 PTextureFileType, PBumpRanger,  PMaximumShapeObjects,PMaximumShapeLevels,
 PPixelEnlargement, PSeaLevelUsed : Integer;
 PDtmDtcLoad:String[255];
 PLoadDTCOnStart,
 PUseConglomeration, PUseImageMap, PUseEcoTypes, PUseFlippedHTF,
 PCreateTexturesOnDemand, PSaveCreatedTextures, PUseSavedTextures,
 PUseXScale, PUseZScale, PUseSeaLevel, PUseBumpMap,
    PUseContourColors, PLoadDTPOnStart, PRunDTS,
    PUseDOV, PUseClodP, PUseQualityD,         PDisplayFPS,
    PUseClouds, PUseWaves,PUseStormClouds,PUseSunMoving,
    PPrintBigChecked, PSkip32BitNotice, PUseThumbnails,
    PScaleBarVisible, PSkipIntroScreen, PFilePreviews,
    PErrorBeepOn, PWarningBeepOn ,PInfoBeepOn, PRegisterFileTypes,
    PConfirmBeepOn, PCompletedBeepOn, PVoicesON :Boolean;
  {X Y Location of forms}
      PDTMformX, PDTMformY,      {Main}
      PPOFFormX, PPOFFormY,  {TPOFForm}
      PHtfFormX,  PHtfFormY,  {HtfFormX}
      PMessageX, PMessageY,  {Message box}
      PfrmLMMWizardX, PfrmLMMWizardY,
      PFrmLightmapFaceGroupsX, PFrmLightmapFaceGroupsY,
      PFInfoX,PFInfoY,
      PFractalFormX, PFractalFormY,
      PFractalPreviewFormX, PFractalPreviewFormY,
      //MathingsFormX  LSystemFormX
      //GlsTrealViewerFormX aGlsTreeFormX ATreeDemoFormX
      //RandomTreeSeedNumber  SeasonComboBox.ItemIndex
      //HealthTrackBar.Position  TreeDefFileNameEdit.Text
      PdtmGLSAboutFormX,PdtmGLSAboutFormY,
      PZipFormX,PZipFormY,
      PdtmHtfDem24kFormX,PdtmHtfDem24kFormY,
      PdtmHdsSunConfigFormX,PdtmHdsSunConfigFormY,
      Pt3de1FormX, Pt3de1FormY,
      Pt3dFormX, Pt3dFormY,
      PGizmoPathFormX, PGizmoPathFormY,
      PdtmTaskDroneX,PdtmTaskDroneY,
      PdtmTaskDroneAboutX,PdtmTaskDroneAboutY,
      PdtmHdsFormX,PdtmHdsFormY,
      PImageMakerFormX, PImageMakerFormY,
      PLineProfileFormX,PLineProfileFormY,
      PdtmDbFormX,PdtmDbFormY,
      PdtmDTPFormX,PdtmDTPFormY,
      PdtmEcotypeColorsFormX, PdtmEcotypeColorsFormY,
      PDtmGlBaseFormX,PDtmGlBaseFormY,
      PGLSViewerFormX,PGLSViewerFormY,
      PDtmJoyFormX,PDtmJoyFormY,
      PDTMGLFormX,PDTMGLFormY,
      PdtmSmdQcFormX,PdtmSmdQcFormY,
      PdtmSmdLoadMdlFormX,PdtmSmdLoadMdlFormY,
      PNavFormX,PNavFormY,
      PdtmPanImageFormX,PdtmPanImageFormY,
      PDtmImageRGBFormX,PDtmImageRGBFormY,
      PSystemInfoFormX,PSystemInfoFormY,
      PRIFImageViewerFormX,PRIFImageViewerFormY,
      PAboutX, PAboutY: Integer;

(*    PColorWhite, PColorBlack,
      PColorPURPLE, PColorDPURPLE, PColorYELLOW, PColorLYELLOW,
      PColor1, PColor2, PColor3, PColor4, PColor5, PColor6, PColor8,
      PColor7, PColor9,
      {PUVW, PVDW, PVMW, PVLW, PUDW, PUMW, PULW,} PDDW, PDMW, PDLW,
      PMDW, PMMW, PMLW, PLDW, PLMW, PLLW,
      {PUVC, PVDC, PVMC, PVLC, PUDC, PUMC, PULC,} PDDC, PDMC, PDLC,
      PMDC, PMMC, PMLC, PLDC, PLMC, PLLC,
      {PUVF, PVDF, PVMF, PVLF, PUDF, PUMF, PULF,} PDDF, PDMF, PDLF,
      PMDF, PMMF, PMLF, PLDF, PLMF, PLLF,
      {PUVA, PVDA, PVMA, PVLA, PUDA, PUMA, PULA,} PDDA, PDMA, PDLA,
      PMDA, PMMA, PMLA, PLDA, PLMA, PLLA,
      {PUVR, PVDR, PVMR, PVLR, PUDR, PUMR, PULR,} PDDR, PDMR, PDLR,
      PMDR, PMMR, PMLR, PLDR, PLMR, PLLR,
      {PUVT, PVDT, PVMT, PVLT, PUDT, PUMT, PULT,} PDDT, PDMT, PDLT,
      PMDT, PMMT, PMLT, PLDT, PLMT, PLLT,
      {PUVB, PVDB, PVMB, PVLB, PUDB, PUMB, PULB,} PDDB, PDMB, PDLB,
      PMDB, PMMB, PMLB, PLDB, PLMB, PLLB,
      {PUVU, PVDU, PVMU, PVLU, PUDU, PUMU, PULU,} PDDU, PDMU, PDLU,
      PMDU, PMMU, PMLU, PLDU, PLMU, PLLU,
      {PUVS, PVDS, PVMS, PVLS, PUDS, PUMS, PULS,} PDDS, PDMS, PDLS,
      PMDS, PMMS, PMLS, PLDS, PLMS, PLLS
      : TColor;       *)
  end;
{  PrefFile = file of PrefRecord;
var
  PreRcd: PrefRecord;}
var
  Colorset16: Integer;  Color256S:Integer;
  Color16FName: string;
  Color256FName: string;
  RGBArray: TColormatrix; {16 RGB's  3*16  [0..2, 0..15]}
  ColorArray: array[0..255] of TColor; {passing fancy}
  ColorRGBArray: array[0..2, 0..255] of Byte;

  FBackGroundColor: TColor;
  Colorreg: Integer;
  Started: TDateTime;
  StartedNameNumber: string;
  DtmHtfDisplay,
      DTMformX, DTMformY,      {Main}
      POFFormX, POFFormY,  {TPOFForm}
      HtfFormX,HtfFormY,  {BFilefinder}
      MessageX, MessageY,  {Message box}
      frmLMMWizardX, frmLMMWizardY,
      FrmLightmapFaceGroupsX, FrmLightmapFaceGroupsY,
      FInfoX,FInfoY,
      FractalFormX, FractalFormY,
      FractalPreviewFormX, FractalPreviewFormY,
      dtmGLSAboutFormX,dtmGLSAboutFormY,
      ZipFormX,ZipFormY,
      dtmHtfDem24kFormX,dtmHtfDem24kFormY,
      dtmHdsSunConfigFormX,dtmHdsSunConfigFormY,
      t3de1FormX, t3de1FormY,
      t3dFormX, t3dFormY,
      dtmTaskDroneX,dtmTaskDroneY,
      dtmTaskDroneAboutX,dtmTaskDroneAboutY,
      GizmoPathFormX, GizmoPathFormY,
      dtmHdsFormX,dtmHdsFormY,
      ImageMakerFormX, ImageMakerFormY,
      LineProfileFormX,LineProfileFormY,
      dtmDTPFormX, dtmDTPFormY,
      dtmEcotypeColorsFormX, dtmEcotypeColorsFormY,
      dtmDbFormX,dtmDbFormY,
      dtmPanImageFormX,dtmPanImageFormY,
      DtmImageRGBFormX,DtmImageRGBFormY,
      NavFormX,NavFormY,
      SystemInfoFormX,SystemInfoFormY,
      DtmGlBaseFormX,DtmGlBaseFormY,
      DTMGLFormX,DTMGLFormY,
      GLSViewerFormX,GLSViewerFormY,
      {DtmJoyFormX,DtmJoyFormY,}
      RIFImageViewerFormX,RIFImageViewerFormY,
      dtmSmdQcFormX,dtmSmdQcFormY,
      dtmSmdLoadMdlFormX,dtmSmdLoadMdlFormY,
      AboutX, AboutY    : Integer;

  {EditingColor, ClassStartPanelColor,
  BackgroundColor,
  HighlightColor,      MapBordersColor, MapGridsColor,
    MapDatasColor, MapBacksColor,
  EditColor,   CurrentColor: TColor; }
    CurrentColor,  MapDataColor,
    MapHighlightColor,  MapEditColor,  MapEditingColor,
    MapGridColor, MapContourColor,
    MapBackgroundColor, MapBlankColor, MapMaroonedColor,
    ThumbColor: TColor;(*
ColorWhite, ColorBlack, {CurrentColor,}
    ColorPURPLE, ColorDPURPLE, ColorYELLOW, ColorLYELLOW,
    Color1, Color2, Color3, Color4, Color5, Color6, Color8, Color7,
    Color9,
    {UVW, VDW, VMW, VLW, UDW, UMW, ULW,} DDW, DMW, DLW, MDW, MMW, MLW,
    LDW, LMW, LLW,
    {UVC, VDC, VMC, VLC, UDC, UMC, ULC,} DDC, DMC, DLC, MDC, MMC, MLC,
    LDC, LMC, LLC,
    {UVF, VDF, VMF, VLF, UDF, UMF, ULF,} DDF, DMF, DLF, MDF, MMF, MLF,
    LDF, LMF, LLF,
    {UVA, VDA, VMA, VLA, UDA, UMA, ULA,} DDA, DMA, DLA, MDA, MMA, MLA,
    LDA, LMA, LLA,
    {UVR, VDR, VMR, VLR, UDR, UMR, ULR,} DDR, DMR, DLR, MDR, MMR, MLR,
    LDR, LMR, LLR,
    {UVT, VDT, VMT, VLT, UDT, UMT, ULT,} DDT, DMT, DLT, MDT, MMT, MLT,
    LDT, LMT, LLT,
    {UVB, VDB, VMB, VLB, UDB, UMB, ULB,} DDB, DMB, DLB, MDB, MMB, MLB,
    LDB, LMB, LLB,
    {UVU, VDU, VMU, VLU, UDU, UMU, ULU,} DDU, DMU, DLU, MDU, MMU, MLU,
    LDU, LMU, LLU,
    {UVS, VDS, VMS, VLS, UDS, UMS, ULS,} DDS, DMS, DLS, MDS, MMS, MLS,
    LDS, LMS, LLS
    : TColor;            *)
    LOSFanLimits:Boolean;
    LOSHeight, LOSRange,  LOSDirection,  LOSAngle,
    ThresholdBarPosition{500}, IntervalBarPosition{100},
    JoyCentroidX,  JoyCentroidY,
    SlopeDirection, SlopeCellSize,
    TotalContours,ContourInterval,
    ThumbSize: Integer;
    StormCloudsRateUsed,StormCloudsRangeUsed,
    WavesRateUsed,
        CloudAnime, CloudChangeAmount,
        CloudSharpUsed, CloudSharpRangeUsed,
 DOVUsed, ClodPUsed, QualityDUsed,
 XScaleUsed,ZScaleUsed:Double;
 TilesperTexture:Cardinal;
 CloudRandomSeedUsed:Longint;
 WavesRangeUsed,
 CloudMinUsed, CloudMinRangeUsed, CloudImageSizeUsed,
 BumpRanger, MaximumShapeObjects,MaximumShapeLevels,
 TextureFileType, PixelEnlargement, SeaLevelUsed : Integer;
 CloudFileUsed:String;
  SunMovingUsed : Integer;
//
  JoyNullRange: Integer;
  StormMovingFileUsed :String;
  StormWindDirectionUsed, StormWindSpeedUsed,
  StormWindDirectionVarUsed, StormWindSpeedVariationUsed,
  StormCloudsDirectionUsed, StormCloudsSpeedUsed,
  StormCloudsNumberUsed : Integer;

  RainDensityUsed,RainDensityVarUsed,
  LightningFrequencyUsed,LightningForceUsed,
  TornadoeFrequencyUsed,TornadoeForceUsed,
  StormCloudsPosXUsed,StormCloudsPosYUsed,StormCloudsPosZUsed,
  StormCloudsNumRangeUsed,StormCloudsNumRangeVarUsed,
  StormCloudsRangeXUsed,StormCloudsRangeYUsed,StormCloudsRangeZUsed:Double;
  DtmDtcLoad:String[255];
  LoadDTCOnStart,
  UseCloudsSetting, UseStormLinear,
  UseStormMoving, UseStormMovingDirS, UseStormMovingPath,
  UseStormRain, UseStormLightning, UseStormTornadoes, UseStormWind:Boolean;
//
  UseCloudsSRange,
 UseCloudsRange,UseCloudFile,  UseSunMoving,  DisplayFPS,
  UseConglomeration, UseImageMap, UseEcoTypes, UseFlippedHTF, UseBumpMap,
 CreateTexturesOnDemand, SaveCreatedTextures, UseSavedTextures,
 UseXScale, UseZScale, UseSeaLevel,
 UseClouds, UseWaves,UseStormClouds,
 UseDOV, UseClodP, UseQualityD,
 LoadDTPOnStart, RunDTS:Boolean;
 UseThumbnails, Skip32BitNotice,PrintBigChecked,FilePreviews,
  ErrorBeepOn, WarningBeepOn ,InfoBeepOn, SkipIntroScreen,
  UseContourColors, RegisterFileTypes,
{  Drawing,bZoomMousing,ImageDrawChecked, ViewMagniOn,
  AlreadyGone, ScaleBarVisible, MorphingOn, MorphingOnDrawing,}
  ConfirmBeepOn, CompletedBeepOn, VoicesON :Boolean;
  InfoString, ConfirmationString, WarnString,
  ErrorString, DoneString,
  ProgramPort,
  Color256Name,  HiddenString,
  ProjectName, MapName,ProjectPath,  MapsPath,
  HTFPaletteName,
  ProjectRobotRldFilename,
  ViewFileName, TempName{Passing name},
  OldFileName4,
  OldFileName3,
  OldFileName2,
  OldFileName1,
  OldFileName0,
  TransSearchDir,ProgramPath,
  VRMProgramPath, ThumbPath, ZipPath,
  Fractal3DPath,  LifePath,  SOSMAPPath,
  DigitizerPath, VRGISPath, DTMPath,
  VoicePath, RasterPath, ILHProgram,
  HTFName,
  TigerPath,DemPath,HTFPath, ShapePath,
  DLGPath,DxfPath,VRMDatabase, ImagePath,   NoNamePath  :String;


//Drone Globals ... USED but NOT STORED in POF
TaskFinished, TaskError, TaskCancelProcess:Boolean;
TaskData2:Double;
TaskData1,TaskResult,
TaskErrorID, TaskStatus, TaskProgress:Integer;
TaskErrorInfo,
TaskOutFileName:String;
TaskInfoFinishTime:TDateTime;

procedure DoLoader;{procedure SetPreferences;}
procedure DoSaver;{procedure GetPreferences;}
procedure ResetToDefaults;
procedure ResetTerrainDefaults;

implementation

uses dtmErrMsg;

procedure DoLoader;
type
  PrefFile = file of PrefRecord;
var
  PreRcd: PrefRecord;
var P_File: PrefFile;
var PathS: string;
procedure SetPreferences;
begin {after loading}
  with PreRcd do begin
  HiddenString:=PHiddenString;
  Color256Name:=PColor256Name;
{  TempName:=PTempName;}
  ProgramPath:=PProgramPath;
  VRMProgramPath:=PVRMProgramPath;
  DigitizerPath:=PDigitizerPath;
  Fractal3DPath:=PFractal3DPath;
  LifePath:=PLifePath;
  SOSMAPPath:=PSOSMAPPath;
  NoNamePath:=PNoNamePath;
  VRGISPath:=PVRGISPath;
  DTMPath:=PDTMPath;
  VoicePath:=PVoicePath;
  RasterPath:=PRasterPath;
  ILHProgram:=PILHProgram;
   ZipPath:=PZipPath;
  InfoString:=PInfoString;
  ConfirmationString:=PConfirmationString;
  WarnString:=PWarnString;
  ErrorString:=PErrorString;
  DoneString:=PDoneString;
  OldFileName4:=POldFileName4;
  OldFileName3:=POldFileName3;
  OldFileName2:=POldFileName2;
  OldFileName1:=POldFileName1;
  OldFileName0:=POldFileName0;
  ProjectPath:=PProjectPath;
  ProjectName:=PProjectName;
  MapName:=PMapName;
  MapsPath:=PMapsPath;
  TigerPath:=PTigerPath;
  DemPath:=PDemPath;
  HTFPath:=PHTFPath;
  ShapePath:=PShapePath;
  DLGPath:=PDLGPath;
  DxfPath:=PDxfPath;
  VRMDatabase:=PVRMDatabase;
  ImagePath:=PImagePath;
  ErrorBeepOn:=PErrorBeepOn;
  WarningBeepOn :=PWarningBeepOn;
  InfoBeepOn :=PInfoBeepOn;
  ConfirmBeepOn:=PConfirmBeepOn;
  CompletedBeepOn:=PCompletedBeepOn;
  SkipIntroScreen:=PSkipIntroScreen;

  PixelEnlargement:=PPixelEnlargement;
  TilesperTexture:=PTilesperTexture;
  XScaleUsed:=PXScaleUsed;
  ZScaleUsed:=PZScaleUsed;
  SeaLevelUsed :=PSeaLevelUsed;
  UseFlippedHTF:=PUseFlippedHTF;
  TextureFileType:=PTextureFileType;
  CreateTexturesOnDemand:=PCreateTexturesOnDemand;
  SaveCreatedTextures:=PSaveCreatedTextures;
  UseSavedTextures:=PUseSavedTextures;
  UseConglomeration:=PUseConglomeration;
  UseImageMap:=PUseImageMap;
  UseEcoTypes:=PUseEcoTypes;
  UseBumpMap:=PUseBumpMap;
  UseClouds:=PUseClouds;
  UseCloudsRange:=PUseCloudsRange;
  UseWaves:=PUseWaves;
  UseStormClouds:=PUseStormClouds;
  UseSunMoving:=PUseSunMoving;
  DisplayFPS:=PDisplayFPS;
  SunMovingUsed :=PSunMovingUsed;
  UseCloudsSRange:=PUseCloudsSRange;
  LoadDTPOnStart:=PLoadDTPOnStart;
  MaximumShapeObjects:=PMaximumShapeObjects;
  MaximumShapeLevels:=PMaximumShapeLevels;
  UseXScale:=PUseXScale;
  UseZScale:=PUseZScale;
  UseSeaLevel:=PUseSeaLevel;
  BumpRanger:=PBumpRanger;
  DOVUsed:=PDOVUsed;
  ClodPUsed:=PClodPUsed;
  QualityDUsed:=PQualityDUsed;
  RunDTS:=PRunDTS;
  DtmDtcLoad:=PDtmDtcLoad;
  LoadDTCOnStart:=PLoadDTCOnStart;
  UseDOV:=PUseDOV;
  UseClodP:=PUseClodP;
  UseQualityD:=PUseQualityD;
    StormCloudsRateUsed:=PStormCloudsRateUsed;
    StormCloudsRangeUsed:=PStormCloudsRangeUsed;
    WavesRateUsed:=PWavesRateUsed;
    WavesRangeUsed:=PWavesRangeUsed;
 CloudFileUsed:=PCloudFileUsed;
 UseCloudFile:=PUseCloudFile;
  CloudAnime:=PCloudAnime;
  CloudChangeAmount:=PCloudChangeAmount;
  CloudSharpUsed:=PCloudSharpUsed;
  CloudSharpRangeUsed:=PCloudSharpRangeUsed;
//
  StormMovingFileUsed:=PStormMovingFileUsed;
  StormWindDirectionUsed:=PStormWindDirectionUsed;
  StormWindSpeedUsed:=PStormWindSpeedUsed;
  StormWindDirectionVarUsed:=PStormWindDirectionVarUsed;
  StormWindSpeedVariationUsed:=PStormWindSpeedVariationUsed;
  StormCloudsDirectionUsed:=PStormCloudsDirectionUsed;
  StormCloudsSpeedUsed:=PStormCloudsSpeedUsed;
  StormCloudsNumberUsed:=PStormCloudsNumberUsed;

  RainDensityUsed:=PRainDensityUsed;
  RainDensityVarUsed:=PRainDensityVarUsed;
  LightningFrequencyUsed:=PLightningFrequencyUsed;
  LightningForceUsed:=PLightningForceUsed;
  TornadoeFrequencyUsed:=PTornadoeFrequencyUsed;
  TornadoeForceUsed:=PTornadoeForceUsed;
  StormCloudsPosXUsed:=PStormCloudsPosXUsed;
  StormCloudsPosYUsed:=PStormCloudsPosYUsed;
  StormCloudsPosZUsed:=PStormCloudsPosZUsed;
  StormCloudsNumRangeUsed:=PStormCloudsNumRangeUsed;
  StormCloudsNumRangeVarUsed:=PStormCloudsNumRangeVarUsed;
  StormCloudsRangeXUsed:=PStormCloudsRangeXUsed;
  StormCloudsRangeYUsed:=PStormCloudsRangeYUsed;
  StormCloudsRangeZUsed:=PStormCloudsRangeZUsed;

  UseCloudsSetting:=PUseCloudsSetting;
  UseStormLinear:=PUseStormLinear;
  UseStormMoving:=PUseStormMoving;
  UseStormMovingDirS:=PUseStormMovingDirS;
  UseStormMovingPath:=PUseStormMovingPath;
  UseStormRain:=PUseStormRain;
  UseStormLightning:=PUseStormLightning;
  UseStormTornadoes:=PUseStormTornadoes;
  UseStormWind:=PUseStormWind;
//
 CloudMinUsed:=PCloudMinUsed;
 CloudMinRangeUsed:=PCloudMinRangeUsed;
 CloudRandomSeedUsed:=PCloudRandomSeedUsed;
 CloudImageSizeUsed:=PCloudImageSizeUsed;

{  ScaleBarVisible:=PScaleBarVisible;}
  Skip32BitNotice:=PSkip32BitNotice;
  FilePreviews:=PFilePreviews;
  VoicesON :=PVoicesON;
    Started := PStarted;
    PrintBigChecked:=PPrintBigChecked;
    RegisterFileTypes:=PRegisterFileTypes;
    StartedNameNumber := PStartedNameNumber;
    Colorreg := PColorreg;
{CropXWide:=PCropXWide;
CropYTall:=PCropYTall;}
    CurrentColor:=PCurrentColor;
    MapDataColor:=PMapDataColor;
    MapHighlightColor:=PMapHighlightColor;
    MapEditColor:=PMapEditColor;
    MapEditingColor:=PMapEditingColor;
    MapGridColor:=PMapGridColor;
     MapContourColor:=PMapContourColor;
    MapBackgroundColor:=PMapBackgroundColor;
     MapBlankColor:=PMapBlankColor;
     MapMaroonedColor:=PMapMaroonedColor;
{    ColorRef := PColorRef;}
   { CurrentColor := PCurrentColor;
    MapBordersColor:=PMapBordersColor;
    MapGridsColor:=PMapGridsColor;
    MapDatasColor:=PMapDatasColor;
    MapBacksColor:=PMapBacksColor; }
      DTMformX:=PDTMformX;
      DTMformY:=PDTMformY;
      POFFormX:=PPOFFormX;
      POFFormY:=PPOFFormY;
      HtfFormY:=PHtfFormY;
      HtfFormX:=PHtfFormX;
      dtmGLSAboutFormX:=PdtmGLSAboutFormX;
      dtmGLSAboutFormY:=PdtmGLSAboutFormY;
      dtmHtfDem24kFormX:=PdtmHtfDem24kFormX;
      dtmHtfDem24kFormY:=PdtmHtfDem24kFormY;
      dtmHdsSunConfigFormX:=PdtmHdsSunConfigFormX;
      dtmHdsSunConfigFormY:=PdtmHdsSunConfigFormY;
      frmLMMWizardX:=PfrmLMMWizardX;
      frmLMMWizardY:=PfrmLMMWizardY;
      FrmLightmapFaceGroupsX:=PFrmLightmapFaceGroupsX;
      FrmLightmapFaceGroupsY:=PFrmLightmapFaceGroupsY;
      FInfoX:=PFInfoX;
      FInfoY:=PFInfoY;
      FractalFormX:=PFractalFormX;
      FractalFormY:=PFractalFormY;
      FractalPreviewFormX:=PFractalPreviewFormX;
      FractalPreviewFormY:=PFractalPreviewFormY;

      t3de1FormX:=Pt3de1FormX;
      t3de1FormY:=Pt3de1FormY;
      t3dFormX:=Pt3dFormX;
      t3dFormY:=Pt3dFormY;
      GizmoPathFormX:=PGizmoPathFormX;
      GizmoPathFormY:=PGizmoPathFormY;
      dtmHdsFormX:=PdtmHdsFormX;
      dtmHdsFormY:=PdtmHdsFormY;
      DTMGLFormX:=PDTMGLFormX;
      DTMGLFormY:=PDTMGLFormY;
      DtmGlBaseFormX:=PDtmGlBaseFormX;
      DtmGlBaseFormY:=PDtmGlBaseFormY;
      GLSViewerFormX:=PGLSViewerFormX;
      GLSViewerFormY:=PGLSViewerFormY;
      {DtmJoyFormX:=PDtmJoyFormX;
      DtmJoyFormY:=PDtmJoyFormY; }
      dtmSmdQcFormX:= PdtmSmdQcFormX;
      dtmSmdQcFormY:= PdtmSmdQcFormY;
      dtmSmdLoadMdlFormX:=PdtmSmdLoadMdlFormX;
      dtmSmdLoadMdlFormY:=PdtmSmdLoadMdlFormY;
      dtmPanImageFormX:=PdtmPanImageFormX;
      dtmPanImageFormY:=PdtmPanImageFormY;
      DtmImageRGBFormX:=PDtmImageRGBFormX;
      DtmImageRGBFormY:=PDtmImageRGBFormY;
      NavFormX:=PNavFormX;
      NavFormY:=PNavFormY;
      MessageX:=PMessageX;
      MessageY:=PMessageY;
      AboutX:=PAboutX;
      AboutY:=PAboutY;
      ZipFormX:=PZipFormX;
      ZipFormY:=PZipFormY;
      dtmDbFormX:=PdtmDbFormX;
      dtmDbFormY:=PdtmDbFormY;
      RIFImageViewerFormX:=PRIFImageViewerFormX;
      PRIFImageViewerFormY:=PRIFImageViewerFormY;
      ImageMakerFormX:=PImageMakerFormX;
      ImageMakerFormY:=PImageMakerFormY;
      LineProfileFormX:=PLineProfileFormX;
      LineProfileFormY:=PLineProfileFormY;
      dtmDTPFormX:=PdtmDTPFormX;
      dtmDTPFormY:=PdtmDTPFormY;
      dtmEcotypeColorsFormX:=PdtmEcotypeColorsFormX;
      dtmEcotypeColorsFormY:=PdtmEcotypeColorsFormY;
      SystemInfoFormX:=PSystemInfoFormX;
      SystemInfoFormY:=PSystemInfoFormY;
      dtmTaskDroneX:= PdtmTaskDroneX;
      dtmTaskDroneY:= PdtmTaskDroneY;
      dtmTaskDroneAboutX:= PdtmTaskDroneAboutX;
      dtmTaskDroneAboutY:= PdtmTaskDroneAboutY;

      UseThumbnails:=PUseThumbnails;
    ThumbColor:=PThumbColor;
    ThumbSize:=PThumbSize;
    ThumbPath:=PThumbPath;
    TotalContours:=PTotalContours;
    ContourInterval:=PContourInterval;
    SlopeDirection:=PSlopeDirection;
    SlopeCellSize:=PSlopeCellSize;
    UseContourColors:=PUseContourColors;
    ThresholdBarPosition{500}:=PThresholdBarPosition;
    IntervalBarPosition{100}:=PIntervalBarPosition;
    JoyNullRange:=PJoyNullRange;
        LOSFanLimits:=PLOSFanLimits;
        LOSHeight:=PLOSHeight;
        LOSRange:=PLOSRange;
        LOSDirection:=PLOSDirection;
        LOSAngle:=PLOSAngle;

  ProgramPort:=PProgramPort;
    (*
     ColorWhite := PColorWhite;
    ColorBlack := PColorBlack;
    ColorPURPLE := PColorPURPLE; ColorDPURPLE := PColorDPURPLE;
    ColorYELLOW := PColorYELLOW; ColorLYELLOW := PColorLYELLOW;
    Color9 := PColor9;
    Color1 := PColor1; Color2 := PColor2;
    Color3 := PColor3; Color4 := PColor4;
    Color5 := PColor5; Color6 := PColor6;
    Color7 := PColor7; Color8 := PColor8;
    {UVW := PUVW; VDW := PVDW; VMW := PVMW; VLW := PVLW; UDW := PUDW;
    UMW := PUMW; ULW := PULW; }DDW := PDDW;
    DMW := PDMW; DLW := PDLW; MDW := PMDW; MMW := PMMW; MLW := PMLW;
    LDW := PLDW; LMW := PLMW; LLW := PLLW;
    {UVC := PUVC; VDC := PVDC; VMC := PVMC; VLC := PVLC; UDC := PUDC;
    UMC := PUMC; ULC := PULC;} DDC := PDDC;
    DMC := PDMC; DLC := PDLC; MDC := PMDC; MMC := PMMC; MLC := PMLC;
    LDC := PLDC; LMC := PLMC; LLC := PLLC;
    {UVF := PUVF; VDF := PVDF; VMF := PVMF; VLF := PVLF; UDF := PUDF;
    UMF := PUMF; ULF := PULF;} DDF := PDDF;
    DMF := PDMF; DLF := PDLF; MDF := PMDF; MMF := PMMF; MLF := PMLF;
    LDF := PLDF; LMF := PLMF; LLF := PLLF;
    {UVA := PUVA; VDA := PVDA; VMA := PVMA; VLA := PVLA; UDA := PUDA;
    UMA := PUMA; ULA := PULA;} DDA := PDDA;
    DMA := PDMA; DLA := PDLA; MDA := PMDA; MMA := PMMA; MLA := PMLA;
    LDA := PLDA; LMA := PLMA; LLA := PLLA;
    {UVR := PUVR; VDR := PVDR; VMR := PVMR; VLR := PVLR; UDR := PUDR;
    UMR := PUMR; ULR := PULR; }DDR := PDDR;
    DMR := PDMR; DLR := PDLR; MDR := PMDR; MMR := PMMR; MLR := PMLR;
    LDR := PLDR; LMR := PLMR; LLR := PLLR;
    {UVT := PUVT; VDT := PVDT; VMT := PVMT; VLT := PVLT; UDT := PUDT;
    UMT := PUMT; ULT := PULT;} DDT := PDDT;
    DMT := PDMT; DLT := PDLT; MDT := PMDT; MMT := PMMT; MLT := PMLT;
    LDT := PLDT; LMT := PLMT; LLT := PLLT;
    {UVB := PUVB; VDB := PVDB; VMB := PVMB; VLB := PVLB; UDB := PUDB;
    UMB := PUMB; ULB := PULB;} DDB := PDDB;
    DMB := PDMB; DLB := PDLB; MDB := PMDB; MMB := PMMB; MLB := PMLB;
    LDB := PLDB; LMB := PLMB; LLB := PLLB;
    {UVU := PUVU; VDU := PVDU; VMU := PVMU; VLU := PVLU; UDU := PUDU;
    UMU := PUMU; ULU := PULU;} DDU := PDDU;
    DMU := PDMU; DLU := PDLU; MDU := PMDU; MMU := PMMU; MLU := PMLU;
    LDU := PLDU; LMU := PLMU; LLU := PLLU;
    {UVS := PUVS; VDS := PVDS; VMS := PVMS; VLS := PVLS; UDS := PUDS;
    UMS := PUMS; ULS := PULS;} DDS := PDDS;
    DMS := PDMS; DLS := PDLS; MDS := PMDS; MMS := PMMS; MLS := PMLS;
    LDS := PLDS; LMS := PLMS; LLS := PLLS;    *)
  end;
end;
begin {}
  PathS := ExtractFilePath(ParamStr(0)) + 'dtm.pof';
  if FileExists(PathS) then
  begin
    AssignFile(P_File, PathS);
    Reset(P_File);
    if IoResult <> 0 then DoMessages(29986);
    {29986, "Failed writing dtm.pof File"}
    Read(P_File, PreRcd);
    CloseFile(P_File);
    SetPreferences;
  end else DoMessages(29985);
  {29985, "dtm.pof Does NOT Exist"}
end;



{---------------------------------------------------------------------}

procedure DoSaver;
type
  PrefFile = file of PrefRecord;
var
  PreRcd: PrefRecord;
var P_File: PrefFile;
var PathS: string;
procedure GetPreferences;
begin {before saving}
  with PreRcd do begin
  PHiddenString:=HiddenString;
    PColorreg := Colorreg;
    PStarted := Started;
    PStartedNameNumber := StartedNameNumber;
  PColor256Name:=Color256Name;
  PPrintBigChecked:=PrintBigChecked;
{  PTempName:=TempName;}
  PProgramPath:=ProgramPath;
  PFractal3DPath:=Fractal3DPath;
  PLifePath:=LifePath;
  PSOSMAPPath:=SOSMAPPath;
  PNoNamePath:=NoNamePath;
  PVRMProgramPath:=VRMProgramPath;
  PDigitizerPath:=DigitizerPath;
  PVRGISPath:=VRGISPath;
  PDTMPath:=DTMPath;
  PVoicePath:=VoicePath;
 PRasterPath:=RasterPath;
  PILHProgram:=ILHProgram;
  PZipPath:=ZipPath;
  PProjectPath:=ProjectPath;
  PProjectName:=ProjectName;
  POldFileName4:=OldFileName4;
  POldFileName3:=OldFileName3;
  POldFileName2:=OldFileName2;
  POldFileName1:=OldFileName1;
  POldFileName0:=OldFileName0;
  PInfoString:=InfoString;
  PConfirmationString:=ConfirmationString;
  PWarnString:=WarnString;
  PErrorString:=ErrorString;
  PDoneString:=DoneString;

  PPixelEnlargement:=PixelEnlargement;
  PTilesperTexture:=TilesperTexture;
  PXScaleUsed:=XScaleUsed;
  PZScaleUsed:=ZScaleUsed;
  PSeaLevelUsed :=SeaLevelUsed;
  PUseConglomeration:=UseConglomeration;
  PUseImageMap:=UseImageMap;
  PUseEcoTypes:=UseEcoTypes;
  PUseBumpMap:=UseBumpMap;
  PUseFlippedHTF:=UseFlippedHTF;
  PTextureFileType:=TextureFileType;
  PCreateTexturesOnDemand:=CreateTexturesOnDemand;
  PSaveCreatedTextures:=SaveCreatedTextures;
  PUseSavedTextures:=UseSavedTextures;
  PUseClouds:=UseClouds;
  PUseCloudsRange:=UseCloudsRange;
  PUseWaves:=UseWaves;
  PUseStormClouds:=UseStormClouds;
  PUseSunMoving:=UseSunMoving;
  PDisplayFPS:=DisplayFPS;
  PSunMovingUsed :=SunMovingUsed;
  PUseCloudsSRange:=UseCloudsSRange;
  PLoadDTPOnStart:=LoadDTPOnStart;
  PMaximumShapeObjects:=MaximumShapeObjects;
  PMaximumShapeLevels:=MaximumShapeLevels;
  PUseXScale:=UseXScale;
  PUseZScale:=UseZScale;
  PUseSeaLevel:=UseSeaLevel;
   PBumpRanger:=BumpRanger;
  PDOVUsed:=DOVUsed;
  PClodPUsed:=ClodPUsed;
  PQualityDUsed:=QualityDUsed;
  PRunDTS:=RunDTS;
  PDtmDtcLoad:=DtmDtcLoad;
  PLoadDTCOnStart:=LoadDTCOnStart;
  PUseDOV:=UseDOV;
  PUseClodP:=UseClodP;
  PUseQualityD:=UseQualityD;
    PStormCloudsRateUsed:=StormCloudsRateUsed;
    PStormCloudsRangeUsed:=StormCloudsRangeUsed;
    PWavesRateUsed:=WavesRateUsed;
    PWavesRangeUsed:=WavesRangeUsed;
 PCloudFileUsed:=CloudFileUsed;
 PUseCloudFile:=UseCloudFile;
  PCloudAnime:=CloudAnime;
  PCloudChangeAmount:=CloudChangeAmount;
  PCloudSharpUsed:=CloudSharpUsed;
  PCloudSharpRangeUsed:=CloudSharpRangeUsed;
//
  PStormMovingFileUsed:=StormMovingFileUsed;
  PStormWindDirectionUsed:=StormWindDirectionUsed;
  PStormWindSpeedUsed:=StormWindSpeedUsed;
  PStormWindDirectionVarUsed:=StormWindDirectionVarUsed;
  PStormWindSpeedVariationUsed:=StormWindSpeedVariationUsed;
  PStormCloudsDirectionUsed:=StormCloudsDirectionUsed;
  PStormCloudsSpeedUsed:=StormCloudsSpeedUsed;
  PStormCloudsNumberUsed:=StormCloudsNumberUsed;

  PRainDensityUsed:=RainDensityUsed;
  PRainDensityVarUsed:=RainDensityVarUsed;
  PLightningFrequencyUsed:=LightningFrequencyUsed;
  PLightningForceUsed:=LightningForceUsed;
  PTornadoeFrequencyUsed:=TornadoeFrequencyUsed;
  PTornadoeForceUsed:=TornadoeForceUsed;
  PStormCloudsPosXUsed:=StormCloudsPosXUsed;
  PStormCloudsPosYUsed:=StormCloudsPosYUsed;
  PStormCloudsPosZUsed:=StormCloudsPosZUsed;
  PStormCloudsNumRangeUsed:=StormCloudsNumRangeUsed;
  PStormCloudsNumRangeVarUsed:=StormCloudsNumRangeVarUsed;
  PStormCloudsRangeXUsed:=StormCloudsRangeXUsed;
  PStormCloudsRangeYUsed:=StormCloudsRangeYUsed;
  PStormCloudsRangeZUsed:=StormCloudsRangeZUsed;

  PUseCloudsSetting:=UseCloudsSetting;
  PUseStormLinear:=UseStormLinear;
  PUseStormMoving:=UseStormMoving;
  PUseStormMovingDirS:=UseStormMovingDirS;
  PUseStormMovingPath:=UseStormMovingPath;
  PUseStormRain:=UseStormRain;
  PUseStormLightning:=UseStormLightning;
  PUseStormTornadoes:=UseStormTornadoes;
  PUseStormWind:=UseStormWind;
//
 PCloudMinUsed:=CloudMinUsed;
 PCloudMinRangeUsed:=CloudMinRangeUsed;
 PCloudRandomSeedUsed:=CloudRandomSeedUsed;
 PCloudImageSizeUsed:=CloudImageSizeUsed;
  PMapName:=MapName;
  PMapsPath:=MapsPath;
  PTigerPath:=TigerPath;
  PDemPath:=DemPath;
  PHTFPath:=HTFPath;
  PShapePath:=ShapePath;
  PDLGPath:=DLGPath;
  PDxfPath:=DxfPath;
  PVRMDatabase:=VRMDatabase;
  PImagePath:=ImagePath;
  PFilePreviews:=FilePreviews;
  PErrorBeepOn:=ErrorBeepOn;
{  PScaleBarVisible:=ScaleBarVisible;}
  PSkipIntroScreen:=SkipIntroScreen;
  PWarningBeepOn :=WarningBeepOn;
  PInfoBeepOn :=InfoBeepOn;
  PConfirmBeepOn:=ConfirmBeepOn;
  PCompletedBeepOn:=CompletedBeepOn;
  PSkip32BitNotice:=Skip32BitNotice;
  PUseThumbnails:=UseThumbnails;
  PVoicesON :=VoicesON;
  PRegisterFileTypes:=RegisterFileTypes;
{  PCropXWide:=CropXWide;
  PCropYTall:=CropYTall;}
{    PColorRef := ColorRef;}
{    PCurrentColor := CurrentColor;
    PMapBordersColor:=MapBordersColor;
    PMapGridsColor:=MapGridsColor;
    PMapDatasColor:=MapDatasColor;
    PMapBacksColor:=MapBacksColor;}

    PCurrentColor:=CurrentColor;
    PMapDataColor:=MapDataColor;
    PMapHighlightColor:=MapHighlightColor;
    PMapEditColor:=MapEditColor;
    PMapEditingColor:=MapEditingColor;
    PMapGridColor:=MapGridColor;
     PMapContourColor:=MapContourColor;
    PMapBackgroundColor:=MapBackgroundColor;
     PMapBlankColor:=MapBlankColor;
     PMapMaroonedColor:=MapMaroonedColor;
      PDTMformX:=DTMformX;
      PDTMformY:=DTMformY;
      PPOFFormX:=POFFormX;
      PPOFFormY:=POFFormY;
      PHtfFormY:=HtfFormY;
      PHtfFormX:=HtfFormX;
      PdtmGLSAboutFormX:=dtmGLSAboutFormX;
      PdtmGLSAboutFormY:=dtmGLSAboutFormY;
      PdtmHtfDem24kFormX:=dtmHtfDem24kFormX;
      PdtmHtfDem24kFormY:=dtmHtfDem24kFormY;
      PdtmHdsSunConfigFormX:=dtmHdsSunConfigFormX;
      PdtmHdsSunConfigFormY:=dtmHdsSunConfigFormY;
      PfrmLMMWizardX:=frmLMMWizardX;
      PfrmLMMWizardY:=frmLMMWizardY;
      PFrmLightmapFaceGroupsX:=FrmLightmapFaceGroupsX;
      PFrmLightmapFaceGroupsY:=FrmLightmapFaceGroupsY;
      PFInfoX:=FInfoX;
      PFInfoY:=FInfoY;
      PFractalFormX:=FractalFormX;
      PFractalFormY:=FractalFormY;
      PFractalPreviewFormX:=FractalPreviewFormX;
      PFractalPreviewFormY:=FractalPreviewFormY;
      PGizmoPathFormX:=GizmoPathFormX;
      PGizmoPathFormY:=GizmoPathFormY;
      Pt3de1FormX:=t3de1FormX;
      Pt3de1FormY:=t3de1FormY;
      Pt3dFormX:=t3dFormX;
      Pt3dFormY:=t3dFormY;
      PdtmHdsFormX:=dtmHdsFormX;
      PdtmHdsFormY:=dtmHdsFormY;
      PDTMGLFormX:=DTMGLFormX;
      PDTMGLFormY:=DTMGLFormY;
      PDtmGlBaseFormX:=DtmGlBaseFormX;
      PDtmGlBaseFormY:=DtmGlBaseFormY;
      PGLSViewerFormX:=GLSViewerFormX;
      PGLSViewerFormY:=GLSViewerFormY;
      {PDtmJoyFormX:=DtmJoyFormX;
      PDtmJoyFormY:=DtmJoyFormY;}
      PdtmSmdQcFormX:= dtmSmdQcFormX;
      PdtmSmdQcFormY:= dtmSmdQcFormY;
      PdtmSmdLoadMdlFormX:=dtmSmdLoadMdlFormX;
      PdtmSmdLoadMdlFormY:=dtmSmdLoadMdlFormY;
      PdtmPanImageFormX:=dtmPanImageFormX;
      PdtmPanImageFormY:=dtmPanImageFormY;
      PDtmImageRGBFormX:=DtmImageRGBFormX;
      PDtmImageRGBFormY:=DtmImageRGBFormY;
      PRIFImageViewerFormX:=RIFImageViewerFormX;
      PRIFImageViewerFormY:=RIFImageViewerFormY;
      PMessageX:=MessageX;
      PMessageY:=MessageY;
      PNavFormX:=NavFormX;
      PNavFormY:=NavFormY;
      PAboutX:=AboutX;
      PAboutY:=AboutY;
      PZipFormX:=ZipFormX;
      PZipFormY:=ZipFormY;
      PImageMakerFormX:=ImageMakerFormX;
      PImageMakerFormY:=ImageMakerFormY;
      PLineProfileFormX:=LineProfileFormX;
      PLineProfileFormY:=LineProfileFormY;
      PdtmDTPFormX:=dtmDTPFormX;
      PdtmDTPFormY:=dtmDTPFormY;
      PdtmEcotypeColorsFormX:=dtmEcotypeColorsFormX;
      PdtmEcotypeColorsFormY:=dtmEcotypeColorsFormY;
      PdtmDbFormX:=dtmDbFormX;
      PdtmDbFormY:=dtmDbFormY;
      PSystemInfoFormX:=SystemInfoFormX;
      PSystemInfoFormY:=SystemInfoFormY;
      PdtmTaskDroneX:= dtmTaskDroneX;
      PdtmTaskDroneY:= dtmTaskDroneY;
      PdtmTaskDroneAboutX:= dtmTaskDroneAboutX;
      PdtmTaskDroneAboutY:= dtmTaskDroneAboutY;
    PThumbColor:=ThumbColor;
    PThumbSize:=ThumbSize;
    PThumbPath:=ThumbPath;
    PTotalContours:=TotalContours;
    PContourInterval:=ContourInterval;
    PUseContourColors:=UseContourColors;
    PSlopeDirection:=SlopeDirection;
    PSlopeCellSize:=SlopeCellSize;
    PJoyNullRange:=JoyNullRange;
    PThresholdBarPosition{500}:=ThresholdBarPosition;
    PIntervalBarPosition{100}:=IntervalBarPosition;
        PLOSFanLimits:=LOSFanLimits;
        PLOSHeight:=LOSHeight;
        PLOSRange:=LOSRange;
        PLOSDirection:=LOSDirection;
        PLOSAngle:=LOSAngle;

  PProgramPort:=ProgramPort;
    (*
    PColorWhite := ColorWhite;
    PColorBlack := ColorBlack;
    PColorPURPLE := ColorPURPLE; PColorDPURPLE := ColorDPURPLE;
    PColorYELLOW := ColorYELLOW; PColorLYELLOW := ColorLYELLOW;
    PColor9 := Color9;
    PColor1 := Color1; PColor2 := Color2; PColor3 := Color3; PColor4
    := Color4;
    PColor5 := Color5; PColor6 := Color6; PColor7 := Color7; PColor8
    := Color8;
    {PUVW := UVW; PVDW := VDW; PVMW := VMW; PVLW := VLW; PUDW := UDW;
    PUMW := UMW; PULW := ULW;} PDDW := DDW;
    PDMW := DMW; PDLW := DLW; PMDW := MDW; PMMW := MMW; PMLW := MLW;
    PLDW := LDW; PLMW := LMW; PLLW := LLW;
    {PUVC := UVC; PVDC := VDC; PVMC := VMC; PVLC := VLC; PUDC := UDC;
    PUMC := UMC; PULC := ULC;} PDDC := DDC;
    PDMC := DMC; PDLC := DLC; PMDC := MDC; PMMC := MMC; PMLC := MLC;
    PLDC := LDC; PLMC := LMC; PLLC := LLC;
    {PUVF := UVF; PVDF := VDF; PVMF := VMF; PVLF := VLF; PUDF := UDF;
    PUMF := UMF; PULF := ULF;} PDDF := DDF;
    PDMF := DMF; PDLF := DLF; PMDF := MDF; PMMF := MMF; PMLF := MLF;
    PLDF := LDF; PLMF := LMF; PLLF := LLF;
    {PUVA := UVA; PVDA := VDA; PVMA := VMA; PVLA := VLA; PUDA := UDA;
    PUMA := UMA; PULA := ULA;} PDDA := DDA;
    PDMA := DMA; PDLA := DLA; PMDA := MDA; PMMA := MMA; PMLA := MLA;
    PLDA := LDA; PLMA := LMA; PLLA := LLA;
    {PUVR := UVR; PVDR := VDR; PVMR := VMR; PVLR := VLR; PUDR := UDR;
    PUMR := UMR; PULR := ULR;} PDDR := DDR;
    PDMR := DMR; PDLR := DLR; PMDR := MDR; PMMR := MMR; PMLR := MLR;
    PLDR := LDR; PLMR := LMR; PLLR := LLR;
    {PUVT := UVT; PVDT := VDT; PVMT := VMT; PVLT := VLT; PUDT := UDT;
    PUMT := UMT; PULT := ULT;} PDDT := DDT;
    PDMT := DMT; PDLT := DLT; PMDT := MDT; PMMT := MMT; PMLT := MLT;
    PLDT := LDT; PLMT := LMT; PLLT := LLT;
   { PUVB := UVB; PVDB := VDB; PVMB := VMB; PVLB := VLB; PUDB := UDB;
    PUMB := UMB; PULB := ULB;} PDDB := DDB;
    PDMB := DMB; PDLB := DLB; PMDB := MDB; PMMB := MMB; PMLB := MLB;
    PLDB := LDB; PLMB := LMB; PLLB := LLB;
    {PUVU := UVU; PVDU := VDU; PVMU := VMU; PVLU := VLU; PUDU := UDU;
    PUMU := UMU; PULU := ULU;} PDDU := DDU;
    PDMU := DMU; PDLU := DLU; PMDU := MDU; PMMU := MMU; PMLU := MLU;
    PLDU := LDU; PLMU := LMU; PLLU := LLU;
    {PUVS := UVS; PVDS := VDS; PVMS := VMS; PVLS := VLS; PUDS := UDS;
    PUMS := UMS; PULS := ULS;} PDDS := DDS;
    PDMS := DMS; PDLS := DLS; PMDS := MDS; PMMS := MMS; PMLS := MLS;
    PLDS := LDS; PLMS := LMS; PLLS := LLS;*)
  end;
end;
begin
  PathS := ExtractFilePath(ParamStr(0)) + 'dtm.pof';
  if (not FileExists(PathS)) then DoMessages(14{39987});
  {14, "Creating dtm.pof File"}
  GetPreferences;
  AssignFile(P_File, PathS);
  Rewrite(P_File);
  if IoResult <> 0 then
  begin
    DoMessages(29986);   {29986, "Failed writing dtm.pof File"}
  end;
  write(P_File, PreRcd);
  CloseFile(P_File);
end;
{---------------------------------------------------------------------}



procedure ResetToDefaults;
var IPString:String;
begin
    FilePreviews:=True;
    PrintBigChecked:=True;
    Skip32BitNotice:=False;
    SkipIntroScreen:=False;
    ErrorBeepOn:=False;
    WarningBeepOn:=False;
    InfoBeepOn :=False;
    ConfirmBeepOn:=False;
    CompletedBeepOn:=False;
    UseThumbnails:=False;
    RegisterFileTypes:=False;

    DTMFormX := 0;
    DTMFormY := 0;
    POFFormX:=123;
    POFFormY:=123;
    HtfFormY:=123;
    HtfFormX:=123;
      dtmGLSAboutFormX:=123;
      dtmGLSAboutFormY:=123;
      dtmHtfDem24kFormX:=123;
      dtmHtfDem24kFormY:=123;
      dtmHdsSunConfigFormX:=123;
      dtmHdsSunConfigFormY:=123;
      frmLMMWizardX:=123;
      frmLMMWizardY:=123;
      FrmLightmapFaceGroupsX:=123;
      FrmLightmapFaceGroupsY:=123;
      FInfoX:=123;
      FInfoY:=123;
      FractalFormX:=123;
      FractalFormY:=123;
      FractalPreviewFormX:=123;
      FractalPreviewFormY:=123;
      GizmoPathFormX:=12;
      GizmoPathFormY:=12;
      t3de1FormX:=123;
      t3de1FormY:=123;
      t3dFormX:=123;
      t3dFormY:=123;
    dtmHdsFormX:=71;
    dtmHdsFormY:=49;
    DTMGLFormX:=123;
    DTMGLFormY:=123;
    DtmGlBaseFormX:=123;
    DtmGlBaseFormY:=123;
    GLSViewerFormX:=123;
    GLSViewerFormY:=123;
    {DtmJoyFormX:=123;
    DtmJoyFormY:=123;}
    dtmSmdQcFormX:=123;
    dtmSmdQcFormY:=123;
    dtmSmdLoadMdlFormX:=123;
    dtmSmdLoadMdlFormY:=123;
    dtmPanImageFormX:=123;
    dtmPanImageFormY:=123;
    RIFImageViewerFormX:=123;
    RIFImageViewerFormY:=123;
    DtmImageRGBFormX:=123;
    DtmImageRGBFormY:=123;
    ImageMakerFormX:=123;
    ImageMakerFormY:=123;
    ZipFormX:=123;
    ZipFormY:=123;
    LineProfileFormX:=123;
    LineProfileFormY:=123;
    dtmDTPFormX:=123;
    dtmDTPFormY:=123;
    dtmEcotypeColorsFormY := 123;
    dtmEcotypeColorsFormX := 123;
    dtmDbFormX:=123;
    dtmDbFormY:=123;
    NavFormX:=123;
    NavFormY:=123;
    MessageX := 123;
    MessageY := 123;
    AboutX := 123;
    AboutY := 123;
    SystemInfoFormX := 123;
    SystemInfoFormY := 123;
      dtmTaskDroneX:= 123;
      dtmTaskDroneY:= 123;
      dtmTaskDroneAboutX:= 123;
      dtmTaskDroneAboutY:= 123;
    {Reset Directories defaults  }
  OldFileName4:=' ';
  OldFileName3:=' ';
  OldFileName2:=' ';
  OldFileName1:=' ';
  OldFileName0:=' ';
    TempName:='';{Passing name}
    DTMPath := (ParamStr(0));
    Fractal3DPath:=DTMPath;
    LifePath:=DTMPath;       { HTFName}
    SOSMAPPath:=DTMPath;
    DigitizerPath:=DTMPath;
    VRGISPath:=DTMPath;
    DTMPath:=DTMPath;
    VoicePath:=DTMPath;
    RasterPath:=DTMPath;
    ILHProgram:=DTMPath;
   InfoString:= DTMPath+ 'fyinfo.wav'; {Info}
   ConfirmationString:= DTMPath+ 'confirm.wav';{ Confirmation}
   WarnString:= DTMPath+ 'warn.wav';{Warn}
   ErrorString:= DTMPath+ 'error.wav';{Error}
   DoneString:= DTMPath+ 'done.wav';{Done}
    ProgramPath:=DTMPath;
    NoNamePath:=DTMPath;


    ProjectPath:=ExtractFilePath(DTMPath)+'Project';
    MapsPath:=ProjectPath;
      ProjectName:=DTMPath;
      MapName:=DTMPath;
    TransSearchDir:=ProjectPath;
    ThumbPath:=ProjectPath;
    DemPath:=ProjectPath;
    HTFPath:=ProjectPath+'\htf\';
    TigerPath:=ProjectPath+'\Robots\';   //actors  Robots
    DLGPath:=ProjectPath+'\Textures\';
    DXFPath:=ProjectPath+'\Objects\';  //Objects
    ShapePath:=ProjectPath+'\Shapes\'; // Shapes
    VRMDatabase:=ProjectPath;  //DB
    ImagePath:=ProjectPath; //RGB Pans
    ZipPath:=ProjectPath;


{    PColorRef,}
    CurrentColor:=clBlack;
    MapDataColor:=clLime;
    MapHighlightColor:=clYellow;
    MapEditColor:=clRed;
    MapEditingColor:=clFuchsia;
    MapGridColor:=clOlive;
     MapContourColor:=clGreen;
    MapBackgroundColor:=clSilver;
     MapBlankColor:=clAqua;
     MapMaroonedColor:=clMaroon;
    ThumbColor:=clWhite;
    ThumbSize:=128;     {ThumbWidth:=128;    ThumbHeight:=96;}
    ThumbPath:=DTMPath;

       //Drone IP address
  IPString:='169.254.126.197:2345';
  ProgramPort:=IPString;
  ResetTerrainDefaults;
end;


procedure ResetTerrainDefaults;
begin
  UseFlippedHTF:=True;
  CreateTexturesOnDemand:=True;
  SaveCreatedTextures:=False;
  UseSavedTextures:=False;
  LoadDTPOnStart:=False;
  LoadDTCOnStart:=False;
  DtmDtcLoad:='';
  RunDTS:=False;
  MaximumShapeObjects:=99;
  MaximumShapeLevels:=9;
  UseFlippedHTF:=True;
  CreateTexturesOnDemand:=True;
  SaveCreatedTextures:=False;
  UseSavedTextures:=False;

  UseXScale:=False;
  UseZScale:=False;
  UseSeaLevel:=False;
  UseConglomeration:=False;
  UseImageMap:=False;
  UseEcoTypes:=False;
  UseBumpMap:=False;
  UseClouds:=False;

  UseStormClouds:=False;
  TextureFileType:=0;
  PixelEnlargement:=2;
  TilesperTexture:=1;
  XScaleUsed:=1;
  ZScaleUsed:=1;
  SeaLevelUsed :=0;
  BumpRanger:=8;

  UseXScale:=False;
  UseZScale:=False;
  UseSeaLevel:=False;
  UseConglomeration:=False;
  UseImageMap:=False;
  UseEcoTypes:=False;
  TextureFileType:=0;
  PixelEnlargement:=2;
  TilesperTexture:=1;
  XScaleUsed:=1;
  ZScaleUsed:=1;
  SeaLevelUsed :=0;
  DOVUsed:=600;
  ClodPUsed:=60;
  QualityDUsed:=300;
    SunMovingUsed :=4;
     UseSunMoving:=False;
       DisplayFPS:=True;
  UseStormClouds:=False;
    StormCloudsRateUsed:=1.9; //disperse2.2
    StormCloudsRangeUsed:=2.649;  //PositionDispersionRange
  UseWaves:=False;
    WavesRateUsed:=5000; //RainForce:=5000
    WavesRangeUsed:=500; //RainTimeInterval:=500
  UseClouds:=False;
  CloudAnime:=6;      // CloudAnime  CloudChangeAmount
  CloudChangeAmount:=0.0001;
  UseCloudsSRange:=False;
  CloudSharpUsed:=0.98;
  CloudSharpRangeUsed:=0.1;
 UseCloudsRange:=False;
 CloudMinUsed:=110;
 CloudMinRangeUsed:=24;
 CloudRandomSeedUsed:=3456;  //119908264
 CloudImageSizeUsed:=128;
 CloudFileUsed:='';
 UseCloudFile:=False;

//
  StormMovingFileUsed :='';
  StormWindDirectionUsed:=45; StormWindSpeedUsed:=13;
  StormWindDirectionVarUsed:=4; StormWindSpeedVariationUsed:=2;
  StormCloudsDirectionUsed:=270; StormCloudsSpeedUsed:=3;
  StormCloudsNumberUsed :=3;

  RainDensityUsed:=7.9;RainDensityVarUsed:=2.649;
  LightningFrequencyUsed:=0.09;LightningForceUsed:=0.49;
  TornadoeFrequencyUsed:=0.19;TornadoeForceUsed:=2.0;
  StormCloudsPosXUsed:=1.0;
  StormCloudsPosYUsed:=2.0;
  StormCloudsPosZUsed:=3.0;
  StormCloudsNumRangeUsed:=0.7;
  StormCloudsNumRangeVarUsed:=1.9;
  StormCloudsRangeXUsed:=4.9;
  StormCloudsRangeYUsed:=2.649;
  StormCloudsRangeZUsed:=1.9;

  UseCloudsSetting:=True;
  UseStormLinear:=True;
  UseStormMoving:=True; UseStormMovingDirS:=False; UseStormMovingPath:=False;
  UseStormRain:=False; UseStormLightning:=False; UseStormTornadoes:=False;
  UseStormWind:=False;
//


  UseDOV:=False;
  UseClodP:=False;
  UseQualityD:=False;
    TotalContours:=9;
    ContourInterval:=20;
    SlopeDirection:=0;
    SlopeCellSize:=100;
    UseContourColors:=True;
    TotalContours:=9;
    ContourInterval:=20;
    SlopeDirection:=0;
    SlopeCellSize:=100;
    UseContourColors:=True;
    JoyNullRange:=3;
    ThresholdBarPosition{500}:=500;{Joystick}
    IntervalBarPosition{100}:=100;
    JoyCentroidX:=0;
    JoyCentroidY:=0;

    LOSHeight:=0;
    LOSRange:=5;
    LOSDirection:=0;
    LOSAngle:=90;
    LOSFanLimits:=False;
    LOSHeight:=0;
    LOSRange:=5;
    LOSDirection:=0;
    LOSAngle:=90;
    LOSFanLimits:=False;
end;

end.
