unit dtmTaskDroneFrm;
{***************************************************************
 *
 * Project  : VR Server   169.254.126.198  197 .. 190
 * Unit Name: aGripserver
 * Purpose  : Demonstrates sending / receiving record data and use of buffers
 * Version  : 1.0         DTM 1.6
 * Date     : May 2003   ..Oct 2004
 * Author   : Ivan Lee Herring
 * History  :
 * Tested   : ?
 * Cribbed from: INDY DEMO : Allen O'Neill <allen_oneill@hotmail.com>
 ****************************************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs,  StdCtrls,
  vrrRemConMessages,
  IdBaseComponent, IdComponent, IdTCPServer, IdSocketHandle,
  ExtCtrls, Menus, Buttons, ComCtrls;

type
  TdtmTaskDroneForm = class(TForm)
    IdTCPDrone: TIdTCPServer;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Options1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    Help1: TMenuItem;
    CpuTimer: TTimer;
    MakeDefault1: TMenuItem;
    TaskNamesFile1: TMenuItem;
    DisplayTaskInfo1: TMenuItem;
    TopPanel: TPanel;
    Memo1: TRichEdit;
    Label6: TLabel;
    TimerToggle: TCheckBox;
    Label2: TLabel;
    Label9: TLabel;
    Label4: TLabel;
    Label7: TLabel;
    edtDroneIP: TEdit;
    btnStart: TButton;
    SpeedButton2: TSpeedButton;
    btnExit: TButton;
    edtDronePort: TEdit;
    Label8: TLabel;
    ProgressLabel: TLabel;
    DroneTask: TLabel;
    TaskLabel: TLabel;
    CpuUseLabel: TLabel;
    CpuSpeedLabel: TLabel;
    ListBox1: TListBox;
    ListBox2: TListBox;
    DataPanel: TPanel;
    MsgLabel: TLabel;
    PasswordLabel: TLabel;
    NameLabel: TLabel;
    DroneIPLabel: TLabel;
    DronePortLabel: TLabel;
    ClientIDLabel: TLabel;
    TaskIDLabel: TLabel;
    TasksAvailableLabel: TLabel;
    TaskData1Label: TLabel;
    TaskData2Label: TLabel;
    TaskResultLabel: TLabel;
    StartTimeLabel: TLabel;
    FinishTimeLabel: TLabel;
    InfoLabel: TLabel;
    InNameLabel: TLabel;
    OutNameLabel: TLabel;
    ProgressIDLabel: TLabel;
    StatusIDLabel: TLabel;
    PriorityIDLabel: TLabel;
    ErrorIDLabel: TLabel;
    ErrorInfoLabel: TLabel;
    HelpBtn: TSpeedButton;
    DronePasswordEdit: TEdit;
    Label3: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnExitClick(Sender: TObject);
    procedure Options1Click(Sender: TObject);
        
    procedure edtDroneIPKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edtDronePortKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure About1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);

    procedure CpuTimerTimer(Sender: TObject);
    procedure TimerToggleClick(Sender: TObject);
function GetCPUSpeed: Double;

    procedure btnStartClick(Sender: TObject);

    procedure IdTCPDroneExecute(AThread: TIdPeerThread);
procedure ProcessMessages(MessageID:Integer);
procedure RunProgram;
procedure ProcessTask;
procedure RepeatUntilTaskCanceledTask;
    procedure Timer1Timer(Sender: TObject);
procedure WantProgress;
    procedure FormActivate(Sender: TObject);
procedure DetermineTasksAvailable;
procedure WriteTaskNames;

    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure MakeDefault1Click(Sender: TObject);
    procedure DisplayTaskInfo1Click(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);


  private
    { Private declarations }
    TasksAvailable:Integer;

  public
    { Public declarations }
    TaskInfo: TTaskInfo;
    TaskList: TTaskList;
  end;


var
  dtmTaskDroneForm: TdtmTaskDroneForm;

implementation

uses
  dtmPOFrm, dtmPOFvar,
  dtmErrMsg,//Show and Print
  dtmTaskDroneAboutFrm, zadCpuUsage,
  dtmHtfFrm, dtmfrm;

{$R *.DFM}

procedure TdtmTaskDroneForm.FormCreate(Sender: TObject);
begin
  left := dtmTaskDroneX;
  top := dtmTaskDroneY;
  edtDroneIP.Text:=Copy(ProgramPort,1,pos(':',ProgramPort)-1);
  edtDronePort.Text:=Copy(ProgramPort,pos(':',ProgramPort)+1,length(ProgramPort));
  TopPanel.Align:= alNone;  //alClient
  DataPanel.Align:= alNone;
  DataPanel.Visible:= False;
  TopPanel.Align:= alTop;
  dtmTaskDroneForm.Height:=213;
end;
procedure TdtmTaskDroneForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if IdTCPDrone.active then
  begin
    IdTCPDrone.active := false;
    IdTCPDrone.Bindings.Clear;
  end;
  dtmTaskDroneX := dtmTaskDroneForm.left;
  dtmTaskDroneY := dtmTaskDroneForm.top;
  ProgramPort:= edtDroneIP.Text+':'+ edtDronePort.Text;
  DoSaver;
end;
procedure TdtmTaskDroneForm.btnExitClick(Sender: TObject);
begin
  close;
end;
procedure TdtmTaskDroneForm.HelpBtnClick(Sender: TObject);
begin
  Application.HelpContext(15000);
end;

procedure TdtmTaskDroneForm.DisplayTaskInfo1Click(Sender: TObject);
begin
  DisplayTaskInfo1.Checked:= (not DisplayTaskInfo1.Checked);
  If DisplayTaskInfo1.Checked then
  begin
  dtmTaskDroneForm.Height:=375; //213
  TopPanel.Align:= alTop;  //alClient
  DataPanel.Visible:= True;
  DataPanel.Align:= alBottom;
  TopPanel.Align:= alClient;
  MsgLabel.Caption:=Inttostr(TaskInfo.Msg);
  PasswordLabel.Caption:=  TaskInfo.Password;
  NameLabel.Caption:=  TaskInfo.Name;
  DroneIPLabel.Caption:=(TaskInfo.DroneIP);
  DronePortLabel.Caption:=Inttostr(TaskInfo.DronePort);
  ClientIDLabel.Caption:=Inttostr(TaskInfo.ClientID);
  TaskIDLabel.Caption:=Inttostr(TaskInfo.TaskIDn);
  TasksAvailableLabel.Caption:=Inttostr(TaskInfo.TaskAvailable);
  TaskData1Label.Caption:=Inttostr(TaskInfo.TaskData1);
  TaskData2Label.Caption:=Floattostr(TaskInfo.TaskData2);
  TaskResultLabel.Caption:=Inttostr(TaskInfo.TaskResult);
  StartTimeLabel.Caption:=DateTimetostr(TaskInfo.StartTime);
  FinishTimeLabel.Caption:=DateTimetostr(TaskInfo.FinishTime);
  InfoLabel.Caption:=TaskInfo.Info;
  InNameLabel.Caption:=TaskInfo.InName;
  OutNameLabel.Caption:=TaskInfo.OutName;
  ProgressIDLabel.Caption:=Inttostr(TaskInfo.ProgressID);
  StatusIDLabel.Caption:=Inttostr(TaskInfo.StatusID);
  PriorityIDLabel.Caption:=Inttostr(TaskInfo.PriorityID);
  ErrorIDLabel.Caption:=Inttostr(TaskInfo.ErrorID);
  ErrorInfoLabel.Caption:=TaskInfo.ErrorInfo;
  end else
  begin
  TopPanel.Align:= alNone;  //alClient
  DataPanel.Align:= alNone;
  DataPanel.Visible:= False;
  TopPanel.Align:= alTop;
  dtmTaskDroneForm.Height:=222;//213;
  end
end;
procedure TdtmTaskDroneForm.FormActivate(Sender: TObject);
var  i:Integer;
begin
  edtDroneIP.Text:=Copy(ProgramPort,1,pos(':',ProgramPort)-1);
  edtDronePort.Text:=Copy(ProgramPort,pos(':',ProgramPort)+1,length(ProgramPort));
  Memo1.Text:=''; //Memo1.Clear;
  DetermineTasksAvailable;
  Application.ProcessMessages;
  CollectCPUData; // Get the data for all processors
  For I:= 1 to 2 do
     begin
      CpuSpeedLabel.Caption := Format('%f MHz', [GetCPUSpeed]);
      Application.ProcessMessages;
    end;
end;

procedure TdtmTaskDroneForm.DetermineTasksAvailable;
var i:Integer;
Begin
  {Vector.dll}{Raster}{Geographic }{Information }{Synthesis}
  {Find ALL COMPATABLE dll's and get their
  Verification Number.. to verify ok to go on...
  Drone Dll ID        1.1.1.Name[16]
  TaskInfo.ClientID NAME !
  Number of Tasks     xx.xx.xx.16x = 25 char string
  Drone Task Number ID  .. 99 balloons
    Name of Task  .. place in the memo}

  If (not FileExists(Extractfilepath(ParamStr(0))+'DtmTaskList.txt')) then
  WriteTaskNames;

  Memo1.Lines.LoadFromFile(Extractfilepath(ParamStr(0))+'DtmTaskList.txt');
  {Memo1.SelectAll;
  Memo1.CopyToClipboard;
  Memo1.Text:='';
  Memo1.PasteFromClipboard;}
  Memo1.SetFocus;
  ListBox1.Visible:=True;
  ListBox2.Visible:=True;
  ListBox1.Clear;
  ListBox2.Clear;
  ListBox1.items:=Memo1.Lines;
  For i := 1 to ListBox1.items.Count-1 do
     If ListBox1.items[i]=ListBox1.items[i-1] then
     ListBox1.items[i-1]:='';
  For i := 0 to ListBox1.items.Count-1 do
     If ListBox1.items[i]<>'' then
     ListBox2.items.add(ListBox1.items[i]);
  Memo1.Lines:=ListBox2.items;
  ListBox2.Clear;
  ListBox1.Clear;
    ListBox1.Visible:=False;
    ListBox2.Visible:=False;

  TasksAvailable:=Memo1.Lines.Count;
  TaskLabel.Caption:=Inttostr(TasksAvailable);
  //+' = 'TaskInfo.TaskAvailable;
End;
procedure TdtmTaskDroneForm.Open1Click(Sender: TObject);
begin
  DetermineTasksAvailable;
//RichEdit1.Lines.LoadFromFile(Path);
end;
procedure TdtmTaskDroneForm.Save1Click(Sender: TObject);
var PathS: string;
begin
  Memo1.Lines.SaveToFile(Extractfilepath(ParamStr(0))+'DtmTaskList.txt');
  PathS := ExtractFilePath(Application.EXEName);
  if FileExists(Extractfilepath(ParamStr(0))+'DtmTaskList.txt') then
    ExecuteFile('DtmTaskList.txt', '', PathS, SW_SHOW)
end;
procedure TdtmTaskDroneForm.MakeDefault1Click(Sender: TObject);
begin
  WriteTaskNames;
end;


procedure TdtmTaskDroneForm.Options1Click(Sender: TObject);
begin
  dtmPOFForm.ShowModal;
end;
procedure TdtmTaskDroneForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(1000);
end;
procedure TdtmTaskDroneForm.About1Click(Sender: TObject);
begin
  dtmTaskDroneAboutForm := TdtmTaskDroneAboutForm.Create(Self);
  dtmTaskDroneAboutForm.ShowModal;
end;
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
{---------------------------------------------------------------------}
procedure TdtmTaskDroneForm.edtDroneIPKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then edtDroneIP.PasteFromClipboard else
  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then edtDroneIP.CopyToClipboard;
end;

procedure TdtmTaskDroneForm.edtDronePortKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (ssCtrl in Shift)and ((Chr(Key)='v') or (Chr(Key)='V'))
      then edtDronePort.PasteFromClipboard else
  if (ssCtrl in Shift)and ((Chr(Key)='c') or (Chr(Key)='C'))
      then edtDronePort.CopyToClipboard;
end;

{---------------------------------------------------------------------}
procedure TdtmTaskDroneForm.TimerToggleClick(Sender: TObject);
begin
  CpuTimer.Enabled:=TimerToggle.Checked;
  If CpuTimer.Enabled then
  begin
   { it will Collect CPU data and Post to form every so often}
  end else
  begin
    CpuUseLabel.Caption:='<Not Set>';
  end;
end;

function TdtmTaskDroneForm.GetCPUSpeed: Double;
const
  DelayTime = 500; // measure time in ms
var
  TimerHi, TimerLo: DWORD;
  PriorityClass, Priority: Integer;
begin
  PriorityClass := GetPriorityClass(GetCurrentProcess);
  Priority := GetThreadPriority(GetCurrentThread);
  SetPriorityClass(GetCurrentProcess, REALTIME_PRIORITY_CLASS);
  SetThreadPriority(GetCurrentThread, THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(10);
  asm
    dw 310Fh // rdtsc
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  Sleep(DelayTime);
  asm
    dw 310Fh // rdtsc
    sub eax, TimerLo
    sbb edx, TimerHi
    mov TimerLo, eax
    mov TimerHi, edx
  end;
  SetThreadPriority(GetCurrentThread, Priority);
  SetPriorityClass(GetCurrentProcess, PriorityClass);
  Result := TimerLo / (1000.0 * DelayTime);
end;

procedure TdtmTaskDroneForm.CpuTimerTimer(Sender: TObject);
var i: Integer;
begin
  CollectCPUData; // Get the data for all processors
  for i:=0 to GetCPUCount-1 do // Show data for each processor
        CpuUseLabel.Caption:=Format('CPU #%d - %5.2f%%',[i,GetCPUUsage(i)*100]);
end;


procedure TdtmTaskDroneForm.btnStartClick(Sender: TObject);
var
  i:Integer;
  Binding : TIdSocketHandle;
  {forgot what these are 169.254.126.198:2345,  127.0.0.1:9999}
begin
  For I:= 1 to 3{10} do  {? makes for a Definite LAG time}
  begin
      CpuSpeedLabel.Caption := Format('%f MHz', [GetCPUSpeed]);
      Application.ProcessMessages;
  end;
  //10038
   {It is normal to receive a 10038 exception (10038, NOT others!) here when
    *shutting down* (NOT at other times!) servers (NOT clients!).}


  if btnStart.caption = 'Start' then
  begin
  Binding := IdTCPDrone.Bindings.Add;
  Binding.Port:=StrToInt(edtDronePort.Text);//2345
  //1024 to 65535
  Binding.IP := edtDroneIP.Text;  //169.254.126.197
  {Binding determine IP Address Port 127.0.0.1:xxxx  self}
  IdTCPDrone.active := not IdTCPDrone.active;
  btnStart.caption := 'Stop'
  end
  else if btnStart.caption = 'Stop' then
  begin
  IdTCPDrone.active := not IdTCPDrone.active;
  IdTCPDrone.Bindings.Clear;
  {Binding determine IP Address Port 127.0.0.1:xxxx  self}
  btnStart.caption := 'Start';
  end;
  {Freeze selections}
   edtDroneIP.Enabled := not IdTCPDrone.active;
   edtDronePort.Enabled := not IdTCPDrone.active;
   {Done on form initialization
   DetermineTasksAvailable(IdTCPDrone.active);}
end;


//These are THREADS ..
//Tasking SHOULD be THREADED..
//Does it .. Can it ever report Progress?
procedure TdtmTaskDroneForm.IdTCPDroneExecute(AThread: TIdPeerThread);
var
  I, MessageID      : integer; //cardinal;
begin
  AThread.connection.ReadBuffer(TaskInfo,SizeOf(TaskInfo));
  MessageID:=TaskInfo.Msg;
  case MessageID of
    C2D_MSG_FirstConnect:
    begin
      If TaskInfo.Password = DronePasswordEdit.Text then
      TaskInfo.Msg:=D2C_MSG_AccountValid  else
      TaskInfo.Msg:=D2C_MSG_AccountInvalid;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
    end;
    C2D_MSG_WantConnection    :
    begin
      TaskInfo.Msg:=D2C_MSG_Connected;
      {This serves as a Drone CPU capacity}
      TaskInfo.FinishTime:= GetCPUSpeed;
      {What and HOW MANY tasks are available - Capable ? }
      {Change this to ID each Program/Dll for USE
       Each Dll MUST have its OWN ID ..99 max.. SAME as used for Task List}
       //DTM
      TaskInfo.ClientID:=30;  //DTM is 30
      TaskInfo.DronePort := strtoint(edtDronePort.Text);
      TaskInfo.DroneIP:= edtDroneIP.Text;
      //Drone uses this temporarily
      TaskInfo.TaskAvailable:=TasksAvailable;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
      {Dunno what the True does...
            AThread.connection.WriteBuffer(TaskInfo,SizeOf(TaskInfo),true);}
      for i:=0 to  TasksAvailable-1 do
      begin
        //NOT really a List..ONLY 1 : Info0: string[29];{xx.xx.xx.name}
       TaskList.Info0:= Memo1.Lines[i];
       AThread.Connection.WriteBuffer(TaskList, SizeOf(TaskList));
      end;
    end;
    C2D_MSG_WantDisconnection :
    begin
      //message info "bye"
      TaskInfo.Msg:=D2C_MSG_DisConnected;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
      //disconnect the client
      AThread.Connection.DisconnectSocket;
      {Cancel the App if running  ?}
      TaskCancelProcess:=True;
      {Reset the Start Stop ? to "Clear" things }

    end;
    //C2D_MSG_StartSendingData
    //C2D_MSG_SendBaseData
    C2D_MSG_Task:
    begin
      TaskInfo.Msg:=D2C_MSG_Task;
      TaskInfo.ProgressID:=TaskProgress;{0 at create}
      ProgressLabel.Caption:=inttostr(TaskProgress);
      TaskInfo.StartTime:=Now;
      TaskInfo.FinishTime :=Now;{Clears CPU test}
      TaskData2:=TaskInfo.TaskData2;
      TaskData1:=TaskInfo.TaskData1;
      TaskOutFileName:=TaskInfo.OutName;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
      ProcessMessages(MessageID);
    end;
    C2D_MSG_WantProgress:
    begin
      WantProgress;
      If TaskError then
      begin
        TaskInfo.Msg:=D2C_MSG_Error;
        TaskInfo.ErrorID :=TaskErrorID;
        TaskInfo.ErrorInfo :=TaskErrorInfo;
        TaskInfo.TaskData2 :=GetCPUUsage(0);
        TaskInfo.TaskResult :=TaskResult;
      end else
      If TaskFinished then
      begin
        TaskInfo.Msg:=D2C_MSG_Finished;
        TaskInfo.FinishTime :=TaskInfoFinishTime;
        TaskInfo.TaskData2 :=GetCPUUsage(0);
        TaskInfo.TaskResult :=TaskResult;
        TaskInfo.OutName :=TaskOutFileName;
      end else
      If TaskProgress < 100 then
      begin
        TaskInfo.Msg:=D2C_MSG_Progress;
        TaskInfo.ProgressID:=TaskProgress;

        TaskInfo.TaskData2 :=GetCPUUsage(0);
        TaskInfo.TaskResult :=TaskResult;
      end;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
    end;
   C2D_MSG_Priority :
    begin
      TaskInfo.Msg:=D2C_MSG_Priority;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
       //  Change the Task Priority
    end;
   C2D_MSG_Cancel :
    begin
      TaskInfo.Msg:=D2C_MSG_Cancel;
      TaskInfo.TaskData2 :=GetCPUUsage(0);
      TaskInfo.FinishTime :=Now;
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));

         {Cancel the App if running  ?}
      TaskCancelProcess:=True;
      {Reset the Start Stop ? to "Clear" things }

    end;
   C2D_MSG_WantUsage:
    begin
      TaskInfo.Msg:=D2C_MSG_WantUsage;
      { for THIS DRONE }
      CollectCPUData;
      TaskInfo.TaskData2 :=GetCPUUsage(0);
      AThread.Connection.WriteBuffer(TaskInfo, SizeOf(TaskInfo));
    end;
  end;
end;


procedure TdtmTaskDroneForm.ProcessMessages(MessageID:Integer);
Begin
  Timer1.Enabled:=True; {Maybe just do some Application.ProcessMessages}
End;

procedure TdtmTaskDroneForm.Timer1Timer(Sender: TObject);
begin
  Timer1.Enabled:=False; {Time tunnel transfer: 1 second delay}
  RunProgram;
end;

procedure TdtmTaskDroneForm.RunProgram;
Begin
  TaskProgress:=0;
  TaskErrorID:=0;
  TaskErrorInfo:='';
  TaskError:=False;
  TaskFinished:=False;
  TaskCancelProcess:=False;
  ProcessTask;
end;

procedure TdtmTaskDroneForm.ProcessTask;
var
  TaskID: Integer;
  InName:String;
Begin
  DroneTask.Caption:=TaskInfo.Name;
  If (TaskStatus =99) then
  begin
    InName:=ParamStr(1);
    TaskID:=strtoint(ParamStr(2));
  end else
  begin
    TaskID:=TaskInfo.TaskIDn;
    InName:=TaskInfo.InName;
  end;
  //Showmessage(TaskInfo.Name +'..'+inttostr(TaskID)+'..'+InName );
  Case TaskID of
  0: RepeatUntilTaskCanceledTask;
  1: dtmHtfForm.DoDem24kListClick(InName);
  2: dtmHtfForm.DoDem250kListClick(InName);
  3: dtmHtfForm.DoSRTM1ListBtnClick(InName);
  4: {begin HtfForm.show; }dtmHtfForm.DoSRTM3ListBtnClick(InName);{end; }

  5: dtmHtfForm.ProcessTpcfg(InName);
  6:
    begin
      DTMform.DoAllLoad(InName);
      TaskFinished:=True;
      TaskInfoFinishTime :=Now;
    end;
  {TaskCancelProcess
        TaskFinished:=True;
      TaskInfoFinishTime :=Now;
      TaskProgress :=   CountIn div CountAll;
    TaskError:=True;
    TaskErrorID:=TaskProgress;
   TaskErrorInfo:=S;
or TaskCancelProcess or TaskError       }
  End;//Case
End;
//Needs work.. Result never used
//Automate the Numbering so they do NOT have to be changed if 1 is added
procedure  TdtmTaskDroneForm.WriteTaskNames;
var
  F: TextFile;
  CurrentCount:Integer;
  HeadStr:String;
Begin                {application.exename}
  AssignFile(F, Extractfilepath(ParamStr(0))+'DtmTaskList.txt');
  Rewrite(F);{Reset(F);}
 { xx.xx.xx.20x = 29 char string
  >TaskInfo.ClientID
  >Number of Tasks
  >Drone Task Number ID  .. 99 balloons
  >Name of Task  .. place in the memo}
  CurrentCount:=0;
  HeadStr:= inttostr(30)+'.' //DTM  is 30
           +inttostr(6)+'.';  //Manually change when tasks added
  //Test Task
  Writeln(F,HeadStr+inttostr(CurrentCount)+'.'
           +'RepeatUntilCanceled ');
  //DoDem24kListClickS1 DoDem24kListClick(DoFileName:String);
  inc(CurrentCount);
  Writeln(F,HeadStr+inttostr(CurrentCount)+'.'
           +'DoDem24kListClickS1');
  //DoDem250kListClickS1 DoDem250kListClick(DoFileName:String);
  inc(CurrentCount);
  Writeln(F,HeadStr+inttostr(CurrentCount)+'.'
           +'DoDem250kListClickS1');

  inc(CurrentCount);
  Writeln(F,HeadStr+inttostr(CurrentCount)+'.'
           +'DoSRTM1ListBtnClickS');
  //DoSRTM3ListBtnClick(inS : string);
  inc(CurrentCount);
  Writeln(F,HeadStr+inttostr(CurrentCount)+'.'
           +'DoSRTM3ListBtnClickS');
  //DoTpcfgOpenS1  DoTpcfgOpen(ODTerrainPack.FileName);
      //ACProcessExecute(Sender: TObject);
  inc(CurrentCount);
  Writeln(F,HeadStr+inttostr(CurrentCount)+'.'
           +'DoTpcfgOpenS1');
  //DoAllLoadS1  DoAllLoad(OpenDialog.FileName);
  inc(CurrentCount);
  Writeln(F,HeadStr+inttostr(CurrentCount)+'.'
           +'DoAllLoadS1');
  CloseFile(F);
End;


procedure TdtmTaskDroneForm.WantProgress;
Begin
  iF TaskError then
  begin
    //set by task
    //TaskErrorID:=TaskProgress;
    //TaskErrorInfo:=S;
  end else
  begin
  Case TaskProgress of
    0..99:
      begin
        ProgressLabel.Caption:=inttostr(TaskProgress);
      end;
    100:
    begin
      ProgressLabel.Caption:=inttostr(0);
      //TaskFinished:=True;
      //TaskInfoFinishTime :=Now;
    end;
  end;{case}
  If TaskProgress < 0 then
  begin
    TaskError:=True;
    TaskErrorID:=TaskProgress;
    {Need to Really get an ErrorString Res file}
    Case  TaskProgress of
      -1:TaskErrorInfo:='Too close to call';
      -101:TaskErrorInfo:='Houston, We have a Problem';
      else TaskErrorInfo:=Inttostr(TaskErrorID);
    end;
  end;
  end;
End;

procedure TdtmTaskDroneForm.RepeatUntilTaskCanceledTask;
var I:Integer;
Begin
  Repeat
  begin
    For I:= 1 to 99 do
    begin
    Application.ProcessMessages;
      //Normally this would be here...
      //If TaskCanceled then {Close Gracefully ?}exit;
      TaskProgress:=I;
      ProgressLabel.Caption:=inttostr(TaskProgress);
      Sleep(50);

      If I < 0 then
      begin
        TaskError:=True;
        exit;
      end;
    end;
    //TaskFinished:=True;
    //TaskInfoFinishTime :=Now;
    //THIS one NEVER finishes unless STOPPED
  end until TaskCancelProcess
End;




end.
