{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
{          Digital Terrain Mapping Main Form            }
{7 heads I L H, Voice, Grip,  VR GIS, DTM, Fractal, Life
10 horns       Tracer, Tongs,  SOS MAP
   SOS MAP consumed Fractal, Life .. became a Head w/3 horns
   I L H grew 3 horns.. so has 4
   Voice has 2,
   Grip has 2,
   VR GIS consumed DTM so has 2
5 Heads 13 horns

   VR GIS  is the G

10: Voice ..Tracer
20: Grip ..Tongs
30: DTM............VR GIS
40: I L H  .. I L H
50: SOS MAP ..Fractal, Life}
// dsgnintf.pas in 'C: \Program Files\Borland\Delphi5\Source\Toolsapi\dsgnintf.pas'

{*******************************************************}
unit dtmfrm;
{: GLScene:
   Basic viewer for HTF Content.<p>
   Gives basic time stats for HTF data extraction and rendering (there is NO
   cache, each tile is reloaded each time from the disk, ie. those are the
   timings you could expect when accessing an HTF area for the first time or
   when "moving at high speed").<p>
   Requires the Graphics32 library (http://www.g32.org)..now... GR32}
  {GLSViewerFrm requires Graphex by Lischke}
  {Database requires TDBF 6.3 and BDE... MemDB? anything to do Blob:images}
   {HTF requires Zip library}
(*  Changed March..August 2002,
          V14  Nov..Dec 2003,
          V15  ...Jan 2004
          V16  Aug..Sep 2004
          V17  Oct..Nov 2004
    by Ivan Lee Herring
  dtmfrm in 'dtmfrm.pas' {DTMform},                              1000
    dtmGlobals in 'dtmGlobals.pas',
       dtmPOFvar,
       dtmErrMsg,
       aclass5 in '..\common\aclass5.pas',
    AllSplash in '..\common\AllSplash.pas' {SplashScreen};
    dtmPOFrm in 'dtmPOFrm.pas' {dtmPOFForm},                     50
    dtmAbout in 'dtmAbout.pas' {AboutDTM},                       222
    dtmLOSProfile in 'dtmLOSProfile.pas' {LineProfileForm}        12000
    dtmSysInfo in 'dtmSysInfo.pas' {SystemInfoForm},              13000

  dtmHtfFrm in 'dtmHtfFrm.pas' {HtfForm},                        2001
    dtmNavFrm in 'dtmNavFrm.pas' {NavForm},                      3000
    AllShapeLoaderFrm in '..\common\AllShapeLoaderFrm.pas' {ShapeLoaderForm},
                                                       ( Dbf, Db, DBTables;)
    DtmShpSaver in 'DtmShpSaver.pas',  includes
      dtmProgressForm
    dtmgrdfuncs in 'dtmgrdfuncs.pas',
      dtmcommasplit in 'dtmcommasplit.pas',
      dtmgridimportfn in 'dtmgridimportfn.pas',
    dtmSdtsReader in 'dtmSdtsReader.pas';
      DSpGlobals,
      DSpSDTS_RPE,
      DSpUtils,
      DSpSDTS,
      DSpISO8211,
    dtmHtfDem24kFrm in 'dtmHtfDem24kFrm.pas' {dtmHtfDem24kForm}, mostly a Progress bar
    dtmHtfDTEDFrm in 'dtmHtfDTEDFrm.pas' {dtmHtfDTEDForm};       mostly a Progress bar
  dtmHTFDEMListMakerFrm in 'dtmHTFDEMListMakerFrm.pas' {dtmHTFDEMListMakerForm},
  dtmHdsFrm in 'dtmHdsFrm.pas' {dtmHdsForm};
    dtmRIFImageViewerFrm in 'dtmRIFImageViewerFrm.pas'
                           {RIFImageViewerForm};                14000 ?
      dtmRasterImageFile in 'dtmRasterImageFile.pas',      duped from HTF
  dtmGlFrm in 'dtmGlFrm.pas' {DTMGLForm},                      4567
    dtmGLSAboutFrm in 'dtmGLSAboutFrm.pas' {dtmGLSAboutForm},
  dtmGlHeight in 'dtmGlHeight.pas' {dtmGlHeightForm}           4321
  dtmHdsFrm in 'dtmHdsFrm.pas' {dtmHdsForm}, TerrainRenderer   4949
  dtmHdsSunConfigFrm in 'dtmHdsSunConfigFrm.pas' {dtmGlHdsSunConfigForm},
  dtmJoy in 'dtmJoy.pas' {dtmJoyForm}                          4444
  dtmIMFrm in 'dtmIMFrm.pas' {ImageMakerForm}                  5678
  dtmDTPFrm in 'dtmDTPFrm.pas' {dtmDTPForm},                   6000
    dtmDtpReader in 'dtmDtpReader.pas',
  dtmEcotypeColorsFrm in 'dtmEcotypeColorsFrm.pas'
                       {dtmEcotypeColorsForm};
                       DTP Project (Legend) part 2
    includes the Db and 3 Reports                               6500
         dtmEcoDbForm                                           6996
         dtmEcoDbReportForm
         dtmEcoDbCSReportForm
         dtmEcoDbCSForm
         dtmEcoReader
  dtmDbFrm in 'dtmDbFrm.pas' {dtmDbForm}                       7000
  dtmDbAboutFrm in 'dtmDbAboutFrm.pas' {dtmDbAboutForm},   Db Component ?
  AllDbAboutFrm in '..\common\AllDbAboutFrm.pas' {allDbAboutForm},  ?
  dtmSmdQcFrm in 'dtmSmdQcFrm.pas' {dtmSmdQcForm},               8000
  dtmSmdLoadMdlFrm in 'dtmSmdLoadMdlFrm.pas' {dtmSmdLoadMdlForm},8500
    USMDStuff.pas
  dtmPanVizFrm in 'dtmPanVizFrm.pas' {dtmPanVizForm},            9000
  dtmImageRGB in 'dtmImageRGB.pas' {DtmImageRGBForm};           10000
  dtmImageDotRGB in 'dtmImageDotRGB.pas' {DtmImageDotRGBForm},  10500
  t3de in 't3de.pas'                             {t3dForm},
    Texture_3D_Unit in 'Texture_3D_Unit.pas',
  t3de1 in 't3de1.pas'                            {t3de1Form},
  dtmGLSViewerFrm in 'GLSViewerFrm.pas' {GLSViewerForm}         11000
                                         {dtmGLSViewerAboutForm},
 ULightMapTools in 'ULightMapTools.pas',
  UFInfo in 'UFInfo.pas' {FInfo},
  UFrmLightmapFaceGroups in 'UFrmLightmapFaceGroups.pas' {FrmLightmapFaceGroups},
  UFrmLMMWizard in 'UFrmLMMWizard.pas' {frmLMMWizard},
  dtmGLSTreeFrm in 'dtmGLSTreeFrm.pas' {dtmGLSTreeForm},        22000
  dtmGLSTrealFrm in 'dtmGLSTrealFrm.pas' {dtmGlsTrealForm},   ..HAS ITS OWN HELP
  dtmGlsTrealAboutFrm in 'dtmGlsTrealAboutFrm.pas' {dtmGlsTrealAboutForm},
  dtmGlsTrealProgressFormUnit in 'dtmGlsTrealProgressFormUnit.pas' {dtmGlsTrealProgressForm},
  dtmGlsTrealViewBitmapFrm in 'dtmGlsTrealViewBitmapFrm.pas' {dtmGlsTrealViewBitmapForm},
  dtmGlsTrealViewerFrm in 'dtmGlsTrealViewerFrm.pas' {dtmGlsTrealViewerForm},
  GlsLSystemFrm in 'GlsLSystemFrm.pas' {LSystemForm},            3100..3111
  GlsMathingsFrm in 'GlsMathingsFrm.pas' {MathingsForm},         3500
  fjul in 'fjul.pas' {FMJForm},                          1001 1002
  GlsFractalFrm in 'GlsFractalFrm.pas' {FractalForm};  21000..21900
  SELDIRHELP = 120;
  HDS  15000
  Task Drone 16000
  Gizmo 17000  17500
  Zip       18000
*)

{gridlines,
 coordinate conversion,
 SCALE of Terrain and thus Data/Actor}
{procedure THtfForm.ReadAnyVersionProj(ReadFileName:String);
procedure THtfForm.ReadVersionProj(ReadFileName:String);
procedure THtfForm.ReadVer1Proj(ReadFileName:String);

procedure THtfForm.WriteProjectionFile(InfileName:String);
procedure THtfForm.WriteBitFile(InfileName:String);
procedure THtfForm.WriteTpcfgFile(InfileName:String);}

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms,  
  Dialogs,  ActnList, ExtDlgs,
  StdCtrls, ExtCtrls, ComCtrls, ImgList,
  Menus, ToolWin,  
  VectorGeometry,
  GLUtils,//StrtoFloatDef
  HeightTileFile,  {HTF file access}
  GR32, GR32_Layers, GR32_Polygons, GR32_Image;

const
  DataLimit = 9;
type
  ScoreList = array[1..DataLimit] of Real;

  TNode =Record
    Position: TVector;
    Scale: TVector;
    Rotation: TVector;
    Speed: single;
    NodeNumber : Integer;
    //FTarget   := CurrentTargetLocation
   end;
type
  TDTMform = class(TForm)
    ToolBar: TToolBar;
    ImageList: TImageList;
    ActionList: TActionList;
    OpenTB: TToolButton;
    LAMap: TLabel;
    ToolButton2: TToolButton;
    ACOpen: TAction;
    ACExit: TAction;
    ExitTB: TToolButton;
    OpenDialog: TOpenDialog;
    ToolButton4: TToolButton;
    TBGrid: TToolButton;
    ToolButton5: TToolButton;
    NavMapTB: TToolButton;
    ACNavMap: TAction;
    StatusBar: TStatusBar;
    PalettesTB: TToolButton;
    ACPalette: TAction;
    PMPalettes: TPopupMenu;
    OpenDialogPal: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    View1: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    OnHelp1: TMenuItem;
    Me1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    Navigator1: TMenuItem;
    Options1: TMenuItem;
    N2: TMenuItem;
    HTFpack1: TMenuItem;
    HintsPanel: TPanel;
    Grid1: TMenuItem;
    OpenShape1: TMenuItem;
    Image321: TImage32;
    SetDtp1: TMenuItem;
    Imagemaker1: TMenuItem;
    DemDblist1: TMenuItem;
    ElevationTint1: TMenuItem;
    SlopeTint1: TMenuItem;
    ContourLines1: TMenuItem;
    Tools1: TMenuItem;
    LOSMaskedArea1: TMenuItem;
    ContourLines21: TMenuItem;
    ContourLinesAll1: TMenuItem;
    SlopeDirectional1: TMenuItem;
    RagDoll1: TMenuItem;
    Panaviewer1: TMenuItem;
    N5: TMenuItem;
    SlopeSetDirection1: TMenuItem;
    Image3DHistogram1: TMenuItem;
    Image3DdotHistogram1: TMenuItem;
    ProgressBar1: TProgressBar;
    GLSViewer1: TMenuItem;
    N6: TMenuItem;
    RIFImageViewer1: TMenuItem;
    N8: TMenuItem;
    SaveDtp1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Redraw1: TMenuItem;
    N9: TMenuItem;
    Ecotype1: TMenuItem;
    OpenPictureDialog: TOpenPictureDialog;
    OpenDtp1: TMenuItem;
    N11: TMenuItem;
    SetEcoColors1: TMenuItem;
    SlopePercent1: TMenuItem;
    AutorangePalette1: TMenuItem;
    AutoColorDialog: TColorDialog;
    N12: TMenuItem;
    SelectAutoColor1: TMenuItem;
    AutoColorShape: TShape;
    N13: TMenuItem;
    tx3RGB3D: TMenuItem;
    Image3D: TMenuItem;
    N14: TMenuItem;
    ReopenHTF1: TMenuItem;
    Reopen0: TMenuItem;
    Reopen1: TMenuItem;
    Reopen2: TMenuItem;
    Reopen3: TMenuItem;
    Reopen4: TMenuItem;
    LOSLineAtoB1: TMenuItem;
    SlopeDirectional901: TMenuItem;
    DrawShapes1: TMenuItem;
    OpenDTM1: TMenuItem;
    PrintdtpDTMProject1: TMenuItem;
    N3: TMenuItem;
    TaskDrone1: TMenuItem;
    N3dRGBViewers1: TMenuItem;
    N7: TMenuItem;
    Path1: TMenuItem;
    PathStart1: TMenuItem;
    PathFinish1: TMenuItem;
    PathLoad1: TMenuItem;
    PathSave1: TMenuItem;
    PathGizmo1: TMenuItem;
    ZipUnzip1: TMenuItem;
    N3DViewers1: TMenuItem;
    ShiftClickaTile1: TMenuItem;
    CtrlClickTilesOnScreen1: TMenuItem;
    ShiftCtrlClickViewFullHTFHDS1: TMenuItem;
    AltClickSnapshotofScreen1: TMenuItem;
    ShiftAltClick1: TMenuItem;
    CtrlAltClick1: TMenuItem;
    CtrlAltShiftClick1: TMenuItem;
    Editors1: TMenuItem;
    GLSTree1: TMenuItem;
    GLSTreal1: TMenuItem;
    N15: TMenuItem;
    N16: TMenuItem;
    LSystem1: TMenuItem;
    Mathings1: TMenuItem;
    Fractal1: TMenuItem;
    F21: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    PathSaveasshp1: TMenuItem;
    PathNewClear1: TMenuItem;
    Zoom1: TMenuItem;
    CtrlClicknada1: TMenuItem;
    N20: TMenuItem;
    CtrlAltClicknada1: TMenuItem;
    CtrlAltShiftClicknada1: TMenuItem;
    UsedforZOOM1: TMenuItem;
    N1DegreeGrid1: TMenuItem;
    GridperHtfRez1: TMenuItem;
    PalletteTints1: TMenuItem;
    DeLaunayVoroni1: TMenuItem;
    DVLoad1: TMenuItem;
    DVSave1: TMenuItem;
    DVStart1: TMenuItem;
    DVFinish1: TMenuItem;
    DVNewClear1: TMenuItem;
    N4: TMenuItem;
    DVDeLaunay1: TMenuItem;
    DVVoronoi1: TMenuItem;
    N10: TMenuItem;
    DV2DEditor1: TMenuItem;
    DVPoints1: TMenuItem;
    DVConvexHull1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

procedure ShowHint(Sender: TObject);
procedure DisplaySplashScreen;
    procedure ACExitExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormKeyPress(Sender: TObject; var Key: Char);

{here}
    procedure Reopen0Click(Sender: TObject);
    procedure Reopen1Click(Sender: TObject);
     procedure Reopen2Click(Sender: TObject);
    procedure Reopen3Click(Sender: TObject);
    procedure Reopen4Click(Sender: TObject);
procedure ResetFileMenu;

    procedure ACOpenExecute(Sender: TObject);
    procedure OpenDTM1Click(Sender: TObject);
    procedure OpenDtp1Click(Sender: TObject);
procedure DoAllLoad(AFilename:String);
procedure DoLoad(AFilename:String);

procedure DodtpLoad(InDtmFilename:String);
//moved to dtmdtmReadr.pasprocedure DodtmMapLoad(InDtmFilename:String);
    procedure PrintdtpDTMProject1Click(Sender: TObject);
procedure DoSavePrintedDtmProject(Filename:String);
    procedure SaveDtp1Click(Sender: TObject);
procedure DoSaveDtmProject(Filename:String);

    procedure PrepareBitmap;
procedure PrepareTerrainBitmap;
procedure PrepareBigBitmap;
procedure PrepareTileBitmap;
procedure PrepTints(Xwin,Yhin:Integer);
procedure SortItQuick(Count: Integer; var Item: ScoreList);
procedure PrepContour1(Xwin,Yhin:Integer);
procedure PrepContourAll(Xwin,Yhin:Integer);
procedure PrepContour2(Xwin,Yhin:Integer);
procedure PrepLOSArea(Xwin,Yhin:Integer);
procedure PrepEcoType(Xwin,Yhin:Integer);

    procedure TBGridClick(Sender: TObject);
    procedure ACNavMapExecute(Sender: TObject);
    procedure ACNavMapUpdate(Sender: TObject);
    procedure ACPaletteExecute(Sender: TObject);
    procedure AutoColorShapeMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AutorangePalette1Click(Sender: TObject);
    procedure SelectAutoColor1Click(Sender: TObject);
procedure DoAutorangePalette;

    procedure HTFpack1Click(Sender: TObject);

    procedure Options1Click(Sender: TObject);
    procedure Contents1Click(Sender: TObject);
    procedure OnHelp1Click(Sender: TObject);
    procedure Me1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);

    procedure OpenShape1Click(Sender: TObject);
Function NewLayer:Boolean; {Calls AllShapeLoaderFrm}
    procedure DrawShapes1Click(Sender: TObject);
procedure DVDORedraw;
    procedure Redraw1Click(Sender: TObject);

    procedure Image321Resize(Sender: TObject);
    procedure Image321MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure Image321MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer; Layer: TCustomLayer);
    procedure Image321MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);

    procedure SetDtp1Click(Sender: TObject);
    procedure Imagemaker1Click(Sender: TObject);
    procedure DemDblist1Click(Sender: TObject);
procedure AllBtnsUp;
    procedure ElevationTint1Click(Sender: TObject);
    procedure SlopeTint1Click(Sender: TObject);
    procedure SlopeDirectional1Click(Sender: TObject);
    procedure SlopeDirectional901Click(Sender: TObject);
    procedure SlopeSetDirection1Click(Sender: TObject);
    procedure SlopePercent1Click(Sender: TObject);
    procedure ContourLines1Click(Sender: TObject);
    procedure ContourLines21Click(Sender: TObject);
    procedure ContourLinesAll1Click(Sender: TObject);

    procedure Ecotype1Click(Sender: TObject);
    procedure SetEcoColors1Click(Sender: TObject);
    procedure LOSLineAtoB1Click(Sender: TObject);
    procedure LOSMaskedArea1Click(Sender: TObject);
procedure DoLOSint(LOSintin,X,Y:Integer);
{procedure LineofSightArea;}

    procedure RagDoll1Click(Sender: TObject);
    procedure Panaviewer1Click(Sender: TObject);
    procedure Image3DHistogram1Click(Sender: TObject);
    procedure Image3DdotHistogram1Click(Sender: TObject);

    procedure TaskDrone1Click(Sender: TObject);
    procedure GLSViewer1Click(Sender: TObject);
    procedure RIFImageViewer1Click(Sender: TObject);


    procedure tx3RGB3DClick(Sender: TObject);
    procedure Image3DClick(Sender: TObject);


    procedure PathStart1Click(Sender: TObject);
    procedure PathFinish1Click(Sender: TObject);
    procedure PathLoad1Click(Sender: TObject);
    procedure PathSave1Click(Sender: TObject);
    procedure PathGizmo1Click(Sender: TObject);
    procedure ZipUnzip1Click(Sender: TObject);
    procedure GLSTree1Click(Sender: TObject);
    procedure GLSTreal1Click(Sender: TObject);
    procedure LSystem1Click(Sender: TObject);
    procedure Mathings1Click(Sender: TObject);
    procedure Fractal1Click(Sender: TObject);
    procedure F21Click(Sender: TObject);
    procedure PathSaveasshp1Click(Sender: TObject);
    procedure PathNewClear1Click(Sender: TObject);
    procedure DV2DEditor1Click(Sender: TObject);
    procedure DVNewClear1Click(Sender: TObject);
    procedure DVLoad1Click(Sender: TObject);
    procedure DVStart1Click(Sender: TObject);
    procedure DVFinish1Click(Sender: TObject);
    procedure DVSave1Click(Sender: TObject);
    procedure DVDeLaunay1Click(Sender: TObject);
    procedure DVVoronoi1Click(Sender: TObject);
    procedure DVPoints1Click(Sender: TObject);
    procedure DVConvexHull1Click(Sender: TObject);

  private
    { Private declarations }
    BusyDrawing,
    Firsttime, LOSQuit:Boolean;
    {BackClipBitmap,// Not needed HERE
       is used to load a Project file in other program}
    bmpTile : TBitmap32;  {Used for each small tile}
                          {big tiled image is Image321's}
    GPFNodes: Array of TNode;
    CurrentRezLevel,
    TotalNodes:Integer;
    curX, curY, mx, my : Integer;{Mouse locations}
  public
    { Public declarations }
     Canvas: TCanvas;
     Dragging: Boolean;
//  heightColor : array [Low(SmallInt)..High(SmallInt)] of TColor32;

  end;

var
  DTMform: TDTMform;
  DataItem: ScoreList;
  LOSint,NumberOfScores1: Integer;
  heightColor : array [Low(SmallInt)..High(SmallInt)] of TColor32;

implementation

{$R *.dfm}

uses Registry,
     AllSplash,
     dtmGlobals,
     dtmPOFrm,
     dtmPOFvar,
     dtmAbout,

     AllShapeLoaderFrm,
     dtmDbFrm,
     dtmErrMsg,
     dtmNavFrm,
     dtmHtfFrm,
     dtmRIFImageViewerFrm,
     dtmSdtsReader,{SDTS}
     dtmIMFrm,
     dtmDTPFrm,
     dtmDtpdtmreader, {Dtm}
     dtmHdsFrm,
     DtmGlfrm, dtmGlHeight,
     dtmGLSViewerFrm,
     dtmSmdQcFrm,
     dtmSmdLoadMdlFrm,
      t3de, t3de1,
     dtmImageRGB, dtmImageDotRGB,
     dtmPanVizFrm,
     dtmLOSProfile,
     dtmEcotypeColorsFrm, dtmEcoReader,
   //  dtmTaskDroneFrm,
     dtmPathGizmoFrm,
     ZipFrm,

     GlsLSystemFrm,      //TreeConstants, GlsLsysTurtlep
     GlsMathingsFrm,
     GlsFractalFrm,
     // fjul,
     dtmGLSTrealFrm, //GlsTreeDemoFrm,
     dtmGLSTreeFrm, dtmDvFrm;

{ Quick'n dirty parser for palette file format '.pal',
  in which each line defines
  nodes in the color ramp palette:
             value:red,green,blue
  color is then interpolated between node values
     (ie. between each line in the file)}
procedure PreparePal(const fileName : String);
   procedure ParseLine(buf : String; var n : Integer; var c : TAffineVector);
   var
      p : Integer;
   begin
      p:=Pos(':', buf);
      n:=StrToInt(Copy(buf, 1, p-1)); buf:=Copy(buf, p+1, MaxInt);
      p:=Pos(',', buf);
      c[0]:=StrToInt(Copy(buf, 1, p-1)); buf:=Copy(buf, p+1, MaxInt);
      p:=Pos(',', buf);
      c[1]:=StrToInt(Copy(buf, 1, p-1)); buf:=Copy(buf, p+1, MaxInt);
      c[2]:=StrToInt(buf);
   end;
var
   prev, next : Integer;
   pC, nC : TAffineVector;
   procedure Ramp;
   var
      cur : Integer;
      cC : TAffineVector;
      d : Single;
   begin
      if prev<next then
         d:=1/(next-prev)
      else d:=0;
      for cur:=prev to next do
      begin
         cC:=VectorLerp(pC, nC, (cur-prev)*d);
         heightColor[cur]:=Color32(Round(cC[0]), Round(cC[1]), Round(cC[2]));
      end;
   end;
var
   i : Integer;
   sl : TStrings;
begin
   sl:=TStringList.Create;
   try
      sl.LoadFromFile(fileName);
      prev:=0;
      pC:=NullVector;
      for i:=0 to sl.Count-1 do
      begin
         ParseLine(sl[i], next, nC);
         Ramp;
         prev:=next;
         pC:=nC;
      end;
   finally
      sl.Free;
   end;
end;


procedure TDTMform.FormCreate(Sender: TObject);
var
   reg : TRegistry;
   shellCmd : String;
   keyOkay : Boolean;
const
   cKeyName : String = 'Applications\dtm.exe\shell\open\command';
   cFriendlyKeyName : String = 'Applications\dtm.exe';
var
   i,ii : Integer;
   sr : TSearchRec;
   mi : TMenuItem;
   sl : TStringList;
   Helps: string;
begin
  If (not SkipIntroScreen) then DisplaySplashScreen;
  if FileExists(ExtractFilePath(ParamStr(0)) + 'dtm.pof') then
  begin
    DoLoader;
  end else
  begin
    StartedNameNumber := 'Not Registered';
//    StartedNameNumber := 'alle alle in free'; {F3197432-460875}    
    Started := Date;
    Colorreg := 32;
    RandSeed:=8111953;
    Helps:='';
    HiddenString:=
      'DTM 1.6 Copyright, 2004: Ivan Lee Herring ';
    For i:=length(HiddenString) to 255 do   //255-42=213
    Helps:= Helps + char(random(128)+32);
    HiddenString:= HiddenString+Helps;
    ResetToDefaults;
    DoSaver;
  end; {of pof file, start of normal initialize}
BusyDrawing:=False;
  top := DTMformY;
  left := DTMformX;{  Version:='1.1';  moved to Global Const}
  
  Reopen0.Caption:= '&0 '+ OldFileName0;
  Reopen1.Caption:= '&1 '+ OldFileName1;
  Reopen2.Caption:= '&2 '+ OldFileName2;
  Reopen3.Caption:= '&3 '+ OldFileName3;
  Reopen4.Caption:= '&4 '+ OldFileName4;
  LOSQuit:=False;
  ProgramPath := ExtractFilePath(ParamStr(0));
  OpenDialog.InitialDir := ProgramPath;
  ForceCurrentDirectory := True;//i dont like My Documents folder
  {Get App Location to load Help}
  Helps := ProgramPath + 'dtm.HLP';
  Application.HelpFile := Helps;
  Application.OnHint := ShowHint;
  ProgressBar1.Visible:=False;
  ProjectRobotRldFilename:= NoName;
  isRunningOnDtp:=False;//dtmGlobals .. used in dtmGlHeight to load shape..project
  isReallyGone:=False;
  isHTFLoaded:=False;
  CurrentRezLevel:=0;//None loaded yet, Range 1..11
  Dragging := False;
  NoGLRunning:=True;
  LOSint:=0;
  DShiftOffsetX:=0;
  DShiftOffsetY:=0;
  MaxOffsetX:=0;
  MaxOffsetY:=0;
  MinimumElevation:=0;
  MaximumElevation:=0;
  AutoMinimumElevation:=32767;   //Set so processing Makes it smaller
  AutoMaximumElevation:= -32768;
  AutoDefaultZ:=32767; //Why so HIGH?
  SetLength(ManMatrix,10,10);//So other forms have something to eat
  Randomize;
  For i:=0 to 9 do
    For ii:=0 to 9 do
      ManMatrix[i,ii]:= Random(100);
  SetLength(EcoRecord, 10, 10);
  SetLength(LayA,0);
  SetLength(LayersControlArray,0);
  SetLength(ShapesFoundArray,0);
  Setlength(GPFNodes,0);
  bmpTile:=TBitmap32.Create;
  Image321.SetupBitmap;
  Image321.Bitmap.Clear(clWhite32);
  Canvas := TCanvas.Create; // create a new independent TCanvas object
  Canvas.Handle := Image321.Bitmap.Handle; // attach it to the Bitmap32 object
  LayersLoaded:=0;
  OpenShape1.Enabled:=False;
  SetDtp1.Enabled:=False;
  PrintdtpDTMProject1.Enabled:=False;

  Imagemaker1.Enabled:=False;
  HTFPaletteName:=ProgramPath+ 'Blue-Green-Red.pal'; //used by DTP loader only
  DtmHtfDisplay:=0;  //used by DTP loader only
  PreparePal(ProgramPath+'Blue-Green-Red.pal');
  i:=FindFirst(ProgramPath+'*.pal', faAnyFile, sr);
  sl:=TStringList.Create;
  try
    while i=0 do
    begin
      sl.Add(sr.Name);
      i:=FindNext(sr);
    end;
    sl.Sort;
    for i:=0 to sl.Count-1 do
    begin
      mi:=TMenuItem.Create(PMPalettes);
      mi.Caption:=Copy(sl[i], 1, Length(sl[i])-4);
      mi.Hint:=ProgramPath+sl[i];
      mi.OnClick:=ACPaletteExecute;
      PMPalettes.Items.Add(mi);
    end;
  finally
    sl.Free;
    FindClose(sr);
  end;

  If VoicesON then {else dont load the dll s }
  begin
  MMSysHandle := LoadLibrary('WINMM.DLL');
  if (MMSysHandle <> 0) then
  begin
    @PlaySound := GetProcAddress(MMSysHandle, 'sndPlaySoundA');
  end else
  begin
    MMSysHandle := LoadLibrary('MMSYSTEM.DLL');
    if (MMSysHandle <> 0) then
    begin
      @PlaySound := GetProcAddress(MMSysHandle, 'sndPlaySound');
    end;
  end;
  if (MMSysHandle = 0) then DoMessages(22222);
       {22222, "WINMM.DLL or MMSYSTEM.DLL required for Sound"}
  end;
   // register as an application that handles arbitrary file classes
   //How to Register File types TO HANDLE?
   //moved from from GLSViewer...
   If RegisterFileTypes then
   begin
     try
      reg:=TRegistry.Create;
      try
   {cKeyName : String = 'Applications\dtm.exe\shell\open\command';
   cFriendlyKeyName : String = 'Applications\dtm.exe';}
         shellCmd:='"'+Application.ExeName+'" "%1"';
         reg.RootKey:=HKEY_CLASSES_ROOT;
         keyOkay:=False;
         if reg.OpenKeyReadOnly(cKeyName) then
            keyOkay:=(reg.ReadString('')=shellCmd);
         if not keyOkay then begin
            reg.CloseKey;
            if reg.OpenKey(cKeyName, True) then
               reg.WriteString('', shellCmd);
            reg.CloseKey;
            if reg.OpenKey(cFriendlyKeyName, True) then
               reg.WriteString('FriendlyAppName', 'dtm, OpenGL 3D Files Viewer');
         end;
      finally
         reg.Free;
      end;
   except
      // ignore all registry issues (not critical)
   end;
   end; //RegisterFileTypes
  Firsttime:=True; //FormShow thingy :Loads Command Line Files OR VR GIS Tasks
  //VR GIS Task Processing Globals... Set in the FormShow
  TaskFinished:=False;TaskError:=False; TaskCancelProcess:=False;
  TaskData2:=0;  TaskData1:=0;  TaskResult:=0;
  TaskErrorID:=0; TaskStatus:=0; TaskProgress:=0;
  TaskErrorInfo:=''; TaskOutFileName:='';   
end;


procedure TDTMform.FormShow(Sender: TObject);
var NotTasked:Boolean;
begin
  NotTasked:=True;
  If Firsttime then
  begin
    Firsttime:=false;
    if ParamCount =4 then
    begin
      //actually reversed.. but easier to code
      If (ParamStr(2) = '_') then begin end else
      begin
        If (strtoint(ParamStr(2))>0 ) then
        begin
          TaskStatus :=99;
          NotTasked:=False;
          If (ParamStr(3) <> '_')then TaskData1:=strtoint(ParamStr(3));
          If (ParamStr(4) <> '_')then TaskData2:=strtofloat(ParamStr(4));
      //    dtmTaskDroneForm.ProcessTask;
        end;
      end;
    end;
    if NotTasked then
    begin
      if ParamCount >0 then
      begin
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.HTF' then
        begin   {Check self first  DTMPath}
          HTFPath := ExtractFilePath(ParamStr(1));
          HTFName := ExtractFileName(ParamStr(1));
          DoLoad(ParamStr(1));
        end else    {dtm Map file   ???}
        If (Lowercase(ExtractFileExt(ParamStr(1)))= '.dtm') then
          DodtmMapLoad(ParamStr(1))
        else         {dtm Project file}
        If (Lowercase(ExtractFileExt(ParamStr(1)))= '.dtp') then
          DodtpLoad(ParamStr(1))
        else    {Pan images?}
        if ((UpperCase(ExtractFileExt(ParamStr(1))) = '.BMP')
          or (UpperCase(ExtractFileExt(ParamStr(1))) = '.JPG')
          or (UpperCase(ExtractFileExt(ParamStr(1))) = '.PNG')) then
        begin    {Need a Plane for 'flat' pictures}
          NoGLRunning:=False;
          dtmPanVizForm.Show;
          dtmPanVizForm.ShowDown(ParamStr(1));
        end else
        {Actors}
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.QC' then
        begin
          NoGLRunning:=False;
          dtmSmdQcForm.Show;
          dtmSmdQcForm.DoCcOpen(ParamStr(1));
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.MDL' then
        begin
          dtmSmdLoadMdlForm.show;
          dtmSmdLoadMdlForm.DoMdlOpen(ParamStr(1));
        end else
        {?All? Terrain data types}
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.TPCFG' then
        begin
          dtmHtfForm.show;
          dtmHtfForm.DoTpcfgOpen(ParamStr(1));
        end else
        {DT2:DoDTEDtoBin,  DDR:DoSDTStoBin, HGT ?-1 or -3 ?}
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.DT2' then
        begin
          dtmHtfForm.show;
          dtmHtfForm.SetDefaultDEMProj;
          DemPath:= ExtractFilePath(ParamStr(1));
          dtmHtfForm.DoDTEDtoBin(ParamStr(1),DemPath,0);
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.DDR' then
        begin
          dtmHtfForm.show;
          dtmHtfForm.SetDefaultDEMProj;
          DemPath:= ExtractFilePath(ParamStr(1));
          DoSDTStoBin(ParamStr(1),DemPath,0);
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.DEM' then
        begin
          dtmHtfForm.show;
          dtmHtfForm.SetDefaultDEMProj;
          DemPath:= ExtractFilePath(ParamStr(1));
          {dtmHtfForm.DoDEMtoBin(ParamStr(1),DemPath,0);}
          dtmHtfForm.Dodem24ktobin(ParamStr(1),DemPath,0);
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.GRD' then
        begin
          dtmHtfForm.show;
          dtmHtfForm.DoSurferGridtoBin(ParamStr(1));
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.XYZ' then
        begin
          dtmHtfForm.show;
          dtmHtfForm.DoXYZtoBin(ParamStr(1));
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.BT' then
        begin
          dtmHtfForm.show;
          dtmHtfForm.DoBT(ParamStr(1));
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.VRP' then
        begin
          dtmHtfForm.show;
          dtmHtfForm.ReadAnyVersionProj(ParamStr(1));
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.BIT' then
        begin    {BIT... make a little bitty bit viewer,}
          dtmHtfForm.show;
          dtmHtfForm.ReadAlittleBit(ParamStr(1));
        end else
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.SHP' then
        begin         {SHP simple viewer?}
          dtmHtfForm.show;
          dtmHtfForm.ReadAlittleShp(ParamStr(1));
        end else
        {3D RGB image pixel count}
        if UpperCase(ExtractFileExt(ParamStr(1))) = '.RS3' then
        begin
          ImagePath:=ExtractFilePath(ParamStr(1));
          NoGLRunning:=False;
          Application.ProcessMessages;
          DtmImageRGBForm.Show;
          DtmImageRGBForm.ShowDown(ParamStr(1));
        end else
        begin  {GLSViewer 3d files.. .smd, .3ds, ...? }
        NoGLRunning:=False;
        dtmGLSViewerForm.show;
        end;
      end;
    end;
  end;
end;

procedure TDTMform.DisplaySplashScreen;
begin
  SplashScreen := TSplashScreen.Create(Application);
  SplashScreen.SplashSet(7,3000);
  SplashScreen.Show;
  SplashScreen.Refresh;
end;

procedure TDTMform.ShowHint(Sender: TObject);
begin
  HintsPanel.Caption := Application.Hint;
end;

procedure TDTMform.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  LayersLoaded:=0;
  isReallyGone:=True;
  Application.ProcessMessages;
  { DTMGLForm.Close;}
  DTMformY := DTMform.top;
  DTMformX := DTMform.left;
  DoSaver;
  Application.ProcessMessages;
  CanClose:=True;
end;

procedure TDTMform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
{  Application.ProcessMessages;}
end;

procedure TDTMform.FormDestroy(Sender: TObject);
begin
  Setlength(GPFNodes,0);
  SetLength(ManMatrix,0,0);
  SetLength(LayA,0);
  SetLength(LayersControlArray,0);
  SetLength(ShapesFoundArray,0);
  SetLength(EcoRecord, 0, 0);
  htf.Free;
  bmpTile.Free;
  //BackClipBitmap.Free;
  Canvas.Free;
end;

procedure TDTMform.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #27 then Close;
  //Just in case it gets looped
  if Key = 'q' then LOSQuit:=True;
  if Key = 'a' then LOSQuit:=False;
end;

procedure TDTMform.ACExitExecute(Sender: TObject);
begin
  Close;
end;
{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
{This NEEDS to Load and Save a RECORD containing all the info
So it can be used by Gl3D display portions and DTP Option settings}
procedure TDTMform.DodtpLoad(InDtmFilename:String);
var  //These are used to pass data from loading and Set into the shape file
  ShapeFileInT: Textfile;
  InShpFilename,InPath:String[255];
  CanvasLineSize,
  IStipple,  LoaderLayersLoaded, ILoad:Integer;
    {GR32 data}
    LayerColor,OutLineColor:TColor;
    LayerVisible,
    PolyFilled, UseOutlinePoly, PolygonAntialiased:Boolean;
    PolyFillType,
    PointSize, CurrentPointType,
    FillAlphaPosition, LineAlphaPosition:Integer;
    LineSize:Double;
    PolyFillFile,
    WhatsMyLine,InVersion:String;
     LayerPlatoEditText:String;
    //LayerPlatoCommand,
    StippleColorCount:Integer;
    UseStippleStep:Boolean;
    StippleStep:Single;
    StippleColorArray:array of TColor;
Begin
  Try
    ProjectName:= ExtractFileName(InDtmFilename);
    ProjectPath:= ExtractFilePath(InDtmFilename);
    AssignFile(ShapeFileInT, InDtmFilename);
    Reset(ShapeFileInT);
    Application.ProcessMessages;
    Readln(ShapeFileInT, InVersion); {Version}
    If (Version<>InVersion) then {ErrorMessage};
    Readln(ShapeFileInT, WhatsMyLine);
    //This has Gotta be TRUE or ?????
    If WhatsMyLine='True' then bDemLoaded:=True
                          else bDemLoaded:=False;{Boolean}
    Readln(ShapeFileInT, WhatsMyLine);
    //bBackClipBitmapLoadedIgnored here..but stored for other programs
    If WhatsMyLine='True' then bBackClipBitmapLoaded:=True
                          else bBackClipBitmapLoaded:=False;{Boolean}

    Readln(ShapeFileInT, HTFPath);
    Readln(ShapeFileInT, HTFName);
    Readln(ShapeFileInT, BackBitmapPath{, SizeOf(BackBitmapPath), NumRead});
    Readln(ShapeFileInT, BackBitmapName{, SizeOf(BackBitmapName), NumRead});
    {LoadDem}
    If (bDemLoaded) then
    begin
      DodtmMapLoad(HTFPath+HTFName);//This is DTM path and name
      //After  DodtmMapLoad the REAL  HTFPath+HTFName have been set
      AllBtnsUp;
      Case DtmHtfDisplay of
      0: ElevationTint1.Checked:=True;
      1: SlopeTint1.Checked:=True;
      2: SlopeDirectional1.Checked:=True;
      3: SlopeDirectional901.Checked:=True;
      4: SlopeSetDirection1.Checked:=True;
      5: SlopePercent1.Checked:=True;
      6: ContourLines1.Checked:=True;
      7: ContourLinesAll1.Checked:=True;
      8: ContourLines21.Checked:=True;
      9: LOSMaskedArea1.Checked:=True;
      10: Ecotype1.Checked:=True;
      End;
      If (not FileExists(HTFPaletteName)) then
      HTFPaletteName:= ProgramPath+ 'Blue-Green-Red.pal';
      //PreparePal(HTFPaletteName);
      DoLoad(HTFPath+HTFName);
    end
    else DoLoad(HTFPath+HTFName);
    //end of using  bDemLoaded:=True;

    {Load BackClipBitmap .. IGNORE here..
     this is so VOICE can load the same Project ..
       it USES a Back ground}
    {If bBackClipBitmapLoaded then
    begin
      //BackClipBitmap := TBitmap32.Create;
      //BackClipBitmap.LoadFromFile(BackBitmapPath+BackBitmapName);
      Figure out the Image Size and Registration:
      StretchDraw X,Y, Width, Height
      //Image321.Bitmap.Draw(0,0, BackClipBitmap);
      //Tint of Area not Covered... Background Layer Level Top..Bottom
    end;}
    {LayersLoaded}
    Readln(ShapeFileInT, ProjectRobotRldFilename);

    Readln(ShapeFileInT, WhatsMyLine);
    LoaderLayersLoaded:=strtoint(WhatsMyLine);
    For ILoad := 1 to  LoaderLayersLoaded do
    begin
      Readln(ShapeFileInT, InShpFilename);
      Readln(ShapeFileInT, InPath);
      ShpFileName:=InPath+InShpFilename;
      {GR32 data}
      Readln(ShapeFileInT, WhatsMyLine);
      LayerColor:=strtoint(WhatsMyLine);

      Readln(ShapeFileInT, WhatsMyLine);
      OutLineColor:=strtoint(WhatsMyLine);


      {Boolean}
      Readln(ShapeFileInT, WhatsMyLine);
      If WhatsMyLine='True' then LayerVisible:=True
                          else LayerVisible:=False;{Boolean}

      Readln(ShapeFileInT, WhatsMyLine);
      If WhatsMyLine='True' then UseOutlinePoly:=True
                          else UseOutlinePoly:=False;{Boolean}
      Readln(ShapeFileInT, WhatsMyLine);
      If WhatsMyLine='True' then PolygonAntialiased:=True
                          else PolygonAntialiased:=False;{Boolean}
      Readln(ShapeFileInT, WhatsMyLine);
      If WhatsMyLine='True' then PolyFilled:=True
                          else PolyFilled:=False;{Boolean}
{PolyFillType}
      Readln(ShapeFileInT, WhatsMyLine);
      PolyFillType:=strtoint(WhatsMyLine);
      Readln(ShapeFileInT, WhatsMyLine);
      PolyFillFile:=(WhatsMyLine);

      Readln(ShapeFileInT, WhatsMyLine);
      PointSize:=strtoint(WhatsMyLine);
      Readln(ShapeFileInT, WhatsMyLine);
      CurrentPointType:=strtoint(WhatsMyLine);

      Readln(ShapeFileInT, WhatsMyLine);
      FillAlphaPosition:=strtoint(WhatsMyLine);

      Readln(ShapeFileInT, WhatsMyLine);
      LineAlphaPosition:=strtoint(WhatsMyLine);{:Integer;}
      Readln(ShapeFileInT, WhatsMyLine);
      LineSize:=StrtoFloatDef(WhatsMyLine);{:Single;}

      Readln(ShapeFileInT, WhatsMyLine);
      CanvasLineSize:=strtoint(WhatsMyLine);

      Readln(ShapeFileInT, LayerPlatoEditText);
      {Readln(ShapeFileInT, WhatsMyLine);
      LayerPlatoCommand:=strtoint(WhatsMyLine);}

      Readln(ShapeFileInT, WhatsMyLine);
      StippleColorCount:=strtoint(WhatsMyLine);
      Readln(ShapeFileInT, WhatsMyLine);
      If WhatsMyLine='True' then UseStippleStep:=True
                          else UseStippleStep:=False; {:Boolean;}
      Readln(ShapeFileInT, WhatsMyLine);
      StippleStep:=StrtoFloatDef(WhatsMyLine);   { :Single;}
      SetLength(StippleColorArray,StippleColorCount);
      For IStipple := 0 to StippleColorCount-1 do
      begin
        Readln(ShapeFileInT, WhatsMyLine);
        StippleColorArray[IStipple]:=strtoint(WhatsMyLine);
        {:array of TColor;}
      end;

      {Get the .db extension and check for it}
      If FileExists(ChangeFileExt(ShpFileName,'.dbf')) then
      begin
        ShapePath := ExtractFilePath(ShpFileName);
        Image321.Cursor:=crHourGlass; {crDefault}
        If NewLayer then
        begin
          SetDtp1.Enabled:=True;
          LayA[CurrentLayer].LayerColor:=LayerColor;
          LayA[CurrentLayer].OutLineColor:=OutLineColor;
          LayA[CurrentLayer].Visible:=LayerVisible;
          LayA[CurrentLayer].PolygonAntialiased:=PolygonAntialiased;
          LayA[CurrentLayer].PolyFilled:=PolyFilled;
          LayA[CurrentLayer].PolyFillType:=PolyFillType;{PolyFillType}
          LayA[CurrentLayer].PolyFillFile:=PolyFillFile;

          LayA[CurrentLayer].LineAlphaPosition:=LineAlphaPosition;
          LayA[CurrentLayer].FillAlphaPosition:=FillAlphaPosition;
          LayA[CurrentLayer].UseOutlinePoly := UseOutlinePoly;
          LayA[CurrentLayer].LineSize := LineSize;
          LayA[CurrentLayer].CanvasLineSize:=CanvasLineSize;
          LayA[CurrentLayer].PointSize:=PointSize;
          LayA[CurrentLayer].CurrentPointType:=CurrentPointType;
          LayA[CurrentLayer].LayerPlatoEditText:= LayerPlatoEditText;
          //LayA[CurrentLayer].LayerPlatoCommand:= LayerPlatoCommand;

          LayA[CurrentLayer].StippleColorCount:= StippleColorCount;
          LayA[CurrentLayer].UseStippleStep:=UseStippleStep;{ :Boolean;}
          LayA[CurrentLayer].StippleStep:= StippleStep;{  :Single;}
          SetLength(LayA[CurrentLayer].StippleColorArray,StippleColorCount);
          For IStipple := 0 to StippleColorCount-1 do
          begin
            LayA[CurrentLayer].StippleColorArray[IStipple]:=
              StippleColorArray[IStipple];  {:array of TColor;}
         end;

       end else DoRezError(19);
        {Read Layers Shapes GR32 data AND PLACE OVER the default data}
        Image321.Cursor:=crDefault; {crDefault}
      end else DoRezError(20);
    end;

    If InVersion <> Verstring1_2 then
    begin
      {Ready for new version activities here}
    end;
    isRunningOnDtp:=True;
    PrintdtpDTMProject1.Enabled:=True;
  Finally
    CloseFile(ShapeFileInT);
  End;
  PrepareBitmap;
End;
{==============================================================}
procedure TDTMform.SetDtp1Click(Sender: TObject);
begin  //Open the Form to Set the Project parameters
  If LayersLoaded>0 then  //HTF is already loaded too...
  begin   { is MODAL.. only 1 and only IT.. dunno why}
    dtmDTPForm:=TdtmDTPForm.Create(Application);
    dtmDTPForm.Showmodal;
    dtmDTPForm.Release;
    PrepareBitmap;
  end;
end;
{==============================================================}

procedure TDTMform.SaveDtp1Click(Sender: TObject);
begin                      { HTFName }
  SaveDialog1.Filter:= 'DTP Project (*.dtp)|*.dtp';
  SaveDialog1.InitialDir:=ProjectPath;
  SaveDialog1.DefaultExt:='dtp';
  SaveDialog1.Filename:=ChangeFileExt(ProjectName,'.dtp' );
  if SaveDialog1.Execute then
  begin
    Application.ProcessMessages;
    ProjectName:= ExtractFileName(SaveDialog1.Filename);
    ProjectPath:= ExtractFilePath(SaveDialog1.Filename);
    DoSaveDtmProject(SaveDialog1.Filename);
    isRunningOnDtp:=True;//dtmGlHeight can load data ?
    PrintdtpDTMProject1.Enabled:=True;
    //SetDtp1.Enabled:=True; Shape Layers required
  end;
End;
procedure TDTMform.DoSaveDtmProject(Filename:String);
var
  ShapeFileInT: Textfile;
  {  InShpFilename,InPath:String[255];}
  IStipple, ILoad:Integer;
    {GR32 data}
    LayerColor,OutLineColor:TColor;
    LayerVisible,
    PolyFilled, UseOutlinePoly, PolygonAntialiased:Boolean;
    PolyFillType,
    CanvasLineSize,
    PointSize, CurrentPointType,
    FillAlphaPosition, LineAlphaPosition:Integer;
    LineSize:Double;
    PolyFillFile,
    WhatsMyLine,LayerPlatoEditText:String;
    //LayerPlatoCommand,
    StippleColorCount:Integer;
    UseStippleStep:Boolean;
    StippleStep:Single;
    StippleColorArray:array of TColor;
Begin
  Try
    AssignFile(ShapeFileInT, FileName);
    Rewrite(ShapeFileInT);
    WhatsMyLine:=Verstring1_2;
    Writeln(ShapeFileInT, WhatsMyLine); {Version};
    //bDemLoaded is declared in AllShapeLoaderFrm
    //SET in DTP DTM
    If FileExists(MapsPath + MapName) then bDemLoaded:=True;

    If bDemLoaded=True then WhatsMyLine:='True'
                       else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    If bBackClipBitmapLoaded=True then WhatsMyLine:='True'
                       else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    If  bDemLoaded then //write ITS filename
    begin             //MapsPath  MapName
      DodtmMapSave(MapsPath + MapName,False);
      Writeln(ShapeFileInT, MapsPath);
      // HTFName:=ChangeFileExt(HTFName,'.htf' );
      Writeln(ShapeFileInT, MapName);
    end else
    begin
    Writeln(ShapeFileInT, HTFPath);
    HTFName:=ChangeFileExt(HTFName,'.htf' );//? should be htf already ?
    Writeln(ShapeFileInT, HTFName);
    end;
    //ignored..but stored...
    If (not bBackClipBitmapLoaded) then
    begin
    BackBitmapPath:=NoName;
    BackBitmapName:=NoName;
    end;
    Writeln(ShapeFileInT, BackBitmapPath);
    Writeln(ShapeFileInT, BackBitmapName);
{}    Writeln(ShapeFileInT, ProjectRobotRldFilename);{NoName}
    WhatsMyLine:=inttostr(LayersLoaded);
    Writeln(ShapeFileInT, WhatsMyLine);
    {LayersLoaded}
    For ILoad := 1 to  LayersLoaded do
    begin
      {LayA[CurrentLayer].LayerDBName
       LayA[CurrentLayer].LayerDBPath}
      Writeln(ShapeFileInT, LayA[ILoad].Filename);
      Writeln(ShapeFileInT, LayA[ILoad].Path);
    {GR32 data STORED with the .SHP data ..but NOT part of the Shape file
    Kinda like Projection info and other stuff...
    ESRI probably makes Relational Database(s) Linked to the .shp file
    I make these Bogus data files...
    Need to Make Records ... or Keep Extending the Shape files}
LayerColor:=  LayA[ILoad].LayerColor;
OutLineColor:=  LayA[ILoad].OutLineColor;
LayerVisible:=  LayA[ILoad].Visible;
PolygonAntialiased:=  LayA[ILoad].PolygonAntialiased;
PolyFilled  :=   LayA[CurrentLayer].PolyFilled;
PolyFillType  :=   LayA[CurrentLayer].PolyFillType;
PolyFillFile  :=   LayA[CurrentLayer].PolyFillFile;
LineAlphaPosition:=  LayA[ILoad].LineAlphaPosition;
FillAlphaPosition:=  LayA[ILoad].FillAlphaPosition;
UseOutlinePoly:=  LayA[ILoad].UseOutlinePoly;
LineSize:=  LayA[ILoad].LineSize;
CanvasLineSize:=  LayA[ILoad].CanvasLineSize;
PointSize:=  LayA[ILoad].PointSize;
CurrentPointType:=  LayA[ILoad].CurrentPointType;
LayerPlatoEditText:=  LayA[ILoad].LayerPlatoEditText;
//LayerPlatoCommand:=  LayA[ILoad].LayerPlatoCommand;

StippleColorCount:=  LayA[ILoad].StippleColorCount;
UseStippleStep:=  LayA[ILoad].UseStippleStep;{ :Boolean;}
StippleStep:=  LayA[ILoad].StippleStep;{  :Single;}
    SetLength(StippleColorArray,StippleColorCount);
    For IStipple := 0 to StippleColorCount-1 do
    begin
    StippleColorArray[IStipple]:=
      LayA[ILoad].StippleColorArray[IStipple];
            {:array of TColor;}
    end;
    WhatsMyLine:=inttostr(LayerColor);{:TColor;}
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=inttostr(OutLineColor);{:TColor;}
    Writeln(ShapeFileInT, WhatsMyLine);
    {Boolean}
    If LayerVisible=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);

    If UseOutlinePoly=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    If PolygonAntialiased=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    If PolyFilled=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=inttostr(PolyFillType);{PolyFillType}
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=(PolyFillFile);{PolyFillFile}
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=inttostr(PointSize);
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=inttostr(CurrentPointType);
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=inttostr(FillAlphaPosition);
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=inttostr(LineAlphaPosition);{:Integer;}
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=floattostr(LineSize);{:Double;}
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=inttostr(CanvasLineSize);
    Writeln(ShapeFileInT, WhatsMyLine);

   Writeln(ShapeFileInT, LayerPlatoEditText);{:String;}
    {WhatsMyLine:=inttostr(LayerPlatoCommand);
    Writeln(ShapeFileInT, WhatsMyLine); }
    WhatsMyLine:=inttostr(StippleColorCount);
    Writeln(ShapeFileInT, WhatsMyLine);

    If UseStippleStep=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=floattostr(StippleStep);{:Double;}
    Writeln(ShapeFileInT, WhatsMyLine);

    SetLength(StippleColorArray,StippleColorCount);
    For IStipple := 0 to StippleColorCount-1 do
    begin
    WhatsMyLine:=inttostr(StippleColorArray[IStipple]);{:TColor;}
    Writeln(ShapeFileInT, WhatsMyLine);
    end;
    end;{of all the Layers}
  Finally
    CloseFile(ShapeFileInT);
  End;
End;
{==============================================================}
{==============================================================}
procedure TDTMform.PrintdtpDTMProject1Click(Sender: TObject);
var ProjectNameChanged: string;
begin
  {Save the Dtp project to an annotated Text file
   and Call Windows to Display..Print it}
  //dtmErrMsg, Show and Print
  ProjectNameChanged:=
     Copy(ProjectName,0,Length(ProjectName)-4);
     ProjectNameChanged:= ProjectNameChanged+'Anno.txt';
  DoSavePrintedDtmProject(ProjectPath+ProjectNameChanged);
  if FileExists(ProjectPath+ProjectNameChanged) then
    ExecuteFile(ProjectNameChanged, '', ProjectPath, SW_SHOW)
end;
procedure TDTMform.DoSavePrintedDtmProject(Filename:String);
var
  ShapeFileInT: Textfile;
  {  InShpFilename,InPath:String[255];}
  IStipple, ILoad:Integer;
    {GR32 data}
    LayerColor,OutLineColor:TColor;
    LayerVisible,
    PolyFilled, UseOutlinePoly, PolygonAntialiased:Boolean;
    PolyFillType,
    CanvasLineSize,
    PointSize, CurrentPointType,
    FillAlphaPosition, LineAlphaPosition:Integer;
    LineSize:Double;
    PolyFillFile,
    WhatsMyLine,LayerPlatoEditText:String;
    //LayerPlatoCommand,
    StippleColorCount:Integer;
    UseStippleStep:Boolean;
    StippleStep:Single;
    StippleColorArray:array of TColor;
Begin
  Try
    AssignFile(ShapeFileInT, FileName);
    Rewrite(ShapeFileInT);
    WhatsMyLine:=Verstring1_2;
    Writeln(ShapeFileInT, 'Version: '+WhatsMyLine); {};
    //bDemLoaded is declared in AllShapeLoaderFrm
    //SET in DTP DTM
    If FileExists(MapsPath + MapName) then bDemLoaded:=True;

    If bDemLoaded=True then WhatsMyLine:='True'
                       else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, 'bDemLoaded: '+WhatsMyLine);

    //ignored but stored
    If bBackClipBitmapLoaded=True then WhatsMyLine:='True'
                       else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    If  bDemLoaded then //write ITS filename
    begin             //MapsPath  MapName
      DodtmMapSave(MapsPath + MapName,True);
      Writeln(ShapeFileInT, MapsPath);
      // HTFName:=ChangeFileExt(HTFName,'.htf' );
      Writeln(ShapeFileInT, MapName);
      //Append the file to this one
    end else
    begin
    Writeln(ShapeFileInT, HTFPath);
    HTFName:=ChangeFileExt(HTFName,'.htf' );//? should be htf already ?
    Writeln(ShapeFileInT, HTFName);
    end;
    If (not bBackClipBitmapLoaded) then
    begin
    BackBitmapPath:=NoName;
    BackBitmapName:=NoName;
    end;
    Writeln(ShapeFileInT, BackBitmapPath);
    Writeln(ShapeFileInT, BackBitmapName);
{}    Writeln(ShapeFileInT, ProjectRobotRldFilename);{NoName}
    WhatsMyLine:=inttostr(LayersLoaded);
    Writeln(ShapeFileInT, WhatsMyLine);
    {LayersLoaded}
    For ILoad := 1 to  LayersLoaded do
    begin
      {LayA[CurrentLayer].LayerDBName
       LayA[CurrentLayer].LayerDBPath}
      Writeln(ShapeFileInT, LayA[ILoad].Filename);
      Writeln(ShapeFileInT, LayA[ILoad].Path);
    {GR32 data STORED with the .SHP data ..but NOT part of the Shape file
    Kinda like Projection info and other stuff...
    ESRI probably makes Relational Database(s) Linked to the .shp file
    I make these Bogus data files...
    Need to Make Records ... or Keep Extending the Shape files}
LayerColor:=  LayA[ILoad].LayerColor;
OutLineColor:=  LayA[ILoad].OutLineColor;
LayerVisible:=  LayA[ILoad].Visible;
PolygonAntialiased:=  LayA[ILoad].PolygonAntialiased;
PolyFilled  :=   LayA[CurrentLayer].PolyFilled;
PolyFillType  :=   LayA[CurrentLayer].PolyFillType;
PolyFillFile  :=   LayA[CurrentLayer].PolyFillFile;
LineAlphaPosition:=  LayA[ILoad].LineAlphaPosition;
FillAlphaPosition:=  LayA[ILoad].FillAlphaPosition;
UseOutlinePoly:=  LayA[ILoad].UseOutlinePoly;
LineSize:=  LayA[ILoad].LineSize;
CanvasLineSize:=  LayA[ILoad].CanvasLineSize;
PointSize:=  LayA[ILoad].PointSize;
CurrentPointType:=  LayA[ILoad].CurrentPointType;
LayerPlatoEditText:=  LayA[ILoad].LayerPlatoEditText;
//LayerPlatoCommand :=  LayA[ILoad].LayerPlatoCommand;
StippleColorCount:=  LayA[ILoad].StippleColorCount;
UseStippleStep:=  LayA[ILoad].UseStippleStep;{ :Boolean;}
StippleStep:=  LayA[ILoad].StippleStep;{  :Single;}
    SetLength(StippleColorArray,StippleColorCount);
    For IStipple := 0 to StippleColorCount-1 do
    begin
    StippleColorArray[IStipple]:=
      LayA[ILoad].StippleColorArray[IStipple];
            {:array of TColor;}
    end;
    WhatsMyLine:=inttostr(LayerColor);{:TColor;}
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=inttostr(OutLineColor);{:TColor;}
    Writeln(ShapeFileInT, WhatsMyLine);
    {Boolean}

    If LayerVisible=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    If UseOutlinePoly=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    If PolygonAntialiased=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    If PolyFilled=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=inttostr(PolyFillType);{PolyFillType}
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=(PolyFillFile);{PolyFillFile}
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=inttostr(PointSize);
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=inttostr(CurrentPointType);
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=inttostr(FillAlphaPosition);
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=inttostr(LineAlphaPosition);{:Integer;}
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=floattostr(LineSize);{:Double;}
    Writeln(ShapeFileInT, WhatsMyLine);
    WhatsMyLine:=inttostr(CanvasLineSize);
    Writeln(ShapeFileInT, WhatsMyLine);

    Writeln(ShapeFileInT, LayerPlatoEditText);{:String;}
    {WhatsMyLine:=inttostr(LayerPlatoCommand);
    Writeln(ShapeFileInT, WhatsMyLine);}
    WhatsMyLine:=inttostr(StippleColorCount);
    Writeln(ShapeFileInT, WhatsMyLine);

    If UseStippleStep=True then WhatsMyLine:='True'
                          else WhatsMyLine:='False';{Boolean}
    Writeln(ShapeFileInT, WhatsMyLine);

    WhatsMyLine:=floattostr(StippleStep);{:Double;}
    Writeln(ShapeFileInT, WhatsMyLine);

    SetLength(StippleColorArray,StippleColorCount);
    For IStipple := 0 to StippleColorCount-1 do
    begin
    WhatsMyLine:=inttostr(StippleColorArray[IStipple]);{:TColor;}
    Writeln(ShapeFileInT, WhatsMyLine);
    end;
    end;{of all the Layers}
  Finally
    CloseFile(ShapeFileInT);
  End;
End;
{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
procedure TDTMform.Reopen0Click(Sender: TObject);
begin
  If ((OldFileName0<>' ')and (FileExists(OldFileName0))) then
  begin
    //HTFPath := ExtractFilePath(OldFileName0);
    {TongFilename := ExtractFileName(OldFileName0);}
    //If (OldFileName1=OldFileName0) then OldFileName1:=' ';
    DoAllLoad(OldFileName0);
  end else
  begin
    OldFileName0:=' ';
    ResetFileMenu;
  end;
end;

procedure TDTMform.Reopen1Click(Sender: TObject);
begin
  If ((OldFileName1<>' ')and (FileExists(OldFileName1))) then
  begin
    //HTFPath := ExtractFilePath(OldFileName1);
    {TongFilename := ExtractFileName(OldFileName1);}
    //If (OldFileName2=OldFileName1) then OldFileName2:=' ';
    DoAllLoad(OldFileName1);
  end else
  begin
    OldFileName1:= ' ';
    ResetFileMenu;
  end;
end;

procedure TDTMform.Reopen2Click(Sender: TObject);
begin
  If ((OldFileName2<>' ')and (FileExists(OldFileName2))) then
  begin
    //HTFPath := ExtractFilePath(OldFileName2);
    {TongFilename := ExtractFileName(OldFileName2);}
    //If (OldFileName3=OldFileName2) then OldFileName3:=' ';
    DoAllLoad(OldFileName2);
  end else
  begin
    OldFileName2:=' ';
    ResetFileMenu;
  end;
end;

procedure TDTMform.Reopen3Click(Sender: TObject);
begin
  If ((OldFileName3<>' ')and (FileExists(OldFileName3))) then
  begin
    //HTFPath := ExtractFilePath(OldFileName3);
    {TongFilename := ExtractFileName(OldFileName3);}
    //If (OldFileName3=OldFileName4) then OldFileName4:=' ';
    DoAllLoad(OldFileName3);
  end else
  begin
    OldFileName3:=' ';
    ResetFileMenu;
  end;
end;

procedure TDTMform.Reopen4Click(Sender: TObject);
begin
  If ((OldFileName4<>' ')and (FileExists(OldFileName4))) then
  begin
    //HTFPath := ExtractFilePath(OldFileName4);
    {TongFilename := ExtractFileName(OldFileName4);}
    DoAllLoad(OldFileName4);
  end else
  begin
    OldFileName4:=' ';
    ResetFileMenu;
  end;
end;

procedure TDTMform.ResetFileMenu;
begin
  If (OldFileName3=OldFileName4) then OldFileName4:=' ';
  If (OldFileName3=OldFileName2) then OldFileName3:=' ';
  If (OldFileName2=OldFileName1) then OldFileName2:=' ';
  If (OldFileName1=OldFileName0) then OldFileName1:=' ';
  {if this was a list it could be sorted.. this can still get buggered}
  If (OldFileName0=' ') then
  begin
   OldFileName0:= OldFileName1;
   OldFileName1:=' ';
  end;
  If (OldFileName1=' ') then
  begin
   OldFileName1:= OldFileName2;
   OldFileName2:=' ';
  end;
  If (OldFileName2=' ') then
  begin
   OldFileName2:= OldFileName3;
   OldFileName3:=' ';
  end;
  If (OldFileName3=' ') then
  begin
   OldFileName3:= OldFileName4;
   OldFileName4:=' ';
  end;
  If (OldFileName3=OldFileName4) then OldFileName4:=' ';
  If (OldFileName3=OldFileName2) then OldFileName3:=' ';
  If (OldFileName2=OldFileName1) then OldFileName2:=' ';
  If (OldFileName1=OldFileName0) then OldFileName1:=' ';
  Reopen0.Caption:= '&0 '+ OldFileName0;
  Reopen1.Caption:= '&1 '+ OldFileName1;
  Reopen2.Caption:= '&2 '+ OldFileName2;
  Reopen3.Caption:= '&3 '+ OldFileName3;
  Reopen4.Caption:= '&4 '+ OldFileName4;
end;
{==============================================================}
{==============================================================}

{==============================================================}
{==============================================================}
procedure TDTMform.ACOpenExecute(Sender: TObject);
begin
  OpenDialog.Filter:= 'HTF File (*.htf)|*.htf;.dtm';
  {HTF File (*.htf)|*.htf|All Files (*.*)|*.*|dtp Files (*.dtp)|*.dtp}
  OpenDialog.FileName:= '*.htf';
  OpenDialog.InitialDir:=HTFPath;
  if OpenDialog.Execute then  DoAllLoad(OpenDialog.FileName);
end;
procedure TDTMform.OpenDTM1Click(Sender: TObject);
begin
  OpenDialog.Filter:= 'DTM File (*.dtm)|*.dtm';
  OpenDialog.FileName:= '*.dtm';
  OpenDialog.InitialDir:=MapsPath;
  if OpenDialog.Execute then DoAllLoad(OpenDialog.FileName)
end;
procedure TDTMform.OpenDtp1Click(Sender: TObject);
begin
  OpenDialog.Filter:= 'DTP File (*.dtp)|*.dtp|dtp Files (*.dtp)|*.dtp';
  {HTF File (*.htf)|*.htf|All Files (*.*)|*.*}
  OpenDialog.FileName:= '*.dtp';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then  DoAllLoad(OpenDialog.FileName);
end;
procedure TDTMform.DoAllLoad(AFilename:String);
begin
  OldFileName4:=OldFileName3;
  OldFileName3:=OldFileName2;
  OldFileName2:=OldFileName1;
  OldFileName1:=OldFileName0;
  OldFileName0:=AFilename;//OpenDialog.FileName;
  ResetFileMenu;

  If (Lowercase(ExtractFileExt(AFilename))= '.htf') then
  begin
    HTFPath:=ExtractFilePath(AFilename);
    isRunningOnDtp:=False;{not loaded from a .dtp}
    DoLoad(AFilename);
  end else
  If (Lowercase(ExtractFileExt(AFilename))= '.dtm') then
  begin     //DodtmMapLoad in dtmdtmreader.pas
      DodtmMapLoad(AFilename);//This is DTM path and name
      //After  DodtmMapLoad the REAL  HTFPath+HTFName have been set
      AllBtnsUp;
      Case DtmHtfDisplay of
      0: ElevationTint1.Checked:=True;
      1: SlopeTint1.Checked:=True;
      2: SlopeDirectional1.Checked:=True;
      3: SlopeDirectional901.Checked:=True;
      4: SlopeSetDirection1.Checked:=True;
      5: SlopePercent1.Checked:=True;
      6: ContourLines1.Checked:=True;
      7: ContourLinesAll1.Checked:=True;
      8: ContourLines21.Checked:=True;
      9: LOSMaskedArea1.Checked:=True;
      10: Ecotype1.Checked:=True;
      End;
      If (not FileExists(HTFPaletteName)) then
      HTFPaletteName:= ProgramPath+ 'Blue-Green-Red.pal';
      //PreparePal(HTFPaletteName);
      isRunningOnDtp:=False;
      DoLoad(HTFPath+HTFName);
    end else
  If (Lowercase(ExtractFileExt(AFilename))= '.dtp') then
  begin
    ProjectPath:=ExtractFilePath(AFilename);
    DodtpLoad(AFilename);
  end;
end;
procedure TDTMform.DoLoad(AFilename:String);
var
  i:Integer;
  tileInfo : PHeightTileInfo;
  tileList : TList;
Begin
  If FileExists(AFilename) then
  if UpperCase(ExtractFileExt(AFilename)) = '.HTF' then
  begin
    {New Htf... new all}
    HTFPath:=ExtractFilePath(AFilename);
    curX:=0;
    curY:=0;
    isHTFLoaded:=False;
    DShiftOffsetX:=0;
    DShiftOffsetY:=0;
    AutoMinimumElevation:=32767;
    AutoMaximumElevation:= -32767;
    LayersLoaded:=0;
    SetLength(ManMatrix,10,10);
    SetLength(LayA,0);
    SetLength(LayersControlArray,0);
    SetLength(ShapesFoundArray,0);
    Application.ProcessMessages;
    HTFName := ExtractFileName(AFilename);
    OpenShape1.Enabled:=True;
    Imagemaker1.Enabled:=True;
    htf.Free;
    htf:=THeightTileFile.Create(AFilename);
    Caption:='Digital Terrain Mapping : '+ExtractFileName(AFilename);
    If FileExists(ChangeFileExt(AFilename,'.vrp')) then
    Begin  {Pretend is Full Globe Geo Projection for now}
      dtmHtfForm.ReadAnyVersionProj(ChangeFileExt(AFilename,'.vrp'));
      DataScalerX:=( (abs(MapProjRec.TopRightXEditText-MapProjRec.TopLeftXEditText) /htf.SizeX));
      DataScalerY:=( (abs(MapProjRec.BottomLeftYEditText-MapProjRec.TopLeftYEditText) /htf.SizeY));
      //Need CORRECTION from 0,0
      //TLocoOffsetX:=MapProjRec.TopLeftXEditText;
      //TLocoOffsetY:=MapProjRec.BottomLeftYEditText;
      DataSizeMaxOffX:= htf.SizeX;
      DataSizeMaxOffY:= htf.SizeY;
        CurrentRezLevel:=1;//Need to figure out What Rez it actually IS
    end else
    Begin  {Guess full world htf}
      DataScalerX:=( (360 /htf.SizeX));
      DataScalerY:=( (180 /htf.SizeY));
      DataSizeMaxOffX:= htf.SizeX;
      DataSizeMaxOffY:= htf.SizeY;
        CurrentRezLevel:=1;//Need to figure out What Rez it actually IS
    end;
    FileSizeX:= htf.SizeX;
    FileSizeY:= htf.SizeY;
    ScreenHeight:=Image321.Height;
    ScreenWidth:=Image321.Width;
    isHTFLoaded:=True;
    AutoDefaultZ:=htf.DefaultZ;
    MinimumElevation:=  32767;
    MaximumElevation:= -32768;
    tileList:=TList.Create;
    try
      htf.TilesInRect(0, 0, htf.SizeX-1,
                      htf.SizeY-1, tileList);
      for i:=0 to tileList.Count-1 do
      begin
        tileInfo:=PHeightTileInfo(tileList[i]);
        If tileInfo.min> AutoDefaultZ then
          If MinimumElevation> tileInfo.min
             then MinimumElevation:=tileInfo.min;
          If MaximumElevation< tileInfo.max
             then MaximumElevation:=tileInfo.max;
      end;
          If AutoMinimumElevation> MinimumElevation
             then AutoMinimumElevation:=MinimumElevation;
          If AutoMaximumElevation< MaximumElevation
             then AutoMaximumElevation:=MaximumElevation;
    finally
      tileList.Free;
    end;
    PrepareBitmap;
  end;
End;
{==============================================================}
{==============================================================}
procedure TDTMform.PrepareBitmap;
var
  i, sex, tx, ty : Integer;
  scanLine : PColor32Array;
  tileInfo : PHeightTileInfo;
  dataRow : PSmallIntArray;
  tile : PHeightTile;
  start, lap, stop, htfTime, drawTime, freq : Int64;
  tileList : TList;
begin
  If BusyDrawing then exit else BusyDrawing:=True;
  If ((ElevationTint1.Checked)and(LOSint=0)) then
  begin
    sex:=Image321.Width;
    Image321.Bitmap.Clear(Color32(MapBackgroundColor));
    if not Assigned(htf) then Exit;
      {Figure out the Image Size and Registration:
      StretchDraw X,Y, Width, Height}
    {If bBackClipBitmapLoaded then
      Image321.Bitmap.Draw(0,0, BackClipBitmap);}
    drawTime:=0;
    tileList:=TList.Create;
    try
      QueryPerformanceCounter(start);
      htf.TilesInRect(curX, curY, curX+sex-1,
                      curY+Image321.Bitmap.Height-1, tileList);
      QueryPerformanceCounter(stop);
      htfTime:=stop-start;

      for i:=0 to tileList.Count-1 do
      begin
        tileInfo:=PHeightTileInfo(tileList[i]);
        QueryPerformanceCounter(start);
        tile:=htf.GetTile(tileInfo.left, tileInfo.top);
        QueryPerformanceCounter(lap);
        bmpTile.Width:=tileinfo.width;
        bmpTile.Height:=tileInfo.height;

        for ty:=0 to tileInfo.height-1 do
        begin
          scanLine:=bmpTile.ScanLine[ty];
          dataRow:=@tile.data[ty*tileInfo.width];
          for tx:=0 to tileInfo.width-1 do
             scanLine[tx]:=heightColor[dataRow[tx]];
        end;

        Image321.Bitmap.Draw(tileInfo.left-curX, tileInfo.top-curY, bmpTile);

        QueryPerformanceCounter(stop);
        htfTime:=htfTime+lap-start;
        drawTime:=drawTime+stop-lap;
      end;
      {Tile Grid Lines}
      if TBGrid.Down then
      begin
        for i:=0 to tileList.Count-1 do with PHeightTileInfo(tileList[i])^ do
        begin
          Image321.Bitmap.FrameRectS(
          left-curX,
          top-curY,
          left+width-curX+1,
          top+height-curY+1,
          Color32(MapGridColor));
        end;
      end;

(*    if ((LayersLoaded>0)and (DrawShapes1.Checked)) then
      begin
        DataSizeMinOffX:= curX;
        DataSizeMinOffY:= curY;
    Image321.Bitmap.BeginUpdate;
        DVDORedraw; {Draw Shape Files}
  Image321.Bitmap.EndUpdate;
  Image321.Bitmap.Changed;
  Image321.Refresh; // force repaint}
      End;*)
    finally
      tileList.Free;
    end;

    if ((LayersLoaded>0)and (DrawShapes1.Checked)) then
      begin
        DataSizeMinOffX:= curX;
        DataSizeMinOffY:= curY;
  Image321.Bitmap.BeginUpdate;
        DVDORedraw; {Draw Shape Files}
  Image321.Bitmap.EndUpdate;
  Image321.Bitmap.Changed;
  Image321.Refresh; // force repaint}
      End;

    QueryPerformanceFrequency(freq);
    LAMap.Caption:=Format(' %d x %d - %.1f ms HTF - %.1f ms Draw ',
                         [htf.SizeX, htf.SizeY,
                          1000*htfTime/freq,
                          1000*drawTime/freq]);

  //and (NoGLRunning)

  //LOSint 1 is LOS A to B... Draws a line to select 2 points
  //then displays a side view of the data
  //LOSint also used for GL3D display types
  //PrepareTileBitmap: DtmGlfrm is also called by other portions: Image Maker
  end else If ((LOSint=2)) then PrepareTileBitmap
  //PrepareTerrainBitmap calls  dtmHdsFrm
  //Just passes the clicked location and Htf info
  //.. expected to make its own Textures
  //
  else If ((LOSint=4)) then PrepareTerrainBitmap
  {Full screen Height 3d and all the other type of Tints}
  //dtmGlHeightForm  checks isRunningOnDtp to Load Shape data as Objects
  else{ If ((LOSint=3)) then} PrepareBigBitmap;
BusyDrawing:=False;
end;

procedure TDTMform.PrepareTerrainBitmap;
Begin
  if not Assigned(htf) then Exit;
  If FileExists(HTFPath+HTFName) then
  begin
    {If Texture Exists then Load it else Create or use 'fake' texture}
    {CreateTexturesOnDemand:=False;} {Set in Program Options}
   { showmessage(inttostr(htf.TileSize-1)); }
    dtmGlHdsForm.show; {SizeX and SizeY is a Multiple of TileSize}
    dtmGlHdsForm.FormShowDown(htf.TileSize-1, {Tilesize -Overlap }
                              htf.SizeX,
                              htf.SizeY,
                              AutoDefaultZ,
                              mx+curX,
                              my+curY,
                              AutoMinimumElevation,
                              AutoMaximumElevation );
  end;
  LOSint:=0;
End;

procedure TDTMform.PrepareBigBitmap;
var
  sex,sey, i, itl, tx, ty : Integer;
  scanLine : PColor32Array;
  tileInfo : PHeightTileInfo;
  dataRow : PSmallIntArray;
  tile : PHeightTile;
  Correction:SmallInt;
  start, lap, stop, htfTime, drawTime, freq : Int64;
  tileList : TList;
  TinyBmp,TiledBmp:TBitmap;
  MyRect:TRect;
  aManMatrix: array of array of Smallint;
Begin
  Screen.Cursor := crHourGlass;
  sex:=Image321.Bitmap.Width;
  sey:=Image321.Bitmap.Height;
  Image321.Bitmap.Clear(Color32(MapBackgroundColor));
  if not Assigned(htf) then Exit;
  LAMap.Caption:='Busy';
  drawTime:=0;
  tileList:=TList.Create;
  Application.ProcessMessages;
  try
    QueryPerformanceCounter(start);
    htf.TilesInRect(curX, curY, curX+sex-1,
                      curY+Image321.Bitmap.Height-1, tileList);
    QueryPerformanceCounter(stop);
    htfTime:=stop-start;
    {Get data}
    {Setlength(MiniMatrix,sex ,Image321.Bitmap.Height );}
    Setlength(ManMatrix,sex ,sey );
    TinyBmp:=Tbitmap.Create;
    TiledBmp:=Tbitmap.Create;
    If LOSint=3 then {Prepare for 3D}
    begin
      FileSizeX:=Image321.Bitmap.width;
      FileSizeY:=Image321.Bitmap.height;
      NullDemValue :=MinimumElevation;
      CellSizeX :=Image321.Bitmap.width;
      CellSizeY :=Image321.Bitmap.height;
      {TinyBmp:=Tbitmap.Create; }
      TinyBmp.width:=(Image321.Bitmap.width);
      TinyBmp.height:=(Image321.Bitmap.height);
      TinyBmp.PixelFormat := pf32bit;
      {TiledBmp:=Tbitmap.Create;}
      TiledBmp.width:=(Image321.Bitmap.width*2);
      TiledBmp.height:=(Image321.Bitmap.height*2);
      TiledBmp.PixelFormat := pf32bit;
    End;
    bmpTile.Width:=Image321.Bitmap.width;
    bmpTile.Height:=Image321.Bitmap.height;
      {Part 1}
    for itl:=0 to tileList.Count-1 do
    begin
      tileInfo:=PHeightTileInfo(tileList[itl]);
      QueryPerformanceCounter(start);
      tile:=htf.GetTile(tileInfo.left, tileInfo.top);
      QueryPerformanceCounter(lap);
      {Set Data into Matrix}
      {showmessage(Inttostr(tileInfo.left)
          +' - ' +Inttostr(curX)
          + ' '  +Inttostr(tileInfo.top)
          +' - ' +Inttostr(curY)    );}

      for ty:=0 to tileInfo.height-1 do
      begin
        dataRow:=@tile.data[ty*tileInfo.width];
        for tx:=0 to tileInfo.width-1 do
        begin
          If  ((((tileInfo.left+tx)-curX)>=0) and (((tileInfo.left+tx)-curX)<sex)
          and  (((tileInfo.top+ty)-curY)>=0) and (((tileInfo.top+ty)-curY)<Image321.Bitmap.height))
          then
          begin
            {Copy for ManMatrix too + Zeroizer}
            ManMatrix[(tileInfo.left+tx)-curX,
               ((tileInfo.top+ty)-curY)]:=dataRow[tx]{+MinimumElevation};
          end;
        end;
      end;
    end;

    {Set blank into bitmap corners}
    for ty:=0 to sey-1 do
    begin
      scanLine:=bmpTile.ScanLine[ty];
      If ((ty=0) or (ty=sey-1)) then
      begin
        for tx:=0 to sex-1 do
          scanLine[tx]:=Color32(MapBackgroundColor){heightColor[dataRow[tx]]}
      end else
      begin
        scanLine[0]:=Color32(MapBackgroundColor);{heightColor[dataRow[0]];}
        scanLine[sex-1]:=Color32(MapBackgroundColor);{heightColor[dataRow[tileInfo.width-1]];}
      end;
    end;


    IF ElevationTint1.Checked then
    begin
      for ty:=0 to sey-1 do
      begin
        scanLine:=bmpTile.ScanLine[ty];
        for tx:=0 to sex-1 do
            scanLine[tx]:=heightColor[ManMatrix[tx,ty]];
      end;
    end else

    If ({ SlopeTint1 SlopeDirectional1  SlopeSetDirection1 SlopePercent1}
    (SlopeTint1.Checked) or
    (SlopeDirectional1.Checked) or
    (SlopeDirectional901.Checked) or
    (SlopeSetDirection1.Checked) or
    (SlopePercent1.Checked)) then  PrepTints(sex,sey)
    Else
    If (ContourLines1.Checked) then PrepContour1(sex,sey)
    else if   (ContourLinesAll1.Checked) then PrepContourAll(sex,sey)
    Else           //7 Contour lines
    If ContourLines21.Checked then PrepContour2(sex,sey)
    Else If LOSMaskedArea1.Checked then PrepLOSArea(sex,sey)

    Else If Ecotype1.Checked then PrepEcoType(sex,sey);


{procedure Draw(const DstRect, SrcRect: TRect; Src: TBitmap32); overload;}
    Image321.Bitmap.Draw(0,0,bmpTile);
    QueryPerformanceCounter(stop);
    htfTime:=htfTime+lap-start;
    drawTime:=drawTime+stop-lap;
    {Tile Grid Lines}
    if TBGrid.Down then
    begin
      for i:=0 to tileList.Count-1 do with PHeightTileInfo(tileList[i])^ do
      begin
        Image321.Bitmap.FrameRectS(
          left-curX,
          top-curY,
          left+width-curX+1,
          top+height-curY+1,
          Color32(MapGridColor));
      end;
    end;

    if ((LayersLoaded>0)and (DrawShapes1.Checked)) then
    begin
      DataSizeMinOffX:= curX;
      DataSizeMinOffY:= curY;
      DVDORedraw;
    End;
    {Copy bitmap to Texture}
{Draw upside down here ? or switch Manmatrix twice?}
{CopyRect(Dest: TRect; Canvas: TCanvas; Source: TRect);}
    If  LOSint=3 then
    begin
      LOSint:=0;{keep from repeating Pete fell off who was left Repeat}

      Setlength(aManMatrix,sex ,sey );
      If MinimumElevation <0 then
         Correction:=abs(MinimumElevation)+1 else
         Correction:=1-MinimumElevation;
      MinimumElevation:=MinimumElevation+Correction;
      MaximumElevation:=MaximumElevation+Correction;
      for ty:=0 to sey-1 do
        for tx:=0 to sex-1 do
         ManMatrix[tx,ty]:=ManMatrix[tx,ty]+Correction;
      for ty:=0 to sey-1 do  {Reverse top side down}
        for tx:=0 to sex-1 do
         aManMatrix[tx,(sey-ty)-1]:=ManMatrix[tx,ty];
      for ty:=0 to sey-1 do
        for tx:=0 to sex-1 do
         ManMatrix[tx,ty]:=aManMatrix[tx,ty];
      MyRect.Left:=0;
      MyRect.Top:=0;
      MyRect.Right:=TiledBmp.width-1;
      MyRect.Bottom:=TiledBmp.height-1;
      bmpTile.Draw(0,0, Image321.Bitmap); {to get the shape image too}
      TinyBmp.Assign(bmpTile);
      TiledBmp.Canvas.stretchdraw(MyRect,TinyBmp);
      Application.ProcessMessages;
{      dtmGlHeightForm.Image2.picture.Bitmap.PixelFormat := pf32bit;
      dtmGlHeightForm.Image2.picture.Assign(TiledBmp);}
{      dtmGlHeightForm.Heightfield1.Material.Texture.Image.picture.Bitmap.PixelFormat := pf32bit;}
{      dtmGlHeightForm.Image2.picture.Assign(Image321.Bitmap);}
{      dtmGlHeightForm.Heightfield1.Material.Texture.Image.assign(dtmGlHeightForm.Image2.picture.Graphic);}
      dtmGlHeightForm.Heightfield1.Material.Texture.Image.assign(TiledBmp);
      dtmGlHeightForm.show;
      //Application.ProcessMessages;
      dtmGlHeightForm.FormShowDown(sex ,sey);
    End;
  finally
    tileList.Free;
  end;
  {Setlength(MiniMatrix,0,0);}
  TiledBmp.Free;
  TinyBmp.Free;
  {SetLength(PredA, 0);}
  Screen.Cursor := crDefault;
  QueryPerformanceFrequency(freq);
  LAMap.Caption:=Format(' %d x %d - %.1f ms HTF - %.1fms Draw ',
                         [htf.SizeX, htf.SizeY,
                          1000*htfTime/freq,
                          1000*drawTime/freq]);
End;

{Mostly duplicated BUT it only does 1 Tile}
procedure TDTMform.PrepareTileBitmap;
var
   sex,sey,mxx,myy,tx, ty : Integer;
   Correction:SmallInt;
   tileInfo : PHeightTileInfo;
   dataRow : PSmallIntArray;
   scanLine : PColor32Array;
   tile : PHeightTile;
   TinyBmp,TiledBmp:TBitmap;
   MyRect:TRect;
Begin
  LOSint:=0;{{GL form}
  if Assigned(htf) then
  begin
    mxx:=mx+curX;
    myy:=my+curY;
    tileInfo:=htf.XYTileInfo(mxx, myy);
    if Assigned(tileInfo) then
    begin
      tile:=htf.GetTile(tileInfo.left, tileInfo.top);
      FileSizeX:=tileinfo.width;
      FileSizeY:=tileInfo.height;
      sex:=tileInfo.Width;
      sey:=tileInfo.Height;
      SetLength(ManMatrix,tileInfo.width,tileInfo.height);
      If tileInfo.min <0 then
         Correction:=abs(tileInfo.min)+1 else
         Correction:=1-tileInfo.min;
      MinimumElevation:=tileInfo.min+Correction;
      MaximumElevation:=tileInfo.max+Correction;
      NullDemValue :=MinimumElevation;
      CellSizeX :=tileinfo.width;
      CellSizeY :=tileInfo.height;
      FileSizeX:=tileinfo.width;
      FileSizeY:=tileInfo.height;
      TinyBmp:=Tbitmap.Create;
      TinyBmp.width:=(tileinfo.width);
      TinyBmp.height:=(tileInfo.height);
      TinyBmp.PixelFormat := pf32bit;
      TiledBmp:=Tbitmap.Create;
      TiledBmp.width:=(tileinfo.width*2);
      TiledBmp.height:=(tileInfo.height*2);
      TiledBmp.PixelFormat := pf32bit;
      for ty:=0 to tileInfo.height-1 do
      begin
        {If ElevationTint1.Checked then}
        scanLine:=bmpTile.ScanLine[ty];
        dataRow:=@tile.data[ty*tileInfo.width];
        for tx:=0 to tileInfo.width-1 do
        begin
          ManMatrix[tx,(tileInfo.height-ty)-1]:=dataRow[tx]+Correction;
          If ElevationTint1.Checked then
          scanLine[tx]:=heightColor[dataRow[tx]];
        end;
      end;
      If ({(ElevationTint1.Checked) or}
         (SlopeTint1.Checked) or
         (SlopeDirectional1.Checked) or
         (SlopeSetDirection1.Checked) or
         (SlopeDirectional901.Checked) or
         (SlopePercent1.Checked)) then PrepTints(sex,sey)
      Else
      If (ContourLines1.Checked) then PrepContour1(sex,sey)
      else if    (ContourLinesAll1.Checked) then PrepContourAll(sex,sey)
      Else
      If ContourLines21.Checked then PrepContour2(sex,sey)
      Else If LOSMaskedArea1.Checked then PrepLOSArea(sex,sey)
      Else If Ecotype1.Checked then PrepEcoType(sex,sey);;

      MyRect.Left:=0;
      MyRect.Top:=0;
      MyRect.Right:=TiledBmp.width-1;
      MyRect.Bottom:=TiledBmp.height-1;
      TinyBmp.Assign(bmpTile);
      TiledBmp.Canvas.stretchdraw(MyRect,TinyBmp);
      {TiledBmp.SaveToFile('testy.bmp');}
        dtmGlForm.Image1.Picture.Assign(TinyBmp);
        dtmGlForm.Image2.picture.Bitmap.PixelFormat := pf32bit;
        dtmGlForm.Image2.picture.Assign(TiledBmp);
        dtmGlForm.Heightfield1.Material.Texture.Image.assign(dtmGlForm.Image2.picture.Graphic);
        dtmGlForm.show;
        dtmGlForm.FormShowDown(tileInfo.width,tileInfo.Height);
      TiledBmp.Free;
      TinyBmp.Free;
    end;
  end;
End;


procedure TDTMform.PrepTints(Xwin,Yhin:Integer);
var
  SlopePercent,
  C1, C2, C3, C4, C5, C6, C7,C8,
  Elevated,Cx,Cy, Elevator, sex, sey,tx, ty : Integer;
  scanLine : PColor32Array;
Begin
  sex:=Xwin;
  sey:=Yhin;
  { SlopeTint1 SlopeDirectional1  SlopeSetDirection1 SlopePercent1}
  IF ((SlopeTint1.Checked)
             or (SlopeDirectional1.Checked)
             or (SlopeSetDirection1.Checked)
             or (SlopeDirectional901.Checked) 
             or (SlopePercent1.Checked))then
  begin
          for ty:=1 to sey-2 do
          begin
            scanLine:=bmpTile.ScanLine[ty];
            for tx:=1 to sex-2 do
            begin
              scanLine[tx]:=Color32(MapBackgroundColor);
              Elevator:= ManMatrix[tx,ty];
              DataItem[9]:=Elevator;

              IF (SlopeTint1.Checked)then
              begin           {North Only}
              //for CY := -1 to 1 do
                CY := -1;
              begin
                for CX := -1 to 1 do
                begin
                  Elevated := ManMatrix[tx + CX, ty + CY];
                  if (Elevator < Elevated )
                  then scanLine[tx]:=Color32(RGB(255, 0,0)){Red 255,0,0}
                  //else scanLine[tx]:=heightColor[ManMatrix[tx,ty]];
                end;
              end;
            end else
            begin
{ NW [0]
  W [1]
  SW [2]
  N [3]
  C [4]
  S [5]
  NE [6]
  E [7]
 SE [8]}
              C1:= ManMatrix[tx -1, ty + 1];DataItem[1]:=C1;
              C2:= ManMatrix[tx , ty + 1];  DataItem[2]:=C2;
              C3:= ManMatrix[tx +1, ty + 1];DataItem[3]:=C3;
              C4:= ManMatrix[tx -1, ty + 0];DataItem[4]:=C4;
              C5:= ManMatrix[tx +1, ty + 0];DataItem[5]:=C5;
              C6:= ManMatrix[tx -1, ty - 1];DataItem[6]:=C6;
              C7:= ManMatrix[tx , ty - 1];  DataItem[7]:=C7;
              C8:= ManMatrix[tx +1, ty - 1];DataItem[8]:=C8;
              {Sort em        Elevated:=High(List1);}
              SortItQuick(9, DataItem);
              Elevated:=Round(DataItem[9]);{Highest}
              If ((SlopeSetDirection1.Checked)) then
              begin
                Case SlopeDirection of
                  0:if (Elevated= C1 )then scanLine[tx]:=
                  Color32(RGB(0, 0,255));
                 // Color32(RGB(255, 0,0));
                  1:if (Elevated= C2 )then scanLine[tx]:=
                  Color32(RGB(0, 255,255));
                  //Color32(RGB(255, 0,0));
                  2:if (Elevated= C3 )then scanLine[tx]:=
                  Color32(RGB(0, 255,0));
                  //Color32(RGB(255, 0,0));
                  3:if (Elevated= C4 )then scanLine[tx]:=
                  Color32(RGB(255, 255,0));
                  //Color32(RGB(255, 0,0));
                  4:if (Elevated= Elevator )then scanLine[tx]:=
                  Color32(RGB(255, 255,255));
                  //Color32(RGB(255, 0,0));
                  5:if (Elevated= C5 )then scanLine[tx]:=
                  Color32(RGB(255, 155,0));
                  //Color32(RGB(255, 0,0));
                  6:if (Elevated= C6 )then scanLine[tx]:=
                  Color32(RGB(255, 0,0));
                  //Color32(RGB(255, 0,0));
                  7:if (Elevated= C7 )then scanLine[tx]:=
                  Color32(RGB(255, 0,255));
                  //Color32(RGB(255, 0,0));
                  8:if (Elevated= C8 )then scanLine[tx]:=
                  Color32(RGB(255, 0,155));
                  //Color32(RGB(255, 0,0));
                end;
              end else
              If ((SlopeDirectional901.Checked)) then
              begin  {SlopeDirectional1}

{Smaug 255,0,155}if (Elevated= C8 )then scanLine[tx]:=Color32(RGB(255, 0,155))
{Purple 255,0,255}else if (Elevated= C7 )then scanLine[tx]:=Color32(RGB(255, 0,255))
{Red 255,0,0}   else if (Elevated= C6 )then scanLine[tx]:=Color32(RGB(255, 0,0))
{YeOrqange? 255,155,0}else if (Elevated= C5 )then scanLine[tx]:=Color32(RGB(255, 155,0))
{Yellow 255,255,0}else if (Elevated= C4 )then scanLine[tx]:=Color32(RGB(255, 255,0))
 {Green 0,255,0}else if (Elevated= C3 )then scanLine[tx]:=Color32(RGB(0, 255,0))
{Aqua 0,255,255}else if (Elevated= C2 )then scanLine[tx]:=Color32(RGB(0, 255,255))
{Blue 0,0,255 } else if (Elevated= C1 )then scanLine[tx]:=Color32(RGB(0, 0,255))
else scanLine[tx]:=Color32(RGB(255, 255,255));
              end else
              If ((SlopeDirectional1.Checked)) then
              begin  {SlopeDirectional1}
{Blue 0,0,255 } if (Elevated= C1 )then scanLine[tx]:=Color32(RGB(0, 0,255))
{Aqua 0,255,255}else if (Elevated= C2 )then scanLine[tx]:=Color32(RGB(0, 255,255))
 {Green 0,255,0}else if (Elevated= C3 )then scanLine[tx]:=Color32(RGB(0, 255,0))
{Yellow 255,255,0}else if (Elevated= C4 )then scanLine[tx]:=Color32(RGB(255, 255,0))
{YeOrqange? 255,155,0}else if (Elevated= C5 )then scanLine[tx]:=Color32(RGB(255, 155,0))
{Red 255,0,0}   else if (Elevated= C6 )then scanLine[tx]:=Color32(RGB(255, 0,0))
{Purple 255,0,255}else if (Elevated= C7 )then scanLine[tx]:=Color32(RGB(255, 0,255))
{Smaug 255,0,155}else if (Elevated= C8 )then scanLine[tx]:=Color32(RGB(255, 0,155))
else scanLine[tx]:=Color32(RGB(255, 255,255));
              end else
             If ((SlopePercent1.Checked)) then
              begin
                SlopePercent:=
                Round(abs(Elevator-Elevated)/SlopeCellSize);
                //Round(Elevator/Elevated);
                scanLine[tx]:=heightColor[SlopePercent];
              end else Showmessage('Slope Menu error');
            end;
          end;
        end;
      end
End;
{************ Begin of SortItQuick ***************************************}
procedure TDTMform.SortItQuick(Count: Integer; var Item: ScoreList);
  { Making the Array a variable means less copying and space is saved }
{*************************************************************************
*         A recursive procedure made of 2 other procedures.
*         The SortItQuick is a mask to pass the variable to PartialSort
*         which does most of the work.  When a number is found to be sorted
*         the procedure Switch exchanges the 2 numbers.
*************************************************************************}
{********* Recursive procedure inside SortItQuick ************************}
  procedure PartialSort(left, right: Integer; var InArray:ScoreList);
{**************************************************************************
*         This procedure is documented along with the Source code in
*         an effort to effectively allow the understanding of the algorithm.
***************************************************************************}
  var
    k: Real; { used in PartialSort to determine the middle
                               of the array and use it to compare with
                               elements in the array as they are processed }
    i,j:Integer;
{********* Recursive procedure inside SortItQuick *************************}
    procedure Switch(var A, B: Real);
                      { Variable so it will return the numbers as switched }
    var
      C: Real; { The A,B,C Reals are switched around using C as }
    begin { temporary storage passage space.               }
      if A <> B then
      begin
        C := A;
        A := B;
        B := C;
      end;
    end;
{************ End of Switch ***********************************************}
{************ Begin of PartialSort ****************************************}
  begin
    k := (InArray[left] + InArray[right]) / 2;
       { Find the middle of Array to start from }
    i := left;
      { Duplicated to be able to keep the ends while changing }
    j := right;
      { the number that is being referenced in the array      }

    repeat
      while InArray[i] < k do
        { 1 of 2 : Change > to < for Ascending sort   }
        Inc(i);
          { Inc and Dec Increase or Decrease the variable by 1    }

      while k < InArray[j] do
        { 2 of 2 : Change > to < for Ascending sort   }
        Dec(j); { if it is Dec(i,n) the n can be up to a Longint }

      if i <= j then
        { if the left is less than the right then switch the    }
      begin { Numbers in the array                                  }
        Switch(InArray[i], InArray[j]);
        Inc(i);
        Dec(j);
      end;
    until i > j;

    if left < j then
      { Check to see if the original left has been passed   }
      PartialSort(left, j, InArray); { by the working right }
    if i < right then
      PartialSort(i, right, InArray);
  end;
{************ End of PartialSort ******************************************}
{************ Begin of SortItQuick ****************************************}
begin { Actual start of SortItQuick procedure }
  PartialSort(1, Count, Item);
    { Pass the parameters to PartialSort    }
end;
{************ End of SortItQuick ******************************************}

          {Set Data into Matrix}
{          Setlength(MiniMatrix,tileinfo.width ,tileInfo.height );}
(*          for ty:=0 to tileInfo.height-1 do
          begin
            dataRow:=@tile.data[ty*tileInfo.width];
            for tx:=0 to tileInfo.width-1 do
                MiniMatrix[tx,ty]:=dataRow[tx];
            scanLine:=bmpTile.ScanLine[ty];
            If ((ty=0) or (ty=tileInfo.height-1)) then
            begin
              If UseContourColors then
                 for tx:=0 to tileInfo.width-1 do
                 scanLine[tx]:=Color32(MapBacksColor){heightColor[dataRow[tx]]}
              else
                 for tx:=0 to tileInfo.width-1 do
                 scanLine[tx]:=Color32(MapBacksColor);
            end else
            begin
              If UseContourColors then
              begin
                scanLine[0]:=Color32(MapBacksColor);{heightColor[dataRow[0]];}
                scanLine[tileInfo.width-1]:=Color32(MapBacksColor);{heightColor[dataRow[tileInfo.width-1]];}
              end else
              begin
                scanLine[0]:=Color32(MapBacksColor);
                scanLine[tileInfo.width-1]:=Color32(MapBacksColor);
              end;
            end;
          end;
*)
procedure TDTMform.PrepContour1(Xwin,Yhin:Integer);
var
  MiniMe,Mini,Counts, Countless, Elevated,Cx,Cy,
  Elevator, sex,sey, tx, ty : Integer;
  scanLine : PColor32Array;
Begin
  sey:=Yhin;
  sex:=Xwin;
  IF ((ContourLines1.Checked)or(ContourLinesAll1.Checked)) then
  begin
    Counts := ((MaximumElevation - MinimumElevation) div ContourInterval);
    MiniMe:=ContourInterval;
    While MinimumElevation > MiniMe do MiniMe:=MiniMe+MiniMe;
    for ty:=1 to sey-2 do
    begin
      scanLine:=bmpTile.ScanLine[ty];
      for tx:=1 to sex-2 do
      begin
        Application.ProcessMessages;
        If LOSQuit then Exit;
        If ((ManMatrix[tx,ty] mod ContourInterval)=0)then
        begin
          If UseContourColors then
            scanLine[tx]:= heightColor[ManMatrix[tx,ty]]{MapBordersColor}
            else scanLine[tx]:= Color32(MapContourColor);
        end
        else
        begin
          scanLine[tx]:=Color32(MapBackgroundColor);
          Mini:=MiniMe- ContourInterval;
          Elevator:= ManMatrix[tx,ty];
          Countless:= 0;
          Repeat
          begin
                Application.ProcessMessages;
                If LOSQuit then Exit;
            inc(Countless);
            Mini:=Mini+ ContourInterval;
            for CY := -1 to 1 do
            begin
              for CX := -1 to 1 do
              begin
                Elevated := ManMatrix[tx + CX, ty + CY];
                if (((Elevator) = Mini) or
                   ((Elevator < Mini) and (Elevated > Mini))
                   or ((Elevator > Mini) and (Elevated < Mini)))
                then
                begin
                  If UseContourColors then
                     scanLine[tx]:= heightColor[ManMatrix[tx,ty]]
                  else scanLine[tx]:= Color32(MapContourColor);
                  Countless:= Counts;//   break;
                end;
              end;
            end;
          end;
          until Countless= Counts;
        end;
      end;
    end;
  end;
End;


procedure TDTMform.PrepContourAll(Xwin,Yhin:Integer);
var
  LocalContourInterval,Range,
  C1, C2, C3, C4, C5, C6, C7,
  sex,sey,Elevator, {Elevated, Cx,Cy,} tx, ty : Integer;
  scanLine : PColor32Array;
Begin
  sey:=Yhin;
  sex:=Xwin;
  {Check Matrix Contours}
  Range:=(MaximumElevation-MinimumElevation);
  LocalContourInterval:=(Range div 7);
  C1 := (MinimumElevation + LocalContourInterval);
  C2 := (MinimumElevation + (LocalContourInterval * 2));
  C3 := (MinimumElevation + (LocalContourInterval * 3));
  C4 := (MinimumElevation + (LocalContourInterval * 4));
  C5 := (MinimumElevation + (LocalContourInterval * 5));
  C6 := (MinimumElevation + (LocalContourInterval * 6));
  C7 := (MinimumElevation + (LocalContourInterval * 7));

  for ty:=1 to sey-2 do
  begin
    scanLine:=bmpTile.ScanLine[ty];
    for tx:=1 to sex-2 do
    begin
      Application.ProcessMessages;
      If LOSQuit then Exit;
      scanLine[tx]:=Color32(MapBackgroundColor);
      Elevator:= ManMatrix[tx,ty];
      if (Elevator = MaximumElevation) then
        scanLine[tx]:= Color32(clWhite)
      else
      if ((Elevator >= MinimumElevation)
            and (Elevator <= C1)) then
      begin
scanLine[tx]:=Color32(RGB(0, 0,255));
      end else
      if ((Elevator >= C1) and (Elevator <= C2)) then
      begin
scanLine[tx]:=Color32(RGB(0, 255,255));
      end else
      if ((Elevator >= C2) and (Elevator <= C3)) then
      begin
scanLine[tx]:=Color32(RGB(0, 255,0));
      end else
      if ((Elevator >= C3) and (Elevator <= C4)) then
      begin
scanLine[tx]:=Color32(RGB(255, 255,0));
      end else
      if ((Elevator >= C4) and (Elevator <= C5)) then
      begin
scanLine[tx]:=Color32(RGB(255, 0,0));
      end else
      if ((Elevator >= C5) and (Elevator <= C6)) then
      begin
scanLine[tx]:=Color32(RGB(255,0,255));
      end else
      if ((Elevator >= C6) and (Elevator <= C7)) then
      begin
scanLine[tx]:=Color32(RGB(255,255,255));
      end;
    end;
  end;{END of the TINTS}
End;


procedure TDTMform.PrepContour2(Xwin,Yhin:Integer);
var
  LocalContourInterval,Range,
  C1, C2, C3, C4, C5, C6, C7,
  sex,sey,Elevator, Elevated, Cx,Cy, tx, ty : Integer;
  scanLine : PColor32Array;
Begin
  sey:=Yhin;
  sex:=Xwin;
  {Check Matrix Contours}
  Range:=(MaximumElevation-MinimumElevation);
  LocalContourInterval:=(Range div 7);
  C1 := (MinimumElevation + LocalContourInterval);
  C2 := (MinimumElevation + (LocalContourInterval * 2));
  C3 := (MinimumElevation + (LocalContourInterval * 3));
  C4 := (MinimumElevation + (LocalContourInterval * 4));
  C5 := (MinimumElevation + (LocalContourInterval * 5));
  C6 := (MinimumElevation + (LocalContourInterval * 6));
  C7 := (MinimumElevation + (LocalContourInterval * 7));

  for ty:=1 to sey-2 do
  begin
    scanLine:=bmpTile.ScanLine[ty];
    for tx:=1 to sex-2 do
    begin
      Application.ProcessMessages;
      If LOSQuit then Exit;
      scanLine[tx]:=Color32(MapBackgroundColor);
      Elevator:= ManMatrix[tx,ty];
      if (Elevator = MaximumElevation) then
        scanLine[tx]:= Color32(clWhite)
      else
      if ((Elevator >= MinimumElevation)
            and (Elevator <= C1)) then
      begin
        scanLine[tx]:=Color32(MapBackgroundColor);
        for CY := -1 to 1 do begin
          for CX := -1 to 1 do begin
            Elevated := ManMatrix[tx + CX, ty + CY];
            if ((Elevator = C1) or
               ((Elevator < C1) and (Elevated > C1))
            or ((Elevator > C1) and (Elevated < C1)))
            then begin
              scanLine[tx]:=Color32(RGB(0, 0,255));
            end;
          end;
        end;
      end else
      if ((Elevator >= C1) and (Elevator <= C2)) then
      begin
        scanLine[tx]:=Color32(MapBackgroundColor);
        for CY := -1 to 1 do begin
          for CX:= -1 to 1 do begin
            Elevated := ManMatrix[tx + CX, ty + CY];
            if ((Elevator = C2) or
               ((Elevator < C2) and (Elevated > C2))
            or ((Elevator > C2) and (Elevated < C2)))
            then begin
              scanLine[tx]:=Color32(RGB(0, 255,255));
            end;
          end;
        end;
      end else
      if ((Elevator >= C2) and (Elevator <= C3)) then
      begin
        scanLine[tx]:=Color32(MapBackgroundColor);
        for CY := -1 to 1 do begin
          for CX:= -1 to 1 do begin
            Elevated := ManMatrix[tx + CX, ty + CY];
            if ((Elevator = C3) or
               ((Elevator < C3) and (Elevated > C3))
            or ((Elevator > C3) and (Elevated < C3)))
            then begin
              scanLine[tx]:=Color32(RGB(0, 255,0));
            end;
          end;
        end;
      end else
      if ((Elevator >= C3) and (Elevator <= C4)) then
      begin
        scanLine[tx]:=Color32(MapBackgroundColor);
        for CY := -1 to 1 do begin
          for CX := -1 to 1 do begin
            Elevated := ManMatrix[tx + CX, ty + CY];
            if ((Elevator = C4) or
               ((Elevator < C4) and (Elevated > C4))
            or ((Elevator > C4) and (Elevated < C4)))
            then begin
              scanLine[tx]:=Color32(RGB(255, 255,0));
            end;
          end;
        end;
      end else
      if ((Elevator >= C4) and (Elevator <= C5)) then
      begin
        scanLine[tx]:=Color32(MapBackgroundColor);
        for CY := -1 to 1 do begin
          for CX := -1 to 1 do begin
            Elevated := ManMatrix[tx + CX, ty + CY];
            if ((Elevator = C5) or
               ((Elevator < C5) and (Elevated > C5))
            or ((Elevator > C5) and (Elevated < C5)))
            then begin
              scanLine[tx]:=Color32(RGB(255, 0,0));
            end;
          end;
        end;
      end else
      if ((Elevator >= C5) and (Elevator <= C6)) then
      begin
        scanLine[tx]:=Color32(MapBackgroundColor);
        for CY := -1 to 1 do begin
          for CX := -1 to 1 do begin
            Elevated := ManMatrix[tx + CX, ty + CY];
            if ((Elevator = C6) or
               ((Elevator < C6) and (Elevated > C6))
            or ((Elevator > C6) and (Elevated < C6)))
            then begin
              scanLine[tx]:=Color32(RGB(255,0,255));
            end;
          end;
        end;
      end else
      if ((Elevator >= C6) and (Elevator <= C7)) then
      begin
        scanLine[tx]:=Color32(MapBackgroundColor);
        for CY := -1 to 1 do begin
          for CX := -1 to 1 do begin
            Elevated := ManMatrix[tx + CX, ty + CY];
            if ((Elevator = C7) or
               ((Elevator < C7) and (Elevated > C7))
            or ((Elevator > C7) and (Elevated < C7)))
            then begin
              scanLine[tx]:=Color32(RGB(255,255,255));
            end;
          end;
        end;
      end;
    end;
  end;{END of the TINTS}
End;

procedure TDTMform.PrepLOSArea(Xwin,Yhin:Integer);
var
  fraction, xd, yd: DOUBLE;
  i, j: DWord;
  Circle,RoundAbout,Blinder, k,PixelDistance,
  sex,sey, tx2, ty2, tx, ty : Integer;
  scanLine : PColor32Array;
  Keeper:Shortint;
  MiniMatrix:Array of array of Boolean;
function Distance(const x1,x2, y1,y2: Integer): DOUBLE;
begin
  RESULT := SQRT(SQR(x1 - x2) + SQR(y1 - y2))
end {Distance};
begin
//LOSHeight LOSRange  LOSDirection  LOSAngle
  sex:=Xwin;
  sey:=Yhin;
  Setlength(MiniMatrix ,sex ,sey );
  {Compute LOS}
  Circle:= (2*sex)+(2*(sey-2))-1;
  For RoundAbout:=0 to Circle do
  begin
    If ((RoundAbout<sex)) then
    begin {Top}
      ty2:=0;
      tx2:=RoundAbout;
    end else
    If ((RoundAbout<(2*sex)-1)) then
    begin {Bottom}
      ty2:=sey-1;
      tx2:=RoundAbout-sex
    end else
    If ((RoundAbout<((2*sex)+sey-1))) then
    begin {Left side}
       ty2:=RoundAbout-(2*sex);
       tx2:=0;
    end else
    begin  {Right side}
      ty2:=RoundAbout-((2*sex)+sey);
      tx2:=sex-1;
    end;

    PixelDistance := TRUNC(Distance(mx,tx2,my,ty2)+ 0.5);
    Keeper:=ManMatrix[mx,my]+LOSHeight;
    Blinder :=0;
    for k := 1 to PixelDistance-1 do
    begin
      fraction := k / PixelDistance;
        // Add 0.5 to endpoints so "line" is from center of pixel
      xd := (1.0 - fraction) * (mx + 0.5) +fraction * (tX2 + 0.5);
      yd := (1.0 - fraction) * (mY + 0.5) +fraction * (tY2 + 0.5);
      i := TRUNC(xd);
      j := TRUNC(yd);
        {Figure out the LOS}
        {First valley}
      If ((Keeper > ManMatrix[i,j])and (Keeper >Blinder))then MiniMatrix[i,j]:=False
        else {first upslope}
      If ((Keeper < ManMatrix[i,j])and (ManMatrix[i,j] >Blinder)) then
      begin
        Blinder :=ManMatrix[i,j];
        MiniMatrix[i,j]:=False;
      end else
      If ManMatrix[i,j]< Blinder then MiniMatrix[i,j]:=True;
    end;
  end;{Circle}
    {Paint LOS}
  for ty:=0 to sey -1 do
  begin
    scanLine:=bmpTile.ScanLine[ty];
    for tx:=0 to sex-1 do
    begin
      If MiniMatrix[tx,ty] then
         scanLine[tx]:=Color32(clred) else
      If (not MiniMatrix[tx,ty]) then
          scanLine[tx]:=heightColor[ManMatrix[tx,ty]];
    end;
  end;    {tile list}
  //Paint Starting Point  LOSFanLimitsCB
  for ty:=my-LOSRange to my +LOSRange do
  begin
    scanLine:=bmpTile.ScanLine[ty];
    for tx:=mx-LOSRange to mx +LOSRange do
    begin
      If ((tx=mx) and (ty=my)) then
        scanLine[tx]:=heightColor[ManMatrix[tx,ty]]else
        scanLine[tx]:=Color32(MapBlankColor);
    end;
  end;
  Setlength(MiniMatrix ,0 ,0 );
end;
{==============================================================}

{==============================================================}
{==============================================================}
procedure TDTMform.Image321MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer; Layer: TCustomLayer);
var
   tileIdx, n : Integer;
   tileInfo : PHeightTileInfo;
begin
  {if ((ssLeft in shift)and(ssAlt in shift))then
   begin
   end else }
  if Dragging then //Same for LOS 1 and Path 666
  begin
    Image321.Bitmap.LineToS(X, Y);
    Image321.Invalidate;  // be sure to refresh the image
  end else
  if (ssLeft in shift) then    {Move the area}
  begin
    curX:=curX-(x-mx);
    curY:=curY-(y-my);
    mx:=x;
    my:=y;
    PrepareBitmap;
{    Image321.Refresh;}
  end;
  if Assigned(htf) then  //get data and display stats
  begin
    x:=x+curX;
    y:=y+curY;
    StatusBar.Panels[0].Text:=' X: '+IntToStr(x){+','+IntToStr(curx)};
    StatusBar.Panels[1].Text:=' Y: '+IntToStr(y){+','+IntToStr(cury)};
    StatusBar.Panels[2].Text:=' H: '+IntToStr(htf.XYHeight(x, y));

    tileInfo:=htf.XYTileInfo(x, y);
    if Assigned(tileInfo) then
    begin
      tileIdx:=htf.IndexOfTile(tileInfo);
      StatusBar.Panels[3].Text:=' Tile: '+IntToStr(tileIdx);
      n:=htf.TileCompressedSize(tileIdx)+SizeOf(THeightTileInfo);
      StatusBar.Panels[4].Text:=Format(' %.2f kB (%.0f %%)',
                                          [n/1024, 100-100*n/(htf.TileSize*htf.TileSize*2)]);
      StatusBar.Panels[5].Text:=Format(' Tile average: %d, range: [%d; %d])',
                                          [tileInfo.average, tileInfo.min, tileInfo.max]);
    end else
    begin
      StatusBar.Panels[3].Text:=' Tile: N/A';
      StatusBar.Panels[4].Text:=' N/A';
      StatusBar.Panels[5].Text:=' N/A';
    end;
  end;{if htf}
end;


procedure TDTMform.Image321MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
var
  SaveFileName, BackupName: string;
begin
  if (ssRight in shift)then
  begin
    if Assigned(htf) then //Launch HTF Properties Dialog
    showmessage(
      'X: '+ inttostr(htf.SizeX)+' : '+ floattostr(htf.SizeX/htf.TileSize)+#13#10+
      'Y: '+ inttostr(htf.SizeY)+' : '+ floattostr(htf.SizeY/htf.TileSize)+#13#10+
      'TileSize: '+ inttostr(htf.TileSize)+#13#10+
      'DefaultZ: '+ inttostr(htf.DefaultZ)+#13#10+
      'Current Rez Level: '+ inttostr(CurrentRezLevel));
  end else
  {simple drawing on image for Path Route selection}
  If LOSint=666 then
  begin
    //Do nothing
  end else
  {If ... click then make it 3D}
  if ((ssCtrl in shift)and (ssShift in shift)and NoGLRunning) then
  begin
    mx:=X;
    my:=Y;
    NoGLRunning:=False;
    LOSint:=4;
    PrepareBitmap;   {Shift+Ctrl 4 Terrain Renderer Full Size}
  end
  else
  if ((ssShift in shift)and(ssAlt in shift)and NoGLRunning) then
  begin
    mx:=X;
    my:=Y;
    NoGLRunning:=False;
    LOSint:=3;
    PrepareBitmap;   {Shift+Alt 3  Full Screen Size}
  end
  else    ///
  if ((ssCtrl in shift)and(ssShift in shift)and(ssAlt in shift)and NoGLRunning) then
  begin
  //  Dunno what yet.. Place holder to make sure it works
  showmessage('You pressed [Ctrl]+[Alt]+[Shift]');
  end
  else
  if ((ssShift in shift)and NoGLRunning) then
  begin
    mx:=X;
    my:=Y;
    NoGLRunning:=False;
    LOSint:=2;
    PrepareBitmap;   {Shift 2  Tile Size}
  end
  else
  if ((ssCtrl in shift)and (ssAlt in shift)and NoGLRunning) then
  begin
  //Zoom OUT
  If CurrentRezLevel> 1 then
  begin
    dec(CurrentRezLevel);
    //Load LOWER REZ data
  end;
  end else
  if ((ssCtrl in shift)and NoGLRunning) then
  begin
  //Zoom IN
  If CurrentRezLevel < 11 then
  begin
    inc(CurrentRezLevel);
    //Load HIGHER REZ data
  end;
  end else
  if ((ssAlt in shift)) then
  begin      {Alt  Save bitmap image}
   SaveFileName:=ImagePath+ChangeFileExt(HTFName,'.bmp');
    if FileExists(SaveFileName) then
    begin
      BackupName := ExtractFileName(SaveFileName);
      BackupName := ChangeFileExt(BackupName, '.BAK');
      if not RenameFile(SaveFileName, BackupName) then
        raise Exception.Create('Unable to create backup file.');
    end;
   Image321.Bitmap.SaveToFile(SaveFileName);
  end else
  {simple drawing on image for LOS area selection}
  If LOSint=1 then
  begin
    Dragging:=True;
    mx:=X;
    my:=Y;
    Image321.Bitmap.MoveTo(X, Y);
  end else
  begin
    Image321.Cursor:=crSizeAll;
    mx:=X;
    my:=Y;
  end;
end;

procedure TDTMform.Image321MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
begin
  If LOSint=666 then
  begin
    if ((ssAlt in shift)) then
    begin
      //Place Target AND Store the CurrentTargetLocation
      //X,Y Z from IntToStr(htf.XYHeight(x, y))
      //CurrentTargetLocation:= VectorMake(X, Y, htf.XYHeight(x, y), 1);
    end else
    begin
      mx:=X;
      my:=Y;
      If Dragging then
      begin
        Image321.Bitmap.LineToS(X, Y);
        Image321.Invalidate;  // be sure to refresh the image
      end else
      begin
        Image321.Bitmap.MoveTo(X, Y);
        Dragging:=True;
      end;
      inc(TotalNodes);
      Setlength(GPFNodes,TotalNodes);
      GPFNodes[TotalNodes-1].Position[0]:=mx+curX;
      GPFNodes[TotalNodes-1].Position[1]:=my+curY;
      GPFNodes[TotalNodes-1].Position[2]:=(htf.XYHeight(x, y));
      GPFNodes[TotalNodes-1].Rotation[0]:=0;
      GPFNodes[TotalNodes-1].Rotation[1]:=0;
      GPFNodes[TotalNodes-1].Rotation[2]:=0;
      GPFNodes[TotalNodes-1].Scale[0]:=1;
      GPFNodes[TotalNodes-1].Scale[1]:=1;
      GPFNodes[TotalNodes-1].Scale[2]:=1;
      GPFNodes[TotalNodes-1].Speed:=1;
      GPFNodes[TotalNodes-1].NodeNumber:= TotalNodes-1;
      //Do the Path Routine to Store the Point
      {FPosition := VectorMake(X, Y, (htf.XYHeight(x, y), 1);
       FRotation := VectorMake(0, 0, 0, 1);
       FScale    := VectorMake(1, 1, 1, 1);
       FSpeed    := 0;
       FTarget   := CurrentTargetLocation; }
    end;
  end else
  begin //Normal stuff
    Image321.Cursor:=crDefault;
    Dragging := False;
    If LOSint=1 then
    begin
      LOSint:=0;
      AllBtnsUp;
      ElevationTint1.Checked:=True;
      PrepareBitmap;
      //Redraw the LOS Line
      Image321.Bitmap.MoveTo(mX, mY);
      Image321.Bitmap.LineToS(X, Y);
      LineProfileForm.Show;
      LineProfileForm.UpdateImage(mx+curX,x+curX,my+curY,y+curY);
    end;
  end;
end;

procedure TDTMform.Image321Resize(Sender: TObject);
begin
   if Assigned(htf) then
   begin
     Image321.Bitmap.SetSize(DTMform.ClientWidth,
                            (DTMform.ClientHeight-47));
     ScreenHeight:=Image321.Height;
     ScreenWidth:=Image321.Width;
     if Assigned(htf) then PrepareBitmap;
   end;
end;
{==============================================================}


{==============================================================}
{gridlines,
 coordinate conversion,}
{Produce Elevation Tints,
Slope Tints,
Contours,
Line of Sight,
LOS Masked Areas, and
Perspective Views}
procedure TDTMform.TBGridClick(Sender: TObject);
begin   {Default is ON}
  If Grid1.Checked then TBGrid.Down:=False
     else TBGrid.Down:=True;
  Grid1.Checked := TBGrid.Down;
  PrepareBitmap;
end;
procedure TDTMform.Redraw1Click(Sender: TObject);
begin
  PrepareBitmap;
end;

procedure TDTMform.DrawShapes1Click(Sender: TObject);
begin
  DrawShapes1.Checked := (not DrawShapes1.Checked); 
end;

procedure TDTMform.AllBtnsUp;
Begin
  ElevationTint1.Checked:=False;
  SlopeTint1.Checked:=False;
  SlopeDirectional1.Checked:=False;
  SlopeSetDirection1.Checked:=False;
  SlopeDirectional901.Checked:=False;
  SlopePercent1.Checked:=False;
  ContourLines1.Checked:=False;
  ContourLinesAll1.Checked:=False;
  ContourLines21.Checked:=False;
  LOSLineAtoB1.Checked:=False;
  LOSMaskedArea1.Checked:=False;
  Ecotype1.Checked:=False;
End;
procedure TDTMform.ElevationTint1Click(Sender: TObject);
begin
  AllBtnsUp;
  ElevationTint1.Checked:=True;
end;
procedure TDTMform.SlopeTint1Click(Sender: TObject);
begin
  AllBtnsUp;
  SlopeTint1.Checked:=True;
end;
procedure TDTMform.SlopeDirectional1Click(Sender: TObject);
begin
  AllBtnsUp;
  SlopeDirectional1.Checked:=True;
end;
procedure TDTMform.SlopeDirectional901Click(Sender: TObject);
begin
  AllBtnsUp;
  SlopeDirectional901.Checked:=True;
end;
procedure TDTMform.SlopeSetDirection1Click(Sender: TObject);
begin
  AllBtnsUp;
  SlopeSetDirection1.Checked:=True;
end;

procedure TDTMform.SlopePercent1Click(Sender: TObject);
begin
  AllBtnsUp;
  SlopePercent1.Checked:=True;
end;

//Contour Lines.. Division by ZERO.. water, etc...
procedure TDTMform.ContourLines1Click(Sender: TObject);
begin
  AllBtnsUp;
  ContourLines1.Checked:=True;
end;
procedure TDTMform.ContourLinesAll1Click(Sender: TObject);
begin
  AllBtnsUp;
  ContourLinesAll1.Checked:=True;
end;
procedure TDTMform.ContourLines21Click(Sender: TObject);
begin
  AllBtnsUp;
  ContourLines21.Checked:=True;
end;

{Two points required: Start and end point of LOS}
procedure TDTMform.LOSLineAtoB1Click(Sender: TObject);
begin
    AllBtnsUp;
    LOSLineAtoB1.Checked:=True;
    LOSint:=1;
end;
//inherent to mouse call now ?
procedure TDTMform.DoLOSint(LOSintin,X,Y:Integer);
begin
{  showmessage(
    'Which '+Inttostr(LOSint)+
    ' startx '+Inttostr(mx+curX)+
    ' x '+Inttostr(X+curX)+
    ' starty '+Inttostr(my+curY)+
    ' y '+Inttostr(Y+curY));}
  LOSint:=0;
  If LOSintin=1 then
  begin {LineofSight Line}
    LineProfileForm.Show;
    LineProfileForm.UpdateImage(mx+curX,x+curX,my+curY,y+curY);
  end;
end;

{The LOS Area is of the full screen in 3D,
Colors: Green is visible, Red is concealed}
procedure TDTMform.LOSMaskedArea1Click(Sender: TObject);
begin
  AllBtnsUp;
  LOSMaskedArea1.Checked:=True;
end;

procedure TDTMform.Ecotype1Click(Sender: TObject);
begin
  AllBtnsUp;
  Ecotype1.Checked:=True;
end;
{==============================================================}

{==============================================================}
procedure TDTMform.PrepEcoType(Xwin,Yhin:Integer);
var
  StepLevel, StepLevelCount, Step, Stepcount: Integer;
  TotRez,Rez:Double;
  RezEly,RezRely,RezSlope,RezSlopeDir:Double;

  HiEl,LoEl,
  MinRezEly,MinRezRely,MinRezSlope,
  TotRezEly,TotRezRely,TotRezSlope,
  REX, RexSq,RelativeElevation, SlopeDir,
  Slope2,CX2,CY2, Slope,CX,CY:Double;
  WidthX,HeightY, tx, ty : Integer;
  scanLine : PColor32Array;
  EcoMatrix: array of array of array of Double;
Begin
  HeightY:=Yhin-2;
  WidthX:=Xwin-2;
  MinRezEly:=0;MinRezRely:=0;MinRezSlope:=0;LoEl:=0;
  TotRezEly:=0;TotRezRely:=0;TotRezSlope:=0;HiEl:=0;
  {Precompute  Data into Matrix}
  Setlength(EcoMatrix,10 ,EcoLevelsProcessed+1, 4 );
  for Step:=0 to 9 do
  for StepLevel:=0 to EcoLevelsProcessed do
  begin
    EcoMatrix[Step,StepLevel,0]:=(EcoRecord[Step,StepLevel].ElevMax-EcoRecord[Step,StepLevel].ElevMin);
    EcoMatrix[Step,StepLevel,1]:=(EcoRecord[Step,StepLevel].REMax-EcoRecord[Step,StepLevel].REMin);
    EcoMatrix[Step,StepLevel,2]:=(EcoRecord[Step,StepLevel].SlopeMax-EcoRecord[Step,StepLevel].SlopeMin);
    EcoMatrix[Step,StepLevel,3]:=(EcoRecord[Step,StepLevel].SlopeDirMax-EcoRecord[Step,StepLevel].SlopeDirMin)
  end;
  {Inner Bounds.. leaves an 'edge'}
  for ty:=1 to HeightY do
  begin
    scanLine:=bmpTile.ScanLine[ty];
    for tx:=1 to WidthX do
    begin
      {EcoMatrix[tx,ty]:=ManMatrix[tx,ty];}
      CY := (ManMatrix[tx,ty+1] - ManMatrix[tx,ty-1])/2;
      CX := (ManMatrix[tx+1,ty] - ManMatrix[tx-1,ty])/2;
      Slope :=  {Sqrt}(CX+ CY);
      Slope2:=Slope / sqrt((Slope*Slope)+1);
      CX2:=CX*CX;
      CX2:=CX / sqrt((CX2)+1);
      CY2:=CY*CY;
      CY2:=CY / sqrt((CY2)+1);
      SlopeDir:=CX2+CY2;
      REX:=ManMatrix[tx,ty]-
      ((ManMatrix[tx+1,ty-1]+
       ManMatrix[tx+1,ty+1]+
       ManMatrix[tx-1,ty+1]+
       ManMatrix[tx-1,ty-1])  /4);
       RexSq:=REX / sqrt((REX*REX)+1);
       RelativeElevation:=  RexSq;

  TotRez:=0;
  Stepcount:=1;
  StepLevelCount:=0;
  for Step:=1 to 9 do
  for StepLevel:=0 to EcoLevelsProcessed do
  begin       {EcoRecord[ChangeColX,ChangeRowY]}
  RezEly:= abs((ManMatrix[tx,ty]-(EcoMatrix[Step,StepLevel,0]))
           /EcoMatrix[Step,StepLevel,0]);
  RezEly:=  power( 0.5, RezEly);
  RezEly:=  power( RezEly,EcoRecord[Step,StepLevel].ElevSharpness);
{  RezEly:=  power( 0.5, RezEly);}
{  RezEly:= power( power( 0.5,EcoRecord[Step,StepLevel].ElevSharpness),RezEly);}

  RezRely:= ( (RelativeElevation-(EcoMatrix[Step,StepLevel,1]))
           /EcoMatrix[Step,StepLevel,1]);
  RezRely:=  power( 0.5, RezRely);
  RezRely:=  power( RezRely,EcoRecord[Step,StepLevel].RESharpness);

  RezSlope:= ((Slope2-(EcoMatrix[Step,StepLevel,2]))
           /EcoMatrix[Step,StepLevel,2]);
  RezSlope:=  power( 0.5, RezSlope);
  RezSlope:=  power( RezSlope,EcoRecord[Step,StepLevel].SlopeSharpness);

  RezSlopeDir:= ((SlopeDir-(EcoMatrix[Step,StepLevel,3]))
           /EcoMatrix[Step,StepLevel,3]);
  RezSlopeDir:=  power( 0.5, RezSlopeDir);
  RezSlopeDir:=  power( RezSlopeDir,EcoRecord[Step,StepLevel].SlopeDirSharpness);

  Rez:= RezEly+ RezRely+ RezSlope+RezSlopeDir;
  {Sun Rises from East so What?} {then Valley UpDown else if}{Shady?}
  If Rez > TotRez then
  begin
  TotRez:=Rez;
  Stepcount:=Step ;
  StepLevelCount:=StepLevel;
  end;
  end;
  {StatusBar.Panels[5].Text:=  Floattostr(TotRez);
  Application.ProcessMessages;}
    scanLine[tx]:=Color32(EcoRecord[Stepcount,StepLevelCount].Color);

        If EcoBool[4]=True then
        begin
        If ManMatrix[tx,ty] > HiEl then HiEl:=ManMatrix[tx,ty];
        If ManMatrix[tx,ty] < LoEl then LoEl:=ManMatrix[tx,ty];
        If RelativeElevation > TotRezEly then TotRezEly:=RelativeElevation;
        If Slope2 > TotRezRely then TotRezRely:=Slope2;
        If SlopeDir > TotRezSlope then TotRezSlope:=SlopeDir;
        If RelativeElevation < MinRezEly then MinRezEly:=RelativeElevation;
        If Slope2 < MinRezRely then MinRezRely:=Slope2;
        If SlopeDir < MinRezSlope then MinRezSlope:=SlopeDir;
        If ( (Slope2> 0) and (Slope2< 0.4)) then
          begin      {HINT Debugging}
           StatusBar.Panels[5].Text:=  Floattostr(
           {RelativeElevation}
           Slope2
           {SlopeDir} ) ;
           Application.ProcessMessages;
          end;
        end;
    end;
  end;
  If EcoBool[4]=True then
     showmessage(
  'E: '+Floattostr((HiEl))+#13#10+
  'R: '+Floattostr((TotRezEly))+  #13#10+
  'S: '+Floattostr((TotRezRely))+#13#10+
  'sD: '+Floattostr((TotRezSlope))
       +  #13#10+  #13#10+
  'E-: '+Floattostr((LoEl))+#13#10+
  'R-: '+Floattostr((MinRezEly))+  #13#10+
  'S-: '+Floattostr((MinRezRely))+#13#10+
  'sD-: '+Floattostr((MinRezSlope)) );
  Setlength(EcoMatrix,0 ,0, 0 );
End;
{==============================================================}

{==============================================================}

Procedure TDTMform.ACNavMapExecute(Sender: TObject);
begin
   if NavForm.Execute(htf) then
   begin
      curX:=NavForm.PickX;
      curY:=NavForm.PickY;
      PrepareBitmap;
   end;
end;

procedure TDTMform.ACNavMapUpdate(Sender: TObject);
begin
   ACNavMap.Enabled:=Assigned(htf);
end;

procedure TDTMform.ACPaletteExecute(Sender: TObject);
begin
   if Sender is TMenuItem then
   begin
     PreparePal(TMenuItem(Sender).Hint);
     PrepareBitmap;
   end  else
   begin
     OpenDialogPal.InitialDir:= ProgramPath;
     OpenDialogPal.Filter:= 'HTF Palette (*.pal)|*.pal';
     OpenDialogPal.FileName:= '*.pal';
     if OpenDialogPal.Execute then
     begin
       if UpperCase(ExtractFileExt(OpenDialogPal.FileName)) = '.PAL' then
       begin
         PreparePal(OpenDialogPal.FileName);
         PrepareBitmap;
       end;
     end;
   end;
end;

procedure TDTMform.SelectAutoColor1Click(Sender: TObject);
begin
  AutoColorDialog.Color:=AutoColorShape.Brush.Color;
  if AutoColorDialog.Execute then
  AutoColorShape.Brush.Color := AutoColorDialog.Color;
end;
procedure TDTMform.AutoColorShapeMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
   SelectAutoColor1Click(Sender);
end;
procedure TDTMform.AutorangePalette1Click(Sender: TObject);
begin
    if not Assigned(htf) then Exit;
    DoAutorangePalette;
end;
procedure TDTMform.DoAutorangePalette;
var
   prev, next : Integer;
   pC, nC : TAffineVector;
      cur : Integer;
      cC : TAffineVector;
      d : Single;
begin
    if not Assigned(htf) then Exit;
    //this did not work so used Auto Min..Max
     { prev:=0;
      pC:=NullVector;
      next:=AutoMinimumElevation;
      nc[0]:=1;
      nc[1]:=1;
      nc[2]:=1;
      if prev<next then
         d:=1/(next-prev)
      else d:=0;
      for cur:=prev to next do
      begin
         cC:=VectorLerp(pC, nC, (cur-prev)*d);
         heightColor[cur]:=Color32(Round(cC[0]), Round(cC[1]), Round(cC[2]));
      end;  }
      nc[0]:=AutoMinimumElevation;
      nc[1]:=AutoMinimumElevation;
      nc[2]:=AutoMinimumElevation;

      prev:=AutoMinimumElevation;
      pC:=nc;
      next:=AutoMaximumElevation;

      nc[0]:={254;}GetRValue(AutoColorShape.Brush.Color);
      nc[1]:={254;}GetGValue(AutoColorShape.Brush.Color);
      nc[2]:={254;}GetBValue(AutoColorShape.Brush.Color);
      if prev<next then
         d:=1/(next-prev)
      else d:=0;
      for cur:=prev to next do
      begin
         cC:=VectorLerp(pC, nC, (cur-prev)*d);
         heightColor[cur]:=Color32(Round(cC[0]), Round(cC[1]), Round(cC[2]));
      end;

      prev:=AutoMaximumElevation;
      pC:=nc;
      next:=32767;
      nc[0]:=255;
      nc[1]:=255;
      nc[2]:=255;
      if prev<next then
         d:=1/(next-prev)
      else d:=0;
      for cur:=prev to next do
      begin
         cC:=VectorLerp(pC, nC, (cur-prev)*d);
         heightColor[cur]:=Color32(Round(cC[0]), Round(cC[1]), Round(cC[2]));
      end;
//just so i know what that VectorLerp is..does
{function VectorLerp(const V1, V2: TAffineVector; t: Single): TAffineVector;
begin
   Result[X]:=V1[X]+(V2[X]-V1[X])*t;
   Result[Y]:=V1[Y]+(V2[Y]-V1[Y])*t;
   Result[Z]:=V1[Z]+(V2[Z]-V1[Z])*t;
end;}
end;
{==============================================================}


{==============================================================}
procedure TDTMform.Contents1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_CONTENTS, 0);
end;

procedure TDTMform.OnHelp1Click(Sender: TObject);
begin
  Application.HelpCommand(HELP_HELPONHELP, 0);
end;

procedure TDTMform.Me1Click(Sender: TObject);
begin
  Application.HelpContext(1000);
end;

procedure TDTMform.About1Click(Sender: TObject);
begin
  AboutDTM.Show;
end;
{==============================================================}


{==============================================================}
procedure TDTMform.OpenShape1Click(Sender: TObject);
begin
  OpenDialog.Filter:= 'Shape File (*.shp)|*.shp';
  OpenDialog.FileName:= '*.shp';
  OpenDialog.InitialDir:=ShapePath;
  if OpenDialog.Execute then
  begin
    if length(OpenDialog.filename) = 0 then Exit;{Exits from the current procedure.}
    if ('.SHP'= UpperCase(ExtractFileExt(OpenDialog.FileName))) then
    begin
       ShapePath := ExtractFilePath(OpenDialog.Filename);
       ShpFileName := OpenDialog.Filename;
      DTMform.Cursor:=crHourGlass; {crDefault}
      If NewLayer then
      begin

      end else DoMessages(8);{8, "Not a Shape (*.shp) file"}
      DTMform.Cursor:=crDefault; {crDefault}
    end;
  end;
end;


Function TDTMform.NewLayer:Boolean;
var gotloaded:Boolean;
begin
  gotloaded:=False;
  Inc(LayersLoaded);
  CurrentLayer:=LayersLoaded;
  SetLength(LayA,LayersLoaded+1);{Trash the Zero layer in array}
  SetLength(LayersControlArray,LayersLoaded);
  LayersControlArray[(LayersLoaded-1)]:= LayersLoaded;
  If ShapeLoaderForm.LoadLayer then gotloaded:=True;
  If gotloaded then result:=gotloaded else
  begin
    {do something cause it failed loading}
    dec(LayersLoaded);
    CurrentLayer:=LayersLoaded;
    SetLength(LayA,LayersLoaded+1);
    SetLength(LayersControlArray,LayersLoaded);
    result:=gotloaded;
    DoMessages(16);{16, "Error loading Shape (*.shp) file"}
  end;
  SetDtp1.Enabled:=gotloaded;
  PrepareBitmap;
end;

{==============================================================}
{Text X,Y =recompute; if 'set' rescale then recompute}
procedure TDTMform.DVDORedraw;
var LayerVisible,
 UseOutlinePoly:Boolean;
 LayerDo, Startat,{ Finishat, }
 INumparts,  INumPoints, CurrentPointType,PointSize,
 ShapeType, ShapeToDo, DXI,DYI,
 NumShape, NumParts, NumPoints,
 FillAlphaPosition, LineAlphaPosition : integer;
 DXdtemp,DYdtemp:Double;
 Editarray:Array of TPoint;
{ Editarray32:TArrayOfFixedPoint;}
 PolyColor, OutLineColor,PointColor:TColor32;
    Polygon: TPolygon32;
    Outline: TPolygon32;
    TmpPoly: TPolygon32;
    Step, LineSize:Single;
begin
  If LayersLoaded>0 then
  Begin
    {Offset is +- to center data to 0,0}
    DataSizeMinOffX:= DataSizeMinOffX*DataScalerX;
    DataSizeMinOffY:= DataSizeMinOffY*DataScalerY;
    ScreenScale :=   DataScalerX;
    For Startat:=0 to LayersLoaded-1 do
    Begin
      LayerDo:=LayersControlArray[Startat];
      LayerVisible:=   LayA[LayerDo].Visible;
      ShapeType:= LayA[LayerDo].ShpType;
      NumShape:= LayA[LayerDo].ShapeN;
      Image321.Bitmap.PenColor :=
            Color32(LayA[LayerDo].LayerColor);
      PointColor:= Color32(LayA[LayerDo].LayerColor);
      PolyColor:= Color32(LayA[LayerDo].LayerColor);
      OutLineColor:= Color32(LayA[LayerDo].OutLineColor);
          {Point Type, Box, Numpoints, Points }
  Canvas.Pen.Color := LayA[LayerDo].LayerColor; // use standard TCanvas methods for drawing
  Canvas.Brush.Color := LayA[LayerDo].LayerColor; // use standard TCanvas methods for drawing
  Canvas.Pen.Width := LayA[LayerDo].CanvasLineSize; // use standard TCanvas methods for drawing
     Canvas.Brush.Style := bsSolid; {bsClear}
      If ((ShapeType=1) or(ShapeType=11) or(ShapeType=21)) then
      begin
        CurrentPointType:=LayA[LayerDo].CurrentPointType;
        PointSize:=LayA[LayerDo].PointSize;
          case CurrentPointType of {Set for all points NOW}
            1:Canvas.Brush.Style :=bsClear;
            3:Canvas.Pen.Color :=LayA[CurrentLayer].OutLineColor;
            6..7:Canvas.Brush.Style :=bsClear;
          end;
        For ShapeToDo:=1 to NumShape do
        Begin
          dXTemp:=LayA[LayerDo].LyrShp[ShapeToDo].XMax;
          dYTemp:=LayA[LayerDo].LyrShp[ShapeToDo].YMax;
             //MaxOffsetX MaxOffsetY are set in Shape file
             //DShiftOffsetX set in DTP HTF FIX
             //Kinda confusing..the value is NOT what is  displayed...
          DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
          DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
          DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
          DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
{Points: Dot Circle DotInCircle FilledCircle PlusSign X Box XInBox FilledBox}
          case CurrentPointType of
            0: {Pnt Dot} Canvas.Pixels[DXI, DYI] :=
                LayA[CurrentLayer].LayerColor;
            1: {Pnt Circle}
              begin {    Canvas.Ellipse}
                Canvas.Ellipse(DXI - PointSize, DYI - PointSize,
                DXI + PointSize, DYI +PointSize);
              end;
            2: {Pnt DotInCircle  }
              begin
                Canvas.Ellipse(DXI - PointSize,
                DYI - PointSize, DXI + PointSize, DYI +PointSize);
                Canvas.Pixels[DXI, DYI] :=
                  LayA[CurrentLayer].OutLineColor;
              end;
              {FilledCircle}
            3:Canvas.Ellipse(DXI - PointSize,
            DYI - PointSize, DXI + PointSize, DYI +PointSize);

            4: {Pnt PlusSign  +}
              begin
                Canvas.moveto(DXI - PointSize, DYI);
                Canvas.lineto(DXI + PointSize, DYI);
                Canvas.moveto(DXI, DYI + PointSize);
                Canvas.lineto(DXI, DYI - PointSize);
              end;
            5: {PntX   X}
              begin
                Canvas.moveto(DXI - PointSize, DYI - PointSize);
                Canvas.lineto(DXI + PointSize, DYI + PointSize);
                Canvas.moveto(DXI - PointSize, DYI + PointSize);
                Canvas.lineto(DXI + PointSize, DYI - PointSize);
              end;

            6: {Pnt Box X1, Y1, X2, Y2}
              begin
                Canvas.Rectangle(DXI - PointSize,
                DYI - PointSize, DXI + PointSize, DYI +PointSize);
              end;
            7: {Pnt XInBox}
              begin
                Canvas.Rectangle(DXI - PointSize,
                DYI - PointSize, DXI + PointSize, DYI +PointSize);
                Canvas.moveto(DXI - PointSize, DYI - PointSize);
                Canvas.lineto(DXI + PointSize, DYI + PointSize);
                Canvas.moveto(DXI - PointSize, DYI + PointSize);
                Canvas.lineto(DXI + PointSize, DYI - PointSize);
              end;
             8: {FilledBox}
          Canvas.FillRect(Rect(DXI-PointSize,DYI+PointSize,
          DXI+PointSize,DYI-PointSize){,PointColor});
          end; {Case}
        end;
      end else
{0 Null Shape
1 Point      11 PointZ       21 PointM
8 MultiPoint 18 MultiPointZ  28 MultiPointM

3 PolyLine   13 PolyLineZ    23 PolyLineM
5 Polygon    15 PolygonZ     25 PolygonM
31 MultiPatch      Fan or Strip     }
      If ( (ShapeType=3) or (ShapeType=13) or (ShapeType=23)
{         or(ShapeType=5) or (ShapeType=15) or (ShapeType=25)}
         {MultiPoint 1 Part of Many Points}
         or(ShapeType=8) or(ShapeType=18) or(ShapeType=28)
         {31 blocked out Fans and Strips}
         )then
      begin
        For ShapeToDo:=1 to NumShape do
        Begin
          Application.ProcessMessages;
          Numparts:=LayA[LayerDo].LyrShp[ShapeToDo].PartsN;{Numparts}
          for INumparts := 1 to Numparts do
          begin {Always at least 1 0...}
            NumPoints:=LayA[LayerDo].LyrShp[ShapeToDo].PPA[INumparts];
            {Make Poly array}
            SetLength(Editarray,NumPoints);
            for INumPoints := 1{2} to NumPoints do
            begin {2 points internally}
              dXTemp:=LayA[LayerDo].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Xd;
              dYTemp:=LayA[LayerDo].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Yd;
              DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
              DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
              DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
              DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
              Editarray[INumPoints-1].X:= DXI;
              Editarray[INumPoints-1].Y:= DYI;
            end;{INumPoints}
            begin
              Image321.Bitmap.MoveTo(Editarray[0].X, Editarray[0].Y);
              for INumPoints := 2 to NumPoints do
   If LayA[LayerDo].UseStippleStep then
   Image321.Bitmap.LineToFSP(Editarray[INumPoints-1].X,
                                        Editarray[INumPoints-1].Y)
   else
    Image321.Bitmap.LineToS(Editarray[INumPoints-1].X,
                                        Editarray[INumPoints-1].Y);
            end;
          end;{INumparts}
        end; {For ShapeToDo}
      end else

      If ((ShapeType=5) or (ShapeType=15) or (ShapeType=25) )then
      begin
        {New Polygon ?}
        Polygon := TPolygon32.Create;
        Outline := TPolygon32.Create;
        Polygon.Antialiased := LayA[LayerDo].PolygonAntialiased;
        UseOutlinePoly:= LayA[LayerDo].UseOutlinePoly;
        Polygon.FillMode := pfWinding;  {pfAlternate}
        FillAlphaPosition:= LayA[LayerDo].FillAlphaPosition;
        LineAlphaPosition:= LayA[LayerDo].LineAlphaPosition;
        LineSize:= LayA[LayerDo].LineSize;
        For ShapeToDo:=1 to NumShape do
        Begin
          Application.ProcessMessages;
          Numparts:=LayA[LayerDo].LyrShp[ShapeToDo].PartsN;{Numparts}
          for INumparts := 1 to Numparts do
          begin {Always at least 1 0...}
            Polygon.NewLine;
            NumPoints:=LayA[LayerDo].LyrShp[ShapeToDo].PPA[INumparts];
            {Make Poly array}
            {SetLength(Editarray32,NumPoints);}
            for INumPoints := 1 to NumPoints do
            begin {2 points internally}
              dXTemp:=LayA[LayerDo].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Xd;
              dYTemp:=LayA[LayerDo].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Yd;
              DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
              DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
              DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
              DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
              {Editarray32[INumPoints-1].X:= DXI;
              Editarray32[INumPoints-1].Y:= DYI;}
             Polygon.Add(FixedPoint(DXI, DYI))
            end;{INumPoints}
            begin
              {Image321.Bitmap.MoveTo(Editarray[0].X, Editarray[0].Y);
              for INumPoints := 2 to NumPoints do
                Image321.Bitmap.LineToS(Editarray[INumPoints-1].X,
                                        Editarray[INumPoints-1].Y);}
            end;
          end;{INumparts}
        end; {For ShapeToDo}
        Polygon.DrawFill(Image321.Bitmap,
                   SetAlpha(PolyColor, FillAlphaPosition));
        if UseOutlinePoly then
        begin
          TmpPoly := Polygon.Outline;
          Outline := TmpPoly.Grow(Fixed(LineSize / 2), 0.5);
          Outline.FillMode := pfWinding;
          TmpPoly.Free;
        end;
        if UseOutlinePoly then
           Outline.Antialiased := LayA[LayerDo].PolygonAntialiased;
        if UseOutlinePoly then
           Outline.DrawFill(Image321.Bitmap,
                     SetAlpha(OutLineColor, LineAlphaPosition))
           else Polygon.DrawEdge(Image321.Bitmap,
                     SetAlpha(OutLineColor, LineAlphaPosition));
        Outline.Free;
        {Outline := nil;  }
        Polygon.Free;
      end;{LayerDo ShapeType}
    end;{CurrentLayer for each layer}
  end;{Any Layers ?}
  SetLength(Editarray,0);{  SetLength(Editarray32,0);}
End;
{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
procedure TDTMform.Options1Click(Sender: TObject);
begin
  dtmPOFForm.show;
end;

procedure TDTMform.SetEcoColors1Click(Sender: TObject);
begin
  dtmEcotypeColorsForm.show;
end;

procedure TDTMform.HTFpack1Click(Sender: TObject);
begin
  dtmHtfForm.show;
end;



procedure TDTMform.DemDblist1Click(Sender: TObject);
begin
  dtmDbForm.show;
end;

procedure TDTMform.Imagemaker1Click(Sender: TObject);
begin
  if Assigned(htf) then
  begin
    ImageMakerForm:=TImageMakerForm.Create(Application);
    ImageMakerForm.Showmodal;
    ImageMakerForm.Release;
  end;
end;

{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}

procedure TDTMform.GLSTree1Click(Sender: TObject);
begin
 //Stuarts Demo.. to Save a GLS Tree
 dtmGLSTreeForm.show;
end;

procedure TDTMform.GLSTreal1Click(Sender: TObject);
begin
 //TReal Tree Maker... GLS Versioning
  dtmGlsTrealForm.show;
end;

procedure TDTMform.LSystem1Click(Sender: TObject);
begin
  LSystemForm:=TLSystemForm.Create(Application);
  try
    LSystemForm.ShowModal;
  finally
    LSystemForm.Release;
  end;
end;

procedure TDTMform.Mathings1Click(Sender: TObject);
begin     {MathingsForm}
  If NoGLRunning then
  begin
    NoGLRunning:=False;
    MathingsForm:=TMathingsForm.Create(Application);
  try
    MathingsForm.ShowModal;
  finally
    MathingsForm.Release;
  end;
    NoGLRunning:=True;
  end;
end;
procedure TDTMform.F21Click(Sender: TObject);
begin
  FractalForm.Show;    //Launches GlForm for 3D
  FractalForm.ShowDown;
end;
//Cannot be Modal.. launches other forms
procedure TDTMform.Fractal1Click(Sender: TObject);
begin  //FMJForm.Show;   //Launches GlForm for 3D
//  FractalForm.Show;
//  FractalForm.ShowDown;
 { If NoGLRunning then
  begin
    NoGLRunning:=False;
    //FractalForm:=TFractalForm.Create(Application);
  try     //FractalForm.ShowModal;
    FractalForm.Show;
  finally
    //FractalForm.Release;
  end;
    NoGLRunning:=True;
  end; }
end;

procedure TDTMform.RagDoll1Click(Sender: TObject);
begin
  If NoGLRunning then
  begin
    NoGLRunning:=False;
    dtmSmdQcForm.show;  //Cannot be Modal.. launches other forms
  end;
end;

procedure TDTMform.GLSViewer1Click(Sender: TObject);
begin
  If NoGLRunning then
  begin
    NoGLRunning:=False;
   dtmGLSViewerForm.show;//??Cannot be Modal.. launches other forms
  end;
end;

procedure TDTMform.Panaviewer1Click(Sender: TObject);
begin
  If NoGLRunning then
  begin
    NoGLRunning:=False;
    dtmPanVizForm.Show; //??Cannot be Modal.. launches other forms
  end;
end;
{==============================================================}
{==============================================================}

{Joystick Settings form moved to Tongs
  If NoGLRunning then
  begin
    NoGLRunning:=False;
    dtmJoyForm:=TdtmJoyForm.Create(Application);
    dtmJoyForm.Showmodal;
    dtmJoyForm.Release;
  end;}
procedure TDTMform.Image3DHistogram1Click(Sender: TObject);
begin
  If NoGLRunning then
  begin
    {Open a data file made of an Image Histogram
     Display on a GL form as Cubes...
     255x255x255: Location determines RGB Value
             -> Look up in Data LIST
             to determine COUNT of Values of that color}
    OpenDialog.Filter:= 'Raster 3d Histogram File (*.rs3)|*.rs3';
    OpenDialog.FileName:= '*.rs3';
    OpenDialog.InitialDir:=ImagePath;
    if OpenDialog.Execute then
    begin
      ImagePath:=ExtractFilePath(OpenDialog.FileName);
      NoGLRunning:=False;
      Application.ProcessMessages;
      DtmImageRGBForm.Show;
      DtmImageRGBForm.ShowDown(OpenDialog.FileName);
    end;
  end;
end;

procedure TDTMform.Image3DdotHistogram1Click(Sender: TObject);
type
  Count3D = array[0..255] of Byte;
var
  Count3DArray: Count3D;
  RX, GY, BZ, Value: Byte;
  Counter:Integer;
  fLoad: file of Count3D;
begin
  If NoGLRunning then
  begin
    {Open a data file made of an Image Histogram
     Display on a GL form as dots... All at once
     255x255x255: precompute the LIST of Records
     thus saving time later:
     NO PIXEL VALUE lookup comparison of null values}
    OpenDialog.Filter:= 'Raster 3d Histogram File (*.rs3)|*.rs3';
    OpenDialog.FileName:= '*.rs3';
    OpenDialog.InitialDir:=ImagePath;
    if OpenDialog.Execute then
    begin
      ImagePath:=ExtractFilePath(OpenDialog.FileName);
      NoGLRunning:=False;
      Application.ProcessMessages;
      Counter:=0;
      {$I-}
      AssignFile(fLoad, OpenDialog.FileName);
      Reset(fLoad);
      ProgressBar1.Position:=0;
      ProgressBar1.Visible:=True;
      for BZ := 0 to 255 do
      begin
        ProgressBar1.Position:= Round(100 * (BZ / 255));
        for GY := 0 to 255 do
        begin {Row}
          Read(fLoad, Count3DArray);
          for RX := 0 to 255 do
          begin {Col}
            Value := Count3DArray[RX];
            If Value > 0 then
            begin
              inc(Counter);
              SetLength(Array3D, Counter+1);
              Array3D[Counter].RX:=RX;
              Array3D[Counter].GY:=GY;
              Array3D[Counter].BZ:=BZ;
              Array3D[Counter].Count:=Value;
            end;
          end;
        end;
      end;
      CloseFile(fLoad);
      {$I+}
      Array3DCounter:=Counter;
      ProgressBar1.Position:=0;
      ProgressBar1.Visible:=False;
      Application.ProcessMessages;
      DtmImageDotRGBForm:=TDtmImageDotRGBForm.Create(Application);
      DtmImageDotRGBForm.Caption:='Rx Gy Bz 3D Dot: '
                           +ExtractFileName(OpenDialog.FileName)+
                            ', Sprites:'+Inttostr(Counter);
      DtmImageDotRGBForm.Showmodal;
      DtmImageDotRGBForm.Release;
      SetLength(Array3D, 0);
    end;
  end;
end;

procedure TDTMform.Image3DClick(Sender: TObject);
begin
  If NoGLRunning then
  begin
    {Open a data file made of an Image Histogram
     Display on a GL form as Cubes...
     255x255x255: Location determines RGB Value
             -> Look up in Data LIST
             to determine COUNT of Values of that color}
    OpenDialog.Filter:= 'Raster 3d Histogram File (*.rs3)|*.rs3';
    OpenDialog.FileName:= '*.rs3';
    OpenDialog.InitialDir:=ImagePath;
    if OpenDialog.Execute then
    begin
      ImagePath:=ExtractFilePath(OpenDialog.FileName);
      TempName:= OpenDialog.FileName;
      NoGLRunning:=False;
      Application.ProcessMessages;
      t3de1Form:=Tt3de1Form.Create(Application);
      t3de1Form.Showmodal;
      t3de1Form.Release;
    end;
     NoGLRunning:=True;
  end;
end;

procedure TDTMform.tx3RGB3DClick(Sender: TObject);
begin
  If NoGLRunning then
  begin
    t3dForm:=Tt3dForm.Create(Application);
    t3dForm.Showmodal;
    t3dForm.Release;
    NoGLRunning:=True;
  end;
end;
{==============================================================}
{==============================================================}
procedure TDTMform.RIFImageViewer1Click(Sender: TObject);
begin
  RIFImageViewerForm.Show;
end;
{==============================================================}
{==============================================================}

procedure TDTMform.TaskDrone1Click(Sender: TObject);
begin
  //dtmTaskDroneForm.show;
end;
{==============================================================}
{==============================================================}




{==============================================================}
{==============================================================}
  //Paths are NOT Path Node Methods.. ONLY the GPF data
procedure TDTMform.PathStart1Click(Sender: TObject);
begin
  LOSint:=666; {Set 666 ON}
  Setlength(GPFNodes,0);
  TotalNodes:=0;
end;

procedure TDTMform.PathFinish1Click(Sender: TObject);
begin
  Dragging := False;
  LOSint:=0;{Set 666 OFF}
end;
procedure TDTMform.PathNewClear1Click(Sender: TObject);
begin
  Dragging := False;
  LOSint:=0;{Set 666 OFF}
  Setlength(GPFNodes,0);
  TotalNodes:=0;
end;

 {Load GPF data and Display}
procedure TDTMform.PathLoad1Click(Sender: TObject);
var
  F: TextFile;
  S: string;
  I:Integer;
begin
  OpenDialog.Filter := 'Path files (*.pth)|*.pth';
  OpenDialog.InitialDir:=ProjectPath;
  if OpenDialog.Execute then
  begin
    ProjectPath:=ExtractFilePath(OpenDialog.FileName);
    AssignFile(F, OpenDialog.FileName);
    Reset(F);
    Readln(F, S);      //Header stuff
    If (S= PathVersion) then
    begin end else
    begin
      CloseFile(F);
      showmessage('Wrong Version or File: Not '+PathVersion);
      //NewBtnClick(Sender);
      Exit;
    end;
    Readln(F, S);// XMax:= Strtoint(S);//XYZ Max Min to make Grids
    Readln(F, S);// XMin:= Strtoint(S);//: [Default 10x10x10]
    Readln(F, S);// YMax:= Strtoint(S);
    Readln(F, S);// YMin:= Strtoint(S);
    Readln(F, S);// ZMax:= Strtoint(S);
    Readln(F, S);// ZMin:= Strtoint(S);
    Readln(F, S);// XOffset:= Strtoint(S);
    Readln(F, S);// YOffset:= Strtoint(S);
    Readln(F, S);// ZOffset:= Strtoint(S);
    Readln(F, S);// XOrigin:= Strtoint(S);
    Readln(F, S);// YOrigin:= Strtoint(S);
    Readln(F, S);// ZOrigin:= Strtoint(S);
    Readln(F, S);// XStep:= StrtoFloatDef(S);
    Readln(F, S);// YStep:= StrtoFloatDef(S);
    Readln(F, S);// ZStep:= StrtoFloatDef(S);
    Readln(F, S);// XScale:= StrtoFloatDef(S);
    Readln(F, S);// YScale:= StrtoFloatDef(S);
    Readln(F, S);// ZScale:= StrtoFloatDef(S);
    Readln(F, S);//Number of Active Paths..  Paths [1]
                      //I dunno HOW so just 1.. it is # 0
    //Movement.ActivePathIndex := 0;
    //TLineSplineMode
    Readln(F, S); ///SplineModeRG.ItemIndex:= Strtoint(S);
     //Path 1 : Count of Nodes
    Readln(F, S); TotalNodes:= Strtoint(S);
    //TotalNodesLabel.Caption:=inttostr(TotalNodes);
    Readln(F, S); //LoopCount:= Strtoint(S);
    //LoopedEdit.Text :=inttostr(LoopCount);
    Readln(F, S);// ShowPathCB.Checked:=(S='True');
    Readln(F, S);// LoopPathCB.Checked:=(S='True');
    Readln(F, S);// FlyTheCubeCB.Checked:=(S='True');
    Readln(F, S);// F2CB.Checked:=(S='True');

    for I := 0 to TotalNodes - 1 do
    begin
      //MakeABlank(I,0);
      Readln(F, S); GPFNodes[i].Position[0]:= strtofloatdef(S,0);
      Readln(F, S); GPFNodes[i].Position[1]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Position[2]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Rotation[0]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Rotation[1]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Rotation[2]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Scale[0]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Scale[1]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Scale[2]:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].Speed:= strtofloatdef(S);
      Readln(F, S); GPFNodes[i].NodeNumber:= Strtoint(S);
      //SetGPFCubeToNodeCube(i);
      //SetGPFCubeToNode(i);
    end;
    //SetGPFCubeToText(TotalNodes-1);
    //Path.ShowPath := ShowPathCB.Checked;
    //Path.Looped := LoopPathCB.Checked;
    CloseFile(F);
  end;
end;

procedure TDTMform.PathSave1Click(Sender: TObject);  {Save GPF data}
var
  OffsetString:String;
  I:Integer;
  F: TextFile;
begin
  if Assigned(htf) then begin
    //Select a filename and save data
    SaveDialog1.Filter := 'Path files (*.pth)|*.pth';
    SaveDialog1.InitialDir:=ProjectPath;
    if SaveDialog1.Execute then          { Display Open dialog box }
    begin
      AssignFile(F, SaveDialog1.FileName);
      Rewrite(F);
      //Write Header stuff
      Writeln(F, PathVersion);
      Writeln(F, Inttostr(FileSizeX));  //XYZ Max Min to make Grids
      Writeln(F, Inttostr(0)); //: [Default 10x10x10]
      Writeln(F, Inttostr(FileSizeY));
      Writeln(F, Inttostr(0));
      Writeln(F, Inttostr(MaximumElevation));
      Writeln(F, Inttostr(MinimumElevation));
      //function InputBox(const ACaption, APrompt, ADefault: string): string
      OffsetString:= InputBox('Path Limits','X Offset','0');
      Writeln(F,OffsetString);
      OffsetString:= InputBox('Path Limits','Y Offset','0');
      Writeln(F,OffsetString);
      OffsetString:= InputBox('Path Limits','Z Offset','0');
      Writeln(F,OffsetString);
      Writeln(F, Inttostr(0));
      Writeln(F, Inttostr(0));
      Writeln(F, Inttostr(0));
      Writeln(F, Floattostr(0.5));
      Writeln(F, Floattostr(0.5));
      Writeln(F, Floattostr(0.5));
      Writeln(F, Floattostr(1.0));
      Writeln(F, Floattostr(1.0));
      Writeln(F, Floattostr(1.0));
 {  XMax,  XMin, YMax, YMin, ZMax, ZMin
  XOffset,YOffset, ZOffset,
  XOrigin, YOrigin, ZOrigin,  //Areal Extents of the Grid
 :Integer;
  XStep,YStep,ZStep,
  XScale, YScale, ZScale  : Single; }
      Writeln(F,'1'); //Number of Active Paths..  Paths [1]
                      //I dunno HOW so just 1.. it is # 0
      Writeln(F,'1'); //SplineMode
      Writeln(F, Inttostr(TotalNodes));
      Writeln(F,'0');//LoopCount
       Writeln(F,'False');
       Writeln(F,'False');
       Writeln(F,'False');
       Writeln(F,'False');

      for I := 0 to TotalNodes - 1 do
      begin
    Writeln(F,Floattostr(GPFNodes[i].Position[0]));
    Writeln(F,Floattostr(GPFNodes[i].Position[1]));
    Writeln(F,Floattostr(GPFNodes[i].Position[2]));
    Writeln(F,Floattostr(GPFNodes[i].Rotation[0]));
    Writeln(F,Floattostr(GPFNodes[i].Rotation[1]));
    Writeln(F,Floattostr(GPFNodes[i].Rotation[2]));
    Writeln(F,Floattostr(GPFNodes[i].Scale[0]));
    Writeln(F,Floattostr(GPFNodes[i].Scale[1]));
    Writeln(F,Floattostr(GPFNodes[i].Scale[2]));
    Writeln(F,Floattostr(GPFNodes[i].Speed));
    Writeln(F,Inttostr(GPFNodes[i].NodeNumber));    //Node Number #
      end;
      CloseFile(F);
    end;
  end;
end;

procedure TDTMform.PathSaveasshp1Click(Sender: TObject);
var
  I:Integer;
  F: TextFile;
begin
  if Assigned(htf) then
  begin
    //Select a filename and save data
    SaveDialog1.Filter := 'Shape files (*.shp)|*.shp';
    SaveDialog1.InitialDir:=ShapePath;
    if SaveDialog1.Execute then          { Display Open dialog box }
    begin
      AssignFile(F, SaveDialog1.FileName);
      Rewrite(F);
   //Save Points as a .shp file
//         Writeln(F, Inttostr(TotalNodes));   
      for I := 0 to TotalNodes - 1 do
      begin
    Writeln(F,Floattostr(GPFNodes[i].Position[0]));
    Writeln(F,Floattostr(GPFNodes[i].Position[1]));
    Writeln(F,Floattostr(GPFNodes[i].Position[2]));
      end;
      CloseFile(F);
    end;
  end;
end;


procedure TDTMform.PathGizmo1Click(Sender: TObject);
begin 
  If NoGLRunning then {Launch the GizmoPath form}
  begin
    NoGLRunning:=False;
    GizmoPathForm:=TGizmoPathForm.Create(Application);
    GizmoPathForm.Showmodal;
    GizmoPathForm.Release;
    NoGLRunning:=True;
  end;
end;
{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
procedure TDTMform.ZipUnzip1Click(Sender: TObject);
begin
  ZipForm.show;
end;
{==============================================================}
{==============================================================}


{==============================================================}
{==============================================================}
procedure TDTMform.DVNewClear1Click(Sender: TObject);
begin
  Dragging := False;
  LOSint:=0;{Set 666 OFF}
  Setlength(GPFNodes,0);
  TotalNodes:=0;
end;

{Load GPF data and Display as D or V}
procedure TDTMform.DVLoad1Click(Sender: TObject);
var
  I:Integer;
  S:String;
  F: TextFile;
begin
  if Assigned(htf) then
  begin
    OpenDialog.Filter :='DV files (*.dvf)|*.dvf';
    OpenDialog.InitialDir:=ProjectPath;
    if OpenDialog.Execute then
    begin
      ProjectPath:=ExtractFilePath(OpenDialog.FileName);
      AssignFile(F, OpenDialog.FileName);
      Reset(F);
      Readln(F, S);  TotalNodes:=strtoint(S);
      Setlength(GPFNodes,TotalNodes);
      for I := 0 to TotalNodes - 1 do
      begin
        Readln(F, S);GPFNodes[i].Position[0]:=Strtoint(S);
        Readln(F, S);GPFNodes[i].Position[1]:=Strtoint(S);
        // Writeln(F,Floattostr(GPFNodes[i].Position[2]));
      end;
      CloseFile(F);
    end;
  end;
end;

procedure TDTMform.DVStart1Click(Sender: TObject);
begin
  LOSint:=666; {Set 666 ON}
  Setlength(GPFNodes,0);
  TotalNodes:=0;
end;

procedure TDTMform.DVFinish1Click(Sender: TObject);
begin
  Dragging := False;
  LOSint:=0;{Set 666 OFF}
end;

procedure TDTMform.DVSave1Click(Sender: TObject);
var
  I:Integer;
  F: TextFile;
begin
  if Assigned(htf) then begin
    //Select a filename and save data
    SaveDialog1.Filter := 'DV files (*.dvf)|*.dvf';
    SaveDialog1.InitialDir:=ProjectPath;
    if SaveDialog1.Execute then          { Display Open dialog box }
    begin
      AssignFile(F, SaveDialog1.FileName);
      Rewrite(F);
      Writeln(F, Inttostr(TotalNodes));
      for I := 0 to TotalNodes - 1 do
      begin
        Writeln(F,Floattostr(GPFNodes[i].Position[0]));
        Writeln(F,Floattostr(GPFNodes[i].Position[1]));
        //Writeln(F,Floattostr(GPFNodes[i].Position[2]));
      end;
      CloseFile(F);
    end;
  end;
end;


procedure TDTMform.DVDeLaunay1Click(Sender: TObject);
begin
  DVDeLaunay1.Checked:= (not DVDeLaunay1.Checked);
end; 
procedure TDTMform.DVVoronoi1Click(Sender: TObject);
begin
  DVVoronoi1.Checked:= (not DVVoronoi1.Checked);
end;
procedure TDTMform.DVConvexHull1Click(Sender: TObject);
begin
  DVConvexHull1.Checked:= (not DVConvexHull1.Checked);
end;
procedure TDTMform.DVPoints1Click(Sender: TObject);
begin
  DVPoints1.Checked:= (not DVPoints1.Checked);
end;

procedure TDTMform.DV2DEditor1Click(Sender: TObject);
begin
  //Delaunay triangulation, Voronoi diagram
  DVForm.Show;
end;
{==============================================================}
{==============================================================}




end.
