{*******************************************************}
{                                                       }
{                      Tachyon Unit                     }
{    Vector Raster Geographic Information Synthesis     }
{                     VOICE  ..  Tracer                 }
{                     GRIP ICE .. Tongs                 }
{                Digital Terrain Mapping                }
{               Image Locatable Holographics            }
{                          SOS MAP                      }
{  Surreal Object Synthesis Multimedia Analysis Product }
{                   Fractal3D  Life MOW                 }
{       Copyright (c) 1995,2006  Ivan Lee Herring       }
{                                                       }
{*******************************************************}
unit dtmHdsFrm;
{GLScene Terrain Renderer using a HTF HDS }
{Textures Generated: Elevation Tint..or..Ecotype Tint
                     w/ Lightmap detail or default detail
                     w/ Contours or not}
{Textures available everywhere
 partially... (Oceans Eleven and Edges)
  None.. If Create Set for None.. use Default Fakes
  else   None.. create Elevation Tints on demand
Memory use deletion  }
{Globals set in Viewer    HTFPath+HTFName  htf
Globals set in Program Options
  UseFlippedHTF:=False;
  CreateTexturesOnDemand:=False;
  SaveCreatedTextures:=False;
  UseSavedTextures:=False;
  LoadShapeDBs:=False;
  UseXScale:=False;
  UseZScale:=False;
  UseSeaLevel:=False;
  UseContours:=False;
  UseLightMap:=False;
  UseEcoTypes:=False;
  PixelEnlargement:=2;
  TilesperTexture:=1;
  XScaleUsed:=1;
  ZScaleUsed:=1;
  SeaLevelUsed :=0;}

interface

uses
  Windows, Messages, SysUtils, Classes, Menus,
  Graphics, Controls, Forms, Dialogs, ExtCtrls, ComCtrls,
  FileCtrl,{Directory Creation}
  pngimage, tga, jpeg,  GR32, {Texture}
  GLScene, GLObjects, VectorGeometry, GLTexture, Keyboard,
  GLCadencer, GLWin32Viewer, GLMisc, GLUtils,  OpenGL1x,
  GLBitmapFont, GLWindowsFont, GLHUDObjects,
  GLVectorFileObjects,{TGLGLSMVectorFile  GLSM (GLScene Mesh) vector file.}
  GLGeomObjects, GLGraphics,
  GLBehaviours,  GLMovement,//Path Nodes
  GLTree, //Vegetation
  GLWaterPlane, //Ocean Water
  GLThorFX,                  //Storm Clouds
  GLParticleFX, GLPerlinPFX,
  GLSkydome, GLProcTextures,//Clouds
  GLModelManager,// Shape Objects in 3D
  GLFILESMD,GLFileMD2, GLFileMD3, //Actors  QC loader
  GLFileMDC,{MDC MD3 plus files}
  GLFileGL2,{Ghoul2}
  GLFILEOCT,{output from FSRad, http://www.fluidstudios.com/fsrad.html}
  GLFileNurbs,
  GLFileNMF, {NormalMapper  http://www.ati.com/developer/tools.html}
  GLFileLWO,{Lightwave LWO }
  GLFileGTS,{GTS (GNU Triangulated Surface)}
  //Objects MS3D, 3DS;*. MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GL2 GTS LWO
  GLFILEMS3D, GLFILE3DS, GLFILEOBJ,GLFILETIN,GLFILEPLY,GLFILESTL,
  GLTexCombineShader,
  GLHeightData, GLHeightTileFileHDS, GLTerrainRenderer,
  //CustomBump  {GLBumpmapHDS,}
  GLHTFBumpHDS, GLAVIRecorder, GLWin32FullScreenViewer;

type

  TWayPoint = record
    Position : TAffineVector;
    Active   : Boolean;
  end;
  TSSxyz = record
    X,Y,Z : Double;
  end;
  TShapeAttRecord = record
    Shape, Filename   : Integer;
    end;
  TdtmGlHdsForm = class(TForm)
    GLScene1: TGLScene;
    GLSceneViewer1: TGLSceneViewer;
    GLCadencer1: TGLCadencer;
    Timer1: TTimer;
    GLCamera: TGLCamera;
    GLHeightTileFileHDS1: TGLHeightTileFileHDS;
    CameraCube: TGLDummyCube;
    GLTerrainRenderer1: TGLTerrainRenderer;
    GLLightSource1: TGLLightSource;
    HTFPS: TGLHUDText;
    BFSmall: TGLWindowsBitmapFont;
    StatusBar: TStatusBar;
    ObjectsML: TGLMaterialLibrary;
    SBarPopupMenu: TPopupMenu;
    ExitMenuItem: TMenuItem;
    TakeMeHome1: TMenuItem;
    GLSkyDome1: TGLSkyDome;
    LoadDTP1: TMenuItem;
    Location1: TMenuItem;
    ActorMenu: TMenuItem;
    Loadsmd1: TMenuItem;
    LoadActorTexture1: TMenuItem;
    Loadmd21: TMenuItem;
    Actor1: TGLActor;
    ActorBase: TGLDummyCube;
    Marker: TGLDummyCube;
    GLTorus1: TGLTorus;
    GLArrowLine1: TGLArrowLine;
    RunningMan1: TMenuItem;
    OpenDialog1: TOpenDialog;
    AxisOn1: TMenuItem;
    MovingMan1: TMenuItem;
    N2: TMenuItem;
    CloudSphere: TGLSphere;
    N1: TMenuItem;
    CloudsFaster: TMenuItem;
    CloudsSlower1: TMenuItem;
    CloudsMuchSlower1: TMenuItem;
    CloudsActiveMenu: TMenuItem;
    CloudsMore1: TMenuItem;
    CloudsLess1: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    CloudsOff1: TMenuItem;
    SPSun: TGLSprite;
    GLTexCombineShader1: TGLTexCombineShader;
    TerrainML: TGLMaterialLibrary;
    ShapeDC: TGLDummyCube;
    BillBoardDC: TGLDummyCube;
    ProcessSunMovements1: TMenuItem;
    Loadqc1: TMenuItem;
    SetSunParameters1: TMenuItem;
    ResetSun1: TMenuItem;
    SunMenu1: TMenuItem;
    Waves: TMenuItem;
    GLPlane1: TGLPlane;
    GLPlane2: TGLPlane;
    Storm1: TMenuItem;
    Help1: TMenuItem;
    Ocean1: TMenuItem;
    N5: TMenuItem;
    DarkClouds1: TMenuItem;
    OceanMoving1: TMenuItem;
    WaterFxDC: TGLDummyCube;
    SeaPlane: TGLWaterPlane;
    StormCloudDC: TGLDummyCube;
    OceanMenu: TMenuItem;
    GLPerlinPFXManager1: TGLPerlinPFXManager;
    WeatherMenu: TMenuItem;
    Project1: TMenuItem;
    StormEffectsMenu: TMenuItem;
    Rain1: TMenuItem;
    Lightning1: TMenuItem;
    Tornadoes1: TMenuItem;
    Wind1: TMenuItem;
    ImposterDC: TGLDummyCube;
    StormLightAxisDC: TGLDummyCube;
    LightningDC: TGLDummyCube;
    RunDTPMenu: TMenuItem;
    RunAllLayers1: TMenuItem;
    RunSelectedLayer1: TMenuItem;
    RunSelectedObject1: TMenuItem;
    N6: TMenuItem;
    LoadDTC1: TMenuItem;
    Actor2: TGLActor;
    ActorsML: TGLMaterialLibrary;
    StopRunningDTP1: TMenuItem;
    DTC1: TMenuItem;
    RunDTC1: TMenuItem;
    StopDTC1: TMenuItem;
    DTP1: TMenuItem;
    FlybyTargetCube: TGLDummyCube;
    RobotDC: TGLDummyCube;
    Loadrld1: TMenuItem;
    Loadmd22: TMenuItem;
    CullingDC: TGLDummyCube;
    GLSprite1: TGLSprite;
    AVIRecorder1: TAVIRecorder;
    GLFullScreenViewer1: TGLFullScreenViewer;
    MMMatLib: TGLMaterialLibrary;
    MMDC: TGLDummyCube;
    MMProxyDC: TGLDummyCube;
    procedure FormCreate(Sender: TObject);
    procedure Help1Click(Sender: TObject);
procedure CreateStormClouds;
    procedure ExitMenuItemClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FormHide(Sender: TObject);
    procedure FormShowDown(InTileSize,
                           InSizeX, InSizeY:Cardinal;
                           InAutoDefaultZ,
                           InX, InY,
                           InAutoMinimumElevation,
                           InAutoMaximumElevation:Integer);
procedure SetShapeObjects;
procedure LoadShapeOld(Filename:String;ILoad:Integer);
procedure LoadShapeShifterObject(ActorUp,ActorFilename,TextureFileName,P2FileName:String; ActorUpSize,ActorScale,ActorLength,ActorWidth,ActorHeight:Double;ILoad,oldCTRG:Integer);
procedure LoadShapeobject(ActorUp,ActorFilename,TextureFileName:String; ActorUpSize,ActorScale,ActorLength,ActorWidth,ActorHeight:Double;ILoad,oldCTRG:Integer);
procedure LoadTextureBillboardobject(ActorUp,Filename:String;ActorUpSize, ActorScale,ActorLength,ActorWidth,ActorHeight:Double;ILoad,oldCTRG:Integer);

procedure LoadAreaobject(Filename:String;ILoad:Integer);
procedure LoadPointobject(Filename:String;ILoad:Integer);
procedure LoadLineobject(Filename:String;ILoad:Integer);

    procedure Timer1Timer(Sender: TObject);
    procedure GLCadencer1Progress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure FormKeyPress(Sender: TObject; var Key: Char);

    procedure TakeMeHome1Click(Sender: TObject);
procedure DoActorMovement;
    procedure LoadDTP1Click(Sender: TObject);
procedure LoadActorrld(Filename:String);
procedure Do3dsOpen( ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,TextureFileName,ActorUp : String);
procedure DoQcOpen( ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String);
    procedure Loadsmd1Click(Sender: TObject);
procedure DoLoadsmd( ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String);
    procedure LoadActorTexture1Click(Sender: TObject);
procedure DoLoadActorTexture(fileName : String);

    procedure Loadrld1Click(Sender: TObject);
    procedure Loadmd22Click(Sender: TObject);
procedure DoLoadmd2( ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String;Weapon:Boolean);
    procedure Loadmd21Click(Sender: TObject);
    procedure GLSceneViewer1MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure RunningMan1Click(Sender: TObject);
    procedure AxisOn1Click(Sender: TObject);
    procedure MovingMan1Click(Sender: TObject);

    procedure CloudsFasterClick(Sender: TObject);
    procedure CloudsSlower1Click(Sender: TObject);
    procedure CloudsMuchSlower1Click(Sender: TObject);
    procedure CloudsMore1Click(Sender: TObject);
    procedure CloudsLess1Click(Sender: TObject);
    procedure CloudsOff1Click(Sender: TObject);
    procedure ProcessSunMovements1Click(Sender: TObject);
    procedure GLHDSBump1MarkDirtyEvent(const area: TRect);
    procedure GLHDSBump1StartPreparingData(heightData: THeightData);
    procedure Loadqc1Click(Sender: TObject);
    procedure ResetSun1Click(Sender: TObject);
    procedure SetSunParameters1Click(Sender: TObject);


    procedure Ocean1Click(Sender: TObject);
    procedure OceanMoving1Click(Sender: TObject);
    procedure WavesClick(Sender: TObject);
    procedure DarkClouds1Click(Sender: TObject);


    procedure Storm1Click(Sender: TObject);
    procedure Rain1Click(Sender: TObject);
    procedure Lightning1Click(Sender: TObject);
    procedure Tornadoes1Click(Sender: TObject);
    procedure Wind1Click(Sender: TObject);

    procedure StopRunningDTP1Click(Sender: TObject);
    procedure RunSelectedLayer1Click(Sender: TObject);
    procedure RunAllLayers1Click(Sender: TObject);
    procedure RunSelectedObject1Click(Sender: TObject);

    procedure LoadDTC1Click(Sender: TObject);
procedure DoLoadDTC(InFile:String);    //DtcFlyBy
procedure LoadActorDtc(S:String;DtcFileTypeRGItemIndex:Integer);
procedure DoLoadActorDtc(
ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double;
fileName,TextureFileName,ActorUp : String);
    procedure RunDTC1Click(Sender: TObject);
procedure DoRunDTC;
    procedure StopDTC1Click(Sender: TObject);
    procedure FlybyTargetCubeProgress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure CameraCubeProgress(Sender: TObject; const deltaTime,
      newTime: Double);
    procedure FormResize(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure AVIRecorder1PostProcessEvent(Sender: TObject;
      frame: TBitmap);


  private
    { Private declarations }
    //Actor Status Booleans
      ActorSmdLoaded, ActorMd2Loaded, ActorMd2WpnLoaded: Boolean;
    // Runningman
      theta: single;
      WayPoint: TWayPoint;
      currentanim: string;

    //Weather and Stuff Created
      StormCloudsCreated:Boolean;
      StormCloudDC2  :  TGLDummyCube;
      //  StormTornadoCone  :  TGLCone;
      DtmPerlinPFXManager2,
      DtmPerlinPFXManager:TGLPerlinPFXManager;
      DtmThorFXManager:TGLThorFXManager;
      TornadoeRanger,  LightningRanger:Double;

      //Sky Clouds..NOT Storm clouds
        CloudRanger: Integer;
        CloudSharpRanger,
        CloudChange,  CloudNewTime:Double;
      //Scaled from Global BumpRanger  for BumpMapping Control
      BumpRange:Double;
      GLHTFBumpHDS1:   TGLHTFBumpHDS;
      //Sun      {Sunlatitude,Sunlongitude,}
      Brightness:single;
      thedatetime:TDateTime;

      AnythingRunning:Boolean;
      Manager : TGLModelManager;  // The model manager
      //DTP Project
        DTProjectLoaded:Boolean;
      //Shape Object Max
        MaximumShapesLoaded : Integer;
        RunningDTPTotal,
        RunningDTPLayer,
        RunningDTPObject: Integer; //Which Layer Object in Spotlight
        PlatoCommandFile:String;//File name for the DTS DTD file
        PlatoCommand: Integer;//Type of Command file
    AreaArray:Array of TShapeAttRecord;
    PointArray:Array of TShapeAttRecord;
    LinearArray:Array of TShapeAttRecord;
        ShapeShifterArray:Array of TSSxyz;//SSxyz:TAffineVector;
        ShapeShifter, ShapeShifterLayer, ShapeShifterCount : Integer;
        ShapeShifterFileName:String;
        ShapeShifterRunning:Boolean;
      //DTC Project
        DtcFileType, DtcFileTypeRGItemIndex: Integer;
        DtcAbortAvi,
        DtcRunning,DtcFlyBy:Boolean;
        DtcLAArray,
        DtcAZArray:Array of String;
        DtcCommandFile:String;//File name for the DTC file
    procedure PathTravelStop(Sender: TObject; Path: TGLMovementPath; var Looped: Boolean);
    procedure PathAllTravelledOver(Sender: TObject);
  public
    { Public declarations }
    //HTF info passed from Global to these Local variables
    DtmTileSize, HeightPointsPerTexture: Integer;
    PointsPerTexture,
    TexturesWideX, TexturesTallY,
    TilesWideX,TilesTallY:Cardinal;
    //Created Texture Name usage
    HTFExtension, HTFTexturePath, HTFTextureName  :String;
    //Texture loading time and Tile Count displayed in Caption
    TotalHtfLoadTime, TotalTexLoadTime: Int64;
    TotalLoaded:Integer;
    {Where am i Starting Location Storage}
      dtmAutoDefaultZ,StartingX,StartingY:Integer;
      DataWideX, DataTallY:Integer;
    {Mouse Activity}
    dtmGlmx,dtmGlmy,dtmGlmx2,dtmGlmy2:Integer;
    XPositionCorrection, CamHeight : Single;
    mx, my : Integer;
    procedure ResetMousePos;
  end;


var
  dtmGlHdsForm: TdtmGlHdsForm;

implementation

{$R *.DFM}

uses dtmfrm, dtmPOFvar,  dtmGlobals,
     dtmErrMsg, AllShapeLoaderFrm,
     dtmSmdQcUSMDStuff, //Marcus
     dtmHdsSunConfigFrm, //uShadedAerialTerrainDemo  Created June 2004 Skinhat
     dtmHdsSunUnit,
     dtmEcotypeColorsFrm, dtmEcoReader;

procedure TdtmGlHdsForm.FormCreate(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  AnythingRunning :=False;
  DtcFlyBy:=False;
  DtcRunning:=False;
    DtcCommandFile:='';
    DtcFileType:=0;
    DtcFileTypeRGItemIndex:=-1;//None loaded
  top := dtmHdsFormY;
  left := dtmHdsFormX;
  LightningRanger:=0;
  TornadoeRanger:=0;
  TotalLoaded:=0;
  MaximumShapesLoaded:=0;
  {Repete:=0;}
  TotalHtfLoadTime:=0;
  TotalTexLoadTime:=0;
  StormCloudsCreated :=False;
  CloudChange:=0;   //CloudChange  CloudNewTime
  CloudNewTime:=0;
  RunningMan1.Enabled:=False;
  ActorSmdLoaded:=False;
  ActorMd2Loaded:=False;
  ActorMd2WpnLoaded:=False;
  DTProjectLoaded:=False;
  RunDTPMenu.Enabled:=False;
  RunningDTPObject:=0;
  RunningDTPTotal :=0;
  RunningDTPLayer:=0;

  PlatoCommandFile:='';
  PlatoCommand:=0;
  ShapeShifter:=-1;
  ShapeShifterLayer:=-1; ShapeShifterCount:=-1;
  ShapeShifterFileName:='';
  ShapeShifterRunning:=False;
    GLHTFBumpHDS1:=   TGLHTFBumpHDS.Create(nil);
    GLHTFBumpHDS1.OnMarkDirtyEvent:=GLHDSBump1MarkDirtyEvent;
    GLHTFBumpHDS1.OnStartPreparingData:= GLHDSBump1StartPreparingData;
end;
procedure TdtmGlHdsForm.CreateStormClouds;
var
  ThorFX:TGLBThorFX;
  PFXSource:TGLSourcePFXEffect;
  GLParticleFXRenderer1 : TGLParticleFXRenderer;
  I:Integer;
Begin
  //Create a StormCloudsNumberUsed of DummyCubes and attendant Clouds
  //Under StormCloudDC
  {StormCloudDC  GLParticleFXRenderer1}
  GLParticleFXRenderer1:=(StormCloudDC.AddNewChild(TGLParticleFXRenderer) as TGLParticleFXRenderer);

  DtmPerlinPFXManager := TGLPerlinPFXManager.Create(nil);
                      //Acceleration XYZ  0
  DtmPerlinPFXManager.AspectRatio:=2.5;  //1
  DtmPerlinPFXManager.BlendingMode:=bmTransparency;//bmAdditive
                      //Brightness  1
  DtmPerlinPFXManager.Cadencer :=GLCadencer1;
  DtmPerlinPFXManager.ColorInner:= //clrYellow
        DtmPerlinPFXManager.ColorOuter;
  //Created with 1 already there
  //PFXLifeColor := TPFXLifeColors.Create(GLPerlinPFXManager1{.LifeColors});
  //GLPerlinPFXManager1.LifeColors.Add;
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[0]).LifeTime:=5;
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[0]).RotateAngle:=5;
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[0]).SizeScale:=0.8;
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[0]).ColorInner.Alpha:=1;
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[0]).ColorInner.Blue:=1;
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[0]).ColorInner.Green:=1;
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[0]).ColorInner.Red:=1;
  //Add another  TPFXLifeColors layer
  //PFXLifeColor := TPFXLifeColors.Create(DtmPerlinPFXManager{.LifeColors});
  DtmPerlinPFXManager.LifeColors.Add;
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[1]).LifeTime:=10;    //3
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[1]).RotateAngle:=15; //0
  TPFXLifeColor(DtmPerlinPFXManager.LifeColors.Items[1]).SizeScale:=1;    //1
                      //ColorMode scmFade scmInner  scmNone  scmOuter
                      //Friction 1
                      //Gamma 1
                      //NoiseAmplitude 50
                      //NoiseScale 100
  DtmPerlinPFXManager.NoiseSeed:=5678;  //0
  DtmPerlinPFXManager.ParticleSize:=5;  //1
  DtmPerlinPFXManager.Renderer:=GLParticleFXRenderer1;
                      //Rotation 0
                      //Smoothness 1
                      //SpritesPerTexture  sptFour
  DtmPerlinPFXManager.TexMapSize:=9; //6
  //THIS is repeated for EACH GROUP..
  //ALL use the same GLParticleFXRenderer1 and GLPerlinPFXManager1
  For I:= 0 to StormCloudsNumberUsed-1 do
  begin
    PFXSource := TGLSourcePFXEffect.Create(nil);
    StormCloudDC.Effects.Add(PFXSource);
    TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).Manager:=DtmPerlinPFXManager;
    TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).PositionDispersion:=StormCloudsRateUsed+(Random*StormCloudsRangeUsed); //1.2
    TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).PositionDispersionRange.X:=StormCloudsRangeXUsed;
    TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).PositionDispersionRange.Y:=StormCloudsRangeYUsed;
    TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).PositionDispersionRange.Z:=StormCloudsRangeZUsed;
    If UseStormLinear then
     TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).InitialPosition.X :=((I *StormCloudsNumRangeUsed) +(Random*StormCloudsNumRangeVarUsed));
    TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).InitialPosition.Y :=((I *StormCloudsNumRangeUsed) +(Random*StormCloudsNumRangeVarUsed));
    TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).InitialPosition.Z :=((I *StormCloudsNumRangeUsed) +(Random*StormCloudsNumRangeVarUsed));
  end;
    If (UseStormRain)then
    begin
    //RainDensityUsed   RainDensityVarUsed
    end;
    If (UseStormWind)then
    begin
      //StormWindDirectionUsed      StormWindDirectionVarUsed
      // StormWindSpeedUsed     StormWindSpeedVariationUsed
      //
    end;
  If UseStormLightning then
  begin
//  StromLightAxisDC.TurnAngle  LightningDC  StormCloudDC2.Turnangle
    LightningDC.Position.X:=StormCloudsRangeXUsed;
    LightningDC.Position.Y:=StormCloudsRangeYUsed;
    DtmThorFXManager  := TGLThorFXManager.Create(nil);
    DtmThorFXManager.Cadencer :=GLCadencer1;
    DtmThorFXManager.Wildness:=9.99; //
    DtmThorFXManager.GlowSize:= LightningForceUsed;
    DtmThorFXManager.InnerColor.Alpha:=0.3;
    DtmThorFXManager.Disabled:=False;
    DtmThorFXManager.Core:=False;
    DtmThorFXManager.Target.y:=-33;
    Lightning1.Checked := True;
//    For I:= 0 to StormCloudsNumberUsed-1 do begin
      ThorFX := TGLBThorFX.Create(nil);
      LightningDC.Effects.Add(ThorFX);
      TGLBThorFX(LightningDC.Effects.Items[0]).Manager:=DtmThorFXManager;
//    end;
  end;
  If UseStormTornadoes then
  begin
    Tornadoes1.Checked:=True;
      //inc(EffectsCount);
    StormCloudDC2:=(StormCloudDC.AddNewChild(TGLDummyCube) as TGLDummyCube);
{    StormTornadoCone:=(StormCloudDC.AddNewChild(TGLCone) as TGLCone);
   StormTornadoCone.Material.Texture.Image.LoadFromFile(ExtractFilePath(Application.ExeName)+'026eau.jpg');
   StormTornadoCone.Material.Texture.Disabled:=False;
    StormTornadoCone.BottomRadius:=0.3;
    StormTornadoCone.Up.Y:=-1;
    StormTornadoCone.Position.Y:=-10;
        StormTornadoCone.Scale.X:=23;
        StormTornadoCone.Scale.Y:=23;
        StormTornadoCone.Scale.Z:=23;}

    DtmPerlinPFXManager2 := TGLPerlinPFXManager.Create(nil);
    DtmPerlinPFXManager2.AspectRatio:=0.8;  //1
    DtmPerlinPFXManager2.BlendingMode:=bmTransparency;//bmAdditive
                      //Brightness  1
    DtmPerlinPFXManager2.Cadencer :=GLCadencer1;
    DtmPerlinPFXManager2.ColorInner:= //.Color:=clrYellow
        DtmPerlinPFXManager2.ColorOuter;
    //Created with 1 already there
    //PFXLifeColor := TPFXLifeColors.Create(GLPerlinPFXManager1{.LifeColors});
    //GLPerlinPFXManager1.LifeColors.Add;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[0]).LifeTime:=1;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[0]).RotateAngle:=5;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[0]).SizeScale:=0.8;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[0]).ColorInner.Alpha:=1;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[0]).ColorInner.Blue:=0.99;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[0]).ColorInner.Green:=0.8;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[0]).ColorInner.Red:=0.7;
    //Add another  TPFXLifeColors layer
    //PFXLifeColor := TPFXLifeColors.Create(DtmPerlinPFXManager{.LifeColors});
    DtmPerlinPFXManager2.LifeColors.Add;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[1]).LifeTime:=3;    //3
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[1]).RotateAngle:=15; //0
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[1]).SizeScale:=1;    //1
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[1]).ColorInner.Blue:=0.99;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[1]).ColorInner.Green:=0.9;
    TPFXLifeColor(DtmPerlinPFXManager2.LifeColors.Items[1]).ColorInner.Red:=0.9;
                      //ColorMode scmFade scmInner  scmNone  scmOuter
                      //Friction 1
                      //Gamma 1
                      //NoiseAmplitude 50
                      //NoiseScale 100
    DtmPerlinPFXManager2.NoiseSeed:=2356;  //0
    DtmPerlinPFXManager2.ParticleSize:=3;  //1
    DtmPerlinPFXManager2.Renderer:=GLParticleFXRenderer1;
    //DtmPerlinPFXManager2.Rotation:=30;
                      //Smoothness 1
                      //SpritesPerTexture  sptFour
    DtmPerlinPFXManager2.TexMapSize:=4; //6
    For I:= 0 to (Round(TornadoeForceUsed)*2) do
    begin
    PFXSource := TGLSourcePFXEffect.Create(nil);
    StormCloudDC2.Effects.Add(PFXSource);
    TGLSourcePFXEffect(StormCloudDC2.Effects.Items[I]).Manager:=DtmPerlinPFXManager2;
    TGLSourcePFXEffect(StormCloudDC2.Effects.Items[I]).PositionDispersion:=TornadoeForceUsed+(TornadoeFrequencyUsed); //1.2
    TGLSourcePFXEffect(StormCloudDC2.Effects.Items[I]).PositionDispersionRange.X:=TornadoeForceUsed*TornadoeFrequencyUsed;
    TGLSourcePFXEffect(StormCloudDC2.Effects.Items[I]).PositionDispersionRange.Y:=TornadoeForceUsed*TornadoeFrequencyUsed;
    TGLSourcePFXEffect(StormCloudDC2.Effects.Items[I]).PositionDispersionRange.Z:=TornadoeForceUsed*TornadoeFrequencyUsed;
    end;
    end;
  If UseStormMoving then
  begin
    If UseStormMovingDirS then
    begin  //START at Position.. Move per Direction per Cadencer
      StormCloudDC.Position.X:=StormCloudsPosXUsed;
      StormCloudDC.Position.Y:=StormCloudsPosYUsed;
      StormCloudDC.Position.Z:=StormCloudsPosZUsed;
    end else
    If UseStormMovingPath then
    begin
      //Starts at 0,0,0 and Moves to/with StormDC per NODE
    end else
    begin
      //Starts at 0,0,0 and Moves to/with StormDC
    end;
  end else
  begin
    StormCloudDC.Position.X:=StormCloudsPosXUsed;
    StormCloudDC.Position.Y:=StormCloudsPosYUsed;
    StormCloudDC.Position.Z:=StormCloudsPosZUsed;
  end;
End;
procedure TdtmGlHdsForm.FormDestroy(Sender: TObject);
var I:Integer;
begin
  SetLength(ShapeShifterArray,0);
  SetLength(DtcAZArray, 0);
  SetLength(DtcLAArray, 0);
  SetLength(AreaArray,0);
  SetLength(PointArray,0);
  SetLength(LinearArray,0);
  If StormCloudsCreated then
  begin
    If UseStormTornadoes then
    begin
    For I:= (Round(TornadoeForceUsed)*2) downto 0 do
    begin
      TGLSourcePFXEffect(StormCloudDC2.Effects.Items[I]).ParticleInterval:=0;
      StormCloudDC2.Effects.Delete(I);
      StormCloudDC2.DeleteChildren;
      //Children[0].Delete;
    end;
      DtmPerlinPFXManager2.LifeColors.Delete(1);
      DtmPerlinPFXManager2.LifeColors.Delete(0);
      DtmPerlinPFXManager2.Destroy;
      StormCloudDC2.Destroy;
    end;
    If UseStormLightning then
    begin
      LightningDC.Effects.Delete(0);
      DtmThorFXManager.Destroy;
    end;
    If (UseStormRain)then
    begin
    end;
    If (UseStormWind)then
    begin
    end;
    For I:= StormCloudsNumberUsed-1 downto 0 do
    begin  // I:= 0;
    TGLSourcePFXEffect(StormCloudDC.Effects.Items[I]).ParticleInterval:=0;
    StormCloudDC.Effects.Delete(I);
    end;
    DtmPerlinPFXManager.LifeColors.Delete(1);
    DtmPerlinPFXManager.LifeColors.Delete(0);
    DtmPerlinPFXManager.Destroy;
  end;
  GLHTFBumpHDS1.Destroy;
end;
procedure TdtmGlHdsForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  GLHTFBumpHDS1.MaxPoolSize:=0;
  GLHeightTileFileHDS1.HTFFileName :='';
  NoGLRunning:=True;
  dtmHdsFormY := dtmGlHdsForm.top;
  dtmHdsFormX := dtmGlHdsForm.left;
  DoSaver;
end;
procedure TdtmGlHdsForm.FormHide(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  NoGLRunning:=True;
end;
procedure TdtmGlHdsForm.FormResize(Sender: TObject);
begin
  GLSceneViewer1.ResetPerformanceMonitor;
  AVIRecorder1.Width:=GLSceneViewer1.Width;
  AVIRecorder1.Height:=GLSceneViewer1.Height;
end;
procedure TdtmGlHdsForm.FormDblClick(Sender: TObject);
begin
   //Fullscreen..Form Resize ?
end;
procedure TdtmGlHdsForm.ExitMenuItemClick(Sender: TObject);
begin
  Close;
end;
procedure TdtmGlHdsForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(15000);
end;

procedure TdtmGlHdsForm.TakeMeHome1Click(Sender: TObject);
begin
  {Reset to Where it all started... Just in case parameters get crazy
   NEED to store the info when Showdown called
   Place the CODE in a separate procedure, called at start and whenever}
  If UseFlippedHTF then
  begin
  GLterrainRenderer1.Position.X:= DataWideX;//Starts at Other end
  //GLterrainRenderer1.Position.Y:= InSizeY;
   CameraCube.Position.X := StartingX *GLterrainRenderer1.Scale.X;
   CameraCube.Position.Y := 0;
   CameraCube.Position.Z := StartingY *GLterrainRenderer1.Scale.Y;
   XPositionCorrection:=1;// Lat Lon conversion (InX*GLterrainRenderer1.Scale.X);
  end else
  begin
   CameraCube.Position.X :=( -StartingX *GLterrainRenderer1.Scale.X);
   CameraCube.Position.Y := 0;
   CameraCube.Position.Z := StartingY *GLterrainRenderer1.Scale.Y;
   XPositionCorrection:=-1;// Lat Lon conversion (InX*GLterrainRenderer1.Scale.X);
  end;
end;

 {  HTFTextureName:=  Copy(HTFName,0,Length(HTFName)-4);
  HTFTexturePath:=  '\'+HTFTextureName+'tex\';
  Case TextureFileType of
    0:HTFExtension:='.png';
    1:HTFExtension:='.bmp';
    2:HTFExtension:='.jpg';
  end;
LoadTileTex
  Texname:=Format(HTFTextureName+'Tex_%d_%d'+HTFExtension, [i, j]);
    Telname:=Format(HTFTextureName+'Tel_%d_%d'+HTFExtension, [i, j]);
CreateTextures
    Texname:=Format(HTFTextureName+'Tex_%d_%d'+HTFExtension, [i, j]);
 format(HTFTextureName+'Tex_%d_%d'+HTFExtension,[i,j]))

 TotalBugLoaded TotalBuged  Repete
 2640 Ecotint }
{Run through HTF for ALL tiles to get the Min and Max..
  Do it when FIRST loading the HTF in the Viewer}
{Pass the Selected Starting Point : X,Y}
procedure TdtmGlHdsForm.FormShowDown(InTileSize,
      InSizeX, InSizeY:Cardinal;
      InAutoDefaultZ,
      InX, InY,
      InAutoMinimumElevation, InAutoMaximumElevation:Integer);
var
   i : Integer;
   bmp : TBitmap;
  aPERM: array [0..255] of Byte;
  outfile:Textfile;
  s:string;
Begin
  Randomize;
   // Create the manager : give him a dummycube to store the freeforms
   //    and give him a Matlib
   Manager := TGLModelManager.Create(MMDC,MMMatLib);
    //  GLScene1.VisibilityCulling:=vcObjectBased;
    //  GLScene1.VisibilityCulling:=vcHierarchical;
    //  GLScene1.VisibilityCulling:=vcNone;
  If (UseClouds or UseCloudsSetting)then
  begin
    //GLSkyDome1.Visible:=false;
    //GLSphere1.Visible:=True;
    //Create a Matlib   ObjecstML
        {[dark FULL] s99m30 .. s98 m60..90
        [50/50]    97..97
        [lighter]  95.120
        [10/10]    90 160}
    with CloudSphere.Material.Texture do
    begin
      If (UseCloudFile and (FileExists(CloudFileUsed)))then
      begin
      Try
        AssignFile(outfile, CloudFileUsed);   { File selected in dialog box }
        Reset(outfile);
        Readln(outfile, s{'DTM Cloud Base V1.0'});
        For I := 0 to 255 do
        begin
          Readln(outfile, s);
          aPERM[I]:=strtoint(s);
        end;
      Finally
        CloseFile(outfile);
      End;
      TGLProcTextureNoise(Image).SetPermFromData(aPERM);
      end else TGLProcTextureNoise(Image).SetPermToDefault;
      //TextureFormat:=tfRGBA;//TGLTextureFormat(Integer(tfRGB)+CBFormat.ItemIndex);
      //Compression:=TGLTextureCompression(Integer(tcNone)+CBCompression.ItemIndex);
      TGLProcTextureNoise(Image).Height :=CloudImageSizeUsed;
      TGLProcTextureNoise(Image).Width :=CloudImageSizeUsed;
      TGLProcTextureNoise(Image).MinCut :=CloudMinUsed;
      CloudRanger:=CloudMinUsed;
      TGLProcTextureNoise(Image).NoiseSharpness :=CloudSharpUsed;
      CloudSharpRanger:=CloudSharpUsed;
      TGLProcTextureNoise(Image).NoiseRandSeed :=CloudRandomSeedUsed ;
      TGLProcTextureNoise(Image).Seamless := True;
       //1 is seamless      //CheckBox2.Checked;
    end;
  end else
  begin
    CloudsActiveMenu.Enabled:=false;
  end;

  If (UseStormClouds and (not StormCloudsCreated))then
  begin //Rain Particles     //Storm Clouds
    Storm1.Checked := True;
    StormCloudDC.Visible:=True;
    StormCloudsCreated:=True;
    CreateStormClouds;
    StormEffectsMenu.Enabled:=True;
  end;  
  { Set the start date and time. Starts at todays date 4 in the morning }
  thedatetime:= now;  //date+encodetime(4,0,0,0);

  { GLHeightTileFileHDS1.MaxPoolSize:=8*1024*1024;}{Not an option here}
   // 8 MB height data cache
   // Note this is the data size in terms of elevation samples,
   // it does not take into account all the data required/allocated by the renderer
   {Set this per WHAT? ... a percentage of the HTF size?
   It is NOT  a Cache to prevent RELOADING the data +texture(s), Just data
   8 * DataWideX * DataTallY  could make an 8 Gig cache... TOO BIG
   *1024*1024 is just to make it a _8_ Megabyte sized Cache}
     GLHTFBumpHDS1.MaxPoolSize:= 8*1024*1024;
     GLHTFBumpHDS1.BumpMapLibrary:=TerrainML;
     GLHTFBumpHDS1.BumpScale:=0.15; //changes darkness of bumps
     //resolution..grain of texture ONLY 1 allowed...
     //commmented out the adjustments
     GLHTFBumpHDS1.SubSampling:=1;
     GLTerrainRenderer1.HeightDataSource := GLHTFBumpHDS1;
     //Smooths the Effect 256 is Original Demo number .. ~div 32
     // scaleDiv255:=GLCustomHDS1.BumpScale*(1/BumpRange);
     BumpRange:= (InAutoMaximumElevation-InAutoMinimumElevation)/ BumpRanger;
     {Tex0:=Dot3(Tex0, Col);      Diffuse.Color:=   Bumpn;
     Texture2Name:='contrast'; amount of white
      Tex1:=Interpolate(Tex0, Tex1, EnvCol);  contrast code makes EnvColor  .5 at start  current code makes it 1.0
      Tex2:=Tex1*Tex2;     details  scale is 32
      Maybe put in My tint for texture NOPE cant change them.. they go bonkers
      Tex3:=Tex2*Tex3;  texture Diffuse is <0.800 0.800 0.502 1.000> (light brown) mid-blue in dialog}

     HTFTextureName:=  Copy(HTFName,0,Length(HTFName)-4);
     HTFTexturePath:=  HTFTextureName+'tex\';
     if UseEcoTypes then
       HTFTexturePath:=  HTFTextureName+'tee\';
     if UseImageMap then
       HTFTexturePath:=  HTFTextureName+'tei\';
     if UseConglomeration then
       HTFTexturePath:=  HTFTextureName+'tec\';
     if UseBumpMap then
       HTFTexturePath:=  HTFTextureName+'teb\';
  Case TextureFileType of
    0:HTFExtension:='.png';
    1:HTFExtension:='.bmp';
    2:HTFExtension:='.jpg';
  end;//case
  {Store Parameters for Regroup to starting Point}
  StartingX:=InX;
  StartingY:=InY;
  DataWideX:=InSizeX;
  DataTallY:=InSizeY;
  dtmAutoDefaultZ:=InAutoDefaultZ;

  {GLterrainRenderer1 Uses MatLib so any settings to Material are Ignored
      MappingS 0,1,0,0  T 0,1,0,0
      Direction 0,1,0    Position 0,0,0}
  {- tilespertexture: the number of tiles you have in a texture,
     texture size being irrelevant (a texture size is always 1x1 (float),
     the image/bitmap you use defines only its resolution)}
     {Value can only be 'determined' by user input knowledge of textures produced/used}
     {TilesperTexture; is available BUT the MATH is done like it is 1 to 1
     TilesperTexture used in
       PointsPerTexture :=InTileSize*TilesperTexture;}
  GLTerrainRenderer1.TilesPerTexture:=1;// (InSizeX div InTileSize);

  {Tile Size or ?x? Textures per Height tile ?
  Need for variable to cover x tiles per texture}
  PointsPerTexture :=InTileSize*TilesperTexture;// 128;
  HeightPointsPerTexture:=InTileSize*TilesperTexture;// 128;

  Brightness:=0.5;
    {use HTF.DefaultHeight or 0 or MinimumElevation or an Input Water Level}
  If UseSeaLevel then
  begin                  //016eau.jpg  sea.bmp  026eau.jpg
    GLHTFBumpHDS1.DefaultHeight:=SeaLevelUsed;
    If FileExists(ExtractFilePath(Application.ExeName)+'026eau.jpg') then
    Begin
      TerrainML.materials.GetLibMaterialByName('sea').material.texture.image.loadfromfile(ExtractFilePath(Application.ExeName)+'026eau.jpg');
      GLPlane1.Visible:=True;
      GLPlane2.Visible:=True;
      Ocean1.Checked := True;
      OceanMoving1.Checked:= True;
      { Set the brightness of the sea }
      GLPlane2.material.FrontProperties.diffuse.Alpha:=1-Brightness;
      GLPlane2.material.BlendingMode:=bmTransparency;
      GLPlane2.material.Texture.texturemode:=tmdecal;
       SeaPlane.Visible:=UseWaves;
       Waves.Enabled:=UseWaves;
       If UseWaves then
       begin
         Waves.Checked := True;
         SeaPlane.RainForce:=WavesRateUsed;
         SeaPlane.RainTimeInterval:=WavesRangeUsed;
       end;
    end else
    begin
      UseSeaLevel:=False;
      Showmessage('026eau.jpg missing');
    end;
  end else
  begin
    If InAutoDefaultZ < InAutoMinimumElevation then
       GLHTFBumpHDS1.DefaultHeight:=InAutoDefaultZ
      else GLHTFBumpHDS1.DefaultHeight:=InAutoMinimumElevation;
  end;

  // Height 60 width 60  x 140 y 100 z -235
   SPSun.Material.Texture.Image.LoadFromFile(ExtractFilePath(Application.ExeName)+'flare1.bmp');
   If UseSunMoving then ProcessSunMovements1.Checked:=True;
  // load texmaps  ..  Check Presence and put in BASE detail for all first
  //Actual textures are loaded when data is.. allows producing them there
  //This is just for 'All else fails'
  If FileExists(ExtractFilePath(Application.ExeName)+'detailmap.jpg') then
  begin
    TerrainML.LibMaterialByName('details').Material.Texture.Image.LoadFromFile(ExtractFilePath(Application.ExeName)+'detailmap.jpg');
    with TerrainML.LibMaterialByName('details').Material.Texture do
    begin
      MappingSCoordinates.W:= 1/ InTileSize;
      MappingTCoordinates.W:= 1/ InTileSize;
       MappingMode :=tmmObjectLinear;//       tmmUser
       MinFilter:=miLinear; //miLinearMipmapLinear
        Disabled:=False;
        TextureFormat:=tfLuminance;
        TextureMode:=tmModulate;
        TextureWrap:=twBoth;
    end;
      {Wrap is ON so 4 per 128x128 point Texture tile ? Terrain Scale?
      512x512 image covers 4092x4092  8x ?}
      with TerrainML.LibMaterialByName('details').TextureScale do
      begin  //detailmap is 128x128
        X:=128/ InTileSize;  //1 2 4 8 16  32  64;
        Y:=128/ InTileSize;
        Z:=128/ InTileSize;
      end;

  end else
  begin
    Showmessage(ExtractFilePath(Application.ExeName)+'detailmap.jpg'+ ' MIA Bye');
    dtmGlHdsForm.Close;
  end;
   //Texture is just a color that passes the Normal Color on as tint
   // Diffuse RGBA  .8, .8, .5, 1
   // Bumpn[0]:=0.873;    Bumpn[1]:=0.3;   Bumpn[2]:=0.766;     Bumpn[3]:=0.5;
   // BumplibMat.Material.FrontProperties.Diffuse.Color:=   Bumpn;
   //   Bumpn : TVector;
   //Does no good to change it
   {with TerrainML.LibMaterialByName('texture').Material do
   begin      //This turns it into a gray scale
      bmp:=TBitmap.Create;
      try
         bmp.PixelFormat:=pf24bit;
         bmp.Width:=65536;
         bmp.Height:=1;     // 32768..32767
         for i:=0 to 65536 do
         bmp.Canvas.Pixels[i, 0]:=
         //RGB(0, 0, i);
         heightColor[i - 32768];
         Texture.Image.Assign(bmp);
      finally
         bmp.Free;
      end;
   end;}

   with TerrainML.LibMaterialByName('contrast').Material do
   begin
      bmp:=TBitmap.Create;
      try
         bmp.PixelFormat:=pf24bit;
         bmp.Width:=1;
         bmp.Height:=1;
         i:=255;
         bmp.Canvas.Pixels[0, 0]:=RGB(i, i, i);
         Texture.Image.Assign(bmp);
      finally
         bmp.Free;
      end;       //0..255 adjusts amount of Bummap use
      i:=(100{TBIntensity.Position}*255) div 100; //=255
      Texture.EnvColor.AsWinColor:=RGB(i, i, i);
      //Material.Texture2Name := 'details';
   end;


                                                      {dtmFAKEhdstex.jpg}
  If FileExists(ExtractFilePath(Application.ExeName)+'035eau.jpg') then
  begin
    with TerrainML.AddTextureMaterial('FAKE',
           ExtractFilePath(Application.ExeName)+'035eau.jpg',  False) do
    begin
      with Material.Texture do
      begin
        TextureMode:=tmReplace;
        TextureWrap:=twNone;
      end;
      //TerrainML.Materials[1].
      Texture2Name := 'details';
    end;
  end else
  begin
    Showmessage(ExtractFilePath(Application.ExeName)+'035eau.jpg'+ ' MIA Bye-Bye');
    dtmGlHdsForm.Close;
  end;
  GLTerrainRenderer1.MaterialLibrary:=TerrainML;

  {ALL these Texture numbers need to be Squared XxY for actual value}
  {Textures cover 128 points OR Same as TileSize ?
      at 2 (256), 4 (512), or 8 (1024) pixels per data point
      Texture density (2,4,or 8)is determined during Texture creation,
      NO affect on anything here, ALWAYS 128 points per texture}
  {Maybe bonkers, but close to correct amount of textures needed}
  {-1 done in main Tilesize.. +-overlay of 1 }
  {- tilesize: expressed in elevation samples}
  DtmTileSize:=InTileSize;
  GLTerrainRenderer1.TileSize:= InTileSize;
   {TilesWideX and TilesTallY Used as Temporary variable for math}
  If (InSizeX mod PointsPerTexture) = 0 then  TilesWideX:=0
  else  TilesWideX:= ((InSizeX mod PointsPerTexture)div InTileSize );
  TexturesWideX:= ((InSizeX Div PointsPerTexture))+TilesWideX;
  If (InSizeY mod PointsPerTexture) = 0 then  TilesTallY:=0
  else  TilesTallY:= ((InSizeY mod PointsPerTexture)div InTileSize );
  TexturesTallY:= (InSizeY Div PointsPerTexture)+TilesTallY;
  {showmessage(inttostr(TilesWideX)+' : '+
  inttostr(InSizeX mod PointsPerTexture)+' : '+
  inttostr(InSizeY mod PointsPerTexture)+' : '+
  inttostr(TilesTallY) ); }
  {InSizeX, InSizeY,   Div  Tilesize = # of Tiles
   EXPECTS the data to be in Tilesize Increments}
  TilesWideX:= (InSizeX Div InTileSize);
  TilesTallY:= (InSizeY Div InTileSize);


    {X,Y 2.5  Z 0.5}      {512=2.5}                   {34 = 4000 .. 7.5 = 900}
    //PixelXSizeEdit from Projection is the size in Degrees
    //KiloPerPixelEdit
    //Inverse? size/tilesize gets Bigger with Datasize
    //actual scale would seem to get smaller with LARGE datasets
    // X and Y are Set Equal even if they might NOT be ... LatLon variation
  If UseXScale then  GLterrainRenderer1.Scale.X := XScaleUsed
  else
  GLterrainRenderer1.Scale.X :=1;// ((InSizeX)/ (PointsPerTexture));
  GLterrainRenderer1.Scale.Y :=//(InSizeY/ PointsPerTexture);
                                GLterrainRenderer1.Scale.X ;
  XPositionCorrection := GLterrainRenderer1.Scale.X ;
  {Base estimate to scale Height}
  If UseZScale then  GLterrainRenderer1.Scale.Z := ZScaleUsed
  else
    GLterrainRenderer1.Scale.Z :=8192 /
    (InAutoMaximumElevation-InAutoMinimumElevation);

  // CLODPrecision IS
  If UseClodP then GLTerrainRenderer1.CLODPrecision := Round(ClodPUsed) else
  GLTerrainRenderer1.CLODPrecision :=  60; //Need to be a Ratio to TileSize?
  // QualityDistance IS
  If UseQualityD then GLTerrainRenderer1.QualityDistance := QualityDUsed else
  GLTerrainRenderer1.QualityDistance :=  300; //Fog starts at 450 DOV 600


   {Starting Position... Location Clicked.. Scaled
    Cube     Direction 0,0, 1 Up 0,1,0
    Camera             0,0,-1    0,1,0
    Terrain            0,1, 0    0,0,1}
   {Scale * Position = Data location ... after inital setup Warpage
     GLterrainRenderer1.Scale.X := InSizeX/PointsPerTexture;
     DCCamera.Position.X / Scale = Data X
     Y is Top = 0 .. same as HTF
     X is Negative its scale width to be 0 at its Max Width}
  {Move so it starts and looks like the Viewer screen}
   {Fake stuff Changes depending on other parameters.. Need Offset ?}
  If UseFlippedHTF then
  begin
  GLterrainRenderer1.Position.X:= InSizeX*GLterrainRenderer1.Scale.X;//Starts at Other end
  //GLterrainRenderer1.Position.Y:= InSizeY;
   CameraCube.Position.X := InX *GLterrainRenderer1.Scale.X;
   CameraCube.Position.Y := 0;
   CameraCube.Position.Z := InY *GLterrainRenderer1.Scale.Y;
   XPositionCorrection:= XPositionCorrection* 1;// Lat Lon conversion (InX*GLterrainRenderer1.Scale.X);
  end else
  begin
   CameraCube.Position.X :=( -InX *GLterrainRenderer1.Scale.X);
   CameraCube.Position.Y := 0;
   CameraCube.Position.Z := InY *GLterrainRenderer1.Scale.Y;
   XPositionCorrection:= XPositionCorrection* -1;// Lat Lon conversion (InX*GLterrainRenderer1.Scale.X);
  end;
  {GLterrainRenderer1.Up.Z:=1; nope, not this} {X0 Y0}
   {Camera is in GL Coords Y=Up, while Terrain is in Z=Up Coords}
   {the camera 'bumps' itself 10,10 at startup..
   DOV and Height make Camera View Perspective}
  { CameraCube.Translate(25, 0, -15);}  {this moves x,y,z not used here}
  {Turn to Face selected Terrain position North is UP Forward}
   CameraCube.Turn(30{90});

   // Initial camera height offset (controlled with pageUp/pageDown)
   CamHeight:=20; {CamHeight used in Movement to Adjust Cubes}
  {Camera is Riding the DummyCube}
  {Place Camera to view around DummyCube}
  GLCamera.Position.X :=  0;
  GLCamera.Position.Y :=  1;
  GLCamera.Position.Z :=  3;

 { PRunDTS,    PUseDOV, PUseClodP, PUseQualityD,
    PDOVUsed, PClodPUsed, PQualityDUsed,}
  If UseDOV then GLCamera.DepthOfView  := DOVUsed else
  GLCamera.DepthOfView  := 600;{Fog ends at 650... White out beyond}
  GLCamera.FocalLength :=  50;
  GLCamera.TargetObject:=CameraCube;
                     //Fog : Start: DOV-150  End: DOV+50
  GLSceneViewer1.Cursor:=crNone;
  GLSceneViewer1.Buffer.FogEnvironment.FogStart:= GLCamera.DepthOfView-150;//450;
  GLSceneViewer1.Buffer.FogEnvironment.FogEnd:= GLCamera.DepthOfView+50;//650;
  // clrWhite;
  GLSceneViewer1.Buffer.FogEnvironment.FogColor.Alpha:=1;
  GLSceneViewer1.Buffer.FogEnvironment.FogColor.Blue:=1;
  GLSceneViewer1.Buffer.FogEnvironment.FogColor.Green:=1;
  GLSceneViewer1.Buffer.FogEnvironment.FogColor.Red:=1;
  GLSceneViewer1.Buffer.BackgroundColor:=clWhite;
  //[roDoubleBuffer,roRenderToWindow]
  GLSceneViewer1.Camera:=GLCamera;

   //appears to be in the West... Bumpmap seems it is in the East
   SPSun.Position.x:= 140;  //distance
   SPSun.Position.y:= 100;   //up
   SPSun.Position.z:= -235;//75;  //circular ?
   // SPSun.Height:=60;// Image size aka width
   
   //Only 1 Tile gets wrapped..Not good for HTF
  GLHeightTileFIleHDS1.InfiniteWrap := FALSE;
  //  SetCurrentDir(ExtractFilePath(Application.ExeName));
  //... I use Path rather than absolute location
  // Global String variables: HTFPath+HTFName;
  If (UseFlippedHTF and FileExists(HTFPath+HTFTextureName+'flip'+'.htf')) then
  GLHeightTileFileHDS1.HTFFileName :=HTFPath+HTFTextureName+'flip'+'.htf'
  else
  begin
    UseFlippedHTF:=False;
    GLHeightTileFileHDS1.HTFFileName :=HTFPath+HTFTextureName+'.htf';//HTFName;
  end;

  dtmGlHdsForm.Caption:=inttostr(0);//Current Tile used//HTFPath+HTFName;
          StatusBar.Panels[0].Text :='X: '+
            Inttostr(Round((CameraCube.Position.X {*XPositionCorrection})));
          StatusBar.Panels[1].Text :='Y: '+
            Inttostr(Round((CameraCube.Position.Z {*XPositionCorrection})));
          StatusBar.Panels[2].Text :='Height: '+
            Inttostr(Round(( CameraCube.Position.Y
            {CamHeight}
            {DCCamera.Position.Y+ GLCamera.DistanceToTarget})));
          StatusBar.Panels[3].Text :='DOView: '+ {600   1000}
            Floattostr((GLCamera.DepthOfView));
          StatusBar.Panels[4].Text :='Z Scale: '+ {0.5}
            Floattostr((GLTerrainRenderer1.Scale.Z));
          StatusBar.Panels[5].Text :='X Scale: '+ {2.5}
            Floattostr((GLTerrainRenderer1.Scale.X));
          StatusBar.Panels[6].Text := 'CLOD Precision: '+{60  5}
            Inttostr(Round(GLTerrainRenderer1.CLODPrecision));
          StatusBar.Panels[7].Text := 'Quality Distance: '+{300  100}
            Inttostr(Round(GLTerrainRenderer1.QualityDistance));

   If (isRunningOnDtp and LoadDTPOnStart) then
   begin
      //Load the Data...
      //It is in FileName Strings or the Shape file attributes
      If ((ProjectRobotRldFilename<> NoName)
      and( FileExists(ProjectRobotRldFilename)) )then
        LoadActorrld(ProjectRobotRldFilename);
        SetShapeObjects;         {Load Path and Run}
        DTProjectLoaded:=True;
        RunDTPMenu.Enabled:=True;
   end;

   If (LoadDTCOnStart) then
   begin
     DoLoadDTC(DtcCommandFile);
     DoRunDTC;
   end;
   //  DtcCommandFile,//File name for the DTC file
   NoGLRunning:=False;
   Timer1.Enabled:=True;
   GLCadencer1.Enabled:=True;
End;


procedure TdtmGlHdsForm.SetShapeObjects;
var LayerDo, ILoad:Integer;
Begin   { For ILoad := 1 to  LayersLoaded do}
  For ILoad:=0 to LayersLoaded-1 do
  Begin
    LayerDo:=LayersControlArray[ILoad];
    {Read the .ots file that Determines What and How the Object is displayed}
    If (LayA[LayerDo].LayerPlatoEditText= (''))
       or(not FileExists(LayA[LayerDo].LayerPlatoEditText)) then
       begin end else
    begin
      If ExtractFileExt(LayA[LayerDo].LayerPlatoEditText)='.old'then
      begin
      if( FileExists(LayA[LayerDo].LayerPlatoEditText)) then
        LoadShapeOld(LayA[LayerDo].LayerPlatoEditText,LayerDo)
        else showmessage(inttostr(LayerDo)+' :'+LayA[LayerDo].LayerPlatoEditText+':');
      end else
      If ExtractFileExt(LayA[LayerDo].LayerPlatoEditText)='.ald'then
      begin
      if( FileExists(LayA[LayerDo].LayerPlatoEditText)) then
        LoadAreaobject(LayA[LayerDo].LayerPlatoEditText,LayerDo)
      end else
      If ExtractFileExt(LayA[LayerDo].LayerPlatoEditText)='.lld'then
      begin
      if( FileExists(LayA[LayerDo].LayerPlatoEditText)) then
        LoadLineobject(LayA[LayerDo].LayerPlatoEditText,LayerDo)
      end else
      If ExtractFileExt(LayA[LayerDo].LayerPlatoEditText)='.pld'then
      begin
      if( FileExists(LayA[LayerDo].LayerPlatoEditText)) then
        LoadPointobject(LayA[LayerDo].LayerPlatoEditText,LayerDo)
      end;
    end;
  end;
End;

//Load files and Set Object Locations...
procedure TdtmGlHdsForm.LoadShapeOld(Filename:String;ILoad:Integer);
var
 ShapeSobject,
 Shapeobject, TextureBillboard:Boolean;
 ActorFileName,ActorTextureFileName,
 P2FileName,ActorScaleString: string;
 ActorUp, S : string;
 F: TextFile;
  oldCTRG:Integer;
  Length, Width,  Height,
 ActorUpSize, ActorScale:Double;
begin
  Shapeobject:=False;
  TextureBillboard:=False;
  ShapeSobject:=False;
  ActorScale:=1; ActorUpSize:=1;  ActorUp:='Y';
  Length:=1;Width:=1;Height:=1;oldCTRG:=1;
  ProjectPath:=ExtractFilePath(Filename);
  AssignFile(F, FileName);
  Reset(F);
  Readln(F, S);
  If (S=GoatVersion) then
  begin
    {Read file and get ActorFileName, TextureFileName,
       WeaponFileName, WpnTextureFileName Filenames...}
    //shape object (*.3ds)|*.3DS;*. OBJ;*.TIN;*.PLY;*.STL';
    Readln(F, S);  If S = 'True' then Shapeobject:=True;
    //Texture Billboard (*.png)|*.png;*.jpg;*.bmp';
    Readln(F, S);  If S = 'True' then TextureBillboard:=True;
    Readln(F, S);  If S = 'True' then ShapeSobject:=True;
    //Read the File Names
    Readln(F, ActorFileName); //Whatever file name
    Readln(F, ActorTextureFileName); //whatever is there
    Readln(F, ActorScaleString); //Re used for ActorScale
    ActorScale:=StrtoFloatDef(ActorScaleString);
    Readln(F, S);   oldCTRG :=StrtoInt(S);
    Readln(F, S); Length :=StrtoFloatDef(S);
    Readln(F, S); Width :=StrtoFloatDef(S);
    Readln(F, ActorUp); //Up Dir
    Readln(F, S); Height :=StrtoFloatDef(S);
    Readln(F, S); ActorUpSize:=StrtoFloatDef(S);
    Readln(F, P2FileName);
    CloseFile(F);
  end;
  {showmessage(ActorFileName+','+TextureFileName
  +','+ floattostr(ActorScale) +','+inttostr(ILoad));}
  If  Shapeobject then LoadShapeobject(ActorUp,ActorFileName,ActorTextureFileName,ActorUpSize,ActorScale,Length,Width,Height,ILoad,oldCTRG)
  else if TextureBillboard then LoadTextureBillboardobject(ActorUp,ActorTextureFileName,ActorUpSize,ActorScale,Length,Width,Height,ILoad,oldCTRG)
  else if ShapeSobject then LoadShapeShifterObject(ActorUp,ActorFileName,
       ActorTextureFileName, P2FileName, ActorUpSize,ActorScale,Length,Width,Height, ILoad,oldCTRG);
end;

//MDC MD3 GL2 MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GTS LWO GLSM
//OpenDialog.Filter:= 'Object (*.3ds)|*.MD2;*.3DS;*.OBJ;*.TIN;*.PLY;*.STL;*.OCT;*.NMF;*.GTS;*.LWO;*.MS3D;*.GLSM';

//  SetLength(ShapeShifterArray,0);
procedure TdtmGlHdsForm.LoadShapeShifterObject(ActorUp,ActorFilename,TextureFileName,P2FileName:String;ActorUpSize,ActorScale,ActorLength,ActorWidth,ActorHeight:Double;ILoad,oldCTRG:Integer);
// Load 1 Object AND the List of Path-Action-Evolve
//Set 1st as Default  ShapeShifterArray:Array of TAffineVector;
var libMat : TGLLibMaterial;
  //NumParts, NumPoints, //for polygons or lines
  ShapeType, ShapeToDo, DXI,DYI, NumShape: integer;
  terrainHeight:Single;
  DXdtemp,DYdtemp:Double;
  NewObject: TGLFreeForm;
  NewObjectMd2: TGLActor;
  IsMd2:Boolean;
  Dirs:String; Dir:Integer;
 // min, max : TAffineVector;
begin //  LayA[ILoad].OtsNameEditText
  NewObject:=(ShapeDC.AddNewChild(TGLFreeForm) as TGLFreeform);
  NewObjectMd2:=(ShapeDC.AddNewChild(TGLActor) as TGLActor);
  IsMd2:=False;
  ShapeType:= LayA[ILoad].ShpType;
  NumShape:= LayA[ILoad].ShapeN;
  If ((MaximumShapesLoaded+1 ) < MaximumShapeObjects) then
  begin inc(MaximumShapesLoaded); end else
  begin
    showmessage('Maximum Shapes Exceeded');
    exit;
  end;
  If ((ShapeType=1) or(ShapeType=11) or(ShapeType=21)) then
  begin
    dXTemp:=LayA[ILoad].LyrShp[1].XMax;
    dYTemp:=LayA[ILoad].LyrShp[1].YMax;
    DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp{- TMinOffX} ;
    DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp{+ TMinOffY};
    DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
    DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
    SetLength(ShapeShifterArray,NumShape);
    ShapeShifterArray[0].X:=DXI;
    ShapeShifterArray[0].Z:=DYI;
    //Switch for Md2..Objects can have Moving Parts
    If (ExtractFileExt(ActorFilename)='.md2')then
    begin
      ShapeDC.Children[ShapeDC.Count-1].Free;
      libMat:=ObjectsML.Materials.Add;
      libMat.Name:='Object_'+inttostr(ILoad);
      NewObjectMd2.Material.LibMaterialName:=libMat.Name;
      NewObjectMd2.Material.MaterialLibrary:=ObjectsML;
      NewObjectMd2.LoadFromFile(ActorFilename);
      If FileExists(TextureFileName) then
      begin
        ObjectsML.materials.GetLibMaterialByName('Object_'+inttostr(ILoad)).material.texture.image.loadfromfile(TextureFileName);
      end;
      NewObjectMd2.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
      NewObjectMd2.Position.X:=DXI;
      NewObjectMd2.Position.Z:=DYI;
      //NewObjectMd2.GetExtents(min, max);
      with NewObjectMd2.Position do
      begin
        terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
        //Y:=terrainHeight+ActorUpSize {-(min[2]*ActorScale)}; //0.04
        Y:=terrainHeight+ActorUpSize;
        ShapeShifterArray[0].Y:=Y;
      end;

      {NewObjectMd2.Up.z:=-1;
      NewObjectMd2.Up.y:=0;  }
//Dirs:= ActorUp;
    If Length(ActorUp)=2 then
    begin
      Dirs:= ActorUp[1];
      If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
      ActorUp := ActorUp[2];
    end else Dir:=1;
    If lowercase(ActorUp)='y' then
    begin
      NewObjectMd2.Up.y:=Dir;
      NewObjectMd2.Up.z:= 0;
      NewObjectMd2.Up.x:=0;
    end else
    If lowercase(ActorUp)='z' then
    begin
      NewObjectMd2.Up.y:=Dir;
      NewObjectMd2.Up.z:=0;
      NewObjectMd2.Up.x:=0;
    end else
    If lowercase(ActorUp)='x' then
    begin
      NewObjectMd2.Up.x:=Dir;
      NewObjectMd2.Up.y:=0;
      NewObjectMd2.Up.z:=0;
    end;

      IsMd2:=True;
    end else
    begin
      ShapeDC.Children[ShapeDC.Count-2].Free;
   if Uppercase(ExtractFileExt(ActorFilename))='.GLSM' then
   begin
        try
           if FileExists(ChangeFileExt(ActorFilename,'.GLML')) then
              ObjectsML.LoadFromFile(ChangeFileExt(ActorFilename,'.GLML'));
        except
              ShowMessage('Error loading MaterialLibrary "'+ChangeFileExt(ActorFilename,'.GLML')+'"');
        end;

   end else
   begin
      libMat:=ObjectsML.Materials.Add;
      libMat.Name:='Object_'+inttostr(ILoad);
      NewObject.Material.LibMaterialName:=libMat.Name;
  end;
      NewObject.Material.MaterialLibrary:=ObjectsML;

      NewObject.LoadFromFile(ActorFilename);
      If FileExists(TextureFileName) then
      begin
        ObjectsML.materials.GetLibMaterialByName('Object_'+inttostr(ILoad)).material.texture.image.loadfromfile(TextureFileName);
      end;
      NewObject.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
      //NewObject.GetExtents(min, max); //xyzwt
      NewObject.Position.X:=DXI;
      NewObject.Position.Z:=DYI;
      with NewObject.Position do
      begin       //ShapeDC.DeleteChildren;
        terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
        //0,0,0 is Center of Mass min is negative
        //Y:=terrainHeight+ActorUpSize{- (min[2]*ActorScale)}; //0.04
        Y:=terrainHeight+ActorUpSize;
        ShapeShifterArray[0].Y:=Y;
      end;   //cities is NOT full size.. Countries is
      {NewObject.Up.z:=-1;
      NewObject.Up.y:=0;  ActorUp}
    If Length(ActorUp)=2 then
    begin
      Dirs:= ActorUp[1];
      If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
      ActorUp := ActorUp[2];
    end else Dir:=1;
    If lowercase(ActorUp)='y' then
    begin
      NewObject.Up.y:=Dir;
      NewObject.Up.z:= 0;
      NewObject.Up.x:=0;
    end else
    If lowercase(ActorUp)='z' then
    begin
      NewObject.Up.y:=Dir;
      NewObject.Up.z:=0;
      NewObject.Up.x:=0;
    end else
    If lowercase(ActorUp)='x' then
    begin
      NewObject.Up.x:=Dir;
      NewObject.Up.y:=0;
      NewObject.Up.z:=0;
    end;

    end;
    //End of Switch of Md2 or any thing ELSE
    If ((MaximumShapesLoaded+NumShape ) < MaximumShapeObjects) then
       inc(MaximumShapesLoaded, NumShape-1)
       else
       begin
         NumShape :=(MaximumShapeObjects-MaximumShapesLoaded);
         MaximumShapesLoaded:= MaximumShapeObjects;
       end;
    ShapeShifter:=ShapeDC.Count-1;
    ShapeShifterLayer:=ILoad;
    ShapeShifterCount:=NumShape-1;
    ShapeShifterFileName:=P2FileName;
    For ShapeToDo:=2 to NumShape do
    Begin
      dtmGlHdsForm.Caption:=inttostr(ShapeToDo-1);
      Application.ProcessMessages;
      dXTemp:=LayA[ILoad].LyrShp[ShapeToDo].XMax;
      dYTemp:=LayA[ILoad].LyrShp[ShapeToDo].YMax;
      DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp{- TMinOffX} ;
      DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp{+ TMinOffY};
      DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
      DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
      ShapeShifterArray[ShapeToDo-1].X:=DXI;
      ShapeShifterArray[ShapeToDo-1].Z:=DYI;
      If IsMd2 then
      with NewObjectMd2.Position do
      begin
        terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
        Y:=terrainHeight+ActorUpSize{- (min[2]*ActorScale)}; //0.04
        ShapeShifterArray[ShapeToDo-1].Y:=Y;
      end else
      with NewObject.Position do
      begin       //ShapeDC.DeleteChildren;
        terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
        //0,0,0 is Center of Mass min is negative
        Y:=terrainHeight+ActorUpSize{- (min[2]*ActorScale)}; //0.04
        ShapeShifterArray[ShapeToDo-1].Y:=Y;
      end;
    end;
  end;
End;

//Create a FreeForm and the Proxies for it.. Place according to
//Shape File Location
{0 Null Shape
1 Point      11 PointZ       21 PointM
8 MultiPoint 18 MultiPointZ  28 MultiPointM
3 PolyLine   13 PolyLineZ    23 PolyLineM
5 Polygon    15 PolygonZ     25 PolygonM
31 MultiPatch      Fan or Strip     }
procedure TdtmGlHdsForm.LoadShapeobject(ActorUp, ActorFilename,TextureFileName:String; ActorUpSize,ActorScale,ActorLength,ActorWidth,ActorHeight:Double;ILoad,oldCTRG:Integer);
var libMat : TGLLibMaterial;
var
  //NumParts, NumPoints, //for polygons or lines
  ShapeType, ShapeToDo, DXI,DYI, NumShape: integer;
  terrainHeight:Single;
  DXdtemp,DYdtemp:Double;
  NewObject: TGLFreeForm;
  NewObjectMd2: TGLActor;
  IsMd2:Boolean;
  proxy: TGLProxyObject;
  Dirs:String; Dir:Integer;
//  min, max : TAffineVector;
begin //  LayA[ILoad].LayerPlatoEditText
  NewObject:=(ShapeDC.AddNewChild(TGLFreeForm) as TGLFreeform);
  NewObjectMd2:=(ShapeDC.AddNewChild(TGLActor) as TGLActor);
  IsMd2:=False;
  ShapeType:= LayA[ILoad].ShpType;
  NumShape:= LayA[ILoad].ShapeN;
  If ((MaximumShapesLoaded+1 ) < MaximumShapeObjects) then
  begin inc(MaximumShapesLoaded); end else
  begin
    showmessage('Maximum Shapes Exceeded');
    exit;
  end;
  If ((ShapeType=1) or(ShapeType=11) or(ShapeType=21)) then
  begin
    { TMaxOffsetX TMaxOffsetY: Read from vrp projection
      TMaxOffsetX:=( (abs(MapProjRec.TopRightXEditText-MapProjRec.TopLeftXEditText) /htf.SizeX));
      TMaxOffsetY:=( (abs(MapProjRec.BottomLeftYEditText-MapProjRec.TopLeftYEditText) /htf.SizeY));
      else
      TMaxOffsetX:=( (360 /htf.SizeX));
      TMaxOffsetY:=( (180 /htf.SizeY));
      TMaxOffX:= htf.SizeX;
      TMaxOffY:= htf.SizeY;
      These should be a SCALED not an ADDED Value
        TMinOffX:= curX;    Amount moved from upper left 0,0
        TMinOffY:= curY;    NOT current Mouse X,Y
        DShiftOffsetX DShiftOffsetY Never changed from 0 }
    {Offset is +- to center data to 0,0
    BECAUSE Screen does NOT contain all data
    SO Mouse X,Y is a Portion of the Complete Picture
    TMinOffX:= TMinOffX*TMaxOffsetX;
    TMinOffY:= TMinOffY*TMaxOffsetY;
    ScreenScale :=   TMaxOffsetX;}
    //MaxOffsetX MaxOffsetY set in Shape file loading
             //DShiftOffsetX set in DTP HTF FIX
             //Kinda confusing..the value is NOT what is  displayed...
                               {1}
    dXTemp:=LayA[ILoad].LyrShp[1].XMax;
    dYTemp:=LayA[ILoad].LyrShp[1].YMax;
    DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp{- TMinOffX} ;
    DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp{+ TMinOffY};
    DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
    DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
           // Filename,TextureFileName
    //Switch for Md2..Objects can have Moving Parts
    If (ExtractFileExt(ActorFilename)='.md2')then
    begin
      ShapeDC.Children[ShapeDC.Count-1].Free;
      libMat:=ObjectsML.Materials.Add;
      libMat.Name:='Object_'+inttostr(ILoad);
      NewObjectMd2.Material.LibMaterialName:=libMat.Name;
      NewObjectMd2.Material.MaterialLibrary:=ObjectsML;
      NewObjectMd2.LoadFromFile(ActorFilename);
      If FileExists(TextureFileName) then
      begin
        {NewObject.Material.Texture.Image.LoadFromFile(TextureFileName);
         NewObject.Material.Texture.Disabled:=False;}
        ObjectsML.materials.GetLibMaterialByName('Object_'+inttostr(ILoad)).material.texture.image.loadfromfile(TextureFileName);
      end;
      NewObjectMd2.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
      NewObjectMd2.Position.X:=DXI;
      NewObjectMd2.Position.Z:=DYI;
      //NewObject.GetExtents(min, max);
      with NewObjectMd2.Position do
      begin
        terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
        Y:=terrainHeight+ActorUpSize{- (min[2]*ActorScale)}; //0.04
      end;
{      NewObjectMd2.Up.z:=-1;
      NewObjectMd2.Up.y:=0;}
    If Length(ActorUp)=2 then
    begin
      Dirs:= ActorUp[1];
      If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
      ActorUp := ActorUp[2];
    end else Dir:=1;
    If lowercase(ActorUp)='y' then
    begin
      NewObjectMd2.Up.y:=Dir;
      NewObjectMd2.Up.z:= 0;
      NewObjectMd2.Up.x:=0;
    end else
    If lowercase(ActorUp)='z' then
    begin
      NewObjectMd2.Up.y:=Dir;
      NewObjectMd2.Up.z:=0;
      NewObjectMd2.Up.x:=0;
    end else
    If lowercase(ActorUp)='x' then
    begin
      NewObjectMd2.Up.x:=Dir;
      NewObjectMd2.Up.y:=0;
      NewObjectMd2.Up.z:=0;
    end;
      IsMd2:=True;
    end else
    begin
      ShapeDC.Children[ShapeDC.Count-2].Free;
   if Uppercase(ExtractFileExt(ActorFilename))='.GLSM' then
   begin
        try
           if FileExists(ChangeFileExt(ActorFilename,'.GLML')) then
              ObjectsML.LoadFromFile(ChangeFileExt(ActorFilename,'.GLML'));
        except
              ShowMessage('Error loading MaterialLibrary "'+ChangeFileExt(ActorFilename,'.GLML')+'"');
        end;

   end else
   begin

      libMat:=ObjectsML.Materials.Add;
      libMat.Name:='Object_'+inttostr(ILoad);
      NewObject.Material.LibMaterialName:=libMat.Name;
   end;
      NewObject.Material.MaterialLibrary:=ObjectsML;
      NewObject.LoadFromFile(ActorFilename);
      If FileExists(TextureFileName) then
      begin
        {NewObject.Material.Texture.Image.LoadFromFile(TextureFileName);
         NewObject.Material.Texture.Disabled:=False;}
        ObjectsML.materials.GetLibMaterialByName('Object_'+inttostr(ILoad)).material.texture.image.loadfromfile(TextureFileName);
      end;
      NewObject.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
      //NewObject.GetExtents(min, max); //xyzwt
      { with CubeExtents do begin
        CubeWidth:=max[0]-min[0];
        CubeHeight:=max[1]-min[1];
        CubeDepth:=max[2]-min[2];
        Position.AsAffineVector:=VectorLerp(min, max, 0.5);
        end; }
      NewObject.Position.X:=DXI;
      NewObject.Position.Z:=DYI;
      with NewObject.Position do
      begin       //ShapeDC.DeleteChildren;
        terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
        //0,0,0 is Center of Mass min is negative
        Y:=terrainHeight+ActorUpSize{- (min[2]*ActorScale)}; //0.04
      end;   //cities is NOT full size.. Countries is
     { NewObject.Up.z:=-1;
      NewObject.Up.y:=0;}
    If Length(ActorUp)=2 then
    begin
      Dirs:= ActorUp[1];
      If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
      ActorUp := ActorUp[2];
    end else Dir:=1;
    If lowercase(ActorUp)='y' then
    begin
      NewObject.Up.y:=Dir;
      NewObject.Up.z:= 0;
      NewObject.Up.x:=0;
    end else
    If lowercase(ActorUp)='z' then
    begin
      NewObject.Up.y:=Dir;
      NewObject.Up.z:=0;
      NewObject.Up.x:=0;
    end else
    If lowercase(ActorUp)='x' then
    begin
      NewObject.Up.x:=Dir;
      NewObject.Up.y:=0;
      NewObject.Up.z:=0;
    end;
      //NewObject.Position.Y:=htf.XYHeight(DXI, DYI);
      //showmessage(Filename);
       { showmessage(Floattostr(NewObject.Position.X)+','
        +Floattostr(NewObject.Position.Z)+','
        +Floattostr(NewObject.Position.Y)); }
      //NewObject.ShowAxes:=True;
      //CameraCube.Position:= NewObject.Position;
    end;
    //End of Switch of Md2 or any thing ELSE
    If ((MaximumShapesLoaded+NumShape ) < MaximumShapeObjects) then
       inc(MaximumShapesLoaded, NumShape-1)
       else
       begin
         NumShape :=(MaximumShapeObjects-MaximumShapesLoaded);
         MaximumShapesLoaded:= MaximumShapeObjects;
       end;

    For ShapeToDo:=2 to NumShape do
    Begin
      dtmGlHdsForm.Caption:=inttostr(ShapeToDo-1);
      Application.ProcessMessages;
      dXTemp:=LayA[ILoad].LyrShp[ShapeToDo].XMax;
      dYTemp:=LayA[ILoad].LyrShp[ShapeToDo].YMax;
      DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp{- TMinOffX} ;
      DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp{+ TMinOffY};
      DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
      DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;

     proxy:=TGLProxyObject(ShapeDC.AddNewChild(TGLProxyObject));
      with proxy do
      begin
        ProxyOptions:=[pooObjects];
        If IsMd2 then
        begin
          MasterObject:=NewObjectMd2;
          Direction:=NewObjectMd2.Direction;
          Up:=NewObjectMd2.Up;
          Scale:=NewObjectMd2.Scale;
        end else
        begin
          MasterObject:=NewObject;
          Direction:=NewObject.Direction;
          Up:=NewObject.Up;
          Scale:=NewObject.Scale;
        end;
        Visible:=True;
        // retrieve reference attitude

        //SetVector(ActorScale, ActorScale, ActorScale, 0);
        Position.X:=DXI;
        Position.Z:=DYI;
        //Position.Y:=htf.XYHeight(DXI, DYI);
        with Position do
        begin
          terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
          Y:=terrainHeight+ActorUpSize{- (min[2]*0.04)}; //0.04
        end;
         // randomize orientation
         RollAngle:=Random(360);
        TransformationChanged;
      end;
    end;
  end;
end;

procedure TdtmGlHdsForm.LoadTextureBillboardobject(ActorUp,Filename:String; ActorUpSize,ActorScale,ActorLength,ActorWidth,ActorHeight:Double;ILoad,oldCTRG:Integer);
var libMat : TGLLibMaterial;
  //NumParts, NumPoints, //for polygons or lines
  ShapeType, ShapeToDo, DXI,DYI, NumShape: integer;
  DXdtemp,DYdtemp:Double;
  spr : TGLSprite;
begin //  LayA[ILoad].OtsNameEditText
  ShapeType:= LayA[ILoad].ShpType;
  NumShape:= LayA[ILoad].ShapeN;
  If ((ShapeType=1) or(ShapeType=11) or(ShapeType=21)) then
  begin
    dXTemp:=LayA[ILoad].LyrShp[1].XMax;
    dYTemp:=LayA[ILoad].LyrShp[1].YMax;
    DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
    DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
    DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
    DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
           // Filename,TextureFileName
    spr:=(BillBoardDC.AddNewChild(TGLSprite) as TGLSprite);
    //spr.LoadFromFile(Filename);
    spr.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
    spr.Width :=ActorWidth;
    spr.Height :=ActorHeight;
    spr.Position.X:=DXI;
    spr.Position.Y:=DYI;
    spr.Position.Z:=htf.XYHeight(DXI, DYI)+ActorUpSize; //ActorUp  ActorUpSize
    //Need to Load the Texture into a Matlib NOT the Sprite Texture
    libMat:=ObjectsML.Materials.Add;
    libMat.Name:='Object_'+inttostr(ILoad);
    spr.Material.LibMaterialName:=libMat.Name;
    spr.Material.MaterialLibrary:=ObjectsML;
    If FileExists(Filename) then
    begin
      {NewObject.Material.Texture.Image.LoadFromFile(TextureFileName);
      NewObject.Material.Texture.Disabled:=False;}
      ObjectsML.materials.GetLibMaterialByName('Object_'+inttostr(ILoad)).material.texture.image.loadfromfile(Filename);
    end;
    //spr.Material.Texture.Image.LoadFromFile(Filename);
    For ShapeToDo:=2 to NumShape do
    Begin
      dXTemp:=LayA[ILoad].LyrShp[ShapeToDo].XMax;
      dYTemp:=LayA[ILoad].LyrShp[ShapeToDo].YMax;
      DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
      DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
      DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
      DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
      spr:=TGLSprite(BillBoardDC.AddNewChild(TGLSprite));
      spr.Assign(spr);
     with spr do
     begin
       Visible:=True;
       spr.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
       spr.Position.X:=DXI;
       spr.Position.Y:=DYI;
       spr.Position.Z:=htf.XYHeight(DXI, DYI)+ActorUpSize;
       spr.Width :=ActorWidth;
       spr.Height :=ActorHeight;
       TransformationChanged;
     end;
    end;
  end;
end;


//Read the DTP file to get the Attribute and Model Data
//Read the Shape file and CONNECT the Shape TO the Model
//1 Object at CenterMass, or Lines or Polgons Depict an Area
//Use Point files for Plants..
//   NO WAY to make random within area YET
//   NO WAY to use a Density Map
{Go through the Shape file per Shape
  then If a Shape Attribute = ???
   I Proxy the Object OR BillBoard or Imposter OR....
  At the Correct Location
  AND have to Check the Activity to see how it is to Behave}
procedure TdtmGlHdsForm.LoadAreaobject(Filename:String;ILoad:Integer);
var
  S:String;
 BioFile, outfile:Textfile;
 // ControlType,SupportStructureType,
 DisplayType, AreaShapeAttType,
  ControlFileNamesCount, AttributeCount,i:Integer;
  NewProxy : TGLProxyObject;
 INumparts,  INumPoints,
 NumShape, NumParts, NumPoints,
  ShapeType, ShapeToDo, DXI,DYI: integer;
 Editarray:Array of TPoint;
  DXdtemp,DYdtemp:Double;
  ControlStringList,
  AreaShapeAttStringList:TStringList;
 ActorFileName,ActorTextureFileName,
 P2FileName: string;
 ActorUp : string;
  Dirs:String; Dir:Integer;
//  oldCTRG:Integer;
//  ActorLength, ActorWidth,  ActorHeight,
 ActorUpSize, ActorScale:Double;
 terrainHeight:Single;
 AttrCount:Integer;
 ControlFileName,AttrString: string;
begin
  ControlStringList:= TStringList.Create;
  AreaShapeAttStringList := TStringList.Create;
  Try
    //ActorScale:=1; ActorUpSize:=1;
    ActorUp:='Y';
    AssignFile(outfile, FileName);
    Reset(outfile);   //Open File and Set Data
    Readln(outfile,S); If S= GoatVersion then;
    Readln(outfile,S); // aldRG.ItemIndex:=strtoint(S);
    Readln(outfile,S);  DisplayType:=strtoint(S);
    //The Attribute to Display
    Readln(outfile,S);  AreaShapeAttType:=strtoint(S);

    //Number of Shape Attribute Values
    Readln(outfile,S);
    AttributeCount:=strtoint(S);
    For I:=0 to AttributeCount-1 do
    begin
      Readln(outfile, S);
      AreaShapeAttStringList.add(S);
    end;
    //Array..List of Shape Attribute = ptd Filenames in pdl
    //1=17 2=4 3=11 4=1 5=1
    SetLength(AreaArray,AttributeCount);
    For i:= 0 to AttributeCount-1 do
    begin
      Readln(outfile, S); AreaArray[i].Shape:=strtoint(S);
      Readln(outfile, S); AreaArray[i].FileName:=strtoint(S);
    end;
    Application.ProcessMessages;
    //Filename of  Other Defined List (.odl)
    Readln(outfile,S);
    //adlFilenameEdit.Text:= S;
    //Number of ControlFileNames
    Readln(outfile,S);
    ControlFileNamesCount:=strtoint(S);
    //adlRichEdit.Clear;
    For I:=0 to ControlFileNamesCount-1 do
    begin
      Readln(outfile, S);
      ControlStringList.add(S);
    end;
  Finally
    CloseFile(outfile);
  End;
  //  LayA[ILoad].OtsNameEditText
  ShapeType:= LayA[ILoad].ShpType;
  NumShape:= LayA[ILoad].ShapeN;
  //ONLY Area OBJECTS HERE
  If ((ShapeType=5) or(ShapeType=15) or(ShapeType=25)) then
  begin
    If ((DisplayType = 3)or(DisplayType = 7)) then
    begin
      For ShapeToDo:=1 to NumShape do
      Begin
        Application.ProcessMessages;
        Numparts:=LayA[ILoad].LyrShp[ShapeToDo].PartsN;{Numparts}
        for INumparts := 1 to Numparts do
        begin {Always at least 1 0...}
          NumPoints:=LayA[ILoad].LyrShp[ShapeToDo].PPA[INumparts];
          {Make Poly array}
          SetLength(Editarray,NumPoints);
          for INumPoints := 1{2} to NumPoints do
          begin {2 points internally}
            dXTemp:=LayA[ILoad].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Xd;
            dYTemp:=LayA[ILoad].LyrShp[ShapeToDo].PARA[INumparts].PA[INumPoints].Yd;
            DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
            DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
            DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
            DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
            Editarray[INumPoints-1].X:= DXI;
            Editarray[INumPoints-1].Y:= DYI;
          end;{INumPoints}

          If DisplayType = 3 then
          begin  //Lines
(*
              Image321.Bitmap.MoveTo(Editarray[0].X, Editarray[0].Y);
              for INumPoints := 2 to NumPoints do
   If LayA[LayerDo].UseStippleStep then
   Image321.Bitmap.LineToFSP(Editarray[INumPoints-1].X,
                                        Editarray[INumPoints-1].Y)
   else
    Image321.Bitmap.LineToS(Editarray[INumPoints-1].X,
                                        Editarray[INumPoints-1].Y);

*)
          end else
          If DisplayType = 7 then
          begin //Polygons

          end;
        end;{INumparts}
      end; {For ShapeToDo}
    end else
    If DisplayType = 0 then
    begin  //1 Proxy Object at Center of Area...
      For ShapeToDo:=1 to NumShape do
      Begin
        dXTemp:=LayA[ILoad].LyrShp[ShapeToDo].XMax;
        dYTemp:=LayA[ILoad].LyrShp[ShapeToDo].YMax;
        DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
        DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
        DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
        DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
        AttrString:=LayA[ILoad].LyrShp[ShapeToDo].AAttributes[AreaShapeAttType];
        AttrCount:=-1;
        For I:=0 to AttributeCount-1 do
        begin
          If AttrString =
          AreaShapeAttStringList.Strings[i] then
          AttrCount:=i;
        end;
        For i:= 0 to AttributeCount-1 do
        begin
          if PointArray[i].Shape=AttrCount then
          ControlFileName:=ControlStringList.Strings[ PointArray[i].FileName];
          AssignFile(BioFile, ControlFileName);
          Reset(BioFile);
          While not EOF(BioFile) do
          begin
          Readln(BioFile,S);
        Try     { File selected in dialog box }
          AssignFile(outfile,ControlFileName);
          Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S); // aslSidEdit.Text:=S;
      Readln(outfile,S); // aslUidEdit.Text:=S;
      Readln(outfile,S); // aslCnEdit.Text:=S;
      Readln(outfile,S); // aslSnEdit.Text:=S;
      Readln(outfile,S); // aslGroupEdit.Text:=S;
      Readln(outfile,S); // aslPlantsEdit.Text:=S;
      Readln(outfile,S); // aslDensityEdit.Text:=S;
      Readln(outfile,S); // aslObjTypeRG.ItemIndex:=strtoint(S);
      Readln(outfile,ActorFileName); // asl3dFileEdit.Text:=S;
      Readln(outfile,ActorTextureFileName); // asl3dTexEdit.Text:=S;
      Readln(outfile,S); // aslWidthEdit.Text:=S;
      Readln(outfile,S); // aslHeightEdit.Text:=S;
      Readln(outfile,S);  //ActorLength aslDepthEdit.Text:=S;
      Readln(outfile,S);  //aslSrEdit.Text:=S;
      Readln(outfile,S);  //aslSdEdit.Text:=S;
      Readln(outfile,S);  ActorScale:=strtofloat(S);
      Readln(outfile,ActorUp);//  aslUpDirEdit.Text:=S;
      Readln(outfile,S);  ActorUpSize:=strtofloat(S);
      Readln(outfile,P2FileName); // aslControlEdit.Text:=S;
        Finally
          CloseFile(outfile);
        End;
        NewProxy := TGLProxyObject(MMProxyDC.AddNewChild(TGLProxyObject));
        NewProxy.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
          //BillBoards only
          //NewProxy.Width :=ActorWidth;
          //NewProxy.Height :=ActorHeight;
        NewProxy.Position.X:=DXI;
        NewProxy.Position.Z:=DYI;
        with NewProxy.Position do
        begin       //ShapeDC.DeleteChildren;
          terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
          Y:=terrainHeight+ActorUpSize{- (min[2]*ActorScale)}; //0.04
          NewProxy.Position.Y:=Y;
        end;
        If Length(ActorUp)=2 then
        begin
          Dirs:= ActorUp[1];
          If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
          ActorUp := ActorUp[2];
        end else Dir:=1;
        If lowercase(ActorUp)='y' then
        begin
          NewProxy.Up.y:=Dir;
          NewProxy.Up.z:= 0;
          NewProxy.Up.x:=0;
        end else
        If lowercase(ActorUp)='z' then
        begin
          NewProxy.Up.y:=Dir;
          NewProxy.Up.z:=0;
          NewProxy.Up.x:=0;
        end else
        If lowercase(ActorUp)='x' then
        begin
          NewProxy.Up.x:=Dir;
          NewProxy.Up.y:=0;
          NewProxy.Up.z:=0;
        end;
        // Need a master object for this new proxy ?
        // Just use the manager :
        NewProxy.MasterObject := Manager.LoadModel(ActorFilename,ActorTextureFileName);
          end;
        end;
      end;
    end;
  end;
  SetLength(Editarray,0);
end;

//Read the DTP file to get the Attribute and Model Data
//Read the Shape file and CONNECT the Shape TO the Model
procedure TdtmGlHdsForm.LoadPointobject(Filename:String;ILoad:Integer);
var
  NewProxy : TGLProxyObject;
 // ControlType,SupportStructureType,
 DisplayType, PointShapeAttType,
  ShapeType, ShapeToDo, DXI,DYI, NumShape: integer;
  DXdtemp,DYdtemp:Double;
  ControlFileNamesCount, AttributeCount,i:Integer;
  S:String;
  outfile:Textfile;
  ControlStringList,
  PointShapeAttStringList:TStringList;
 ActorFileName,ActorTextureFileName,
 P2FileName: string;
 ActorUp : string;
  Dirs:String; Dir:Integer;
//  oldCTRG:Integer;
//  ActorLength, ActorWidth,  ActorHeight,
 ActorUpSize, ActorScale:Double;
 terrainHeight:Single;
 AttrCount:Integer;
 ControlFileName,AttrString: string;
begin
  ControlStringList:= TStringList.Create;
  PointShapeAttStringList := TStringList.Create;
  Try
    //ActorScale:=1; ActorUpSize:=1;
    ActorUp:='Y';
    //  ActorLength:=1;ActorWidth:=1;ActorHeight:=1;oldCTRG:=1;
    Try     { File selected in dialog box }
      AssignFile(outfile, Filename);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S); // ControlType:=strtoint(S);
      Readln(outfile,S);  DisplayType:=strtoint(S);
      Readln(outfile,S); // SupportStructureType:=strtoint(S);
      //The Attribute to Display
      Readln(outfile,S);  PointShapeAttType:=strtoint(S);

      //Number of Shape Attribute Values
      Readln(outfile,S);
      AttributeCount:=strtoint(S);
      //PointShapeAttSelectCB.Clear;
      For I:=0 to AttributeCount-1 do
      begin
        Readln(outfile, S);
        PointShapeAttStringList.add(S);
      end;
      //Array..List of Shape Attribute = ptd Filenames in pdl
      //1=17 2=4 3=11 4=1 5=1
      SetLength(PointArray,AttributeCount);
      For i:= 0 to AttributeCount-1 do
      begin
        Readln(outfile, S); PointArray[i].Shape:=strtoint(S);
        Readln(outfile, S); PointArray[i].FileName:=strtoint(S);
      end;
      Application.ProcessMessages;
      //Filename of  Other Defined List (.odl)
      Readln(outfile,S);
      //PointFilenameEdit.Text:= S;
      //Number of ControlFileNames
      Readln(outfile,S);
      ControlFileNamesCount:=strtoint(S);
      For I:=0 to ControlFileNamesCount-1 do
      begin
        Readln(outfile, S);
        ControlStringList.add(S);
      end;
    Finally
      CloseFile(outfile);
    End;

    //  LayA[ILoad].OtsNameEditText
    ShapeType:= LayA[ILoad].ShpType;
    NumShape:= LayA[ILoad].ShapeN;
    If ((ShapeType=1) or(ShapeType=11) or(ShapeType=21)) then
    begin   //ONLY POINT OBJECTS HERE
      For ShapeToDo:=1 to NumShape do
      Begin
        dXTemp:=LayA[ILoad].LyrShp[ShapeToDo].XMax;
        dYTemp:=LayA[ILoad].LyrShp[ShapeToDo].YMax;
        DXdtemp:=MaxOffsetX +DShiftOffsetX+dXTemp- DataSizeMinOffX ;
        DYdtemp:=MaxOffsetY +DShiftOffsetY+dYTemp+ DataSizeMinOffY;
        DXI:= Trunc((DXdtemp   ) / ScreenScale) ;
        DYI:=Trunc(DataSizeMaxOffY-( ((DYdtemp ) / ScreenScale))) ;
        AttrString:=LayA[ILoad].LyrShp[ShapeToDo].AAttributes[PointShapeAttType];
        AttrCount:=-1;
        For I:=0 to AttributeCount-1 do
        begin
          If AttrString =
          PointShapeAttStringList.Strings[i] then
          AttrCount:=i;
        end;
        For i:= 0 to AttributeCount-1 do
        begin
          if PointArray[i].Shape=AttrCount then
          ControlFileName:=ControlStringList.Strings[ PointArray[i].FileName];
        end;
           // Filename,TextureFileName
        //Get the Attribute and Connect the Link
        // ControlStringList[1]
        { Find will only work on sorted lists! }
        {    MyList.Sort;  ControlStringList  PointShapeAttStringList
            if MyList.Find('Flowers', Index) then
            begin}

        Try     { File selected in dialog box }
          AssignFile(outfile,ControlFileName);
          Reset(outfile);   //Open File and Set Data
          Readln(outfile,S); If S= GoatVersion then;
          Readln(outfile,ActorFileName);
          Readln(outfile,ActorTextureFileName);
          Readln(outfile,S); // ActorWidth:=strtoint(S);
          Readln(outfile,S); // ActorLength:=strtoint(S);
          Readln(outfile,S); // ActorHeight:=strtoint(S);

          Readln(outfile,S); // LtdSupportWidthEdit.Text:=S;
          Readln(outfile,S); // LtdSupportDepthEdit.Text:=S;
          Readln(outfile,P2FileName);
          Readln(outfile,S); ActorScale:=strtofloat(S);
          Readln(outfile,ActorUp);
          Readln(outfile,S); ActorUpSize:=strtofloat(S);

        Finally
          CloseFile(outfile);
        End;
        //Only Proxies Supported so far...
        If DisplayType = 0 then
        begin
          NewProxy := TGLProxyObject(MMProxyDC.AddNewChild(TGLProxyObject));
          NewProxy.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
          //BillBoards only
          //NewProxy.Width :=ActorWidth;
          //NewProxy.Height :=ActorHeight;
          NewProxy.Position.X:=DXI;
          NewProxy.Position.Z:=DYI;
          with NewProxy.Position do
          begin       //ShapeDC.DeleteChildren;
            terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
            Y:=terrainHeight+ActorUpSize{- (min[2]*ActorScale)}; //0.04
            NewProxy.Position.Y:=Y;
          end;
          If Length(ActorUp)=2 then
          begin
            Dirs:= ActorUp[1];
            If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
            ActorUp := ActorUp[2];
          end else Dir:=1;
          If lowercase(ActorUp)='y' then
          begin
            NewProxy.Up.y:=Dir;
            NewProxy.Up.z:= 0;
            NewProxy.Up.x:=0;
          end else
          If lowercase(ActorUp)='z' then
          begin
            NewProxy.Up.y:=Dir;
            NewProxy.Up.z:=0;
            NewProxy.Up.x:=0;
          end else
          If lowercase(ActorUp)='x' then
          begin
            NewProxy.Up.x:=Dir;
            NewProxy.Up.y:=0;
            NewProxy.Up.z:=0;
          end;

          // Need a master object for this new proxy ?
          // Just use the manager :
          NewProxy.MasterObject := Manager.LoadModel(ActorFilename,ActorTextureFileName);
        end;
      end;
    end;
  finally
    ControlStringList.Free;
    PointShapeAttStringList.Free;
  end;
end;


//Read the DTP file to get the Attribute and Model Data
//Read the Shape file and CONNECT the Shape TO the Model
{What about Tornado Lines? I do NOT want them displayed
 I Want to be able to Chose 1
  to Have it be a Tornado
 Turn Lines into Paths: Run as a Path:  LinearDisplayRG.Itemindex=6}
procedure TdtmGlHdsForm.LoadLineobject(Filename:String;ILoad:Integer);
var
  S:String;
  outfile:Textfile;
  ControlFileNamesCount, AttributeCount,i:Integer;
{  NewProxy : TGLProxyObject;
 // ControlType,SupportStructureType,
 DisplayType, PointShapeAttType,
  ShapeType, ShapeToDo, DXI,DYI, NumShape: integer;
  DXdtemp,DYdtemp:Double;


  ControlStringList,
  PointShapeAttStringList:TStringList;
 ActorFileName,ActorTextureFileName,
 P2FileName: string;
 ActorUp : string;
  Dirs:String; Dir:Integer;
//  oldCTRG:Integer;
//  ActorLength, ActorWidth,  ActorHeight,
 ActorUpSize, ActorScale:Double;
 terrainHeight:Single;
 AttrCount:Integer;
 ControlFileName,AttrString: string;}
begin
  Try     { File selected in dialog box }
      AssignFile(outfile, Filename);
      Reset(outfile);   //Open File and Set Data
      Readln(outfile,S); If S= GoatVersion then;
      Readln(outfile,S); // LinearlldRG.ItemIndex:=strtoint(S);
      Readln(outfile,S); // LinearDisplayRG.ItemIndex:=strtoint(S);
      Readln(outfile,S); // LinearSupportRG.ItemIndex:=strtoint(S);
      //The Attribute to Display
      Readln(outfile,S);  //LinearShapeAttCB.ItemIndex:=strtoint(S);

      //Number of Shape Attribute Values
      Readln(outfile,S);
      AttributeCount:=strtoint(S);
      //LSTLabel.Caption:=inttostr(AttributeCount);
      //LinearShapeAttSelectCB.Items.BeginUpdate;
      //LinearShapeAttSelectCB.Clear;
      For I:=0 to AttributeCount-1 do
      begin
        Readln(outfile, S);
        //LinearShapeAttSelectCB.Items.add(S);
      end;
      //LinearShapeAttSelectCB.Items.EndUpdate;
      //LinearShapeAttSelectCB.ItemIndex:=0;
      //LinearShapeAttSelectUpDown.Position:=0;
      //CurrentLldLabel.Caption:=inttostr(LinearShapeAttSelectCB.ItemIndex);
      //Array..List of Shape Attribute = ptd Filenames in pdl
      //1=17 2=4 3=11 4=1 5=1
      SetLength(LinearArray,AttributeCount);
      For i:= 0 to AttributeCount-1 do
      begin
        Readln(outfile, S); LinearArray[i].Shape:=strtoint(S);
        Readln(outfile, S); LinearArray[i].FileName:=strtoint(S);
      end;
      Application.ProcessMessages;
      //Filename of  Other Defined List (.odl)
      Readln(outfile,S);
      //LinearLdlFilenameEdit.Text:= S;
      //Number of ControlFileNames
      Readln(outfile,S);
      ControlFileNamesCount:=strtoint(S);
      //ldlRichEdit.Clear;
      For I:=0 to ControlFileNamesCount-1 do
      begin
        Readln(outfile, S);
        //ldlRichEdit.Lines.add(S);
      end;
      //This should set the caption too
      //LinearLdlUpDown.Position:=0;
      //CurrentLtdLabel.Caption:=inttostr(LinearLdlUpDown.Position);
      //CurrentLdlEdit.Text:=
      //  ldlRichEdit.Lines[LinearLdlUpDown.Position];
    Finally
      CloseFile(outfile);
    End;

end;


procedure TdtmGlHdsForm.GLHDSBump1MarkDirtyEvent(const area: TRect);
begin
   GLHeightTileFileHDS1.MarkDirty(area);
end;

procedure TdtmGlHdsForm.GLHDSBump1StartPreparingData(
                        heightData: THeightData);
var
   htfHD: THeightData;
   n, i, j: Integer;
   offset : TTexPoint;
   libMat : TGLLibMaterial;   //xecib   :Jacob
   Texname{,Teename,Tecname, Teiname, Tebname} : String;
   Bitbmp:TBitmap;    jp: TJpegImage;  PNG: TPNGObject;
   //BumpTime,
   start,  stop, htfTime, htfTime2, texTime, freq: Int64;
   Bumpn : TVector;
   Bumpbmp32 : TGLBitmap32;
//   BumphtfHD : THeightData;
   BumplibMat : TGLLibMaterial;
  //  half,  hdStep,
   Bumpx, Bumpy, hdY, hdX, mapSize : Integer;
   dcx, dcy : Single;
   invLen, scaleDiv255 : Single;
   prevRow, curRow, nextRow : PSmallIntArray;
   nmRow : PGLPixel32Array;
Function LoadTileTex:Boolean;
begin
  if (UseSavedTextures and (FileExists(HTFPath+HTFTexturePath+Texname)) ) then
  begin
    BitBmp := TBitmap.Create;
    Case TextureFileType of
      0:begin
          PNG := TPNGObject.Create;
          PNG.LoadFromFile(HTFPath+HTFTexturePath+Texname);
          Bitbmp.Assign(PNG);
          PNG.Free;
        end;
      1: Bitbmp.LoadFromFile(HTFPath+HTFTexturePath+Texname);
      2:begin
          jp := TJpegImage.Create;
          jp.LoadFromFile(HTFPath+HTFTexturePath+Texname);
          Bitbmp.Assign(jp);
          jp.Free;
        end;
    end;
    libMat:=TerrainML.AddTextureMaterial(Texname, Bitbmp);
//    If UseBumpMap then TerrainML.LibMaterialByName('details').Material.Texture.Image.Assign(Bitbmp);

    {libMat:=GLMaterialLibrary1.AddTextureMaterial(name,
     HTFPath+HTFTexturePath+Texname,False);}
    with libMat.Material.Texture do
    begin
      TextureMode:=tmReplace;
      TextureWrap:=twNone;
      MagFilter:=maLinear; //maNearest;
      MinFilter:=miLinear;//miNearest;
      //miLinearMipmapLinear;
      //miNearestMipmapNearest;
      //Compression:=tcHighQuality;//tcStandard;
      //comment out to turn off texture compression
      //FilteringQuality:=tfAnisotropic;
    end;
    BitBmp.Free;
    libMat.Texture2Name:='details';
    LoadTileTex:=True;
  end else
  begin
    LoadTileTex:=False;
  end;
end;
Function CreateTextures:Boolean;
var
  ScaleRect:TRect;
  x, y : Integer;
  bmp, bmp2 : TBitmap32;
  scanLine :PColor32Array;// PByteArray;
 {Eco Color  takes longer to make than Load...}
{  StepLevel, StepLevelCount, Step, Stepcount: Integer;
  TotRez,Rez:Double;
  RezEly,RezRely,RezSlope,RezSlopeDir:Double;
  HiEl,LoEl,
  MinRezEly,MinRezRely,MinRezSlope,
  TotRezEly,TotRezRely,TotRezSlope,
  REX, RexSq,RelativeElevation, SlopeDir,
  Slope2,CX2,CY2, Slope,CX,CY:Double;
   // htfTileSize,
  WidthX,HeightY, tx, ty : Integer;
  EcoMatrix: array of array of array of Double;}
Begin
  If (CreateTexturesOnDemand
     { and(not UseImageMap)and(not UseEcoTypes)and(not UseContours) } )then
  begin
    //Here ONLY Tex files made so rename just in case
    Texname:=Format(HTFTextureName+'Tex%d_%d_%d'+HTFExtension, [PixelEnlargement,i, j]);

      {BitBmp := TBitmap.Create;
      BitBmp.HandleType := bmDIB;
      BitBmp.PixelFormat := pf32Bit;
      BitBmp.Width := DtmTileSize;
      BitBmp.Height := DtmTileSize;
      for y := DtmTileSize- 1 downto 0 do
      begin
        scanLine:=BitBmp.ScanLine[y];
        for x := 0 to DtmTileSize- 1 do
        scanLine[x]:=heightColor[htfHD.SmallIntRaster[y,x]];
      end;}
    {Create an Elevation Tint of THIS tile}

    bmp:=TBitmap32.Create;
    bmp2:=TBitmap32.Create;
    bmp.setsize(DtmTileSize,DtmTileSize );
    bmp2.setsize(DtmTileSize*PixelEnlargement,DtmTileSize*PixelEnlargement );
    {Actual Height data is REVERSED Right to Left  by Terrain Renderer
     Bitmap is Reversed Top to Bottom and EXPANDED}
 //   Elevation Tint
      for y := DtmTileSize- 1 downto 0 do
      begin
        scanLine:=bmp.ScanLine[y];
        for x := 0 to DtmTileSize- 1 do
        scanLine[x]:=heightColor[htfHD.SmallIntRaster[y,x]];
      end;
      {ok so store it in Matlib}    {bmp.AssignTo(Bitbmp);}
      BitBmp := TBitmap.Create;
      BitBmp.HandleType := bmDIB;
      BitBmp.PixelFormat := pf32Bit;
      BitBmp.Width := bmp2.Width;
      BitBmp.Height := bmp2.Height;
      ScaleRect.Left:=0; ScaleRect.Top:=0;
      ScaleRect.Right:= DtmTileSize*PixelEnlargement;
      ScaleRect.Bottom:= DtmTileSize*PixelEnlargement;
      bmp.StretchFilter:=sfSpline;
      bmp.DrawTo(Bmp2,ScaleRect);
      bmp2.DrawTo(BitBmp.Canvas.Handle, 0, 0);

      libMat:=TerrainML.AddTextureMaterial(Texname, Bitbmp);
      {libMat:=TerrainML.AddTextureMaterial(name,
       HTFPath+HTFTexturePath+name,False);}
      with libMat.Material.Texture do
      begin
        TextureMode:=tmReplace;
        TextureWrap:=twNone;
        // MagFilter:=maLinear;
        // MinFilter:=miLinearMipmapNearest;
        //Compression:=tcStandard;//comment out to turn off texture compression
          //FilteringQuality:=tfAnisotropic;
      end;

      {If UseBumpMap then TerrainML.LibMaterialByName('details').Material.Texture.Image.Assign(Bitbmp)
      else} libMat.Texture2Name:='details';

      CreateTextures:=True;
      If SaveCreatedTextures then
      begin  {Convert to Png to save disk space}
         {  UseContours, UseLightMap, UseEcoTypes,}
        if not DirectoryExists(HTFPath+HTFTexturePath) then
        if not CreateDir(HTFPath+HTFTexturePath) then
        begin
          //raise Exception.Create
          showmessage('Cannot create '+HTFPath+HTFTexturePath);
          BitBmp.Free;
          bmp.Free;
          bmp2.Free;
          exit;
        end;
        Case TextureFileType of
        0:begin
          PNG := TPNGObject.Create;
          PNG.Assign(BitBmp);    //Convert data into png
          PNG.SaveToFile(HTFPath+HTFTexturePath+Texname);
          PNG.Free;
          end;
        1: Bitbmp.SaveToFile(HTFPath+HTFTexturePath+Texname);
        2:begin
          jp := TJpegImage.Create;
          with jp do
          begin
            Assign(BitBmp);
            SaveToFile(HTFPath+HTFTexturePath+Texname);
          end;
          jp.Free;
          end;
        end;
      end;
      BitBmp.Free;
      bmp.Free;
      bmp2.Free;
  end else CreateTextures:=False;
End;
begin {Actual GLCustomHDS1StartPreparingData code}
  texTime:=0;
  QueryPerformanceCounter(start);
  with heightData do
  htfHD:=GLHeightTileFileHDS1.GetData(XLeft, YTop, Size, DataType);
  if (htfHD.DataState=hdsNone) then
           //or (htfHD.HeightMax<=cWaterLevel-cWaterOpaqueDepth) then
      heightData.DataState:=hdsNone
  else
  begin
    {Keep in Bounds 512x512  64x64 tilesize  Textures 4x4
     512/128 = which texture 0..3,0..3         HTF.Size/4=Divisor
     Divide World into Chunks (512x512) of Tiles (64x64) of Textures 4x4}
    i:=(heightData.YTop div HeightPointsPerTexture);
    j:=(heightData.XLeft div HeightPointsPerTexture);
    if ( (Cardinal(j)<TexturesWideX+1) and (Cardinal(i)<TexturesTallY+1)) then
    begin
      inc(TotalLoaded);

      heightData.TextureCoordinatesMode:=tcmLocal;
         {Which tile and 3 ?
         (TilesPerTexture=1
          heightData.XLeft div DtmTileSize) / TexturesWideX}
      If TilesPerTexture=1 then
      begin
        offset.S:=0;
        offset.T:=0;
        heightData.TextureCoordinatesOffset:=offset;
        {heightData.TextureCoordinatesScale:=TexPointMake
        (1/PixelEnlargement,1/PixelEnlargement); }
        heightData.TextureCoordinatesScale:=TexPointMake(1,1);
      end else
      begin
        n:=((heightData.XLeft div DtmTileSize {32}) and 3);
            {4 textures per side = 0.25 ?  1/TexturesWideX}
        offset.S:=n*(1/TilesPerTexture);//0.25;
        n:=((heightData.YTop div DtmTileSize) and 3);
        offset.T:=-n*(1/TilesPerTexture);//0.25;
        heightData.TextureCoordinatesOffset:=offset;
        heightData.TextureCoordinatesScale:=
        TexPointMake( 1/TilesPerTexture{ 0.25},
                          1/TilesPerTexture {0.25} );
      end;

      heightData.DataType:=hdtSmallInt;
      htfHD.DataType:=hdtSmallInt;
      heightData.Allocate(hdtSmallInt);
      QueryPerformanceCounter(stop);
      htfTime:=stop-start;
      TotalHtfLoadTime:=TotalHtfLoadTime+ htfTime;
      // If texture is already in Material Library then use it... else Make it

      {Load the texture map.. If all fails it remains default}
     If UseBumpMap then
      begin
      {Bump Map created Below.. It uses htf data}
        Texname:=Format(HTFTextureName+'Teb%d_%d_%d'+HTFExtension, [PixelEnlargement,i, j]);

      end else
      begin
      QueryPerformanceCounter(start);
      Texname:=Format(HTFTextureName+'Tex%d_%d_%d'+HTFExtension, [PixelEnlargement,i, j]);
        if UseEcoTypes then
        Texname:=Format(HTFTextureName+'Tee%d_%d_%d'+HTFExtension, [PixelEnlargement,i, j]);
        if UseImageMap then
        Texname:=Format(HTFTextureName+'Tei%d_%d_%d'+HTFExtension, [PixelEnlargement,i, j]);
        if UseConglomeration then
        Texname:=Format(HTFTextureName+'Tec%d_%d_%d'+HTFExtension, [PixelEnlargement,i, j]);
      //Finding an old Texture never worked... i dunno
        //showmessage(HTFPath+HTFTexturePath+Texname);
       //LibMaterialByName
      {libMat:=TerrainML.LibMaterialByName(
               format(HTFTextureName+'Tex_%d_%d'+HTFExtension,[i,j]));
      if libMat<>nil then }
      {iF (TerrainML.Name=
           format(HTFTextureName+'Tex_%d_%d'+HTFExtension,[i,j]))
           then
           begin
           heightData.MaterialName:=
           format(HTFTextureName+'Tex_%d_%d'+HTFExtension,[i,j]);
           inc(Repete); //Redone Counter commented out ...Nothing Ever marked Dirty.. so nothing reloaded?
           end
      else }
      begin
        If LoadTileTex then
        begin
           heightData.MaterialName:=Texname
        end
        else if CreateTextures then
        begin
           heightData.MaterialName:=Texname
        end else
        begin
          heightData.MaterialName:='FAKE';
        end;
        QueryPerformanceCounter(stop);
        texTime:=stop-start;
        TotalTexLoadTime:= TotalTexLoadTime+ texTime;
      end;
      end;

      QueryPerformanceCounter(start);
      Move(htfHD.SmallIntData^, heightData.SmallIntData^, htfHD.DataSize);

      heightData.DataState:=hdsReady;
      heightData.HeightMin:=htfHD.HeightMin;
      heightData.HeightMax:=htfHD.HeightMax;
      QueryPerformanceCounter(stop);
      htfTime2:=stop-start;
      TotalHtfLoadTime:=TotalHtfLoadTime+ htfTime2;
     If UseBumpMap then
      begin
      QueryPerformanceCounter(start);
      //NEED to Make a  BumphtfHD with the Overlay data
   {   My DtmTileSize skips overlap..
       Bumpmapping need overlap of 2
       1 from each side... it then is made smaller for bitmap}
      {Setlength(ManMatrix,DtmTileSize+2 ,DtmTileSize+2 );
      for Bumpy := 0 to DtmTileSize- 1 do
        for Bumpx := 0 to DtmTileSize- 1 do
        ManMatrix[1+Bumpx,1+Bumpy]:=htfHD.SmallIntRaster[Bumpx,Bumpy];
      //Setlength(ManMatrix,DtmTileSize+2 ,DtmTileSize+2 );
        Bumpy := 0;
        for Bumpx := 0 to DtmTileSize do
        ManMatrix[Bumpx,Bumpy]:=   //fill x side
         htf.XYHeight(Bumpx+(DtmTileSize*j),(Bumpy)+(DtmTileSize*i));

        Bumpy := DtmTileSize;
        for Bumpx := 0 to DtmTileSize do
        ManMatrix[1+Bumpx,1+Bumpy]:=   //fill x side
         htf.XYHeight(Bumpx+(DtmTileSize*j),(Bumpy)+(DtmTileSize*i));
        Bumpx := 0;
      for Bumpy := 0 to DtmTileSize do
        ManMatrix[Bumpx,Bumpy]:=   //fill y side
         htf.XYHeight(Bumpx+(DtmTileSize*j),(Bumpy)+(DtmTileSize*i));
        Bumpx := DtmTileSize;
      for Bumpy := 0 to DtmTileSize do
        ManMatrix[1+Bumpx,1+Bumpy]:=   //fill y side
         htf.XYHeight(Bumpx+(DtmTileSize*j),(Bumpy)+(DtmTileSize*i));
       }
      {UseLightMap Base material created.. now BumpMap it}
      //line 177 of TGLBumpmapHDS.StartPreparingData(heightData : THeightData);
{   if Assigned(GLCustomHDS1.BumpMapLibrary)
       and (heightData.DataState<>hdsNone) then}
       begin
      BumplibMat:=TerrainML{GLCustomHDS1.BumpMapLibrary}.Materials.Add;
      //FBumpmapLibrary.Materials.Add;
      BumplibMat.Name:='BumpHDS_'+IntToHex(Int64(heightData), 16);
      with BumplibMat.Material.Texture do
      begin
         ImageClassName:=TGLBlankImage.ClassName;
         Enabled:=True;
         MagFilter:=maLinear;
         MinFilter:=miLinearMipmapNearest;
         TextureMode:=tmReplace;
         TextureWrap:=twNone;
         TextureFormat:=tfRGBA;//tfRGBA16;  // tfRGBA32;
         Bumpbmp32:=(Image as TGLBlankImage).GetBitmap32(GL_TEXTURE_2D);
//         GenerateNormalMap(htfHD, bmp32, FBumpScale);
{procedure TGLBumpmapHDS.GenerateNormalMap(heightData : THeightData;
                                          normalMap : TGLBitmap32;
                                          scale : Single);
var
   x, y, hdY, hdX, half, mapSize, hdStep : Integer;
   dcx, dcy : Single;
   invLen, scaleDiv255 : Single;
   prevRow, curRow, nextRow : PSmallIntArray;
   nmRow : PGLPixel32Array;
begin}

   htfHD.DataType:=hdtSmallInt;
   //hdStep:=0;
   mapSize:=(DtmTileSize -4);
   //(htfHD.Size-4);  //This leaves that Black border
   //BECAUSE it Reads the Tiles size which is set to be +Overlap
   {if (mapSize>8) and (GLCustomHDS1.SubSampling>1) then
   begin
      mapSize:=mapSize div GLCustomHDS1.SubSampling;
      if mapSize<8 then mapSize:=8;
      while (mapSize shl hdStep)<(htfHD.Size-4) do Inc(hdStep);
   end; }         // showmessage(inttostr(mapSize));// 125+4=129
   Bumpbmp32.Height:=mapSize;
   Bumpbmp32.Width:=mapSize;
   //half:=(mapSize shr 1);

   //scaleDiv255:=GLCustomHDS1.BumpScale*(1/255);
   //smooths it into not visible Bumps.. 65536
   scaleDiv255:=GLHTFBumpHDS1.BumpScale*(1/BumpRange);
   hdY:=0;
   for Bumpy:=0 to Bumpbmp32.Height-1 do
   begin
      prevRow:=htfHD.SmallIntRaster[hdY];
      curRow:=htfHD.SmallIntRaster[hdY+1];
      nextRow:=htfHD.SmallIntRaster[hdY+2];

      nmRow:=Bumpbmp32.ScanLine[Bumpbmp32.Height-1-Bumpy];
      hdX:=0;
      for Bumpx:=0 to Bumpbmp32.Width-1 do
      begin
         dcx:= scaleDiv255*
         (curRow[hdX+2]-curRow[hdX]);
         //ManMatrix[hdX+2,hdY+1]-ManMatrix[hdX,hdY+1];
         dcy:= scaleDiv255*
         (prevRow[hdX+1]-nextRow[hdX+1]);
         //ManMatrix[hdX+1,hdY]-ManMatrix[hdX+1,hdY+2];
         invLen:=RSqrt(Sqr(dcx)+Sqr(dcy)+1);
         with nmRow[Bumpx] do
         begin
            r:=Round(128+127*ClampValue(dcx*invLen, -1, 1));
            g:=Round(128+127*ClampValue(dcy*invLen, -1, 1));
            b:=Round(128+127*invLen);
            a:=255;
         end;
         Inc(hdX{, (1+Integer(hdX=half)) shl hdStep});
      end;
      Inc(hdY{, (1+Integer(hdY=half)) shl hdStep});
   end;

      end;
      // scale and translate the bumpmap to reduce seams
      BumplibMat.TextureOffset.SetVector(0.5/Bumpbmp32.Width, 0.5/Bumpbmp32.Width, 1);
      BumplibMat.TextureScale.SetVector({1,1,1 }
                                    (Bumpbmp32.Width-1)/Bumpbmp32.Width,
                                    (Bumpbmp32.Width-1)/Bumpbmp32.Width, 1);
   end {else BumplibMat:=nil};
   if Assigned(BumplibMat) then
   begin
      {if Assigned(FOnNewTilePrepared) then
         FOnNewTilePrepared(Self, heightData, libMat)
      else heightData.MaterialName:=libMat.Name;}
      //heightData.MaterialName:=Texname
   heightData.MaterialName:=BumplibMat.Name;//normalMapMaterial.Name;
   BumplibMat.Texture2Name:='contrast';
   //BumplibMat.Texture2Name := 'details';
   BumplibMat.Shader:=GLTexCombineShader1;
   BumplibMat.Material.MaterialOptions:=[moNoLighting];
   If ProcessSunMovements1.Checked then
   begin
   Bumpn:=VectorNormalize(SPSun.AbsolutePosition);
   // .96 .17 .21 0  //.94 .16  .27   //.97 .41  .7  .5
{showmessage(
          floattostr(Bumpn[0])
   +' ,'+ floattostr(Bumpn[1])
   +' ,'+ floattostr(Bumpn[2])
   +' ,'+ floattostr(Bumpn[3]));}
   ScaleVector(Bumpn, 0.5);
   Bumpn[1]:=-Bumpn[1];
   Bumpn[2]:=-Bumpn[2];            // .98 .41 .39 .5
   AddVector(Bumpn , 0.5);
   Bumpn[2]:=Bumpn[2]*2;
   //Bumpn[0]:= Bumpn[0]/2;        //.49 .42 .38 .5
   //What i get from the Sun
   //Black Sun: Bumpn[0]:=0.127;    Bumpn[1]:=0.3;   Bumpn[2]:=0.23;     Bumpn[3]:=0.5;
   // dim day  Bumpn[0]:=0.47;    Bumpn[1]:=0.58;   Bumpn[2]:=0.68;     Bumpn[3]:=0.5;

   end else
   begin  //from original Bump Demo
     Bumpn[0]:=0.873;    Bumpn[1]:=0.3;   Bumpn[2]:=0.766;     Bumpn[3]:=0.5;
   end;
   BumplibMat.Material.FrontProperties.Diffuse.Color:=   Bumpn;

{showmessage(
          floattostr(Bumpn[0])
   +' ,'+ floattostr(Bumpn[1])
   +' ,'+ floattostr(Bumpn[2])
   +' ,'+ floattostr(Bumpn[3]));}
   end;
        QueryPerformanceCounter(stop);
        texTime:=stop-start;
        TotalTexLoadTime:= TotalTexLoadTime+ texTime;
      end;
      //Setlength(ManMatrix,0 ,0 );
      QueryPerformanceFrequency(freq);
      //15 tiles in Viewer =3ms  130 tiles in 3D
      //Load Saved        4466 36   Htf: 485 1
      //                  5916  41  Htf: 71  6 ..must have had the htf in cache
      //Create Eco took  > 10 times Load.. so ONLY Load saved Eco...
      //Bump                278    2.2            60.8   0.5
      //Elevation tint Tex:1733 at 13 for1  Htf: 470 at 3 for 1
      //JisX   IisY
      dtmGlHdsForm.Caption:=
   Format('Hds= X%d  Y%d  Total %d , Tex= %.1f @ %.1f , Htf= %.1f @ %.1f ms',
                  [j,i,TotalLoaded,
                   1000*TotalTexLoadTime/freq, 1000*texTime/freq,
                   1000*TotalHtfLoadTime/freq, 1000*(htfTime+htfTime2)/freq]);

    end else heightData.DataState:=hdsNone;
  end;
  GLHeightTileFileHDS1.Release(htfHD);
end;

{==============================================================}
{==============================================================}
(*
procedure TdtmHdsForm.ActorDo(action:string; Perform:boolean);
begin
   if ((Action<>Actor1.CurrentAnimation)and(Perform=True)) then
      Actor1.SwitchToAnimation(action);
If ActorSmdLoaded then
   if ((Action=Actor1.CurrentAnimation)and(Perform=False)) then
      Actor1.SwitchToAnimation('idle')
      else
If ActorMd2Loaded then
   if ((Action=Actor1.CurrentAnimation)and(Perform=False)) then
      Actor1.SwitchToAnimation('stand');
   //Actor2.Synchronize(Actor1);
   If Actor2Md2WpnLoaded then Actor2.Synchronize(Actor1);
   If Actor2SmdLoaded then Actor2.Synchronize(Actor1);
end; *)
{==============================================================}
{==============================================================}


procedure TdtmGlHdsForm.GLCadencer1Progress(Sender: TObject; const deltaTime,
  newTime: Double);
var
  mousemovements:Integer;
  speed, alpha : Single;
 // moving : String;
  surfaceHeight,
  terrainHeight : Single;
  newMousePos : TPoint;
  sunposVector:TVector;
  azsun,altsun:single;
	r, cr, sr : Single;
begin  //idle
  {ShapeShifter:=-1;
  ShapeShifterLayer:=-1;
  ShapeShifterCount:=-1;
  ShapeShifterFileName:='';
    RunningDTPTotal :=1;
    RunningDTPLayer:=CurrentLayer;
    RunningDTPObject:=strtoint(SelectedObjectString);
    PlatoCommandFile:=LayA[CurrentLayer].LayerPlatoEditText;  }
  If AnythingRunning then
  begin
  If (DtcRunning and DtcFlyBy) then
  begin
    //A Flyby CONTROLS the Camera
    //Process the Camera and Target Paths
  end else
  If ShapeShifterRunning then
  begin
  //A Shifting Layer Directs the Camera TO the Performance

  end else
  If (DtcRunning and (DtcFileTypeRGItemIndex > -1)) then
  begin
  //
  end;
  end else
  If RunningMan1.Checked then
  begin //Watch the litle guy Run around the Current location
    DoActorMovement;
    //Animate the arrowlines
    GlArrowLine1.Position.Y:=0.5*sin(theta)+1;
    theta:=theta+1;
  end else
  begin //Move the Camera to desired location
      If ActorMd2Loaded then  currentanim:='stand'
       else currentanim:='idle'; //'walk';  run
    // handle keypresses
    if IsKeyDown(VK_SHIFT) then
    begin Actor1.Interval:=100;speed:=100*deltaTime end
      else begin Actor1.Interval:=150;speed:=20*deltaTime;end;
    with GLCamera.Position do
    begin
      if (IsKeyDown(VK_UP)or IsKeyDown(VK_DOWN)or
         IsKeyDown(VK_LEFT) or IsKeyDown(VK_RIGHT))then
        If ActorMd2Loaded then  currentanim:='run'
           else currentanim:='run'; //'walk';    ;
      if IsKeyDown(VK_UP) then
         CameraCube.Position.AddScaledVector(speed, GLCamera.AbsoluteVectorToTarget);
      if IsKeyDown(VK_DOWN) then
         CameraCube.Position.AddScaledVector(-speed, GLCamera.AbsoluteVectorToTarget);
      if IsKeyDown(VK_LEFT) then
         CameraCube.Position.AddScaledVector(-speed, GLCamera.AbsoluteRightVectorToTarget);
      if IsKeyDown(VK_RIGHT) then
         CameraCube.Position.AddScaledVector(speed, GLCamera.AbsoluteRightVectorToTarget);
      if IsKeyDown(VK_PRIOR) then    // pageUp
         CamHeight:=CamHeight+speed;
      if IsKeyDown(VK_NEXT) then     // pageDown
         CamHeight:=CamHeight-speed;
      If ActorMd2Loaded or ActorSmdLoaded then
      begin
        if Actor1.CurrentAnimation<>currentanim then
        begin
          Actor1.SwitchToAnimation(currentanim);
          If ActorMd2WpnLoaded then
          begin
            Actor2.Interval:=Actor1.Interval;
            Actor2.Synchronize(Actor1);
          end;
        end;
      end;
    end;
    //mousemovements:  Zoom in or Out
    if IsKeyDown('v') then  mousemovements:=-1 else
           mousemovements:=1;
    // mousemovements and actions
    if IsKeyDown(VK_LBUTTON) then
    begin
      alpha:=CameraCube.Position.Y;
      CameraCube.Position.AddScaledVector(speed*mousemovements, GLCamera.AbsoluteVectorToTarget);
      CamHeight:=CamHeight+CameraCube.Position.Y-alpha;
    end;
    {if IsKeyDown(VK_RBUTTON) then begin
      alpha:=CameraCube.Position.Y;
      CameraCube.Position.AddScaledVector(-speed, GLCamera.AbsoluteVectorToTarget);
      CamHeight:=CamHeight+CameraCube.Position.Y-alpha;
    end;}
    // don't drop our target through terrain!
    //Although Mouse Zooming can go below...?!?!?!
    with CameraCube.Position do
    begin
      terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
      surfaceHeight:=
      //(GLTerrainRenderer1.Scale.Z*GLHTFBumpHDS1.DefaultHeight)/PointsPerTexture;
       GLHTFBumpHDS1.DefaultHeight;
       if terrainHeight<surfaceHeight then
         terrainHeight:=surfaceHeight;
      Y:=terrainHeight+CamHeight;
    end;
    If MovingMan1.Checked then
    begin
      ActorBase.Position:=CameraCube.Position;
      ActorBase.Position.y:=CameraCube.Position.y-CamHeight;
    end;

    GetCursorPos(newMousePos);
    GLCamera.MoveAroundTarget((Screen.Height div 2-newMousePos.Y)*0.25,
                             (Screen.Width div 2-newMousePos.X)*0.25);
    ResetMousePos;
  end;
  {show sky}
  If UseClouds then
  begin
    CloudNewTime:= CloudNewTime+ deltaTime;
    if ((CloudNewTime)>CloudAnime) then
    begin                 //     CloudChangeAmount:=0.0001;
      If UseCloudsRange then
      begin
        //Make bigger number
        If CloudRanger < (CloudMinUsed+ CloudMinRangeUsed) then
        begin
          CloudRanger:=CloudRanger+1;
          TGLProcTextureNoise(CloudSphere.Material.Texture.Image).MinCut :=Round(CloudRanger);
        end else   //check that it is too small..Reset so above catches
        If TGLProcTextureNoise(CloudSphere.Material.Texture.Image).MinCut < (CloudMinUsed-CloudMinRangeUsed) then
        begin
          CloudRanger:= TGLProcTextureNoise(CloudSphere.Material.Texture.Image).MinCut;
        end else
        begin   //Reduce it till Caught by above
          TGLProcTextureNoise(CloudSphere.Material.Texture.Image).MinCut :=
          TGLProcTextureNoise(CloudSphere.Material.Texture.Image).MinCut  -1;
        end;
      end;
      If UseCloudsSRange then
      begin
        //Make bigger number
        If CloudSharpRanger < (CloudSharpUsed+ CloudSharpRangeUsed) then
        begin
          CloudSharpRanger:=CloudSharpRanger+CloudChangeAmount;
          TGLProcTextureNoise(CloudSphere.Material.Texture.Image).NoiseSharpness :=CloudSharpRanger;
        end else   //check that it is too small..Reset so above catches
        If TGLProcTextureNoise(CloudSphere.Material.Texture.Image).NoiseSharpness < (CloudSharpUsed-CloudSharpRangeUsed) then
        begin
          CloudSharpRanger:= TGLProcTextureNoise(CloudSphere.Material.Texture.Image).NoiseSharpness;
        end else
        begin   //Reduce it till Caught by above
          TGLProcTextureNoise(CloudSphere.Material.Texture.Image).NoiseSharpness :=
          TGLProcTextureNoise(CloudSphere.Material.Texture.Image).NoiseSharpness  -CloudChangeAmount;
        end;
      end;
        // dtmHdsForm.Caption:= floattostr(CloudNewTime) + ' , '+ floattostr(CloudChange);
        CloudChange:=CloudChange+CloudChangeAmount;
        CloudNewTime:=0;
        TGLProcTextureNoise(CloudSphere.Material.Texture.Image).NoiseAnimate(CloudChange);
    end;
  end;

  //The Sun is still buggered..
  //Dunno if it is from my Cloud SPHERE moving the Sun with it or WHAT
  If ProcessSunMovements1.Checked then
  begin
    //Increment the time so that a day elapses in fmConfig.edminutes minutes }
    theDateTime:=theDatetime+
     ( (deltatime/(60*60*24))
      /(SunMovingUsed/(60*24)) );

    {Set the position of the sun -.25 to adjust position}
    //Adjust for location FROM GMT ?
    //datetime,  latitude, longitude
    // showmessage(floattostr(-((((TMaxOffsetX* CameraCube.Position.x)  -180)/360){*24})));
    sunposition(thedatetime {-0.25}
     // +(((((TMaxOffsetX* CameraCube.Position.x)  -180)/360){*24}))
       ,
      //Convert Current Location to Lat Long
      //Only good for Whole World HTF...
      Round( 90- (DataScalerY* CameraCube.Position.z) ),
      Round((DataScalerX* CameraCube.Position.x)  -180 ),
      azsun,altsun);
      {showmessage(floattostr(TMaxOffsetX* CameraCube.Position.x  -180 )+ ' , '+
                  floattostr(90- TMaxOffsetY* CameraCube.Position.z));}


                       //Distance, ,
      //100 is Sun distance.. Keep inside the Sphere...
    sunposVector:=sunpositionAsVector(140,azsun,altsun) ;
    //sunpos:=sunposvector(800,thedatetime,52.5,-1.91667) GLLensFlare1;
    //Rise in the East Set in the West  .works in USA correctly
    SPSun.Position.x:=  1* sunposVector[0];
    SPSun.position.y:=  -1 *sunposVector[2];
    SPSun.position.z:=  1 *sunposVector[1];
    //SPSun.Position.x:= 140;  //distance
    //SPSun.Position.y:= 100;   //up
    //SPSun.Position.z:= -235;//75;  //circular ?
    { Get the radiance of the sun based upon the altitude of the sun }
     Brightness:= sunradiance(altsun);
    // SPSun.Material.Texture.ImageGamma:= Brightness;
    // SPSun.Material.Texture.ImageBrightness:= Brightness;
    //SPSun.Width:= 60*Brightness;
    //SPSun.Height:=SPSun.Width;
  end;


  If ((Ocean1.Checked)) then
  begin
      { Move the sea WITH the Camera: All under a DC  Plane1, GLWaterPlane1}                                                             //0.005
     WaterFxDC.Position.x:=CameraCube.Position.x;
     WaterFxDC.Position.z:=CameraCube.Position.z;
     //GLPlane1.Position.x:=CameraCube.Position.x;
     //GLPlane1.Position.z:=CameraCube.Position.z;
     //GLWaterPlane1
     //GLPlane2.Position.x:=CameraCube.Position.x;
     //GLPlane2.Position.z:=CameraCube.Position.z;
    If OceanMoving1.Checked then
    begin
      TerrainML.materials.GetLibMaterialByName('sea').TextureOffSet.addScaledVector(deltaTime*0.005-(deltaTime*(Random/1000)),xvector);
      { Set the brightness of the sea .. doesnt change.. i did ? wrong}
      GLPlane2.material.FrontProperties.diffuse.Alpha:=1-Brightness;
      GLPlane2.material.BlendingMode:=bmTransparency;
      GLPlane2.material.Texture.texturemode:=tmdecal;
    end;
  end;

  //Storm Clouds CONTAIN a LOT of stuff
  //and it ALL happens where the Cloud IS
  If (Storm1.Checked) then//This allows Stopping Cloud Movement
  begin
  If UseStormMoving then
  begin
    If  UseStormMovingDirS then
    begin  //START at Position.. Move per Direction per Cadencer
    //StormCloudsDirectionUsed    StormCloudsSpeedUsed
      StormCloudDC.Position.X:=StormCloudsPosXUsed;
      StormCloudDC.Position.Y:=StormCloudsPosYUsed;
      StormCloudDC.Position.Z:=StormCloudsPosZUsed;
    end else
    If  UseStormMovingPath then
    begin       //StormMovingFileUsed
      //Starts at 0,0,0 and Moves to/with StormDC per NODE
       { StormCloudDC.Position.x:=CameraCube.Position.x;
        StormCloudDC.Position.z:=CameraCube.Position.z;
        StormCloudDC.Position.y:=CameraCube.Position.y;}
    end else
    begin
      //Starts at 0,0,0 and Moves to/with StormDC
        StormCloudDC.Position.x:=CameraCube.Position.x;
        StormCloudDC.Position.z:=CameraCube.Position.z;
        StormCloudDC.Position.y:=CameraCube.Position.y;
    end;
  end;
  end;
    If (Tornadoes1.Checked)then
    begin
        If TornadoeRanger > TornadoeFrequencyUsed then
        begin  //Tornadoe Touching DOWN
          StormCloudDC2.Turnangle:=StormCloudDC2.Turnangle+10;
          //StormTornadoCone.Turnangle:=StormTornadoCone.Turnangle+1;
          alpha:=Random*2*PI;
          r:=2*Random;
          SinCos(alpha, r*r, sr, cr);
          StormCloudDC2.Position.SetPoint(sr*3, (3*r-3)*3, cr*3);
          StormCloudDC2.Position.y:=StormCloudDC2.Position.y-(StormCloudDC.Position.y*0.6);
          If TornadoeRanger > TornadoeForceUsed then TornadoeRanger:=0 else
          TornadoeRanger:=TornadoeRanger+0.001;
        end else
        begin
          TornadoeRanger:=TornadoeRanger+0.0001;
          StormCloudDC2.Position:=StormCloudDC.Position;//Hide in the Main Cloud
        end;
    end;
    If (Lightning1.Checked)then
    begin
      //  StromLightAxisDC.TurnAngle  LightningDC  StormCloudDC2.Turnangle
      if (DtmThorFXManager.GlowSize < LightningForceUsed) then
      begin     //During FLASH it gets bigger UNTIL LightningForceUsed
        DtmThorFXManager.GlowSize:= DtmThorFXManager.GlowSize+0.01;
        DtmThorFXManager.InnerColor.Alpha:=DtmThorFXManager.InnerColor.Alpha+0.01;
        LightningRanger:=0;
      end
      else
      begin
        DtmThorFXManager.Disabled:=True;
        DtmThorFXManager.InnerColor.Alpha:=0.0;
        DtmThorFXManager.Core:=False;
        If LightningRanger > LightningFrequencyUsed then
        begin     //Lightning Strikes
          DtmThorFXManager.Disabled:=False;
          DtmThorFXManager.GlowSize:=0;
          DtmThorFXManager.Core:=True;
          DtmThorFXManager.InnerColor.Alpha:=0.33;
          //THIS makes Lightning Strike OTHER than Center to Center
          StormLightAxisDC.TurnAngle:=StormLightAxisDC.TurnAngle+Random(180);
          If (Storm1.Checked) then
          begin    //Readjust if Moving..REALLY need a CORRECT Height
            DtmThorFXManager.Target.y:=-CamHeight;
            DtmThorFXManager.Target.X:=0;
            DtmThorFXManager.Target.z:=0;
          end;
        end else LightningRanger:=LightningRanger+0.001;
      end;
    end;
    If (Rain1.Checked)then
    begin
    end;
    If (Wind1.Checked)then
    begin
    end;


  StatusBar.Panels[0].Text :='X: '+
            Inttostr(Round((CameraCube.Position.X *XPositionCorrection)));
  StatusBar.Panels[1].Text :='Y: '+
            Inttostr(Round((CameraCube.Position.Z *XPositionCorrection)));
  StatusBar.Panels[2].Text :='Height: '+
     Floattostr(CameraCube.Position.Y);
  if IsKeyDown(VK_ESCAPE) then Close;
end;
procedure TdtmGlHdsForm.Timer1Timer(Sender: TObject);
begin
  If DisplayFPS then
  begin
  {Longitude follows the standard convention of
   positive values east of Greenwich, negative to the west.}
    HTFPS.Text:=             //y  x
      Format('%.1f FPS - %d,Lat %.2f, Lon %.2f',
                            //Lat %d, Lon %d',
                         [GLSceneViewer1.FramesPerSecond,
                         GLTerrainRenderer1.LastTriangleCount,
( (90-( DataScalerY* CameraCube.Position.z/XPositionCorrection))),
//      (90-Round( DataScalerY* CameraCube.Position.z/XPositionCorrection)),
(( (DataScalerX* CameraCube.Position.x/XPositionCorrection)-180))  ]);
//      ( Round(DataScalerX* CameraCube.Position.x/XPositionCorrection)-180)  ]);
  If ProcessSunMovements1.Checked then
  HTFPS.Text:= HTFPS.Text
                       //0.25 corrects for USA only
     +'   '+datetostr(thedatetime-0.75)+' '+timetostr(thedatetime-0.75)
    +' Sun:  '+ Floattostrf(1-Brightness,ffFixed,4,2);

  GLSceneViewer1.ResetPerformanceMonitor;
  end;
end;

procedure TdtmGlHdsForm.ResetMousePos;
begin
  if GLSceneViewer1.Cursor=crNone then
      SetCursorPos(Screen.Width div 2, Screen.Height div 2);
end;

procedure TdtmGlHdsForm.CloudsFasterClick(Sender: TObject);
begin
  CloudAnime:= CloudAnime-1;
  If (CloudAnime < 0) then CloudAnime:=0;
  CloudNewTime:=0;
  CloudChange:=0;
  //GLSphere1.TurnAngle:= GLSphere1.TurnAngle+ deltaTime;
end;

procedure TdtmGlHdsForm.CloudsSlower1Click(Sender: TObject);
begin      // CloudAnime:=6;
  CloudAnime:= CloudAnime+1;
  CloudNewTime:=0;
  CloudChange:=0;
end;
procedure TdtmGlHdsForm.CloudsMuchSlower1Click(Sender: TObject);
begin
  CloudAnime:= CloudAnime+10;
  CloudNewTime:=0;
  CloudChange:=0;
end;
{      TGLProcTextureNoise(GLSphere1.Material.Texture.Image).MinCut :=120;//0..120..255 SpinEdit1.Value;
      TGLProcTextureNoise(GLSphere1.Material.Texture.Image).NoiseSharpness :=90/100;//0..90 SpinEdit2.Value /100;}
procedure TdtmGlHdsForm.CloudsMore1Click(Sender: TObject);
begin
  CloudChangeAmount:=CloudChangeAmount+0.001;
end;
procedure TdtmGlHdsForm.CloudsLess1Click(Sender: TObject);
begin
  CloudChangeAmount:=CloudChangeAmount-0.001;
end;
procedure TdtmGlHdsForm.CloudsOff1Click(Sender: TObject);
begin
   UseClouds:=false;
   CloudSphere.Visible:=false;
   ProcessSunMovements1.Checked :=false;
   CloudsActiveMenu.Enabled:=false;
   CloudsOff1.Enabled:=false;
   SunMenu1.Enabled:=false;
end;
procedure TdtmGlHdsForm.DarkClouds1Click(Sender: TObject);
begin
  DarkClouds1.Checked:= (not DarkClouds1.Checked);

  with CloudSphere.Material.Texture do
  begin
    If DarkClouds1.Checked then
    begin
    SPSun.Width:= 0;
    SPSun.Height:=SPSun.Width;
    CloudSphere.Material.BlendingMode:=bmOpaque;
    GLSceneViewer1.Buffer.BackgroundColor:=clgray;
    // GLSceneViewer1.Buffer.FogEnvironment.FogColor.AsWinColor:=RGB(1, 1, 1);
    GLSceneViewer1.Buffer.FogEnvironment.FogColor.Alpha:=0;
    GLSceneViewer1.Buffer.FogEnvironment.FogColor.Blue:=0;
    GLSceneViewer1.Buffer.FogEnvironment.FogColor.Green:=0;
    GLSceneViewer1.Buffer.FogEnvironment.FogColor.Red:=0;
    GLSkyDome1.Visible:=False;
    //GLSkyDome1.Bands[0].StopColor.AsWinColor:=RGB(0, 0, 0);
     // ImageGamma:=-1;
     // ImageBrightness:=-0.05;
     // EnvColor.Alpha:=0;

      TGLProcTextureNoise(Image).MinCut :=20;//0//0..120..255 SpinEdit1.Value;
      TGLProcTextureNoise(Image).NoiseSharpness :=99/100;//.99//0..90 SpinEdit2.Value /100;
    end else
{[dark FULL] s99m30 .. s98 m60..90
[50/50]    97..97
[lighter]  95.120
[10/10]    90 160}
    begin
    SPSun.Width:= 60;
    SPSun.Height:=SPSun.Width;
    CloudSphere.Material.BlendingMode:=bmTransparency;//bmOpaque;
    //GLSceneViewer1.Buffer.BackgroundColor:=clwhite;
    //    GLSceneViewer1.Buffer.FogEnvironment.FogColor.AsWinColor:=RGB(1, 1, 1);
    GLSceneViewer1.Buffer.FogEnvironment.FogColor.Alpha:=1;
    GLSceneViewer1.Buffer.FogEnvironment.FogColor.Blue:=1;
    GLSceneViewer1.Buffer.FogEnvironment.FogColor.Green:=1;
    GLSceneViewer1.Buffer.FogEnvironment.FogColor.Red:=1;
    GLSkyDome1.Bands[0].StopColor.AsWinColor:=RGB(1, 0, 0);
     { ImageGamma:=1;
      ImageBrightness:=1;
      EnvColor.Alpha:=1;}
      GLSkyDome1.Visible:=True;
      TGLProcTextureNoise(Image).MinCut :=120;//0//0..120..255 SpinEdit1.Value;
      TGLProcTextureNoise(Image).NoiseSharpness :=90/100;//.99//0..90 SpinEdit2.Value /100;
    end;
  end;
end;


procedure TdtmGlHdsForm.ProcessSunMovements1Click(Sender: TObject);
begin
  GLCadencer1.Enabled:=False;
  ProcessSunMovements1.Checked := (not ProcessSunMovements1.Checked);
  GLCadencer1.Enabled:=True;
end;

procedure TdtmGlHdsForm.ResetSun1Click(Sender: TObject);
begin
  {Turn OFF Stuff and Move Sun to...}
  ProcessSunMovements1.Checked:=False;
   SPSun.Position.x:= 140;  //distance
   SPSun.Position.y:= 100;   //up
   SPSun.Position.z:= -235;//75;  //circular ?
   SPSun.Width:=  60;
   SPSun.Height:= 60;
end;

procedure TdtmGlHdsForm.SetSunParameters1Click(Sender: TObject);
var
  iYear,iMonth,iDay:word;
  iHour,iMin,iSec,iMSec:word;
begin
  dtmGlHdsSunConfigForm.edMinutes.text:=inttostr(SunMovingUsed);
  decodedate(theDateTime,iYear,iMonth,iDay);
  dtmGlHdsSunConfigForm.edYear.text:=inttostr(iYear);
  dtmGlHdsSunConfigForm.edMonth.text:=inttostr(iMonth);
  dtmGlHdsSunConfigForm.edDay.text:=inttostr(iDay);
  decodetime(thedateTime,iHour,iMin,iSec,iMSec);
  dtmGlHdsSunConfigForm.edHour.text:=inttostr(iHour);
  dtmGlHdsSunConfigForm.edMin.text:=inttostr(iMin);

  if dtmGlHdsSunConfigForm.ShowModal=mrOk then
  begin
    iYear:=strtoInt(dtmGlHdsSunConfigForm.edYear.text);
    iMonth:=strtoInt( dtmGlHdsSunConfigForm.edMonth.text);
    iDay:=strtoInt(dtmGlHdsSunConfigForm.edDay.text);
    iHour:=strToInt(dtmGlHdsSunConfigForm.edHour.text);
    iMin:=strToInt(dtmGlHdsSunConfigForm.edMin.text);
    theDateTime:=encodeDate(iYear,iMonth,iDay)
                +encodeTime(iHour,iMin,0,0);
    SunMovingUsed:= strtoInt(dtmGlHdsSunConfigForm.edMinutes.text);
  end;
end;

procedure TdtmGlHdsForm.Ocean1Click(Sender: TObject);
begin
  Ocean1.Checked := (not Ocean1.Checked);
  GLPlane1.Visible:=Ocean1.Checked;
  GLPlane2.Visible:=Ocean1.Checked;
  If (not Ocean1.Checked) then
  begin
    OceanMoving1.Checked :=Ocean1.Checked;
    Waves.Checked:= Ocean1.Checked;
    SeaPlane.Visible:=Waves.Checked;
  end;
end;
procedure TdtmGlHdsForm.OceanMoving1Click(Sender: TObject);
begin
  If Ocean1.Checked then
  begin
    OceanMoving1.Checked := (not OceanMoving1.Checked);
  end;
end;
procedure TdtmGlHdsForm.WavesClick(Sender: TObject);
begin
  Waves.Checked:= (not Waves.Checked);
  SeaPlane.Visible:=Waves.Checked;
end;

/////////////////////////////////////////
procedure TdtmGlHdsForm.Storm1Click(Sender: TObject);
begin
  Storm1.Checked:= (not Storm1.Checked);
end;
procedure TdtmGlHdsForm.Rain1Click(Sender: TObject);
begin
  Rain1.Checked:= (not Rain1.Checked);
end;
procedure TdtmGlHdsForm.Lightning1Click(Sender: TObject);
begin
  Lightning1.Checked:= (not Lightning1.Checked);
end;
procedure TdtmGlHdsForm.Tornadoes1Click(Sender: TObject);
begin
  Tornadoes1.Checked:= (not Tornadoes1.Checked);
end;
procedure TdtmGlHdsForm.Wind1Click(Sender: TObject);
begin
  Wind1.Checked:= (not Wind1.Checked);
end;
/////////////////////////////////////////



procedure TdtmGlHdsForm.FormKeyPress(Sender: TObject; var Key: Char);
var
   i : Integer;
   pm : TPolygonMode;
begin
   case Key of
      'w', 'W' : begin
         with TerrainML do
         begin
            if Materials[0].Material.FrontProperties.PolygonMode=pmLines then
               pm:=pmFill
            else pm:=pmLines;
            for i:=0 to Materials.Count-1 do
               Materials[i].Material.FrontProperties.PolygonMode:=pm;
         end;
       end;
      '*' :
        begin
          with GLTerrainRenderer1 do
               if CLODPrecision>20 then
               CLODPrecision:=Round(CLODPrecision*0.8);
          StatusBar.Panels[6].Text :='CLOD Precision: '+
            Inttostr(Round(GLTerrainRenderer1.CLODPrecision));
        end;
      '/' :
        begin
           with GLTerrainRenderer1 do
              if CLODPrecision<1000 then
              CLODPrecision:=Round(CLODPrecision*1.2);
          StatusBar.Panels[6].Text :='CLOD Precision: '+
            Inttostr(Round(GLTerrainRenderer1.CLODPrecision));
        end;
      '-' :
        begin
          with GLTerrainRenderer1 do
               if QualityDistance>40 then
               QualityDistance:=Round(QualityDistance*0.8);
          StatusBar.Panels[7].Text :='Quality Distance: '+
            Inttostr(Round(GLTerrainRenderer1.QualityDistance));
        end;
      '+' :
        begin
           with GLTerrainRenderer1 do
              if QualityDistance<1000 then
              QualityDistance:=Round(QualityDistance*1.2+1);
          StatusBar.Panels[7].Text :='Quality Distance: '+
            Inttostr(Round(GLTerrainRenderer1.QualityDistance));
        end;
      'a' :
        begin
          with GLTerrainRenderer1 do
               if Scale.Z> 0.1 then
               Scale.Z:=(Scale.Z - 0.1);
          StatusBar.Panels[4].Text :='Z Scale: '+
            Floattostr((GLTerrainRenderer1.Scale.Z));
        end;
      'z' :
        begin
           with GLTerrainRenderer1 do
              if Scale.Z<1000 then
              Scale.Z:=(Scale.Z+ 0.1);
          StatusBar.Panels[4].Text :='Z Scale: '+
            Floattostr((GLTerrainRenderer1.Scale.Z));
        end;
//TO DO :
//Scale needs to change XPositionCorrection AND Camera Position
//so Position stays the same and Location is Correct
      's' :
        begin
          with GLTerrainRenderer1 do
               if Scale.X> 0.1 then
               begin
               Scale.X:=(Scale.X - 0.1);
               Scale.Y:=(Scale.Y - 0.1);
               end;
          StatusBar.Panels[5].Text :='X Scale: '+
            Floattostr((GLTerrainRenderer1.Scale.X));
            XPositionCorrection:= GLTerrainRenderer1.Scale.X;
        end;
      'x' :
        begin
           with GLTerrainRenderer1 do
              if Scale.X < 1000 then
              begin
              Scale.X:=(Scale.X+ 0.1);
              Scale.Y:=(Scale.Y+ 0.1);
              end;
          StatusBar.Panels[5].Text :='X Scale: '+
            Floattostr((GLTerrainRenderer1.Scale.X));
          XPositionCorrection:= GLTerrainRenderer1.Scale.X;
        end;
        //Scale Big Change   e+ r -
      'r' :
        begin
          with GLTerrainRenderer1 do
               if Scale.X> 1.1 then
               begin
               Scale.X:=(Scale.X - 1);
               Scale.Y:=(Scale.Y - 1);
               end;
          StatusBar.Panels[5].Text :='X Scale: '+
            Floattostr((GLTerrainRenderer1.Scale.X));
          XPositionCorrection:= GLTerrainRenderer1.Scale.X;
        end;
      'e' :
        begin
           with GLTerrainRenderer1 do
              if Scale.X < 1000 then
              begin
              Scale.X:=(Scale.X+ 1);
              Scale.Y:=(Scale.Y+ 1);
              end;
          StatusBar.Panels[5].Text :='X Scale: '+
            Floattostr((GLTerrainRenderer1.Scale.X));
          XPositionCorrection:= GLTerrainRenderer1.Scale.X;
        end;

      'd' : if GLCamera.DepthOfView<2000 then begin
         GLCamera.DepthOfView:=GLCamera.DepthOfView*1.2;
         with GLSceneViewer1.Buffer.FogEnvironment do begin
            FogEnd:=FogEnd*1.2;
            FogStart:=FogStart*1.2;
            CloudSphere.Radius:= FogEnd-60;
         end;
          StatusBar.Panels[3].Text :='Cam DOView: '+ {1000}
            Floattostr((GLCamera.DepthOfView));
      end;
      'c' : if GLCamera.DepthOfView>300 then begin
         GLCamera.DepthOfView:=GLCamera.DepthOfView/1.2;
         with GLSceneViewer1.Buffer.FogEnvironment do begin
            FogEnd:=FogEnd/1.2;
            FogStart:=FogStart/1.2;
            CloudSphere.Radius:= FogEnd-60;
         end;
          StatusBar.Panels[3].Text :='Cam DOView: '+ {1000}
            Floattostr((GLCamera.DepthOfView));
      end;
      'h': begin   {Enable Repositioning form}
             GLSceneViewer1.Cursor:=crNone;
             Timer1.Enabled:=True;
             GLCadencer1.Enabled:=True;
           end;
      'n': begin
           GLSceneViewer1.Cursor:=crDefault;
           Timer1.Enabled:=False;
           GLCadencer1.Enabled:=False;
           end;
      'u':Brightness:=Brightness+0.1;
      'i':Brightness:=Brightness-0.1;
      'q':DtcAbortAvi:=True;
   end;
   Key:=#0;
end;


procedure TdtmGlHdsForm.FormMouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
begin
   //Adjust Camera distance with mousewheel
   GLCamera.AdjustDistanceToTarget(Power(1.1, WheelDelta/120));
   StatusBar.Panels[2].Text :='Height: '+
     Inttostr(Round( CameraCube.Position.Y));
end;

procedure TdtmGlHdsForm.AxisOn1Click(Sender: TObject);
begin
   AxisOn1.Checked:=(not AxisOn1.Checked);
   ActorBase.ShowAxes:=AxisOn1.Checked;
end;
procedure TdtmGlHdsForm.RunningMan1Click(Sender: TObject);
begin
   RunningMan1.Checked:=(not RunningMan1.Checked);
end;
procedure TdtmGlHdsForm.MovingMan1Click(Sender: TObject);
begin
   MovingMan1.Checked:=(not MovingMan1.Checked);
end;///TakeMeHome1Click at Top above Showdown


procedure TdtmGlHdsForm.LoadDTC1Click(Sender: TObject);
begin
  OpenDialog1.Filter := 'DTC (*.dtc)|*.dtc';
  OpenDialog1.InitialDir := ProjectPath;
  OpenDialog1.Filename:='*.dtc';
  if OpenDialog1.execute then
    DoLoadDTC(OpenDialog1.Filename);
end;
procedure TdtmGlHdsForm.DoLoadDTC(InFile:String); //DtcFlyBy
var
 S : string;
 TotalNodes, //LoopCount,
 I,ActorCount,CommandCount:Integer;
 NodePitchAngle, NodeTurnAngle, NodeRollAngle:Single;
 F,PathNodeFile: TextFile;
  Movement: TGLMovement;
    //FormCreate  Movement   := GetOrCreateMovement(PathCube);
  Path:     TGLMovementPath;
    //New or Load  Path       := Movement.AddPath;
  Node:     TGLPathNode;
begin
    // DtcCommandFile     //IF  then DtcFlyBy:=True;
    Application.ProcessMessages;
    AssignFile(F, InFile);
    Reset(F);
    Readln(F, S);
    DtcFileTypeRGItemIndex:=strtoint(S);
    Case DtcFileTypeRGItemIndex of
    0://Layers
    Begin
      Readln(F, S); ActorCount:=strtoint(S);
      For I:=0 to ActorCount-1 do
      begin
      Readln(F, S);
      LoadActorDtc(S,DtcFileTypeRGItemIndex);
      //DtcA1RichEdit.Lines.add(S);
      //Load rld files and Create ROBOTS
      //RobotDC  SEE Culling Demo for Actor Settings
      end;
      Readln(F, S); ActorCount:=strtoint(S);
      For I:=0 to ActorCount-1 do
      begin
      Readln(F, S);
      LoadActorDtc(S,DtcFileTypeRGItemIndex);
      //DtcA1RichEdit.Lines.add(S);
      //Load rld files and Create ROBOTS
      //RobotDC  SEE Culling Demo for Actor Settings
      end;
      Readln(F, S); CommandCount:=strtoint(S);
      If (ActorCount <> CommandCount) then
      showmessage('Actors <> Commands'+#13#10+
      inttostr(ActorCount)+ ' <> '+ inttostr(CommandCount));
      SetLength(DtcLAArray, CommandCount);
      For I:=0 to CommandCount-1 do
      begin   //DtcA2RichEdit.Lines.add(S);
        Readln(F, S);
        DtcLAArray[i]:=s;
      end;
      If Extractfileext(DtcLAArray[0])='.act' then
      DtcFileType:=1 else
      If Extractfileext(DtcLAArray[0])='.pth' then
      DtcFileType:=1 else
      If Extractfileext(DtcLAArray[0])='.evo' then
      DtcFileType:=1 else
      Begin
        ShowMessage('DTC Layers File Type is Unknown');
        SetLength(DtcLAArray, 0);
        Exit;
      End;

    End;
    1:// Objects
    Begin
      Readln(F, S); ActorCount:=strtoint(S);
      For I:=0 to ActorCount-1 do
      begin
      Readln(F, S);
      LoadActorDtc(S,DtcFileTypeRGItemIndex);
      //DtcA1RichEdit.Lines.add(S);
      //Load rld files and Create ROBOTS
      //RobotDC  SEE Culling Demo for Actor Settings
      end;
    End;
    2://Multiple Actors.. Path Action  or Evolve Commands
    Begin
      Readln(F, S); ActorCount:=strtoint(S);
      For I:=0 to ActorCount-1 do
      begin
      Readln(F, S);
      LoadActorDtc(S,DtcFileTypeRGItemIndex);
      //DtcA1RichEdit.Lines.add(S);
      //Load rld files and Create ROBOTS
      //RobotDC  SEE Culling Demo for Actor Settings
      end;
      Readln(F, S); CommandCount:=strtoint(S);
      If (ActorCount <> CommandCount) then
      showmessage('Actors <> Commands'+#13#10+
      inttostr(ActorCount)+ ' <> '+ inttostr(CommandCount));
      SetLength(DtcAZArray, CommandCount);
      For I:=0 to CommandCount-1 do
      begin   //DtcA2RichEdit.Lines.add(S);
        Readln(F, S);
        DtcAZArray[i]:=s;
      end;
      If Extractfileext(DtcLAArray[0])='.act' then
      DtcFileType:=1 else
      If Extractfileext(DtcLAArray[0])='.pth' then
      DtcFileType:=1 else
      If Extractfileext(DtcLAArray[0])='.evo' then
      DtcFileType:=1 else
      Begin
        ShowMessage('DTC AZ File Type is Unknown');
        SetLength(DtcAZArray, 0);
        Exit;
      End;
    end;
    3: //Flyby
    Begin
      Readln(F, S); //DtcFCamEdit.Text:=S;
      //Read Into Camera Path Nodes
      //CameraCube
      Movement   := GetOrCreateMovement(CameraCube);
      Movement.OnAllPathTravelledOver := PathAllTravelledOver;
      Movement.OnPathTravelStop := PathTravelStop;
      Path       := Movement.AddPath;
    AssignFile(PathNodeFile, S);
    Reset(PathNodeFile);
    Readln(PathNodeFile, S);
      For i:=1 to 16 do Readln(PathNodeFile, S);
      Movement.ActivePathIndex := 0;
      Readln(PathNodeFile, S);
      Readln(PathNodeFile, S);TotalNodes:= Strtoint(S);
      Readln(PathNodeFile, S);//LoopCount:= Strtoint(S);
      For i:=1 to 4 do Readln(PathNodeFile, S);
    for I := 0 to TotalNodes - 1 do
    begin
      Node:=Path.AddNode;
      Readln(PathNodeFile, S); Node.X:= strtofloatdef(S,0);
      Readln(PathNodeFile, S); Node.Y:= strtofloatdef(S);
      Readln(PathNodeFile, S); Node.Z:= strtofloatdef(S);
      Readln(PathNodeFile, S); NodePitchAngle:= strtofloatdef(S);
      Readln(PathNodeFile, S); NodeTurnAngle:= strtofloatdef(S);
      Readln(PathNodeFile, S); NodeRollAngle:= strtofloatdef(S);
      Movement.ActivePath.Nodes.Items[I].RotationAsVector :=
      VectorMake(NodePitchAngle, NodeTurnAngle, NodeRollAngle);
      Readln(PathNodeFile, S); Node.ScaleX:= strtofloatdef(S);
      Readln(PathNodeFile, S); Node.ScaleY:= strtofloatdef(S);
      Readln(PathNodeFile, S); Node.ScaleZ:= strtofloatdef(S);
      Readln(PathNodeFile, S); Node.Speed:= strtofloatdef(S);
      Readln(PathNodeFile, S); //Node.NodeNumber:= Strtoint(S);
      end;
      CloseFile(PathNodeFile);
      Readln(F, S); //DtcFTarEdit.Text:=S;
      //Read Into Target Path Nodes
      //FlybyTargetCube
      Movement   := GetOrCreateMovement(FlybyTargetCube);
      Path       := Movement.AddPath;
    AssignFile(PathNodeFile, S);
    Reset(PathNodeFile);
    Readln(PathNodeFile, S);
      For i:=1 to 16 do Readln(PathNodeFile, S);
      Movement.ActivePathIndex := 0;
      Readln(PathNodeFile, S);
      Readln(PathNodeFile, S);TotalNodes:= Strtoint(S);
      Readln(PathNodeFile, S);//LoopCount:= Strtoint(S);
      For i:=1 to 4 do Readln(PathNodeFile, S);
    for I := 0 to TotalNodes - 1 do
    begin
      Node:=Path.AddNode;
      Readln(PathNodeFile, S); Node.X:= strtofloatdef(S,0);
      Readln(PathNodeFile, S); Node.Y:= strtofloatdef(S);
      Readln(PathNodeFile, S); Node.Z:= strtofloatdef(S);
      Readln(PathNodeFile, S); NodePitchAngle:= strtofloatdef(S);
      Readln(PathNodeFile, S); NodeTurnAngle:= strtofloatdef(S);
      Readln(PathNodeFile, S); NodeRollAngle:= strtofloatdef(S);
      Movement.ActivePath.Nodes.Items[I].RotationAsVector :=
      VectorMake(NodePitchAngle, NodeTurnAngle, NodeRollAngle);
      Readln(PathNodeFile, S); Node.ScaleX:= strtofloatdef(S);
      Readln(PathNodeFile, S); Node.ScaleY:= strtofloatdef(S);
      Readln(PathNodeFile, S); Node.ScaleZ:= strtofloatdef(S);
      Readln(PathNodeFile, S); Node.Speed:= strtofloatdef(S);
      Readln(PathNodeFile, S); //Node.NodeNumber:= Strtoint(S);
      end;
      CloseFile(PathNodeFile);
      DtcFlyBy:=True;
    end;
    End;//Case
    CloseFile(F);
end;
procedure TdtmGlHdsForm.LoadActorDtc(S:String;DtcFileTypeRGItemIndex:Integer);
var
 ActorFileName,TextureFileName,
// WpnPath,WeaponFileName, WpnTextureFileName,
 ActorScaleString,
 FileS,ActorUp : string;  I:Integer;
 F: TextFile;
 ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double;
begin
  ProjectPath:=ExtractFilePath(S);
  AssignFile(F, S);
  Reset(F);
  Readln(F, FileS);
  If (FileS=GoatVersion) then
  begin
    Readln(F, ActorFileName);
    //showmessage(ActorFileName);
    Readln(F, TextureFileName);
    //Type of File  smd md2  md2+ qc 3ds
    //
    Readln(F, FileS);      i:=strtoint(FileS);
    Readln(F, ActorScaleString);
    ActorScale:=StrtoFloatDef(ActorScaleString);
    Readln(F, FileS);      ActorPositionX:=StrtoFloatDef(FileS);
    Readln(F, FileS);      ActorPositionY:=StrtoFloatDef(FileS);
    Readln(F, ActorUp);
    Readln(F, FileS);      ActorPositionZ:=StrtoFloatDef(FileS);
    CloseFile(F);
//MDC MD3 GL2 MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GTS LWO GLSM
//'Robot  (*.qc,*.smd,*.md2,*.md3,*.mdc,*.gl2,*.MS3D,*.3ds)|*.qc;*.smd;*.md2;*.md3;*.mdc;*.gl2;*.ms3d;*.3ds';
If i=0 then
begin
          If FileExists(ActorFileName) then
          DoLoadActorDtc(ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ,ActorFileName,TextureFileName,ActorUp);
end else ShowMessage('DTC Rld Type MUST be DTC Object');
        end;
end;
procedure TdtmGlHdsForm.DoLoadActorDtc(
ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double;
fileName,TextureFileName,ActorUp : String);
var
  libMat : TGLLibMaterial;
  NewObject: TGLFreeForm;
  NewObjectMd2: TGLActor;
  //proxy: TGLProxyObject;
  Dirs:String; Dir:Integer;
  terrainHeight:Single;
  //min, max : TAffineVector;
begin //  LayA[ILoad].LayerPlatoEditText
  If ((lowercase(ExtractFileExt(fileName))='.3ds')
    or(lowercase(ExtractFileExt(fileName))='.ms3d')
    or(lowercase(ExtractFileExt(fileName))='.glsm'))then
  begin
    NewObject:=(RobotDC.AddNewChild(TGLFreeForm) as TGLFreeform);
    libMat:=ObjectsML.Materials.Add;
    libMat.Name:='Object_'+extractfilename(fileName);//inttostr(ILoad);
    NewObject.Material.LibMaterialName:=libMat.Name;
    NewObject.Material.MaterialLibrary:=ObjectsML;
    NewObject.LoadFromFile(fileName);
    If FileExists(TextureFileName) then
    begin
        {NewObject.Material.Texture.Image.LoadFromFile(TextureFileName);
         NewObject.Material.Texture.Disabled:=False;}
        ObjectsML.materials.GetLibMaterialByName('Object_'+extractfilename(fileName){inttostr(ILoad)}).material.texture.image.loadfromfile(TextureFileName);
    end;
    NewObject.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
    NewObject.Position.X:=ActorPositionX;
    NewObject.Position.Z:=ActorPositionY;
    NewObject.Position.Y:=ActorPositionZ;
    with NewObject.Position do
    begin
      terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
      Y:=terrainHeight+ ActorPositionZ;
    end;
    If Length(ActorUp)=2 then
    begin
      Dirs:= ActorUp[1];
      If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
      ActorUp := ActorUp[2];
    end else Dir:=1;
    If lowercase(ActorUp)='y' then
    begin
      NewObject.Up.y:=Dir;
      NewObject.Up.z:= 0;
      NewObject.Up.x:=0;
    end else
    If lowercase(ActorUp)='z' then
    begin
      NewObject.Up.y:=Dir;
      NewObject.Up.z:=0;
      NewObject.Up.x:=0;
    end else
    If lowercase(ActorUp)='x' then
    begin
      NewObject.Up.x:=Dir;
      NewObject.Up.y:=0;
      NewObject.Up.z:=0;
    end;
  end else
  begin
    //Load as an OBJECT not ACTOR *.GLSM,*.MS3D,*.3ds
    NewObjectMd2:=(RobotDC.AddNewChild(TGLActor) as TGLActor);
    libMat:=ObjectsML.Materials.Add;
    libMat.Name:='Object_'+extractfilename(fileName);//inttostr(ILoad);
    NewObjectMd2.Material.LibMaterialName:=libMat.Name;
    NewObjectMd2.Material.MaterialLibrary:=ObjectsML;
    NewObjectMd2.LoadFromFile(fileName);
    If FileExists(TextureFileName) then
    begin
        {NewObject.Material.Texture.Image.LoadFromFile(TextureFileName);
         NewObject.Material.Texture.Disabled:=False;}
        ObjectsML.materials.GetLibMaterialByName('Object_'+extractfilename(fileName){inttostr(ILoad)}).material.texture.image.loadfromfile(TextureFileName);
    end;
    NewObjectMd2.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
    NewObjectMd2.Position.X:=ActorPositionX;
    NewObjectMd2.Position.Z:=ActorPositionY;
    NewObjectMd2.Position.Y:=ActorPositionZ;
    with NewObjectMd2.Position do
    begin
      terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
      Y:=terrainHeight+ ActorPositionZ;
    end;
    If Length(ActorUp)=2 then
    begin
      Dirs:= ActorUp[1];
      If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
      ActorUp := ActorUp[2];
    end else Dir:=1;
    If lowercase(ActorUp)='y' then
    begin
      NewObjectMd2.Up.y:=Dir;
      NewObjectMd2.Up.z:= 0;
      NewObjectMd2.Up.x:=0;
    end else
    If lowercase(ActorUp)='z' then
    begin
      NewObjectMd2.Up.y:=Dir;
      NewObjectMd2.Up.z:=0;
      NewObjectMd2.Up.x:=0;
    end else
    If lowercase(ActorUp)='x' then
    begin
      NewObjectMd2.Up.x:=Dir;
      NewObjectMd2.Up.y:=0;
      NewObjectMd2.Up.z:=0;
    end;
  end;
End;

procedure TdtmGlHdsForm.RunDTC1Click(Sender: TObject);
begin
  DoRunDTC;
end;
procedure TdtmGlHdsForm.DoRunDTC; //DtcFlyBy
var  Movement: TGLMovement;
begin
  DtcRunning:=True;
  AnythingRunning:=True;
   // DtcCommandFile  DtcRunning:=False; DtcFlyBy:=True;
  If DtcFlyBy then
  begin  //recorder demo
    if not AVIRecorder1.CreateAVIFile then Exit;
     // if AVIRecorder1.filename is empty, a dialog box will appear asking
     // for the filename. CreateAVIFile() will return a bool
     // indicating if user presses "cancel" in the dialog box.
    DtcAbortAvi:=False;

    Movement := GetMovement(CameraCube);
    if Assigned(Movement) then  Movement.StartPathTravel;

    Movement := GetMovement(FlybyTargetCube);
    if Assigned(Movement) then  Movement.StartPathTravel;
    CameraCube.OnProgress:= CameraCubeProgress;
  end;
end;
procedure TdtmGlHdsForm.FlybyTargetCubeProgress(Sender: TObject;
  const deltaTime, newTime: Double);
begin
//FlybyTargetCube.OnProgress:= FlybyTargetCubeProgress
end;
procedure TdtmGlHdsForm.CameraCubeProgress(Sender: TObject; const deltaTime,
  newTime: Double);
begin
  //CameraCube.OnProgress:= CameraCubeProgress
  AVIRecorder1.AddAVIFrame;
  // you might want to update your progress bar here.
  Application.ProcessMessages; // so that our app. is not freezed,
          // and will accept user abort.
end;
procedure TdtmGlHdsForm.AVIRecorder1PostProcessEvent(Sender: TObject;
  frame: TBitmap);
begin
   // PostProcess event is used to add a "watermark"
   // that will be in the AVI, but isn't visible on-screen
   with frame.Canvas do begin
      Font.Color:=clAqua;
      Font.Name:='Courier New';//'Courrier New';
      Font.Size:=24;
      Font.Style:=[fsBold];
      Brush.Style:=bsClear;
      TextOut(20, 20, Format('GLScene %.3d', [1{TrackBar.Position}]));
   end;
end;
procedure TdtmGlHdsForm.PathTravelStop(Sender: TObject; Path: TGLMovementPath; var Looped: Boolean);
begin
   {if not Application.Terminated then
      InformationDlg('Path Travel Stopped');}
  AVIRecorder1.CloseAVIFile(DtcAbortAvi);
   // if DtcAbortAvi, CloseAVIFile will
   // also delete the unfinished file.
CameraCube.OnProgress:= nil;//CameraCubeProgress;
//StopDTC1Click
  DtcRunning:=False;
  DtcAbortAvi:=True;
  AnythingRunning:=False;
end;

procedure TdtmGlHdsForm.PathAllTravelledOver(Sender: TObject);
var  Movement: TGLMovement;
begin
   if not Application.Terminated then
    //  InformationDlg('All Path(es) Traveled Over');
//   dec(LoopCount);
//   If (LoopCount <= 0) then
   begin
   //Path.Looped:=False;
   Movement := GetMovement(CameraCube);
   Movement.StopPathTravel;
   end;
end;
procedure TdtmGlHdsForm.StopDTC1Click(Sender: TObject);
begin
  DtcRunning:=False;
  DtcAbortAvi:=True;
  AnythingRunning:=False;
end;





procedure TdtmGlHdsForm.StopRunningDTP1Click(Sender: TObject);
begin
  AnythingRunning:=False;
  RunningDTPTotal:=0;
  ShapeShifterRunning:=False;
end;
procedure TdtmGlHdsForm.RunAllLayers1Click(Sender: TObject);
begin
  RunningDTPTotal:= LayersLoaded;
  AnythingRunning:=True;
end;
procedure TdtmGlHdsForm.RunSelectedLayer1Click(Sender: TObject);
var SelectedObjectString:String;
begin
  If DTProjectLoaded then //There is stuff there  LayersLoaded>0{isRunningOnDtp}
  begin
    //Select Which Layer to Work on  LayersLoaded
    SelectedObjectString:=
    InputBox('Layer Selection of '+inttostr(LayersLoaded),
                                  'Do This one','1');
    CurrentLayer:=strtoint(SelectedObjectString);
    RunningDTPTotal :=1;
    RunningDTPLayer:=CurrentLayer;
    RunningDTPObject:=-1;
    PlatoCommandFile:=LayA[CurrentLayer].LayerPlatoEditText;
    //RUN the Selected Object
    AnythingRunning:=True;
    showmessage(inttostr(RunningDTPObject)+' , '+
                inttostr(RunningDTPLayer)+' , '+
                PlatoCommandFile );
  end;
end;
procedure TdtmGlHdsForm.RunSelectedObject1Click(Sender: TObject);
var SelectedObjectString:String;
begin
  If DTProjectLoaded then //There is stuff there  LayersLoaded>0{isRunningOnDtp}
  begin
    //Select Which Layer to Work on  LayersLoaded
    SelectedObjectString:=
    InputBox('Layer Selection of '+inttostr(LayersLoaded),
                                  'Do This one','1');
    CurrentLayer:=strtoint(SelectedObjectString);
    If (CurrentLayer=ShapeShifterLayer)then begin end else
    begin
      showmessage(inttostr(CurrentLayer)+' is not the Shifter Layer: '+
                  inttostr(ShapeShifterLayer));
      exit;
    end;
  {ShapeShifter:=-1;
  ShapeShifterLayer:=-1;
  ShapeShifterCount:=-1;
  ShapeShifterFileName:='';
    RunningDTPTotal :=1;
    RunningDTPLayer:=CurrentLayer;
    RunningDTPObject:=strtoint(SelectedObjectString);
    PlatoCommandFile:=LayA[CurrentLayer].LayerPlatoEditText;  }
    //Set the Number of Objects and Get the Selected Object
    SelectedObjectString:=
    InputBox('Selection of '+inttostr(LayA[CurrentLayer].ShapeN),
                                  'Do This one','1');

    RunningDTPTotal :=1;
    RunningDTPLayer:=CurrentLayer;
    RunningDTPObject:=strtoint(SelectedObjectString);
    PlatoCommandFile:=LayA[CurrentLayer].LayerPlatoEditText;
    //RUN the Selected Object
    showmessage(inttostr(RunningDTPObject)+' , '+
                inttostr(RunningDTPLayer)+' , '+
                PlatoCommandFile );
    ShapeShifterRunning:=True;
    AnythingRunning:=True;    
  end;
end;
procedure TdtmGlHdsForm.LoadDTP1Click(Sender: TObject);
Begin
  //If LoadShapeDBs will load this at start up
  If isRunningOnDtp then //There is stuff there LayersLoaded
  Begin {Load Actor, etc... Shape Objects,... ???}
    If DTProjectLoaded then exit;  //??? duplicate clone
           Timer1.Enabled:=False;
           GLCadencer1.Enabled:=False;
           Application.ProcessMessages;
      //Load the Data...
      //It is in FileName Strings or the Shape file attributes
      If ((ProjectRobotRldFilename<> NoName)
      and( FileExists(ProjectRobotRldFilename)) )then
      begin   //ProjectActorOtsFilename
        LoadActorrld(ProjectRobotRldFilename); //located next
        Application.ProcessMessages;
        SetShapeObjects; //located at start    {Load Path and Run}
        DTProjectLoaded:=True;
        RunDTPMenu.Enabled:=True;
      end;
      Timer1.Enabled:=True;
      GLCadencer1.Enabled:=True;
  End; {isRunningOnDtp}
end;

procedure TdtmGlHdsForm.Loadrld1Click(Sender: TObject);
begin
    {Load Actor base}
    OpenDialog1.Filter:='Robot |*.rld';
    OpenDialog1.InitialDir:=TigerPath;
    OpenDialog1.Filename:='*.rld';
    dtmGlHdsForm.Cursor:=crHourGlass;
    if OpenDialog1.Execute then
    LoadActorrld(OpenDialog1.FileName);
     dtmGlHdsForm.Cursor:=crNone; //crDefault;
end;
//This Loads an Actor..Depending on Filename Extension
procedure TdtmGlHdsForm.LoadActorrld(Filename:String);
var
 ActorFileName,TextureFileName,
// WpnPath,WeaponFileName, WpnTextureFileName,
 ActorScaleString,
 S,ActorUp : string;  I:Integer;
 F: TextFile;
 ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double;
begin
  ProjectPath:=ExtractFilePath(Filename);
  AssignFile(F, FileName);
  Reset(F);
  Readln(F, S);
  If (S=GoatVersion) then
  begin
    Readln(F, ActorFileName);
    //showmessage(ActorFileName);
    Readln(F, TextureFileName);
    //Type of File  smd md2  md2+ qc 3ds
    //
    Readln(F, S);      i:=strtoint(S);
    Readln(F, ActorScaleString);
    ActorScale:=StrtoFloatDef(ActorScaleString);
    Readln(F, S);      ActorPositionX:=StrtoFloatDef(S);
    Readln(F, S);      ActorPositionY:=StrtoFloatDef(S);
    Readln(F, ActorUp);
    Readln(F, S);      ActorPositionZ:=StrtoFloatDef(S);
    CloseFile(F);
//MDC MD3 GL2 MS3D, OBJ;*.TIN;*.PLY;*.STL'OCT NMF GTS LWO GLSM
//'Robot  (*.qc,*.smd,*.md2,*.md3,*.mdc,*.gl2,*.MS3D,*.3ds)|*.qc;*.smd;*.md2;*.md3;*.mdc;*.gl2;*.ms3d;*.3ds';
If i=0 then
begin
          If FileExists(ActorFileName) then
          Do3dsOpen(ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ,ActorFileName,TextureFileName,ActorUp);
end else
begin
          If lowercase(ExtractFileExt(ActorFileName))='.qc' then
          DoQcOpen(ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ,ActorFileName,ActorUp);
          If lowercase(ExtractFileExt(ActorFileName))='.smd' then
          DoLoadsmd(ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ,ActorFileName,ActorUp);
          If lowercase(ExtractFileExt(ActorFileName))='.md2' then
          DoLoadmd2(ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ,ActorFileName,ActorUp,i=2);
          If FileExists(TextureFileName) then
          Actor1.Material.Texture.Image.LoadFromFile(TextureFileName);
end;
        end;
end;

procedure TdtmGlHdsForm.Do3dsOpen( ActorScale,
ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,TextureFileName,ActorUp : String);
var
  libMat : TGLLibMaterial;
  NewObject: TGLFreeForm;
  NewObjectMd2: TGLActor;
  //proxy: TGLProxyObject;
  Dirs:String; Dir:Integer;
  terrainHeight:Single;
  //min, max : TAffineVector;
begin //  LayA[ILoad].LayerPlatoEditText
  If ((lowercase(ExtractFileExt(fileName))='.3ds')
    or(lowercase(ExtractFileExt(fileName))='.ms3d')
    or(lowercase(ExtractFileExt(fileName))='.glsm'))then
  begin
    NewObject:=(RobotDC.AddNewChild(TGLFreeForm) as TGLFreeform);
    libMat:=ObjectsML.Materials.Add;
    libMat.Name:='Object_'+extractfilename(fileName);//inttostr(ILoad);
    NewObject.Material.LibMaterialName:=libMat.Name;
    NewObject.Material.MaterialLibrary:=ObjectsML;
    NewObject.LoadFromFile(fileName);
    If FileExists(TextureFileName) then
    begin
        {NewObject.Material.Texture.Image.LoadFromFile(TextureFileName);
         NewObject.Material.Texture.Disabled:=False;}
        ObjectsML.materials.GetLibMaterialByName('Object_'+extractfilename(fileName){inttostr(ILoad)}).material.texture.image.loadfromfile(TextureFileName);
    end;
    NewObject.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
    NewObject.Position.X:=ActorPositionX;
    NewObject.Position.Z:=ActorPositionY;
    NewObject.Position.Y:=ActorPositionZ;
    with NewObject.Position do
    begin
      terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
      Y:=terrainHeight+ ActorPositionZ;
    end;
    If Length(ActorUp)=2 then
    begin
      Dirs:= ActorUp[1];
      If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
      ActorUp := ActorUp[2];
    end else Dir:=1;
    If lowercase(ActorUp)='y' then
    begin
      NewObject.Up.y:=Dir;
      NewObject.Up.z:= 0;
      NewObject.Up.x:=0;
    end else
    If lowercase(ActorUp)='z' then
    begin
      NewObject.Up.y:=Dir;
      NewObject.Up.z:=0;
      NewObject.Up.x:=0;
    end else
    If lowercase(ActorUp)='x' then
    begin
      NewObject.Up.x:=Dir;
      NewObject.Up.y:=0;
      NewObject.Up.z:=0;
    end;
  end else
  begin
    //Load as an OBJECT not ACTOR *.GLSM,*.MS3D,*.3ds
    NewObjectMd2:=(RobotDC.AddNewChild(TGLActor) as TGLActor);
    libMat:=ObjectsML.Materials.Add;
    libMat.Name:='Object_'+extractfilename(fileName);//inttostr(ILoad);
    NewObjectMd2.Material.LibMaterialName:=libMat.Name;
    NewObjectMd2.Material.MaterialLibrary:=ObjectsML;
    NewObjectMd2.LoadFromFile(fileName);
    If FileExists(TextureFileName) then
    begin
        {NewObject.Material.Texture.Image.LoadFromFile(TextureFileName);
         NewObject.Material.Texture.Disabled:=False;}
        ObjectsML.materials.GetLibMaterialByName('Object_'+extractfilename(fileName){inttostr(ILoad)}).material.texture.image.loadfromfile(TextureFileName);
    end;
    NewObjectMd2.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
    NewObjectMd2.Position.X:=ActorPositionX;
    NewObjectMd2.Position.Z:=ActorPositionY;
    NewObjectMd2.Position.Y:=ActorPositionZ;
    with NewObjectMd2.Position do
    begin
      terrainHeight:=GLTerrainRenderer1.InterpolatedHeight(AsVector);
      Y:=terrainHeight+ ActorPositionZ;
    end;
    If Length(ActorUp)=2 then
    begin
      Dirs:= ActorUp[1];
      If (Dirs ='-' ) then Dir:=-1 else Dir:=1;
      ActorUp := ActorUp[2];
    end else Dir:=1;
    If lowercase(ActorUp)='y' then
    begin
      NewObjectMd2.Up.y:=Dir;
      NewObjectMd2.Up.z:= 0;
      NewObjectMd2.Up.x:=0;
    end else
    If lowercase(ActorUp)='z' then
    begin
      NewObjectMd2.Up.y:=Dir;
      NewObjectMd2.Up.z:=0;
      NewObjectMd2.Up.x:=0;
    end else
    If lowercase(ActorUp)='x' then
    begin
      NewObjectMd2.Up.x:=Dir;
      NewObjectMd2.Up.y:=0;
      NewObjectMd2.Up.z:=0;
    end;
  end;
End;

procedure TdtmGlHdsForm.Loadqc1Click(Sender: TObject);
begin
    {Load Actor base}
    OpenDialog1.Filter:='actor |*.qc';
    OpenDialog1.InitialDir:=TigerPath;
    OpenDialog1.Filename:='*.qc';
    dtmGlHdsForm.Cursor:=crHourGlass;
    if OpenDialog1.Execute then
    DoQcOpen(0.04,0,0,0,OpenDialog1.FileName,'Y');
    // ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String
     dtmGlHdsForm.Cursor:=crNone; //crDefault;
end;
procedure TdtmGlHdsForm.DoQcOpen( ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String);
var   min, max : TAffineVector;
begin
  ActorSmdLoaded:=False;
  ActorMd2Loaded:=False;
  ActorMd2WpnLoaded:=False;
  TigerPath:=ExtractFilePath(FileName);
  Application.ProcessMessages;
  // LOAD THE Filename, into Actor1, with MODEL, + with ANIMATIONS
  LoadQC(FileName,Actor1,True,True);

      ActorSmdLoaded:=True;
          Actor1.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
        ActorBase.Position.X:=CameraCube.Position.x;
        ActorBase.Position.Y:=(CameraCube.Position.y-CamHeight);
        ActorBase.Position.Z:=CameraCube.Position.z;
  Actor1.GetExtents(min, max); //xyzwt
  If ActorPositionZ=0 then
  Actor1.Position.Y:= (max[2]/2)*ActorScale else
  Actor1.Position.Y:=(ActorPositionZ);
  Actor1.AnimationMode:=aamLoop;
  Actor1.FrameInterpolation:=afpLinear;
       Actor1.StructureChanged;
       RunningMan1.Enabled:=True;
       WayPoint.Active:=False;
     Actor1.OverlaySkeleton:=False;
     //Actor1.Interval := 50;
 If ActorMd2Loaded then
  Actor1.SwitchToAnimation('stand')
  else Actor1.SwitchToAnimation('walk'); //idle


end;


procedure TdtmGlHdsForm.Loadsmd1Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  OpenDialog1.Filter:='actor |*.smd';
  OpenDialog1.InitialDir:=TigerPath;
  OpenDialog1.Filename:='*.*';
  if OpenDialog1.Execute then
  // ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String
  DoLoadsmd(0.04,0,0,0,OpenDialog1.Filename,'Y');
  Timer1.Enabled:=True;
  GLCadencer1.Enabled:=True;
end;
procedure TdtmGlHdsForm.DoLoadsmd( ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String);
var   min, max : TAffineVector;
begin
  ActorSmdLoaded:=False;
  ActorMd2Loaded:=False;
  ActorMd2WpnLoaded:=False;  Actor2.Visible:=False;
  TigerPath:=ExtractFilePath(fileName);
    //----Load the main Actor ---
  Actor1.LoadFromFile(fileName);
  Actor1.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
  Actor1.GetExtents(min, max); //xyzwt
  If ActorPositionZ=0 then
  Actor1.Position.Y:= (max[2]/2)*ActorScale else
  Actor1.Position.Y:=(ActorPositionZ);
  ActorBase.Position.X:=CameraCube.Position.x;
  ActorBase.Position.Y:=(CameraCube.Position.y-CamHeight);
  ActorBase.Position.Z:=CameraCube.Position.z;
//  idle.smd   treadwater.smd  swim.smd  run2.smd  walk2handed.smd
  If FileExists(TigerPath+'walk.smd') then begin
    Actor1.AddDataFromFile(TigerPath+'walk.smd');
    Actor1.Animations[Actor1.Animations.Count-1].Name := 'walk';
    Actor1.Animations[1].MakeSkeletalTranslationStatic;
  end else showmessage('no walk');
  If FileExists(TigerPath+'run.smd') then begin
    Actor1.AddDataFromFile(TigerPath+'run.smd');
    Actor1.Animations[Actor1.Animations.Count-1].Name := 'run';
    Actor1.Animations[2].MakeSkeletalTranslationStatic;
    end else showmessage('no run');
{      // Define animation properties
      //walk.smd run.smd   jump.smd long_jump.smd look_left_right.smd}
  ActorSmdLoaded:=True;
  Actor1.AnimationMode:=aamLoop;
  Actor1.FrameInterpolation:=afpLinear;
  //Actor1.Interval := 50;
  If ActorMd2Loaded then
    Actor1.SwitchToAnimation('stand')
    else Actor1.SwitchToAnimation('walk'); //idle
  RunningMan1.Enabled:=True;
  WayPoint.Active:=False;

end;



procedure TdtmGlHdsForm.Loadmd21Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  OpenDialog1.Filter:='actor |*.md2';
  OpenDialog1.InitialDir:=TigerPath;
  OpenDialog1.Filename:='*.*';
  if OpenDialog1.Execute then
 // ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String

       DoLoadmd2(0.04,0,0,0,OpenDialog1.Filename,'Y',False);
  Timer1.Enabled:=True;
  GLCadencer1.Enabled:=True;
end;
procedure TdtmGlHdsForm.Loadmd22Click(Sender: TObject);
begin
  Timer1.Enabled:=False;
  GLCadencer1.Enabled:=False;
  OpenDialog1.Filter:='actor |*.md2';
  OpenDialog1.InitialDir:=TigerPath;
  OpenDialog1.Filename:='*.*';
  if OpenDialog1.Execute then
  // ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String
       DoLoadmd2(0.04,0,0,0,OpenDialog1.Filename,'Y',True);
  Timer1.Enabled:=True;
  GLCadencer1.Enabled:=True;
end;
procedure TdtmGlHdsForm.DoLoadmd2( ActorScale,ActorPositionX,ActorPositionY,ActorPositionZ:Double; fileName,ActorUp : String;Weapon:Boolean);
var
 WpnPath,WeaponFileName, TextureFileName, WpnTextureFileName:String;
var   min, max : TAffineVector; 
begin
  ActorSmdLoaded:=False;
  ActorMd2Loaded:=False;
  ActorMd2WpnLoaded:=False;  Actor2.Visible:=False;
  {Load Actor base}
  TigerPath:=ExtractFilePath(FileName);
   //----Load the main Actor and skin----
  Actor1.LoadFromFile(FileName);

  If FileExists(ChangeFileExt(FileName ,'.jpg')) then
  begin    {Load Actor texture}
    Actor1.Material.Texture.Image.LoadFromFile(ChangeFileExt(FileName ,'.jpg'));
    TextureFileName:=ChangeFileExt(FileName ,'.jpg');
  end;
  If FileExists(ChangeFileExt(FileName ,'.pcx')) then
  begin    {Load Actor texture}
    Actor1.Material.Texture.Image.LoadFromFile(ChangeFileExt(FileName ,'.pcx'));
    TextureFileName:=ChangeFileExt(FileName ,'.pcx');
  end;
  Actor1.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
  ActorBase.Position.X:=CameraCube.Position.x;
  ActorBase.Position.Y:=(CameraCube.Position.y-CamHeight)+ActorScale;
  ActorBase.Position.Z:=CameraCube.Position.z;
  Actor1.GetExtents(min, max); //xyzwt
  If ActorPositionZ=0 then
  Actor1.Position.Y:= (max[2]/2)*ActorScale else
  Actor1.Position.Y:=(ActorPositionZ);
  // Define animation properties
   Actor1.Animations.LoadFromFile(TigerPath+'Quake2Animations.aaf');

  Actor1.AnimationMode:=aamLoop;
  Actor1.FrameInterpolation:=afpLinear;   
  Actor1.SwitchToAnimation('stand',True); //stand
  Actor1.AnimationMode:=aamLoop;
  ActorMd2Loaded:=True;
          //weaponWaste.jpg
          If Weapon then begin
          WpnPath:=ExtractFilePath(FileName);
           WeaponFileName:='weapon'+ExtractFileName(FileName);
          If FileExists(WpnPath+WeaponFileName) then
          begin
            Actor2.Visible:=True;
          Actor2.LoadFromFile(WpnPath+WeaponFileName);
          //Actor2.Scale.SetVector(ActorScale, ActorScale, ActorScale, 0);
  If ActorPositionZ=0 then
  Actor2.Position.Y:= (max[2]/2)*ActorScale else
  Actor2.Position.Y:=(ActorPositionZ);
           WpnTextureFileName:='weapon'+ExtractFileName(TextureFileName);
          If FileExists(WpnPath+WpnTextureFileName) then
          Actor2.Material.Texture.Image.LoadFromFile(WpnPath+WpnTextureFileName);
           ActorMd2WpnLoaded:=True;
          Actor2.Visible:=True;
          If ActorMd2WpnLoaded then
          begin
          Actor2.Animations.Assign(Actor1.Animations);
          Actor2.Synchronize(Actor1);
          end;
        end;
        end;
  RunningMan1.Enabled:=True;
  WayPoint.Active:=False;
(*
   // Load Actor into GLScene
   Actor1.LoadFromFile('waste.md2');
   Actor1.Material.Texture.Image.LoadFromFile('waste.jpg');
   // Load Quake2 animations defaults, for "waste.md2", this is not required
   // since the author did not renamed the frames, and thus, GLScene can
   // recover them from the .MD2, but other authors just made a mess...
   // Loading the default animations takes care of that
   Actor1.Animations.LoadFromFile('Quake2Animations.aaf');
*)
end;

procedure TdtmGlHdsForm.LoadActorTexture1Click(Sender: TObject);
begin
  If (ActorSmdLoaded or ActorMd2Loaded)then
  begin
    OpenDialog1.Filter:='Actor texture (jpg)|*.jpg;*.tga;*.bmp';
    OpenDialog1.InitialDir:=TigerPath;
    OpenDialog1.Filename:='*.*';
    if OpenDialog1.Execute then
    DoLoadActorTexture(OpenDialog1.Filename);
  end;
end;
procedure TdtmGlHdsForm.DoLoadActorTexture(fileName : String);
//var libMat : TGLLibMaterial;
Begin
  //libMat:=ActorsML.AddTextureMaterial(Texname, Bitbmp);
  {libMat:=ActorsML.Materials.Add;
  libMat.Name:='Actor_'+inttostr(0);
  Actor1.Material.LibMaterialName:=libMat.Name;
  Actor1.Material.MaterialLibrary:=ActorsML;}
  Actor1.Material.Texture.Image.LoadFromFile(fileName);
end;

procedure TdtmGlHdsForm.DoActorMovement;
var
   angle,dist,
   left,right  : Single;
   v1,v2,
   Original    : TAffineVector;
   sign        : integer;
begin
  if WayPoint.Active then begin
    ActorBase.Move(0.5);

    Original:=ActorBase.Direction.AsAffineVector;
    VectorSubtract(WayPOint.Position,ActorBase.Position.AsAffineVector,v1);
    v1[1]:=0;
    v2:=ActorBase.Direction.AsAffineVector;
    v2[1]:=0;
    angle:=VectorAngleCosine(v1,v2);

    //Which way should the actor turn?
    //This is a cheap trick, but it does work. Basically we're just
    //turning the actor both ways and checking which direction is the
    //closest to the direction we want.
    ActorBase.Turn(1);
    v2:=ActorBase.Direction.AsAffineVector;
    v2[1]:=0;
    left:=VectorAngleCosine(v1,v2);
    ActorBase.Turn(-1);
    v2:=ActorBase.Direction.AsAffineVector;
    v2[1]:=0;
    right:=VectorAngleCosine(v1,v2);
    sign:=0;
    if right<>left then begin
      if right>left then
        sign:=-1
      else
        sign:=1;
    end;
    //Return the actor to his original direction
    ActorBase.Direction.AsAffineVector:=Original;

    //This determines how fast the actor should turn
    //Once he is close enough we just set him in the proper direction
    if angle<0.99 then
      if angle<0.5 then
        angle:=sign*30
      else
        if angle<0.9 then
          angle:=sign*10
        else
          if angle<0.95 then
            angle:=sign*5
          else begin
            angle:=0;
            ActorBase.Direction.AsAffineVector:=v1;
          end;
    ActorBase.Turn(angle);

    if currentanim<>'run' then begin
      Actor1.SwitchToAnimation('run',True);
      currentanim:='run';
    end;
    //Actor1.NextFrame;
  end else begin
  If ActorMd2Loaded then begin
    if currentanim<>'stand' then begin
      Actor1.SwitchToAnimation('stand',True);
      currentanim:='stand';
    end;
    end else
    if currentanim<>'walk' then begin  //idle
      Actor1.SwitchToAnimation('walk',True);
      currentanim:='walk';
    end;
  end;

  //Set the actor to the terrain height   GLTerrainRenderer1
  ActorBase.Position.Y:=GLTerrainRenderer1.InterpolatedHeight(ActorBase.Position.AsVector)+0.1;

  //If the waypoint is active then the actor moves towards it
  //Once within a distance from the waypoint, deactivate the waypoint
  if WayPoint.Active then begin
    WayPoint.Position:=Marker.Position.AsAffineVector;
    dist:=VectorDistance(WayPoint.Position,ActorBase.Position.AsAffineVector);
    if abs(dist)>1 then begin
      WayPoint.Active:=True;
    end else begin
      WayPoint.Active:=False;
    end;
    Marker.Visible:=WayPoint.Active;
  end;
end;

procedure TdtmGlHdsForm.GLSceneViewer1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   rayStart, rayVector, iPoint, iNormal : TVector;
begin
  If RunningMan1.Checked then
  begin
    if (ssCtrl in Shift) then
      GLSceneViewer1.Cursor:=crHandPoint //crDefault
    else
    GLSceneViewer1.Cursor:=crNone;

    if (ssCtrl in Shift) {and (ssLeft in Shift)} then
    begin
      // Code from the raycasting demo
      SetVector(rayStart, GLCamera.AbsolutePosition);
      SetVector(rayVector, GLSceneViewer1.Buffer.ScreenToVector(AffineVectorMake(x, GLSceneViewer1.Height-y, 0)));
      NormalizeVector(rayVector);
      if GLTerrainRenderer1.RayCastIntersect(rayStart, rayVector, @iPoint, @iNormal) then begin
        Marker.Position.AsVector:=iPoint;
        WayPoint.Active:=True;
      end;
    end;
    mx:=x; my:=y;
  end;
end;

procedure TdtmGlHdsForm.GLSceneViewer1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  If RunningMan1.Checked then
  begin
    if (ssCtrl in Shift) then
      GLSceneViewer1.Cursor:=crHandPoint
    else
    begin                //crDefault
      GLSceneViewer1.Cursor:=crNone;
      if ssLeft in Shift then
      begin
        GLCamera.MoveAroundTarget(my-y, mx-x);
      end;
    end;
    mx:=x; my:=y;
  end;
end;







end.
